
package io.platform.approvalConfiguration.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.approvalConfiguration.dto.AuditPathsLevelsDto;
import io.platform.approvalConfiguration.service.client.api.AuditPathsLevelsServiceClient;
import io.platform.base.common.utils.ExecuteResult;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("auditPathsLevelsServiceRemote")
public class AuditPathsLevelsServiceRemote {

    @Reference(check = false)
    private AuditPathsLevelsServiceClient auditPathsLevelsServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<AuditPathsLevelsDto> getList(Map<String, Object> params) {
        return auditPathsLevelsServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page<AuditPathsLevelsDto> getPage(Page<AuditPathsLevelsDto> page, AuditPathsLevelsDto auditPathsLevelsDto) {
        return auditPathsLevelsServiceClient.getPage(page, auditPathsLevelsDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public AuditPathsLevelsDto getOne(Long id) {
        AuditPathsLevelsDto auditPathsLevelsDto = auditPathsLevelsServiceClient.queryObject(id);
        return auditPathsLevelsDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(AuditPathsLevelsDto auditPathsLevelsDto) {

        return auditPathsLevelsServiceClient.save(auditPathsLevelsDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(AuditPathsLevelsDto auditPathsLevelsDto) {

        return auditPathsLevelsServiceClient.update(auditPathsLevelsDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return auditPathsLevelsServiceClient.deleteBatch(ids);
    }


}
