
package io.platform.approvalConfiguration.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.approvalConfiguration.dto.AuditPathsActsDto;
import io.platform.approvalConfiguration.dto.AuditPathsDto;
import io.platform.approvalConfiguration.service.client.api.AuditPathsServiceClient;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.Query;
import io.platform.sys.dto.SysUserDto;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("auditPathsServiceRemote")
public class AuditPathsServiceRemote {

    @Reference(check = false)
    private AuditPathsServiceClient auditPathsServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<AuditPathsDto> getList(Map<String, Object> params) {
        return auditPathsServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page getPage(Page page, AuditPathsDto auditPathsDto, SysUserDto sysUserDto) {
        return auditPathsServiceClient.getPage(page, auditPathsDto, sysUserDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public AuditPathsDto getOne(Long id) {
        AuditPathsDto auditPathsDto = auditPathsServiceClient.queryObject(id);
        return auditPathsDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(String auditPathsDto, String auditPathsLevelsDto, SysUserDto sysUserDto) {
        return auditPathsServiceClient.save(auditPathsDto, auditPathsLevelsDto, sysUserDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(AuditPathsDto auditPathsDto) {

        return auditPathsServiceClient.update(auditPathsDto);
    }

    public Map<String, Object> queryAuditPath(AuditPathsDto auditPathsDto, SysUserDto sysUserDto) {
        return auditPathsServiceClient.queryAuditPath(auditPathsDto, sysUserDto);
    }

    public ExecuteResult<String> deleteAuditPaths(Integer ids) {
        return auditPathsServiceClient.deleteAuditPaths(ids);
    }

    public Map<String, Object> selectAuditPathAct(Page page, AuditPathsActsDto auditPathsActsDto) {
        return auditPathsServiceClient.selectAuditPathAct(page,auditPathsActsDto);
    }

    public ExecuteResult<String> saveAuditPathAct(String auditPathsActsDtoList, SysUserDto sysUserDto) {
        return auditPathsServiceClient.saveAuditPathAct(auditPathsActsDtoList, sysUserDto);
    }

    public Map<String, Object>  selectApprovedEvents(SysUserDto sysUserDto) {
        return auditPathsServiceClient.selectApprovedEvents(sysUserDto);
    }
}
