
package io.platform.budget.web.remote;

import com.alibaba.dubbo.config.annotation.Reference;
import com.baomidou.mybatisplus.plugins.Page;
import io.platform.approvalConfiguration.dto.AuditItemsDto;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.budget.dto.BudgetAdjustBillsDto;
import io.platform.budget.service.client.api.BudgetAdjustBillsServiceClient;
import io.platform.sys.dto.SysUserDto;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("budgetAdjustBillsServiceRemote")
public class BudgetAdjustBillsServiceRemote {

    @Reference(check = false)
    private BudgetAdjustBillsServiceClient budgetAdjustBillsServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<BudgetAdjustBillsDto> getList(Map<String, Object> params) {
        return budgetAdjustBillsServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page<BudgetAdjustBillsDto> getPage(Page<BudgetAdjustBillsDto> page, BudgetAdjustBillsDto budgetAdjustBillsDto) {
        return budgetAdjustBillsServiceClient.getPage(page, budgetAdjustBillsDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public BudgetAdjustBillsDto getOne(Long id) {
        BudgetAdjustBillsDto budgetAdjustBillsDto = budgetAdjustBillsServiceClient.queryObject(id);
        return budgetAdjustBillsDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(BudgetAdjustBillsDto budgetAdjustBillsDto) {

        return budgetAdjustBillsServiceClient.save(budgetAdjustBillsDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(BudgetAdjustBillsDto budgetAdjustBillsDto) {

        return budgetAdjustBillsServiceClient.update(budgetAdjustBillsDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return budgetAdjustBillsServiceClient.deleteBatch(ids);
    }


    public Map<String, Object> selectAllAuditItems(String status, SysUserDto sysUserDto) {
        return budgetAdjustBillsServiceClient.selectAllAuditItems(status, sysUserDto);
    }
}
