
package io.platform.budget.web.remote;

import com.alibaba.dubbo.config.annotation.Reference;
import com.baomidou.mybatisplus.plugins.Page;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.budget.dto.ProjectBillsAdjustsDto;
import io.platform.budget.service.client.api.ProjectBillsAdjustsServiceClient;
import io.platform.project.dto.ProjectBillsStepsAdjustDto;
import io.platform.project.dto.ProjectBillsSubsDto;
import io.platform.sys.dto.SysUserDto;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("projectBillsAdjustsServiceRemote")
public class ProjectBillsAdjustsServiceRemote {

    @Reference(check = false)
    private ProjectBillsAdjustsServiceClient projectBillsAdjustsServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<ProjectBillsAdjustsDto> getList(Map<String, Object> params) {
        return projectBillsAdjustsServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Map<String, Object> getPage(Map<String, Object> map,SysUserDto sysUserDto) {
        return projectBillsAdjustsServiceClient.getPage(map,sysUserDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public ProjectBillsAdjustsDto getOne(Long id) {
        ProjectBillsAdjustsDto projectBillsAdjustsDto = projectBillsAdjustsServiceClient.queryObject(id);
        return projectBillsAdjustsDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(ProjectBillsAdjustsDto projectBillsAdjustsDto) {

        return projectBillsAdjustsServiceClient.save(projectBillsAdjustsDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(ProjectBillsAdjustsDto projectBillsAdjustsDto) {

        return projectBillsAdjustsServiceClient.update(projectBillsAdjustsDto);
    }

    /**
     * 删除预算
     * @param projectBillsAdjustsDto
     */
    public ExecuteResult<String> deleteProjectAdjusts(ProjectBillsAdjustsDto projectBillsAdjustsDto) {
        return projectBillsAdjustsServiceClient.deleteProjectAdjusts(projectBillsAdjustsDto);
    }

    /**
     * 调整预算模糊查询
     *
     * @param projectBillsSubsDto
     * @return
     */
    public Map<String, Object> fuzzyQueryProjectAdjust(ProjectBillsSubsDto projectBillsSubsDto) {
        return projectBillsAdjustsServiceClient.fuzzyQueryProjectAdjust(projectBillsSubsDto);
    }


    public Map<String, Object> changeFuzzyQueryProjectAdjust(ProjectBillsSubsDto projectBillsSubsDto) {
        return projectBillsAdjustsServiceClient.changeFuzzyQueryProjectAdjust(projectBillsSubsDto);
    }

    /**
     * 提交
     */
    public ExecuteResult<String> saveProjectAdjusts(String projectBillsSubs, String projectBillsAdjustsDto, SysUserDto sysUserDto) {
        return projectBillsAdjustsServiceClient.saveProjectAdjusts(projectBillsSubs, projectBillsAdjustsDto, sysUserDto);
    }

    /**
     * 暂存
     */
    public ExecuteResult<String> projectAdjustsTemporary(String projectBillsSubs, String projectBillsAdjustsDto, SysUserDto sysUserDto) {
        return projectBillsAdjustsServiceClient.projectAdjustsTemporary(projectBillsSubs, projectBillsAdjustsDto, sysUserDto);
    }

    /**
     * 查询暂存操作信息
     *
     * @param projectBillsAdjustsDto
     * @return
     */
    public Map<String, Object> queryTemporaryInformation(ProjectBillsAdjustsDto projectBillsAdjustsDto) {
        return projectBillsAdjustsServiceClient.queryTemporaryInformation(projectBillsAdjustsDto);
    }

    /**
     * 查询子工程预算信息
     */
    public Map<String, Object> queryProSubBudgetTemporary(ProjectBillsSubsDto projectBillsSubsDto) {
        return projectBillsAdjustsServiceClient.queryProSubBudgetTemporary(projectBillsSubsDto);
    }

    public Map<String, Object> queryProSubBudget(ProjectBillsSubsDto projectBillsSubsDto) {
        return projectBillsAdjustsServiceClient.queryProSubBudget(projectBillsSubsDto);
    }
}
