
package io.platform.budget.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.budget.dto.ProjectBillsBudgetsDto;
import io.platform.budget.service.client.api.ProjectBillsBudgetsServiceClient;
import io.platform.engineering.dto.BpurchasesDto;
import io.platform.engineering.service.client.api.BpurchasesServiceClient;
import io.platform.project.dto.ProjectBillsSubsDto;
import io.platform.project.dto.ProjectbillsDto;
import io.platform.project.dto.SubContractBillsDto;
import io.platform.project.service.client.api.SubContractBillsServiceClient;
import io.platform.sys.dto.SysUserDto;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("projectBillsBudgetsServiceRemote")
public class ProjectBillsBudgetsServiceRemote {

    @Reference(check = false)
    private ProjectBillsBudgetsServiceClient projectBillsBudgetsServiceClient;

    @Reference(check = false)
    private BpurchasesServiceClient bpurchasesServiceClient;

    @Reference(check = false)
    private SubContractBillsServiceClient subContractBillsServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<ProjectBillsBudgetsDto> getList(Map<String, Object> params) {
        return projectBillsBudgetsServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page<ProjectBillsBudgetsDto> getPage(Page<ProjectBillsBudgetsDto> page, ProjectBillsBudgetsDto projectBillsBudgetsDto) {
        return projectBillsBudgetsServiceClient.getPage(page, projectBillsBudgetsDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public ProjectBillsBudgetsDto getOne(Long id) {
        ProjectBillsBudgetsDto projectBillsBudgetsDto = projectBillsBudgetsServiceClient.queryObject(id);
        return projectBillsBudgetsDto;
    }

    /**
     * 暂存
     */
    public ExecuteResult<String> projectBudgetTemporary(String projectBillsSubs, String projectBudget, SysUserDto sysUserDto) {
        return projectBillsBudgetsServiceClient.projectBudgetTemporary(projectBillsSubs, projectBudget, sysUserDto);
    }

    /**
     * 提交
     */
    public ExecuteResult<String> projectBudgetSave(String projectBillsSubs, String projectBudget, SysUserDto sysUserDto) {
        return projectBillsBudgetsServiceClient.projectBudgetSave(projectBillsSubs, projectBudget, sysUserDto);
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(ProjectBillsBudgetsDto projectBillsBudgetsDto) {
        return projectBillsBudgetsServiceClient.save(projectBillsBudgetsDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(ProjectBillsBudgetsDto projectBillsBudgetsDto) {
        return projectBillsBudgetsServiceClient.update(projectBillsBudgetsDto);
    }

    /**
     * 删除预算编制
     *
     * @param projectBillsSubsDto
     */
    public ExecuteResult<String> deleteProjectBudget(ProjectBillsSubsDto projectBillsSubsDto) {
        return projectBillsBudgetsServiceClient.deleteProjectBudget(projectBillsSubsDto);
    }

    /**
     * 根据单号查询
     *
     * @param id
     * @return
     */
    public Map<String, Object> budgetsQueryContract(Integer id) {
        return projectBillsBudgetsServiceClient.budgetsQueryContract(id);
    }

    /**
     * 编辑提交
     */
    public ExecuteResult<String> editBudgetSave(List<ProjectBillsBudgetsDto> projectBillsBudgetsDto) {
        return projectBillsBudgetsServiceClient.editBudgetSave(projectBillsBudgetsDto);
    }

    public Map<String, Object> selectBillsBudget(ProjectBillsBudgetsDto projectBillsBudgetsDto) {
        return projectBillsBudgetsServiceClient.selectBillsBudget(projectBillsBudgetsDto);
    }

    public List<BpurchasesDto> selectProjectPriceBudget(String subNo, Integer loginContractorId) {
        return bpurchasesServiceClient.selectProjectPriceBudget(subNo, loginContractorId);
    }

    public Map<String, Object>  selectProjectSubBills(SubContractBillsDto subContractBillsDto) {
        return subContractBillsServiceClient.selectProjectSubBills(subContractBillsDto);
    }

    public List<Map<String, Object>> selectRenewRecordNew(ProjectBillsSubsDto projectBillsSubsDto) {
        return subContractBillsServiceClient.selectRenewRecordNew(projectBillsSubsDto);
    }
}
