
package io.platform.contract.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.contract.dto.OtherProjectDto;
import io.platform.contract.service.client.api.OtherProjectServiceClient;
import io.platform.moneyManagement.dto.InvoiceBillsDto;
import io.platform.sys.dto.SysUserDto;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("otherProjectServiceRemote")
public class OtherProjectServiceRemote {

    @Reference(check = false)
    private OtherProjectServiceClient otherProjectServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<OtherProjectDto> getList(Map<String, Object> params) {
        return otherProjectServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Map<String, Object> getPage(Map<String, Object> map,SysUserDto sysUserDto) {
        return otherProjectServiceClient.getPage(map,sysUserDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public OtherProjectDto getOne(Long id) {
        OtherProjectDto otherProjectDto = otherProjectServiceClient.queryObject(id);
        return otherProjectDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(OtherProjectDto otherProjectDto) {

        return otherProjectServiceClient.save(otherProjectDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(OtherProjectDto otherProjectDto) {

        return otherProjectServiceClient.update(otherProjectDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return otherProjectServiceClient.deleteBatch(ids);
    }

    /**
     * 暂存
     */
    public ExecuteResult<String> otherProTemporary(OtherProjectDto otherProjectDto, SysUserDto sysUserDto) {
        return otherProjectServiceClient.otherProTemporary(otherProjectDto, sysUserDto);
    }

    /**
     * 提交
     */
    public ExecuteResult<String> otherProSave(OtherProjectDto otherProjectDto, SysUserDto sysUserDto) {
        return otherProjectServiceClient.otherProSave(otherProjectDto, sysUserDto);
    }

    /**
     * 查询暂存信息
     */
    public Map<String, Object> queryOtherProTemporary(OtherProjectDto otherProjectDto) {
        return otherProjectServiceClient.queryOtherProTemporary(otherProjectDto);
    }

    public Map<String, Object> queryOtherProPurchaseNcNo(OtherProjectDto otherProjectDto, SysUserDto sysUserDto) {
        return otherProjectServiceClient.queryOtherProPurchaseNcNo(otherProjectDto, sysUserDto);
    }

    public Map<String, Object> purchaseNcPage(Page page, InvoiceBillsDto otherProjectDto, SysUserDto sysUserDto) {
        return otherProjectServiceClient.purchaseNcPage(page,otherProjectDto, sysUserDto);
    }
}
