
package io.platform.contract.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.contract.dto.ProjectBillsStlPlansDto;
import io.platform.contract.service.client.api.ProjectBillsStlPlansServiceClient;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("projectBillsStlsServiceRemote")
public class ProjectBillsStlsServiceRemote {

    @Reference(check = false)
    private ProjectBillsStlPlansServiceClient projectBillsStlsServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<ProjectBillsStlPlansDto> getList(Map<String, Object> params) {
        return projectBillsStlsServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page<ProjectBillsStlPlansDto> getPage(Page<ProjectBillsStlPlansDto> page, ProjectBillsStlPlansDto projectBillsStlPlansDto) {
        return projectBillsStlsServiceClient.getPage(page, projectBillsStlPlansDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public ProjectBillsStlPlansDto getOne(Long id) {
        ProjectBillsStlPlansDto projectBillsStlPlansDto = projectBillsStlsServiceClient.queryObject(id);
        return projectBillsStlPlansDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(ProjectBillsStlPlansDto projectBillsStlPlansDto) {

        return projectBillsStlsServiceClient.save(projectBillsStlPlansDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(ProjectBillsStlPlansDto projectBillsStlPlansDto) {

        return projectBillsStlsServiceClient.update(projectBillsStlPlansDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return projectBillsStlsServiceClient.deleteBatch(ids);
    }

    /**
     * 查询结算明细
     *
     * @param projectBillsStlPlansDto
     * @return
     */
    public Map<String, Object> queryProStls(ProjectBillsStlPlansDto projectBillsStlPlansDto) {
        return projectBillsStlsServiceClient.queryProStls(projectBillsStlPlansDto);
    }
}
