
package io.platform.contract.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.contract.dto.TasklistsDto;
import io.platform.contract.service.client.api.TasklistsServiceClient;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("tasklistsServiceRemote")
public class TasklistsServiceRemote {

    @Reference(check = false)
    private TasklistsServiceClient tasklistsServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<TasklistsDto> getList(Map<String, Object> params) {
        return tasklistsServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page<TasklistsDto> getPage(Page<TasklistsDto> page, TasklistsDto tasklistsDto) {
        return tasklistsServiceClient.getPage(page, tasklistsDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public TasklistsDto getOne(Long id) {
        TasklistsDto tasklistsDto = tasklistsServiceClient.queryObject(id);
        return tasklistsDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(TasklistsDto tasklistsDto) {

        return tasklistsServiceClient.save(tasklistsDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(TasklistsDto tasklistsDto) {

        return tasklistsServiceClient.update(tasklistsDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return tasklistsServiceClient.deleteBatch(ids);
    }


}
