
package io.platform.engineering.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.engineering.dto.BbranchsDto;
import io.platform.engineering.service.client.api.BbranchsServiceClient;
import io.platform.sys.dto.SysUserDto;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("bbranchsServiceRemote")
public class BbranchsServiceRemote {

    @Reference(check = false)
    private BbranchsServiceClient bbranchsServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<BbranchsDto> getList(Map<String, Object> params) {
        return bbranchsServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page<BbranchsDto> getPage(Page<BbranchsDto> page, BbranchsDto bbranchsDto) {
        return bbranchsServiceClient.getPage(page, bbranchsDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public BbranchsDto getOne(Long id) {
        BbranchsDto bbranchsDto = bbranchsServiceClient.queryObject(id);
        return bbranchsDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> branchSave(BbranchsDto bbranchsDto, SysUserDto sysUserDto) {

        return bbranchsServiceClient.branchSave(bbranchsDto, sysUserDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(BbranchsDto bbranchsDto) {

        return bbranchsServiceClient.update(bbranchsDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return bbranchsServiceClient.deleteBatch(ids);
    }

    /**
     * 模糊查询
     *
     * @param bbranchsDto
     * @return
     */
    public Map<String, Object> fuzzyQueryBranch(Page page, BbranchsDto bbranchsDto) {
        return bbranchsServiceClient.fuzzyQueryBranch(page, bbranchsDto);
    }

    /**
     * 查询所有
     */
    public Map<String, Object> selectbranchs(BbranchsDto bbranchsDto, SysUserDto sysUserDto) {
        return bbranchsServiceClient.selectbranchs(bbranchsDto, sysUserDto);
    }

    /**
     * 查询所有
     */
    public String selectbranchsTree() {
        return bbranchsServiceClient.selectbranchsTree();
    }
    public Map<String, Object> homeGetBranchs(SysUserDto sysUserDto) {
        return bbranchsServiceClient.homeGetBranchs(sysUserDto);
    }
}
