
package io.platform.engineering.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.engineering.dto.BbudgetsDto;
import io.platform.engineering.service.client.api.BbudgetsServiceClient;
import io.platform.moneyManagement.dto.InvoiceBillsDto;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("bbudgetsServiceRemote")
public class BbudgetsServiceRemote {

    @Reference(check = false)
    private BbudgetsServiceClient bbudgetsServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<BbudgetsDto> getList(Map<String, Object> params) {
        return bbudgetsServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page<BbudgetsDto> getPage(Page<BbudgetsDto> page, BbudgetsDto bbudgetsDto) {
        return bbudgetsServiceClient.getPage(page, bbudgetsDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public BbudgetsDto getOne(Long id) {
        BbudgetsDto bbudgetsDto = bbudgetsServiceClient.queryObject(id);
        return bbudgetsDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(BbudgetsDto bbudgetsDto) {

        return bbudgetsServiceClient.save(bbudgetsDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(BbudgetsDto bbudgetsDto) {

        return bbudgetsServiceClient.update(bbudgetsDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return bbudgetsServiceClient.deleteBatch(ids);
    }

    /**
     * 模糊查询
     *
     * @param bbudgetsDto
     * @return
     */
    public Map<String, Object> fuzzyQueryBudget(Page page, BbudgetsDto bbudgetsDto) {
        return bbudgetsServiceClient.fuzzyQueryBudget(page, bbudgetsDto);
    }

    /*
     * 暂用！！！！！！！！！！！！！！！暂用！！！！！！！！！！
     */
    public Map<String, Object> zYQueryBudgetId(InvoiceBillsDto invoiceBillsDto) {
        return bbudgetsServiceClient.zYQueryBudgetId(invoiceBillsDto);
    }

    /**
     * 查询所有
     */
    public Map<String, Object> selectBudgets(BbudgetsDto bbudgetsDto) {
        return bbudgetsServiceClient.selectBudgets(bbudgetsDto);
    }

    public Map<String, Object> selectOtherBudgets(BbudgetsDto bbudgetsDto) {
        return bbudgetsServiceClient.selectOtherBudgets(bbudgetsDto);
    }
}
