
package io.platform.engineering.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.engineering.dto.BcorpTypesDto;
import io.platform.engineering.service.client.api.BcorpTypesServiceClient;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("bcorpTypesServiceRemote")
public class BcorpTypesServiceRemote {

    @Reference(check = false)
    private BcorpTypesServiceClient bcorpTypesServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<BcorpTypesDto> getList(Map<String, Object> params) {
        return bcorpTypesServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page<BcorpTypesDto> getPage(Page<BcorpTypesDto> page, BcorpTypesDto bcorpTypesDto) {
        return bcorpTypesServiceClient.getPage(page, bcorpTypesDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public BcorpTypesDto getOne(Long id) {
        BcorpTypesDto bcorpTypesDto = bcorpTypesServiceClient.queryObject(id);
        return bcorpTypesDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(BcorpTypesDto bcorpTypesDto) {

        return bcorpTypesServiceClient.save(bcorpTypesDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(BcorpTypesDto bcorpTypesDto) {

        return bcorpTypesServiceClient.update(bcorpTypesDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return bcorpTypesServiceClient.deleteBatch(ids);
    }

    /**
     * 模糊查询
     *
     * @param bcorpTypesDto
     * @return
     */
    public Map<String, Object> fuzzyQueryCorpsType(Page page, BcorpTypesDto bcorpTypesDto) {
        return bcorpTypesServiceClient.fuzzyQueryCorpsType(page, bcorpTypesDto);
    }

    /**
     * 查询所有
     */
    public Map<String, Object> selectCorpType(BcorpTypesDto bcorpTypesDto) {
        return bcorpTypesServiceClient.selectCorpType(bcorpTypesDto);
    }
}
