
package io.platform.engineering.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.engineering.dto.BcorpsDto;
import io.platform.engineering.dto.BprojectTypesDto;
import io.platform.engineering.service.client.api.BcorpsServiceClient;
import io.platform.sys.dto.SysUserDto;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("bcorpsServiceRemote")
public class BcorpsServiceRemote {

    @Reference(check = false)
    private BcorpsServiceClient bcorpsServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<BcorpsDto> getList(Map<String, Object> params) {
        return bcorpsServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page<BcorpsDto> getPage(Page<BcorpsDto> page, BcorpsDto bcorpsDto, SysUserDto sysUserDto) {
        return bcorpsServiceClient.getPage(page, bcorpsDto,sysUserDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public BcorpsDto getOne(Long id) {
        BcorpsDto bcorpsDto = bcorpsServiceClient.queryObject(id);
        return bcorpsDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(BcorpsDto bcorpsDto) {

        return bcorpsServiceClient.save(bcorpsDto);
    }
    /**
     * 保存 数据
     */
    public ExecuteResult<String> saveList(List<BcorpsDto> bcorpsDto) {

        return bcorpsServiceClient.saveList(bcorpsDto);
    }
    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(BcorpsDto bcorpsDto) {

        return bcorpsServiceClient.update(bcorpsDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return bcorpsServiceClient.deleteBatch(ids);
    }


    /**
     * 模糊查询
     *
     * @param page
     * @param bcorpsDto
     * @return
     */
    public Map<String, Object> fuzzyQueryCorps(Page page, BcorpsDto bcorpsDto) {
        return bcorpsServiceClient.fuzzyQueryCorps(page, bcorpsDto);
    }

    /**
     * 查询所有
     */
    public Map<String, Object> selectCorps(BcorpsDto bcorpsDto) {
        return bcorpsServiceClient.selectCorps(bcorpsDto);
    }
}
