
package io.platform.engineering.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.engineering.dto.BdeptsDto;
import io.platform.engineering.service.client.api.BdeptsServiceClient;
import io.platform.sys.dto.SysUserDto;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("bdeptsServiceRemote")
public class BdeptsServiceRemote {

    @Reference(check = false)
    private BdeptsServiceClient bdeptsServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<BdeptsDto> getList(Map<String, Object> params) {
        return bdeptsServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page<BdeptsDto> getPage(Page<BdeptsDto> page, BdeptsDto bdeptsDto) {
        return bdeptsServiceClient.getPage(page, bdeptsDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public BdeptsDto getOne(Long id) {
        BdeptsDto bdeptsDto = bdeptsServiceClient.queryObject(id);
        return bdeptsDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(BdeptsDto bdeptsDto) {

        return bdeptsServiceClient.save(bdeptsDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(BdeptsDto bdeptsDto) {

        return bdeptsServiceClient.update(bdeptsDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return bdeptsServiceClient.deleteBatch(ids);
    }


    /**
     * 查询所有
     */
    public Map<String, Object> selectDepts(BdeptsDto bdeptsDto) {
        return bdeptsServiceClient.selectDepts(bdeptsDto);
    }
}
