
package io.platform.engineering.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.engineering.dto.BemplsDto;
import io.platform.engineering.service.client.api.BemplsServiceClient;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("bemplsServiceRemote")
public class BemplsServiceRemote {

    @Reference(check = false)
    private BemplsServiceClient bemplsServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<BemplsDto> getList(Map<String, Object> params) {
        return bemplsServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page<BemplsDto> getPage(Page<BemplsDto> page, BemplsDto bemplsDto) {
        return bemplsServiceClient.getPage(page, bemplsDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public BemplsDto getOne(Long id) {
        BemplsDto bemplsDto = bemplsServiceClient.queryObject(id);
        return bemplsDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(BemplsDto bemplsDto) {

        return bemplsServiceClient.save(bemplsDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(BemplsDto bemplsDto) {

        return bemplsServiceClient.update(bemplsDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return bemplsServiceClient.deleteBatch(ids);
    }

    /**
     * 模糊查询
     *
     * @param bemplsDto
     * @return
     */
    public Map<String, Object> fuzzyQueryEmpls(Page page, BemplsDto bemplsDto) {
        return bemplsServiceClient.fuzzyQueryEmpls(page, bemplsDto);
    }
}
