
package io.platform.engineering.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.engineering.dto.BemplsDto;
import io.platform.engineering.dto.BpayPropertysDto;
import io.platform.engineering.service.client.api.BpayPropertysServiceClient;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("bpayPropertysServiceRemote")
public class BpayPropertysServiceRemote {

    @Reference(check = false)
    private BpayPropertysServiceClient bpayPropertysServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<BpayPropertysDto> getList(Map<String, Object> params) {
        return bpayPropertysServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page<BpayPropertysDto> getPage(Page<BpayPropertysDto> page, BpayPropertysDto bpayPropertysDto) {
        return bpayPropertysServiceClient.getPage(page, bpayPropertysDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public BpayPropertysDto getOne(Long id) {
        BpayPropertysDto bpayPropertysDto = bpayPropertysServiceClient.queryObject(id);
        return bpayPropertysDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(BpayPropertysDto bpayPropertysDto) {

        return bpayPropertysServiceClient.save(bpayPropertysDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(BpayPropertysDto bpayPropertysDto) {

        return bpayPropertysServiceClient.update(bpayPropertysDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return bpayPropertysServiceClient.deleteBatch(ids);
    }

    /**
     * 模糊查询
     *
     * @param bpayPropertysDto
     * @return
     */
    public Map<String, Object> fuzzyQueryPayProperty(Page page, BpayPropertysDto bpayPropertysDto) {
        return bpayPropertysServiceClient.fuzzyQueryPayProperty(page, bpayPropertysDto);
    }

    /**
     * 查询所有
     */
    public Map<String, Object> selectPayPropertys(BpayPropertysDto bpayPropertysDto) {
        return bpayPropertysServiceClient.selectPayPropertys(bpayPropertysDto);
    }
}
