
package io.platform.engineering.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.engineering.dto.BpriceModesDto;
import io.platform.engineering.service.client.api.BpriceModesServiceClient;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("bpriceModesServiceRemote")
public class BpriceModesServiceRemote {

    @Reference(check = false)
    private BpriceModesServiceClient bpriceModesServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<BpriceModesDto> getList(Map<String, Object> params) {
        return bpriceModesServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page<BpriceModesDto> getPage(Page<BpriceModesDto> page, BpriceModesDto bpriceModesDto) {
        return bpriceModesServiceClient.getPage(page, bpriceModesDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public BpriceModesDto getOne(Long id) {
        BpriceModesDto bpriceModesDto = bpriceModesServiceClient.queryObject(id);
        return bpriceModesDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(BpriceModesDto bpriceModesDto) {

        return bpriceModesServiceClient.save(bpriceModesDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(BpriceModesDto bpriceModesDto) {

        return bpriceModesServiceClient.update(bpriceModesDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return bpriceModesServiceClient.deleteBatch(ids);
    }

    /**
     * 模糊查询
     *
     * @param bpriceModesDto
     * @return
     */
    public Map<String, Object> fuzzyQueryPriceModes(Page page, BpriceModesDto bpriceModesDto) {
        return bpriceModesServiceClient.fuzzyQueryPriceModes(page, bpriceModesDto);
    }

    /**
     * 查询所有
     */
    public Map<String, Object> selectProModes(BpriceModesDto bpriceModesDto) {
        return bpriceModesServiceClient.selectProModes(bpriceModesDto);
    }
}
