
package io.platform.engineering.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.engineering.dto.BprojectNodeStepsDto;
import io.platform.engineering.dto.BprojectNodesDto;
import io.platform.engineering.service.client.api.BprojectNodeStepsServiceClient;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("bprojectNodeStepsServiceRemote")
public class BprojectNodeStepsServiceRemote {

    @Reference(check = false)
    private BprojectNodeStepsServiceClient bprojectNodeStepsServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<BprojectNodeStepsDto> getList(Map<String, Object> params) {
        return bprojectNodeStepsServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page<BprojectNodeStepsDto> getPage(Page<BprojectNodeStepsDto> page, BprojectNodeStepsDto bprojectNodeStepsDto) {
        return bprojectNodeStepsServiceClient.getPage(page, bprojectNodeStepsDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public BprojectNodeStepsDto getOne(Long id) {
        BprojectNodeStepsDto bprojectNodeStepsDto = bprojectNodeStepsServiceClient.queryObject(id);
        return bprojectNodeStepsDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(BprojectNodeStepsDto bprojectNodeStepsDto) {

        return bprojectNodeStepsServiceClient.save(bprojectNodeStepsDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(BprojectNodeStepsDto bprojectNodeStepsDto) {

        return bprojectNodeStepsServiceClient.update(bprojectNodeStepsDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return bprojectNodeStepsServiceClient.deleteBatch(ids);
    }

    /**
     * 模糊查询
     *
     * @param bprojectNodeStepsDto
     * @return
     */
    public Map<String, Object> fuzzyQueryProjectNodeSt(Page page, BprojectNodeStepsDto bprojectNodeStepsDto) {
        return bprojectNodeStepsServiceClient.fuzzyQueryProjectNodeSt(page, bprojectNodeStepsDto);
    }

    /**
     * 查询所有
     */
    public Map<String, Object> selectProNodeSteps(BprojectNodeStepsDto bprojectNodeStepsDto) {
        return bprojectNodeStepsServiceClient.selectProNodeSteps(bprojectNodeStepsDto);
    }
}
