
package io.platform.engineering.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.engineering.dto.BprojectNodesDto;
import io.platform.engineering.service.client.api.BprojectNodesServiceClient;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("bprojectNodesServiceRemote")
public class BprojectNodesServiceRemote {

    @Reference(check = false)
    private BprojectNodesServiceClient bprojectNodesServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<BprojectNodesDto> getList(Map<String, Object> params) {
        return bprojectNodesServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page<BprojectNodesDto> getPage(Page<BprojectNodesDto> page, BprojectNodesDto bprojectNodesDto) {
        return bprojectNodesServiceClient.getPage(page, bprojectNodesDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public BprojectNodesDto getOne(Long id) {
        BprojectNodesDto bprojectNodesDto = bprojectNodesServiceClient.queryObject(id);
        return bprojectNodesDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(BprojectNodesDto bprojectNodesDto) {

        return bprojectNodesServiceClient.save(bprojectNodesDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(BprojectNodesDto bprojectNodesDto) {

        return bprojectNodesServiceClient.update(bprojectNodesDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return bprojectNodesServiceClient.deleteBatch(ids);
    }

    /**
     * 模糊查询
     *
     * @param bprojectNodesDto
     * @return
     */
    public Map<String, Object> fuzzyQueryProjectNodes(Page page, BprojectNodesDto bprojectNodesDto) {
        return bprojectNodesServiceClient.fuzzyQueryProjectNodes(page, bprojectNodesDto);
    }

    /**
     * 查询所有
     */
    public Map<String, Object> selectProNodes(BprojectNodesDto bprojectNodesDto) {
        return bprojectNodesServiceClient.selectProNodes(bprojectNodesDto);
    }
}
