
package io.platform.engineering.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.engineering.dto.BprojectTypesItemsDto;
import io.platform.engineering.service.client.api.BprojectTypesItemsServiceClient;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("bprojectTypesItemsServiceRemote")
public class BprojectTypesItemsServiceRemote {

    @Reference(check = false)
    private BprojectTypesItemsServiceClient bprojectTypesItemsServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<BprojectTypesItemsDto> getList(Map<String, Object> params) {
        return bprojectTypesItemsServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page<BprojectTypesItemsDto> getPage(Page<BprojectTypesItemsDto> page, BprojectTypesItemsDto bprojectTypesItemsDto) {
        return bprojectTypesItemsServiceClient.getPage(page, bprojectTypesItemsDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public BprojectTypesItemsDto getOne(Long id) {
        BprojectTypesItemsDto bprojectTypesItemsDto = bprojectTypesItemsServiceClient.queryObject(id);
        return bprojectTypesItemsDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(BprojectTypesItemsDto bprojectTypesItemsDto) {

        return bprojectTypesItemsServiceClient.save(bprojectTypesItemsDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(BprojectTypesItemsDto bprojectTypesItemsDto) {

        return bprojectTypesItemsServiceClient.update(bprojectTypesItemsDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return bprojectTypesItemsServiceClient.deleteBatch(ids);
    }

    /**
     * 查询所有
     */
    public Map<String, Object> selectProTypsItems(BprojectTypesItemsDto bprojectTypesItemsDto) {
        return bprojectTypesItemsServiceClient.selectProTypsItems(bprojectTypesItemsDto);
    }
}
