
package io.platform.engineering.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.engineering.dto.BprojectTypesDto;
import io.platform.engineering.service.client.api.BprojectTypesServiceClient;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("bprojectTypesServiceRemote")
public class BprojectTypesServiceRemote {

    @Reference(check = false)
    private BprojectTypesServiceClient bprojectTypesServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<BprojectTypesDto> getList(Map<String, Object> params) {
        return bprojectTypesServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page<BprojectTypesDto> getPage(Page<BprojectTypesDto> page, BprojectTypesDto bprojectTypesDto) {
        return bprojectTypesServiceClient.getPage(page, bprojectTypesDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public BprojectTypesDto getOne(Long id) {
        BprojectTypesDto bprojectTypesDto = bprojectTypesServiceClient.queryObject(id);
        return bprojectTypesDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(BprojectTypesDto bprojectTypesDto) {

        return bprojectTypesServiceClient.save(bprojectTypesDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(BprojectTypesDto bprojectTypesDto) {

        return bprojectTypesServiceClient.update(bprojectTypesDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return bprojectTypesServiceClient.deleteBatch(ids);
    }


    /**
     * 模糊查询
     *
     * @param page
     * @param bprojectTypesDto
     * @return
     */
    public Map<String, Object> fuzzyQueryProjectTypes(Page page, BprojectTypesDto bprojectTypesDto) {
        return bprojectTypesServiceClient.fuzzyQueryProjectTypes(page, bprojectTypesDto);
    }

    /**
     * 查询所有
     */
    public Map<String, Object> selectProTypes(BprojectTypesDto bprojectTypesDto) {
        return bprojectTypesServiceClient.selectProTypes(bprojectTypesDto);
    }
}
