
package io.platform.engineering.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.engineering.dto.BpurchaseModesDto;
import io.platform.engineering.service.client.api.BpurchaseModesServiceClient;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("bpurchaseModesServiceRemote")
public class BpurchaseModesServiceRemote {

    @Reference(check = false)
    private BpurchaseModesServiceClient bpurchaseModesServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<BpurchaseModesDto> getList(Map<String, Object> params) {
        return bpurchaseModesServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page<BpurchaseModesDto> getPage(Page<BpurchaseModesDto> page, BpurchaseModesDto bpurchaseModesDto) {
        return bpurchaseModesServiceClient.getPage(page, bpurchaseModesDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public BpurchaseModesDto getOne(Long id) {
        BpurchaseModesDto bpurchaseModesDto = bpurchaseModesServiceClient.queryObject(id);
        return bpurchaseModesDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(BpurchaseModesDto bpurchaseModesDto) {

        return bpurchaseModesServiceClient.save(bpurchaseModesDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(BpurchaseModesDto bpurchaseModesDto) {

        return bpurchaseModesServiceClient.update(bpurchaseModesDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return bpurchaseModesServiceClient.deleteBatch(ids);
    }

    /**
     * 查询所有
     */
    public Map<String, Object> selectpurModes(BpurchaseModesDto bpurchaseModesDto) {
        return bpurchaseModesServiceClient.selectpurModes(bpurchaseModesDto);
    }
}
