
package io.platform.engineering.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.engineering.dto.BpurchaseSubTypesDto;
import io.platform.engineering.service.client.api.BpurchaseSubTypesServiceClient;
import io.platform.sys.dto.SysUserDto;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("bpurchaseSubTypesServiceRemote")
public class BpurchaseSubTypesServiceRemote {

    @Reference(check = false)
    private BpurchaseSubTypesServiceClient bpurchaseSubTypesServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<BpurchaseSubTypesDto> getList(Map<String, Object> params) {
        return bpurchaseSubTypesServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page<BpurchaseSubTypesDto> getPage(Page<BpurchaseSubTypesDto> page, BpurchaseSubTypesDto bpurchaseSubTypesDto) {
        return bpurchaseSubTypesServiceClient.getPage(page, bpurchaseSubTypesDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public BpurchaseSubTypesDto getOne(Long id) {
        BpurchaseSubTypesDto bpurchaseSubTypesDto = bpurchaseSubTypesServiceClient.queryObject(id);
        return bpurchaseSubTypesDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(BpurchaseSubTypesDto bpurchaseSubTypesDto) {

        return bpurchaseSubTypesServiceClient.save(bpurchaseSubTypesDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(BpurchaseSubTypesDto bpurchaseSubTypesDto) {

        return bpurchaseSubTypesServiceClient.update(bpurchaseSubTypesDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return bpurchaseSubTypesServiceClient.deleteBatch(ids);
    }


    public Map<String, Object> down(SysUserDto sysUserDto) {
        return bpurchaseSubTypesServiceClient.down(sysUserDto);
    }

    /**
     * 查询所有
     */
    public Map<String, Object> selectPurchSubTypes(BpurchaseSubTypesDto bpurchaseSubTypesDto) {
        return bpurchaseSubTypesServiceClient.selectPurchSubTypes(bpurchaseSubTypesDto);
    }
}
