
package io.platform.engineering.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.engineering.dto.BpurchaseTypesDto;
import io.platform.engineering.service.client.api.BpurchaseTypesServiceClient;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("bpurchaseTypesServiceRemote")
public class BpurchaseTypesServiceRemote {

    @Reference(check = false)
    private BpurchaseTypesServiceClient bpurchaseTypesServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<BpurchaseTypesDto> getList(Map<String, Object> params) {
        return bpurchaseTypesServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page<BpurchaseTypesDto> getPage(Page<BpurchaseTypesDto> page, BpurchaseTypesDto bpurchaseTypesDto) {
        return bpurchaseTypesServiceClient.getPage(page, bpurchaseTypesDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public BpurchaseTypesDto getOne(Long id) {
        BpurchaseTypesDto bpurchaseTypesDto = bpurchaseTypesServiceClient.queryObject(id);
        return bpurchaseTypesDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(BpurchaseTypesDto bpurchaseTypesDto) {

        return bpurchaseTypesServiceClient.save(bpurchaseTypesDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(BpurchaseTypesDto bpurchaseTypesDto) {

        return bpurchaseTypesServiceClient.update(bpurchaseTypesDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return bpurchaseTypesServiceClient.deleteBatch(ids);
    }

    /**
     * 查询所有
     */
    public Map<String, Object> selectPurchTypes(BpurchaseTypesDto bpurchaseTypesDto) {
        return bpurchaseTypesServiceClient.selectPurchTypes(bpurchaseTypesDto);
    }
}
