
package io.platform.engineering.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.engineering.dto.BpurchasesDto;
import io.platform.engineering.service.client.api.BpurchasesServiceClient;
import io.platform.moneyManagement.dto.InvoiceBillsDto;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("bpurchasesServiceRemote")
public class BpurchasesServiceRemote {

    @Reference(check = false)
    private BpurchasesServiceClient bpurchasesServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<BpurchasesDto> getList(Map<String, Object> params) {
        return bpurchasesServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page<BpurchasesDto> getPage(Page<BpurchasesDto> page, BpurchasesDto bpurchasesDto) {
        return bpurchasesServiceClient.getPage(page, bpurchasesDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public BpurchasesDto getOne(Long id) {
        BpurchasesDto bpurchasesDto = bpurchasesServiceClient.queryObject(id);
        return bpurchasesDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(BpurchasesDto bpurchasesDto) {

        return bpurchasesServiceClient.save(bpurchasesDto);
    }
    /**
     * 保存 数据
     */
    public ExecuteResult<String> saveList(List<BpurchasesDto> bpurchasesDto) {

        return bpurchasesServiceClient.saveList(bpurchasesDto);
    }
    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(BpurchasesDto bpurchasesDto) {

        return bpurchasesServiceClient.update(bpurchasesDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return bpurchasesServiceClient.deleteBatch(ids);
    }

    /**
     * 模糊查询
     */
    public Map<String, Object> fuzzyQueryPurchases(Page page, BpurchasesDto bpurchasesDto) {
        return bpurchasesServiceClient.fuzzyQueryPurchases(page, bpurchasesDto);
    }

    /**
     * 查询所有
     */
    public Map<String, Object> selectPurchases(BpurchasesDto bpurchasesDto) {
        return bpurchasesServiceClient.selectPurchases(bpurchasesDto);
    }

    public Map<String, Object> queryDirectPay(Page page, InvoiceBillsDto invoiceBillsDto) {
        return bpurchasesServiceClient.queryDirectPay(page, invoiceBillsDto);
    }
}
