
package io.platform.fileManagement.remote;
import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.fileManagement.dto.DataFileManagementDto;
import io.platform.fileManagement.service.client.api.DataFileManagementServiceClient;
import org.springframework.boot.configurationprocessor.json.JSONArray;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("dataFileManagementServiceRemote")
public class DataFileManagementServiceRemote {

    @Reference(check = false)
    private DataFileManagementServiceClient dataFileManagementServiceClient;
    /**
     * 根据参数获取列表  无分页
     */
    public List<DataFileManagementDto> getList(Map<String, Object> params){
        return dataFileManagementServiceClient.queryList(params);
    }
    /**
     * 根据参数进行 分页查询
     */
    public Page<DataFileManagementDto> getPage(Page<DataFileManagementDto> page,DataFileManagementDto dataFileManagementDto){
        return dataFileManagementServiceClient.getPage(page,dataFileManagementDto);
    }
    /**
     * 根据主键 获取单条数据明细
     */
    public DataFileManagementDto getOne(Long id){
        DataFileManagementDto dataFileManagementDto = dataFileManagementServiceClient.queryObject(id);
        return dataFileManagementDto;
    }
    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(DataFileManagementDto dataFileManagementDto){

       return  dataFileManagementServiceClient.save(dataFileManagementDto);
    }
    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(DataFileManagementDto dataFileManagementDto){

        return dataFileManagementServiceClient.update(dataFileManagementDto);
    }
    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids){
        return  dataFileManagementServiceClient.deleteBatch(ids);
    }
    /**
     *  参数查询getFileList
     */
    public List<HashMap<String,String>>  getFileList(Integer ids){
        return  dataFileManagementServiceClient.getFileList(ids);
    }
    /**
     *  参数查询getFileList
     */
    public String getFileList2(Integer ids){
        return  dataFileManagementServiceClient.getFileList2(ids);
    }

}
