
package io.platform.fileManagement.remote;
import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.fileManagement.dto.DataFileOperatingDto;
import io.platform.fileManagement.service.client.api.DataFileOperatingServiceClient;
import org.springframework.stereotype.Service;
import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("dataFileOperatingServiceRemote")
public class DataFileOperatingServiceRemote {

    @Reference(check = false)
    private DataFileOperatingServiceClient dataFileOperatingServiceClient;
    /**
     * 根据参数获取列表  无分页
     */
    public List<DataFileOperatingDto> getList(Map<String, Object> params){
        return dataFileOperatingServiceClient.queryList(params);
    }
    /**
     * 根据参数进行 分页查询
     */
    public Page<DataFileOperatingDto> getPage(Page<DataFileOperatingDto> page,DataFileOperatingDto dataFileOperatingDto){
        return dataFileOperatingServiceClient.getPage(page,dataFileOperatingDto);
    }
    /**
     * 根据主键 获取单条数据明细
     */
    public DataFileOperatingDto getOne(Long id){
        DataFileOperatingDto dataFileOperatingDto = dataFileOperatingServiceClient.queryObject(id);
        return dataFileOperatingDto;
    }
    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(DataFileOperatingDto dataFileOperatingDto){

       return  dataFileOperatingServiceClient.save(dataFileOperatingDto);
    }
    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(DataFileOperatingDto dataFileOperatingDto){

        return dataFileOperatingServiceClient.update(dataFileOperatingDto);
    }
    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids){
        return  dataFileOperatingServiceClient.deleteBatch(ids);
    }



}
