
package io.platform.fileManagement.remote;
import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.fileManagement.dto.DataFileStorageDto;
import io.platform.fileManagement.service.client.api.DataFileStorageServiceClient;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("dataFileStorageServiceRemote")
public class DataFileStorageServiceRemote {

    @Reference(check = false)
    private DataFileStorageServiceClient dataFileStorageServiceClient;
    /**
     * 根据参数获取列表  无分页
     */
    public List<DataFileStorageDto> getList(Map<String, Object> params){
        return dataFileStorageServiceClient.queryList(params);
    }


    /**
     * 根据参数进行 分页查询
     */
    public Page<DataFileStorageDto> getPage(Page<DataFileStorageDto> page,DataFileStorageDto dataFileStorageDto){
        return dataFileStorageServiceClient.getPage(page,dataFileStorageDto);
    }
    /**
     * 根据主键 获取单条数据明细
     */
    public DataFileStorageDto getOne(Long id){
        DataFileStorageDto dataFileStorageDto = dataFileStorageServiceClient.queryObject(id);
        return dataFileStorageDto;
    }
    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(DataFileStorageDto dataFileStorageDto){

       return  dataFileStorageServiceClient.save(dataFileStorageDto);
    }
    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(DataFileStorageDto dataFileStorageDto){

        return dataFileStorageServiceClient.update(dataFileStorageDto);
    }
    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids){
        return  dataFileStorageServiceClient.deleteBatch(ids);
    }

    public List<DataFileStorageDto> selectHomeFileList() {
        return dataFileStorageServiceClient.selectHomeFileList();
    }

}
