
package io.platform.moneyManagement.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.moneyManagement.dto.InvoiceBillsAttachsDto;
import io.platform.moneyManagement.service.client.api.InvoiceBillsAttachsServiceClient;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("invoiceBillsAttachsServiceRemote")
public class InvoiceBillsAttachsServiceRemote {

    @Reference(check = false)
    private InvoiceBillsAttachsServiceClient invoiceBillsAttachsServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<InvoiceBillsAttachsDto> getList(Map<String, Object> params) {
        return invoiceBillsAttachsServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page<InvoiceBillsAttachsDto> getPage(Page<InvoiceBillsAttachsDto> page, InvoiceBillsAttachsDto invoiceBillsAttachsDto) {
        return invoiceBillsAttachsServiceClient.getPage(page, invoiceBillsAttachsDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public InvoiceBillsAttachsDto getOne(Long id) {
        InvoiceBillsAttachsDto invoiceBillsAttachsDto = invoiceBillsAttachsServiceClient.queryObject(id);
        return invoiceBillsAttachsDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(InvoiceBillsAttachsDto invoiceBillsAttachsDto) {

        return invoiceBillsAttachsServiceClient.save(invoiceBillsAttachsDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(InvoiceBillsAttachsDto invoiceBillsAttachsDto) {

        return invoiceBillsAttachsServiceClient.update(invoiceBillsAttachsDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return invoiceBillsAttachsServiceClient.deleteBatch(ids);
    }


}
