
package io.platform.moneyManagement.web.remote;

import com.alibaba.dubbo.config.annotation.Reference;
import com.baomidou.mybatisplus.plugins.Page;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.moneyManagement.dto.InvoiceBillsItemsDto;
import io.platform.moneyManagement.service.client.api.InvoiceBillsItemsServiceClient;
import io.platform.sys.dto.SysUserDto;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("invoiceBillsItemsServiceRemote")
public class InvoiceBillsItemsServiceRemote {

    @Reference(check = false)
    private InvoiceBillsItemsServiceClient invoiceBillsItemsServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<InvoiceBillsItemsDto> getList(Map<String, Object> params) {
        return invoiceBillsItemsServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page<InvoiceBillsItemsDto> getPage(Page<InvoiceBillsItemsDto> page, InvoiceBillsItemsDto invoiceBillsItemsDto) {
        return invoiceBillsItemsServiceClient.getPage(page, invoiceBillsItemsDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public InvoiceBillsItemsDto getOne(Long id) {
        InvoiceBillsItemsDto invoiceBillsItemsDto = invoiceBillsItemsServiceClient.queryObject(id);
        return invoiceBillsItemsDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(InvoiceBillsItemsDto invoiceBillsItemsDto) {

        return invoiceBillsItemsServiceClient.save(invoiceBillsItemsDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(InvoiceBillsItemsDto invoiceBillsItemsDto) {

        return invoiceBillsItemsServiceClient.update(invoiceBillsItemsDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return invoiceBillsItemsServiceClient.deleteBatch(ids);
    }


    public Map<String, Object> selectNumber(String subNo, Integer purchaseId, Integer budgetId) {
        return invoiceBillsItemsServiceClient.selectNumber(subNo, purchaseId, budgetId);
    }

    /**
     * 删除单条明细
     */
    public ExecuteResult<String> deleteItem(InvoiceBillsItemsDto invoiceBillsItemsDto) {
        return invoiceBillsItemsServiceClient.deleteItem(invoiceBillsItemsDto);
    }


    public Map<String, Object> selectDirectPaymentPurchase(String subNo, Integer budId, SysUserDto sysUserDto) {
        return invoiceBillsItemsServiceClient.selectDirectPaymentPurchase(subNo,budId, sysUserDto);
    }
}
