
package io.platform.moneyManagement.web.remote;
import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.moneyManagement.dto.InvoiceBillsPlansDto;
import io.platform.moneyManagement.service.client.api.InvoiceBillsPlansServiceClient;
import org.springframework.stereotype.Service;
import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("invoiceBillsPlansServiceRemote")
public class InvoiceBillsPlansServiceRemote {

    @Reference(check = false)
    private InvoiceBillsPlansServiceClient invoiceBillsPlansServiceClient;
    /**
     * 根据参数获取列表  无分页
     */
    public List<InvoiceBillsPlansDto> getList(Map<String, Object> params){
        return invoiceBillsPlansServiceClient.queryList(params);
    }
    /**
     * 根据参数进行 分页查询
     */
    public Page<InvoiceBillsPlansDto> getPage(Page<InvoiceBillsPlansDto> page,InvoiceBillsPlansDto invoiceBillsPlansDto){
        return invoiceBillsPlansServiceClient.getPage(page,invoiceBillsPlansDto);
    }
    /**
     * 根据主键 获取单条数据明细
     */
    public InvoiceBillsPlansDto getOne(Long id){
        InvoiceBillsPlansDto invoiceBillsPlansDto = invoiceBillsPlansServiceClient.queryObject(id);
        return invoiceBillsPlansDto;
    }
    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(InvoiceBillsPlansDto invoiceBillsPlansDto){

       return  invoiceBillsPlansServiceClient.save(invoiceBillsPlansDto);
    }
    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(InvoiceBillsPlansDto invoiceBillsPlansDto){

        return invoiceBillsPlansServiceClient.update(invoiceBillsPlansDto);
    }
    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids){
        return  invoiceBillsPlansServiceClient.deleteBatch(ids);
    }


    public Map<String, Object> selectMaterialPrice(Integer id) {
        return invoiceBillsPlansServiceClient.selectMaterialPrice(id);
    }

    public ExecuteResult<String> deleteMaterialPrice(Integer id) {
        return invoiceBillsPlansServiceClient.deleteMaterialPrice(id);
    }
}
