
package io.platform.moneyManagement.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.moneyManagement.dto.InvoiceBillsSharesDto;
import io.platform.moneyManagement.service.client.api.InvoiceBillsSharesServiceClient;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("invoiceBillsSharesServiceRemote")
public class InvoiceBillsSharesServiceRemote {

    @Reference(check = false)
    private InvoiceBillsSharesServiceClient invoiceBillsSharesServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<InvoiceBillsSharesDto> getList(Map<String, Object> params) {
        return invoiceBillsSharesServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page<InvoiceBillsSharesDto> getPage(Page<InvoiceBillsSharesDto> page, InvoiceBillsSharesDto invoiceBillsSharesDto) {
        return invoiceBillsSharesServiceClient.getPage(page, invoiceBillsSharesDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public InvoiceBillsSharesDto getOne(Long id) {
        InvoiceBillsSharesDto invoiceBillsSharesDto = invoiceBillsSharesServiceClient.queryObject(id);
        return invoiceBillsSharesDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(InvoiceBillsSharesDto invoiceBillsSharesDto) {

        return invoiceBillsSharesServiceClient.save(invoiceBillsSharesDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(InvoiceBillsSharesDto invoiceBillsSharesDto) {

        return invoiceBillsSharesServiceClient.update(invoiceBillsSharesDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return invoiceBillsSharesServiceClient.deleteBatch(ids);
    }


}
