
package io.platform.moneyManagement.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.base.common.utils.R;
import io.platform.moneyManagement.dto.PayCrBillsDto;
import io.platform.moneyManagement.service.client.api.PayCrBillsServiceClient;
import io.platform.project.dto.ProjectBillsSubsDto;
import io.platform.sys.dto.SysUserDto;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("payCrBillsServiceRemote")
public class PayCrBillsServiceRemote {

    @Reference(check = false)
    private PayCrBillsServiceClient payCrBillsServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<PayCrBillsDto> getList(Map<String, Object> params) {
        return payCrBillsServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Map<String, Object> getPage(Map<String, Object> map, SysUserDto sysUserDto) {
        return payCrBillsServiceClient.getPage(map, sysUserDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public PayCrBillsDto getOne(Long id) {
        PayCrBillsDto payCrBillsDto = payCrBillsServiceClient.queryObject(id);
        return payCrBillsDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(PayCrBillsDto payCrBillsDto) {

        return payCrBillsServiceClient.save(payCrBillsDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(PayCrBillsDto payCrBillsDto) {

        return payCrBillsServiceClient.update(payCrBillsDto);
    }

    /**
     * 删除付款记录-直接成本
     */
    public ExecuteResult<String> deleteDirectPayment(PayCrBillsDto payCrBillsDto) {
        return payCrBillsServiceClient.deleteDirectPayment(payCrBillsDto);
    }

    /**
     * 删除付款记录-间接成本
     */
    public ExecuteResult<String> deletePayCrBill(PayCrBillsDto payCrBillsDto) {
        return payCrBillsServiceClient.deletePayCrBill(payCrBillsDto);
    }

    /**
     * 暂存
     */
    public ExecuteResult<String> payCrTemporary(String projectForm, String payment, String supplier, String paymentSharing, SysUserDto sysUserDto) {
        return payCrBillsServiceClient.payCrTemporary(projectForm, payment, supplier, paymentSharing, sysUserDto);
    }

    /**
     * 查询暂存
     */
    public Map<String, Object> queryPayCrTemporary(PayCrBillsDto payCrBillsDto) {
        return payCrBillsServiceClient.queryPayCrTemporary(payCrBillsDto);
    }

    /**
     * 提交
     */
    public ExecuteResult<String> payCrSave(String projectForm, String payment, String supplier, String paymentSharing, SysUserDto sysUserDto) {
        return payCrBillsServiceClient.payCrSave(projectForm, payment, supplier, paymentSharing, sysUserDto);
    }

    public Map<String, Object> payCrSelect(ProjectBillsSubsDto projectBillsSubsDto) {
        return payCrBillsServiceClient.payCrSelect(projectBillsSubsDto);
    }

    /**
     * 模糊搜素收付款信息
     */
    public Map<String, Object> fuzzyQueryInvoice(Page page, PayCrBillsDto payCrBillsDto) {
        return payCrBillsServiceClient.fuzzyQueryInvoice(page, payCrBillsDto);
    }

    /**
     * 付款-直接成本-暂存
     */
    public ExecuteResult<String> directPaymentTemporary(String projectForm) {
        return payCrBillsServiceClient.directPaymentTemporary(projectForm);
    }

    /**
     * 付款-直接成本-提交
     */
    public ExecuteResult<String> directPaymentSave(String projectForm, SysUserDto sysUserDto) {
        return payCrBillsServiceClient.directPaymentSave(projectForm, sysUserDto);
    }

    /**
     * 查询该工程下预算项目
     */
    public Map<String, Object> queryBudgets(PayCrBillsDto payCrBillsDto) {
        return payCrBillsServiceClient.queryBudgets(payCrBillsDto);
    }

    /**
     * 确认付款
     */
    public ExecuteResult<String> editCrAffirmStatus(PayCrBillsDto payCrBillsDto, SysUserDto sysUserDto) {
        return payCrBillsServiceClient.editCrAffirmStatus(payCrBillsDto, sysUserDto);
    }

    /**
     * 驳回付款
     *
     * @param payCrBillsDto
     * @return
     */
    public ExecuteResult<String> refute(PayCrBillsDto payCrBillsDto, SysUserDto sysUserDto) {
        return payCrBillsServiceClient.refute(payCrBillsDto, sysUserDto);
    }

    public Map<String, Object> payCrIndirectPage(Map<String, Object> map, SysUserDto sysUserDto) {
        return payCrBillsServiceClient.payCrIndirectPage(map, sysUserDto);
    }

    public Map<String, Object> selectPayCrIndirectPrint(PayCrBillsDto payCrBillsDto, SysUserDto sysUserDto) {
        return payCrBillsServiceClient.selectPayCrIndirectPrint(payCrBillsDto, sysUserDto);
    }

    public ExecuteResult<String> turnDownStatus(PayCrBillsDto payCrBillsDto, SysUserDto sysUserDto) {
        return payCrBillsServiceClient.turnDownStatus(payCrBillsDto, sysUserDto);
    }

    public Map<String, Object> updatePayCr(Integer id) {
        return payCrBillsServiceClient.updatePayCr(id);
    }

    public String financialDismissal(Integer id, String affirmantRemarks, SysUserDto sysUserDto) {
        return payCrBillsServiceClient.financialDismissal(id, affirmantRemarks, sysUserDto);
    }

    public String financialSuccess(Integer id, String affirmantRemarks, SysUserDto sysUserDto) {
        return payCrBillsServiceClient.financialSuccess(id, affirmantRemarks, sysUserDto);
    }

    public boolean updatePayCrIndirectPrint(PayCrBillsDto payCrBillsDto) {
        return payCrBillsServiceClient.updatePayCrIndirectPrint(payCrBillsDto);
    }

    public Map<String, Object> selectFundpay(PayCrBillsDto payCrBillsDto, SysUserDto sysUserDto) {
        return payCrBillsServiceClient.selectFundpay(payCrBillsDto, sysUserDto);
    }

    public String cxFinancialSuccess(Integer id, String affirmantRemarks, SysUserDto sysUserDto) {
        return payCrBillsServiceClient.cxFinancialSuccess(id, affirmantRemarks, sysUserDto);
    }

    public ExecuteResult<String> revokePayment(PayCrBillsDto payCrBillsDto, SysUserDto sysUserDto) {
        return payCrBillsServiceClient.revokePayment(payCrBillsDto,sysUserDto);
    }
}
