
package io.platform.moneyManagement.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.moneyManagement.dto.PayCrBillsSharesDto;
import io.platform.moneyManagement.service.client.api.PayCrBillsSharesServiceClient;
import io.platform.sys.dto.SysUserDto;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("payCrBillsSharesServiceRemote")
public class PayCrBillsSharesServiceRemote {

    @Reference(check = false)
    private PayCrBillsSharesServiceClient payCrBillsSharesServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<PayCrBillsSharesDto> getList(Map<String, Object> params) {
        return payCrBillsSharesServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page<PayCrBillsSharesDto> getPage(Page<PayCrBillsSharesDto> page, PayCrBillsSharesDto payCrBillsSharesDto) {
        return payCrBillsSharesServiceClient.getPage(page, payCrBillsSharesDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public PayCrBillsSharesDto getOne(Long id) {
        PayCrBillsSharesDto payCrBillsSharesDto = payCrBillsSharesServiceClient.queryObject(id);
        return payCrBillsSharesDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(PayCrBillsSharesDto payCrBillsSharesDto) {

        return payCrBillsSharesServiceClient.save(payCrBillsSharesDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(PayCrBillsSharesDto payCrBillsSharesDto) {

        return payCrBillsSharesServiceClient.update(payCrBillsSharesDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return payCrBillsSharesServiceClient.deleteBatch(ids);
    }


    public Map<String, Object> selectPirce(String dto) {
        return payCrBillsSharesServiceClient.selectPirce(dto);
    }

    public Map<String, Object> selectProjectNc(String ncNo, String subNo, SysUserDto sysUserDto) {
        return payCrBillsSharesServiceClient.selectProjectNc(ncNo, subNo, sysUserDto);
    }

    public String saveMaterial(String zhu, String fapiao, String mingxi, SysUserDto sysUserDto) {
        return payCrBillsSharesServiceClient.saveMaterial(zhu, fapiao, mingxi, sysUserDto);
    }

    public Map<String, Object> selectPricePrint(Integer id) {
        return payCrBillsSharesServiceClient.selectPricePrint(id);
    }

    public Map<String, Object> selectPricePrint2(Integer id) {
        return payCrBillsSharesServiceClient.selectPricePrint2(id);
    }

    public Map<String, Object> selectDirectPaymentPrint(Integer id) {
        return payCrBillsSharesServiceClient.selectDirectPaymentPrint(id);
    }

    public Boolean updatePayCrPrint(Integer id) {
        return payCrBillsSharesServiceClient.updatePayCrPrint(id);
    }
}
