
package io.platform.moneyManagement.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.moneyManagement.dto.PayDrBillsItemsDto;
import io.platform.moneyManagement.service.client.api.PayDrBillsItemsServiceClient;
import io.platform.project.dto.ProjectbillsDto;
import io.platform.sys.dto.SysUserDto;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("payDrBillsItemsServiceRemote")
public class PayDrBillsItemsServiceRemote {

    @Reference(check = false)
    private PayDrBillsItemsServiceClient payDrBillsItemsServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<PayDrBillsItemsDto> getList(Map<String, Object> params) {
        return payDrBillsItemsServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page<PayDrBillsItemsDto> getPage(Page<PayDrBillsItemsDto> page, PayDrBillsItemsDto payDrBillsItemsDto) {
        return payDrBillsItemsServiceClient.getPage(page, payDrBillsItemsDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public PayDrBillsItemsDto getOne(Long id) {
        PayDrBillsItemsDto payDrBillsItemsDto = payDrBillsItemsServiceClient.queryObject(id);
        return payDrBillsItemsDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(PayDrBillsItemsDto payDrBillsItemsDto) {

        return payDrBillsItemsServiceClient.save(payDrBillsItemsDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(PayDrBillsItemsDto payDrBillsItemsDto) {

        return payDrBillsItemsServiceClient.update(payDrBillsItemsDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return payDrBillsItemsServiceClient.deleteBatch(ids);
    }


    public Map<String, Object> selectDirectCostPrice(String subNo, String ncNo, SysUserDto sysUserDto) {
        return payDrBillsItemsServiceClient.selectDirectCostPrice(subNo, ncNo, sysUserDto);
    }

    public String saveDirect(String zhu, String fapiao, String fujian, SysUserDto sysUserDto) {
        return payDrBillsItemsServiceClient.saveDirect(zhu, fapiao, fujian, sysUserDto);
    }

    public Map<String, Object> selectDirect(Integer id, SysUserDto sysUserDto) {
        return payDrBillsItemsServiceClient.selectDirect(id, sysUserDto);
    }

    public List<Map<String, Object>> selectPayDrData(SysUserDto sysUserDto) {
        return payDrBillsItemsServiceClient.selectPayDrData(sysUserDto);
    }

    public List<Map<String, Object>> selectPayDrDataCount(SysUserDto sysUserDto) {
        return payDrBillsItemsServiceClient.selectPayDrDataCount(sysUserDto);
    }

    public List<Map<String, Object>> selectPayDrTopData(String name, Integer typeId, SysUserDto sysUserDto) {
        return payDrBillsItemsServiceClient.selectPayDrTopData(name, typeId, sysUserDto);
    }

    public List<Map<String, Object>> selectPayDyAllAmt() {
        return payDrBillsItemsServiceClient.selectPayDyAllAmt();
    }

    public Map<String, Object> selectSubAmtCrAndDr(SysUserDto sysUserDto) {
        return payDrBillsItemsServiceClient.selectSubAmtCrAndDr(sysUserDto);
    }

    public List<Map<String, Object>> selectBranchSubProjectAmt(SysUserDto sysUserDto) {
        return payDrBillsItemsServiceClient.selectBranchSubProjectAmt(sysUserDto);
    }

    public List<Long> selectAllDrInterestRate(SysUserDto sysUserDto) {
        return payDrBillsItemsServiceClient.selectAllDrInterestRate(sysUserDto);
    }
}
