
package io.platform.moneyManagement.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.moneyManagement.dto.PayDrBillsDto;
import io.platform.moneyManagement.service.client.api.PayDrBillsServiceClient;
import io.platform.project.dto.ProjectBillsSubsDto;
import io.platform.sys.dto.SysUserDto;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("payDrBillsServiceRemote")
public class PayDrBillsServiceRemote {

    @Reference(check = false)
    private PayDrBillsServiceClient payDrBillsServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<PayDrBillsDto> getList(Map<String, Object> params) {
        return payDrBillsServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Map<String, Object> getPage(Map<String, Object> map,SysUserDto sysUserDto) {
        return payDrBillsServiceClient.getPage(map,sysUserDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public PayDrBillsDto getOne(Long id) {
        PayDrBillsDto payDrBillsDto = payDrBillsServiceClient.queryObject(id);
        return payDrBillsDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(PayDrBillsDto payDrBillsDto) {

        return payDrBillsServiceClient.save(payDrBillsDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(PayDrBillsDto payDrBillsDto) {

        return payDrBillsServiceClient.update(payDrBillsDto);
    }

    /**
     * 删除收款记录
     * @param payDrBillsDto
     */
    public ExecuteResult<String> deletePayDr(PayDrBillsDto payDrBillsDto) {
        return payDrBillsServiceClient.deletePayDr(payDrBillsDto);
    }

    /**
     * 收款发票信息查询
     *
     * @param projectBillsSubsDto
     */
    public Map<String, Object> changeFuzzyQueryPayDr(ProjectBillsSubsDto projectBillsSubsDto) {
        return payDrBillsServiceClient.changeFuzzyQueryPayDr(projectBillsSubsDto);
    }

    /**
     * 暂存
     */
    public ExecuteResult<String> payDrTemporary(String payDr, String payDrItems, SysUserDto sysUserDto) {
        return payDrBillsServiceClient.payDrTemporary(payDr, payDrItems, sysUserDto);
    }

    /**
     * 查询暂存数据
     */
    public Map<String, Object> queryPayTemporary(PayDrBillsDto payDrBillsDto) {
        return payDrBillsServiceClient.queryPayTemporary(payDrBillsDto);
    }

    /**
     * 提交
     */
    public ExecuteResult<String> payDrSave(String payDr, String payDrItems, SysUserDto sysUserDto) {
        return payDrBillsServiceClient.payDrSave(payDr, payDrItems, sysUserDto);
    }

    /**
     * 财务确认
     */
    public ExecuteResult<String> editAffirmStatus(PayDrBillsDto payDrBillsDto, SysUserDto sysUserDto) {
        return payDrBillsServiceClient.editAffirmStatus(payDrBillsDto, sysUserDto);
    }

    public Map<String,Object> selectAll(Page<PayDrBillsDto> page, PayDrBillsDto payDrBillsDto,SysUserDto sysUserDto) {
        return payDrBillsServiceClient.selectAll(page,payDrBillsDto,sysUserDto);
    }

    public Map<String, Object> selectPrintInformation(PayDrBillsDto payDrBillsDto, SysUserDto sysUserDto) {
        return payDrBillsServiceClient.selectPrintInformation(payDrBillsDto, sysUserDto);
    }

    public ExecuteResult<String> updatePayCrIndirectPrint(PayDrBillsDto payDrBillsDto) {
        return payDrBillsServiceClient.updatePayCrIndirectPrint(payDrBillsDto, payDrBillsDto);
    }
}
