
package io.platform.progressConfiguration.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.progressConfiguration.dto.ProjectNodeNexusDto;
import io.platform.progressConfiguration.service.client.api.ProjectNodeNexusServiceClient;
import io.platform.sys.dto.SysUserDto;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("projectNodeNexusServiceRemote")
public class ProjectNodeNexusServiceRemote {

    @Reference(check = false)
    private ProjectNodeNexusServiceClient projectNodeNexusServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<ProjectNodeNexusDto> getList(Map<String, Object> params) {
        return projectNodeNexusServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page getPage(Page<ProjectNodeNexusDto> page, ProjectNodeNexusDto projectNodeNexusDto, SysUserDto sysUserDto) {
        return projectNodeNexusServiceClient.getPage(page, projectNodeNexusDto, sysUserDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public ProjectNodeNexusDto getOne(Long id) {
        ProjectNodeNexusDto projectNodeNexusDto = projectNodeNexusServiceClient.queryObject(id);
        return projectNodeNexusDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(ProjectNodeNexusDto projectNodeNexusDto) {

        return projectNodeNexusServiceClient.save(projectNodeNexusDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(ProjectNodeNexusDto projectNodeNexusDto) {

        return projectNodeNexusServiceClient.update(projectNodeNexusDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return projectNodeNexusServiceClient.deleteBatch(ids);
    }


    public Map<String, Object> queryProNodeNexus(SysUserDto sysUserDto) {
        return projectNodeNexusServiceClient.queryProNodeNexus(sysUserDto);
    }

    public ExecuteResult<String> saveProNodeNexus(String form, String items, SysUserDto sysUserDto) {
        return projectNodeNexusServiceClient.saveProNodeNexus(form, items, sysUserDto);
    }

    public Map<String, Object> queryProNodeNexusTemporary(ProjectNodeNexusDto projectNodeNexusDto, SysUserDto sysUserDto) {
        return projectNodeNexusServiceClient.queryProNodeNexusTemporary(projectNodeNexusDto, sysUserDto);
    }
}
