
package io.platform.project.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.project.dto.AttachFilesDto;
import io.platform.project.service.client.api.AttachFilesServiceClient;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("attachFilesServiceRemote")
public class AttachFilesServiceRemote {

    @Reference(check = false)
    private AttachFilesServiceClient attachFilesServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<AttachFilesDto> getList(Map<String, Object> params) {
        return attachFilesServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page<AttachFilesDto> getPage(Page<AttachFilesDto> page, AttachFilesDto attachFilesDto) {
        return attachFilesServiceClient.getPage(page, attachFilesDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public AttachFilesDto getOne(Long id) {
        AttachFilesDto attachFilesDto = attachFilesServiceClient.queryObject(id);
        return attachFilesDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(AttachFilesDto attachFilesDto) {

        return attachFilesServiceClient.save(attachFilesDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(AttachFilesDto attachFilesDto) {

        return attachFilesServiceClient.update(attachFilesDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return attachFilesServiceClient.deleteBatch(ids);
    }


}
