
package io.platform.project.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.project.dto.DictionariesDto;
import io.platform.project.service.client.api.DictionariesServiceClient;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("dictionariesServiceRemote")
public class DictionariesServiceRemote {

    @Reference(check = false)
    private DictionariesServiceClient dictionariesServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<DictionariesDto> getList(Map<String, Object> params) {
        return dictionariesServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page<DictionariesDto> getPage(Page<DictionariesDto> page, DictionariesDto dictionariesDto) {
        return dictionariesServiceClient.getPage(page, dictionariesDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public DictionariesDto getOne(Long id) {
        DictionariesDto dictionariesDto = dictionariesServiceClient.queryObject(id);
        return dictionariesDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(DictionariesDto dictionariesDto) {

        return dictionariesServiceClient.save(dictionariesDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(DictionariesDto dictionariesDto) {

        return dictionariesServiceClient.update(dictionariesDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return dictionariesServiceClient.deleteBatch(ids);
    }


}
