
package io.platform.project.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.project.dto.ProcessBillsDto;
import io.platform.project.dto.ProjectBillsSubsDto;
import io.platform.project.service.client.api.ProcessBillsServiceClient;
import io.platform.sys.dto.SysUserDto;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.RequestBody;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("processBillsServiceRemote")
public class ProcessBillsServiceRemote {

    @Reference(check = false)
    private ProcessBillsServiceClient processBillsServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<ProcessBillsDto> getList(Map<String, Object> params) {
        return processBillsServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Map<String, Object> getPage(@RequestBody Map<String, Object> map) {
        return processBillsServiceClient.getPage(map);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public ProcessBillsDto getOne(Long id) {
        ProcessBillsDto processBillsDto = processBillsServiceClient.queryObject(id);
        return processBillsDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(ProcessBillsDto processBillsDto) {

        return processBillsServiceClient.save(processBillsDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(ProcessBillsDto processBillsDto) {

        return processBillsServiceClient.update(processBillsDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return processBillsServiceClient.deleteBatch(ids);
    }

    /**
     * 查询项目进度
     *
     * @param processBillsDto
     */
    public Map<String, Object> changeFuzzyQueryProjectSub(ProjectBillsSubsDto processBillsDto) {
        return processBillsServiceClient.changeFuzzyQueryProjectSub(processBillsDto);
    }

    /**
     * 暂存
     */
    public ExecuteResult<String> processTemporary(String process, String processSteps, SysUserDto sysUserDto) {
        return processBillsServiceClient.processTemporary(process, processSteps, sysUserDto);
    }

    /**
     * 查询暂存
     */
    public Map<String, Object> queryDataTemporary(ProcessBillsDto processBillsDto) {
        return processBillsServiceClient.queryDataTemporary(processBillsDto);
    }

    /**
     * 提交
     */
    public ExecuteResult<String> processSave(String process, String processSteps, SysUserDto sysUserDto) {
        return processBillsServiceClient.processSave(process, processSteps, sysUserDto);
    }

    /**
     * 模糊查询 维护记录
     */
    public Map<String, Object> fuzzyQueryProcess(Page pageDto, ProcessBillsDto processBillsDto) {
        return processBillsServiceClient.fuzzyQueryProcess(pageDto, processBillsDto);
    }

    /**
     * 查询开工申报表
     */
    public String queryProjectStartAttach(ProjectBillsSubsDto projectBillsSubsDto) {
        return processBillsServiceClient.queryProjectStartAttach(projectBillsSubsDto);
    }

    /**
     * 查询项目维护进度
     */
    public Map<String, Object> queryProcessValue(Integer id, SysUserDto sysUserDto) {
        return processBillsServiceClient.queryProcessValue(id, sysUserDto);
    }

    public Map<String, Object> selectProjectProcessData(Integer id) {
        return processBillsServiceClient.selectProjectProcessData(id);
    }
}
