
package io.platform.project.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.project.dto.ProcessBillsStepsDto;
import io.platform.project.service.client.api.ProcessBillsStepsServiceClient;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("processBillsStepsServiceRemote")
public class ProcessBillsStepsServiceRemote {

    @Reference(check = false)
    private ProcessBillsStepsServiceClient processBillsStepsServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<ProcessBillsStepsDto> getList(Map<String, Object> params) {
        return processBillsStepsServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page<ProcessBillsStepsDto> getPage(Page<ProcessBillsStepsDto> page, ProcessBillsStepsDto processBillsStepsDto) {
        return processBillsStepsServiceClient.getPage(page, processBillsStepsDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public ProcessBillsStepsDto getOne(Long id) {
        ProcessBillsStepsDto processBillsStepsDto = processBillsStepsServiceClient.queryObject(id);
        return processBillsStepsDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(ProcessBillsStepsDto processBillsStepsDto) {

        return processBillsStepsServiceClient.save(processBillsStepsDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(ProcessBillsStepsDto processBillsStepsDto) {

        return processBillsStepsServiceClient.update(processBillsStepsDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return processBillsStepsServiceClient.deleteBatch(ids);
    }


}
