
package io.platform.project.web.remote;
import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.project.dto.ProjectBillsHistoryDto;
import io.platform.project.service.client.api.ProjectBillsHistoryServiceClient;
import org.springframework.stereotype.Service;
import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("projectBillsHistoryServiceRemote")
public class ProjectBillsHistoryServiceRemote {

    @Reference(check = false)
    private ProjectBillsHistoryServiceClient projectBillsHistoryServiceClient;
    /**
     * 根据参数获取列表  无分页
     */
    public List<ProjectBillsHistoryDto> getList(Map<String, Object> params){
        return projectBillsHistoryServiceClient.queryList(params);
    }
    /**
     * 根据参数进行 分页查询
     */
    public Page<ProjectBillsHistoryDto> getPage(Page<ProjectBillsHistoryDto> page,ProjectBillsHistoryDto projectBillsHistoryDto){
        return projectBillsHistoryServiceClient.getPage(page,projectBillsHistoryDto);
    }
    /**
     * 根据主键 获取单条数据明细
     */
    public ProjectBillsHistoryDto getOne(Long id){
        ProjectBillsHistoryDto projectBillsHistoryDto = projectBillsHistoryServiceClient.queryObject(id);
        return projectBillsHistoryDto;
    }
    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(ProjectBillsHistoryDto projectBillsHistoryDto){

       return  projectBillsHistoryServiceClient.save(projectBillsHistoryDto);
    }
    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(ProjectBillsHistoryDto projectBillsHistoryDto){

        return projectBillsHistoryServiceClient.update(projectBillsHistoryDto);
    }
    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids){
        return  projectBillsHistoryServiceClient.deleteBatch(ids);
    }



}
