
package io.platform.project.web.remote;

import com.alibaba.dubbo.config.annotation.Reference;
import com.baomidou.mybatisplus.plugins.Page;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.project.dto.ProjectBillsStepsAdjustDto;
import io.platform.project.service.client.api.ProjectBillsStepsAdjustServiceClient;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("projectBillsStepsAdjustServiceRemote")
public class ProjectBillsStepsAdjustServiceRemote {

    @Reference(check = false)
    private ProjectBillsStepsAdjustServiceClient projectBillsStepsAdjustServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<ProjectBillsStepsAdjustDto> getList(Map<String, Object> params) {
        return projectBillsStepsAdjustServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page<ProjectBillsStepsAdjustDto> getPage(Page<ProjectBillsStepsAdjustDto> page, ProjectBillsStepsAdjustDto projectBillsStepsAdjustDto) {
        return projectBillsStepsAdjustServiceClient.getPage(page, projectBillsStepsAdjustDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public ProjectBillsStepsAdjustDto getOne(Long id) {
        ProjectBillsStepsAdjustDto projectBillsStepsAdjustDto = projectBillsStepsAdjustServiceClient.queryObject(id);
        return projectBillsStepsAdjustDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(ProjectBillsStepsAdjustDto projectBillsStepsAdjustDto) {

        return projectBillsStepsAdjustServiceClient.save(projectBillsStepsAdjustDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(ProjectBillsStepsAdjustDto projectBillsStepsAdjustDto) {

        return projectBillsStepsAdjustServiceClient.update(projectBillsStepsAdjustDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return projectBillsStepsAdjustServiceClient.deleteBatch(ids);
    }

    /**
     * 模糊查询
     *
     * @param projectBillsStepsAdjustDto
     * @return
     */
    public Map<String, Object> fuzzyQueryProjectAdjust(Page page, ProjectBillsStepsAdjustDto projectBillsStepsAdjustDto) {
        return projectBillsStepsAdjustServiceClient.fuzzyQueryProjectAdjust(page, projectBillsStepsAdjustDto);
    }

    public Map<String, Object> selectSubCount() {
        return projectBillsStepsAdjustServiceClient.selectSubCount();
    }
}
