
package io.platform.project.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.project.dto.ProjectBillsStepsAdjustDto;
import io.platform.project.dto.ProjectBillsStepsDto;
import io.platform.project.dto.ProjectBillsSubsDto;
import io.platform.project.dto.ProjectbillsDto;
import io.platform.project.service.client.api.ProjectBillsStepsServiceClient;
import io.platform.sys.dto.SysUserDto;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("projectBillsStepsServiceRemote")
public class ProjectBillsStepsServiceRemote {

    @Reference(check = false)
    private ProjectBillsStepsServiceClient projectBillsStepsServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<ProjectBillsStepsDto> getList(Map<String, Object> params) {
        return projectBillsStepsServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page<ProjectBillsStepsDto> getPage(Page<ProjectBillsStepsDto> page, ProjectBillsStepsDto projectBillsStepsDto) {
        return projectBillsStepsServiceClient.getPage(page, projectBillsStepsDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public ProjectBillsStepsDto getOne(Long id) {
        ProjectBillsStepsDto projectBillsStepsDto = projectBillsStepsServiceClient.queryObject(id);
        return projectBillsStepsDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(String projectBillsContract, String projectBillsStls) {
        return projectBillsStepsServiceClient.save(projectBillsContract, projectBillsStls);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(String projectBillsContract, String projectBillsStls) {
        return projectBillsStepsServiceClient.update(projectBillsContract, projectBillsStls);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return projectBillsStepsServiceClient.deleteBatch(ids);
    }

    /**
     * 根据单号查询
     *
     * @param projectbillsDto
     * @param sysUserDto
     * @return
     */
    public Map<String, Object> numberQueryContract(ProjectBillsSubsDto projectbillsDto, SysUserDto sysUserDto) {
        return projectBillsStepsServiceClient.numberQueryContract(projectbillsDto, sysUserDto);
    }

    /**
     * 暂存
     *
     * @param projectBillsContract
     * @param sysUserDto
     */
    public ExecuteResult<String> projectStepTemporary(String projectBillsContract, String projectBillsStls, SysUserDto sysUserDto) {
        return projectBillsStepsServiceClient.projectStepTemporary(projectBillsContract, projectBillsStls, sysUserDto);
    }

    /**
     * 提交
     */
    public ExecuteResult<String> projectStepSave(String projectBillsContract, String projectBillsStls, SysUserDto sysUserDto) {
        return projectBillsStepsServiceClient.projectStepSave(projectBillsContract, projectBillsStls, sysUserDto);
    }

    /**
     * 编辑提交
     */
    public ExecuteResult<String> editMilestoneSave(List<ProjectBillsStepsAdjustDto> projectBillsStepsAdjustDtos, SysUserDto sysUserDto) {
        return projectBillsStepsServiceClient.editMilestoneSave(projectBillsStepsAdjustDtos, sysUserDto);
    }

    /**
     * 查询修改记录
     */
    public Map<String, Object> queryRecords(ProjectBillsStepsAdjustDto projectBillsStepsAdjustDto) {
        return projectBillsStepsServiceClient.queryRecords(projectBillsStepsAdjustDto);
    }

    public String processStepsSave(String item, SysUserDto sysUserDto) {
        return projectBillsStepsServiceClient.processStepsSave(item, sysUserDto);
    }

    public Page<ProjectBillsSubsDto> selectProjectSubDataList(Page<ProjectBillsSubsDto> page,ProjectBillsSubsDto projectBillsSubsDto,SysUserDto sysUserDto) {
        return projectBillsStepsServiceClient.selectProjectSubDataList(page,projectBillsSubsDto,sysUserDto);
    }
}
