
package io.platform.project.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.budget.dto.ProjectBillsBudgetsDto;
import io.platform.project.service.client.api.ProjectBillsSubsServiceClient;
import io.platform.project.dto.ProjectBillsSubsDto;
import io.platform.sys.dto.SysUserDto;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("projectBillsSubsServiceRemote")
public class ProjectBillsSubsServiceRemote {

    @Reference(check = false)
    private ProjectBillsSubsServiceClient projectBillsSubsServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<ProjectBillsSubsDto> getList(Map<String, Object> params) {
        return projectBillsSubsServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Map<String, Object> getPage(Map<String, Object> map, SysUserDto sysUserDto) {
        return projectBillsSubsServiceClient.getPage(map, sysUserDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public ProjectBillsSubsDto getOne(Long id) {
        ProjectBillsSubsDto projectBillsSubsDto = projectBillsSubsServiceClient.queryObject(id);
        return projectBillsSubsDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(ProjectBillsSubsDto projectBillsSubsDto) {

        return projectBillsSubsServiceClient.save(projectBillsSubsDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(ProjectBillsSubsDto projectBillsSubsDto) {

        return projectBillsSubsServiceClient.update(projectBillsSubsDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return projectBillsSubsServiceClient.deleteBatch(ids);
    }

    /**
     * 暂存
     */
    public ExecuteResult<String> projectSubTemporary(List<ProjectBillsSubsDto> projectBillsSubsDto) {
        return projectBillsSubsServiceClient.projectSubTemporary(projectBillsSubsDto);
    }

    /**
     * 模糊查询
     *
     * @param projectBillsSubsDto
     * @return
     */
    public Map<String, Object> fuzzyQueryProjectSubs(Page page, ProjectBillsSubsDto projectBillsSubsDto) {
        return projectBillsSubsServiceClient.fuzzyQueryProjectSubs(page, projectBillsSubsDto);
    }

    /**
     * 条件查询
     */
    public Map<String, Object> conditionalQueryProjectSubs(Page page, ProjectBillsSubsDto projectBillsSubsDto) {
        return projectBillsSubsServiceClient.conditionalQueryProjectSubs(page, projectBillsSubsDto);
    }

    /**
     * 查询总包结算过子项目
     */
    public Map<String, Object> querySettlementProjectSubs(Page page, ProjectBillsSubsDto projectBillsSubsDto) {
        return projectBillsSubsServiceClient.querySettlementProjectSubs(page, projectBillsSubsDto);
    }

    public Map<String, Object> queryProjectSummaryData(ProjectBillsSubsDto projectBillsSubsDto) {
        return projectBillsSubsServiceClient.queryProjectSummaryData(projectBillsSubsDto);
    }

    public Map<String, Object> getProSummaryPage(Map<String, Object> map, SysUserDto sysUserDto) {
        return projectBillsSubsServiceClient.getProSummaryPage(map, sysUserDto);
    }

    public Page<ProjectBillsSubsDto> purchaseSubPage(Page<ProjectBillsSubsDto> page, ProjectBillsSubsDto projectBillsSubsDto, SysUserDto sysUserDto) {
        return projectBillsSubsServiceClient.purchaseSubPage(page, projectBillsSubsDto, sysUserDto);
    }

    public Map<String, Object> projectBalancePage(Map<String, Object> params, SysUserDto sysUserDto) {
        return projectBillsSubsServiceClient.projectBalancePage(params, sysUserDto);
    }

    public Map<String, Object> queryPayInvoiceVal(Page page, ProjectBillsBudgetsDto projectBillsBudgetsDto,SysUserDto sysUserDto) {
        return projectBillsSubsServiceClient.queryPayInvoiceVal(page, projectBillsBudgetsDto,sysUserDto);
    }

    public Map<String, Object> getEngineeringPage(Page page, ProjectBillsSubsDto projectBillsSubsDto, SysUserDto sysUserDto) {
        return projectBillsSubsServiceClient.getEngineeringPage(page, projectBillsSubsDto, sysUserDto);
    }

    public List<Map<String, Object>> engineeringExportExcel(ProjectBillsSubsDto projectBillsSubsDto) {
        return projectBillsSubsServiceClient.engineeringExportExcel(projectBillsSubsDto);
    }

    public Page<ProjectBillsSubsDto> selectSubPage(Page<ProjectBillsSubsDto> page, ProjectBillsSubsDto projectBillsSubsDto, SysUserDto sysUserDto) {
        return projectBillsSubsServiceClient.selectSubPage(page, projectBillsSubsDto, sysUserDto);
    }

    public Map<String, Object> queryProjectBillsSubs(ProjectBillsSubsDto projectBillsSubsDto) {
        return projectBillsSubsServiceClient.queryProjectBillsSubs(projectBillsSubsDto);
    }

    public Map<String, Object> moneySettlementPage(Map<String, Object> params, SysUserDto sysUserDto) {
        return projectBillsSubsServiceClient.moneySettlementPage(params, sysUserDto);
    }

    public Map<String, Object> queryClosingVal(Integer integer, SysUserDto sysUserDto) {
        return projectBillsSubsServiceClient.queryClosingVal(integer, sysUserDto);
    }

    public List<Map<String, Object>> subsistingExportExcel(ProjectBillsSubsDto projectBillsSubsDto, SysUserDto sysUserDto) {
        return projectBillsSubsServiceClient.subsistingExportExcel(projectBillsSubsDto, sysUserDto);
    }
}
