
package io.platform.project.web.remote;

import com.alibaba.dubbo.config.annotation.Reference;
import com.baomidou.mybatisplus.plugins.Page;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.budget.dto.ProjectBillsBudgetsDto;
import io.platform.approvalConfiguration.dto.AuditItemsDto;
import io.platform.moneyManagement.dto.InvoiceBillsDto;
import io.platform.project.dto.ProjectBS;
import io.platform.project.dto.ProjectBillsSubsDto;
import io.platform.project.service.client.api.ProjectbillsServiceClient;
import io.platform.project.dto.ProjectbillsDto;
import io.platform.sys.dto.SysUserDto;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("projectbillsServiceRemote")
public class ProjectbillsServiceRemote {

    @Reference(check = false)
    private ProjectbillsServiceClient projectbillsServiceClient;

    /**
     * 根据参数进行 分页查询
     */
    public Map<String, Object> getPage(Map<String, Object> map, SysUserDto sysUserDto) {
        return projectbillsServiceClient.getPage(map, sysUserDto);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Map<String, Object> tkPage(Map<String, Object> map, SysUserDto sysUserDto) {
        return projectbillsServiceClient.tkPage(map, sysUserDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public ProjectbillsDto getOne(Long id) {
        ProjectbillsDto projectbillsDto = projectbillsServiceClient.queryObject(id);
        return projectbillsDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(String projectBillsContract, String projectBillsStls, SysUserDto sysUserDto) {
        return projectbillsServiceClient.save(projectBillsContract, projectBillsStls, sysUserDto);
    }

    /**
     * 暂存 数据
     */
    public ExecuteResult<String> temporary(String projectBillsContract, String projectBillsStls, String attachs, SysUserDto sysUserDto) {
        return projectbillsServiceClient.temporary(projectBillsContract, projectBillsStls, attachs, sysUserDto);
    }

    /**
     * 暂存 数据
     */
    public ExecuteResult<String> projectBillsTemporary(String project, String proSubs, SysUserDto sysUserDto) {
        return projectbillsServiceClient.projectBillsTemporary(project, proSubs, sysUserDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(String projectBillsContract, String projectBillsStls, SysUserDto sysUserDto) {
        return projectbillsServiceClient.update(projectBillsContract, projectBillsStls, sysUserDto);
    }

    /**
     * 立项提交
     */
    public ExecuteResult<String> projectBillsUpdate(String project, String proSubs, SysUserDto sysUserDto) {
        return projectbillsServiceClient.projectBillsUpdate(project, proSubs, sysUserDto);
    }

    /**
     * 删除总包合同
     *
     * @param projectbillsDto
     */
    public ExecuteResult<String> deleteContract(ProjectbillsDto projectbillsDto) {
        return projectbillsServiceClient.deleteContract(projectbillsDto);
    }

    /**
     * 查询开工信息
     */
    public Map<String, Object> pageStart(Map<String, Object> map, SysUserDto sysUserDto) {
        return projectbillsServiceClient.pageStart(map, sysUserDto);
    }

    /**
     * 查询开工信息
     */
    public Map<String, Object> queryProStartDateInformation(ProjectbillsDto projectbillsDto) {
        return projectbillsServiceClient.queryProStartDateInformation(projectbillsDto);
    }

    /**
     * 提交开工日期
     */
    public ExecuteResult<String> projectStartUpdate(ProjectbillsDto projectbillsDto, SysUserDto sysUserDto) {
        return projectbillsServiceClient.projectStartUpdate(projectbillsDto, sysUserDto);
    }

    /**
     * 查询总包结算
     */
    public Map<String, Object> queryTurnkeySettlement(ProjectbillsDto projectbillsDto) {
        return projectbillsServiceClient.queryTurnkeySettlement(projectbillsDto);
    }

    /**
     * 总包结算记账
     */
    public ExecuteResult<String> turnkeySettlementSave(String projectbill, String projectSubs, String projectAttachs, SysUserDto sysUserDto) {
        return projectbillsServiceClient.turnkeySettlementSave(projectbill, projectSubs, projectAttachs, sysUserDto);
    }

    /**
     * 提交
     */
    public ExecuteResult<String> contractSave(String projectBillsContract, String projectBillsStls, String attachs, SysUserDto sysUserDto) {
        return projectbillsServiceClient.contractSave(projectBillsContract, projectBillsStls, attachs, sysUserDto);
    }

    /**
     * 查询立项信息
     */
    public Map<String, Object> queryProjectBills(ProjectbillsDto projectbillsDto) {
        return projectbillsServiceClient.queryProjectBills(projectbillsDto);
    }

    /**
     * 查询项目结项信息
     */
    public List<ProjectBillsBudgetsDto> queryProjectBalance(ProjectbillsDto projectbillsDto) {
        return projectbillsServiceClient.queryProjectBalance(projectbillsDto);
    }

    /**
     * 提交结项信息
     */
    public ExecuteResult<String> projectBalanceSave(ProjectBS projectBS, SysUserDto sysUserDto,String billsBudgets) {
        return projectbillsServiceClient.projectBalanceSave(projectBS, sysUserDto, billsBudgets);
    }

    /**
     * 查询立项信息提醒
     */
    public Map<String, Object> queryProjectWarning() {
        return projectbillsServiceClient.queryProjectWarning();
    }

    /**
     * 查询总包暂存数据
     */
    public Map<String, Object> queryContractTemporary(ProjectbillsDto projectbillsDto) {
        return projectbillsServiceClient.queryContractTemporary(projectbillsDto);
    }

    public ExecuteResult<String> survivingProjectsTemporary(String projectBills, String projects, String costSituation, String projectBudgets, SysUserDto sysUserDto) {
        return projectbillsServiceClient.survivingProjectsTemporary(projectBills, projects, costSituation, projectBudgets, sysUserDto);
    }

    public ExecuteResult<String> survivingProjectsSave(String projectBills, String projects, String costSituation, String projectBudgets, SysUserDto sysUserDto) {
        return projectbillsServiceClient.survivingProjectsSave(projectBills, projects, costSituation, projectBudgets, sysUserDto);
    }

    public ExecuteResult<String> survivingProjectsModifyCommit(String projectBills, String projects, String costSituation, String projectBudgets,
                                                               String backupData, SysUserDto sysUserDto) {
        return projectbillsServiceClient.survivingProjectsModifyCommit(projectBills, projects, costSituation, projectBudgets, backupData, sysUserDto);
    }

    /**
     * 查询续存信息
     */
    public Map<String, Object> getPageSurvivingPro(Map<String, Object> map) {
        return projectbillsServiceClient.getPageSurvivingPro(map);
    }

    /**
     * 查询续存项目暂存信息
     */
    public Map<String, Object> querySurvivingProTemporary(ProjectbillsDto projectbillsDto) {
        return projectbillsServiceClient.querySurvivingProTemporary(projectbillsDto);
    }

    public Map<String, Object> getRenewPage(Map<String, Object> map, SysUserDto sysUserDto) {
        return projectbillsServiceClient.getRenewPage(map, sysUserDto);
    }

    public Map<String, Object> proBalanceVal(ProjectBillsSubsDto projectBillsSubsDto) {
        return projectbillsServiceClient.proBalanceVal(projectBillsSubsDto);
    }

    public Map<String, Object> queryProjectSumPayCr(ProjectbillsDto projectbillsDto) {
        return projectbillsServiceClient.queryProjectSumPayCr(projectbillsDto);
    }

    public Map<String, Object> settlementPage(Map<String, Object> map, SysUserDto sysUserDto) {
        return projectbillsServiceClient.settlementPage(map, sysUserDto);
    }

    public ExecuteResult<String> completionReminderRead(ProjectbillsDto projectbillsDto) {
        return projectbillsServiceClient.completionReminderRead(projectbillsDto);
    }

    public Map<String, Object> queryPending(Map<String, Object> maps, SysUserDto sysUserDto) {
        return projectbillsServiceClient.queryPending(maps, sysUserDto);
    }

    public Map<String, Object> queryPendingProjectId(AuditItemsDto auditItemsDto) {
        return projectbillsServiceClient.queryPendingProjectId(auditItemsDto);
    }

    public Map<String, Object> projectEndQueryPendingVal(ProjectbillsDto projectbillsDto) {
        return projectbillsServiceClient.projectEndQueryPendingVal(projectbillsDto);
    }

    public ExecuteResult<String> approved(AuditItemsDto auditItemsDto, SysUserDto sysUserDto) {
        return projectbillsServiceClient.approved(auditItemsDto, sysUserDto);
    }

    public ExecuteResult<String> approvalRejected(AuditItemsDto auditItemsDto, SysUserDto sysUserDto) {
        return projectbillsServiceClient.approvalRejected(auditItemsDto, sysUserDto);
    }

    public Map<String, Object> getHomeProList(Map<String, Object> map, SysUserDto sysUserDto) {
        return projectbillsServiceClient.getHomeProList(map, sysUserDto);
    }

    public Page selectAllWarningsCurrent(Page pageDto, ProjectbillsDto projectbillsDto, SysUserDto sysUserDto) {
        return projectbillsServiceClient.selectAllWarningsCurrent(pageDto, projectbillsDto, sysUserDto);
    }

    public Page selectWarningMatters(Page page, ProjectbillsDto projectbillsDto, SysUserDto sysUserDto) {
        return projectbillsServiceClient.selectWarningMatters(page, projectbillsDto, sysUserDto);
    }

    public ExecuteResult<String> projectSettlerSave(ProjectBS projectBS, SysUserDto sysUserDto) {
        return projectbillsServiceClient.projectSettlerSave(projectBS, sysUserDto);
    }

    public Map<String, Object> queryTurnkeyExistingBillVal(Integer id) {
        return projectbillsServiceClient.queryTurnkeyExistingBillVal(id);
    }

    public ExecuteResult<String> updateBilling(String from, String list, String edit, SysUserDto sysUserDto) {
        return projectbillsServiceClient.updateBilling(from, list, edit, sysUserDto);
    }
    public String getSerialNum(String Str){
        return projectbillsServiceClient.getserialNum(Str);
    }
    public ExecuteResult<String> withdrawalApproval(ProjectBillsSubsDto projectBillsSubsDto) {
        return projectbillsServiceClient.withdrawalApproval(projectBillsSubsDto);
    }

    public Double selectSumPurchaseInvCr(InvoiceBillsDto invoiceBillsDto, SysUserDto sysUserDto) {
        return projectbillsServiceClient.selectSumPurchaseInvCr(invoiceBillsDto, sysUserDto);
    }

    public ExecuteResult<String> contractAdminSave(String projectBillsContract, String projectBillsStls, String attachs, SysUserDto sysUserDto) {
        return projectbillsServiceClient.contractAdminSave(projectBillsContract, projectBillsStls, attachs, sysUserDto);
    }
}
