
package io.platform.project.web.remote;
import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.project.dto.SubConBillsAttachsDto;
import io.platform.project.service.client.api.SubConBillsAttachsServiceClient;
import org.springframework.stereotype.Service;
import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("subConBillsAttachsServiceRemote")
public class SubConBillsAttachsServiceRemote {

    @Reference(check = false)
    private SubConBillsAttachsServiceClient subConBillsAttachsServiceClient;
    /**
     * 根据参数获取列表  无分页
     */
    public List<SubConBillsAttachsDto> getList(Map<String, Object> params){
        return subConBillsAttachsServiceClient.queryList(params);
    }
    /**
     * 根据参数进行 分页查询
     */
    public Page<SubConBillsAttachsDto> getPage(Page<SubConBillsAttachsDto> page,SubConBillsAttachsDto subConBillsAttachsDto){
        return subConBillsAttachsServiceClient.getPage(page,subConBillsAttachsDto);
    }
    /**
     * 根据主键 获取单条数据明细
     */
    public SubConBillsAttachsDto getOne(Long id){
        SubConBillsAttachsDto subConBillsAttachsDto = subConBillsAttachsServiceClient.queryObject(id);
        return subConBillsAttachsDto;
    }
    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(SubConBillsAttachsDto subConBillsAttachsDto){

       return  subConBillsAttachsServiceClient.save(subConBillsAttachsDto);
    }
    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(SubConBillsAttachsDto subConBillsAttachsDto){

        return subConBillsAttachsServiceClient.update(subConBillsAttachsDto);
    }
    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids){
        return  subConBillsAttachsServiceClient.deleteBatch(ids);
    }



}
