
package io.platform.project.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.project.dto.ProjectBillsSubsDto;
import io.platform.project.dto.SubContractBillsDto;
import io.platform.project.service.client.api.SubContractBillsServiceClient;
import io.platform.sys.dto.SysUserDto;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("subContractBillsServiceRemote")
public class SubContractBillsServiceRemote {

    @Reference(check = false)
    private SubContractBillsServiceClient subContractBillsServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<SubContractBillsDto> getList(Map<String, Object> params) {
        return subContractBillsServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page<SubContractBillsDto> getPage(Page<SubContractBillsDto> page, SubContractBillsDto subContractBillsDto,SysUserDto sysUserDto) {
        return subContractBillsServiceClient.getPage(page, subContractBillsDto,sysUserDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public SubContractBillsDto getOne(Long id) {
        SubContractBillsDto subContractBillsDto = subContractBillsServiceClient.queryObject(id);
        return subContractBillsDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(SubContractBillsDto subContractBillsDto) {

        return subContractBillsServiceClient.save(subContractBillsDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(SubContractBillsDto subContractBillsDto) {

        return subContractBillsServiceClient.update(subContractBillsDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return subContractBillsServiceClient.deleteBatch(ids);
    }


    public Map<String, Object> selectAll(ProjectBillsSubsDto projectBillsSubsDto) {
        return subContractBillsServiceClient.selectAll(projectBillsSubsDto);
    }

    /**
     * 分包合同暂存
     */
    public ExecuteResult<String> subContractTemporary(String from,String item, String list, SysUserDto sysUserDto) {
        return subContractBillsServiceClient.subContractTemporary(from, item, list, sysUserDto);
    }

    /**
     * 分包合同提交
     */
    public ExecuteResult<String> subContractSave(String from,String item, String list, SysUserDto sysUserDto) {
        return subContractBillsServiceClient.subContractSave(from, item ,list, sysUserDto);
    }

    /**
     * 查询分包记录信息
     */
    public Map<String, Object> querySubContractTemporary(SubContractBillsDto subContractBillsDto) {
        return subContractBillsServiceClient.querySubContractTemporary(subContractBillsDto);
    }

    /**
     * 分包结算查询
     */
    public Map<String, Object> fuzzyQuerySubContracts(Page page, SubContractBillsDto subContractBillsDto) {
        return subContractBillsServiceClient.fuzzyQuerySubContracts(page, subContractBillsDto);
    }

    public Map<String, Object> enineeringPage(Page page, SubContractBillsDto subContractBillsDto) {
        return subContractBillsServiceClient.enineeringPage(page, subContractBillsDto);
    }

    public Map<String, Object> selectFormData(Integer id,String subNo,SysUserDto sysUserDto) {
        return subContractBillsServiceClient.selectFormData(id,subNo,sysUserDto);
    }

    public String saveSubContract(String list, String subNo, SysUserDto sysUserDto) {
        return subContractBillsServiceClient.saveSubContract(list,subNo, sysUserDto);
    }

    public double getPrepayments(Integer id) {
        return subContractBillsServiceClient.getPrepayments(id);
    }

    public ExecuteResult<String> selectPaymentInformation(SubContractBillsDto subContractBillsDto) {
        return subContractBillsServiceClient.selectPaymentInformation(subContractBillsDto);
    }
}
