
package io.platform.projectSettlement.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.projectSettlement.dto.ProjectBillsAttachsDto;
import io.platform.projectSettlement.service.client.api.ProjectBillsAttachsServiceClient;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("projectBillsAttachsServiceRemote")
public class ProjectBillsAttachsServiceRemote {

    @Reference(check = false)
    private ProjectBillsAttachsServiceClient projectBillsAttachsServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<ProjectBillsAttachsDto> getList(Map<String, Object> params) {
        return projectBillsAttachsServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page<ProjectBillsAttachsDto> getPage(Page<ProjectBillsAttachsDto> page, ProjectBillsAttachsDto projectBillsAttachsDto) {
        return projectBillsAttachsServiceClient.getPage(page, projectBillsAttachsDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public ProjectBillsAttachsDto getOne(Long id) {
        ProjectBillsAttachsDto projectBillsAttachsDto = projectBillsAttachsServiceClient.queryObject(id);
        return projectBillsAttachsDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(ProjectBillsAttachsDto projectBillsAttachsDto) {

        return projectBillsAttachsServiceClient.save(projectBillsAttachsDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(ProjectBillsAttachsDto projectBillsAttachsDto) {

        return projectBillsAttachsServiceClient.update(projectBillsAttachsDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return projectBillsAttachsServiceClient.deleteBatch(ids);
    }


}
