
package io.platform.projectSettlement.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.projectSettlement.dto.ProjectStlBillsItemsDto;
import io.platform.projectSettlement.service.client.api.ProjectStlBillsItemsServiceClient;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("projectStlBillsItemsServiceRemote")
public class ProjectStlBillsItemsServiceRemote {

    @Reference(check = false)
    private ProjectStlBillsItemsServiceClient projectStlBillsItemsServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<ProjectStlBillsItemsDto> getList(Map<String, Object> params) {
        return projectStlBillsItemsServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page<ProjectStlBillsItemsDto> getPage(Page<ProjectStlBillsItemsDto> page, ProjectStlBillsItemsDto projectStlBillsItemsDto) {
        return projectStlBillsItemsServiceClient.getPage(page, projectStlBillsItemsDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public ProjectStlBillsItemsDto getOne(Long id) {
        ProjectStlBillsItemsDto projectStlBillsItemsDto = projectStlBillsItemsServiceClient.queryObject(id);
        return projectStlBillsItemsDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(ProjectStlBillsItemsDto projectStlBillsItemsDto) {

        return projectStlBillsItemsServiceClient.save(projectStlBillsItemsDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(ProjectStlBillsItemsDto projectStlBillsItemsDto) {

        return projectStlBillsItemsServiceClient.update(projectStlBillsItemsDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return projectStlBillsItemsServiceClient.deleteBatch(ids);
    }


}
