
package io.platform.projectSettlement.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.project.dto.ProjectBillsSubsDto;
import io.platform.project.dto.SubContractBillsDto;
import io.platform.projectSettlement.dto.ProjectStlBillsDto;
import io.platform.projectSettlement.service.client.api.ProjectStlBillsServiceClient;
import io.platform.sys.dto.SysUserDto;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("projectStlBillsServiceRemote")
public class ProjectStlBillsServiceRemote {

    @Reference(check = false)
    private ProjectStlBillsServiceClient projectStlBillsServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<ProjectStlBillsDto> getList(Map<String, Object> params) {
        return projectStlBillsServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Map<String, Object> proStlBillsPage(Map<String, Object> map) {
        return projectStlBillsServiceClient.proStlBillsPage(map);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public ProjectStlBillsDto getOne(Long id) {
        ProjectStlBillsDto projectStlBillsDto = projectStlBillsServiceClient.queryObject(id);
        return projectStlBillsDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(ProjectStlBillsDto projectStlBillsDto) {

        return projectStlBillsServiceClient.save(projectStlBillsDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(ProjectStlBillsDto projectStlBillsDto) {

        return projectStlBillsServiceClient.update(projectStlBillsDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return projectStlBillsServiceClient.deleteBatch(ids);
    }

    /**
     * 提交
     */
    public ExecuteResult<String> projectStlSave(String projectStlBill, String projectStls, String dataAttachs, SysUserDto sysUserDto) {
        return projectStlBillsServiceClient.projectStlSave(projectStlBill, projectStls, dataAttachs, sysUserDto);
    }

    /**
     * 查询 分包结算 信息
     * @param projectBillsSubsDto
     */
    public Map<String, Object> querySubContract(ProjectBillsSubsDto projectBillsSubsDto) {
        return projectStlBillsServiceClient.querySubContract(projectBillsSubsDto);
    }

    /**
     * 查询暂存数据
     */
    public Map<String, Object> fuzzyQueryPSTl(ProjectStlBillsDto projectStlBillsDto) {
        return projectStlBillsServiceClient.fuzzyQueryPSTl(projectStlBillsDto);
    }
}
