
package io.platform.purchase.web.remote;
import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.base.common.utils.R;
import io.platform.engineering.dto.BpurchasesDto;
import io.platform.project.dto.ProjectBillsSubsDto;
import io.platform.purchase.dto.PurchaseBillsDto;
import io.platform.purchase.dto.PurchaseBillsItemsDto;
import io.platform.purchase.service.client.api.PurchaseBillsItemsServiceClient;
import io.platform.sys.dto.SysUserDto;
import org.springframework.stereotype.Service;
import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("purchaseBillsItemsServiceRemote")
public class PurchaseBillsItemsServiceRemote {

    @Reference(check = false)
    private PurchaseBillsItemsServiceClient purchaseBillsItemsServiceClient;
    /**
     * 根据参数获取列表  无分页
     */
    public List<PurchaseBillsItemsDto> getList(Map<String, Object> params){
        return purchaseBillsItemsServiceClient.queryList(params);
    }
    /**
     * 根据参数进行 分页查询
     */
    public Page<PurchaseBillsItemsDto> getPage(Page<PurchaseBillsItemsDto> page,PurchaseBillsItemsDto purchaseBillsItemsDto){
        return purchaseBillsItemsServiceClient.getPage(page,purchaseBillsItemsDto);
    }
    /**
     * 根据主键 获取单条数据明细
     */
    public PurchaseBillsItemsDto getOne(Long id){
        PurchaseBillsItemsDto purchaseBillsItemsDto = purchaseBillsItemsServiceClient.queryObject(id);
        return purchaseBillsItemsDto;
    }
    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(PurchaseBillsItemsDto purchaseBillsItemsDto){

       return  purchaseBillsItemsServiceClient.save(purchaseBillsItemsDto);
    }
    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(PurchaseBillsItemsDto purchaseBillsItemsDto){

        return purchaseBillsItemsServiceClient.update(purchaseBillsItemsDto);
    }
    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids){
        return  purchaseBillsItemsServiceClient.deleteBatch(ids);
    }


    public ExecuteResult<String> deleteItem(PurchaseBillsItemsDto purchaseBillsItemsDto) {
        return purchaseBillsItemsServiceClient.deleteItem(purchaseBillsItemsDto);
    }

    public Map<String,Object> maintenancePage(Page<PurchaseBillsItemsDto> page,PurchaseBillsItemsDto purchaseBillsItemsDto,String list) {
        return purchaseBillsItemsServiceClient.maintenancePage(page,purchaseBillsItemsDto,list);
    }

    public List<PurchaseBillsItemsDto> selectArrivalSum(List<PurchaseBillsItemsDto> list) {
        return purchaseBillsItemsServiceClient.selectArrivalSum(list);
    }

    public Map<String,Object> selectProjectResult(String sub) {
        return purchaseBillsItemsServiceClient.selectProjectResult(sub);
    }

    public  Page<PurchaseBillsDto> selectList(Page<PurchaseBillsDto> page, PurchaseBillsDto purchaseBillsDto,SysUserDto sysUserDto) {
        return purchaseBillsItemsServiceClient.selectList(page,purchaseBillsDto,sysUserDto);
    }

    public Map<String, Object> selectSrcType(String mingxi) {
        return purchaseBillsItemsServiceClient.selectSrcType(mingxi);
    }

    public ExecuteResult<String> saveResultItem(String mingxi, SysUserDto sysUserDto) {
        return purchaseBillsItemsServiceClient.saveResultItem(mingxi,sysUserDto);
    }

    public Page<BpurchasesDto> selectResultPurchase(ProjectBillsSubsDto projectBillsSubsDto, Page<BpurchasesDto> page, SysUserDto sysUserDto) {
        return purchaseBillsItemsServiceClient.selectResultPurchase(page,projectBillsSubsDto, sysUserDto);
    }
}
