
package io.platform.purchase.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.purchase.dto.PurchaseBillsDto;
import io.platform.purchase.dto.PurchaseBillsProjsDto;
import io.platform.purchase.dto.PurchaseBillsPuridsDto;
import io.platform.purchase.service.client.api.PurchaseBillsProjsServiceClient;
import io.platform.sys.dto.SysUserDto;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("purchaseBillsProjsServiceRemote")
public class PurchaseBillsProjsServiceRemote {

    @Reference(check = false)
    private PurchaseBillsProjsServiceClient purchaseBillsProjsServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<PurchaseBillsProjsDto> getList(Map<String, Object> params) {
        return purchaseBillsProjsServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Map<String, Object> getPage(Page<PurchaseBillsProjsDto> page, PurchaseBillsProjsDto purchaseBillsProjsDto, SysUserDto sysUserDto) {
        return purchaseBillsProjsServiceClient.getPage(page, purchaseBillsProjsDto, sysUserDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public PurchaseBillsProjsDto getOne(Long id) {
        PurchaseBillsProjsDto purchaseBillsProjsDto = purchaseBillsProjsServiceClient.queryObject(id);
        return purchaseBillsProjsDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(PurchaseBillsProjsDto purchaseBillsProjsDto) {

        return purchaseBillsProjsServiceClient.save(purchaseBillsProjsDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(PurchaseBillsProjsDto purchaseBillsProjsDto) {

        return purchaseBillsProjsServiceClient.update(purchaseBillsProjsDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        return purchaseBillsProjsServiceClient.deleteBatch(ids);
    }

    public String saveWork(String from, String list, String supper, SysUserDto sysUserDto) {
        return purchaseBillsProjsServiceClient.saveWork(from, list, supper, sysUserDto);
    }

    public String updateWork(String from, String list, String supper) {
        return purchaseBillsProjsServiceClient.updateWork(from, list, supper);

    }

    /**
     * 模糊查询分包计划明细
     */
    public Map<String, Object> fuzzyQueryPurProjs(Page page, PurchaseBillsProjsDto purchaseBillsProjsDto) {
        return purchaseBillsProjsServiceClient.fuzzyQueryPurProjs(page, purchaseBillsProjsDto);
    }

    /**
     * 选择分包计划明细查询
     */
    public Map<String, Object> changeFuzzyQueryPurProjs(PurchaseBillsProjsDto purchaseBillsProjsDto) {
        return purchaseBillsProjsServiceClient.changeFuzzyQueryPurProjs(purchaseBillsProjsDto);
    }

    public Map<String, Object> selectItem(String billNo) {
        return purchaseBillsProjsServiceClient.selectItem(billNo);
    }

    public Map<String, Object> editItem(String id) {
        return purchaseBillsProjsServiceClient.editItem(id);
    }

    public String saveProItem(String purchaseBillsDto) {
        return purchaseBillsProjsServiceClient.saveProItem(purchaseBillsDto);
    }

    public String adminSaveProItem(String purchaseBillsDto) {
        return purchaseBillsProjsServiceClient.adminSaveProItem(purchaseBillsDto);
    }

    public Map<String, Object> selectProItem(String id) {
        return purchaseBillsProjsServiceClient.selectProItem(id);
    }

    public void deleteSupplier(Integer id) {
        purchaseBillsProjsServiceClient.deleteSupplier(id);
    }

    public Map<String, Object> selectProItemPurids(Integer id) {
        return purchaseBillsProjsServiceClient.selectProItemPurids(id);
    }

    public String savePurchasePro(String from, String list, SysUserDto sysUserDto) {
        return purchaseBillsProjsServiceClient.savePurchasePro(from, list, sysUserDto);
    }

    public String updatePurchasePro(String from, String list) {
        return purchaseBillsProjsServiceClient.updatePurchasePro(from, list);
    }
}
