
package io.platform.purchase.web.remote;
import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.purchase.dto.PurchaseBillsPuridsDto;
import io.platform.purchase.service.client.api.PurchaseBillsPuridsServiceClient;
import org.springframework.stereotype.Service;
import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("purchaseBillsPuridsServiceRemote")
public class PurchaseBillsPuridsServiceRemote {

    @Reference(check = false)
    private PurchaseBillsPuridsServiceClient purchaseBillsPuridsServiceClient;
    /**
     * 根据参数获取列表  无分页
     */
    public List<PurchaseBillsPuridsDto> getList(Map<String, Object> params){
        return purchaseBillsPuridsServiceClient.queryList(params);
    }
    /**
     * 根据参数进行 分页查询
     */
    public Page<PurchaseBillsPuridsDto> getPage(Page<PurchaseBillsPuridsDto> page,PurchaseBillsPuridsDto purchaseBillsPuridsDto){
        return purchaseBillsPuridsServiceClient.getPage(page,purchaseBillsPuridsDto);
    }
    /**
     * 根据主键 获取单条数据明细
     */
    public PurchaseBillsPuridsDto getOne(Long id){
        PurchaseBillsPuridsDto purchaseBillsPuridsDto = purchaseBillsPuridsServiceClient.queryObject(id);
        return purchaseBillsPuridsDto;
    }
    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(PurchaseBillsPuridsDto purchaseBillsPuridsDto){

       return  purchaseBillsPuridsServiceClient.save(purchaseBillsPuridsDto);
    }
    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(PurchaseBillsPuridsDto purchaseBillsPuridsDto){

        return purchaseBillsPuridsServiceClient.update(purchaseBillsPuridsDto);
    }
    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids){
        return  purchaseBillsPuridsServiceClient.deleteBatch(ids);
    }


    public Map<String, Object> getSupplierPage(Page<PurchaseBillsPuridsDto> page, PurchaseBillsPuridsDto purchaseBillsPuridsDto) {
    return purchaseBillsPuridsServiceClient.getSupplierPage(page,purchaseBillsPuridsDto);
    }
}
