
package io.platform.purchase.web.remote;

import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.project.dto.ProjectBillsSubsDto;
import io.platform.purchase.dto.PurchaseBillsDto;
import io.platform.purchase.dto.PurchaseBillsItemsDto;
import io.platform.purchase.service.client.api.PurchaseBillsServiceClient;
import io.platform.sys.dto.SysUserDto;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("purchaseBillsServiceRemote")
public class PurchaseBillsServiceRemote {

    @Reference(check = false)
    private PurchaseBillsServiceClient purchaseBillsServiceClient;

    /**
     * 根据参数获取列表  无分页
     */
    public List<PurchaseBillsDto> getList(Map<String, Object> params) {
        return purchaseBillsServiceClient.queryList(params);
    }

    /**
     * 根据参数进行 分页查询
     */
    public Page<PurchaseBillsDto> getPage(Page<PurchaseBillsDto> page, PurchaseBillsDto purchaseBillsDto) {
        return purchaseBillsServiceClient.getPage(page, purchaseBillsDto);
    }

    /**
     * 根据主键 获取单条数据明细
     */
    public PurchaseBillsDto getOne(Long id) {
        PurchaseBillsDto purchaseBillsDto = purchaseBillsServiceClient.queryObject(id);
        return purchaseBillsDto;
    }

    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(PurchaseBillsDto purchaseBillsDto) {

        return purchaseBillsServiceClient.save(purchaseBillsDto);
    }

    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(PurchaseBillsDto purchaseBillsDto) {

        return purchaseBillsServiceClient.update(purchaseBillsDto);
    }

    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(PurchaseBillsDto purchaseBillsDto) {
        return purchaseBillsServiceClient.deleteBatch(purchaseBillsDto);
    }


    public String materialDemand(String purchaseBillsDto, String list, SysUserDto sysUserDto) {
        return purchaseBillsServiceClient.materialDemand(purchaseBillsDto, list, sysUserDto);
    }

    public String zancun(String purchaseBillsDto, String billsItemsDtos) {
        return purchaseBillsServiceClient.zancun(purchaseBillsDto, billsItemsDtos);
    }

    public String voer(String from, String list) {
        return purchaseBillsServiceClient.over(from, list);
    }

    public Map<String, Object> getItem(String billNo, SysUserDto sysUserDto) {
        return purchaseBillsServiceClient.getItem(billNo, sysUserDto);
    }

    public String saveOne(String from, String list, SysUserDto sysUserDto, String attach) {
        return purchaseBillsServiceClient.saveOne(from, list, sysUserDto, attach);
    }

    public String saveTwo(String from, String list, String supplierList, SysUserDto sysUserDto, String attach) {
        return purchaseBillsServiceClient.saveTwo(from, list, supplierList, sysUserDto, attach);
    }

    public Map<String, Object> onceAgain(Integer id) {
        return purchaseBillsServiceClient.onceAgain(id);
    }

    public String temporaryOne(String from, String list, SysUserDto sysUserDto, String attach) {
        return purchaseBillsServiceClient.temporaryOne(from, list, sysUserDto, attach);
    }

    public String temporaryTwo(String from, String list, String supplierList, String attach, SysUserDto sysUserDto) {
        return purchaseBillsServiceClient.temporaryTwo(from, list, supplierList, attach, sysUserDto);
    }

    public Map<String, Object> getResultItem(String billNo, String zbNo) {
        return purchaseBillsServiceClient.getResultItem(billNo, zbNo);
    }

    public Map<String, Object> selectPurchaseTypes() {
        return purchaseBillsServiceClient.selectPurchaseTypes();
    }

    public ExecuteResult<String> deleteTender(PurchaseBillsDto purchaseBillsDto, SysUserDto sysUserDto) {
        return purchaseBillsServiceClient.deleteTender(purchaseBillsDto, sysUserDto);
    }

    public ExecuteResult<String> deleteFrame(PurchaseBillsDto purchaseBillsDto, SysUserDto sysUserDto) {
        return purchaseBillsServiceClient.deleteFrame(purchaseBillsDto, sysUserDto);
    }

    public String upLedger(String from, String list) {
        return purchaseBillsServiceClient.upLedger(from, list);
    }

    public Map<String, Object> selectContractor(SysUserDto sysUserDto) {
        return purchaseBillsServiceClient.selectContractor(sysUserDto);
    }

    public String saveSingle(String from, String list, SysUserDto sysUserDto, String attach) {
        return purchaseBillsServiceClient.saveSingle(from, list, sysUserDto, attach);
    }

    public ExecuteResult<String> deletePurchase(PurchaseBillsDto purchaseBillsDto) {
        return purchaseBillsServiceClient.deletePurchase(purchaseBillsDto);
    }
}
