
package io.platform.tasklistsHistory.remote;
import com.baomidou.mybatisplus.plugins.Page;
import com.alibaba.dubbo.config.annotation.Reference;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.base.common.utils.PageUtils;
import io.platform.base.common.utils.Query;
import io.platform.tasklistsHistory.dto.TasklistsHistoryDto;
import io.platform.tasklistsHistory.service.client.api.TasklistsHistoryServiceClient;
import org.springframework.stereotype.Service;
import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/8/31.
 */
@Service("tasklistsHistoryServiceRemote")
public class TasklistsHistoryServiceRemote {

    @Reference(check = false)
    private TasklistsHistoryServiceClient tasklistsHistoryServiceClient;
    /**
     * 根据参数获取列表  无分页
     */
    public List<TasklistsHistoryDto> getList(Map<String, Object> params){
        return tasklistsHistoryServiceClient.queryList(params);
    }
    /**
     * 根据参数进行 分页查询
     */
    public Page<TasklistsHistoryDto> getPage(Page<TasklistsHistoryDto> page,TasklistsHistoryDto tasklistsHistoryDto){
        return tasklistsHistoryServiceClient.getPage(page,tasklistsHistoryDto);
    }
    /**
     * 根据主键 获取单条数据明细
     */
    public TasklistsHistoryDto getOne(Long id){
        TasklistsHistoryDto tasklistsHistoryDto = tasklistsHistoryServiceClient.queryObject(id);
        return tasklistsHistoryDto;
    }
    /**
     * 保存 数据
     */
    public ExecuteResult<String> save(TasklistsHistoryDto tasklistsHistoryDto){

       return  tasklistsHistoryServiceClient.save(tasklistsHistoryDto);
    }
    /**
     * 修改单条数据
     */
    public ExecuteResult<String> update(TasklistsHistoryDto tasklistsHistoryDto){

        return tasklistsHistoryServiceClient.update(tasklistsHistoryDto);
    }
    /**
     * 批量删除
     */
    public ExecuteResult<String> deleteBatch(List<Long> ids){
        return  tasklistsHistoryServiceClient.deleteBatch(ids);
    }



}
