
package io.platform.approvalConfiguration.service.client.api;

import com.baomidou.mybatisplus.plugins.Page;

import java.util.List;
import java.util.Map;

import io.platform.approvalConfiguration.dto.AuditPathsActsDto;
import io.platform.approvalConfiguration.dto.AuditPathsDto;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.sys.dto.SysUserDto;

/**
 * Created by sevelli on 2017/8/31.
 */
public interface AuditPathsServiceClient {
    /**
     * 根据ID 查询单个对象
     */
    AuditPathsDto queryObject(Long id);

    /**
     * 根据参数查询 列表  无分页
     */
    List<AuditPathsDto> queryList(Map<String, Object> map);

    /**
     * 根据参数查询 对应参数的 集合大小
     */
    int queryTotal(Map<String, Object> map);

    /**
     * 保存对象
     */
    ExecuteResult<String> save(String auditPathsDto, String auditPathsLevelsDto, SysUserDto sysUserDto);

    /**
     * 更新对象
     */
    ExecuteResult<String> update(AuditPathsDto auditPathsDto);

    /**
     * 根据主键 删除对象
     */
    ExecuteResult<String> delete(Long id);

    /**
     * 根据分页参数 获取 分页集合
     */
    Page getPage(Page page, AuditPathsDto auditPathsDto, SysUserDto sysUserDto);

    Map<String, Object> queryAuditPath(AuditPathsDto auditPathsDto, SysUserDto sysUserDto);

    ExecuteResult<String> deleteAuditPaths(Integer ids);

    Map<String, Object> selectAuditPathAct(Page page,AuditPathsActsDto auditPathsActsDto);

    ExecuteResult<String> saveAuditPathAct(String auditPathsActsDtoList, SysUserDto sysUserDto);

    Map<String, Object> selectApprovedEvents(SysUserDto sysUserDto);
}
