
package io.platform.budget.service.client.api;

import com.baomidou.mybatisplus.plugins.Page;

import java.util.List;
import java.util.Map;

import io.platform.base.common.utils.ExecuteResult;
import io.platform.budget.dto.ProjectBillsAdjustsDto;
import io.platform.project.dto.ProjectBillsSubsDto;
import io.platform.sys.dto.SysUserDto;

/**
 * Created by sevelli on 2017/8/31.
 */
public interface ProjectBillsAdjustsServiceClient {
    /**
     * 根据ID 查询单个对象
     */
    ProjectBillsAdjustsDto queryObject(Long id);

    /**
     * 根据参数查询 列表  无分页
     */
    List<ProjectBillsAdjustsDto> queryList(Map<String, Object> map);

    /**
     * 根据参数查询 对应参数的 集合大小
     */
    int queryTotal(Map<String, Object> map);

    /**
     * 保存对象
     */
    ExecuteResult<String> save(ProjectBillsAdjustsDto projectBillsAdjustsDto);

    /**
     * 更新对象
     */
    ExecuteResult<String> update(ProjectBillsAdjustsDto projectBillsAdjustsDto);

    /**
     * 根据主键 删除对象
     */
    ExecuteResult<String> delete(Long id);

    /**
     * 删除预算
     */
    ExecuteResult<String> deleteProjectAdjusts(ProjectBillsAdjustsDto projectBillsAdjustsDto);

    /**
     * 根据分页参数 获取 分页集合
     */
    Map<String, Object> getPage(Map<String, Object> map,SysUserDto sysUserDto);

    /**
     * 调整预算模糊查询
     *
     * @param projectBillsSubsDto
     * @return
     */
    Map<String, Object> fuzzyQueryProjectAdjust(ProjectBillsSubsDto projectBillsSubsDto);

    Map<String, Object> changeFuzzyQueryProjectAdjust(ProjectBillsSubsDto projectBillsSubsDto);

    /**
     * 提交
     */
    ExecuteResult<String> saveProjectAdjusts(String projectBillsSubs, String projectBillsAdjustsDto, SysUserDto sysUserDto);

    /**
     * 暂存
     */
    ExecuteResult<String> projectAdjustsTemporary(String projectBillsSubs, String projectBillsAdjustsDto, SysUserDto sysUserDto);

    /**
     * 查询暂存操作信息
     *
     * @param projectBillsAdjustsDto
     * @return
     */
    Map<String, Object> queryTemporaryInformation(ProjectBillsAdjustsDto projectBillsAdjustsDto);

    /**
     * 查询子工程预算信息
     */
    Map<String, Object> queryProSubBudgetTemporary(ProjectBillsSubsDto projectBillsSubsDto);

    Map<String, Object> queryProSubBudget(ProjectBillsSubsDto projectBillsSubsDto);
}
