
package io.platform.budget.service.client.api;

import com.baomidou.mybatisplus.plugins.Page;
import io.platform.budget.dto.ProjectBillsBudgetsDto;

import java.util.List;
import java.util.Map;

import io.platform.base.common.utils.ExecuteResult;
import io.platform.project.dto.ProjectBillsSubsDto;
import io.platform.project.dto.ProjectbillsDto;
import io.platform.project.dto.SubContractBillsDto;
import io.platform.sys.dto.SysUserDto;

/**
 * Created by sevelli on 2017/8/31.
 */
public interface ProjectBillsBudgetsServiceClient {
    /**
     * 根据ID 查询单个对象
     */
    ProjectBillsBudgetsDto queryObject(Long id);

    /**
     * 根据参数查询 列表  无分页
     */
    List<ProjectBillsBudgetsDto> queryList(Map<String, Object> map);

    /**
     * 根据参数查询 对应参数的 集合大小
     */
    int queryTotal(Map<String, Object> map);

    /**
     * 保存对象
     */
    ExecuteResult<String> save(ProjectBillsBudgetsDto projectBillsBudgetsDto);

    /**
     * 更新对象
     */
    ExecuteResult<String> update(ProjectBillsBudgetsDto projectBillsBudgetsDto);

    /**
     * 根据主键 删除对象
     */
    ExecuteResult<String> delete(Long id);

    /**
     * 根据主键集合 批量删除
     */
    ExecuteResult<String> deleteProjectBudget(ProjectBillsSubsDto projectBillsSubsDto);

    /**
     * 根据分页参数 获取 分页集合
     */
    Page<ProjectBillsBudgetsDto> getPage(Page<ProjectBillsBudgetsDto> page, ProjectBillsBudgetsDto projectBillsBudgetsDto);

    /**
     * 根据单号查询
     *
     * @param id
     * @return
     */
    Map<String, Object> budgetsQueryContract(Integer id);

    /**
     * 暂存
     */
    ExecuteResult<String> projectBudgetTemporary(String projectBillsSubs, String projectBudget, SysUserDto sysUserDto);

    /**
     * 提交
     */
    ExecuteResult<String> projectBudgetSave(String projectBillsSubs, String projectBudget, SysUserDto sysUserDto);

    /**
     * 编辑提交
     */
    ExecuteResult<String> editBudgetSave(List<ProjectBillsBudgetsDto> projectBillsBudgetsDto);

    Map<String, Object> selectBillsBudget(ProjectBillsBudgetsDto projectBillsBudgetsDto);
}
