
package io.platform.contract.service.client.api;

import com.baomidou.mybatisplus.plugins.Page;
import io.platform.contract.dto.OtherProjectDto;

import java.util.List;
import java.util.Map;

import io.platform.base.common.utils.ExecuteResult;
import io.platform.moneyManagement.dto.InvoiceBillsDto;
import io.platform.sys.dto.SysUserDto;

/**
 * Created by sevelli on 2017/8/31.
 */
public interface OtherProjectServiceClient {
    /**
     * 根据ID 查询单个对象
     */
    OtherProjectDto queryObject(Long id);

    /**
     * 根据参数查询 列表  无分页
     */
    List<OtherProjectDto> queryList(Map<String, Object> map);

    /**
     * 根据参数查询 对应参数的 集合大小
     */
    int queryTotal(Map<String, Object> map);

    /**
     * 保存对象
     */
    ExecuteResult<String> save(OtherProjectDto otherProjectDto);

    /**
     * 更新对象
     */
    ExecuteResult<String> update(OtherProjectDto otherProjectDto);

    /**
     * 根据主键 删除对象
     */
    ExecuteResult<String> delete(Long id);

    /**
     * 根据主键集合 批量删除
     */
    ExecuteResult<String> deleteBatch(List<Long> idList);

    /**
     * 根据分页参数 获取 分页集合
     */
    Map<String, Object> getPage(Map<String, Object> map,SysUserDto sysUserDto);

    /**
     * 暂存
     */
    ExecuteResult<String> otherProTemporary(OtherProjectDto otherProjectDto, SysUserDto sysUserDto);

    /**
     * 提交
     */
    ExecuteResult<String> otherProSave(OtherProjectDto otherProjectDto, SysUserDto sysUserDto);

    /**
     * 查询暂存信息
     */
    Map<String, Object> queryOtherProTemporary(OtherProjectDto otherProjectDto);

    Map<String, Object> queryOtherProPurchaseNcNo(OtherProjectDto otherProjectDto, SysUserDto sysUserDto);

    Map<String, Object> purchaseNcPage(Page page, InvoiceBillsDto otherProjectDto,SysUserDto sysUserDto);
}
