
package io.platform.contract.service.client.api;

import com.baomidou.mybatisplus.plugins.Page;
import io.platform.contract.dto.ProjectBillsStlPlansDto;

import java.util.List;
import java.util.Map;

import io.platform.base.common.utils.ExecuteResult;

/**
 * Created by sevelli on 2017/8/31.
 */
public interface ProjectBillsStlPlansServiceClient {
    /**
     * 根据ID 查询单个对象
     */
    ProjectBillsStlPlansDto queryObject(Long id);

    /**
     * 根据参数查询 列表  无分页
     */
    List<ProjectBillsStlPlansDto> queryList(Map<String, Object> map);

    /**
     * 根据参数查询 对应参数的 集合大小
     */
    int queryTotal(Map<String, Object> map);

    /**
     * 保存对象
     */
    ExecuteResult<String> save(ProjectBillsStlPlansDto projectBillsStlPlansDto);

    /**
     * 更新对象
     */
    ExecuteResult<String> update(ProjectBillsStlPlansDto projectBillsStlPlansDto);

    /**
     * 根据主键 删除对象
     */
    ExecuteResult<String> delete(Long id);

    /**
     * 根据主键集合 批量删除
     */
    ExecuteResult<String> deleteBatch(List<Long> idList);

    /**
     * 根据分页参数 获取 分页集合
     */
    Page<ProjectBillsStlPlansDto> getPage(Page<ProjectBillsStlPlansDto> page, ProjectBillsStlPlansDto projectBillsStlPlansDto);

    /**
     * 查询结算明细
     *
     * @param projectBillsStlPlansDto
     * @return
     */
    Map<String, Object> queryProStls(ProjectBillsStlPlansDto projectBillsStlPlansDto);
}
