
package io.platform.engineering.service.client.api;

import com.baomidou.mybatisplus.plugins.Page;
import io.platform.engineering.dto.BbranchsDto;

import java.util.List;
import java.util.Map;

import io.platform.base.common.utils.ExecuteResult;
import io.platform.sys.dto.SysUserDto;

/**
 * Created by sevelli on 2017/8/31.
 */
public interface BbranchsServiceClient {
    /**
     * 根据ID 查询单个对象
     */
    BbranchsDto queryObject(Long id);

    /**
     * 根据参数查询 列表  无分页F
     */
    List<BbranchsDto> queryList(Map<String, Object> map);

    /**
     * 根据参数查询 对应参数的 集合大小
     */
    int queryTotal(Map<String, Object> map);

    /**
     * 保存对象
     */
    ExecuteResult<String> branchSave(BbranchsDto bbranchsDto, SysUserDto sysUserDto);

    /**
     * 更新对象
     */
    ExecuteResult<String> update(BbranchsDto bbranchsDto);

    /**
     * 根据主键 删除对象
     */
    ExecuteResult<String> delete(Long id);

    /**
     * 根据主键集合 批量删除
     */
    ExecuteResult<String> deleteBatch(List<Long> idList);

    /**
     * 根据分页参数 获取 分页集合
     */
    Page<BbranchsDto> getPage(Page<BbranchsDto> page, BbranchsDto bbranchsDto);

    /**
     * 模糊查询
     *
     * @param bbranchsDto
     * @return
     */
    Map<String, Object> fuzzyQueryBranch(Page page, BbranchsDto bbranchsDto);

    /**
     * 查询所有
     */
    Map<String, Object> selectbranchs(BbranchsDto bbranchsDto, SysUserDto sysUserDto);
    /**
     * 查询所有
     */
    String selectbranchsTree();

    Map<String, Object> homeGetBranchs(SysUserDto sysUserDto);
}
