
package io.platform.engineering.service.client.api;

import com.baomidou.mybatisplus.plugins.Page;
import io.platform.engineering.dto.BbudgetsDto;

import java.util.List;
import java.util.Map;

import io.platform.base.common.utils.ExecuteResult;
import io.platform.moneyManagement.dto.InvoiceBillsDto;

/**
 * Created by sevelli on 2017/8/31.
 */
public interface BbudgetsServiceClient {
    /**
     * 根据ID 查询单个对象
     */
    BbudgetsDto queryObject(Long id);

    /**
     * 根据参数查询 列表  无分页
     */
    List<BbudgetsDto> queryList(Map<String, Object> map);

    /**
     * 根据参数查询 对应参数的 集合大小
     */
    int queryTotal(Map<String, Object> map);

    /**
     * 保存对象
     */
    ExecuteResult<String> save(BbudgetsDto bbudgetsDto);

    /**
     * 更新对象
     */
    ExecuteResult<String> update(BbudgetsDto bbudgetsDto);

    /**
     * 根据主键 删除对象
     */
    ExecuteResult<String> delete(Long id);

    /**
     * 根据主键集合 批量删除
     */
    ExecuteResult<String> deleteBatch(List<Long> idList);

    /**
     * 根据分页参数 获取 分页集合
     */
    Page<BbudgetsDto> getPage(Page<BbudgetsDto> page, BbudgetsDto bbudgetsDto);

    /**
     * 模糊查询
     *
     * @param bbudgetsDto
     * @return
     */
    Map<String, Object> fuzzyQueryBudget(Page page, BbudgetsDto bbudgetsDto);

    /*
     * 暂用！！！！！！！！！！！！！！！暂用！！！！！！！！！！
     */
    Map<String, Object> zYQueryBudgetId(InvoiceBillsDto invoiceBillsDto);

    /**
     * 查询所有
     */
    Map<String, Object> selectBudgets(BbudgetsDto bbudgetsDto);

    Map<String, Object> selectOtherBudgets(BbudgetsDto bbudgetsDto);
}
