
package io.platform.engineering.service.client.api;

import com.baomidou.mybatisplus.plugins.Page;
import io.platform.engineering.dto.BcorpsDto;

import java.util.List;
import java.util.Map;

import io.platform.base.common.utils.ExecuteResult;
import io.platform.engineering.dto.BprojectTypesDto;
import io.platform.sys.dto.SysUserDto;

/**
 * Created by sevelli on 2017/8/31.
 */
public interface BcorpsServiceClient {
    /**
     * 根据ID 查询单个对象
     */
    BcorpsDto queryObject(Long id);

    /**
     * 根据参数查询 列表  无分页
     */
    List<BcorpsDto> queryList(Map<String, Object> map);

    /**
     * 根据参数查询 对应参数的 集合大小
     */
    int queryTotal(Map<String, Object> map);

    /**
     * 保存对象
     */
    ExecuteResult<String> save(BcorpsDto bcorpsDto);
    /**
     * 保存多个对象
     */
    ExecuteResult<String> saveList(List<BcorpsDto> bcorpsDto);

    /**
     * 更新对象
     */
    ExecuteResult<String> update(BcorpsDto bcorpsDto);

    /**
     * 根据主键 删除对象
     */
    ExecuteResult<String> delete(Long id);

    /**
     * 根据主键集合 批量删除
     */
    ExecuteResult<String> deleteBatch(List<Long> idList);

    /**
     * 根据分页参数 获取 分页集合
     */
    Page<BcorpsDto> getPage(Page<BcorpsDto> page, BcorpsDto bcorpsDto, SysUserDto sysUserDto);

    /**
     * 模糊查询
     *
     * @param page
     * @param bcorpsDto
     * @return
     */
    Map<String, Object> fuzzyQueryCorps(Page page, BcorpsDto bcorpsDto);

    /**
     * 查询所有
     */
    Map<String, Object> selectCorps(BcorpsDto bcorpsDto);
}
