
package io.platform.engineering.service.client.api;

import com.baomidou.mybatisplus.plugins.Page;
import io.platform.engineering.dto.BemplsDto;
import io.platform.engineering.dto.BpayPropertysDto;

import java.util.List;
import java.util.Map;

import io.platform.base.common.utils.ExecuteResult;

/**
 * Created by sevelli on 2017/8/31.
 */
public interface BpayPropertysServiceClient {
    /**
     * 根据ID 查询单个对象
     */
    BpayPropertysDto queryObject(Long id);

    /**
     * 根据参数查询 列表  无分页
     */
    List<BpayPropertysDto> queryList(Map<String, Object> map);

    /**
     * 根据参数查询 对应参数的 集合大小
     */
    int queryTotal(Map<String, Object> map);

    /**
     * 保存对象
     */
    ExecuteResult<String> save(BpayPropertysDto bpayPropertysDto);

    /**
     * 更新对象
     */
    ExecuteResult<String> update(BpayPropertysDto bpayPropertysDto);

    /**
     * 根据主键 删除对象
     */
    ExecuteResult<String> delete(Long id);

    /**
     * 根据主键集合 批量删除
     */
    ExecuteResult<String> deleteBatch(List<Long> idList);

    /**
     * 根据分页参数 获取 分页集合
     */
    Page<BpayPropertysDto> getPage(Page<BpayPropertysDto> page, BpayPropertysDto bpayPropertysDto);

    /**
     * 模糊查询
     *
     * @param bpayPropertysDto
     * @return
     */
    Map<String, Object> fuzzyQueryPayProperty(Page page, BpayPropertysDto bpayPropertysDto);

    /**
     * 查询所有
     */
    Map<String, Object> selectPayPropertys(BpayPropertysDto bpayPropertysDto);
}
