
package io.platform.engineering.service.client.api;

import com.baomidou.mybatisplus.plugins.Page;
import io.platform.engineering.dto.BprojectNodeStepsDto;

import java.util.List;
import java.util.Map;

import io.platform.base.common.utils.ExecuteResult;
import io.platform.engineering.dto.BprojectNodesDto;

/**
 * Created by sevelli on 2017/8/31.
 */
public interface BprojectNodeStepsServiceClient {
    /**
     * 根据ID 查询单个对象
     */
    BprojectNodeStepsDto queryObject(Long id);

    /**
     * 根据参数查询 列表  无分页
     */
    List<BprojectNodeStepsDto> queryList(Map<String, Object> map);

    /**
     * 根据参数查询 对应参数的 集合大小
     */
    int queryTotal(Map<String, Object> map);

    /**
     * 保存对象
     */
    ExecuteResult<String> save(BprojectNodeStepsDto bprojectNodeStepsDto);

    /**
     * 更新对象
     */
    ExecuteResult<String> update(BprojectNodeStepsDto bprojectNodeStepsDto);

    /**
     * 根据主键 删除对象
     */
    ExecuteResult<String> delete(Long id);

    /**
     * 根据主键集合 批量删除
     */
    ExecuteResult<String> deleteBatch(List<Long> idList);

    /**
     * 根据分页参数 获取 分页集合
     */
    Page<BprojectNodeStepsDto> getPage(Page<BprojectNodeStepsDto> page, BprojectNodeStepsDto bprojectNodeStepsDto);

    /**
     * 模糊查询
     *
     * @param bprojectNodeStepsDto
     * @return
     */
    Map<String, Object> fuzzyQueryProjectNodeSt(Page page, BprojectNodeStepsDto bprojectNodeStepsDto);

    /**
     * 查询所有
     */
    Map<String, Object> selectProNodeSteps(BprojectNodeStepsDto bprojectNodeStepsDto);
}
