
package io.platform.engineering.service.client.api;

import com.baomidou.mybatisplus.plugins.Page;
import io.platform.engineering.dto.BprojectNodesDto;

import java.util.List;
import java.util.Map;

import io.platform.base.common.utils.ExecuteResult;

/**
 * Created by sevelli on 2017/8/31.
 */
public interface BprojectNodesServiceClient {
    /**
     * 根据ID 查询单个对象
     */
    BprojectNodesDto queryObject(Long id);

    /**
     * 根据参数查询 列表  无分页
     */
    List<BprojectNodesDto> queryList(Map<String, Object> map);

    /**
     * 根据参数查询 对应参数的 集合大小
     */
    int queryTotal(Map<String, Object> map);

    /**
     * 保存对象
     */
    ExecuteResult<String> save(BprojectNodesDto bprojectNodesDto);

    /**
     * 更新对象
     */
    ExecuteResult<String> update(BprojectNodesDto bprojectNodesDto);

    /**
     * 根据主键 删除对象
     */
    ExecuteResult<String> delete(Long id);

    /**
     * 根据主键集合 批量删除
     */
    ExecuteResult<String> deleteBatch(List<Long> idList);

    /**
     * 根据分页参数 获取 分页集合
     */
    Page<BprojectNodesDto> getPage(Page<BprojectNodesDto> page, BprojectNodesDto bprojectNodesDto);

    /**
     * 模糊查询
     *
     * @param bprojectNodesDto
     * @return
     */
    Map<String, Object> fuzzyQueryProjectNodes(Page page, BprojectNodesDto bprojectNodesDto);

    /**
     * 查询所有
     */
    Map<String, Object> selectProNodes(BprojectNodesDto bprojectNodesDto);
}
