
package io.platform.engineering.service.client.api;

import com.baomidou.mybatisplus.plugins.Page;
import io.platform.engineering.dto.BpurchasesDto;

import java.util.List;
import java.util.Map;

import io.platform.base.common.utils.ExecuteResult;
import io.platform.moneyManagement.dto.InvoiceBillsDto;

/**
 * Created by sevelli on 2017/8/31.
 */
public interface BpurchasesServiceClient {
    /**
     * 根据ID 查询单个对象
     */
    BpurchasesDto queryObject(Long id);

    /**
     * 根据参数查询 列表  无分页
     */
    List<BpurchasesDto> queryList(Map<String, Object> map);

    /**
     * 根据参数查询 对应参数的 集合大小
     */
    int queryTotal(Map<String, Object> map);

    /**
     * 保存对象
     */
    ExecuteResult<String> save(BpurchasesDto bpurchasesDto);
    /**
     * 保存对象
     */
    ExecuteResult<String> saveList(List<BpurchasesDto> bpurchasesDto);

    /**
     * 更新对象
     */
    ExecuteResult<String> update(BpurchasesDto bpurchasesDto);

    /**
     * 根据主键 删除对象
     */
    ExecuteResult<String> delete(Long id);

    /**
     * 根据主键集合 批量删除
     */
    ExecuteResult<String> deleteBatch(List<Long> idList);

    /**
     * 根据分页参数 获取 分页集合
     */
    Page<BpurchasesDto> getPage(Page<BpurchasesDto> page, BpurchasesDto bpurchasesDto);

    /**
     * 模糊查询
     */
    Map<String, Object> fuzzyQueryPurchases(Page page, BpurchasesDto bpurchasesDto);

    /**
     * 查询所有
     */
    Map<String, Object> selectPurchases(BpurchasesDto bpurchasesDto);

    Map<String, Object> queryDirectPay(Page page, InvoiceBillsDto invoiceBillsDto);

    List<BpurchasesDto> selectProjectPriceBudget(String subNo, Integer loginContractorId);
}
