package io.platform.moneyManagement.dto;

import com.baomidou.mybatisplus.annotations.TableField;
import lombok.Data;

import java.util.Date;

@Data
public class PayCrBillsDto implements java.io.Serializable {
    private static final long serialVersionUID = 5454155825314635342L;


    /**
     * id       db_column: id
     */
    private Integer id;
    /**
     * 单据编号       db_column: bill_no
     */
    private String billNo;
    /**
     * 业务活动号       db_column: act_id
     */
    private Integer actId;
    /**
     * 来源活动号       db_column: src_act_id
     */
    private Integer srcActId;
    /**
     * 单据编号       db_column: src_bill_no
     */
    private String srcBillNo;
    /**
     * 来源行号       db_column: src_line_no
     */
    private Integer srcLineNo;
    /**
     * 原始活动号       db_column: org_act_id
     */
    private Integer orgActId;
    /**
     * 原始编号       db_column: org_bill_no
     */
    private String orgBillNo;
    /**
     * 原始行号       db_column: org_line_no
     */
    private Integer orgLineNo;
    /**
     * 单据状态（1-新建2处理中6完成）       db_column: bill_status
     */
    private Integer billStatus;
    /**
     * 制单人       db_column: op_user_id
     */
    private Integer opUserId;
    /**
     * 制单人姓名       db_column: op_user_name
     */
    private String opUserName;
    /**
     * 制单日期       db_column: create_date
     */
    private Date createDate;
    /**
     * 收款日期       db_column: bill_date
     */
    private Date billDate;
    /**
     * 提交日期       db_column: post_date
     */
    private Date postDate;
    /**
     * 备注       db_column: remarks
     */
    private String remarks;
    /**
     * 承包单位id       db_column: branch_id
     */
    private Integer branchId;
    /**
     * 付款发票维护单据编号（关联InvoiceBills）       db_column: inv_bill_no
     */
    private String invBillNo;
    /**
     * 子工程编号       db_column: project_sub_no
     */
    private String projectSubNo;
    /**
     * 预算费用id       db_column: budget_id
     */
    private Integer budgetId;
    /**
     * 供应商id       db_column: purcaser_id
     */
    private Integer purcaserId;
    /**
     * 合同编号       db_column: contract_no
     */
    private String contractNo;
    /**
     * 合同审定金额       db_column: contract_amt
     */
    private Double contractAmt;
    /**
     * nc采购订单号       db_column: purcaser_nc_no
     */
    private String purcaserNcNo;
    /**
     * 银行联行号       db_column: purcaser_bank_no
     */
    private String purcaserBankNo;
    /**
     * 开户银行       db_column: purcaser_bank
     */
    private String purcaserBank;
    /**
     * 银联账号       db_column: purcaser_acc_no
     */
    private String purcaserAccNo;
    /**
     * 累计开票金额       db_column: inv_total_amt
     */
    private Double invTotalAmt;
    /**
     * 累计付款金额       db_column: stl_total_amt
     */
    private Double stlTotalAmt;
    /**
     * 本次付款金额       db_column: stl_amt
     */
    private Double stlAmt;
    /**
     * 确认人id       db_column: user_id
     */
    private Integer userId;
    /**
     * 确认人姓名       db_column: user_name
     */
    private String userName;
    /**
     * 确认时间       db_column: affirmant_date
     */
    private Date affirmantDate;
    /**
     * 确认意见       db_column: affirmant_remarks
     */
    private String affirmantRemarks;
    /**
     * 确认状态T通过F待处理       db_column: confirm_status
     */
    private String confirmStatus;
    /**
     * 是否为特殊付款申请      db_column: flag_special
     */
    private Integer flagSpecial;
    /**
     * 是否已打印(T 已打印  F 未打印)      db_column: is_printed
     */
    private String isPrinted;
    /**
     * 打印时间
     */
    private Date printTime;
    /**
     * 特殊付款说明
     */
    private String specialItem;
    /**
     * 二維碼
     */
    private String printQrCode;
    //columns END
    private String printCount;
    /**
     * 是否是存续项目的付款
     */
    private Integer ifCx;
    /**
     * 审定金额
     */
    private Double contractAuditAmt;
    /**
     * 质保金
     */
    private Double warrantyAmt;
    /**
     * 其他扣款
     */
    private Double otherAmt;
}
