
package io.platform.moneyManagement.service.client.api;

import java.util.List;
import java.util.Map;

import com.baomidou.mybatisplus.plugins.Page;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.moneyManagement.dto.InvoiceBillsItemsDto;
import io.platform.sys.dto.SysUserDto;

/**
 * Created by sevelli on 2017/8/31.
 */
public interface InvoiceBillsItemsServiceClient {
    /**
     * 根据ID 查询单个对象
     */
    InvoiceBillsItemsDto queryObject(Long id);

    /**
     * 根据参数查询 列表  无分页
     */
    List<InvoiceBillsItemsDto> queryList(Map<String, Object> map);

    /**
     * 根据参数查询 对应参数的 集合大小
     */
    int queryTotal(Map<String, Object> map);

    /**
     * 保存对象
     */
    ExecuteResult<String> save(InvoiceBillsItemsDto invoiceBillsItemsDto);

    /**
     * 更新对象
     */
    ExecuteResult<String> update(InvoiceBillsItemsDto invoiceBillsItemsDto);

    /**
     * 根据主键 删除对象
     */
    ExecuteResult<String> delete(Long id);

    /**
     * 根据主键集合 批量删除
     */
    ExecuteResult<String> deleteBatch(List<Long> idList);

    /**
     * 根据分页参数 获取 分页集合
     */
    Page<InvoiceBillsItemsDto> getPage(Page<InvoiceBillsItemsDto> page, InvoiceBillsItemsDto invoiceBillsItemsDto);

    Map<String, Object> selectNumber(String subNo, Integer purchaseId, Integer budgetId);

    /**
     * 删除单条明细
     */
    ExecuteResult<String> deleteItem(InvoiceBillsItemsDto invoiceBillsItemsDto);


    Map<String, Object> selectDirectPaymentPurchase(String subNo, Integer budId, SysUserDto sysUserDto);
}
