
package io.platform.moneyManagement.service.client.api;

import java.util.List;
import java.util.Map;

import com.baomidou.mybatisplus.plugins.Page;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.budget.dto.ProjectBillsBudgetsDto;
import io.platform.moneyManagement.dto.InvoiceBillsDto;
import io.platform.project.dto.ProjectBillsSubsDto;
import io.platform.project.dto.SubContractBillsDto;
import io.platform.purchase.dto.PurchaseBillsItemsDto;
import io.platform.sys.dto.SysUserDto;

/**
 * Created by sevelli on 2017/8/31.
 */
public interface InvoiceBillsServiceClient {
    /**
     * 根据ID 查询单个对象
     */
    InvoiceBillsDto queryObject(Long id);

    /**
     * 根据参数查询 列表  无分页
     */
    List<InvoiceBillsDto> queryList(Map<String, Object> map);

    /**
     * 根据参数查询 对应参数的 集合大小
     */
    int queryTotal(Map<String, Object> map);

    /**
     * 保存对象
     */
    ExecuteResult<String> save(InvoiceBillsDto invoiceBillsDto);

    /**
     * 更新对象
     */
    ExecuteResult<String> update(InvoiceBillsDto invoiceBillsDto);

    /**
     * 根据主键 删除对象
     */
    ExecuteResult<String> delete(Long id);

    /**
     * 删除收款发票
     */
    ExecuteResult<String> deleteInvoice(InvoiceBillsDto invoiceBillsDto);

    /**
     * 删除收款发票-分包工程
     */
    ExecuteResult<String> deleteEngineering(InvoiceBillsDto invoiceBillsDto);

    /**
     * 删除付款发票-直接成本
     */
    ExecuteResult<String> deleteDirectInvoice(InvoiceBillsDto invoiceBillsDto);

    /**
     * 删除付款发票-间接成本
     */
    ExecuteResult<String> deletePayInvoice(InvoiceBillsDto invoiceBillsDto);

    /**
     * 根据分页参数 获取 分页集合
     */
    Map<String, Object> invoicePage(Map<String, Object> map,SysUserDto sysUserDto);

    /**
     * 收款发票信息查询
     */
    Map<String, Object> changeFuzzyQueryProject(ProjectBillsSubsDto projectBillsSubsDto);

    /**
     * 暂存
     */
    ExecuteResult<String> invoiceTemporary(String projectForm, String progress, String maintenance, SysUserDto sysUserDto);

    /**
     * 查询暂存数据
     */
    Map<String, Object> queryInvoiceTemporary(InvoiceBillsDto invoiceBillsDto);

    /**
     * 提交
     */
    ExecuteResult<String> invoiceSave(String projectForm, String progress, String maintenance, SysUserDto sysUserDto);

    /**
     * 付款发票-分包工程信息查询
     */
    Map<String, Object> changeFuzzyQueryEngineeringInvoice(ProjectBillsSubsDto projectBillsSubsDto);

    /**
     * 付款发票分包工程暂存
     */
    ExecuteResult<String> engineeringInvoiceTemporary(String projectForm, String payPost, String invoDeta, SysUserDto sysUserDto);

    /**
     * 付款发票分包工程提交
     */
    ExecuteResult<String> engineeringInvoiceSave(String projectForm, String payPost, String invoDeta, SysUserDto sysUserDto);

    /**
     * 查询付款发票分包工程暂存数据
     */
    Map<String, Object> queryEngineeringInvoiceTemporary(InvoiceBillsDto invoiceBillsDto, SysUserDto sysUserDto);

    Map<String, Object> selectItem(ProjectBillsSubsDto projectBillsSubsDto);


    /**
     * 付款发票间接成本分页列表
     */
    Map<String, Object> payInvoiceMaintenancePage(Page page, InvoiceBillsDto invoiceBillsDto);

    /**
     * 付款发票-间接成本信息查询
     */
    Map<String, Object> changeFuzzyQueryPayInvoice(InvoiceBillsDto invoiceBillsDto);

    /**
     * 付款发票维护-间接成本暂存
     */
    ExecuteResult<String> payInvoiceMaintenanceTemporary(String projectForm, String detailMaintenance, String invoiceItem, String costSharing, String relevantAttach, SysUserDto sysUserDto);

    /**
     * 查询付款发票维护-间接成本暂存数据
     */
    Map<String, Object> queryPayInvoiceMaintenanceTemporary(InvoiceBillsDto invoiceBillsDto, SysUserDto sysUserDto);

    /**
     * 付款发票维护-间接成本提交
     */
    ExecuteResult<String> payInvoiceMaintenanceSave(String projectForm, String detailMaintenance, String invoiceItem, String costSharing, String relevantAttach, SysUserDto sysUserDto);

    /**
     * 模糊搜素收付款信息
     */
    Map<String, Object> fuzzyQueryInvoice(Page page, InvoiceBillsDto invoiceBillsDto, SysUserDto sysUserDto);

    /**
     * 付款发票直接接成本分页列表
     */
    Map<String, Object> directInvoiceCostPage(Page page, InvoiceBillsDto invoiceBillsDto);

    String directTemporary(String zhu, String fapiao, String fujian, SysUserDto sysUserDto);

    Map<String, Object> selectBillsItem(String subNo,Integer purchaseId);

    /**
     * 查询付款发票-直接成本暂存信息
     */
    Map<String, Object> queryDirectCostTemporary(InvoiceBillsDto invoiceBillsDto);

    Map<String, Object> invoiceMaterialPage(Map<String, Object> map,SysUserDto sysUserDto);

    Map<String, Object> queryEngineeringSubContract(SubContractBillsDto subContractBillsDto);

    Map<String, Object> queryPayInvoiceMaintenBudget(ProjectBillsBudgetsDto projectBillsBudgetsDto);

    Map<String, Object> selectPrint(InvoiceBillsDto invoiceBillsDto, SysUserDto sysUserDto);

    Map<String, Object> queryInvoiceIndirect(InvoiceBillsDto invoiceBillsDto);

    Boolean updatePrintTime(Integer id);

    Map<String, Object> selectOtherIndirect(Map<String, Object> map, SysUserDto sysUserDto);

    ExecuteResult<String> updateContractNo(SubContractBillsDto subContractBillsDto);

    ExecuteResult<String> updatePayCrContractNo(SubContractBillsDto subContractBillsDto);

    ExecuteResult<String> revoke(InvoiceBillsDto invoiceBillsDto, SysUserDto sysUserDto);

    ExecuteResult<String> revokeProjectPirce(InvoiceBillsDto invoiceBillsDto, SysUserDto sysUserDto);

    ExecuteResult<String> revokeDirectInvoiceCost(InvoiceBillsDto invoiceBillsDto, SysUserDto sysUserDto);

    ExecuteResult<String> revokeIndirect(InvoiceBillsDto invoiceBillsDto, SysUserDto sysUserDto);
}
