
package io.platform.moneyManagement.service.client.api;

import com.baomidou.mybatisplus.plugins.Page;

import java.util.List;
import java.util.Map;

import io.platform.base.common.utils.ExecuteResult;
import io.platform.moneyManagement.dto.PayCrBillsDto;
import io.platform.project.dto.ProjectBillsSubsDto;
import io.platform.sys.dto.SysUserDto;

/**
 * Created by sevelli on 2017/8/31.
 */
public interface PayCrBillsServiceClient {
    /**
     * 根据ID 查询单个对象
     */
    PayCrBillsDto queryObject(Long id);

    /**
     * 根据参数查询 列表  无分页
     */
    List<PayCrBillsDto> queryList(Map<String, Object> map);

    /**
     * 根据参数查询 对应参数的 集合大小
     */
    int queryTotal(Map<String, Object> map);

    /**
     * 保存对象
     */
    ExecuteResult<String> save(PayCrBillsDto payCrBillsDto);

    /**
     * 更新对象
     */
    ExecuteResult<String> update(PayCrBillsDto payCrBillsDto);

    /**
     * 根据主键 删除对象
     */
    ExecuteResult<String> delete(Long id);

    /**
     * 删除付款记录-直接成本
     */
    ExecuteResult<String> deleteDirectPayment(PayCrBillsDto payCrBillsDto);

    /**
     * 删除付款记录-间接成本
     */
    ExecuteResult<String> deletePayCrBill(PayCrBillsDto payCrBillsDto);

    /**
     * 根据分页参数 获取 分页集合
     */
    Map<String, Object> getPage(Map<String, Object> map, SysUserDto sysUserDto);

    /**
     * 暂存
     */
    ExecuteResult<String> payCrTemporary(String projectForm, String payment, String supplier, String paymentSharing, SysUserDto sysUserDto);

    /**
     * 查询暂存
     */
    Map<String, Object> queryPayCrTemporary(PayCrBillsDto payCrBillsDto);

    /**
     * 提交
     */
    ExecuteResult<String> payCrSave(String projectForm, String payment, String supplier, String paymentSharing, SysUserDto sysUserDto);

    Map<String, Object> payCrSelect(ProjectBillsSubsDto projectBillsSubsDto);

    /**
     * 模糊搜素收付款信息
     */
    Map<String, Object> fuzzyQueryInvoice(Page page, PayCrBillsDto payCrBillsDto);

    /**
     * 付款-直接成本-暂存
     */
    ExecuteResult<String> directPaymentTemporary(String projectForm);

    /**
     * 付款-直接成本-提交
     */
    ExecuteResult<String> directPaymentSave(String projectForm, SysUserDto sysUserDto);

    /**
     * 查询该工程下预算项目
     */
    Map<String, Object> queryBudgets(PayCrBillsDto payCrBillsDto);

    /**
     * 确认付款
     */
    ExecuteResult<String> editCrAffirmStatus(PayCrBillsDto payCrBillsDto, SysUserDto sysUserDto);

    /**
     * 驳回请求
     *
     * @param payCrBillsDto
     * @return
     */
    ExecuteResult<String> refute(PayCrBillsDto payCrBillsDto, SysUserDto sysUserDto);

    Map<String, Object> payCrIndirectPage(Map<String, Object> map, SysUserDto sysUserDto);

    Map<String, Object> selectPayCrIndirectPrint(PayCrBillsDto payCrBillsDto, SysUserDto sysUserDto);

    ExecuteResult<String> turnDownStatus(PayCrBillsDto payCrBillsDto, SysUserDto sysUserDto);

    Map<String, Object> updatePayCr(Integer id);

    String financialDismissal(Integer id, String affirmantRemarks, SysUserDto sysUserDto);

    String financialSuccess(Integer id, String affirmantRemarks, SysUserDto sysUserDto);

    boolean updatePayCrIndirectPrint(PayCrBillsDto payCrBillsDto);

    Map<String, Object> selectFundpay(PayCrBillsDto payCrBillsDto, SysUserDto sysUserDto);

    String cxFinancialSuccess(Integer id, String affirmantRemarks, SysUserDto sysUserDto);

    ExecuteResult<String> revokePayment(PayCrBillsDto payCrBillsDto, SysUserDto sysUserDto);
}
