
package io.platform.moneyManagement.service.client.api;

import com.baomidou.mybatisplus.plugins.Page;

import java.util.List;
import java.util.Map;

import io.platform.base.common.utils.ExecuteResult;
import io.platform.moneyManagement.dto.PayDrBillsItemsDto;
import io.platform.project.dto.ProjectbillsDto;
import io.platform.sys.dto.SysUserDto;

/**
 * Created by sevelli on 2017/8/31.
 */
public interface PayDrBillsItemsServiceClient {
    /**
     * 根据ID 查询单个对象
     */
    PayDrBillsItemsDto queryObject(Long id);

    /**
     * 根据参数查询 列表  无分页
     */
    List<PayDrBillsItemsDto> queryList(Map<String, Object> map);

    /**
     * 根据参数查询 对应参数的 集合大小
     */
    int queryTotal(Map<String, Object> map);

    /**
     * 保存对象
     */
    ExecuteResult<String> save(PayDrBillsItemsDto payDrBillsItemsDto);

    /**
     * 更新对象
     */
    ExecuteResult<String> update(PayDrBillsItemsDto payDrBillsItemsDto);

    /**
     * 根据主键 删除对象
     */
    ExecuteResult<String> delete(Long id);

    /**
     * 根据主键集合 批量删除
     */
    ExecuteResult<String> deleteBatch(List<Long> idList);

    /**
     * 根据分页参数 获取 分页集合
     */
    Page<PayDrBillsItemsDto> getPage(Page<PayDrBillsItemsDto> page, PayDrBillsItemsDto payDrBillsItemsDto);

    Map<String, Object> selectDirectCostPrice(String subNo, String ncNo, SysUserDto sysUserDto);

    String saveDirect(String zhu, String fapiao, String fujian, SysUserDto sysUserDto);

    Map<String, Object> selectDirect(Integer id, SysUserDto sysUserDto);

    List<Map<String, Object>> selectPayDrData(SysUserDto sysUserDto);

    List<Map<String, Object>> selectPayDrDataCount(SysUserDto sysUserDto);

    List<Map<String, Object>> selectPayDrTopData(String name, Integer typeId, SysUserDto sysUserDto);

    List<Map<String, Object>> selectPayDyAllAmt();

    Map<String, Object> selectSubAmtCrAndDr(SysUserDto sysUserDto);

    List<Map<String, Object>> selectBranchSubProjectAmt(SysUserDto sysUserDto);

    List<Long> selectAllDrInterestRate(SysUserDto sysUserDto);
}
