
package io.platform.moneyManagement.service.client.api;


import java.util.List;
import java.util.Map;

import com.baomidou.mybatisplus.plugins.Page;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.moneyManagement.dto.PayDrBillsDto;
import io.platform.project.dto.ProjectBillsSubsDto;
import io.platform.sys.dto.SysUserDto;

/**
 * Created by sevelli on 2017/8/31.
 */
public interface PayDrBillsServiceClient {
    /**
     * 根据ID 查询单个对象
     */
    PayDrBillsDto queryObject(Long id);

    /**
     * 根据参数查询 列表  无分页
     */
    List<PayDrBillsDto> queryList(Map<String, Object> map);

    /**
     * 根据参数查询 对应参数的 集合大小
     */
    int queryTotal(Map<String, Object> map);

    /**
     * 保存对象
     */
    ExecuteResult<String> save(PayDrBillsDto payDrBillsDto);

    /**
     * 更新对象
     */
    ExecuteResult<String> update(PayDrBillsDto payDrBillsDto);

    /**
     * 根据主键 删除对象
     */
    ExecuteResult<String> delete(Long id);

    /**
     * 删除收款记录
     */
    ExecuteResult<String> deletePayDr(PayDrBillsDto payDrBillsDto);

    /**
     * 根据分页参数 获取 分页集合
     */
    Map<String, Object> getPage(Map<String, Object> map,SysUserDto sysUserDto);

    /**
     * 收款发票信息查询
     */
    Map<String, Object> changeFuzzyQueryPayDr(ProjectBillsSubsDto projectBillsSubsDto);

    /**
     * 暂存
     */
    ExecuteResult<String> payDrTemporary(String payDr, String payDrItems, SysUserDto sysUserDto);

    /**
     * 查询暂存数据
     */
    Map<String, Object> queryPayTemporary(PayDrBillsDto payDrBillsDto);

    /**
     * 提交
     */
    ExecuteResult<String> payDrSave(String payDr, String payDrItems, SysUserDto sysUserDto);

    /**
     * 财务确认
     */
    ExecuteResult<String> editAffirmStatus(PayDrBillsDto payDrBillsDto, SysUserDto sysUserDto);

    Map<String,Object> selectAll(Page<PayDrBillsDto> page, PayDrBillsDto payDrBillsDto,SysUserDto sysUserDto);

    Map<String, Object> selectPrintInformation(PayDrBillsDto payDrBillsDto, SysUserDto sysUserDto);

    ExecuteResult<String> updatePayCrIndirectPrint(PayDrBillsDto payDrBillsDto, PayDrBillsDto payDrBillsDto1);
}
