package io.platform.project.dto;

import com.baomidou.mybatisplus.annotations.TableField;
import lombok.Data;

@Data
public class ProjectbillsDto implements java.io.Serializable {
    private static final long serialVersionUID = 5454155825314635342L;


    /**
     * id       db_column: id
     */
    private Integer id;
    /**
     * 单据编号       db_column: bill_no
     */
    private String billNo;
    /**
     * 业务活动号ID       db_column: act_id
     */
    private Integer actId;
    /**
     * 来源活动ID       db_column: src_act_id
     */
    private Integer srcActId;
    /**
     * 来源单据编号       db_column: src_bill_no
     */
    private Integer srcBillNo;
    /**
     * 来源行号       db_column: src_line_no
     */
    private Integer srcLineNo;
    /**
     * 原始活动ID       db_column: org_act_id
     */
    private Integer orgActId;
    /**
     * 原始编号       db_column: org_bill_no
     */
    private Integer orgBillNo;
    /**
     * 原始行号       db_column: org_line_no
     */
    private Integer orgLineNo;
    /**
     * 制单人ID       db_column: op_user_id
     */
    private Integer opUserId;
    /**
     * 制单人姓名       db_column: op_user_name
     */
    private String opUserName;
    /**
     * 制单日期       db_column: create_date
     */
    private java.util.Date createDate;
    /**
     * 业务日期       db_column: bill_date
     */
    private java.util.Date billDate;
    /**
     * 提交日期       db_column: post_date
     */
    private java.util.Date postDate;
    /**
     * 备注       db_column: remarks
     */
    private String remarks;
    /**
     * 是否有子项目（T有F无）       db_column: have_project_sub
     */
    private String haveProjectSub;
    /**
     * 工程编号       db_column: project_no
     */
    private String projectNo;
    /**
     * NC工程编号       db_column: nc_project_no
     */
    private String ncProjectNo;
    /**
     * 合同编号（根据总包合同选择）       db_column: contract_no
     */
    private String contractNo;
    /**
     * 合同名称       db_column: contract_name
     */
    private String contractName;
    /**
     * 工程类型ID（关联基础资料）       db_column: project_type_id
     */
    private Integer projectTypeId;
    /**
     * 工程小类型ID（关联基础资料）       db_column: project_type_item_id
     */
    private Integer projectTypeItemId;
    /**
     * 工程名称       db_column: project_name
     */
    private String projectName;
    /**
     * 工程地点       db_column: construction_place
     */
    private String constructionPlace;
    /**
     * 业主单位ID（关联基础资料）       db_column: corp_id
     */
    private Integer corpId;
    /**
     * 承包单位ID（关联基础资料）       db_column: branch_id
     */
    private Integer branchId;
    /**
     * 审批公司id（关联基础资料）       db_column: approval_branch_id
     */
    private Integer approvalBranchId;
    /**
     * 签约地点       db_column: sign_addr
     */
    private String signAddr;
    /**
     * 签约日期       db_column: sign_date
     */
    private java.util.Date signDate;
    /**
     * 计划开工日期       db_column: plan_start_date
     */
    private java.util.Date planStartDate;
    /**
     * 计划竣工日期       db_column: plan_end_date
     */
    private java.util.Date planEndDate;
    /**
     * 实际开工日期       db_column: act_start_date
     */
    private java.util.Date actStartDate;
    /**
     * 实际竣工日期       db_column: act_end_date
     */
    private java.util.Date actEndDate;
    /**
     * 实际工期       db_column: act_days
     */
    private Integer actDays;
    /**
     * 开工状态（1-新建2处理中6完成）       db_column: start_date_status
     */
    private Integer startDateStatus;
    /**
     * 结算人id       db_column: settlement_user_id
     */
    private Integer settlementUserId;
    /**
     * 结算状态（1-新建2处理中6完成）       db_column: settlement_status
     */
    private Integer settlementStatus;
    /**
     * 上传结算文件       db_column: set_attach_id
     */
    private String setAttachId;
    /**
     * 上传开工文件       db_column: set_start_attach_id
     */
    private String setStartAttachId;
    /**
     * 开工操作人       db_column: start_user_id
     */
    private Integer startUserId;
    /**
     * 开工备注       db_column: start_remarks
     */
    private String startRemarks;
    /**
     * 上传竣工文件       db_column: set_end_attach_id
     */
    private String setEndAttachId;
    /**
     * 竣工状态（1-新建2处理中6完成）       db_column: start_date_end
     */
    private Integer startDateEnd;
    /**
     * 竣工操作人       db_column: end_user_id
     */
    private Integer endUserId;
    /**
     * 竣工备注       db_column: end_remarks
     */
    private String endRemarks;
    /**
     * 计划工期天数       db_column: plan_days
     */
    private Integer planDays;
    /**
     * 价款确定方式（关联基础资料）       db_column: price_mode_id
     */
    private Integer priceModeId;
    /**
     * 合同金额       db_column: contract_amt
     */
    private Double contractAmt;
    /**
     * 合同金额(大写)       db_column: contract_amt_capital
     */
    private String contractAmtCapital;
    /**
     * 合同税率(%)       db_column: contract_tax_rate
     */
    private Double contractTaxRate;
    /**
     * 实际税率(%)       db_column: act_contract_tax_amt
     */
    private Double actContractTaxAmt;
    /**
     * 合同税额(%)       db_column: contract_tax_amt
     */
    private Double contractTaxAmt;
    /**
     * 结算方式：T“一次性支付”、F“分期收款”       db_column: stl_type
     */
    private String stlType;
    /**
     * 客户类别编号（关联基础资料）       db_column: corp_type_id
     */
    private Integer corpTypeId;
    /**
     * 实际实施单位       db_column: constructor_id
     */
    private Integer constructorId;
    /**
     * 工程详情       db_column: project_detail
     */
    private String projectDetail;
    /**
     * 工程部经理（关联人员信息表）       db_column: project_leader
     */
    private Integer projectLeader;
    /**
     * 项目经理ID（关联人员信息表）       db_column: project_mng_id
     */
    private Integer projectMngId;
    /**
     * 经理部门ID（根据选择的项目经理自动显示）       db_column: project_mng_dept_id
     */
    private Integer projectMngDeptId;
    /**
     * 合同审定金额       db_column: contract_audit_amt
     */
    private double contractAuditAmt;
    /**
     * 总包结算日期       db_column: contract_audit_date
     */
    private Integer contractAuditDate;
    /**
     * 里程碑编制人姓名       db_column: step_user_name
     */
    private String stepUserName;
    /**
     * 里程碑编制日期       db_column: step_date
     */
    private java.util.Date stepDate;
    /**
     * 图纸交割日期       db_column: drawing_date
     */
    private java.util.Date drawingDate;
    /**
     * 预算总金额（根据预算明细计算）       db_column: budget_amt
     */
    private Double budgetAmt;
    /**
     * 预算毛利润额       db_column: budget_profit
     */
    private Double budgetProfit;
    /**
     * 预算毛利润率       db_column: budget_profit_rate
     */
    private Double budgetProfitRate;
    /**
     * 预算编制人姓名       db_column: budget_user_name
     */
    private String budgetUserName;
    /**
     * 预算调整日期       db_column: budget_adjust_date
     */
    private java.util.Date budgetAdjustDate;
    /**
     * 预算调整总金额（根据预算明细计算）       db_column: budget_adjust_amt
     */
    private Double budgetAdjustAmt;
    /**
     * 预算调整毛利润额       db_column: budget_adjust_profit
     */
    private Double budgetAdjustProfit;
    /**
     * 预算调整毛利润率       db_column: budget_adjust_profit_rate
     */
    private Double budgetAdjustProfitRate;
    /**
     * 结项人id       db_column: closing_user_id
     */
    private Integer closingUserId;
    /**
     * 结项人姓名       db_column: closing_user_name
     */
    private String closingUserName;
    /**
     * 结项时间       db_column: closing_date
     */
    private java.util.Date closingDate;
    /**
     * 结项状态       db_column: closing_status
     */
    private Integer closingStatus;
    /**
     * 结项备注       db_column: closing_remarks
     */
    private String closingRemarks;
    /**
     * 是否是存续项目       db_column: is_sur
     */
    private String isSur;
    /**
     * 工程收入金额       db_column: pro_income_amt
     */
    private Double proIncomeAmt;
    /**
     * 工程成本金额       db_column: pro_cost_amt
     */
    private Double proCostAmt;
    /**
     * 账面收入       db_column: bo_amt_dr
     */

    private Double boAmtDr;
    /**
     * 账面成本       db_column: bo_amt_cr
     */
    private Double boAmtCr;
    /**
     * 账面毛利额       db_column: bo_amt_profit
     */
    private Double boAmtProfit;
    /**
     * 账面毛利额率       db_column: bo_amt_profit_rate
     */
    private Double boAmtProfitRate;
    /**
     * 总包预估金额       db_column: estimated_amt
     */
    private Double estimatedAmt;
    /**
     * 已开发票金额       db_column: sub_inv_amt_cr
     */
    private Double subInvAmtCr;
    /**
     * 未开发票金额       db_column: sub_inv_amt_blc
     */
    private Double subInvAmtBlc;
    /**
     * 已收款金额       db_column: sub_amt_dr
     */
    private Double subAmtDr;
    /**
     * 剩余应收金额       db_column: sub_amt_blc
     */
    private Double subAmtBlc;
    /**
     * 结算金额       db_column: settlement_amt
     */
    private Double settlementAmt;
    /**
     * 立项时间       db_column: create_project_date
     */
    private java.util.Date createProjectDate;

    /**
     * 项目类型（对应 1，2，3级）       db_column: project_type
     */
    private Integer projectType;

    /**
     * 工程成本金额       db_column: project_cost
     */
    private Double projectCost;

    /**
     * 工程毛利额       db_column: project_profit
     */
    private Double projectProfit;

    /**
     * 工程毛利率       db_column: project_profit_rate
     */
    private Double projectProfitRate;

    /**
     * 存续项目状态（1新建 2暂存 6提交）       db_column: renew_project_status
     */
    private Integer renewProjectStatus;

    /**
     * 合同金额（合同金额 / 合同审定金额）       db_column: amt
     */
    private Double amt;

    /**
     * 税率（合同税率 / 合同审定税率）       db_column: tax_rate
     */
    private Double taxRate;

    /**
     * 子项目里程碑状态 (1待处理 6已完成）      db_column: project_steps_status
     */
    private Integer projectStepsStatus;

    /**
     * 子项目进度状态(1未完成 6已完成)      db_column: pro_current_status
     */
    private Integer proCurrentStatus;
    /**
     * 竣工30天提醒      db_column: completion_reminder
     */
    private Integer completionReminder;

    /**
     * 修改原因
     */
    private String modifyReason;
    /**
     * 修改次数
     */
    private Integer modifyCount;

    /**
     * 备注
     */
    private String mainRemarks;
//columns END
}
