
package io.platform.project.service.client.api;

import com.baomidou.mybatisplus.plugins.Page;

import java.util.List;
import java.util.Map;

import io.platform.base.common.utils.ExecuteResult;
import io.platform.project.dto.ProcessBillsDto;
import io.platform.project.dto.ProjectBillsSubsDto;
import io.platform.sys.dto.SysUserDto;
import org.springframework.web.bind.annotation.RequestBody;

/**
 * Created by sevelli on 2017/8/31.
 */
public interface ProcessBillsServiceClient {
    /**
     * 根据ID 查询单个对象
     */
    ProcessBillsDto queryObject(Long id);

    /**
     * 根据参数查询 列表  无分页
     */
    List<ProcessBillsDto> queryList(Map<String, Object> map);

    /**
     * 根据参数查询 对应参数的 集合大小
     */
    int queryTotal(Map<String, Object> map);

    /**
     * 保存对象
     */
    ExecuteResult<String> save(ProcessBillsDto processBillsDto);

    /**
     * 更新对象
     */
    ExecuteResult<String> update(ProcessBillsDto processBillsDto);

    /**
     * 根据主键 删除对象
     */
    ExecuteResult<String> delete(Long id);

    /**
     * 根据主键集合 批量删除
     */
    ExecuteResult<String> deleteBatch(List<Long> idList);

    /**
     * 根据分页参数 获取 分页集合
     */
    Map<String, Object> getPage(@RequestBody Map<String, Object> map);

    /**
     * 查询项目进度
     */
    Map<String, Object> changeFuzzyQueryProjectSub(ProjectBillsSubsDto projectBillsSubsDto);

    /**
     * 暂存
     */
    ExecuteResult<String> processTemporary(String process, String processSteps, SysUserDto sysUserDto);

    /**
     * 查询暂存
     */
    Map<String, Object> queryDataTemporary(ProcessBillsDto processBillsDto);

    /**
     * 提交
     */
    ExecuteResult<String> processSave(String process, String processSteps, SysUserDto sysUserDto);

    /**
     * 模糊查询 维护记录
     */
    Map<String, Object> fuzzyQueryProcess(Page pageDto, ProcessBillsDto processBillsDto);

    /**
     * 查询开工申报表
     */
    String queryProjectStartAttach(ProjectBillsSubsDto projectBillsSubsDto);

    /**
     * 查询项目维护进度
     */
    Map<String, Object> queryProcessValue(Integer id, SysUserDto sysUserDto);

    Map<String, Object> selectProjectProcessData(Integer id);
}
