
package io.platform.project.service.client.api;


import com.baomidou.mybatisplus.plugins.Page;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.project.dto.ProjectBillsStepsAdjustDto;

import java.util.List;
import java.util.Map;

/**
 * Created by sevelli on 2017/8/31.
 */
public interface ProjectBillsStepsAdjustServiceClient {
    /**
     * 根据ID 查询单个对象
     */
    ProjectBillsStepsAdjustDto queryObject(Long id);

    /**
     * 根据参数查询 列表  无分页
     */
    List<ProjectBillsStepsAdjustDto> queryList(Map<String, Object> map);

    /**
     * 根据参数查询 对应参数的 集合大小
     */
    int queryTotal(Map<String, Object> map);

    /**
     * 保存对象
     */
    ExecuteResult<String> save(ProjectBillsStepsAdjustDto projectBillsStepsAdjustDto);

    /**
     * 更新对象
     */
    ExecuteResult<String> update(ProjectBillsStepsAdjustDto projectBillsStepsAdjustDto);

    /**
     * 根据主键 删除对象
     */
    ExecuteResult<String> delete(Long id);

    /**
     * 根据主键集合 批量删除
     */
    ExecuteResult<String> deleteBatch(List<Long> idList);

    /**
     * 根据分页参数 获取 分页集合
     */
    Page<ProjectBillsStepsAdjustDto> getPage(Page<ProjectBillsStepsAdjustDto> page, ProjectBillsStepsAdjustDto projectBillsStepsAdjustDto);

    /**
     * 模糊查询
     *
     * @param projectBillsStepsAdjustDto
     * @return
     */
    Map<String, Object> fuzzyQueryProjectAdjust(Page page, ProjectBillsStepsAdjustDto projectBillsStepsAdjustDto);

    Map<String, Object> selectSubCount();
}
