
package io.platform.project.service.client.api;

import com.baomidou.mybatisplus.plugins.Page;

import java.util.List;
import java.util.Map;

import io.platform.base.common.utils.ExecuteResult;
import io.platform.project.dto.ProjectBillsStepsAdjustDto;
import io.platform.project.dto.ProjectBillsStepsDto;
import io.platform.project.dto.ProjectBillsSubsDto;
import io.platform.project.dto.ProjectbillsDto;
import io.platform.sys.dto.SysUserDto;

/**
 * Created by sevelli on 2017/8/31.
 */
public interface ProjectBillsStepsServiceClient {
    /**
     * 根据ID 查询单个对象
     */
    ProjectBillsStepsDto queryObject(Long id);

    /**
     * 根据参数查询 列表  无分页
     */
    List<ProjectBillsStepsDto> queryList(Map<String, Object> map);

    /**
     * 根据参数查询 对应参数的 集合大小
     */
    int queryTotal(Map<String, Object> map);

    /**
     * 保存对象
     */
    ExecuteResult<String> save(String projectBillsContract, String projectBillsStls);

    /**
     * 更新对象
     */
    ExecuteResult<String> update(String projectBillsContract, String projectBillsStls);

    /**
     * 根据主键 删除对象
     */
    ExecuteResult<String> delete(Long id);

    /**
     * 根据主键集合 批量删除
     */
    ExecuteResult<String> deleteBatch(List<Long> idList);

    /**
     * 根据分页参数 获取 分页集合
     */
    Page<ProjectBillsStepsDto> getPage(Page<ProjectBillsStepsDto> page, ProjectBillsStepsDto projectBillsStepsDto);

    /**
     * 根据单号查询
     *
     * @param projectbillsDto
     * @return
     */
    Map<String, Object> numberQueryContract(ProjectBillsSubsDto projectbillsDto, SysUserDto sysUserDto);

    /**
     * 暂存
     */
    ExecuteResult<String> projectStepTemporary(String projectBillsContract, String projectBillsStls, SysUserDto sysUserDto);

    /**
     * 提交
     */
    ExecuteResult<String> projectStepSave(String projectBillsContract, String projectBillsStls, SysUserDto sysUserDto);

    /**
     * 编辑提交
     */
    ExecuteResult<String> editMilestoneSave(List<ProjectBillsStepsAdjustDto> projectBillsStepsDtos, SysUserDto sysUserDto);

    /**
     * 查询修改记录
     */
    Map<String, Object> queryRecords(ProjectBillsStepsAdjustDto projectBillsStepsAdjustDto);

    String processStepsSave(String item, SysUserDto sysUserDto);

    Page<ProjectBillsSubsDto> selectProjectSubDataList(Page<ProjectBillsSubsDto> page,ProjectBillsSubsDto projectBillsSubsDto,SysUserDto sysUserDto);
}
