
package io.platform.project.service.client.api;

import com.baomidou.mybatisplus.plugins.Page;

import java.util.List;
import java.util.Map;

import io.platform.base.common.utils.ExecuteResult;
import io.platform.budget.dto.ProjectBillsBudgetsDto;
import io.platform.project.dto.ProjectBillsSubsDto;
import io.platform.sys.dto.SysUserDto;

/**
 * Created by sevelli on 2017/8/31.
 */
public interface ProjectBillsSubsServiceClient {
    /**
     * 根据ID 查询单个对象
     */
    ProjectBillsSubsDto queryObject(Long id);

    /**
     * 根据参数查询 列表  无分页
     */
    List<ProjectBillsSubsDto> queryList(Map<String, Object> map);

    /**
     * 根据参数查询 对应参数的 集合大小
     */
    int queryTotal(Map<String, Object> map);

    /**
     * 保存对象
     */
    ExecuteResult<String> save(ProjectBillsSubsDto projectBillsSubsDto);

    /**
     * 更新对象
     */
    ExecuteResult<String> update(ProjectBillsSubsDto projectBillsSubsDto);

    /**
     * 根据主键 删除对象
     */
    ExecuteResult<String> delete(Long id);

    /**
     * 根据主键集合 批量删除
     */
    ExecuteResult<String> deleteBatch(List<Long> idList);

    /**
     * 根据分页参数 获取 分页集合
     */
    Map<String, Object> getPage(Map<String, Object> map, SysUserDto sysUserDto);

    /**
     * 暂存
     */
    ExecuteResult<String> projectSubTemporary(List<ProjectBillsSubsDto> projectBillsSubsDto);

    /**
     * 模糊查询
     */
    Map<String, Object> fuzzyQueryProjectSubs(Page page, ProjectBillsSubsDto projectBillsSubsDto);

    /**
     * 条件查询
     */
    Map<String, Object> conditionalQueryProjectSubs(Page page, ProjectBillsSubsDto projectBillsSubsDto);

    /**
     * 查询总包结算过子项目
     */
    Map<String, Object> querySettlementProjectSubs(Page page, ProjectBillsSubsDto projectBillsSubsDto);

    Map<String, Object> queryProjectSummaryData(ProjectBillsSubsDto projectBillsSubsDto);

    Map<String, Object> getProSummaryPage(Map<String, Object> map,SysUserDto sysUserDto);

    Page<ProjectBillsSubsDto> purchaseSubPage(Page<ProjectBillsSubsDto> page, ProjectBillsSubsDto projectBillsSubsDto,SysUserDto sysUserDto);

    Map<String, Object> projectBalancePage(Map<String, Object> params,SysUserDto sysUserDto);

    Map<String, Object> queryPayInvoiceVal(Page page, ProjectBillsBudgetsDto projectBillsBudgetsDto,SysUserDto sysUserDto);

    Map<String, Object> getEngineeringPage(Page page, ProjectBillsSubsDto projectBillsSubsDto,SysUserDto sysUserDto);

    List<Map<String, Object>> engineeringExportExcel(ProjectBillsSubsDto projectBillsSubsDto);

    Page<ProjectBillsSubsDto> selectSubPage(Page<ProjectBillsSubsDto> page, ProjectBillsSubsDto projectBillsSubsDto,SysUserDto sysUserDto);

    Map<String, Object> queryProjectBillsSubs(ProjectBillsSubsDto projectBillsSubsDto);

    Map<String, Object> moneySettlementPage(Map<String, Object> params, SysUserDto sysUserDto);

    Map<String, Object> queryClosingVal(Integer integer, SysUserDto sysUserDto);

    List<Map<String, Object>> subsistingExportExcel(ProjectBillsSubsDto projectBillsSubsDto, SysUserDto sysUserDto);
}
