
package io.platform.project.service.client.api;

import java.util.List;
import java.util.Map;

import com.baomidou.mybatisplus.plugins.Page;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.budget.dto.ProjectBillsBudgetsDto;
import io.platform.approvalConfiguration.dto.AuditItemsDto;
import io.platform.moneyManagement.dto.InvoiceBillsDto;
import io.platform.project.dto.ProjectBS;
import io.platform.project.dto.ProjectBillsSubsDto;
import io.platform.project.dto.ProjectbillsDto;
import io.platform.sys.dto.SysUserDto;

/**
 * Created by sevelli on 2017/8/31.
 */
public interface ProjectbillsServiceClient {
    /**
     * 根据ID 查询单个对象
     */
    ProjectbillsDto queryObject(Long id);

    /**
     * 根据参数查询 对应参数的 集合大小
     */
    int queryTotal(Map<String, Object> map);

    /**
     * 保存对象
     */
    ExecuteResult<String> save(String projectBillsContract, String projectBillsStls, SysUserDto sysUserDto);

    /**
     * 暂存对象
     */
    ExecuteResult<String> temporary(String projectBillsContract, String projectBillsStls, String attachs, SysUserDto sysUserDto);

    /**
     * 更新对象
     */
    ExecuteResult<String> update(String projectBillsContract, String projectBillsStls, SysUserDto sysUserDto);

    /**
     * 根据主键 删除对象
     */
    ExecuteResult<String> delete(Long id);

    /**
     * 根据主键集合 批量删除
     *
     * @param projectbillsDto
     */
    ExecuteResult<String> deleteContract(ProjectbillsDto projectbillsDto);

    /**
     * 根据分页参数 获取 分页集合
     */
    Map<String, Object> getPage(Map<String, Object> map, SysUserDto sysUserDto);

    /**
     * 根据分页参数 获取 分页集合
     */
    Map<String, Object> tkPage(Map<String, Object> map, SysUserDto sysUserDto);

    /**
     * 暂存 数据
     */
    ExecuteResult<String> projectBillsTemporary(String project, String proSubs, SysUserDto sysUserDto);

    /**
     * 立项提交
     */
    ExecuteResult<String> projectBillsUpdate(String project, String proSubs, SysUserDto sysUserDto);

    /**
     * 查询开工信息
     */
    Map<String, Object> pageStart(Map<String, Object> map, SysUserDto sysUserDto);

    /**
     * 查询开工信息
     */
    Map<String, Object> queryProStartDateInformation(ProjectbillsDto projectbillsDto);

    /**
     * 提交开工日期
     */
    ExecuteResult<String> projectStartUpdate(ProjectbillsDto projectbillsDto, SysUserDto sysUserDto);

    /**
     * 查询总包结算
     */
    Map<String, Object> queryTurnkeySettlement(ProjectbillsDto projectbillsDto);

    /**login
     * 总包结算记账
     */
    ExecuteResult<String> turnkeySettlementSave(String projectbill, String projectSubs, String projectAttachs, SysUserDto sysUserDto);

    /**
     * 提交
     */
    ExecuteResult<String> contractSave(String projectBillsContract, String projectBillsStls, String attachs, SysUserDto sysUserDto);

    /**
     * 查询立项信息
     */
    Map<String, Object> queryProjectBills(ProjectbillsDto projectbillsDto);

    /**
     * 查询项目结项信息
     */
    List<ProjectBillsBudgetsDto> queryProjectBalance(ProjectbillsDto projectbillsDto);

    /**
     * 提交结项信息
     */
    ExecuteResult<String> projectBalanceSave(ProjectBS projectBS, SysUserDto sysUserDto, String billsBudgets);

    /**
     * 查询立项信息提醒
     */
    Map<String, Object> queryProjectWarning();

    /**
     * 查询总包暂存数据
     */
    Map<String, Object> queryContractTemporary(ProjectbillsDto projectbillsDto);

    ExecuteResult<String> survivingProjectsTemporary(String projectBills, String projects, String costSituation, String projectBudgets, SysUserDto sysUserDto);

    ExecuteResult<String> survivingProjectsSave(String projectBills, String projects, String costSituation, String projectBudgets, SysUserDto sysUserDto);

    /**
     * 查询续存信息
     */
    Map<String, Object> getPageSurvivingPro(Map<String, Object> map);

    /**
     * 查询续存项目暂存信息
     */
    Map<String, Object> querySurvivingProTemporary(ProjectbillsDto projectbillsDto);


    ExecuteResult<String> survivingProjectsModifyCommit(String projectBills, String projects, String costSituation, String projectBudgets,
                                                        String backupData, SysUserDto sysUserDto);

    Map<String, Object> getRenewPage(Map<String, Object> map, SysUserDto sysUserDto);

    Map<String, Object> proBalanceVal(ProjectBillsSubsDto projectBillsSubsDto);

    Map<String, Object> queryProjectSumPayCr(ProjectbillsDto projectbillsDto);

    Map<String, Object> settlementPage(Map<String, Object> map, SysUserDto sysUserDto);

    ExecuteResult<String> completionReminderRead(ProjectbillsDto projectbillsDto);

    Map<String, Object> queryPending(Map<String, Object> maps, SysUserDto sysUserDto);

    Map<String, Object> queryPendingProjectId(AuditItemsDto auditItemsDto);

    Map<String, Object> projectEndQueryPendingVal(ProjectbillsDto projectbillsDto);

    ExecuteResult<String> approved(AuditItemsDto auditItemsDto, SysUserDto sysUserDto);

    ExecuteResult<String> approvalRejected(AuditItemsDto auditItemsDto, SysUserDto sysUserDto);

    Map<String, Object> getHomeProList(Map<String, Object> map, SysUserDto sysUserDto);

    Page selectAllWarningsCurrent(Page pageDto, ProjectbillsDto projectbillsDto, SysUserDto sysUserDto);

    ExecuteResult<String> projectSettlerSave(ProjectBS projectBS, SysUserDto sysUserDto);

    Map<String, Object> queryTurnkeyExistingBillVal(Integer id);

    ExecuteResult<String> updateBilling(String from, String list, String edit, SysUserDto sysUserDto);

    ExecuteResult<String> withdrawalApproval(ProjectBillsSubsDto projectBillsSubsDto);

    String getserialNum(String str);

    Page selectWarningMatters(Page page, ProjectbillsDto projectbillsDto, SysUserDto sysUserDto);

    Double selectSumPurchaseInvCr(InvoiceBillsDto invoiceBillsDto, SysUserDto sysUserDto);

    ExecuteResult<String> contractAdminSave(String projectBillsContract, String projectBillsStls, String attachs, SysUserDto sysUserDto);
}
