
package io.platform.project.service.client.api;

import com.baomidou.mybatisplus.plugins.Page;
import io.platform.project.dto.ProjectBillsSubsDto;
import io.platform.project.dto.SubContractBillsDto;

import java.util.List;
import java.util.Map;

import io.platform.base.common.utils.ExecuteResult;
import io.platform.sys.dto.SysUserDto;

/**
 * Created by sevelli on 2017/8/31.
 */
public interface SubContractBillsServiceClient {
    /**
     * 根据ID 查询单个对象
     */
    SubContractBillsDto queryObject(Long id);

    /**
     * 根据参数查询 列表  无分页
     */
    List<SubContractBillsDto> queryList(Map<String, Object> map);

    /**
     * 根据参数查询 对应参数的 集合大小
     */
    int queryTotal(Map<String, Object> map);

    /**
     * 保存对象
     */
    ExecuteResult<String> save(SubContractBillsDto subContractBillsDto);

    /**
     * 更新对象
     */
    ExecuteResult<String> update(SubContractBillsDto subContractBillsDto);

    /**
     * 根据主键 删除对象
     */
    ExecuteResult<String> delete(Long id);

    /**
     * 根据主键集合 批量删除
     */
    ExecuteResult<String> deleteBatch(List<Long> idList);

    /**
     * 根据分页参数 获取 分页集合
     */
    Page<SubContractBillsDto> getPage(Page<SubContractBillsDto> page, SubContractBillsDto subContractBillsDto,SysUserDto sysUserDto);

    Map<String, Object> selectAll(ProjectBillsSubsDto projectBillsSubsDto);

    /**
     * 分包合同提交
     */
    ExecuteResult<String> subContractSave(String from,String item, String list, SysUserDto sysUserDto);

    /**
     * 分包合同暂存
     */
    ExecuteResult<String> subContractTemporary(String from,String item, String list, SysUserDto sysUserDto);

    /**
     * 查询分包记录信息
     */
    Map<String, Object> querySubContractTemporary(SubContractBillsDto subContractBillsDto);

    /**
     * 分包结算查询
     */
    Map<String, Object> fuzzyQuerySubContracts(Page page, SubContractBillsDto subContractBillsDto);

    Map<String, Object> enineeringPage(Page page, SubContractBillsDto subContractBillsDto);

    Map<String, Object> selectFormData(Integer id,String subNo,SysUserDto sysUserDto);

    String saveSubContract(String list,String subNo, SysUserDto sysUserDto);

    Map<String, Object>  selectProjectSubBills(SubContractBillsDto subContractBillsDto);

    List<Map<String, Object>> selectRenewRecordNew(ProjectBillsSubsDto projectBillsSubsDto);

    double getPrepayments(Integer id);

    ExecuteResult<String> selectPaymentInformation(SubContractBillsDto subContractBillsDto);
}
