
package io.platform.projectSettlement.service.client.api;

import com.baomidou.mybatisplus.plugins.Page;

import java.util.List;
import java.util.Map;

import io.platform.base.common.utils.ExecuteResult;
import io.platform.projectSettlement.dto.ProjectAnnexDto;

/**
 * Created by sevelli on 2017/8/31.
 */
public interface ProjectAnnexServiceClient {
    /**
     * 根据ID 查询单个对象
     */
    ProjectAnnexDto queryObject(Long id);

    /**
     * 根据参数查询 列表  无分页
     */
    List<ProjectAnnexDto> queryList(Map<String, Object> map);

    /**
     * 根据参数查询 对应参数的 集合大小
     */
    int queryTotal(Map<String, Object> map);

    /**
     * 保存对象
     */
    ExecuteResult<String> save(ProjectAnnexDto projectAnnexDto);

    /**
     * 更新对象
     */
    ExecuteResult<String> update(ProjectAnnexDto projectAnnexDto);

    /**
     * 根据主键 删除对象
     */
    ExecuteResult<String> delete(Long id);

    /**
     * 根据主键集合 批量删除
     */
    ExecuteResult<String> deleteBatch(List<Long> idList);

    /**
     * 根据分页参数 获取 分页集合
     */
    Page<ProjectAnnexDto> getPage(Page<ProjectAnnexDto> page, ProjectAnnexDto projectAnnexDto);
}
