
package io.platform.projectSettlement.service.client.api;

import com.baomidou.mybatisplus.plugins.Page;

import java.util.List;
import java.util.Map;

import io.platform.base.common.utils.ExecuteResult;
import io.platform.project.dto.ProjectBillsSubsDto;
import io.platform.project.dto.SubContractBillsDto;
import io.platform.projectSettlement.dto.ProjectStlBillsDto;
import io.platform.sys.dto.SysUserDto;

/**
 * Created by sevelli on 2017/8/31.
 */
public interface ProjectStlBillsServiceClient {
    /**
     * 根据ID 查询单个对象
     */
    ProjectStlBillsDto queryObject(Long id);

    /**
     * 根据参数查询 列表  无分页
     */
    List<ProjectStlBillsDto> queryList(Map<String, Object> map);

    /**
     * 根据参数查询 对应参数的 集合大小
     */
    int queryTotal(Map<String, Object> map);

    /**
     * 保存对象
     */
    ExecuteResult<String> save(ProjectStlBillsDto projectStlBillsDto);

    /**
     * 更新对象
     */
    ExecuteResult<String> update(ProjectStlBillsDto projectStlBillsDto);

    /**
     * 根据主键 删除对象
     */
    ExecuteResult<String> delete(Long id);

    /**
     * 根据主键集合 批量删除
     */
    ExecuteResult<String> deleteBatch(List<Long> idList);

    /**
     * 根据分页参数 获取 分页集合
     */
    Map<String, Object> proStlBillsPage(Map<String, Object> map);

    /**
     * 提交
     */
    ExecuteResult<String> projectStlSave(String projectStlBill, String projectStls, String dataAttachs, SysUserDto sysUserDto);

    /**
     * 查询 分包结算 信息
     */
    Map<String, Object> querySubContract(ProjectBillsSubsDto projectBillsSubsDto);

    /**
     * 查询暂存数据
     */
    Map<String, Object> fuzzyQueryPSTl(ProjectStlBillsDto projectStlBillsDto);
}
