package io.platform.purchase.dto;

import lombok.Data;

@Data
public class PurchaseBillsDto implements java.io.Serializable {
    private static final long serialVersionUID = 5454155825314635342L;


    /**
     * id       db_column: id
     */
    private Integer id;
    /**
     * 单据编号       db_column: bill_no
     */
    private String billNo;
    /**
     * 业务活动号ID       db_column: act_id
     */
    private Integer actId;
    /**
     * 来源活动ID       db_column: src_act_id
     */
    private Integer srcActId;
    /**
     * 来源单据编号       db_column: src_bill_no
     */
    private String srcBillNo;
    /**
     * 来源行号       db_column: src_line_no
     */
    private Integer srcLineNo;
    /**
     * 原始活动ID       db_column: org_act_id
     */
    private Integer orgActId;
    /**
     * 原始编号       db_column: org_bill_no
     */
    private String orgBillNo;
    /**
     * 原始行号       db_column: org_line_no
     */
    private Integer orgLineNo;
    /**
     * 单据状态（1-新建2处理中6完成）       db_column: bill_status
     */
    private Integer billStatus;
    /**
     * 制单人ID       db_column: op_user_id
     */
    private Integer opUserId;
    /**
     * 制单人姓名       db_column: op_user_name
     */
    private String opUserName;
    /**
     * 制单日期       db_column: create_date
     */
    private java.util.Date createDate;
    /**
     * 业务日期       db_column: bill_date
     */
    private java.util.Date billDate;
    /**
     * 提交日期       db_column: post_date
     */
    private java.util.Date postDate;
    /**
     * 备注       db_column: remark
     */
    private String remark;
    /**
     * 计划编号或采购编号       db_column: purchase_no
     */
    private String purchaseNo;
    /**
     * 工程编号（下拉选择）       db_column: project_no
     */
    private String projectSubNo;
    /**
     * 本次占用预算金额       db_column: amt
     */
    private Double amt;
    /**
     * 材料预算金额       db_column: budget_amt
     */
    private Double budgetAmt;
    /**
     * 累计占用预算金额       db_column: budget_use_amt
     */
    private Double budgetUseAmt;
    /**
     * 剩余预算金额       db_column: budget_blc_amt
     */
    private Double budgetBlcAmt;
    /**
     * 采购方式ID（基础资料B_PurchaseMode）       db_column: purchase_mode_id
     */
    private Integer purchaseModeId;
    /**
     * 采购方式选择理由       db_column: purchase_mode_desc
     */
    private String purchaseModeDesc;
    /**
     * 是否客户指定       db_column: if_corp_assign
     */
    private String ifCorpAssign;
    /**
     * 单一来源采购详细说明       db_column: corp_assign_desc
     */
    private String corpAssignDesc;
    /**
     * 供应商ID       db_column: purchase_id
     */
    private Integer purchaseId;
    /**
     * 计划类型
     */
    private Integer purchaseSrcId;
    /***
     * 附件地址
     */
    private String fileAddress;
    /***
     *  申请单位
     */
    private Integer contractorId;
//columns END

}
