
package io.platform.purchase.service.client.api;

import com.baomidou.mybatisplus.plugins.Page;
import io.platform.engineering.dto.BpurchasesDto;
import io.platform.project.dto.ProjectBillsSubsDto;
import io.platform.purchase.dto.PurchaseBillsDto;
import io.platform.purchase.dto.PurchaseBillsItemsDto;

import java.util.List;
import java.util.Map;

import io.platform.base.common.utils.ExecuteResult;
import io.platform.sys.dto.SysUserDto;

/**
 * Created by sevelli on 2017/8/31.
 */
public interface PurchaseBillsItemsServiceClient{
        /**
         * 根据ID 查询单个对象
         */
        PurchaseBillsItemsDto queryObject(Long id);
        /**
         * 根据参数查询 列表  无分页
         */
        List<PurchaseBillsItemsDto>queryList(Map<String, Object> map);
        /**
         * 根据参数查询 对应参数的 集合大小
         */
        int queryTotal(Map<String, Object> map);
        /**
         * 保存对象
         */
        ExecuteResult<String> save(PurchaseBillsItemsDto purchaseBillsItemsDto);
        /**
         * 更新对象
         */
        ExecuteResult<String> update(PurchaseBillsItemsDto purchaseBillsItemsDto);
        /**
         * 根据主键 删除对象
         */
        ExecuteResult<String> delete(Long id);
        /**
         * 根据主键集合 批量删除
         */
        ExecuteResult<String> deleteBatch(List<Long> idList);
        /**
         * 根据分页参数 获取 分页集合
         */
        Page<PurchaseBillsItemsDto>getPage(Page<PurchaseBillsItemsDto>page,PurchaseBillsItemsDto purchaseBillsItemsDto);

        ExecuteResult<String> deleteItem(PurchaseBillsItemsDto purchaseBillsItemsDto);

        Map<String,Object> maintenancePage(Page<PurchaseBillsItemsDto> page, PurchaseBillsItemsDto purchaseBillsItemsDto,String list);

    List<PurchaseBillsItemsDto> selectArrivalSum(List<PurchaseBillsItemsDto> list);

        Map<String,Object> selectProjectResult(String sub);

    Page<PurchaseBillsDto> selectList(Page<PurchaseBillsDto> page, PurchaseBillsDto purchaseBillsDto,SysUserDto sysUserDto);

    Map<String, Object> selectSrcType(String mingxi);

    ExecuteResult<String> saveResultItem(String mingxi, SysUserDto sysUserDto);

    Page<BpurchasesDto> selectResultPurchase(Page<BpurchasesDto> page, ProjectBillsSubsDto projectBillsSubsDto, SysUserDto sysUserDto);
}
