
package io.platform.purchase.service.client.api;

import com.baomidou.mybatisplus.plugins.Page;
import io.platform.purchase.dto.PurchaseBillsDto;
import io.platform.purchase.dto.PurchaseBillsProjsDto;

import java.util.List;
import java.util.Map;

import io.platform.base.common.utils.ExecuteResult;
import io.platform.purchase.dto.PurchaseBillsPuridsDto;
import io.platform.sys.dto.SysUserDto;

/**
 * Created by sevelli on 2017/8/31.
 */
public interface PurchaseBillsProjsServiceClient {
    /**
     * 根据ID 查询单个对象
     */
    PurchaseBillsProjsDto queryObject(Long id);

    /**
     * 根据参数查询 列表  无分页
     */
    List<PurchaseBillsProjsDto> queryList(Map<String, Object> map);

    /**
     * 根据参数查询 对应参数的 集合大小
     */
    int queryTotal(Map<String, Object> map);

    /**
     * 保存对象
     */
    ExecuteResult<String> save(PurchaseBillsProjsDto purchaseBillsProjsDto);

    /**
     * 更新对象
     */
    ExecuteResult<String> update(PurchaseBillsProjsDto purchaseBillsProjsDto);

    /**
     * 根据主键 删除对象
     */
    ExecuteResult<String> delete(Long id);

    /**
     * 根据主键集合 批量删除
     */
    ExecuteResult<String> deleteBatch(List<Long> idList);

    /**
     * 根据分页参数 获取 分页集合
     */
    Map<String, Object> getPage(Page<PurchaseBillsProjsDto> page, PurchaseBillsProjsDto purchaseBillsProjsDto, SysUserDto sysUserDto);

    String saveWork(String from, String list, String supper, SysUserDto sysUserDto);

    String updateWork(String from, String list, String supper);

    /**
     * 模糊查询分包计划明细
     */
    Map<String, Object> fuzzyQueryPurProjs(Page page, PurchaseBillsProjsDto purchaseBillsProjsDto);

    /**
     * 选择分包计划明细查询
     */
    Map<String, Object> changeFuzzyQueryPurProjs(PurchaseBillsProjsDto purchaseBillsProjsDto);

    Map<String, Object> selectItem(String billNo);

    Map<String, Object> editItem(String id);

    String saveProItem(String purchaseBillsDto);

    String adminSaveProItem(String purchaseBillsDto);

    Map<String, Object> selectProItem(String id);

    void deleteSupplier(Integer id);

    Map<String, Object> selectProItemPurids(Integer id);

    String savePurchasePro(String from, String list, SysUserDto sysUserDto);

    String updatePurchasePro(String from, String list);
}
