
package io.platform.purchase.service.client.api;

import com.baomidou.mybatisplus.plugins.Page;
import io.platform.purchase.dto.PurchaseBillsDto;

import java.util.List;
import java.util.Map;

import io.platform.base.common.utils.ExecuteResult;
import io.platform.sys.dto.SysUserDto;

/**
 * Created by sevelli on 2017/8/31.
 */
public interface PurchaseBillsServiceClient {
    /**
     * 根据ID 查询单个对象
     */
    PurchaseBillsDto queryObject(Long id);

    /**
     * 根据参数查询 列表  无分页
     */
    List<PurchaseBillsDto> queryList(Map<String, Object> map);

    /**
     * 根据参数查询 对应参数的 集合大小
     */
    int queryTotal(Map<String, Object> map);

    /**
     * 保存对象
     */
    ExecuteResult<String> save(PurchaseBillsDto purchaseBillsDto);

    /**
     * 更新对象
     */
    ExecuteResult<String> update(PurchaseBillsDto purchaseBillsDto);

    /**
     * 根据主键 删除对象
     */
    ExecuteResult<String> delete(Long id);

    /**
     * 根据主键集合 批量删除
     */
    ExecuteResult<String> deleteBatch(PurchaseBillsDto purchaseBillsDto);

    /**
     * 根据分页参数 获取 分页集合
     */
    Page<PurchaseBillsDto> getPage(Page<PurchaseBillsDto> page, PurchaseBillsDto purchaseBillsDto);

    String materialDemand(String purchaseBillsDto, String list, SysUserDto sysUserDto);

    String zancun(String purchaseBillsDto, String billsItemsDtos);

    String over(String from, String list);

    Map<String, Object> getItem(String billNo, SysUserDto sysUserDto);

    String saveOne(String from, String list, SysUserDto sysUserDto, String attach);

    String saveTwo(String from, String list, String supplierList, SysUserDto sysUserDto, String attach);

    Map<String, Object> onceAgain(Integer id);

    String temporaryOne(String from, String list, SysUserDto sysUserDto, String attach);

    String temporaryTwo(String from, String list, String supplierList, String attach, SysUserDto sysUserDto);

    Map<String, Object> getResultItem(String billNo, String zbNo);

    Map<String, Object> selectPurchaseTypes();

    ExecuteResult<String> deleteTender(PurchaseBillsDto purchaseBillsDto, SysUserDto sysUserDto);

    ExecuteResult<String> deleteFrame(PurchaseBillsDto purchaseBillsDto, SysUserDto sysUserDto);

    String upLedger(String from, String list);

    Map<String, Object> selectContractor(SysUserDto sysUserDto);

    String saveSingle(String from, String list, SysUserDto sysUserDto, String attach);

    ExecuteResult<String> deletePurchase(PurchaseBillsDto purchaseBillsDto);
}
