
package io.platform.tasklistsHistory.service.client.api;

import com.baomidou.mybatisplus.plugins.Page;

import java.util.List;
import java.util.Map;

import io.platform.base.common.utils.ExecuteResult;
import io.platform.tasklistsHistory.dto.TasklistsHistoryDto;

/**
 * Created by sevelli on 2017/8/31.
 */
public interface TasklistsHistoryServiceClient{
        /**
         * 根据ID 查询单个对象
         */
        TasklistsHistoryDto queryObject(Long id);
        /**
         * 根据参数查询 列表  无分页
         */
        List<TasklistsHistoryDto>queryList(Map<String, Object> map);
        /**
         * 根据参数查询 对应参数的 集合大小
         */
        int queryTotal(Map<String, Object> map);
        /**
         * 保存对象
         */
        ExecuteResult<String> save(TasklistsHistoryDto tasklistsHistoryDto);
        /**
         * 更新对象
         */
        ExecuteResult<String> update(TasklistsHistoryDto tasklistsHistoryDto);
        /**
         * 根据主键 删除对象
         */
        ExecuteResult<String> delete(Long id);
        /**
         * 根据主键集合 批量删除
         */
        ExecuteResult<String> deleteBatch(List<Long> idList);
        /**
         * 根据分页参数 获取 分页集合
         */
        Page<TasklistsHistoryDto>getPage(Page<TasklistsHistoryDto> page, TasklistsHistoryDto tasklistsHistoryDto);
}
