package io.platform.approvalConfiguration.biz.entity;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.enums.IdType;

import java.io.Serializable;

import lombok.Data;

@Data
@TableName("audit_items")
public class AuditItems extends Model<AuditItems> implements Serializable {
    private static final long serialVersionUID = 5454155825314635342L;


    /**
     * id       db_column: id
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

    /**
     * 单据编号       db_column: bill_no
     */
    @TableField("bill_no")
    private String billNo;

    /**
     * 活动号       db_column: act_id
     */
    @TableField("act_id")
    private Integer actId;

    /**
     * 审核路径名       db_column: path_id
     */
    @TableField("path_id")
    private Integer pathId;

    /**
     * 审核级次1.2.3       db_column: level_id
     */
    @TableField("level_id")
    private Integer levelId;

    /**
     * 是否是最后一级审核       db_column: iffinal_item
     */
    @TableField("iffinal_item")
    private String iffinalItem;

    /**
     * xx项目名       db_column: sub_ject
     */
    @TableField("sub_ject")
    private String subJect;

    /**
     * 工程编号       db_column: project_no
     */
    @TableField("project_no")
    private String projectNo;

    /**
     * NC工程编号       db_column: project_nc_no
     */
    @TableField("project_nc_no")
    private String projectNcNo;

    /**
     * 单位id       db_column: branch_id
     */
    @TableField("branch_id")
    private Integer branchId;

    /**
     * 请核人ID       db_column: send_user_id
     */
    @TableField("send_user_id")
    private Integer sendUserId;

    /**
     * 请核人姓名       db_column: send_name
     */
    @TableField("send_name")
    private String sendName;

    /**
     * 请核时间       db_column: send_time
     */
    @TableField("send_time")
    private java.util.Date sendTime;

    /**
     * 请核备注       db_column: send_msg
     */
    @TableField("send_msg")
    private String sendMsg;

    /**
     * 审核人ID       db_column: audit_user_id
     */
    @TableField("audit_user_id")
    private Integer auditUserId;

    /**
     * 审核通过时间       db_column: audit_item
     */
    @TableField("audit_item")
    private java.util.Date auditItem;

    /**
     * 审核意见       db_column: audit_msg
     */
    @TableField("audit_msg")
    private String auditMsg;

    /**
     * O提交、N未知状态、S待审、B审核退回、A审核通过       db_column: audit_status
     */
    @TableField("audit_status")
    private String auditStatus;
//columns END

}
