package io.platform.approvalConfiguration.biz.mapper;

import io.platform.approvalConfiguration.biz.entity.Audit;
import io.platform.approvalConfiguration.biz.entity.AuditPathsLevels;
import io.platform.base.common.BaseMapper;
import io.platform.approvalConfiguration.biz.entity.AuditItems;
import io.platform.project.dto.ProjectBillsSubsDto;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/9/6.
 */
@Mapper
public interface AuditItemsMapper extends BaseMapper<AuditItems> {


    int updateAuditStatus(@Param("aud") AuditItems at);

    int deleteUpLevelId(@Param("aud") AuditItems auditItem);

    int selectAuditItemTotal(@Param("hashMap") Map<String, Object> maps);

    List<Map<String, Object>> selectAuditItemRecords(@Param("hashMap") Map<String, Object> maps);

    List<AuditPathsLevels> queryAuditLevels(@Param("audit") Audit audit);

    List<Map<String, Object>> selectClsingAuditItems(@Param("id") Integer integer, @Param("contractorId") Integer loginContractorId);

    int deletePurchaseApproval(@Param("pro") ProjectBillsSubsDto projectBillsSubsDto);

    int deleteProSubsApproval(@Param("pro") ProjectBillsSubsDto projectBillsSubsDto);

    int deleteProjectApproval(@Param("pro") ProjectBillsSubsDto projectBillsSubsDto);

    int deleteInvoiceApproval(@Param("sub") ProjectBillsSubsDto projectBillsSubsDto);

    int deleteInvoiceIndirectApproval(@Param("sub") ProjectBillsSubsDto projectBillsSubsDto);

    int deletePayCrApproval(@Param("sub") ProjectBillsSubsDto projectBillsSubsDto);

    int deleteAdjusts(@Param("sub") ProjectBillsSubsDto projectBillsSubsDto);

    int deletePayCrUpLevelId(@Param("audit") AuditItems auditItem);

    List<AuditItems> selectAuditItems(@Param("map") Map<String, Object> map);

    int deleteInvoiceShareApproval(@Param("sub") ProjectBillsSubsDto projectBillsSubsDto);

    int deleteInvShareUpLevelId(@Param("aud") AuditItems auditItem);

    int updateInvShareAuditStatus(@Param("aud") AuditItems at);

    List<AuditItems> selectApprovedEvents(@Param("id") int intValue);
}
