
package io.platform.approvalConfiguration.impl;

import com.alibaba.dubbo.config.annotation.Service;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;


import io.platform.approvalConfiguration.biz.entity.AuditItemsUsers;
import io.platform.approvalConfiguration.biz.service.AuditItemsUsersService;
import io.platform.approvalConfiguration.dto.AuditItemsUsersDto;
import io.platform.approvalConfiguration.service.client.api.AuditItemsUsersServiceClient;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

import io.platform.base.common.BaseServiceClient;
import io.platform.base.common.utils.ExecuteResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Created by sevelli on 2017/8/31.
 */
@Component
@Service()
public class AuditItemsUsersServiceClientImpl extends BaseServiceClient<AuditItemsUsers, AuditItemsUsersDto> implements AuditItemsUsersServiceClient {
    private Logger logger = LoggerFactory.getLogger(getClass());
    @Resource
    private AuditItemsUsersService auditItemsUsersService;

    @Override
    public AuditItemsUsersDto queryObject(Long id) {
        AuditItemsUsers auditItemsUsers = auditItemsUsersService.selectById(id);
        AuditItemsUsersDto auditItemsUsersDto = new AuditItemsUsersDto();
        BeanUtils.copyProperties(auditItemsUsers, auditItemsUsersDto);
        return auditItemsUsersDto;
    }

    @Override
    public List<AuditItemsUsersDto> queryList(Map<String, Object> map) {
        List<AuditItemsUsers> auditItemsUsersList = auditItemsUsersService.selectByMap(map);
        return convertList(auditItemsUsersList, AuditItemsUsersDto.class);
    }

    @Override
    public int queryTotal(Map<String, Object> map) {
        EntityWrapper<AuditItemsUsers> ew = new EntityWrapper<>();
        ew.allEq(map);
        return auditItemsUsersService.selectCount(ew);
    }

    @Override
    public ExecuteResult<String> save(AuditItemsUsersDto auditItemsUsersDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            AuditItemsUsers auditItemsUsers = new AuditItemsUsers();
            revert(auditItemsUsersDto, auditItemsUsers);
            boolean flag = auditItemsUsersService.insert(auditItemsUsers);
            if (!flag) {
                result.addErrorMessage("保存失败。");
            }
        } catch (Exception e) {
            logger.error(" 保存错误：" + e.toString(), e);
            result.addErrorMessage("保存错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> update(AuditItemsUsersDto auditItemsUsersDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            AuditItemsUsers auditItemsUsers = new AuditItemsUsers();
            revert(auditItemsUsersDto, auditItemsUsers);

            boolean flag = auditItemsUsersService.updateById(auditItemsUsers);
            if (!flag) {
                result.addErrorMessage("更新失败。");
            }
        } catch (Exception e) {
            logger.error(" 更新错误：" + e.toString(), e);
            result.addErrorMessage("更新错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> delete(Long id) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = auditItemsUsersService.deleteById(id);
            if (!flag) {
                result.addErrorMessage("删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = auditItemsUsersService.deleteBatchIds(ids);
            if (!flag) {
                result.addErrorMessage("批量删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public Page<AuditItemsUsersDto> getPage(Page<AuditItemsUsersDto> pageDto, AuditItemsUsersDto auditItemsUsersDto) {
        Page<AuditItemsUsers> page = new Page<>(pageDto.getCurrent(), pageDto.getSize());
        page.setAsc(pageDto.isAsc());
        page.setOrderByField(pageDto.getOrderByField());
        page.setCondition(pageDto.getCondition());
        AuditItemsUsers auditItemsUsers = new AuditItemsUsers();
        revert(auditItemsUsersDto, auditItemsUsers);
        EntityWrapper<AuditItemsUsers> wrapper = new EntityWrapper<>();
        wrapper.setEntity(auditItemsUsers);
        page = auditItemsUsersService.selectPage(page, wrapper);
        List<AuditItemsUsersDto> auditItemsUsersDtoList = convertList(page.getRecords(), AuditItemsUsersDto.class);
        pageDto.setTotal(auditItemsUsersService.selectCount(wrapper));
        pageDto.setRecords(auditItemsUsersDtoList);
        return pageDto;
    }
}
