
package io.platform.approvalConfiguration.impl;

import com.alibaba.dubbo.config.annotation.Service;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;


import io.platform.approvalConfiguration.biz.entity.AuditPathsActsMould;
import io.platform.approvalConfiguration.biz.service.AuditPathsActsMouldService;
import io.platform.approvalConfiguration.dto.AuditPathsActsMouldDto;
import io.platform.approvalConfiguration.service.client.api.AuditPathsActsMouldServiceClient;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

import io.platform.base.common.BaseServiceClient;
import io.platform.base.common.utils.ExecuteResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Created by sevelli on 2017/8/31.
 */
@Component
@Service()
public class AuditPathsActsMouldServiceClientImpl extends BaseServiceClient<AuditPathsActsMould, AuditPathsActsMouldDto> implements AuditPathsActsMouldServiceClient {
    private Logger logger = LoggerFactory.getLogger(getClass());
    @Resource
    private AuditPathsActsMouldService auditPathsActsMouldService;

    @Override
    public AuditPathsActsMouldDto queryObject(Long id) {
        AuditPathsActsMould auditPathsActsMould = auditPathsActsMouldService.selectById(id);
        AuditPathsActsMouldDto auditPathsActsMouldDto = new AuditPathsActsMouldDto();
        BeanUtils.copyProperties(auditPathsActsMould, auditPathsActsMouldDto);
        return auditPathsActsMouldDto;
    }

    @Override
    public List<AuditPathsActsMouldDto> queryList(Map<String, Object> map) {
        List<AuditPathsActsMould> auditPathsActsMouldList = auditPathsActsMouldService.selectByMap(map);
        return convertList(auditPathsActsMouldList, AuditPathsActsMouldDto.class);
    }

    @Override
    public int queryTotal(Map<String, Object> map) {
        EntityWrapper<AuditPathsActsMould> ew = new EntityWrapper<>();
        ew.allEq(map);
        return auditPathsActsMouldService.selectCount(ew);
    }

    @Override
    public ExecuteResult<String> save(AuditPathsActsMouldDto auditPathsActsMouldDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            AuditPathsActsMould auditPathsActsMould = new AuditPathsActsMould();
            revert(auditPathsActsMouldDto, auditPathsActsMould);
            boolean flag = auditPathsActsMouldService.insert(auditPathsActsMould);
            if (!flag) {
                result.addErrorMessage("保存失败。");
            }
        } catch (Exception e) {
            logger.error(" 保存错误：" + e.toString(), e);
            result.addErrorMessage("保存错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> update(AuditPathsActsMouldDto auditPathsActsMouldDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            AuditPathsActsMould auditPathsActsMould = new AuditPathsActsMould();
            revert(auditPathsActsMouldDto, auditPathsActsMould);

            boolean flag = auditPathsActsMouldService.updateById(auditPathsActsMould);
            if (!flag) {
                result.addErrorMessage("更新失败。");
            }
        } catch (Exception e) {
            logger.error(" 更新错误：" + e.toString(), e);
            result.addErrorMessage("更新错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> delete(Long id) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = auditPathsActsMouldService.deleteById(id);
            if (!flag) {
                result.addErrorMessage("删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = auditPathsActsMouldService.deleteBatchIds(ids);
            if (!flag) {
                result.addErrorMessage("批量删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public Page<AuditPathsActsMouldDto> getPage(Page<AuditPathsActsMouldDto> pageDto, AuditPathsActsMouldDto auditPathsActsMouldDto) {
        Page<AuditPathsActsMould> page = new Page<>(pageDto.getCurrent(), pageDto.getSize());
        page.setAsc(pageDto.isAsc());
        page.setOrderByField(pageDto.getOrderByField());
        page.setCondition(pageDto.getCondition());
        AuditPathsActsMould auditPathsActsMould = new AuditPathsActsMould();
        revert(auditPathsActsMouldDto, auditPathsActsMould);
        EntityWrapper<AuditPathsActsMould> wrapper = new EntityWrapper<>();
        wrapper.setEntity(auditPathsActsMould);
        page = auditPathsActsMouldService.selectPage(page, wrapper);
        List<AuditPathsActsMouldDto> auditPathsActsMouldDtoList = convertList(page.getRecords(), AuditPathsActsMouldDto.class);
        pageDto.setTotal(auditPathsActsMouldService.selectCount(wrapper));
        pageDto.setRecords(auditPathsActsMouldDtoList);
        return pageDto;
    }
}
