
package io.platform.approvalConfiguration.impl;

import com.alibaba.dubbo.config.annotation.Service;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;


import io.platform.approvalConfiguration.biz.entity.AuditPathsActs;
import io.platform.approvalConfiguration.biz.service.AuditPathsActsService;
import io.platform.approvalConfiguration.dto.AuditPathsActsDto;
import io.platform.approvalConfiguration.service.client.api.AuditPathsActsServiceClient;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

import io.platform.base.common.BaseServiceClient;
import io.platform.base.common.utils.ExecuteResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Created by sevelli on 2017/8/31.
 */
@Component
@Service()
public class AuditPathsActsServiceClientImpl extends BaseServiceClient<AuditPathsActs, AuditPathsActsDto> implements AuditPathsActsServiceClient {
    private Logger logger = LoggerFactory.getLogger(getClass());
    @Resource
    private AuditPathsActsService auditPathsActsService;

    @Override
    public AuditPathsActsDto queryObject(Long id) {
        AuditPathsActs auditPathsActs = auditPathsActsService.selectById(id);
        AuditPathsActsDto auditPathsActsDto = new AuditPathsActsDto();
        BeanUtils.copyProperties(auditPathsActs, auditPathsActsDto);
        return auditPathsActsDto;
    }

    @Override
    public List<AuditPathsActsDto> queryList(Map<String, Object> map) {
        List<AuditPathsActs> auditPathsActsList = auditPathsActsService.selectByMap(map);
        return convertList(auditPathsActsList, AuditPathsActsDto.class);
    }

    @Override
    public int queryTotal(Map<String, Object> map) {
        EntityWrapper<AuditPathsActs> ew = new EntityWrapper<>();
        ew.allEq(map);
        return auditPathsActsService.selectCount(ew);
    }

    @Override
    public ExecuteResult<String> save(AuditPathsActsDto auditPathsActsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            AuditPathsActs auditPathsActs = new AuditPathsActs();
            revert(auditPathsActsDto, auditPathsActs);
            boolean flag = auditPathsActsService.insert(auditPathsActs);
            if (!flag) {
                result.addErrorMessage("保存失败。");
            }
        } catch (Exception e) {
            logger.error(" 保存错误：" + e.toString(), e);
            result.addErrorMessage("保存错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> update(AuditPathsActsDto auditPathsActsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            AuditPathsActs auditPathsActs = new AuditPathsActs();
            revert(auditPathsActsDto, auditPathsActs);

            boolean flag = auditPathsActsService.updateById(auditPathsActs);
            if (!flag) {
                result.addErrorMessage("更新失败。");
            }
        } catch (Exception e) {
            logger.error(" 更新错误：" + e.toString(), e);
            result.addErrorMessage("更新错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> delete(Long id) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = auditPathsActsService.deleteById(id);
            if (!flag) {
                result.addErrorMessage("删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = auditPathsActsService.deleteBatchIds(ids);
            if (!flag) {
                result.addErrorMessage("批量删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public Page<AuditPathsActsDto> getPage(Page<AuditPathsActsDto> pageDto, AuditPathsActsDto auditPathsActsDto) {
        Page<AuditPathsActs> page = new Page<>(pageDto.getCurrent(), pageDto.getSize());
        page.setAsc(pageDto.isAsc());
        page.setOrderByField(pageDto.getOrderByField());
        page.setCondition(pageDto.getCondition());
        AuditPathsActs auditPathsActs = new AuditPathsActs();
        revert(auditPathsActsDto, auditPathsActs);
        EntityWrapper<AuditPathsActs> wrapper = new EntityWrapper<>();
        wrapper.setEntity(auditPathsActs);
        page = auditPathsActsService.selectPage(page, wrapper);
        List<AuditPathsActsDto> auditPathsActsDtoList = convertList(page.getRecords(), AuditPathsActsDto.class);
        pageDto.setTotal(auditPathsActsService.selectCount(wrapper));
        pageDto.setRecords(auditPathsActsDtoList);
        return pageDto;
    }
}
