
package io.platform.approvalConfiguration.impl;

import com.alibaba.dubbo.config.annotation.Service;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;


import io.platform.approvalConfiguration.biz.entity.AuditPathsLevels;
import io.platform.approvalConfiguration.biz.service.AuditPathsLevelsService;
import io.platform.approvalConfiguration.dto.AuditPathsLevelsDto;
import io.platform.approvalConfiguration.service.client.api.AuditPathsLevelsServiceClient;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

import io.platform.base.common.BaseServiceClient;
import io.platform.base.common.utils.ExecuteResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Created by sevelli on 2017/8/31.
 */
@Component
@Service()
public class AuditPathsLevelsServiceClientImpl extends BaseServiceClient<AuditPathsLevels, AuditPathsLevelsDto> implements AuditPathsLevelsServiceClient {
    private Logger logger = LoggerFactory.getLogger(getClass());
    @Resource
    private AuditPathsLevelsService auditPathsLevelsService;

    @Override
    public AuditPathsLevelsDto queryObject(Long id) {
        AuditPathsLevels auditPathsLevels = auditPathsLevelsService.selectById(id);
        AuditPathsLevelsDto auditPathsLevelsDto = new AuditPathsLevelsDto();
        BeanUtils.copyProperties(auditPathsLevels, auditPathsLevelsDto);
        return auditPathsLevelsDto;
    }

    @Override
    public List<AuditPathsLevelsDto> queryList(Map<String, Object> map) {
        List<AuditPathsLevels> auditPathsLevelsList = auditPathsLevelsService.selectByMap(map);
        return convertList(auditPathsLevelsList, AuditPathsLevelsDto.class);
    }

    @Override
    public int queryTotal(Map<String, Object> map) {
        EntityWrapper<AuditPathsLevels> ew = new EntityWrapper<>();
        ew.allEq(map);
        return auditPathsLevelsService.selectCount(ew);
    }

    @Override
    public ExecuteResult<String> save(AuditPathsLevelsDto auditPathsLevelsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            AuditPathsLevels auditPathsLevels = new AuditPathsLevels();
            revert(auditPathsLevelsDto, auditPathsLevels);
            boolean flag = auditPathsLevelsService.insert(auditPathsLevels);
            if (!flag) {
                result.addErrorMessage("保存失败。");
            }
        } catch (Exception e) {
            logger.error(" 保存错误：" + e.toString(), e);
            result.addErrorMessage("保存错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> update(AuditPathsLevelsDto auditPathsLevelsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            AuditPathsLevels auditPathsLevels = new AuditPathsLevels();
            revert(auditPathsLevelsDto, auditPathsLevels);

            boolean flag = auditPathsLevelsService.updateById(auditPathsLevels);
            if (!flag) {
                result.addErrorMessage("更新失败。");
            }
        } catch (Exception e) {
            logger.error(" 更新错误：" + e.toString(), e);
            result.addErrorMessage("更新错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> delete(Long id) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = auditPathsLevelsService.deleteById(id);
            if (!flag) {
                result.addErrorMessage("删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = auditPathsLevelsService.deleteBatchIds(ids);
            if (!flag) {
                result.addErrorMessage("批量删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public Page<AuditPathsLevelsDto> getPage(Page<AuditPathsLevelsDto> pageDto, AuditPathsLevelsDto auditPathsLevelsDto) {
        Page<AuditPathsLevels> page = new Page<>(pageDto.getCurrent(), pageDto.getSize());
        page.setAsc(pageDto.isAsc());
        page.setOrderByField(pageDto.getOrderByField());
        page.setCondition(pageDto.getCondition());
        AuditPathsLevels auditPathsLevels = new AuditPathsLevels();
        revert(auditPathsLevelsDto, auditPathsLevels);
        EntityWrapper<AuditPathsLevels> wrapper = new EntityWrapper<>();
        wrapper.setEntity(auditPathsLevels);
        page = auditPathsLevelsService.selectPage(page, wrapper);
        List<AuditPathsLevelsDto> auditPathsLevelsDtoList = convertList(page.getRecords(), AuditPathsLevelsDto.class);
        pageDto.setTotal(auditPathsLevelsService.selectCount(wrapper));
        pageDto.setRecords(auditPathsLevelsDtoList);
        return pageDto;
    }
}
