package io.platform.budget.biz.entity;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.enums.IdType;

import java.io.Serializable;

import lombok.Data;

@Data
@TableName("budget_adjust_bills")
public class BudgetAdjustBills extends Model<BudgetAdjustBills> implements Serializable {
    private static final long serialVersionUID = 5454155825314635342L;


    /**
     * id       db_column: id
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

    /**
     * 单据编号       db_column: bill_no
     */
    @TableField("bill_no")
    private String billNo;

    /**
     * 来源行号       db_column: line_no
     */
    @TableField("line_no")
    private Integer lineNo;

    /**
     * 活动号       db_column: act_id
     */
    @TableField("act_id")
    private Integer actId;

    /**
     * 备注       db_column: remarks
     */
    @TableField("remarks")
    private String remarks;

    /**
     * 子工程编号       db_column: project_sub_no
     */
    @TableField("project_sub_no")
    private String projectSubNo;

    /**
     * 预算费用项目id       db_column: budget_id
     */
    @TableField("budget_id")
    private Integer budgetId;

    /**
     * 原始预算金额       db_column: budget_org_amt
     */
    @TableField("budget_org_amt")
    private Double budgetOrgAmt;

    /**
     * 调整后预算金额       db_column: budget_amt
     */
    @TableField("budget_amt")
    private Double budgetAmt;

    /**
     * 预算附件       db_column: attach_id
     */
    @TableField("attach_id")
    private String attachId;

    /**
     * 是否新加预算       db_column: is_add
     */
    @TableField("is_add")
    private Integer isAdd;
//columns END

}
