package io.platform.budget.biz.entity;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.enums.IdType;

import java.io.Serializable;

import lombok.Data;

@Data
@TableName("project_bills_adjusts")
public class ProjectBillsAdjusts extends Model<ProjectBillsAdjusts> implements Serializable {
    private static final long serialVersionUID = 5454155825314635342L;


    /**
     * id       db_column: id
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

    /**
     * 单据编号       db_column: bill_no
     */
    @TableField("bill_no")
    private String billNo;

    /**
     * 业务活动号       db_column: act_id
     */
    @TableField("act_id")
    private Integer actId;

    /**
     * 来源活动号       db_column: src_act_id
     */
    @TableField("src_act_id")
    private Integer srcActId;

    /**
     * 来源编号       db_column: src_bill_no
     */
    @TableField("src_bill_no")
    private String srcBillNo;

    /**
     * 来源行号       db_column: src_line_no
     */
    @TableField("src_line_no")
    private Integer srcLineNo;

    /**
     * 原始活动号       db_column: org_act_id
     */
    @TableField("org_act_id")
    private Integer orgActId;

    /**
     * 原始活动号       db_column: org_bill_no
     */
    @TableField("org_bill_no")
    private String orgBillNo;

    /**
     * 原始行号       db_column: org_line_no
     */
    @TableField("org_line_no")
    private Integer orgLineNo;

    /**
     * 单据状态（1-新建2处理中6完成）       db_column: bill_status
     */
    @TableField("bill_status")
    private Integer billStatus;

    /**
     * 调整后预算金额       db_column: budget_amt_adjusts
     */
    @TableField("budget_amt_adjusts")
    private Double budgetAmtAdjusts;

    /**
     * 调整后毛利额       db_column: budget_profit_adjusts
     */
    @TableField("budget_profit_adjusts")
    private Double budgetProfitAdjusts;

    /**
     * 调整后毛利率       db_column: budget_profit_rate_adjusts
     */
    @TableField("budget_profit_rate_adjusts")
    private Double budgetProfitRateAdjusts;

    /**
     * 制单人id       db_column: op_user_id
     */
    @TableField("op_user_id")
    private Integer opUserId;

    /**
     * 制单人名称       db_column: op_user_name
     */
    @TableField("op_user_name")
    private String opUserName;

    /**
     * 制单日期       db_column: create_date
     */
    @TableField("create_date")
    private java.util.Date createDate;

    /**
     * 业务日期       db_column: bill_date
     */
    @TableField("bill_date")
    private java.util.Date billDate;

    /**
     * 提交日期       db_column: post_date
     */
    @TableField("post_date")
    private java.util.Date postDate;

    /**
     * 备注       db_column: remarks
     */
    @TableField("remarks")
    private String remarks;

    /**
     * 子工程编号       db_column: project_sub_no
     */
    @TableField("project_sub_no")
    private String projectSubNo;

    /**
     * 承包单位       db_column: branch_id
     */
    @TableField("branch_id")
    private Integer branchId;

    /**
     * 上传文件       db_column: attach_id
     */
    @TableField("attach_id")
    private String attachId;
//columns END

}
