package io.platform.budget.biz.entity;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.enums.IdType;

import java.io.Serializable;

import lombok.Data;

@Data
@TableName("project_bills_budgets")
public class ProjectBillsBudgets extends Model<ProjectBillsBudgets> implements Serializable {
    private static final long serialVersionUID = 5454155825314635342L;


    /**
     * id       db_column: id
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

    /**
     * 单据编号       db_column: bill_no
     */
    @TableField("bill_no")
    private String billNo;

    /**
     * 行号       db_column: line_no
     */
    @TableField("line_no")
    private Integer lineNo;

    /**
     * 活动号       db_column: act_id
     */
    @TableField("act_id")
    private Integer actId;

    /**
     * 备注       db_column: remarks
     */
    @TableField("remarks")
    private String remarks;

    /**
     * 子工程编号       db_column: project_sub_no
     */
    @TableField("project_sub_no")
    private String projectSubNo;

    /**
     * 预算费用项目id       db_column: budget_id
     */
    @TableField("budget_id")
    private Integer budgetId;

    /**
     * 预算费用项目id       db_column: budget_id
     */
    @TableField("budget_name")
    private String budgetName;
    /**
     * 原始预算金额       db_column: budget_org_amt
     */
    @TableField("budget_org_amt")
    private Double budgetOrgAmt;

    /**
     * 预算金额       db_column: budget_amt
     */
    @TableField("budget_amt")
    private Double budgetAmt;

    /**
     * 预算附件       db_column: attach_id
     */
    @TableField("attach_id")
    private Integer attachId;

    /**
     * 累计占用预算金额       db_column: budget_use_amt
     */
    @TableField("budget_use_amt")
    private double budgetUseAmt;

    /**
     * 剩余预算金额       db_column: budget_blc_amt
     */
    @TableField("budget_blc_amt")
    private double budgetBlcAmt;

    /**
     * 已开发票金额       db_column: sub_inv_amt_cr
     */
    @TableField("sub_inv_amt_cr")
    private double subInvAmtCr;

    /**
     * 未开发票金额       db_column: sub_inv_amt_blc
     */
    @TableField("sub_inv_amt_blc")
    private double subInvAmtBlc;

    /**
     * 已付款金额       db_column: sub_amt_cr
     */
    @TableField("sub_amt_cr")
    private double subAmtCr;

    /**
     * 剩余应付金额       db_column: sub_amt_blc
     */
    @TableField("sub_amt_blc")
    private double subAmtBlc;

    /**
     * 结算金额       db_column: settlement_amt
     */
    @TableField("settlement_amt")
    private double settlementAmt;
    /**
     * 工程审定金额       db_column: sub_amt_blc
     */
    @TableField("approved_amount")
    private double approvedAmount;
    /**
     * 承包单位       db_column: branch_id
     */
    @TableField("branch_id")
    private Integer branchId;

//columns END

    /**
     * 工程名称
     */
    @TableField(exist = false)
    private String projectSubName;

    /**
     *nc工程编号
     *
     */
    @TableField(exist = false)
    private String ncProjectNo;

}
