
package io.platform.budget.service.client.impl;

import com.alibaba.dubbo.config.annotation.Service;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;

import io.platform.approvalConfiguration.biz.entity.Audit;
import io.platform.approvalConfiguration.biz.service.AuditItemsService;
import io.platform.base.common.utils.CopyUtils;
import io.platform.budget.biz.entity.BudgetAdjustBills;
import io.platform.budget.biz.entity.ProjectBillsAdjusts;
import io.platform.budget.biz.entity.ProjectBillsBudgets;
import io.platform.budget.biz.service.BudgetAdjustBillsService;
import io.platform.budget.biz.service.ProjectBillsAdjustsService;
import io.platform.budget.biz.service.ProjectBillsBudgetsService;
import io.platform.budget.dto.ProjectBillsAdjustsDto;
import io.platform.budget.service.client.api.ProjectBillsAdjustsServiceClient;
import io.platform.contract.biz.entity.Tasklists;
import io.platform.engineering.biz.entity.Bbranchs;
import io.platform.engineering.biz.entity.Bbudgets;
import io.platform.engineering.biz.entity.Bcorps;
import io.platform.engineering.biz.entity.BprojectTypes;
import io.platform.engineering.biz.service.BbranchsService;
import io.platform.engineering.biz.service.BbudgetsService;
import io.platform.engineering.biz.service.BcorpsService;
import io.platform.engineering.biz.service.BprojectTypesService;
import io.platform.project.biz.entity.ProjectBillsSubs;
import io.platform.project.biz.entity.Projectbills;
import io.platform.project.biz.service.ProjectBillsSubsService;
import io.platform.project.biz.service.ProjectbillsService;
import io.platform.project.biz.service.SubContractBillsService;
import io.platform.project.dto.ProjectBS;
import io.platform.project.dto.ProjectBillsSubsDto;
import io.platform.project.dto.ProjectbillsDto;
import io.platform.sys.biz.entity.SysRole;
import io.platform.sys.dto.SysUserDto;
import io.platform.utils.DataUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.util.*;

import io.platform.base.common.BaseServiceClient;
import io.platform.base.common.utils.ExecuteResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;

/**
 * Created by sevelli on 2017/8/31.
 */
@Component
@Service(version = "1.0.0", interfaceClass = ProjectBillsAdjustsServiceClient.class)
public class ProjectBillsAdjustsServiceClientImpl extends BaseServiceClient<ProjectBillsAdjusts, ProjectBillsAdjustsDto> implements ProjectBillsAdjustsServiceClient {
    private Logger logger = LoggerFactory.getLogger(getClass());
    @Resource
    private BcorpsService bcorpsService;
    @Resource
    private BbudgetsService bbudgetsService;
    @Resource
    private BbranchsService bbranchsService;
    @Resource
    private BprojectTypesService bprojectTypesService;
    @Resource
    private BudgetAdjustBillsService budgetAdjustBillsService;
    @Resource
    private ProjectBillsSubsService projectBillsSubsService;
    @Resource
    private ProjectBillsBudgetsService projectBillsBudgetsService;
    @Resource
    private ProjectBillsAdjustsService projectBillsAdjustsService;
    @Resource
    private SubContractBillsService subContractBillsService;
    @Resource
    private ProjectbillsService projectbillsService;

    @Override
    public ProjectBillsAdjustsDto queryObject(Long id) {
        ProjectBillsAdjusts projectBillsAdjusts = projectBillsAdjustsService.selectById(id);
        ProjectBillsAdjustsDto projectBillsAdjustsDto = new ProjectBillsAdjustsDto();
        BeanUtils.copyProperties(projectBillsAdjusts, projectBillsAdjustsDto);
        return projectBillsAdjustsDto;
    }

    @Override
    public List<ProjectBillsAdjustsDto> queryList(Map<String, Object> map) {
        List<ProjectBillsAdjusts> projectBillsAdjustsList = projectBillsAdjustsService.selectByMap(map);
        return convertList(projectBillsAdjustsList, ProjectBillsAdjustsDto.class);
    }

    @Override
    public int queryTotal(Map<String, Object> map) {
        EntityWrapper<ProjectBillsAdjusts> ew = new EntityWrapper<>();
        ew.allEq(map);
        return projectBillsAdjustsService.selectCount(ew);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> save(ProjectBillsAdjustsDto projectBillsAdjustsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            ProjectBillsAdjusts projectBillsAdjusts = new ProjectBillsAdjusts();
            revert(projectBillsAdjustsDto, projectBillsAdjusts);
            boolean flag = projectBillsAdjustsService.insert(projectBillsAdjusts);
            if (!flag) {
                result.addErrorMessage("保存失败。");
            }
        } catch (Exception e) {
            logger.error(" 保存错误：" + e.toString(), e);
            result.addErrorMessage("保存错误：" + e.toString());
        }
        return result;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> update(ProjectBillsAdjustsDto projectBillsAdjustsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            ProjectBillsAdjusts projectBillsAdjusts = new ProjectBillsAdjusts();
            revert(projectBillsAdjustsDto, projectBillsAdjusts);

            boolean flag = projectBillsAdjustsService.updateById(projectBillsAdjusts);
            if (!flag) {
                result.addErrorMessage("更新失败。");
            }
        } catch (Exception e) {
            logger.error(" 更新错误：" + e.toString(), e);
            result.addErrorMessage("更新错误：" + e.toString());
        }
        return result;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> delete(Long id) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = projectBillsAdjustsService.deleteById(id);
            if (!flag) {
                result.addErrorMessage("删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> deleteProjectAdjusts(ProjectBillsAdjustsDto projectBillsAdjustsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            if (projectBillsAdjustsDto != null && projectBillsAdjustsDto.getId() != null) {
                EntityWrapper<ProjectBillsAdjusts> projectBillsAdjustsEntityWrapper = new EntityWrapper<>();
                projectBillsAdjustsEntityWrapper.eq("id", projectBillsAdjustsDto.getId());
                ProjectBillsAdjusts billsAdjusts = projectBillsAdjustsService.selectOne(projectBillsAdjustsEntityWrapper);
                if (Objects.equals(billsAdjusts.getBillStatus(), 6)) {
                    result.addErrorMessage("已提交不允许删除");
                    return result;
                }
                EntityWrapper<BudgetAdjustBills> budgetAdjustBillsEntityWrapper = new EntityWrapper<>();
                budgetAdjustBillsEntityWrapper.eq("bill_no", billsAdjusts.getBillNo())
                        .eq("project_sub_no", billsAdjusts.getProjectSubNo());
                boolean delete = budgetAdjustBillsService.delete(budgetAdjustBillsEntityWrapper);
                if (!delete) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("预算明细删除失败");
                    return result;
                }
                boolean deleteById = projectBillsAdjustsService.deleteById(billsAdjusts);
                if (!deleteById) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("删除预算调整失败");
                    return result;
                }
            } else {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("删除失败。");
                return result;
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除失败");
        }
        return result;
    }

    @Override
    public Map<String, Object> getPage(Map<String, Object> map, SysUserDto sysUserDto) {
        Map<String, Object> hashMap = new HashMap<>();
        SysRole sysRole = subContractBillsService.selectRole(sysUserDto);
        map.put("user", sysUserDto);
        map.put("role", sysRole);
        try {
            int count = projectBillsAdjustsService.selectProAdjustsCount(map);
            if (count != 0) {
                int current = (int) map.get("current");
                int size = (int) map.get("size");
                if (current <= 1) {
                    current = 0;
                } else {
                    current = (current - 1) * size;
                }
                map.put("size", size);
                map.put("current", current);
                List<Map<String, Object>> mapList = projectBillsAdjustsService.selectProAdjustsRecords(map);
                Page page = new Page();
                page.setRecords(mapList);
                page.setTotal(count);
                hashMap.put("page", page);
                return hashMap;
            }
        } catch (Exception e) {
            logger.error("操作异常：" + e.toString(), e);
        }
        return null;
    }

    @Override
    public Map<String, Object> fuzzyQueryProjectAdjust(ProjectBillsSubsDto projectBillsSubsDto) {
        Map<String, Object> map = new HashMap<>();
        EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
        projectBillsSubsEntityWrapper.setSqlSelect("id", "nc_project_no", "project_sub_no", "project_sub_name");
        if (projectBillsSubsDto.getProjectBudgetStatus() != null && projectBillsSubsDto.getProjectBudgetStatus() != 0) {
            projectBillsSubsEntityWrapper.eq("project_budget_status", projectBillsSubsDto.getProjectBudgetStatus());
        }
        if (projectBillsSubsDto.getProjectStepsStatus() != null && projectBillsSubsDto.getProjectStepsStatus() != 0) {
            projectBillsSubsEntityWrapper.eq("project_steps_status", projectBillsSubsDto.getProjectStepsStatus());
        }
        if (projectBillsSubsDto.getProjectSubNo() != null && !projectBillsSubsDto.getProjectSubNo().equals("")) {
            projectBillsSubsEntityWrapper.eq("project_sub_no", projectBillsSubsDto.getProjectSubNo());
        }
        if (projectBillsSubsDto.getProjectSubName() != null && !projectBillsSubsDto.getProjectSubName().equals("")) {
            projectBillsSubsEntityWrapper.like("project_sub_name", "%" + projectBillsSubsDto.getProjectSubName() + "%");
        }
        List<ProjectBillsSubs> billsSubs = projectBillsSubsService.selectList(projectBillsSubsEntityWrapper);
        if (billsSubs.size() != 0) {
            map.put("projecySubs", billsSubs);
            return map;
        }
        return null;
    }

    @Override
    public Map<String, Object> changeFuzzyQueryProjectAdjust(ProjectBillsSubsDto projectBillsStepsAdjustDto) {
        Map<String, Object> map = new HashMap<>();
        if (projectBillsStepsAdjustDto != null) {
            map.put("proSub", projectBillsStepsAdjustDto);
            ProjectBS projectBS = projectBillsAdjustsService.selectProjectSub(map);
            if (projectBS != null) {
                map.put("projectBS", projectBS);
                if (projectBS.getProjectTypeId() != null && projectBS.getProjectTypeId() != 0) {
                    EntityWrapper<BprojectTypes> bprojectTypesEntityWrapper = new EntityWrapper<>();
                    bprojectTypesEntityWrapper.setSqlSelect("id", "project_type_name").eq("id", projectBS.getProjectTypeId());
                    BprojectTypes bprojectTypes = bprojectTypesService.selectOne(bprojectTypesEntityWrapper);
                    map.put("projectType", bprojectTypes);
                }
                if (projectBS.getCorpId() != null && projectBS.getCorpId() != 0) {
                    EntityWrapper<Bcorps> bcorpsEntityWrapper = new EntityWrapper<>();
                    bcorpsEntityWrapper.setSqlSelect("id", "c_name").eq("id", projectBS.getCorpId());
                    Bcorps bcorps = bcorpsService.selectOne(bcorpsEntityWrapper);
                    map.put("corp", bcorps);
                }
                if (projectBS.getConstructorId() != null && projectBS.getConstructorId() != 0) {
                    EntityWrapper<Bbranchs> bbranchsEntityWrapper = new EntityWrapper<>();
                    bbranchsEntityWrapper.setSqlSelect("id", "c_name").eq("id", projectBS.getConstructorId());
                    Bbranchs bbranchs = bbranchsService.selectOne(bbranchsEntityWrapper);
                    map.put("branch", bbranchs);
                }
                EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
                projectBillsBudgetsEntityWrapper.eq("project_sub_no", projectBS.getProjectSubNo());
                List<ProjectBillsBudgets> projectBillsBudgets = projectBillsBudgetsService.selectList(projectBillsBudgetsEntityWrapper);
                if (projectBillsBudgets.size() != 0) {
                    List<Bbudgets> bbudgetsList = new ArrayList<>();
                    for (ProjectBillsBudgets pro : projectBillsBudgets) {
                        EntityWrapper<Bbudgets> bbudgetsEntityWrapper = new EntityWrapper<>();
                        bbudgetsEntityWrapper.setSqlSelect("id", "budget_name").eq("id", pro.getBudgetId());
                        Bbudgets bbudgets = bbudgetsService.selectOne(bbudgetsEntityWrapper);
                        if (bbudgets != null) {
                            bbudgetsList.add(bbudgets);
                        }
                    }
                    map.put("budget", bbudgetsList);
                }
                map.put("projectBudgets", projectBillsBudgets);
            }
            return map;
        }
        return null;
    }

    @Override
    public Map<String, Object> queryTemporaryInformation(ProjectBillsAdjustsDto projectBillsAdjustsDto) {
        if (projectBillsAdjustsDto != null && projectBillsAdjustsDto.getId() != null) {
            Map<String, Object> map = new HashMap<>();
            ProjectBillsAdjusts billsAdjusts = projectBillsAdjustsService.selectById(projectBillsAdjustsDto.getId());
            EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
            projectBillsSubsEntityWrapper.eq("project_sub_no", billsAdjusts.getProjectSubNo())
                    .eq("branch_id", billsAdjusts.getBranchId());
            ProjectBillsSubs billsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
            map.put("proSub", billsSubs);
            map.put("proAdjusts", billsAdjusts);
            ProjectBS projectBS = projectBillsAdjustsService.selectProjectSub(map);
            projectBS.setId(billsAdjusts.getId());
            projectBS.setBillNo(billsAdjusts.getBillNo());
            projectBS.setAttachId(billsAdjusts.getAttachId());
            EntityWrapper<BudgetAdjustBills> budgetAdjustBillsEntityWrapper = new EntityWrapper<>();
            budgetAdjustBillsEntityWrapper.eq("bill_no", billsAdjusts.getBillNo())
                    .eq("project_sub_no", billsAdjusts.getProjectSubNo());
            List<BudgetAdjustBills> budgetAdjustBills = budgetAdjustBillsService.selectList(budgetAdjustBillsEntityWrapper);
            if (projectBS != null) {
                EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
                projectBillsBudgetsEntityWrapper.eq("project_sub_no", billsAdjusts.getProjectSubNo())
                        .eq("branch_id", billsAdjusts.getBranchId());
                List<ProjectBillsBudgets> projectBillsBudgetsList = projectBillsBudgetsService.selectList(projectBillsBudgetsEntityWrapper);
                map.put("proBudgets", projectBillsBudgetsList);
                for (BudgetAdjustBills bj : budgetAdjustBills) {
                    boolean status = true;
                    for (ProjectBillsBudgets pb : projectBillsBudgetsList) {
                        if (Objects.equals(bj.getBudgetId(), pb.getBudgetId())) {
                            status = false;
                            break;
                        }
                    }
                    if (status) {
                        bj.setIsAdd(1);
                    }
                }
                map.put("budgetAdjust", budgetAdjustBills);
                projectBS.setBillNo(billsAdjusts.getBillNo());
                projectBS.setBillStatus(billsAdjusts.getBillStatus());
                projectBS.setCreateUserId(billsAdjusts.getOpUserId());
                map.put("projectBS", projectBS);
                EntityWrapper<Bbudgets> bbudgetsEntityWrapper = new EntityWrapper<>();
                bbudgetsEntityWrapper.setSqlSelect("id", "budget_name");
                List<Bbudgets> bbudgets = bbudgetsService.selectList(bbudgetsEntityWrapper);
                if (bbudgets.size() != 0) {
                    map.put("budget", bbudgets);
                }
                if (projectBS.getProjectTypeId() != null && projectBS.getProjectTypeId() != 0) {
                    EntityWrapper<BprojectTypes> bprojectTypesEntityWrapper = new EntityWrapper<>();
                    bprojectTypesEntityWrapper.setSqlSelect("id", "project_type_name").eq("id", projectBS.getProjectTypeId());
                    BprojectTypes bprojectTypes = bprojectTypesService.selectOne(bprojectTypesEntityWrapper);
                    map.put("projectType", bprojectTypes);
                }
                if (projectBS.getCorpId() != null && projectBS.getCorpId() != 0) {
                    EntityWrapper<Bcorps> bcorpsEntityWrapper = new EntityWrapper<>();
                    bcorpsEntityWrapper.setSqlSelect("id", "c_name").eq("id", projectBS.getCorpId());
                    Bcorps bcorps = bcorpsService.selectOne(bcorpsEntityWrapper);
                    map.put("corp", bcorps);
                }
                if (projectBS.getConstructorId() != null && projectBS.getConstructorId() != 0) {
                    EntityWrapper<Bbranchs> bbranchsEntityWrapper = new EntityWrapper<>();
                    bbranchsEntityWrapper.setSqlSelect("id", "c_name").eq("id", projectBS.getConstructorId());
                    Bbranchs bbranchs = bbranchsService.selectOne(bbranchsEntityWrapper);
                    map.put("branch", bbranchs);
                }
                return map;
            }
        }
        return null;
    }

    @Override
    public Map<String, Object> queryProSubBudgetTemporary(ProjectBillsSubsDto projectBillsSubsDto) {
        if (projectBillsSubsDto != null && projectBillsSubsDto.getId() != null) {
            Map<String, Object> map = new HashMap<>();
            ProjectBS projectBS = projectBillsAdjustsService.selectProAdjustsVal(projectBillsSubsDto);
            if (projectBS != null) {
                map.put("proBs", projectBS);
                if (projectBS.getProjectTypeId() != null) {
                    EntityWrapper<BprojectTypes> typesEntityWrapper = new EntityWrapper<>();
                    typesEntityWrapper.setSqlSelect("id", "project_type_name").eq("id", projectBS.getProjectTypeId());
                    BprojectTypes bprojectTypes = bprojectTypesService.selectOne(typesEntityWrapper);
                    if (bprojectTypes != null) {
                        map.put("proType", bprojectTypes);
                    }
                }
                if (projectBS.getCorpId() != null) {
                    EntityWrapper<Bcorps> bcorpsEntityWrapper = new EntityWrapper<>();
                    bcorpsEntityWrapper.setSqlSelect("id", "c_name").eq("id", projectBS.getCorpId());
                    Bcorps bcorps = bcorpsService.selectOne(bcorpsEntityWrapper);
                    if (bcorps != null) {
                        map.put("corp", bcorps);
                    }
                }
                if (projectBS.getConstructorId() != null) {
                    EntityWrapper<Bbranchs> bbranchsEntityWrapper = new EntityWrapper<>();
                    bbranchsEntityWrapper.setSqlSelect("id", "c_name").eq("id", projectBS.getConstructorId());
                    Bbranchs bbranchs = bbranchsService.selectOne(bbranchsEntityWrapper);
                    if (bbranchs != null) {
                        map.put("branch", bbranchs);
                    }
                }
                EntityWrapper<Bbudgets> bbudgetsEntityWrapper = new EntityWrapper<>();
                bbudgetsEntityWrapper.setSqlSelect("id", "budget_name");
                List<Bbudgets> bbudgets = bbudgetsService.selectList(bbudgetsEntityWrapper);
                if (bbudgets.size() != 0) {
                    map.put("budgets", bbudgets);
                }
            }

            EntityWrapper<BudgetAdjustBills> budgetAdjustBillsEntityWrapper = new EntityWrapper<>();
            budgetAdjustBillsEntityWrapper.eq("project_sub_no", projectBillsSubsDto.getProjectSubNo());
            List<BudgetAdjustBills> budgetAdjustBills = budgetAdjustBillsService.selectList(budgetAdjustBillsEntityWrapper);
            if (budgetAdjustBills.size() != 0) {
                map.put("budgetAdjust", budgetAdjustBills);
            } else {
                EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
                projectBillsBudgetsEntityWrapper.eq("project_sub_no", projectBillsSubsDto.getProjectSubNo());
                List<ProjectBillsBudgets> projectBillsBudgetsList = projectBillsBudgetsService.selectList(projectBillsBudgetsEntityWrapper);
                if (projectBillsBudgetsList.size() != 0) {
                    map.put("proBudgets", projectBillsBudgetsList);
                }
            }
            return map;
        }
        return null;
    }

    @Override
    public Map<String, Object> queryProSubBudget(ProjectBillsSubsDto projectBillsSubsDto) {
        if (projectBillsSubsDto != null && projectBillsSubsDto.getId() != null) {
            Map<String, Object> map = new HashMap<>();
            Map<String, Object> objectMap = projectBillsSubsService.selectProSubBudget(projectBillsSubsDto);
            EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
            int branchId = (int) objectMap.get("branchId");
            String proNo = (String) objectMap.get("projectSubNo");
            projectBillsBudgetsEntityWrapper.eq("project_sub_no", proNo).eq("branch_id", branchId);
            List<ProjectBillsBudgets> projectBillsBudgetsList = projectBillsBudgetsService.selectList(projectBillsBudgetsEntityWrapper);
            List<Bbudgets> bbudgets = bbudgetsService.selectList(new EntityWrapper<>());
            if (objectMap.get("projectTypeId") != null) {
                int protypeId = (int) objectMap.get("projectTypeId");
                BprojectTypes bprojectTypes = bprojectTypesService.selectById(protypeId);
                map.put("proType", bprojectTypes);
            }
            if (objectMap.get("corpId") != null) {
                int corpId = (int) objectMap.get("corpId");
                Bcorps bcorps = bcorpsService.selectById(corpId);
                map.put("corp", bcorps);
            }
            int constructorId = (int) objectMap.get("constructorId");
            Bbranchs bbranchs = bbranchsService.selectById(constructorId);
            map.put("branch", bbranchs);
            map.put("bBudgets", bbudgets);
            map.put("form", objectMap);
            map.put("budgets", projectBillsBudgetsList);
            return map;
        }
        return null;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> projectAdjustsTemporary(String projectBillsSubs, String projectBillsAdjustsDto, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            ProjectBillsAdjusts billsSubs = JSONArray.parseObject(projectBillsSubs, ProjectBillsAdjusts.class);
            JSONArray jsonArray = JSONArray.parseArray(projectBillsAdjustsDto);
            List<BudgetAdjustBills> budgetAdjustBills = JSONObject.parseArray(jsonArray.toJSONString(), BudgetAdjustBills.class);
            if (billsSubs != null) {
                billsSubs.setActId(115);
                billsSubs.setBillStatus(2);
                billsSubs.setOpUserId(sysUserDto.getUserId().intValue());
                billsSubs.setOpUserName(sysUserDto.getUsername());
                billsSubs.setCreateDate(new Date());
                billsSubs.setBillDate(new Date());
                boolean update = projectBillsAdjustsService.insertOrUpdate(billsSubs);
                if (!update) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("暂存失败, 预算项目修改失败");
                    return result;
                }
                if (budgetAdjustBills.size() != 0) {
                    EntityWrapper<BudgetAdjustBills> budgetAdjustBillsEntityWrapper = new EntityWrapper<>();
                    budgetAdjustBillsEntityWrapper.setSqlSelect("id").eq("bill_no", billsSubs.getBillNo());
                    List<BudgetAdjustBills> adjustBills = budgetAdjustBillsService.selectList(budgetAdjustBillsEntityWrapper);
                    if (adjustBills.size() != 0) {
                        for (BudgetAdjustBills bj : adjustBills) {
                            boolean deleteById = budgetAdjustBillsService.deleteById(bj);
                            if (!deleteById) {
                                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                result.addErrorMessage("暂存失败：删除调整失败");
                                return result;
                            }
                        }
                    }
                    int line = 0;
                    for (BudgetAdjustBills bj : budgetAdjustBills) {
                        line++;
//                        if (!Objects.equals(bj.getBudgetOrgAmt(), bj.getBudgetAmt())) {
                        bj.setBillNo(billsSubs.getBillNo());
                        bj.setLineNo(line);
                        bj.setActId(115);
                        bj.setProjectSubNo(billsSubs.getProjectSubNo());
                        boolean insert = budgetAdjustBillsService.insert(bj);
                        if (!insert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("暂存失败：新增明细失败");
                            return result;
                        }
//                        }
                    }
                }
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("预算编制删除失败");
            return result;
        }
        return result;
    }

    @Resource
    private AuditItemsService auditItemsService;

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> saveProjectAdjusts(String projectBillsSubs, String projectBillsAdjustsDto, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            ProjectBillsAdjusts billsSubs = JSONArray.parseObject(projectBillsSubs, ProjectBillsAdjusts.class);
            JSONArray jsonArray = JSONArray.parseArray(projectBillsAdjustsDto);
            List<BudgetAdjustBills> budgetAdjustBills = JSONObject.parseArray(jsonArray.toJSONString(), BudgetAdjustBills.class);
            if (billsSubs != null) {
                billsSubs.setBranchId(sysUserDto.getLoginContractorId());
                billsSubs.setActId(115);
                billsSubs.setBillStatus(4);
                billsSubs.setOpUserId(sysUserDto.getUserId().intValue());
                billsSubs.setOpUserName(sysUserDto.getUsername());
                billsSubs.setCreateDate(new Date());
                billsSubs.setBillDate(new Date());
                billsSubs.setPostDate(new Date());
                boolean update = projectBillsAdjustsService.insertOrUpdate(billsSubs);
                if (!update) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败, 预算项目修改失败");
                    return result;
                }
                EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
                projectBillsSubsEntityWrapper.eq("project_sub_no", billsSubs.getProjectSubNo())
                        .eq("branch_id", billsSubs.getBranchId());
                ProjectBillsSubs billsSubs1 = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
                Audit audit = new Audit();
                audit.setBillNo(billsSubs.getBillNo());
                audit.setProjectNo(billsSubs.getProjectSubNo());
                audit.setBranchId(billsSubs1.getApprovalBranchId());
                audit.setActId(830);
                audit.setLevelId(0);
                audit.setIffinalItem("F");
                audit.setSendUserId(sysUserDto.getUserId().intValue());
                audit.setSendName(sysUserDto.getActualname());
                audit.setSendTime(new Date());
                audit.setAuditUserId(sysUserDto.getUserId().intValue());
                audit.setAuditItem(new Date());
                audit.setAuditMsg("提交");
                audit.setAuditStatus("O");
                EntityWrapper<Projectbills> projectbillsEntityWrapper = new EntityWrapper<>();
                projectbillsEntityWrapper.eq("bill_no", billsSubs1.getBillNo())
                        .eq("corp_id", billsSubs1.getCorpId())
                        .eq("branch_id", billsSubs1.getBranchId());
                Projectbills projectbills = projectbillsService.selectOne(projectbillsEntityWrapper);
                audit.setSubJect(projectbills.getProjectName());
                boolean approvalFlow = auditItemsService.createApprovalFlow(audit);
                if (!approvalFlow) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("审批流异常请检查提交信息");
                    return result;
                }
                EntityWrapper<BudgetAdjustBills> budgetAdjustBillsEntityWrapper = new EntityWrapper<>();
                budgetAdjustBillsEntityWrapper.eq("bill_no", billsSubs.getBillNo())
                        .eq("project_sub_no", billsSubs.getProjectSubNo());
                boolean deleteById = budgetAdjustBillsService.delete(budgetAdjustBillsEntityWrapper);
                if (!deleteById) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：删除明细失败");
                    return result;
                }
                int line = 0;
                for (BudgetAdjustBills bj : budgetAdjustBills) {
                    line++;
                    bj.setBillNo(billsSubs.getBillNo());
                    bj.setLineNo(line);
                    bj.setActId(115);
                    bj.setIsAdd(0);
                    bj.setProjectSubNo(billsSubs.getProjectSubNo());
                    boolean insert = budgetAdjustBillsService.insert(bj);
                    if (!insert) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：新增明细失败");
                        return result;
                    }
                }
//                    EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
//                    projectBillsSubsEntityWrapper.eq("project_sub_no", billsSubs.getProjectSubNo());
//                    ProjectBillsSubs billsSubs1 = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
//                    billsSubs1.setBudgetAmt(amt);
//                    billsSubs1.setBudgetProfit(billsSubs1.getAmt() - billsSubs1.getBudgetAmt());
//                    billsSubs1.setBudgetProfitRate(new Double(new DecimalFormat("#.00").format((billsSubs1.getBudgetProfit() / billsSubs1.getAmt() * 100))));
//                    boolean updateById = projectBillsSubsService.updateById(billsSubs1);
//                    if (!updateById) {
//                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
//                        result.addErrorMessage("提交失败：更新预算金额失败");
//                        return result;
//                    }
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 预算编制删除失败：" + e.toString(), e);
            result.addErrorMessage("预算编制删除失败");
            return result;
        }
        return result;
    }

}
