package io.platform.contract.biz.entity;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.enums.IdType;

import java.io.Serializable;

import lombok.Data;

@Data
@TableName("other_project")
public class OtherProject extends Model<OtherProject> implements Serializable {
    private static final long serialVersionUID = 5454155825314635342L;


    /**
     * id       db_column: id
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    @Override
    protected Serializable pkVal() {
        return this.id;
    }

    /**
     * 系统工程编号       db_column: project_sub_no
     */
    @TableField("project_sub_no")
    private String projectSubNo;

    /**
     * NC采购订单号       db_column: purchase_nc_no
     */
    @TableField("purchase_nc_no")
    private String purchaseNcNo;

    /**
     * 供应商id       db_column: purchases_id
     */
    @TableField("purchases_id")
    private Integer purchasesId;

    /**
     * 成本类型       db_column: budget_id
     */
    @TableField("budget_id")
    private Integer budgetId;

    /**
     * 合同金额       db_column: contract_amt
     */
    @TableField("contract_amt")
    private Double contractAmt;

    /**
     * 合同附件       db_column: attach_id
     */
    @TableField("attach_id")
    private String attachId;

    /**
     * 合同附件       db_column: attach_name
     */
    @TableField("attach_name")
    private String attachName;

    /**
     * 维护人       db_column: op_user_id
     */
    @TableField("op_user_id")
    private Integer opUserId;

    /**
     * 维护日期       db_column: op_date
     */
    @TableField("op_date")
    private java.util.Date opDate;

    /**
     * 状态（1新建 2暂存 6提交）       db_column: status
     */
    @TableField("status")
    private Integer status;
    /**
     * 累计付款金额       db_column: status
     */
    @TableField("contract_inv_amt")
    private Double contractInvAmt;
    /**
     * 累计开票金额       db_column: status
     */
    @TableField("contract_total_amt")
    private Double contractTotalAmt;
    /**
     * 供应商名称       db_column: status
     */
    @TableField("purchases_name")
    private String purchasesName;

    /**
     * 是否存续  F否，T是
     */
    @TableField("is_sur")
    private String isSur;

    /**
     * 承包单位
     */
    @TableField("branch_id")
    private Integer branchId;
//columns END

}
