
package io.platform.contract.service.client.impl;

import com.alibaba.dubbo.config.annotation.Service;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;


import io.platform.budget.service.client.api.ProjectBillsBudgetsServiceClient;
import io.platform.contract.biz.entity.ProjectBillsStlPlans;
import io.platform.contract.biz.service.ProjectBillsStlPlansService;
import io.platform.contract.dto.ProjectBillsStlPlansDto;
import io.platform.contract.service.client.api.ProjectBillsStlPlansServiceClient;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import io.platform.base.common.BaseServiceClient;
import io.platform.base.common.utils.ExecuteResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.transaction.annotation.Transactional;

/**
 * Created by sevelli on 2017/8/31.
 */
@Component
@Service(version = "1.0.0", interfaceClass = ProjectBillsStlPlansServiceClient.class)
public class ProjectBillsStlPlansServiceClientImpl extends BaseServiceClient<ProjectBillsStlPlans, ProjectBillsStlPlansDto> implements ProjectBillsStlPlansServiceClient {
    private Logger logger = LoggerFactory.getLogger(getClass());
    @Resource
    private ProjectBillsStlPlansService projectBillsStlPlansService;

    @Override
    public ProjectBillsStlPlansDto queryObject(Long id) {
        ProjectBillsStlPlans projectBillsStlPlans = projectBillsStlPlansService.selectById(id);
        ProjectBillsStlPlansDto projectBillsStlPlansDto = new ProjectBillsStlPlansDto();
        BeanUtils.copyProperties(projectBillsStlPlans, projectBillsStlPlansDto);
        return projectBillsStlPlansDto;
    }

    @Override
    public List<ProjectBillsStlPlansDto> queryList(Map<String, Object> map) {
        List<ProjectBillsStlPlans> projectBillsStlPlansList = projectBillsStlPlansService.selectByMap(map);
        return convertList(projectBillsStlPlansList, ProjectBillsStlPlansDto.class);
    }

    @Override
    public int queryTotal(Map<String, Object> map) {
        EntityWrapper<ProjectBillsStlPlans> ew = new EntityWrapper<>();
        ew.allEq(map);
        return projectBillsStlPlansService.selectCount(ew);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> save(ProjectBillsStlPlansDto projectBillsStlPlansDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            ProjectBillsStlPlans projectBillsStlPlans = new ProjectBillsStlPlans();
            revert(projectBillsStlPlansDto, projectBillsStlPlans);
            boolean flag = projectBillsStlPlansService.insert(projectBillsStlPlans);
            if (!flag) {
                result.addErrorMessage("保存失败。");
            }
        } catch (Exception e) {
            logger.error(" 保存错误：" + e.toString(), e);
            result.addErrorMessage("保存错误：" + e.toString());
        }
        return result;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> update(ProjectBillsStlPlansDto projectBillsStlPlansDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            ProjectBillsStlPlans projectBillsStlPlans = new ProjectBillsStlPlans();
            revert(projectBillsStlPlansDto, projectBillsStlPlans);

            boolean flag = projectBillsStlPlansService.updateById(projectBillsStlPlans);
            if (!flag) {
                result.addErrorMessage("更新失败。");
            }
        } catch (Exception e) {
            logger.error(" 更新错误：" + e.toString(), e);
            result.addErrorMessage("更新错误：" + e.toString());
        }
        return result;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> delete(Long id) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = projectBillsStlPlansService.deleteById(id);
            if (!flag) {
                result.addErrorMessage("删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = projectBillsStlPlansService.deleteBatchIds(ids);
            if (!flag) {
                result.addErrorMessage("批量删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public Page<ProjectBillsStlPlansDto> getPage(Page<ProjectBillsStlPlansDto> pageDto, ProjectBillsStlPlansDto projectBillsStlPlansDto) {
        Page<ProjectBillsStlPlans> page = new Page<>(pageDto.getCurrent(), pageDto.getSize());
        page.setAsc(pageDto.isAsc());
        page.setOrderByField(pageDto.getOrderByField());
        page.setCondition(pageDto.getCondition());
        ProjectBillsStlPlans projectBillsStlPlans = new ProjectBillsStlPlans();
        revert(projectBillsStlPlansDto, projectBillsStlPlans);
        EntityWrapper<ProjectBillsStlPlans> wrapper = new EntityWrapper<>();
        wrapper.setEntity(projectBillsStlPlans);
        page = projectBillsStlPlansService.selectPage(page, wrapper);
        List<ProjectBillsStlPlansDto> projectBillsStlPlansDtoList = convertList(page.getRecords(), ProjectBillsStlPlansDto.class);
        pageDto.setTotal(projectBillsStlPlansService.selectCount(wrapper));
        pageDto.setRecords(projectBillsStlPlansDtoList);
        return pageDto;
    }

    @Override
    public Map<String, Object> queryProStls(ProjectBillsStlPlansDto projectBillsStlPlansDto) {
        Map<String, Object> map = new HashMap<>();
        EntityWrapper<ProjectBillsStlPlans> projectBillsStlsEntityWrapper = new EntityWrapper<>();
        projectBillsStlsEntityWrapper.eq("bill_no", projectBillsStlPlansDto.getBillNo());
        List<ProjectBillsStlPlans> projectBillsStlPlansList = projectBillsStlPlansService.selectList(projectBillsStlsEntityWrapper);
        if (projectBillsStlPlansList.size() != 0) {
            map.put("stls", projectBillsStlPlansList);
            return map;
        }
        return map;
    }
}
