package io.platform.engineering.biz.entity;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.enums.IdType;

import java.io.Serializable;

import lombok.Data;

@Data
@TableName("b_corps")
public class Bcorps extends Model<Bcorps> implements Serializable {
    private static final long serialVersionUID = 5454155825314635342L;


    /**
     * id       db_column: id
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

    /**
     * corpId       db_column: corp_id
     */
    @TableId(value = "corp_id", type = IdType.AUTO)
    private Integer corpId;

    /**
     * 单位编号       db_column: corp_no
     */
    @TableField("corp_no")
    private String corpNo;

    /**
     * 业主单位编号       db_column: owner_no
     */
    @TableField("owner_no")
    private String ownerNo;

    /**
     * 单位简称       db_column: s_name
     */
    @TableField("s_name")
    private String sname;

    /**
     * 单位缩写
     */
    @TableField("abbr_no")
    private String abbrNo;

    /**
     * 单位全称       db_column: c_name
     */
    @TableField("c_name")
    private String cname;

    /**
     * 单位地址       db_column: caddr
     */
    @TableField("caddr")
    private String caddr;

    /**
     * 单位电话       db_column: tel
     */
    @TableField("tel")
    private String tel;

    /**
     * 单位穿着       db_column: fax
     */
    @TableField("fax")
    private String fax;

    /**
     * 邮寄地址       db_column: po_staddr
     */
    @TableField("po_staddr")
    private String poStaddr;

    /**
     * 企业负责人       db_column: man_ager
     */
    @TableField("man_ager")
    private String manAger;

    /**
     * 负责电话       db_column: man_ager_tel
     */
    @TableField("man_ager_tel")
    private String manAgerTel;

    /**
     * 联系人       db_column: attn
     */
    @TableField("attn")
    private String attn;

    /**
     * 联系人电话       db_column: attn_tel
     */
    @TableField("attn_tel")
    private String attnTel;

    /**
     * 税号       db_column: tax_no
     */
    @TableField("tax_no")
    private String taxNo;

    /**
     * 开户行       db_column: bank
     */
    @TableField("bank")
    private String bank;

    /**
     * 银行账号       db_column: bank_acc_no
     */
    @TableField("bank_acc_no")
    private String bankAccNo;

    /**
     * 客户来源（网络、朋友关系、电话等)       db_column: corpsrc_id
     */
    @TableField("corpsrc_id")
    private Integer corpsrcId;

    /**
     * 客户详情       db_column: details
     */
    @TableField("details")
    private String details;

    /**
     * 操作员       db_column: op_user_name
     */
    @TableField("op_user_name")
    private String opUserName;

    /**
     * 操作日期       db_column: op_date
     */
    @TableField("op_date")
    private java.util.Date opDate;

    /**
     * 状态(N新建A有效S停用)       db_column: status
     */
    @TableField("status")
    private String status;

    /**
     * 备注       db_column: remarks
     */
    @TableField("remarks")
    private String remarks;
//columns END

    /**
     * 业主单位类型。1为系统内，0为系统外
     */
    @TableField("system_type")
    private Integer systemType;
    /**
     * branchId       db_column: branch_id
     */
    @TableId(value = "branch_id")
    private Integer branchId;
}
