package io.platform.engineering.biz.entity;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.enums.IdType;

import java.io.Serializable;

import lombok.Data;

@Data
@TableName("b_price_modes")
public class BpriceModes extends Model<BpriceModes> implements Serializable {
    private static final long serialVersionUID = 5454155825314635342L;


    /**
     * id       db_column: id
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

    /**
     * 工程类型ID       db_column: price_mode_id
     */
    @TableId(value = "price_mode_id", type = IdType.AUTO)
    private Integer priceModeId;

    /**
     * 工程类型编号       db_column: price_mode_no
     */
    @TableField("price_mode_no")
    private String priceModeNo;

    /**
     * 工程类型名称       db_column: price_mode_name
     */
    @TableField("price_mode_name")
    private String priceModeName;

    /**
     * 操作员       db_column: op_user_name
     */
    @TableField("op_user_name")
    private String opUserName;

    /**
     * 操作日期       db_column: op_date
     */
    @TableField("op_date")
    private java.util.Date opDate;

    /**
     * 状态(N新建A有效S停用)       db_column: status
     */
    @TableField("status")
    private String status;

    /**
     * 备注       db_column: remarks
     */
    @TableField("remarks")
    private String remarks;
//columns END

}
