package io.platform.engineering.biz.entity;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.enums.IdType;

import java.io.Serializable;

import lombok.Data;

@Data
@TableName("b_project_node_steps")
public class BprojectNodeSteps extends Model<BprojectNodeSteps> implements Serializable {
    private static final long serialVersionUID = 5454155825314635342L;


    /**
     * id       db_column: id
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

    /**
     * projectStepId       db_column: project_step_id
     */
    @TableField("project_step_id")
    private Integer projectStepId;

    /**
     * 工程步骤编号（01，10，20，30等）       db_column: project_step_no
     */
    @TableField("project_step_no")
    private String projectStepNo;

    /**
     * 工程步骤名称       db_column: project_step_name
     */
    @TableField("project_step_name")
    private String projectStepName;

    /**
     * 工程节点id       db_column: project_node_id
     */
    @TableField("project_node_id")
    private Integer projectNodeId;

    /**
     * 操作员       db_column: op_user_name
     */
    @TableField("op_user_name")
    private String opUserName;

    /**
     * 操作日期       db_column: op_date
     */
    @TableField("op_date")
    private java.util.Date opDate;

    /**
     * 状态(N新建A有效S停用)       db_column: status
     */
    @TableField("status")
    private String status;

    /**
     * 备注       db_column: remarks
     */
    @TableField("remarks")
    private String remarks;
//columns END


    /**
     * 排序值
     */
    @TableField("sort_num")
    private Integer sortNum;

    /**
     * 承包单位id
     */
    @TableField("branch_id")
    private Integer branchId;


}
