
package io.platform.fileManagement.service.client.impl;

import com.alibaba.dubbo.config.annotation.Service;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;


import io.platform.fileManagement.biz.entity.DataFileOperating;
import io.platform.fileManagement.biz.service.DataFileOperatingService;
import io.platform.fileManagement.dto.DataFileOperatingDto;
import io.platform.fileManagement.service.client.api.DataFileOperatingServiceClient;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;
import java.util.Map;
import io.platform.base.common.BaseServiceClient;
import io.platform.base.common.utils.ExecuteResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
 * Created by sevelli on 2017/8/31.
 */
@Component
@Service()
public class DataFileOperatingServiceClientImpl extends BaseServiceClient<DataFileOperating, DataFileOperatingDto> implements DataFileOperatingServiceClient {
    private Logger logger = LoggerFactory.getLogger(getClass());
    @Resource
    private DataFileOperatingService dataFileOperatingService;

    @Override
    public DataFileOperatingDto queryObject(Long id) {
        DataFileOperatingDto dataFileOperating = dataFileOperatingService.selectByFileId(id);
        DataFileOperatingDto dataFileOperatingDto = new DataFileOperatingDto();
        BeanUtils.copyProperties(dataFileOperating,dataFileOperatingDto);
        return dataFileOperating;
    }

    @Override
    public List<DataFileOperatingDto> queryList(Map<String, Object> map) {
        List<DataFileOperating> dataFileOperatingList = dataFileOperatingService.selectByMap(map);
        return convertList(dataFileOperatingList,DataFileOperatingDto.class);
    }

    @Override
    public int queryTotal(Map<String, Object> map) {
        EntityWrapper<DataFileOperating> ew = new EntityWrapper<>();
        ew.allEq(map);
        return dataFileOperatingService.selectCount(ew);
    }

    @Override
    public ExecuteResult<String> save(DataFileOperatingDto dataFileOperatingDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try{
            DataFileOperating dataFileOperating = new DataFileOperating();
            revert(dataFileOperatingDto,dataFileOperating);
            dataFileOperating.setUpdateTime(new Date());
            boolean flag = dataFileOperatingService.insert(dataFileOperating);
            if(!flag){
                result.addErrorMessage("保存失败。");
            }
        }
        catch (Exception e) {
            logger.error(" 保存错误：" + e.toString(), e);
            result.addErrorMessage("保存错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> update(DataFileOperatingDto dataFileOperatingDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try{
            DataFileOperating dataFileOperating = new DataFileOperating();
            revert(dataFileOperatingDto,dataFileOperating);

            boolean flag = dataFileOperatingService.updateById(dataFileOperating);
            if(!flag){
                result.addErrorMessage("更新失败。");
            }
        }
        catch (Exception e) {
            logger.error(" 更新错误：" + e.toString(), e);
            result.addErrorMessage("更新错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> delete(Long id) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try{
            boolean flag = dataFileOperatingService.deleteById(id);
            if(!flag){
                result.addErrorMessage("删除失败。");
            }
        }
        catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try{
            boolean flag = dataFileOperatingService.deleteBatchIds(ids);
            if(!flag){
                result.addErrorMessage("批量删除失败。");
            }
        }
        catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public Page<DataFileOperatingDto> getPage(Page<DataFileOperatingDto> pageDto,DataFileOperatingDto dataFileOperatingDto) {
        Page<DataFileOperating> page = new Page<>(pageDto.getCurrent(),pageDto.getSize());
        page.setAsc(pageDto.isAsc());
        page.setOrderByField(pageDto.getOrderByField());
        page.setCondition(pageDto.getCondition());
        DataFileOperating dataFileOperating = new DataFileOperating();
        revert(dataFileOperatingDto,dataFileOperating);
        EntityWrapper<DataFileOperating> wrapper = new EntityWrapper<>();
        wrapper.setEntity(dataFileOperating);
        List<DataFileOperatingDto> dataFileOperatingDtoList = convertList(page.getRecords(),DataFileOperatingDto.class);
        pageDto.setTotal(dataFileOperatingService.selectQueryPageCount(page,dataFileOperatingDto));
        pageDto.setRecords(dataFileOperatingService.selectQueryPage(page,dataFileOperatingDto));
        return pageDto;
    }
}
