package io.platform.moneyManagement.biz.entity;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.enums.IdType;

import java.io.Serializable;
import java.util.Date;

import lombok.Data;

@Data
@TableName("invoice_bills")
public class InvoiceBills extends Model<InvoiceBills> implements Serializable {
    private static final long serialVersionUID = 5454155825314635342L;


    /**
     * id       db_column: id
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

    /**
     * 单据编号       db_column: bill_no
     */
    @TableField("bill_no")
    private String billNo;

    /**
     * 业务活动号       db_column: act_id
     */
    @TableField("act_id")
    private Integer actId;

    /**
     * 来源活动id       db_column: src_act_id
     */
    @TableField("src_act_id")
    private Integer srcActId;

    /**
     * 单据编号       db_column: src_bill_no
     */
    @TableField("src_bill_no")
    private String srcBillNo;

    /**
     * 来源行号       db_column: src_line_no
     */
    @TableField("src_line_no")
    private Integer srcLineNo;

    /**
     * 原始活动id       db_column: org_act_id
     */
    @TableField("org_act_id")
    private Integer orgActId;

    /**
     * 原始编号       db_column: org_bill_no
     */
    @TableField("org_bill_no")
    private String orgBillNo;

    /**
     * 原始行号       db_column: org_line_no
     */
    @TableField("org_line_no")
    private Integer orgLineNo;

    /**
     * 单据状态（1-新建2处理中6完成）       db_column: bill_status
     */
    @TableField("bill_status")
    private Integer billStatus;

    /**
     * 制单人id       db_column: op_user_id
     */
    @TableField("op_user_id")
    private Integer opUserId;

    /**
     * 制单人姓名       db_column: op_user_name
     */
    @TableField("op_user_name")
    private String opUserName;

    /**
     * 制单日期       db_column: create_date
     */
    @TableField("create_date")
    private Date createDate;

    /**
     * 业务日期       db_column: bill_date
     */
    @TableField("bill_date")
    private Date billDate;

    /**
     * 提交日期       db_column: post_date
     */
    @TableField("post_date")
    private Date postDate;

    /**
     * 备注       db_column: remarks
     */
    @TableField("remarks")
    private String remarks;

    /**
     * 子工程编号       db_column: project_sub_no
     */
    @TableField("project_sub_no")
    private String projectSubNo;

    /**
     * 承包单位id       db_column: branch_id
     */
    @TableField("branch_id")
    private Integer branchId;

    /**
     * 成本名称       db_column: budget_desc
     */
    @TableField("budget_desc")
    private String budgetDesc;

    /**
     * 本次开票总金额（下方所有发票金额之和）       db_column: inv_amt
     */
    @TableField("inv_amt")
    private Double invAmt;

    /**
     * 本次开票比例（%）       db_column: inv_amt_rate
     */
    @TableField("inv_amt_rate")
    private Double invAmtRate;

    /**
     * 款项性质（关联基础资料-PayPropertys）       db_column: pay_property_id
     */
    @TableField("pay_property_id")
    private Integer payPropertyId;

    /**
     * 累计开票金额       db_column: inv_total_amt
     */
    @TableField("inv_total_amt")
    private Double invTotalAmt;

    /**
     * 累计开票比例（%）       db_column: inv_total_rate
     */
    @TableField("inv_total_rate")
    private Double invTotalRate;

    /**
     * 施工进度比例(%)       db_column: progress_rate
     */
    @TableField("progress_rate")
    private Double progressRate;

    /**
     * 工程编号       db_column: contract_no
     */
    @TableField("contract_no")
    private String contractNo;


    /**
     * NC采购单号       db_column: purchase_nc_no
     */
    @TableField("purchase_nc_no")
    private String purchaseNcNo;

    /**
     * 预算费用项目ID       db_column: budget_id
     */
    @TableField("budget_id")
    private Integer budgetId;

    /**
     * 预算金额       db_column: budget_amt
     */
    @TableField("budget_amt")
    private Double budgetAmt;

    /**
     * 累计占用预算金额       db_column: budget_use_amt
     */
    @TableField("budget_use_amt")
    private Double budgetUseAmt;

    /**
     * 剩余预算金额       db_column: budget_blc_amt
     */
    @TableField("budget_blc_amt")
    private Double budgetBlcAmt;

    /**
     * 累计收入开票金额       db_column: sub_inv_amt_dr
     */
    @TableField("sub_inv_amt_dr")
    private Double subInvAmtDr;

    /**
     * 累计成本开票金额       db_column: sub_inv_amt_cr
     */
    @TableField("sub_inv_amt_cr")
    private Double subInvAmtCr;

    /**
     * 供应商累计成本开票金额       db_column: purchase_inv_amt_cr
     */
    @TableField("purchase_inv_amt_cr")
    private Double purchaseInvAmtCr;

    /**
     * 工程采购编号       db_column: purchase_no
     */
    @TableField("purchase_no")
    private String purchaseNo;

    /**
     * 分包单位id       db_column: purchase_id
     */
    @TableField("purchase_id")
    private Integer purchaseId;

    /**
     * 合同金额       db_column: contract_amt
     */
    @TableField("contract_amt")
    private Double contractAmt;

    /**
     * 合同审定金额       db_column: contract_audit_amt
     */
    @TableField("contract_audit_amt")
    private Double contractAuditAmt;

    /**
     * 附件地址
     */
    @TableField("file_Address")
    private String fileAddress;

    /**
     * 附件名称
     */
    @TableField("file_name")
    private String fileName;

    /**
     * 累计付款金额     sub_amt_cr
     */
    @TableField("sub_amt_cr")
    private Double subAmtCr;

    /**
     * 付款状态（T 已付全款，F 未处理，S 处理中）     sub_cr_status
     */
    @TableField("sub_cr_status")
    private String subCrStatus;

    /**
     * 是否是存续项目（T是 F不是）     is_sur
     */
    @TableField("is_sur")
    private String isSur;

    /**
     *      已结算收款金额（账龄分析用）
     */
    @TableField("settled_dr")
    private Double settledDr;

    /**
     *  打印时间
     */
    @TableField("print_time")
    private Date printTime;

    /**
     *  附件张数
     */
    @TableField("print_count")
    private String printCount;

    /**
     *      是否已经打印 0/1
     */
    @TableField("is_print")
    private Integer isPrint;
    /**
     *  是否特殊付款
     */
    @TableField("is_special")
    private Integer isSpecial;

    /**
     *      特殊付款说明
     */
    @TableField("special_item")
    private String specialItem;
//columns END
    /**
     *      二维码
     */
    @TableField("print_qr_code")
    private String printQrCode;

    /**
     * 更新时间
     */
    @TableField("modify_time")
    private Date modifyTime;

    /**
     * 更新人
     */
    @TableField("modify_user_id")
    private Long modifyUserId;






}
