package io.platform.moneyManagement.biz.entity;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.enums.IdType;

import java.io.Serializable;

import lombok.Data;

@Data
@TableName("invoice_bills_indirect")
public class InvoiceBillsIndirect extends Model<InvoiceBillsIndirect> implements Serializable {
    private static final long serialVersionUID = 5454155825314635342L;


    /**
     * id       db_column: id
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

    /**
     * 工程编号       db_column: bill_no
     */
    @TableField("bill_no")
    private String billNo;

    /**
     * 系统工程编号       db_column: project_sub_no
     */
    @TableField("project_sub_no")
    private String projectSubNo;

    /**
     * NC工程编号       db_column: nc_project_no
     */
    @TableField("nc_project_no")
    private String ncProjectNo;

    /**
     * 成本id       db_column: budget_id
     */
    @TableField("budget_id")
    private Integer budgetId;

    /**
     * 供应商id       db_column: purchase_id
     */
    @TableField("purchase_id")
    private Integer purchaseId;

    /**
     * 累计开票金额       db_column: sub_inv_amt_cr
     */
    @TableField("sub_inv_amt_cr")
    private Double  subInvAmtCr;

    /**
     * 累计付款金额       db_column: sub_amt_cr
     */
    @TableField("sub_amt_cr")
    private Double subAmtCr;
//columns END

}
