package io.platform.moneyManagement.biz.entity;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.enums.IdType;

import java.io.Serializable;
import lombok.Data;

@Data
@TableName("invoice_bills_plans")
public class InvoiceBillsPlans extends Model<InvoiceBillsPlans>  implements Serializable{
private static final long serialVersionUID = 5454155825314635342L;


    /**
     * id       db_column: id
     */
    @TableId(value="id", type= IdType.AUTO)
    private Integer id;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

    /**
     * 单据编号       db_column: bill_no
     */
    @TableField("bill_no")
    private String billNo;

    /**
     * 单据行号       db_column: line_no
     */
    @TableField("line_no")
    private Integer lineNo;

    /**
     * 业务活动号ID       db_column: act_id
     */
    @TableField("act_id")
    private Integer actId;

    /**
     * 来源活动ID       db_column: src_act_id
     */
    @TableField("src_act_id")
    private Integer srcActId;

    /**
     * 单据编号       db_column: src_bill_no
     */
    @TableField("src_bill_no")
    private String srcBillNo;

    /**
     * 来源行号       db_column: src_line_no
     */
    @TableField("src_lino_no")
    private Integer srcLinoNo;

    /**
     * 原始活动ID       db_column: org_act_id
     */
    @TableField("org_act_id")
    private Integer orgActId;

    /**
     * 原始编号       db_column: org_bill_no
     */
    @TableField("org_bill_no")
    private String orgBillNo;

    /**
     * 原始行号       db_column: org_line_no
     */
    @TableField("org_lino_no")
    private Integer orgLinoNo;

    /**
     * 备注       db_column: remark
     */
    @TableField("remark")
    private String remark;

    /**
     * 计划编号(根据PurchaseBills表选择)       db_column: purchase_no
     */
    @TableField("purchase_no")
    private String purchaseNo;

    /**
     * 累计开票数量       db_column: inv_total_qty
     */
    @TableField("inv_total_qty")
    private Integer invTotalQty;

    /**
     * 累计开票金额       db_column: inv_iotal_amt
     */
    @TableField("inv_iotal_amt")
    private Double invIotalAmt;

    /**
     * 累计到货数量       db_column: receive_total_qty
     */
    @TableField("receive_total_qty")
    private Double receiveTotalQty;

    /**
     * 采购单价       db_column: price
     */
    @TableField("price")
    private Double price;

    /**
     * 本次开票数量，手工录入       db_column: qty
     */
    @TableField("qty")
    private Integer qty;

    /**
     * 金额       db_column: amt
     */
    @TableField("amt")
    private Double amt;

    /**
     * 关联附件       db_column: attach
     */
    @TableField("attach")
    private String attach;
//columns END

}
