package io.platform.moneyManagement.biz.entity;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.enums.IdType;

import java.io.Serializable;

import lombok.Data;

@Data
@TableName("invoice_bills_shares")
public class InvoiceBillsShares extends Model<InvoiceBillsShares> implements Serializable {
    private static final long serialVersionUID = 5454155825314635342L;


    /**
     * id       db_column: id
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

    /**
     * 单据编号       db_column: bill_no
     */
    @TableField("bill_no")
    private String billNo;

    /**
     * 韩浩       db_column: line_no
     */
    @TableField("line_no")
    private Integer lineNo;

    /**
     * 活动号       db_column: act_id
     */
    @TableField("act_id")
    private Integer actId;

    /**
     * 备注       db_column: remarks
     */
    @TableField("remarks")
    private String remarks;

    /**
     * 子工程编号       db_column: project_sub_no
     */
    @TableField("project_sub_no")
    private String projectSubNo;

    /**
     * 预算费用项目id       db_column: budget_id
     */
    @TableField("budget_id")
    private Integer budgetId;

    /**
     * 预算金额       db_column: budget_amt
     */
    @TableField("budget_amt")
    private Double budgetAmt;

    /**
     * 供应商累计开票金额       db_column: purchase_inv_amt_cr
     */
    @TableField("purchase_inv_amt_cr")
    private Double purchaseInvAmtCr;

    /**
     * 累计占用预算金额       db_column: budget_use_amt
     */
    @TableField("budget_use_amt")
    private Double budgetUseAmt;

    /**
     * 剩余预算金额       db_column: budget_blc_amt
     */
    @TableField("budget_blc_amt")
    private Double budgetBlcAmt;

    /**
     * 本次分摊       db_column: share_amt
     */
    @TableField("share_amt")
    private Double shareAmt;

    /**
     * 预算附件       db_column: attach_id
     */
    @TableField("attach_id")
    private Integer attachId;

    /**
     * 承包单位ID       db_column: branch_id
     */
    @TableField("branch_id")
    private Integer branchId;
//columns END

}
