package io.platform.moneyManagement.biz.entity;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.enums.IdType;

import java.io.Serializable;
import lombok.Data;

@Data
@TableName("invoice_purchase")
public class InvoicePurchase extends Model<InvoicePurchase> implements Serializable {
    private static final long serialVersionUID = 5454155825314635342L;


    /**
     * id       db_column: id
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

    /**
     * 发票表id       db_column: inv_id
     */
    @TableField("inv_id")
    private Integer invId;

    /**
     * 到货明细id       db_column: purchase_item_id
     */
    @TableField("purchase_item_id")
    private Integer purchaseItemId;

    /**
     * 本次开票数量       db_column: time_qty
     */
    @TableField("time_qty")
    private Double timeQty;

    /**
     * 本次金额       db_column: time_amt
     */
    @TableField("time_amt")
    private Double timeAmt;

    /**
     * 单价       db_column: price
     */
    @TableField("price")
    private Double price;

    /**
     * 数量       db_column: qty
     */
    @TableField("qty")
    private Double qty;

    /**
     * 累计开票数量       db_column: sub_time_qty
     */
    @TableField("sub_time_qty")
    private Double subTimeQty;

    /**
     * 备注       db_column: remarks
     */
    @TableField("remarks")
    private String remarks;
//columns END

}
