package io.platform.moneyManagement.biz.entity;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.enums.IdType;

import java.io.Serializable;
import java.util.Date;

import lombok.Data;

@Data
@TableName("pay_cr_bills")
public class PayCrBills extends Model<PayCrBills> implements Serializable {
    private static final long serialVersionUID = 5454155825314635342L;


    /**
     * id       db_column: id
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

    /**
     * 单据编号       db_column: bill_no
     */
    @TableField("bill_no")
    private String billNo;

    /**
     * 业务活动号       db_column: act_id
     */
    @TableField("act_id")
    private Integer actId;

    /**
     * 来源活动号       db_column: src_act_id
     */
    @TableField("src_act_id")
    private Integer srcActId;

    /**
     * 单据编号       db_column: src_bill_no
     */
    @TableField("src_bill_no")
    private String srcBillNo;

    /**
     * 来源行号       db_column: src_line_no
     */
    @TableField("src_line_no")
    private Integer srcLineNo;

    /**
     * 原始活动号       db_column: org_act_id
     */
    @TableField("org_act_id")
    private Integer orgActId;

    /**
     * 原始编号       db_column: org_bill_no
     */
    @TableField("org_bill_no")
    private String orgBillNo;

    /**
     * 原始行号       db_column: org_line_no
     */
    @TableField("org_line_no")
    private Integer orgLineNo;

    /**
     * 单据状态（1-新建2处理中6完成）       db_column: bill_status
     */
    @TableField("bill_status")
    private Integer billStatus;

    /**
     * 制单人       db_column: op_user_id
     */
    @TableField("op_user_id")
    private Integer opUserId;

    /**
     * 制单人姓名       db_column: op_user_name
     */
    @TableField("op_user_name")
    private String opUserName;

    /**
     * 制单日期       db_column: create_date
     */
    @TableField("create_date")
    private Date createDate;

    /**
     * 收款日期       db_column: bill_date
     */
    @TableField("bill_date")
    private Date billDate;

    /**
     * 提交日期       db_column: post_date
     */
    @TableField("post_date")
    private Date postDate;

    /**
     * 备注       db_column: remarks
     */
    @TableField("remarks")
    private String remarks;

    /**
     * 承包单位id       db_column: branch_id
     */
    @TableField("branch_id")
    private Integer branchId;

    /**
     * 付款发票维护单据编号（关联InvoiceBills）       db_column: inv_bill_no
     */
    @TableField("inv_bill_no")
    private String invBillNo;

    /**
     * 子工程编号       db_column: project_sub_no
     */
    @TableField("project_sub_no")
    private String projectSubNo;

    /**
     * 预算费用id       db_column: budget_id
     */
    @TableField("budget_id")
    private Integer budgetId;

    /**
     * 供应商id       db_column: purcaser_id
     */
    @TableField("purcaser_id")
    private Integer purcaserId;

    /**
     * 合同编号       db_column: contract_no
     */
    @TableField("contract_no")
    private String contractNo;

    /**
     * 合同审定金额       db_column: contract_amt
     */
    @TableField("contract_amt")
    private Double contractAmt;

    /**
     * nc采购订单号       db_column: purcaser_nc_no
     */
    @TableField("purcaser_nc_no")
    private String purcaserNcNo;

    /**
     * 银行联行号       db_column: purcaser_bank_no
     */
    @TableField("purcaser_bank_no")
    private String purcaserBankNo;

    /**
     * 开户银行       db_column: purcaser_bank
     */
    @TableField("purcaser_bank")
    private String purcaserBank;

    /**
     * 银联账号       db_column: purcaser_acc_no
     */
    @TableField("purcaser_acc_no")
    private String purcaserAccNo;

    /**
     * 累计开票金额       db_column: inv_total_amt
     */
    @TableField("inv_total_amt")
    private Double invTotalAmt;

    /**
     * 累计付款金额       db_column: stl_total_amt
     */
    @TableField("stl_total_amt")
    private Double stlTotalAmt;

    /**
     * 本次付款金额       db_column: stl_amt
     */
    @TableField("stl_amt")
    private Double stlAmt;

    /**
     * 确认人       db_column: user_id
     */
    @TableField("user_id")
    private Integer userId;

    /**
     * 确认人姓名       db_column: user_name
     */
    @TableField("user_name")
    private String userName;

    /**
     * 确认时间       db_column: affirmant_date
     */
    @TableField("affirmant_date")
    private Date affirmantDate;

    /**
     * 确认意见       db_column: affirmant_remarks
     */
    @TableField("affirmant_remarks")
    private String affirmantRemarks;

    /**
     * 确认状态T通过F待处理       db_column: confirm_status
     */
    @TableField("confirm_status")
    private String confirmStatus;

    /**
     * 是否为特殊付款申请      db_column: flag_special
     */
    @TableField("flag_special")
    private Integer flagSpecial;

    /**
     * 是否已打印(T 已打印  F 未打印)      db_column: is_printed
     */
    @TableField("is_printed")
    private String isPrinted;
    /**
     * 打印时间
     */
    @TableField("print_time")
    private Date printTime;
    /**
     * 特殊付款说明
     */
    @TableField("special_item")
    private String specialItem;
    /**
     * erweima
     */
    @TableField("print_qr_code")
    private String printQrCode;
    //columns END
    @TableField("print_count")
    private String printCount;
    /**
     * 是否是存续项目的付款
     */
    @TableField("if_cx")
    private Integer ifCx;
    /**
     * 审定金额
     */
    @TableField("contract_audit_amt")
    private Double contractAuditAmt;
    /**
     * 质保金
     */
    @TableField("warranty_amt")
    private Double warrantyAmt;
    /**
     * 其他扣款
     */
    @TableField("other_amt")
    private Double otherAmt;
}
