package io.platform.moneyManagement.biz.entity;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.enums.IdType;

import java.io.Serializable;

import lombok.Data;

@Data
@TableName("pay_dr_bills")
public class PayDrBills extends Model<PayDrBills> implements Serializable {
    private static final long serialVersionUID = 5454155825314635342L;


    /**
     * id       db_column: id
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

    /**
     * 单据编号       db_column: bill_no
     */
    @TableField("bill_no")
    private String billNo;

    /**
     * 业务活动好       db_column: act_id
     */
    @TableField("act_id")
    private Integer actId;

    /**
     * 来源活动id       db_column: src_act_id
     */
    @TableField("src_act_id")
    private Integer srcActId;

    /**
     * 来源单号       db_column: src_bill_no
     */
    @TableField("src_bill_no")
    private String srcBillNo;

    /**
     * 来源行号       db_column: src_line_no
     */
    @TableField("src_line_no")
    private Integer srcLineNo;

    /**
     * 原始活动好       db_column: org_act_id
     */
    @TableField("org_act_id")
    private Integer orgActId;

    /**
     * 原始编号       db_column: org_bill_no
     */
    @TableField("org_bill_no")
    private String orgBillNo;

    /**
     * 原始行号       db_column: org_line_no
     */
    @TableField("org_line_no")
    private Integer orgLineNo;

    /**
     * 单据状态（1-新建2处理中6完成）       db_column: bill_status
     */
    @TableField("bill_status")
    private Integer billStatus;

    /**
     * 制单人id       db_column: op_user_id
     */
    @TableField("op_user_id")
    private Integer opUserId;

    /**
     * 制单人姓名       db_column: op_user_name
     */
    @TableField("op_user_name")
    private String opUserName;

    /**
     * 制单日期       db_column: create_date
     */
    @TableField("create_date")
    private java.util.Date createDate;

    /**
     * 收款日期       db_column: bill_date
     */
    @TableField("bill_date")
    private java.util.Date billDate;

    /**
     * 提交日期       db_column: post_date
     */
    @TableField("post_date")
    private java.util.Date postDate;

    /**
     * 备注       db_column: remarks
     */
    @TableField("remarks")
    private String remarks;

    /**
     * 承包单位id       db_column: branch_id
     */
    @TableField("branch_id")
    private Integer branchId;

    /**
     * 业主单位       db_column: corp_id
     */
    @TableField("corp_id")
    private Integer corpId;

    /**
     * 收款总金额（下方所有收款金额之和）       db_column: stl_amt
     */
    @TableField("stl_amt")
    private Double stlAmt;

    /**
     * 上传文件       db_column: attach_id
     */
    @TableField("attach_id")
    private String attachId;

    /**
     * 确认人       db_column: user_id
     */
    @TableField("user_id")
    private Integer userId;

    /**
     * 确认人姓名       db_column: user_name
     */
    @TableField("user_name")
    private String userName;

    /**
     * 打印二维码       db_column: print_qr_code
     */
    @TableField("print_qr_code")
    private String printQrCode;

    /**
     * 确认时间       db_column: affirmant_date
     */
    @TableField("affirmant_date")
    private java.util.Date affirmantDate;

    /**
     * 确认意见       db_column: affirmant_remarks
     */
    @TableField("affirmant_remarks")
    private String affirmantRemarks;

    /**
     * 确认状态T通过F待处理S未通过       db_column: confirm_status
     */
    @TableField("confirm_status")
    private String confirmStatus;

    /**
     * 操作类型       db_column: is_refund
     */
    @TableField("is_refund")
    private Integer isRefund;

    /**
     * 附件张数       db_column: annex
     */
    @TableField("annex")
    private Integer annex;

    /**
     * 收款人       db_column: attn
     */
    @TableField("attn")
    private String attn;

    /**
     * 银行联行号       db_column: bank_number
     */
    @TableField("bank_number")
    private String bankNumber;

    /**
     * 开户银行       db_column: bank
     */
    @TableField("bank")
    private String bank;

    /**
     * 银行账号       db_column: bank_acc_no
     */
    @TableField("bank_acc_no")
    private String bankAccNo;

    /**
     * 报销内容       db_column: refund_content
     */
    @TableField("refund_content")
    private String refundContent;

    /**
     * 打印次数       db_column: printed_count
     */
    @TableField("printed_count")
    private Integer printedCount;

    /**
     * 打印人       db_column: printed_user
     */
    @TableField("printed_user")
    private Integer printedUser;

//columns END

}
