package io.platform.moneyManagement.biz.entity;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.enums.IdType;

import java.io.Serializable;

import lombok.Data;

@Data
@TableName("pay_dr_bills_items")
public class PayDrBillsItems extends Model<PayDrBillsItems> implements Serializable {
    private static final long serialVersionUID = 5454155825314635342L;


    /**
     * id       db_column: id
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

    /**
     * 单据编号       db_column: bill_no
     */
    @TableField("bill_no")
    private String billNo;

    /**
     * 单据行号       db_column: line_no
     */
    @TableField("line_no")
    private Integer lineNo;

    /**
     * 业务活动号       db_column: act_id
     */
    @TableField("act_id")
    private Integer actId;

    /**
     * 来源活动号       db_column: src_act_id
     */
    @TableField("src_act_id")
    private Integer srcActId;

    /**
     * 来源行号       db_column: src_line_no
     */
    @TableField("src_line_no")
    private Integer srcLineNo;

    /**
     * 单据编号       db_column: src_bill_no
     */
    @TableField("src_bill_no")
    private String srcBillNo;

    /**
     * 原始活动号       db_column: org_act_id
     */
    @TableField("org_act_id")
    private Integer orgActId;

    /**
     * 原始编号       db_column: org_bill_no
     */
    @TableField("org_bill_no")
    private String orgBillNo;

    /**
     * 原始行号       db_column: org_line_no
     */
    @TableField("org_line_no")
    private Integer orgLineNo;

    /**
     * 备注       db_column: remarks
     */
    @TableField("remarks")
    private String remarks;

    /**
     * 子工程编号       db_column: project_sub_no
     */
    @TableField("project_sub_no")
    private String projectSubNo;

    /**
     * 承包单位       db_column: branch_id
     */
    @TableField("branch_id")
    private Integer branchId;

    /**
     * 累计开票金额       db_column: inv_total_amt
     */
    @TableField("inv_total_amt")
    private Double invTotalAmt;

    /**
     * 累计开票比例       db_column: inv_total_rate
     */
    @TableField("inv_total_rate")
    private Double invTotalRate;

    /**
     * 本次收款金额       db_column: stl_amt
     */
    @TableField("stl_amt")
    private Double stlAmt;

    /**
     * 累计收款金额       db_column: stl_total_amt
     */
    @TableField("stl_total_amt")
    private Double stlTotalAmt;

    /**
     * 累计收款比例       db_column: stl_total_rate
     */
    @TableField("stl_total_rate")
    private Double stlTotalRate;
//columns END

}
