package io.platform.moneyManagement.biz.mapper;

import io.platform.base.common.BaseMapper;
import io.platform.moneyManagement.biz.entity.InvoiceBills;
import io.platform.moneyManagement.biz.entity.InvoiceBillsShares;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;


/**
 * Created by sevelli on 2017/9/6.
 */
@Mapper
public interface InvoiceBillsSharesMapper extends BaseMapper<InvoiceBillsShares> {

    @Select("select * from invoice_bills_shares where bill_no = #{invo.billNo}")
    List<InvoiceBillsShares> selectInvoShareList(@Param("invo") InvoiceBills invoiceBills);

    @Insert("INSERT INTO invoice_bills_shares ( BILL_NO, LINE_NO, ACT_ID, PROJECT_SUB_NO, BUDGET_ID, BUDGET_AMT, BUDGET_USE_AMT, BUDGET_BLC_AMT, SHARE_AMT, BRANCH_ID)  VALUES" +
            " ( #{invShar.billNo}, #{invShar.lineNo}, #{invShar.actId}, #{invShar.projectSubNo}, #{invShar.budgetId}, #{invShar.budgetAmt}, #{invShar.budgetUseAmt}, #{invShar.budgetBlcAmt}" +
            ", #{invShar.shareAmt}, #{invShar.branchId} )")
    boolean insertInvShares(@Param("invShar") InvoiceBillsShares is);

    @Select("select * from invoice_bills_shares where bill_no = #{invo.billNo} AND act_id = 202 AND branch_id = #{invo.branchId}")
    List<InvoiceBillsShares> selectWithdrawalInvoShareList(@Param("invo") InvoiceBills invoiceBills);
}
