
package io.platform.moneyManagement.service.client.impl;

import com.alibaba.dubbo.config.annotation.Service;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;


import io.platform.contract.service.client.api.ProjectBillsStlPlansServiceClient;
import io.platform.moneyManagement.biz.entity.InvoiceBillsAttachs;
import io.platform.moneyManagement.biz.service.InvoiceBillsAttachsService;
import io.platform.moneyManagement.dto.InvoiceBillsAttachsDto;
import io.platform.moneyManagement.service.client.api.InvoiceBillsAttachsServiceClient;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

import io.platform.base.common.BaseServiceClient;
import io.platform.base.common.utils.ExecuteResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Created by sevelli on 2017/8/31.
 */
@Component
@Service(version = "1.0.0", interfaceClass = InvoiceBillsAttachsServiceClient.class)
public class InvoiceBillsAttachsServiceClientImpl extends BaseServiceClient<InvoiceBillsAttachs, InvoiceBillsAttachsDto> implements InvoiceBillsAttachsServiceClient {
    private Logger logger = LoggerFactory.getLogger(getClass());
    @Resource
    private InvoiceBillsAttachsService invoiceBillsAttachsService;

    @Override
    public InvoiceBillsAttachsDto queryObject(Long id) {
        InvoiceBillsAttachs invoiceBillsAttachs = invoiceBillsAttachsService.selectById(id);
        InvoiceBillsAttachsDto invoiceBillsAttachsDto = new InvoiceBillsAttachsDto();
        BeanUtils.copyProperties(invoiceBillsAttachs, invoiceBillsAttachsDto);
        return invoiceBillsAttachsDto;
    }

    @Override
    public List<InvoiceBillsAttachsDto> queryList(Map<String, Object> map) {
        List<InvoiceBillsAttachs> invoiceBillsAttachsList = invoiceBillsAttachsService.selectByMap(map);
        return convertList(invoiceBillsAttachsList, InvoiceBillsAttachsDto.class);
    }

    @Override
    public int queryTotal(Map<String, Object> map) {
        EntityWrapper<InvoiceBillsAttachs> ew = new EntityWrapper<>();
        ew.allEq(map);
        return invoiceBillsAttachsService.selectCount(ew);
    }

    @Override
    public ExecuteResult<String> save(InvoiceBillsAttachsDto invoiceBillsAttachsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            InvoiceBillsAttachs invoiceBillsAttachs = new InvoiceBillsAttachs();
            revert(invoiceBillsAttachsDto, invoiceBillsAttachs);
            boolean flag = invoiceBillsAttachsService.insert(invoiceBillsAttachs);
            if (!flag) {
                result.addErrorMessage("保存失败。");
            }
        } catch (Exception e) {
            logger.error(" 保存错误：" + e.toString(), e);
            result.addErrorMessage("保存错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> update(InvoiceBillsAttachsDto invoiceBillsAttachsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            InvoiceBillsAttachs invoiceBillsAttachs = new InvoiceBillsAttachs();
            revert(invoiceBillsAttachsDto, invoiceBillsAttachs);

            boolean flag = invoiceBillsAttachsService.updateById(invoiceBillsAttachs);
            if (!flag) {
                result.addErrorMessage("更新失败。");
            }
        } catch (Exception e) {
            logger.error(" 更新错误：" + e.toString(), e);
            result.addErrorMessage("更新错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> delete(Long id) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = invoiceBillsAttachsService.deleteById(id);
            if (!flag) {
                result.addErrorMessage("删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = invoiceBillsAttachsService.deleteBatchIds(ids);
            if (!flag) {
                result.addErrorMessage("批量删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public Page<InvoiceBillsAttachsDto> getPage(Page<InvoiceBillsAttachsDto> pageDto, InvoiceBillsAttachsDto invoiceBillsAttachsDto) {
        Page<InvoiceBillsAttachs> page = new Page<>(pageDto.getCurrent(), pageDto.getSize());
        page.setAsc(pageDto.isAsc());
        page.setOrderByField(pageDto.getOrderByField());
        page.setCondition(pageDto.getCondition());
        InvoiceBillsAttachs invoiceBillsAttachs = new InvoiceBillsAttachs();
        revert(invoiceBillsAttachsDto, invoiceBillsAttachs);
        EntityWrapper<InvoiceBillsAttachs> wrapper = new EntityWrapper<>();
        wrapper.setEntity(invoiceBillsAttachs);
        page = invoiceBillsAttachsService.selectPage(page, wrapper);
        List<InvoiceBillsAttachsDto> invoiceBillsAttachsDtoList = convertList(page.getRecords(), InvoiceBillsAttachsDto.class);
        pageDto.setTotal(invoiceBillsAttachsService.selectCount(wrapper));
        pageDto.setRecords(invoiceBillsAttachsDtoList);
        return pageDto;
    }
}
