
package io.platform.moneyManagement.service.client.impl;

import com.alibaba.dubbo.config.annotation.Service;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;

import io.platform.moneyManagement.biz.entity.InvoiceBillsIndirect;
import io.platform.moneyManagement.biz.service.InvoiceBillsIndirectService;
import io.platform.moneyManagement.dto.InvoiceBillsIndirectDto;
import io.platform.moneyManagement.service.client.api.InvoiceBillsIndirectServiceClient;
import io.platform.moneyManagement.service.client.api.InvoiceBillsServiceClient;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

import io.platform.base.common.BaseServiceClient;
import io.platform.base.common.utils.ExecuteResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Created by sevelli on 2017/8/31.
 */
@Component
@Service(version = "1.0.0", interfaceClass = InvoiceBillsIndirectServiceClient.class)
public class InvoiceBillsIndirectServiceClientImpl extends BaseServiceClient<InvoiceBillsIndirect, InvoiceBillsIndirectDto> implements InvoiceBillsIndirectServiceClient {
    private Logger logger = LoggerFactory.getLogger(getClass());
    @Resource
    private InvoiceBillsIndirectService invoiceBillsIndirectService;

    @Override
    public InvoiceBillsIndirectDto queryObject(Long id) {
        InvoiceBillsIndirect invoiceBillsIndirect = invoiceBillsIndirectService.selectById(id);
        InvoiceBillsIndirectDto invoiceBillsIndirectDto = new InvoiceBillsIndirectDto();
        BeanUtils.copyProperties(invoiceBillsIndirect, invoiceBillsIndirectDto);
        return invoiceBillsIndirectDto;
    }

    @Override
    public List<InvoiceBillsIndirectDto> queryList(Map<String, Object> map) {
        List<InvoiceBillsIndirect> invoiceBillsIndirectList = invoiceBillsIndirectService.selectByMap(map);
        return convertList(invoiceBillsIndirectList, InvoiceBillsIndirectDto.class);
    }

    @Override
    public int queryTotal(Map<String, Object> map) {
        EntityWrapper<InvoiceBillsIndirect> ew = new EntityWrapper<>();
        ew.allEq(map);
        return invoiceBillsIndirectService.selectCount(ew);
    }

    @Override
    public ExecuteResult<String> save(InvoiceBillsIndirectDto invoiceBillsIndirectDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            InvoiceBillsIndirect invoiceBillsIndirect = new InvoiceBillsIndirect();
            revert(invoiceBillsIndirectDto, invoiceBillsIndirect);
            boolean flag = invoiceBillsIndirectService.insert(invoiceBillsIndirect);
            if (!flag) {
                result.addErrorMessage("保存失败。");
            }
        } catch (Exception e) {
            logger.error(" 保存错误：" + e.toString(), e);
            result.addErrorMessage("保存错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> update(InvoiceBillsIndirectDto invoiceBillsIndirectDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            InvoiceBillsIndirect invoiceBillsIndirect = new InvoiceBillsIndirect();
            revert(invoiceBillsIndirectDto, invoiceBillsIndirect);

            boolean flag = invoiceBillsIndirectService.updateById(invoiceBillsIndirect);
            if (!flag) {
                result.addErrorMessage("更新失败。");
            }
        } catch (Exception e) {
            logger.error(" 更新错误：" + e.toString(), e);
            result.addErrorMessage("更新错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> delete(Long id) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = invoiceBillsIndirectService.deleteById(id);
            if (!flag) {
                result.addErrorMessage("删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = invoiceBillsIndirectService.deleteBatchIds(ids);
            if (!flag) {
                result.addErrorMessage("批量删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public Page<InvoiceBillsIndirectDto> getPage(Page<InvoiceBillsIndirectDto> pageDto, InvoiceBillsIndirectDto invoiceBillsIndirectDto) {
        Page<InvoiceBillsIndirect> page = new Page<>(pageDto.getCurrent(), pageDto.getSize());
        page.setAsc(pageDto.isAsc());
        page.setOrderByField(pageDto.getOrderByField());
        page.setCondition(pageDto.getCondition());
        InvoiceBillsIndirect invoiceBillsIndirect = new InvoiceBillsIndirect();
        revert(invoiceBillsIndirectDto, invoiceBillsIndirect);
        EntityWrapper<InvoiceBillsIndirect> wrapper = new EntityWrapper<>();
        wrapper.setEntity(invoiceBillsIndirect);
        page = invoiceBillsIndirectService.selectPage(page, wrapper);
        List<InvoiceBillsIndirectDto> invoiceBillsIndirectDtoList = convertList(page.getRecords(), InvoiceBillsIndirectDto.class);
        pageDto.setTotal(invoiceBillsIndirectService.selectCount(wrapper));
        pageDto.setRecords(invoiceBillsIndirectDtoList);
        return pageDto;
    }
}
