
package io.platform.moneyManagement.service.client.impl;

import com.alibaba.dubbo.config.annotation.Service;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;


import io.platform.contract.service.client.api.ProjectBillsStlPlansServiceClient;
import io.platform.engineering.biz.entity.Bpurchases;
import io.platform.engineering.biz.service.BbranchsService;
import io.platform.engineering.biz.service.BcorpsService;
import io.platform.engineering.biz.service.BpurchasesService;
import io.platform.moneyManagement.biz.entity.InvoiceBills;
import io.platform.moneyManagement.biz.entity.InvoiceBillsItems;
import io.platform.moneyManagement.biz.entity.InvoiceBillsPlans;
import io.platform.moneyManagement.biz.entity.InvoicePurchase;
import io.platform.moneyManagement.biz.service.InvoiceBillsItemsService;
import io.platform.moneyManagement.biz.service.InvoiceBillsPlansService;
import io.platform.moneyManagement.biz.service.InvoiceBillsService;
import io.platform.moneyManagement.biz.service.InvoicePurchaseService;
import io.platform.moneyManagement.dto.InvoiceBillsPlansDto;
import io.platform.moneyManagement.service.client.api.InvoiceBillsPlansServiceClient;
import io.platform.project.biz.entity.ProjectBillsSubs;
import io.platform.project.biz.entity.Projectbills;
import io.platform.project.biz.service.ProjectBillsSubsService;
import io.platform.project.biz.service.ProjectbillsService;
import io.platform.purchase.biz.entity.PurchaseBillsItems;
import io.platform.purchase.biz.service.PurchaseBillsItemsService;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

import io.platform.base.common.BaseServiceClient;
import io.platform.base.common.utils.ExecuteResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.transaction.annotation.Transactional;

/**
 * Created by sevelli on 2017/8/31.
 */
@Component
@Service(version = "1.0.0", interfaceClass = InvoiceBillsPlansServiceClient.class)
public class InvoiceBillsPlansServiceClientImpl extends BaseServiceClient<InvoiceBillsPlans, InvoiceBillsPlansDto> implements InvoiceBillsPlansServiceClient {
    private Logger logger = LoggerFactory.getLogger(getClass());
    @Resource
    private BcorpsService bcorpsService;
    @Resource
    private BbranchsService bbranchsService;
    @Resource
    private BpurchasesService bpurchasesService;
    @Resource
    private ProjectbillsService projectbillsService;
    @Resource
    private InvoiceBillsService invoiceBillsService;
    @Resource
    private InvoicePurchaseService invoicePurchaseService;
    @Resource
    private InvoiceBillsItemsService invoiceBillsItemsService;
    @Resource
    private ProjectBillsSubsService projectBillsSubsService;
    @Resource
    private InvoiceBillsPlansService invoiceBillsPlansService;
    @Resource
    private PurchaseBillsItemsService purchaseBillsItemsService;

    @Override
    public InvoiceBillsPlansDto queryObject(Long id) {
        InvoiceBillsPlans invoiceBillsPlans = invoiceBillsPlansService.selectById(id);
        InvoiceBillsPlansDto invoiceBillsPlansDto = new InvoiceBillsPlansDto();
        BeanUtils.copyProperties(invoiceBillsPlans, invoiceBillsPlansDto);
        return invoiceBillsPlansDto;
    }

    @Override
    public List<InvoiceBillsPlansDto> queryList(Map<String, Object> map) {
        List<InvoiceBillsPlans> invoiceBillsPlansList = invoiceBillsPlansService.selectByMap(map);
        return convertList(invoiceBillsPlansList, InvoiceBillsPlansDto.class);
    }

    @Override
    public int queryTotal(Map<String, Object> map) {
        EntityWrapper<InvoiceBillsPlans> ew = new EntityWrapper<>();
        ew.allEq(map);
        return invoiceBillsPlansService.selectCount(ew);
    }

    @Override
    public ExecuteResult<String> save(InvoiceBillsPlansDto invoiceBillsPlansDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            InvoiceBillsPlans invoiceBillsPlans = new InvoiceBillsPlans();
            revert(invoiceBillsPlansDto, invoiceBillsPlans);
            boolean flag = invoiceBillsPlansService.insert(invoiceBillsPlans);
            if (!flag) {
                result.addErrorMessage("保存失败。");
            }
        } catch (Exception e) {
            logger.error(" 保存错误：" + e.toString(), e);
            result.addErrorMessage("保存错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> update(InvoiceBillsPlansDto invoiceBillsPlansDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            InvoiceBillsPlans invoiceBillsPlans = new InvoiceBillsPlans();
            revert(invoiceBillsPlansDto, invoiceBillsPlans);

            boolean flag = invoiceBillsPlansService.updateById(invoiceBillsPlans);
            if (!flag) {
                result.addErrorMessage("更新失败。");
            }
        } catch (Exception e) {
            logger.error(" 更新错误：" + e.toString(), e);
            result.addErrorMessage("更新错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> delete(Long id) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = invoiceBillsPlansService.deleteById(id);
            if (!flag) {
                result.addErrorMessage("删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = invoiceBillsPlansService.deleteBatchIds(ids);
            if (!flag) {
                result.addErrorMessage("批量删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public Page<InvoiceBillsPlansDto> getPage(Page<InvoiceBillsPlansDto> pageDto, InvoiceBillsPlansDto invoiceBillsPlansDto) {
        Page<InvoiceBillsPlans> page = new Page<>(pageDto.getCurrent(), pageDto.getSize());
        page.setAsc(pageDto.isAsc());
        page.setOrderByField(pageDto.getOrderByField());
        page.setCondition(pageDto.getCondition());
        InvoiceBillsPlans invoiceBillsPlans = new InvoiceBillsPlans();
        revert(invoiceBillsPlansDto, invoiceBillsPlans);
        EntityWrapper<InvoiceBillsPlans> wrapper = new EntityWrapper<>();
        wrapper.setEntity(invoiceBillsPlans);
        page = invoiceBillsPlansService.selectPage(page, wrapper);
        List<InvoiceBillsPlansDto> invoiceBillsPlansDtoList = convertList(page.getRecords(), InvoiceBillsPlansDto.class);
        pageDto.setTotal(invoiceBillsPlansService.selectCount(wrapper));
        pageDto.setRecords(invoiceBillsPlansDtoList);
        return pageDto;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Map<String, Object> selectMaterialPrice(Integer id) {
        try {
            Map<String, Object> map = new HashMap<>();
            InvoiceBills invoiceBills = invoiceBillsService.selectById(id);
            EntityWrapper<InvoiceBillsItems> invoiceBillsItemsEntityWrapper = new EntityWrapper<>();
            invoiceBillsItemsEntityWrapper.eq("bill_no", invoiceBills.getBillNo());
            EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
            projectBillsSubsEntityWrapper.eq("project_sub_no", invoiceBills.getProjectSubNo());
            PurchaseBillsItems purchaseBillsItems = new PurchaseBillsItems();
            purchaseBillsItems.setProjectSubNo(invoiceBills.getProjectSubNo());
            purchaseBillsItems.setPurchaseId(invoiceBills.getPurchaseId().floatValue());
            String beginTime = new String("2020-11-19 00:00:00");
            SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            boolean isOne = false;
            Date sd1 = df.parse(beginTime);
            long long1 = invoiceBills.getCreateDate().getTime();
            long long2 = sd1.getTime();
            // 2020-11-19 之前创建的
            isOne = long1 < long2;
            List<PurchaseBillsItems> itemsList = new ArrayList<>();
            if (isOne) {
                purchaseBillsItems.setActId(9); // 原先活动是 9 ，9代表材料款的每次到货数记录 ,一开始为1，现改为9
                itemsList = purchaseBillsItemsService.selectList(new EntityWrapper<>(purchaseBillsItems));
                for (PurchaseBillsItems item : itemsList) {
                    item.setContractQty(item.getReceiveTotalQty());
                }
            } else {
                purchaseBillsItems.setActId(4);
                itemsList = purchaseBillsItemsService.selectList(new EntityWrapper<>(purchaseBillsItems));
                for  ( int  i  =   0 ; i  <  itemsList.size()  -   1 ; i ++ )  {
                    for  ( int  j  =  itemsList.size()  -   1 ; j  >  i; j -- )  {
                        String contractPrice = String.valueOf(itemsList.get(i).getContractPrice());
                        String contractPrice2 = String.valueOf(itemsList.get(j).getContractPrice());
                        if (!Objects.equals(itemsList.get(i).getId(), itemsList.get(j).getId()) && itemsList.get(i).getBillNo().equals(itemsList.get(j).getBillNo())
                                && itemsList.get(i).getItemName().equals(itemsList.get(j).getItemName()) && contractPrice.equals(contractPrice2)) {
                            itemsList.get(i).setContractQty(Double.parseDouble(String.format("%.4f", itemsList.get(i).getContractQty() + itemsList.get(j).getContractQty())));
                            itemsList.get(i).setInvTotalQty(Double.parseDouble(String.format("%.4f", itemsList.get(i).getInvTotalQty() + itemsList.get(j).getInvTotalQty())));
                            itemsList.remove(j);
                        }
                    }
                }
                for (PurchaseBillsItems pb : itemsList) {
                    EntityWrapper<InvoicePurchase> purchaseEntityWrapper = new EntityWrapper<>();
                    purchaseEntityWrapper.eq("inv_id", invoiceBills.getId())
                            .eq("purchase_item_id", pb.getId());
                    InvoicePurchase invoicePurchase = invoicePurchaseService.selectOne(purchaseEntityWrapper);
                    if (invoicePurchase != null) {
                        pb.setTimeQty(invoicePurchase.getTimeQty());
                        pb.setTimeAmt(invoicePurchase.getTimeAmt());
                    }
                }
            }
            ProjectBillsSubs subs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
            EntityWrapper<Projectbills> projectbillsEntityWrapper = new EntityWrapper<>();
            projectbillsEntityWrapper.eq("bill_no", subs.getBillNo());
            Projectbills projectbills = projectbillsService.selectOne(projectbillsEntityWrapper);
            map.put("bills", invoiceBills);
            map.put("purchase", bpurchasesService.selectById(invoiceBills.getPurchaseId()));
            map.put("branch", bbranchsService.selectById(invoiceBills.getBranchId()));
            map.put("corp", bcorpsService.selectById(subs.getCorpId()));
            map.put("sub", subs);
            map.put("invoiceItem", invoiceBillsItemsService.selectList(invoiceBillsItemsEntityWrapper));
            map.put("itemList", itemsList);
            map.put("zong", projectbills);
            map.put("shiji", bbranchsService.selectById(projectbills.getConstructorId()));
            return map;
        } catch (ParseException e) {
            e.printStackTrace();
        }
        return null;
    }

    @Override
    public ExecuteResult<String> deleteMaterialPrice(Integer id) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        InvoiceBills invoiceBills = invoiceBillsService.selectById(id);
        return result;
    }
}
