
package io.platform.moneyManagement.service.client.impl;

import com.alibaba.dubbo.config.annotation.Service;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;

import io.platform.approvalConfiguration.biz.entity.Audit;
import io.platform.approvalConfiguration.biz.service.AuditItemsService;
import io.platform.base.common.BaseServiceClient;
import io.platform.budget.biz.entity.ProjectBillsBudgets;
import io.platform.budget.biz.service.ProjectBillsBudgetsService;
import io.platform.budget.dto.ProjectBillsBudgetsDto;
import io.platform.contract.biz.entity.OtherProject;
import io.platform.contract.biz.entity.ProjectBillsStlPlans;
import io.platform.contract.biz.service.OtherProjectService;
import io.platform.contract.biz.service.ProjectBillsStlPlansService;
import io.platform.engineering.biz.entity.*;
import io.platform.engineering.biz.service.*;
import io.platform.moneyManagement.biz.entity.*;
import io.platform.moneyManagement.biz.service.*;
import io.platform.moneyManagement.dto.InvoiceBillsDto;
import io.platform.moneyManagement.service.client.api.InvoiceBillsServiceClient;
import io.platform.project.biz.entity.ProjectBillsSubs;
import io.platform.project.biz.entity.Projectbills;
import io.platform.project.biz.entity.SubContractBills;
import io.platform.project.biz.service.ProjectBillsSubsService;
import io.platform.project.biz.service.ProjectbillsService;
import io.platform.project.biz.service.SubContractBillsService;
import io.platform.project.dto.ProjectBS;
import io.platform.project.dto.ProjectBillsSubsDto;
import io.platform.project.dto.SubContractBillsDto;
import io.platform.purchase.biz.entity.PurchaseBills;
import io.platform.purchase.biz.entity.PurchaseBillsItems;
import io.platform.purchase.biz.entity.PurchaseBillsProjs;
import io.platform.purchase.biz.service.PurchaseBillsItemsService;
import io.platform.purchase.biz.service.PurchaseBillsProjsService;
import io.platform.purchase.biz.service.PurchaseBillsService;
import io.platform.sys.biz.entity.SysRole;
import io.platform.sys.dto.SysUserDto;
import io.platform.utils.DataUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.text.SimpleDateFormat;
import java.util.*;

import io.platform.base.common.utils.ExecuteResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.transaction.NoTransactionException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;

/**
 * Created by sevelli on 2017/8/31.
 */
@Component
@Service(version = "1.0.0", interfaceClass = InvoiceBillsServiceClient.class)
public class InvoiceBillsServiceClientImpl extends BaseServiceClient<InvoiceBills, InvoiceBillsDto> implements InvoiceBillsServiceClient {
    private Logger logger = LoggerFactory.getLogger(getClass());
    @Resource
    private BcorpsService bcorpsService;
    @Resource
    private BdeptsService bdeptsService;
    @Resource
    private BbranchsService bbranchsService;
    @Resource
    private AuditItemsService auditItemsService;
    @Resource
    private PayCrBillsService payCrBillsService;
    @Resource
    private BpurchasesService bpurchasesService;
    @Resource
    private InvoiceBillsService invoiceBillsService;
    @Resource
    private OtherProjectService otherProjectService;
    @Resource
    private ProjectbillsService projectbillsService;
    @Resource
    private BpayPropertysService bpayPropertysService;
    @Resource
    private BprojectTypesService bprojectTypesService;
    @Resource
    private PurchaseBillsService purchaseBillsService;
    @Resource
    private InvoicePurchaseService invoicePurchaseService;
    @Resource
    private SubContractBillsService subContractBillsService;
    @Resource
    private InvoiceBillsPlansService invoiceBillsPlansService;
    @Resource
    private PurchaseBillsItemsService purchaseBillsItemsService;
    @Resource
    private ProjectBillsSubsService projectBillsSubsService;
    @Resource
    private InvoiceBillsItemsService invoiceBillsItemsService;
    @Resource
    private PurchaseBillsProjsService purchaseBillsProjsService;
    @Resource
    private InvoiceBillsSharesService invoiceBillsSharesService;
    @Resource
    private InvoiceBillsAttachsService invoiceBillsAttachsService;
    @Resource
    private ProjectBillsBudgetsService projectBillsBudgetsService;
    @Resource
    private InvoiceBillsIndirectService invoiceBillsIndirectService;
    @Resource
    private ProjectBillsStlPlansService projectBillsStlPlansService;

    @Override
    public InvoiceBillsDto queryObject(Long id) {
        InvoiceBills invoiceBills = invoiceBillsService.selectById(id);
        InvoiceBillsDto invoiceBillsDto = new InvoiceBillsDto();
        BeanUtils.copyProperties(invoiceBills, invoiceBillsDto);
        return invoiceBillsDto;
    }

    @Override
    public List<InvoiceBillsDto> queryList(Map<String, Object> map) {
        List<InvoiceBills> invoiceBillsList = invoiceBillsService.selectByMap(map);
        return convertList(invoiceBillsList, InvoiceBillsDto.class);
    }

    @Override
    public int queryTotal(Map<String, Object> map) {
        EntityWrapper<InvoiceBills> ew = new EntityWrapper<>();
        ew.allEq(map);
        return invoiceBillsService.selectCount(ew);
    }

    @Override
    public ExecuteResult<String> save(InvoiceBillsDto invoiceBillsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            InvoiceBills invoiceBills = new InvoiceBills();
            revert(invoiceBillsDto, invoiceBills);
            boolean flag = invoiceBillsService.insert(invoiceBills);
            if (!flag) {
                result.addErrorMessage("保存失败。");
            }
        } catch (Exception e) {
            logger.error(" 保存错误：" + e.toString(), e);
            result.addErrorMessage("保存错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> update(InvoiceBillsDto invoiceBillsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            InvoiceBills invoiceBills = new InvoiceBills();
            revert(invoiceBillsDto, invoiceBills);

            boolean flag = invoiceBillsService.updateById(invoiceBills);
            if (!flag) {
                result.addErrorMessage("更新失败。");
            }
        } catch (Exception e) {
            logger.error(" 更新错误：" + e.toString(), e);
            result.addErrorMessage("更新错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> delete(Long id) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = invoiceBillsService.deleteById(id);
            if (!flag) {
                result.addErrorMessage("删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> deleteInvoice(InvoiceBillsDto invoiceBillsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            if (invoiceBillsDto != null && invoiceBillsDto.getId() != null) {
                EntityWrapper<InvoiceBills> entityWrapper = new EntityWrapper<>();
                entityWrapper.eq("id", invoiceBillsDto.getId()).eq("act_id", 107);
                InvoiceBills invoiceBills = invoiceBillsService.selectOne(entityWrapper);
                EntityWrapper<InvoiceBillsItems> invoiceBillsItemsEntityWrapper = new EntityWrapper<>();
                invoiceBillsItemsEntityWrapper.setSqlSelect("id").eq("bill_no", invoiceBills.getBillNo())
                        .eq("act_id", 107).eq("project_sub_no", invoiceBills.getProjectSubNo());
                List<InvoiceBillsItems> billsItems = invoiceBillsItemsService.selectList(invoiceBillsItemsEntityWrapper);
                if (billsItems.size() != 0) {
                    for (InvoiceBillsItems ib : billsItems) {
                        boolean deleteById = invoiceBillsItemsService.deleteById(ib);
                        if (!deleteById) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            logger.error("明细删除失败");
                            result.addErrorMessage("明细删除失败");
                            return result;
                        }
                    }
                }
                boolean flag = invoiceBillsService.deleteById(invoiceBills);
                if (!flag) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("收款发票记录删除失败");
                    return result;
                }
            } else {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("未获取信息 请确认后提交");
                return result;
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除失败");
        }
        return result;
    }

    /*
     * 删除
     * */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> deleteEngineering(InvoiceBillsDto invoiceBillsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            if (invoiceBillsDto != null && invoiceBillsDto.getId() != null) {
                InvoiceBills invoiceBills = invoiceBillsService.selectById(invoiceBillsDto.getId());
                if ("F".equals(invoiceBills.getIsSur()) && Objects.equals(invoiceBills.getBudgetId(), 2)) {
                    EntityWrapper<PurchaseBillsItems> itemsEntityWrapper = new EntityWrapper<>();
                    itemsEntityWrapper.eq("bill_no", invoiceBills.getBillNo())
                            .eq("project_sub_no", invoiceBills.getProjectSubNo())
                            .eq("purchase_id", invoiceBills.getPurchaseId())
                            .eq("act_id", 9);
                    boolean delete = purchaseBillsItemsService.delete(itemsEntityWrapper);
                    if (!delete) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("撤回失败: 删除材料数据失败");
                        return result;
                    }
                    EntityWrapper<InvoicePurchase> entityWrapper = new EntityWrapper<>();
                    entityWrapper.eq("inv_id", invoiceBills.getId());
                    invoicePurchaseService.delete(entityWrapper);
                }
                EntityWrapper<InvoiceBillsItems> invoiceBillsItemsEntityWrapper = new EntityWrapper<>();
                invoiceBillsItemsEntityWrapper.eq("bill_no", invoiceBills.getBillNo())
                        .eq("act_id", invoiceBills.getActId())
                        .eq("project_sub_no", invoiceBills.getProjectSubNo())
                        .eq("branch_id", invoiceBills.getBranchId());
                boolean delete = invoiceBillsItemsService.delete(invoiceBillsItemsEntityWrapper);
                if (!delete) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    logger.error("明细删除失败");
                    result.addErrorMessage("明细删除失败");
                    return result;
                }
                EntityWrapper<PurchaseBillsItems> entityWrapper = new EntityWrapper<>();
                entityWrapper.eq("project_Sub_No", invoiceBills.getProjectSubNo())
                        .eq("purchase_id", invoiceBills.getPurchaseId().floatValue())
                        .eq("act_id", 9);
                boolean deletePurItems = purchaseBillsItemsService.delete(entityWrapper);
                if (!deletePurItems) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("物资需求记录删除失败");
                    return result;
                }
                boolean flag = invoiceBillsService.deleteById(invoiceBills);
                if (!flag) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("分包工程收款发票记录删除失败");
                    return result;
                }
            } else {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("未获取信息 请确认后提交");
                return result;
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除失败");
            return result;
        }
        return result;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> deleteDirectInvoice(InvoiceBillsDto invoiceBillsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            if (invoiceBillsDto != null && invoiceBillsDto.getId() != null) {
                InvoiceBills invoiceBills = invoiceBillsService.selectById(invoiceBillsDto.getId());
                if (invoiceBills != null) {
                    EntityWrapper<InvoiceBillsItems> itemsEntityWrapper = new EntityWrapper<>();
                    itemsEntityWrapper.eq("bill_no", invoiceBills.getBillNo())
                            .eq("act_id", invoiceBills.getActId())
                            .eq("project_sub_no", invoiceBills.getProjectSubNo())
                            .eq("branch_id", invoiceBills.getBranchId());
                    boolean deleteById = invoiceBillsItemsService.delete(itemsEntityWrapper);
                    if (!deleteById) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("删除错误：删除明细失败");
                        return result;
                    }
                    EntityWrapper<InvoiceBillsAttachs> attachsEntityWrapper = new EntityWrapper<>();
                    attachsEntityWrapper.eq("bill_no", invoiceBills.getBillNo())
                            .eq("act_id", invoiceBills.getActId());
                    boolean deleteAttachs = invoiceBillsAttachsService.delete(attachsEntityWrapper);
                    if (!deleteAttachs) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("删除错误：删除附件失败");
                        return result;
                    }
                    boolean deleteInvoic = invoiceBillsService.deleteById(invoiceBills);
                    if (!deleteInvoic) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("删除错误：删除主表失败");
                        return result;
                    }
                } else {
                    result.addErrorMessage("未找到信息，请确认");
                    return result;
                }
            } else {
                result.addErrorMessage("删除失败：未找到信息，请确认");
                return result;
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除失败");
            return result;
        }
        return result;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> deletePayInvoice(InvoiceBillsDto invoiceBillsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            if (invoiceBillsDto != null && invoiceBillsDto.getId() != null) {
                InvoiceBills invoiceBills = invoiceBillsService.selectById(invoiceBillsDto.getId());
                EntityWrapper<InvoiceBillsItems> invoiceBillsItemsEntityWrapper = new EntityWrapper<>();
                invoiceBillsItemsEntityWrapper.eq("bill_no", invoiceBills.getBillNo())
                        .eq("act_id", 202)
                        .eq("branch_id", invoiceBills.getBranchId());
                boolean delete = invoiceBillsItemsService.delete(invoiceBillsItemsEntityWrapper);
                if (!delete) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    logger.error("明细删除失败");
                    result.addErrorMessage("明细删除失败");
                    return result;
                }
                EntityWrapper<InvoiceBillsAttachs> invoiceBillsAttachsEntityWrapper = new EntityWrapper<>();
                invoiceBillsAttachsEntityWrapper.eq("bill_no", invoiceBills.getBillNo())
                        .eq("act_id", 202);
                boolean deleteByAttach = invoiceBillsAttachsService.delete(invoiceBillsAttachsEntityWrapper);
                if (!deleteByAttach) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("付款发票附件记录删除失败");
                    return result;
                }
                EntityWrapper<InvoiceBillsIndirect> indirectEntityWrapper = new EntityWrapper<>();
                indirectEntityWrapper.eq("bill_no", invoiceBills.getBillNo())
                        .eq("budget_id", invoiceBills.getBudgetId());
                boolean deleteByInvoiceIndirect = invoiceBillsIndirectService.delete(indirectEntityWrapper);
                if (!deleteByInvoiceIndirect) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("删除旧数据失败");
                    return result;
                }
                EntityWrapper<InvoiceBillsShares> invoiceBillsSharesEntityWrapper = new EntityWrapper<>();
                invoiceBillsSharesEntityWrapper.eq("bill_no", invoiceBills.getBillNo())
                        .eq("act_id", 202)
                        .eq("branch_id", invoiceBills.getBranchId());
                boolean deleteByInvoiceShares = invoiceBillsSharesService.delete(invoiceBillsSharesEntityWrapper);
                if (!deleteByInvoiceShares) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("付款发票附件记录删除失败");
                    return result;
                }
                boolean flag = invoiceBillsService.deleteById(invoiceBillsDto.getId());
                if (!flag) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("分包工程收款发票记录删除失败");
                    return result;
                }
            } else {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("未获取信息 请确认后提交");
                return result;
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除失败");
        }
        return result;
    }

    @Override
    public Map<String, Object> fuzzyQueryInvoice(Page page, InvoiceBillsDto invoiceBillsDto, SysUserDto sysUserDto) {
        Map<String, Object> map = new HashMap<>();
        if (invoiceBillsDto != null) {
            map.put("user", sysUserDto);
            Page pageDto = DataUtils.processingPage(page);
            int number = invoiceBillsService.selectPaymentInvoiceCount(map);
            if (number > 0) {
                map.put("current", pageDto.getCurrent());
                map.put("size", pageDto.getSize());
                List<InvoiceBills> mapList = invoiceBillsService.selectPaymentInvoiceRecords(map);
                pageDto.setTotal(number);
                pageDto.setRecords(mapList);
                map.put("page", pageDto);
            }
            return map;
        }
        return null;
    }

    @Override
    public Map<String, Object> invoicePage(Map<String, Object> map, SysUserDto sysUserDto) {
        Map<String, Object> objectMap = new HashMap<>();
        SysRole sysRole = subContractBillsService.selectRole(sysUserDto);
        map.put("user", sysUserDto);
        map.put("role", sysRole);
        try {
            int num = invoiceBillsService.selectInvoiceTotal(map);
            if (num != 0) {
                int current = (int) map.get("current");
                int size = (int) map.get("size");
                if (current <= 1) {
                    current = 0;
                } else {
                    current = (current - 1) * size;
                }
                map.put("size", size);
                map.put("current", current);
                List<Map<String, Object>> mapList = invoiceBillsService.selectInvoiceRecords(map);
                Page page = new Page();
                page.setRecords(mapList);
                page.setTotal(num);
                objectMap.put("page", page);
                return objectMap;
            }
        } catch (Exception e) {
            logger.error("操作异常：" + e.toString(), e);
        }
        return null;
    }

    @Override
    public Map<String, Object> payInvoiceMaintenancePage(Page page, InvoiceBillsDto invoiceBillsDto) {
        Map<String, Object> map = new HashMap<>();
        Page pageDto = DataUtils.processingPage(page);
        EntityWrapper<InvoiceBills> wrapper = new EntityWrapper<>();
        wrapper.eq("act_id", 202);
        int num = invoiceBillsService.selectCount(wrapper);
        if (num != 0) {
            pageDto.setTotal(num);
            wrapper.last("LIMIT " + pageDto.getCurrent() + "," + pageDto.getSize());
            List<InvoiceBills> invoiceBills = invoiceBillsService.selectList(wrapper);
            page.setRecords(invoiceBills);
            map.put("page", pageDto);
            return map;
        }
        return null;
    }

    @Override
    public Map<String, Object> directInvoiceCostPage(Page page, InvoiceBillsDto invoiceBillsDto) {
        Map<String, Object> map = new HashMap<>();
        Page pageDto = DataUtils.processingPage(page);
        EntityWrapper<InvoiceBills> wrapper = new EntityWrapper<>();
        wrapper.eq("act_id", 116);
        int num = invoiceBillsService.selectCount(wrapper);
        if (num != 0) {
            pageDto.setTotal(num);
            wrapper.last("LIMIT " + pageDto.getCurrent() + "," + pageDto.getSize());
            List<InvoiceBills> invoiceBills = invoiceBillsService.selectList(wrapper);
            page.setRecords(invoiceBills);
            map.put("page", pageDto);
            return map;
        }
        return null;
    }

    @Override
    public Map<String, Object> changeFuzzyQueryEngineeringInvoice(ProjectBillsSubsDto projectBillsSubsDto) {
        if (projectBillsSubsDto.getId() != null && projectBillsSubsDto.getId() != 0) {
            Map<String, Object> map = new HashMap<>();
            ProjectBS projectBS = invoiceBillsService.selectInvoice(projectBillsSubsDto);
            EntityWrapper<PurchaseBillsProjs> purchaseBillsProjsEntityWrapper = new EntityWrapper<>();
            purchaseBillsProjsEntityWrapper.eq("project_Sub_No", projectBS.getProjectSubNo())
                    .eq("branch_id", projectBS.getBranchId());
            List<PurchaseBillsProjs> purchaseBillsProjs = purchaseBillsProjsService.selectList(purchaseBillsProjsEntityWrapper);
            EntityWrapper<Bpurchases> bpurchasesEntityWrapper = new EntityWrapper<>();
            bpurchasesEntityWrapper.setSqlSelect("id", "c_name");
            List<Bpurchases> bpurchases = bpurchasesService.selectList(bpurchasesEntityWrapper);
            if (bpurchases.size() != 0) {
                map.put("bpurch", bpurchases);
            }
            map.put("purchPro", purchaseBillsProjs);
            map.put("form", projectBS);
            if (projectBS.getProjectTypeId() != null && projectBS.getProjectTypeId() != 0) {
                EntityWrapper<BprojectTypes> bprojectTypesEntityWrapper = new EntityWrapper<>();
                bprojectTypesEntityWrapper.setSqlSelect("id", "project_type_name").eq("id", projectBS.getProjectTypeId());
                BprojectTypes bprojectTypes = bprojectTypesService.selectOne(bprojectTypesEntityWrapper);
                map.put("projectType", bprojectTypes);
            }
            if (projectBS.getCorpId() != null && projectBS.getCorpId() != 0) {
                EntityWrapper<Bcorps> bcorpsEntityWrapper = new EntityWrapper<>();
                bcorpsEntityWrapper.setSqlSelect("id", "c_name").eq("id", projectBS.getCorpId());
                Bcorps bcorps = bcorpsService.selectOne(bcorpsEntityWrapper);
                map.put("corp", bcorps);
            }
            if (projectBS.getConstructorId() != null && projectBS.getConstructorId() != 0) {
                EntityWrapper<Bbranchs> bbranchsEntityWrapper = new EntityWrapper<>();
                bbranchsEntityWrapper.setSqlSelect("id", "c_name").eq("id", projectBS.getConstructorId());
                Bbranchs bbranchs = bbranchsService.selectOne(bbranchsEntityWrapper);
                map.put("branch", bbranchs);
            }
            return map;
        }
        return null;
    }

    @Override
    public Map<String, Object> changeFuzzyQueryPayInvoice(InvoiceBillsDto invoiceBillsDto) {
        if (invoiceBillsDto != null) {
            Map<String, Object> map = new HashMap<>();
            EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
            projectBillsBudgetsEntityWrapper.eq("project_sub_no", invoiceBillsDto.getProjectSubNo())
                    .eq("budget_id", invoiceBillsDto.getBudgetId());
            ProjectBillsBudgets billsBudgets = projectBillsBudgetsService.selectOne(projectBillsBudgetsEntityWrapper);
            if (billsBudgets != null) {
                map.put("proBudget", billsBudgets);
            } else {
                return map;
            }
            Map<String, Object> mapList = invoiceBillsService.selectPayInvoProSub(invoiceBillsDto);
            if (mapList != null) {
                map.put("mapList", mapList);
            }
            return map;
        }
        return null;
    }

    @Override
    public Map<String, Object> queryPayInvoiceMaintenanceTemporary(InvoiceBillsDto invoiceBillsDto, SysUserDto sysUserDto) {
        if (invoiceBillsDto != null && invoiceBillsDto.getId() != null) {
            Map<String, Object> map = new HashMap<>();
            EntityWrapper<InvoiceBills> invoiceBillsEntityWrapper = new EntityWrapper<>();
            invoiceBillsEntityWrapper.eq("id", invoiceBillsDto.getId());
            InvoiceBills invoiceBills = invoiceBillsService.selectOne(invoiceBillsEntityWrapper);
            map.put("detailMain", invoiceBills);
            EntityWrapper<InvoiceBillsItems> invoiceBillsItemsEntityWrapper = new EntityWrapper<>();
            invoiceBillsItemsEntityWrapper.eq("bill_no", invoiceBills.getBillNo());
            List<InvoiceBillsItems> billsItems = invoiceBillsItemsService.selectList(invoiceBillsItemsEntityWrapper);
            if (billsItems.size() != 0) {
                map.put("invoices", billsItems);
            }
            Bdepts bdepts = bdeptsService.selectById(sysUserDto.getDeptId());
            map.put("dept", bdepts);
            Bbranchs bbranchs = bbranchsService.selectById(invoiceBills.getBranchId());
            map.put("branch", bbranchs);
            // 未知原因
//            EntityWrapper<InvoiceBillsShares> invoiceBillsSharesEntityWrapper = new EntityWrapper<>();
//            invoiceBillsSharesEntityWrapper.eq("bill_no", invoiceBills.getBillNo());
//            List<InvoiceBillsShares> invoiceBillsShares = invoiceBillsSharesService.selectList(invoiceBillsSharesEntityWrapper);
            List<InvoiceBillsShares> invoiceBillsShares = invoiceBillsSharesService.selectInvoShareList(invoiceBills);
            if (invoiceBillsShares.size() != 0) {
                List<ProjectBillsSubs> projectBillsSubsList = new ArrayList<>();
                for (InvoiceBillsShares ib : invoiceBillsShares) {
                    if (ib.getProjectSubNo() != null && !"".equals(ib.getProjectSubNo())) {
                        EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
                        projectBillsSubsEntityWrapper.eq("project_sub_no", ib.getProjectSubNo())
                                .eq("branch_id", ib.getBranchId());
                        ProjectBillsSubs billsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
                        if (billsSubs != null) {
                            projectBillsSubsList.add(billsSubs);
                        }
                    }
                }
                if (projectBillsSubsList.size() != 0) {
                    map.put("proSubs", projectBillsSubsList);
                }
                map.put("costSharings", invoiceBillsShares);
            }
            EntityWrapper<InvoiceBillsAttachs> invoiceBillsAttachsEntityWrapper = new EntityWrapper<>();
            invoiceBillsAttachsEntityWrapper.eq("bill_no", invoiceBills.getBillNo());
            List<InvoiceBillsAttachs> invoiceBillsAttachs = invoiceBillsAttachsService.selectList(invoiceBillsAttachsEntityWrapper);
            if (invoiceBillsAttachs.size() != 0) {
                map.put("relevantAttachments", invoiceBillsAttachs);
            }
            return map;
        }
        return null;
    }


    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> payInvoiceMaintenanceTemporary(String projectForm, String detailMaintenance, String invoiceItem,
                                                                String costSharing, String relevantAttach, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            InvoiceBills bill = JSONArray.parseObject(projectForm, InvoiceBills.class);
            InvoiceBills invoiceBills = JSONArray.parseObject(detailMaintenance, InvoiceBills.class);
            JSONArray jsonArray = JSONArray.parseArray(invoiceItem);
            List<InvoiceBillsItems> invoiceBillsItems = JSONObject.parseArray(jsonArray.toJSONString(), InvoiceBillsItems.class);
            JSONArray costSh = JSONArray.parseArray(costSharing);
            List<InvoiceBillsShares> invoiceBillsShares = JSONObject.parseArray(costSh.toJSONString(), InvoiceBillsShares.class);
            JSONArray array = JSONArray.parseArray(relevantAttach);
            List<InvoiceBillsAttachs> invoiceBillsAttachs = JSONObject.parseArray(array.toJSONString(), InvoiceBillsAttachs.class);
            if (bill.getBillNo() != null) {
                invoiceBills.setBillNo(bill.getBillNo());
                EntityWrapper<InvoiceBills> invoiceBillsEntityWrapper = new EntityWrapper<>();
                invoiceBillsEntityWrapper.setSqlSelect("id").eq("bill_no", bill.getBillNo());
                InvoiceBills invoice = invoiceBillsService.selectOne(invoiceBillsEntityWrapper);
                if (invoice != null) {
                    invoiceBills.setId(invoice.getId());
                    invoice.setOpUserId(sysUserDto.getUserId().intValue());
                    invoice.setOpUserName(sysUserDto.getUsername());
                    invoice.setCreateDate(new Date());
                    invoice.setBillDate(new Date());
                    invoice.setPrintCount(bill.getPrintCount());
                    boolean update = invoiceBillsService.updateById(invoice);
                    if (!update) {
                        result.addErrorMessage("暂存失败：修改收款发票-间接成本失败。");
                        return result;
                    }
                } else {
                    invoiceBills.setPrintCount(bill.getPrintCount());
                    invoiceBills.setBillNo(bill.getBillNo());
                    invoiceBills.setActId(202);
                    invoiceBills.setBillStatus(2);
                    invoiceBills.setOpUserId(sysUserDto.getUserId().intValue());
                    invoiceBills.setOpUserName(sysUserDto.getUsername());
                    invoiceBills.setCreateDate(new Date());
                    invoiceBills.setBillDate(new Date());
                    boolean insert = invoiceBillsService.insert(invoiceBills);
                    if (!insert) {
                        result.addErrorMessage("暂存失败：新建收款发票-间接成本失败。");
                        return result;
                    }
                }
                if (invoiceBillsItems.size() != 0) {
                    EntityWrapper<InvoiceBillsItems> invoiceBillsItemsEntityWrapper = new EntityWrapper<>();
                    invoiceBillsItemsEntityWrapper.setSqlSelect("id").eq("bill_no", bill.getBillNo());
                    List<InvoiceBillsItems> billsItems = invoiceBillsItemsService.selectList(invoiceBillsItemsEntityWrapper);
                    if (billsItems.size() != 0) {
                        for (InvoiceBillsItems ib : billsItems) {
                            invoiceBillsItemsService.deleteById(ib);
                        }
                    }
                    int line = 0;
                    for (InvoiceBillsItems ib : invoiceBillsItems) {
                        line++;
                        ib.setBillNo(bill.getBillNo());
                        ib.setLineNo(line);
                        ib.setActId(202);
                        boolean insert = invoiceBillsItemsService.insert(ib);
                        if (!insert) {
                            result.addErrorMessage("暂存失败：新建收款发票-间接成本明细失败。");
                            return result;
                        }
                    }
                }
                if (invoiceBillsShares.size() != 0) {
                    EntityWrapper<InvoiceBillsShares> sharesEntityWrapper = new EntityWrapper<>();
                    sharesEntityWrapper.setSqlSelect("id").eq("bill_no", bill.getBillNo());
                    List<InvoiceBillsShares> sharesList = invoiceBillsSharesService.selectList(sharesEntityWrapper);
                    if (sharesList.size() != 0) {
                        for (InvoiceBillsShares is : sharesList) {
                            invoiceBillsSharesService.deleteById(is);
                        }
                    }
                    int line = 0;
                    for (InvoiceBillsShares is : invoiceBillsShares) {
                        line++;
                        is.setBillNo(bill.getBillNo());
                        is.setLineNo(line);
                        is.setActId(202);
                        boolean insert = invoiceBillsSharesService.insert(is);
                        if (!insert) {
                            result.addErrorMessage("暂存失败：新建费用分摊明细失败。");
                            return result;
                        }
                    }
                }
                if (invoiceBillsAttachs.size() != 0) {
                    EntityWrapper<InvoiceBillsAttachs> attachsEntityWrapper = new EntityWrapper<>();
                    attachsEntityWrapper.setSqlSelect("id").eq("bill_no", bill.getBillNo());
                    List<InvoiceBillsAttachs> sharesList = invoiceBillsAttachsService.selectList(attachsEntityWrapper);
                    if (sharesList.size() != 0) {
                        for (InvoiceBillsAttachs ib : sharesList) {
                            invoiceBillsAttachsService.deleteById(ib);
                        }
                    }
                    int line = 0;
                    for (InvoiceBillsAttachs ib : invoiceBillsAttachs) {
                        line++;
                        ib.setBillNo(bill.getBillNo());
                        ib.setLineNo(line);
                        ib.setActId(202);
                        ib.setOpUserId(sysUserDto.getUserId().intValue());
                        ib.setOpUserName(sysUserDto.getUsername());
                        ib.setOpDate(new Date());
                        boolean insert = invoiceBillsAttachsService.insert(ib);
                        if (!insert) {
                            result.addErrorMessage("暂存失败：新建付款发票维护附件失败。");
                            return result;
                        }
                    }
                }
            } else {
                result.addErrorMessage("暂存失败：无编号");
                return result;
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 暂存错误：" + e.toString(), e);
            result.addErrorMessage("暂存失败，请重新尝试");
        }
        return result;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> payInvoiceMaintenanceSave(String projectForm, String detailMaintenance, String invoiceItem,
                                                           String costSharing, String relevantAttach, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            InvoiceBills bill = JSONArray.parseObject(projectForm, InvoiceBills.class);
            InvoiceBills invoiceBills = JSONArray.parseObject(detailMaintenance, InvoiceBills.class);
            JSONArray jsonArray = JSONArray.parseArray(invoiceItem);
            List<InvoiceBillsItems> invoiceBillsItems = JSONObject.parseArray(jsonArray.toJSONString(), InvoiceBillsItems.class);
            JSONArray costSh = JSONArray.parseArray(costSharing);
            List<InvoiceBillsShares> invoiceBillsShares = JSONObject.parseArray(costSh.toJSONString(), InvoiceBillsShares.class);
            JSONArray array = JSONArray.parseArray(relevantAttach);
            List<InvoiceBillsAttachs> invoiceBillsAttachs = JSONObject.parseArray(array.toJSONString(), InvoiceBillsAttachs.class);
            if (bill.getBillNo() != null) {
                if (bill.getIsSpecial() != 0) {
                    bill.setBillStatus(4);
                } else {
                    bill.setBillStatus(6);
                }
                EntityWrapper<InvoiceBillsShares> sharesEntityWrapper = new EntityWrapper<>();
                sharesEntityWrapper.eq("bill_no", bill.getBillNo())
                        .eq("act_id", 202)
                        .eq("branch_id", sysUserDto.getLoginContractorId());
                boolean deleteByInvShar = invoiceBillsSharesService.delete(sharesEntityWrapper);
                if (!deleteByInvShar) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：清理附件失败");
                    return result;
                }
                int approvalBranchId = 0;
                if (invoiceBillsShares.size() != 0) {
                    int line = 0;
                    for (InvoiceBillsShares is : invoiceBillsShares) {
                        line++;
                        EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
                        projectBillsBudgetsEntityWrapper.eq("project_sub_no", is.getProjectSubNo())
                                .eq("budget_id", is.getBudgetId())
                                .eq("branch_id", sysUserDto.getLoginContractorId());
                        ProjectBillsBudgets billsBudgets = projectBillsBudgetsService.selectOne(projectBillsBudgetsEntityWrapper);
                        billsBudgets.setBudgetUseAmt(DataUtils.keepDecimals(billsBudgets.getBudgetUseAmt() + is.getShareAmt()));
                        billsBudgets.setSubInvAmtCr(DataUtils.keepDecimals(billsBudgets.getSubInvAmtCr() + is.getShareAmt()));
                        if (billsBudgets.getSubInvAmtCr() > billsBudgets.getBudgetAmt()) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：" + billsBudgets.getBudgetName() + "已开发票金额超出预算金额");
                            return result;
                        }
                        boolean updateById = projectBillsBudgetsService.updateById(billsBudgets);
                        if (!updateById) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：更新项目预算失败。");
                            return result;
                        }
                        EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
                        projectBillsSubsEntityWrapper.eq("project_sub_no", is.getProjectSubNo())
                                .eq("branch_id", sysUserDto.getLoginContractorId());
                        ProjectBillsSubs billsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);


                        // 年底暂时去掉
                        /*if (billsSubs.getSubInvAmtCr() > (is.getShareAmt() + billsSubs.getSubInvAmtDr())) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("第" + line + "行项目的本次开票 + 累计成本开票不能大于累计收入");
                            return result;
                        }*/


                        if (Objects.equals(line, 1)) {
                            approvalBranchId = billsSubs.getApprovalBranchId();
                        }
                        billsSubs.setSubInvAmtCr(DataUtils.keepDecimals(billsSubs.getSubInvAmtCr() + is.getShareAmt()));
                        boolean updateByProSub = projectBillsSubsService.updateById(billsSubs);
                        if (!updateByProSub) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：更新累计成本失败。");
                            return result;
                        }
                        EntityWrapper<InvoiceBillsIndirect> invoiceBillsIndirectEntityWrapper = new EntityWrapper<>();
                        invoiceBillsIndirectEntityWrapper.eq("project_sub_no", is.getProjectSubNo())
                                .eq("budget_id", is.getBudgetId())
                                .eq("purchase_id", invoiceBills.getPurchaseId());
                        InvoiceBillsIndirect invoiceBillsIndirect = invoiceBillsIndirectService.selectOne(invoiceBillsIndirectEntityWrapper);
                        if (invoiceBillsIndirect != null) {
                            invoiceBillsIndirect.setSubInvAmtCr(DataUtils.keepDecimals(invoiceBillsIndirect.getSubInvAmtCr() + is.getShareAmt()));
                            boolean updateByInvIndirect = invoiceBillsIndirectService.updateById(invoiceBillsIndirect);
                            if (!updateByInvIndirect) {
                                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                return result;
                            }
                        } else {
                            InvoiceBillsIndirect invoiceIndirect = new InvoiceBillsIndirect();
                            invoiceIndirect.setBillNo(bill.getBillNo());
                            invoiceIndirect.setProjectSubNo(is.getProjectSubNo());
                            invoiceIndirect.setBudgetId(is.getBudgetId());
                            invoiceIndirect.setPurchaseId(invoiceBills.getPurchaseId());
                            invoiceIndirect.setSubInvAmtCr(is.getShareAmt());
                            boolean insert = invoiceBillsIndirectService.insert(invoiceIndirect);
                            if (!insert) {
                                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                return result;
                            }
                        }
                        is.setBudgetUseAmt(billsBudgets.getBudgetUseAmt());
                        is.setBillNo(bill.getBillNo());
                        is.setLineNo(line);
                        is.setActId(202);
                        is.setBranchId(sysUserDto.getLoginContractorId());
                        // 未知原因 mybatis-plus 新增方法失效
                        boolean insert = invoiceBillsSharesService.insertInvShares(is);
                        if (!insert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：新建费用分摊明细失败。");
                            return result;
                        }
                    }
                }
                EntityWrapper<OtherProject> otherProjectEntityWrapper = new EntityWrapper<>();
                otherProjectEntityWrapper.eq("purchase_nc_no", invoiceBills.getPurchaseNcNo())
                        .eq("branch_id", sysUserDto.getLoginContractorId());
                OtherProject otherProject = otherProjectService.selectOne(otherProjectEntityWrapper);
                if (otherProject != null) {
                    if (bill.getFileAddress() != null) {
                        if (otherProject.getAttachId() == null) {
                            otherProject.setAttachId(bill.getFileAddress());
                            otherProject.setAttachName(bill.getFileName());
                        }
                    }
                    otherProject.setContractTotalAmt(DataUtils.keepDecimals(otherProject.getContractTotalAmt() + invoiceBills.getInvAmt()));
                    if (otherProject.getContractTotalAmt() > otherProject.getContractAmt()) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：其他合同开票金额已超出合同金额");
                        return result;
                    }
                    boolean updateById = otherProjectService.updateById(otherProject);
                    if (!updateById) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：更新其他合同失败。");
                        return result;
                    }
                } else {
                    OtherProject otherPro = new OtherProject();
                    if (bill.getFileAddress() != null) {
                        otherPro.setAttachId(bill.getFileAddress());
                        otherPro.setAttachName(bill.getFileName());
                    }
                    otherPro.setPurchaseNcNo(invoiceBills.getPurchaseNcNo());
                    otherPro.setPurchasesId(invoiceBills.getPurchaseId());
                    otherPro.setBudgetId(invoiceBills.getBudgetId());
                    otherPro.setBranchId(sysUserDto.getLoginContractorId());
                    otherPro.setContractAmt(invoiceBills.getContractAmt());
                    otherPro.setOpUserId(sysUserDto.getUserId().intValue());
                    otherPro.setOpDate(new Date());
                    otherPro.setStatus(6);
                    otherPro.setContractTotalAmt(invoiceBills.getInvAmt());
                    if (otherPro.getContractTotalAmt() > otherPro.getContractAmt()) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：其他合同开票金额已超出合同金额");
                        return result;
                    }
                    boolean insert = otherProjectService.insert(otherPro);
                    if (!insert) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：新建其他合同失败");
                        return result;
                    }
                }
                invoiceBills.setBillNo(bill.getBillNo());
                EntityWrapper<InvoiceBills> invoiceBillsEntityWrapper = new EntityWrapper<>();
                invoiceBillsEntityWrapper.eq("bill_no", bill.getBillNo())
                        .eq("act_id", 202)
                        .eq("branch_id", sysUserDto.getLoginContractorId());
                InvoiceBills invoice = invoiceBillsService.selectOne(invoiceBillsEntityWrapper);
                if (invoice != null) {
                    invoiceBills.setId(invoice.getId());
                    invoiceBills.setBillStatus(bill.getBillStatus());
                    invoiceBills.setBranchId(sysUserDto.getLoginContractorId());
                    invoiceBills.setOpUserId(sysUserDto.getUserId().intValue());
                    invoiceBills.setOpUserName(sysUserDto.getUsername());
                    invoiceBills.setCreateDate(new Date());
                    invoiceBills.setBillDate(new Date());
                    invoiceBills.setPostDate(new Date());
                    invoiceBills.setIsSpecial(bill.getIsSpecial());
                    invoiceBills.setSpecialItem(bill.getSpecialItem());
                    invoiceBills.setPrintCount(bill.getPrintCount());
                    boolean update = invoiceBillsService.updateById(invoiceBills);
                    if (!update) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：修改收款发票-间接成本失败。");
                        return result;
                    }
                } else {
                    invoiceBills.setBillNo(bill.getBillNo());
                    invoiceBills.setActId(202);
                    invoiceBills.setBillStatus(bill.getBillStatus());
                    invoiceBills.setBranchId(sysUserDto.getLoginContractorId());
                    invoiceBills.setOpUserId(sysUserDto.getUserId().intValue());
                    invoiceBills.setOpUserName(sysUserDto.getUsername());
                    invoiceBills.setCreateDate(new Date());
                    invoiceBills.setBillDate(new Date());
                    invoiceBills.setPostDate(new Date());
                    invoiceBills.setIsSpecial(bill.getIsSpecial());
                    invoiceBills.setSpecialItem(bill.getSpecialItem());
                    invoiceBills.setPrintCount(bill.getPrintCount());
                    boolean insert = invoiceBillsService.insert(invoiceBills);
                    if (!insert) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：新建收款发票-间接成本失败。");
                        return result;
                    }
                }
                EntityWrapper<InvoiceBillsItems> invoiceBillsItemsEntityWrapper = new EntityWrapper<>();
                invoiceBillsItemsEntityWrapper.eq("bill_no", bill.getBillNo())
                        .eq("act_id", 202)
                        .eq("branch_id", invoiceBills.getBranchId());
                boolean deleteBy = invoiceBillsItemsService.delete(invoiceBillsItemsEntityWrapper);
                if (!deleteBy) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：清理明细失败");
                    return result;
                }
                if (invoiceBillsItems.size() != 0) {
                    int line = 0;
                    for (InvoiceBillsItems ib : invoiceBillsItems) {
                        line++;
                        ib.setBillNo(bill.getBillNo());
                        ib.setLineNo(line);
                        ib.setActId(202);
                        ib.setBranchId(sysUserDto.getLoginContractorId());
                        boolean insert = invoiceBillsItemsService.insert(ib);
                        if (!insert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：新建收款发票-间接成本明细失败。");
                            return result;
                        }
                    }
                }
                EntityWrapper<InvoiceBillsAttachs> attachsEntityWrapper = new EntityWrapper<>();
                attachsEntityWrapper.eq("bill_no", bill.getBillNo())
                        .eq("act_id", 202);
                boolean deleteByAttach = invoiceBillsAttachsService.delete(attachsEntityWrapper);
                if (!deleteByAttach) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：清理附件失败");
                    return result;
                }
                if (invoiceBillsAttachs.size() != 0) {
                    int line = 0;
                    for (InvoiceBillsAttachs ib : invoiceBillsAttachs) {
                        line++;
                        ib.setBillNo(bill.getBillNo());
                        ib.setLineNo(line);
                        ib.setActId(202);
                        ib.setOpUserId(sysUserDto.getUserId().intValue());
                        ib.setOpUserName(sysUserDto.getUsername());
                        ib.setOpDate(new Date());
                        boolean insert = invoiceBillsAttachsService.insert(ib);
                        if (!insert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：新建付款发票维护附件失败。");
                            return result;
                        }
                    }
                }
                if (bill.getIsSpecial() != 0) {
                    Audit audit = new Audit();
                    audit.setBillNo(bill.getBillNo());
                    audit.setActId(540);
                    audit.setLevelId(0);
                    audit.setIffinalItem("F");
                    audit.setBranchId(approvalBranchId);
//                    audit.setBranchId(sysUserDto.getLoginContractorId());
                    audit.setSendUserId(sysUserDto.getUserId().intValue());
                    audit.setSendName(sysUserDto.getActualname());
                    audit.setSendTime(new Date());
                    audit.setAuditUserId(sysUserDto.getUserId().intValue());
                    audit.setAuditItem(new Date());
                    audit.setAuditMsg("提交");
                    audit.setAuditStatus("O");
                    boolean approvalFlow = auditItemsService.createApprovalFlow(audit);
                    if (!approvalFlow) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("审批流异常请检查提交信息");
                        return result;
                    }
                }
            } else {
                result.addErrorMessage("提交失败：无编号");
                return result;
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 提交错误：" + e.toString(), e);
            result.addErrorMessage("提交失败，请重新尝试");
        }
        return result;
    }

    /*审批版本*/
    /*public ExecuteResult<String> payInvoiceMaintenanceSave(String projectForm, String detailMaintenance, String invoiceItem,
                                                           String costSharing, String relevantAttach, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            InvoiceBills bill = JSONArray.parseObject(projectForm, InvoiceBills.class);
            InvoiceBills invoiceBills = JSONArray.parseObject(detailMaintenance, InvoiceBills.class);
            JSONArray jsonArray = JSONArray.parseArray(invoiceItem);
            List<InvoiceBillsItems> invoiceBillsItems = JSONObject.parseArray(jsonArray.toJSONString(), InvoiceBillsItems.class);
            JSONArray costSh = JSONArray.parseArray(costSharing);
            List<InvoiceBillsShares> invoiceBillsShares = JSONObject.parseArray(costSh.toJSONString(), InvoiceBillsShares.class);
            JSONArray array = JSONArray.parseArray(relevantAttach);
            List<InvoiceBillsAttachs> invoiceBillsAttachs = JSONObject.parseArray(array.toJSONString(), InvoiceBillsAttachs.class);
            if (bill.getBillNo() != null) {
                if (bill.getIsSpecial() != 0) {
                    bill.setBillStatus(4);
                } else {
                    bill.setBillStatus(6);
                    EntityWrapper<OtherProject> otherProjectEntityWrapper = new EntityWrapper<>();
                    otherProjectEntityWrapper.setSqlSelect("id", "contract_total_amt", "attach_id")
                            .eq("purchase_nc_no", invoiceBills.getPurchaseNcNo());
                    OtherProject otherProject = otherProjectService.selectOne(otherProjectEntityWrapper);
                    if (otherProject != null) {
                        if (bill.getFileAddress() != null) {
                            if (otherProject.getAttachId() == null) {
                                otherProject.setAttachId(bill.getFileAddress());
                                otherProject.setAttachName(bill.getFileName());
                            }
                        }
                        otherProject.setContractTotalAmt(otherProject.getContractTotalAmt() + invoiceBills.getInvAmt());
                        boolean updateById = otherProjectService.updateById(otherProject);
                        if (!updateById) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：更新其他合同失败。");
                            return result;
                        }
                    } else {
                        OtherProject otherPro = new OtherProject();
                        if (bill.getFileAddress() != null) {
                            otherPro.setAttachId(bill.getFileAddress());
                            otherPro.setAttachName(bill.getFileName());
                        }
                        otherPro.setPurchaseNcNo(invoiceBills.getPurchaseNcNo());
                        otherPro.setPurchasesId(invoiceBills.getPurchaseId());
                        otherPro.setBudgetId(invoiceBills.getBudgetId());
                        otherPro.setContractAmt(invoiceBills.getContractAmt());
                        otherPro.setOpUserId(sysUserDto.getUserId().intValue());
                        otherPro.setOpDate(new Date());
                        otherPro.setStatus(6);
                        otherPro.setContractTotalAmt(invoiceBills.getInvAmt());
                        boolean insert = otherProjectService.insert(otherPro);
                        if (!insert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：新建其他合同失败");
                            return result;
                        }
                    }
                }
                invoiceBills.setBillNo(bill.getBillNo());
                EntityWrapper<InvoiceBills> invoiceBillsEntityWrapper = new EntityWrapper<>();
                invoiceBillsEntityWrapper.eq("bill_no", bill.getBillNo())
                        .eq("act_id", 202)
                        .eq("branch_id", sysUserDto.getLoginContractorId());
                InvoiceBills invoice = invoiceBillsService.selectOne(invoiceBillsEntityWrapper);
                if (invoice != null) {
                    invoiceBills.setId(invoice.getId());
                    invoiceBills.setBillStatus(bill.getBillStatus());
                    invoiceBills.setBranchId(sysUserDto.getLoginContractorId());
                    invoiceBills.setOpUserId(sysUserDto.getUserId().intValue());
                    invoiceBills.setOpUserName(sysUserDto.getUsername());
                    invoiceBills.setCreateDate(new Date());
                    invoiceBills.setBillDate(new Date());
                    invoiceBills.setPostDate(new Date());
                    invoiceBills.setIsSpecial(bill.getIsSpecial());
                    invoiceBills.setSpecialItem(bill.getSpecialItem());
                    invoiceBills.setPrintCount(bill.getPrintCount());
                    boolean update = invoiceBillsService.updateById(invoiceBills);
                    if (!update) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：修改收款发票-间接成本失败。");
                        return result;
                    }
                } else {
                    invoiceBills.setBillNo(bill.getBillNo());
                    invoiceBills.setActId(202);
                    invoiceBills.setBillStatus(bill.getBillStatus());
                    invoiceBills.setBranchId(sysUserDto.getLoginContractorId());
                    invoiceBills.setOpUserId(sysUserDto.getUserId().intValue());
                    invoiceBills.setOpUserName(sysUserDto.getUsername());
                    invoiceBills.setCreateDate(new Date());
                    invoiceBills.setBillDate(new Date());
                    invoiceBills.setPostDate(new Date());
                    invoiceBills.setIsSpecial(bill.getIsSpecial());
                    invoiceBills.setSpecialItem(bill.getSpecialItem());
                    invoiceBills.setPrintCount(bill.getPrintCount());
                    boolean insert = invoiceBillsService.insert(invoiceBills);
                    if (!insert) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：新建收款发票-间接成本失败。");
                        return result;
                    }
                }
                if (invoiceBillsItems.size() != 0) {
                    EntityWrapper<InvoiceBillsItems> invoiceBillsItemsEntityWrapper = new EntityWrapper<>();
                    invoiceBillsItemsEntityWrapper.eq("bill_no", bill.getBillNo())
                            .eq("act_id", 202);
                    boolean deleteBy = invoiceBillsItemsService.delete(invoiceBillsItemsEntityWrapper);
                    if (!deleteBy) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：清理明细失败");
                        return result;
                    }
                    int line = 0;
                    for (InvoiceBillsItems ib : invoiceBillsItems) {
                        line++;
                        ib.setBillNo(bill.getBillNo());
                        ib.setLineNo(line);
                        ib.setActId(202);
                        ib.setBranchId(sysUserDto.getLoginContractorId());
                        boolean insert = invoiceBillsItemsService.insert(ib);
                        if (!insert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：新建收款发票-间接成本明细失败。");
                            return result;
                        }
                    }
                }


                if (invoiceBillsShares.size() != 0) {
                    EntityWrapper<InvoiceBillsShares> sharesEntityWrapper = new EntityWrapper<>();
                    sharesEntityWrapper.eq("bill_no", bill.getBillNo())
                            .eq("act_id", 202);
                    boolean deleteById = invoiceBillsSharesService.delete(sharesEntityWrapper);
                    if (!deleteById) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：清理附件失败");
                        return result;
                    }
                    int line = 0;
                    for (InvoiceBillsShares is : invoiceBillsShares) {
                        line++;
                        if (Objects.equals(bill.getIsSpecial(), 0)) {
                            EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
                            projectBillsBudgetsEntityWrapper.eq("project_sub_no", is.getProjectSubNo())
                                    .eq("budget_id", is.getBudgetId());
                            ProjectBillsBudgets billsBudgets = projectBillsBudgetsService.selectOne(projectBillsBudgetsEntityWrapper);
                            if (billsBudgets != null) {
                                billsBudgets.setBudgetUseAmt(billsBudgets.getBudgetUseAmt() + is.getShareAmt());
                                billsBudgets.setSubInvAmtCr(billsBudgets.getSubInvAmtCr() + is.getShareAmt());
                                boolean updateById = projectBillsBudgetsService.updateById(billsBudgets);
                                if (!updateById) {
                                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                    result.addErrorMessage("提交失败：更新项目预算失败。");
                                    return result;
                                }
                            }
                            EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
                            projectBillsSubsEntityWrapper.setSqlSelect("id", "sub_inv_amt_cr")
                                    .eq("project_sub_no", is.getProjectSubNo());
                            ProjectBillsSubs billsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
                            if (billsSubs != null) {
                                billsSubs.setSubInvAmtCr(billsSubs.getSubInvAmtCr() + is.getShareAmt());
                                boolean updateById = projectBillsSubsService.updateById(billsSubs);
                                if (!updateById) {
                                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                    result.addErrorMessage("提交失败：更新累计成本失败。");
                                    return result;
                                }
                            }
                            EntityWrapper<InvoiceBillsIndirect> invoiceBillsIndirectEntityWrapper = new EntityWrapper<>();
                            invoiceBillsIndirectEntityWrapper.eq("project_sub_no", is.getProjectSubNo())
                                    .eq("budget_id", is.getBudgetId())
                                    .eq("purchase_id", invoiceBills.getPurchaseId());
                            InvoiceBillsIndirect invoiceBillsIndirect = invoiceBillsIndirectService.selectOne(invoiceBillsIndirectEntityWrapper);
                            if (invoiceBillsIndirect != null) {
                                invoiceBillsIndirect.setSubInvAmtCr(invoiceBillsIndirect.getSubInvAmtCr() + is.getShareAmt());
                                boolean updateById = invoiceBillsIndirectService.updateById(invoiceBillsIndirect);
                                if (!updateById) {
                                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                    return result;
                                }
                            } else {
                                InvoiceBillsIndirect invoiceIndirect = new InvoiceBillsIndirect();
                                invoiceIndirect.setBillNo(bill.getBillNo());
                                invoiceIndirect.setProjectSubNo(is.getProjectSubNo());
                                invoiceIndirect.setBudgetId(is.getBudgetId());
                                invoiceIndirect.setPurchaseId(invoiceBills.getPurchaseId());
                                invoiceIndirect.setSubInvAmtCr(is.getShareAmt());
                                boolean insert = invoiceBillsIndirectService.insert(invoiceIndirect);
                                if (!insert) {
                                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                    return result;
                                }
                            }
                            is.setBudgetUseAmt(billsBudgets.getBudgetUseAmt());
                        }
                        is.setBillNo(bill.getBillNo());
                        is.setLineNo(line);
                        is.setActId(202);
                        boolean insert = invoiceBillsSharesService.insert(is);
                        if (!insert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：新建费用分摊明细失败。");
                            return result;
                        }
                    }
                }
                if (invoiceBillsAttachs.size() != 0) {
                    EntityWrapper<InvoiceBillsAttachs> attachsEntityWrapper = new EntityWrapper<>();
                    attachsEntityWrapper.eq("bill_no", bill.getBillNo())
                            .eq("act_id", 202);
                    boolean deleteById = invoiceBillsAttachsService.delete(attachsEntityWrapper);
                    if (!deleteById) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：清理附件失败");
                        return result;
                    }
                    int line = 0;
                    for (InvoiceBillsAttachs ib : invoiceBillsAttachs) {
                        line++;
                        ib.setBillNo(bill.getBillNo());
                        ib.setLineNo(line);
                        ib.setActId(202);
                        ib.setOpUserId(sysUserDto.getUserId().intValue());
                        ib.setOpUserName(sysUserDto.getUsername());
                        ib.setOpDate(new Date());
                        boolean insert = invoiceBillsAttachsService.insert(ib);
                        if (!insert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：新建付款发票维护附件失败。");
                            return result;
                        }
                    }
                }
                if (bill.getIsSpecial() != 0) {
                    Audit audit = new Audit();
                    audit.setBillNo(bill.getBillNo());
                    audit.setActId(540);
                    audit.setLevelId(0);
                    audit.setIffinalItem("F");
                    audit.setBranchId(sysUserDto.getLoginContractorId());
                    audit.setSendUserId(sysUserDto.getUserId().intValue());
                    audit.setSendName(sysUserDto.getUsername());
                    audit.setSendTime(new Date());
                    audit.setAuditUserId(sysUserDto.getUserId().intValue());
                    audit.setAuditItem(new Date());
                    audit.setAuditMsg("提交");
                    audit.setAuditStatus("O");
                    boolean approvalFlow = auditItemsService.createApprovalFlow(audit);
                    if (!approvalFlow) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("审批流异常请检查提交信息");
                        return result;
                    }
                }
            } else {
                result.addErrorMessage("提交失败：无编号");
                return result;
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 提交错误：" + e.toString(), e);
            result.addErrorMessage("提交失败，请重新尝试");
        }
        return result;
    }*/

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> engineeringInvoiceTemporary(String projectForm, String payPost, String invoDeta, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            ProjectBS projectBS = JSONArray.parseObject(projectForm, ProjectBS.class);
            InvoiceBills invoiceBills = JSONArray.parseObject(payPost, InvoiceBills.class);
            JSONArray jsonArray = JSONArray.parseArray(invoDeta);
            List<InvoiceBillsItems> invoiceBillsItems = JSONObject.parseArray(jsonArray.toJSONString(), InvoiceBillsItems.class);
            EntityWrapper<InvoiceBills> invoiceBillsEntityWrapper = new EntityWrapper<>();
            invoiceBillsEntityWrapper.setSqlSelect("id").eq("bill_no", projectBS.getBillNo());
            InvoiceBills bills = invoiceBillsService.selectOne(invoiceBillsEntityWrapper);
            EntityWrapper<InvoiceBillsItems> invoiceBillsItemsEntityWrapper = new EntityWrapper<>();
            invoiceBillsItemsEntityWrapper.setSqlSelect("id").eq("bill_no", projectBS.getBillNo());
            List<InvoiceBillsItems> billsItems = invoiceBillsItemsService.selectList(invoiceBillsItemsEntityWrapper);
            if (bills != null) {
                bills.setProjectSubNo(invoiceBills.getProjectSubNo());
                bills.setBranchId(projectBS.getBranchId());
                bills.setInvAmt(invoiceBills.getInvAmt());
                bills.setInvAmtRate(invoiceBills.getInvAmtRate());
                bills.setFileAddress(projectBS.getFileAddress());
                bills.setInvTotalAmt(invoiceBills.getInvTotalAmt());
                bills.setInvTotalRate(invoiceBills.getInvTotalRate());
                bills.setProgressRate(invoiceBills.getProgressRate());
                bills.setPurchaseNcNo(invoiceBills.getPurchaseNcNo());
                bills.setBillDate(new Date());
                bills.setCreateDate(new Date());
                bills.setSubInvAmtDr(projectBS.getSubInvAmtDr());
                bills.setSubInvAmtCr(projectBS.getSubInvAmtCr());
                bills.setPurchaseNo(invoiceBills.getPurchaseNo());
                bills.setPurchaseId(invoiceBills.getPurchaseId());
                bills.setContractAmt(invoiceBills.getContractAmt());
                bills.setContractAuditAmt(invoiceBills.getContractAuditAmt());
                bills.setIsSpecial(projectBS.getIsSpecial());
                bills.setSpecialItem(projectBS.getSpecialItem());
                bills.setPrintCount(invoiceBills.getPrintCount());
                boolean update = invoiceBillsService.updateById(bills);
                if (!update) {
                    result.addErrorMessage("暂存失败：更新收款发票失败。");
                    return result;
                }
            } else {
                invoiceBills.setBillNo(projectBS.getBillNo());
                invoiceBills.setActId(109);
                invoiceBills.setBillStatus(2);
                invoiceBills.setFileAddress(projectBS.getFileAddress());
                invoiceBills.setOpUserId(sysUserDto.getUserId().intValue());
                invoiceBills.setOpUserName(sysUserDto.getUsername());
                invoiceBills.setCreateDate(new Date());
                invoiceBills.setBillDate(new Date());
                invoiceBills.setBranchId(projectBS.getBranchId());
                invoiceBills.setSubInvAmtDr(projectBS.getSubInvAmtDr());
                invoiceBills.setSubInvAmtCr(projectBS.getSubInvAmtCr());
                invoiceBills.setIsSpecial(projectBS.getIsSpecial());
                invoiceBills.setSpecialItem(projectBS.getSpecialItem());
                boolean insert = invoiceBillsService.insert(invoiceBills);
                if (!insert) {
                    result.addErrorMessage("暂存失败：新建收款发票失败。");
                    return result;
                }
            }
            if (billsItems.size() != 0) {
                for (InvoiceBillsItems ib : billsItems) {
                    invoiceBillsItemsService.deleteById(ib);
                }
            }
            int line = 0;
            for (InvoiceBillsItems ib : invoiceBillsItems) {
                line++;
                ib.setBillNo(projectBS.getBillNo());
                ib.setLineNo(line);
                ib.setActId(109);
                ib.setProjectSubNo(invoiceBills.getProjectSubNo());
                ib.setBranchId(projectBS.getBranchId());
                boolean insert = invoiceBillsItemsService.insert(ib);
                if (!insert) {
                    result.addErrorMessage("暂存失败：新建收款发票明细失败。");
                    return result;
                }
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 暂存错误：" + e.toString(), e);
            result.addErrorMessage("暂存失败，请重新尝试");
        }
        return result;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> engineeringInvoiceSave(String projectForm, String payPost, String invoDeta, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            ProjectBS projectBS = JSONArray.parseObject(projectForm, ProjectBS.class);
            InvoiceBills invoiceBills = JSONArray.parseObject(payPost, InvoiceBills.class);
            EntityWrapper<InvoiceBills> invoiceBillsEntityWrapper = new EntityWrapper<>();
            /*存西提交时 防止单号被替换*/
            EntityWrapper<SubContractBills> subContractBillsEntityWrapper = new EntityWrapper<>();
            if (projectBS.getIsSur().equals("F")) {
                subContractBillsEntityWrapper.eq("purchase_plan_no", invoiceBills.getPurchaseNo());
            } else {
                subContractBillsEntityWrapper.eq("purchase_plan_no", invoiceBills.getPurchaseNo())
                        .eq("project_sub_no", invoiceBills.getProjectSubNo());
            }
            subContractBillsEntityWrapper.eq("branch_id", invoiceBills.getBranchId());
            SubContractBills subContractBills = subContractBillsService.selectOne(subContractBillsEntityWrapper);
            if (subContractBills != null) {
                double subInvAmtCr = subContractBills.getSubInvAmtCr() + invoiceBills.getInvAmt() - 0.1;
                subContractBills.setPurchaseNcNo(invoiceBills.getPurchaseNcNo());
                subContractBills.setSubInvAmtCr(Double.parseDouble(String.format("%.2f", subContractBills.getSubInvAmtCr() + invoiceBills.getInvAmt())));
                if (projectBS.getIsSpecial() == 0) {
                    if (subInvAmtCr > subContractBills.getAmt()) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：分包合同累计开票金额超出分包合同金额");
                        return result;
                    }
                }
                boolean updateById = subContractBillsService.updateById(subContractBills);
                if (!updateById) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：更新分包合同失败");
                    return result;
                }
            }
            invoiceBillsEntityWrapper.setSqlSelect("id")
                    .eq("bill_no", projectBS.getBillNo())
                    .eq("act_id", 109)
                    .eq("branch_id", projectBS.getBranchId());
            InvoiceBills bills = invoiceBillsService.selectOne(invoiceBillsEntityWrapper);
            if (bills != null) {
                bills.setProjectSubNo(invoiceBills.getProjectSubNo());
                bills.setBranchId(projectBS.getBranchId());
                bills.setInvAmt(invoiceBills.getInvAmt());
                bills.setInvAmtRate(invoiceBills.getInvAmtRate());
                bills.setInvTotalAmt(invoiceBills.getInvTotalAmt());
                bills.setInvTotalRate(invoiceBills.getInvTotalRate());
                bills.setProgressRate(invoiceBills.getProgressRate());
                bills.setPurchaseNcNo(invoiceBills.getPurchaseNcNo());
                bills.setContractNo(subContractBills.getContractNo());
                if (Objects.equals(projectBS.getIsSpecial(), 1)) {
                    bills.setBillStatus(4);
                } else {
                    bills.setBillStatus(6);
                }
                bills.setBillDate(new Date());
                bills.setCreateDate(new Date());
                bills.setPostDate(new Date());
                bills.setBranchId(sysUserDto.getLoginContractorId());
                bills.setOpUserName(sysUserDto.getUsername());
                bills.setOpUserId(sysUserDto.getUserId().intValue());
                bills.setSubInvAmtDr(projectBS.getSubInvAmtDr());
                bills.setSubInvAmtCr(projectBS.getSubInvAmtCr());
                bills.setPurchaseNo(invoiceBills.getPurchaseNo());
                bills.setPurchaseId(invoiceBills.getPurchaseId());
                bills.setFileAddress(projectBS.getFileAddress());
                bills.setContractAmt(invoiceBills.getContractAmt());
                bills.setContractAuditAmt(invoiceBills.getContractAuditAmt());
                bills.setIsSpecial(projectBS.getIsSpecial());
                bills.setSpecialItem(projectBS.getSpecialItem());
                bills.setPrintCount(invoiceBills.getPrintCount());
                boolean update = invoiceBillsService.updateById(bills);
                if (!update) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：更新收款发票失败。");
                    return result;
                }
            } else {
                invoiceBills.setBillNo(projectBS.getBillNo());
                invoiceBills.setActId(109);
                if (Objects.equals(projectBS.getIsSpecial(), 1)) {
                    invoiceBills.setBillStatus(4);
                } else {
                    invoiceBills.setBillStatus(6);
                }
                invoiceBills.setContractNo(subContractBills.getContractNo());
                invoiceBills.setOpUserId(sysUserDto.getUserId().intValue());
                invoiceBills.setOpUserName(sysUserDto.getUsername());
                invoiceBills.setBillDate(new Date());
                invoiceBills.setCreateDate(new Date());
                invoiceBills.setPostDate(new Date());
                invoiceBills.setBudgetId(1);
                invoiceBills.setBranchId(sysUserDto.getLoginContractorId());
                invoiceBills.setFileAddress(projectBS.getFileAddress());
                invoiceBills.setSubInvAmtDr(projectBS.getSubInvAmtDr());
                invoiceBills.setSubInvAmtCr(projectBS.getSubInvAmtCr());
                invoiceBills.setIsSpecial(projectBS.getIsSpecial());
                invoiceBills.setSpecialItem(projectBS.getSpecialItem());
                boolean insert = invoiceBillsService.insert(invoiceBills);
                if (!insert) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：新建收款发票失败。");
                    return result;
                }
            }
            EntityWrapper<InvoiceBillsItems> invoiceBillsItemsEntityWrapper = new EntityWrapper<>();
            invoiceBillsItemsEntityWrapper.eq("bill_no", projectBS.getBillNo())
                    .eq("branch_id", projectBS.getBranchId());
            boolean delete = invoiceBillsItemsService.delete(invoiceBillsItemsEntityWrapper);
            if (!delete) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("提交失败：删除明细失败");
                return result;
            }
            JSONArray jsonArray = JSONArray.parseArray(invoDeta);
            List<InvoiceBillsItems> invoiceBillsItems = JSONObject.parseArray(jsonArray.toJSONString(), InvoiceBillsItems.class);
            if (invoiceBillsItems.size() != 0) {
                int line = 0;
                for (InvoiceBillsItems ib : invoiceBillsItems) {
                    line++;
                    ib.setBillNo(projectBS.getBillNo());
                    ib.setLineNo(line);
                    ib.setActId(109);
                    ib.setProjectSubNo(invoiceBills.getProjectSubNo());
                    ib.setBranchId(projectBS.getBranchId());
                    boolean insert = invoiceBillsItemsService.insert(ib);
                    if (!insert) {
                        result.addErrorMessage("提交失败：新建收款发票明细失败。");
                        return result;
                    }
                }
            }
            EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
            projectBillsBudgetsEntityWrapper.eq("project_sub_no", invoiceBills.getProjectSubNo())
                    .eq("budget_id", 1)
                    .eq("branch_id", sysUserDto.getLoginContractorId());
            ProjectBillsBudgets billsBudgets = projectBillsBudgetsService.selectOne(projectBillsBudgetsEntityWrapper);
            if (billsBudgets != null) {
                billsBudgets.setSubInvAmtCr(Double.parseDouble(String.format("%.2f", billsBudgets.getSubInvAmtCr() + invoiceBills.getInvAmt())));
                billsBudgets.setSubInvAmtBlc(Double.parseDouble(String.format("%.2f", billsBudgets.getBudgetAmt() - billsBudgets.getSubInvAmtCr())));
                boolean updateById = projectBillsBudgetsService.updateById(billsBudgets);
                if (!updateById) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交错误，更新预算失败");
                    return result;
                }
            }
            EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
            projectBillsSubsEntityWrapper.setSqlSelect("id", "sub_inv_amt_cr", "sub_inv_amt_dr")
                    .eq("project_sub_no", invoiceBills.getProjectSubNo())
                    .eq("branch_id", sysUserDto.getLoginContractorId());
            ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
            if (projectBillsSubs != null) {
                projectBillsSubs.setSubInvAmtCr(Double.parseDouble(String.format("%.2f", projectBillsSubs.getSubInvAmtCr() + invoiceBills.getInvAmt())));
                boolean updateById = projectBillsSubsService.updateById(projectBillsSubs);
                if (!updateById) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交错误，更新二级项目失败");
                    return result;
                }
            }
            if (Objects.equals(projectBS.getIsSpecial(), 1)) {
                EntityWrapper<ProjectBillsSubs> subsEntityWrapper = new EntityWrapper<>();
                subsEntityWrapper.eq("project_sub_no", projectBS.getProjectSubNo())
                        .eq("branch_id", projectBS.getBranchId());
                ProjectBillsSubs projectbillsDto = projectBillsSubsService.selectOne(subsEntityWrapper);
                Audit audit = new Audit();
                audit.setBillNo(projectBS.getBillNo());
                audit.setActId(510);
                audit.setLevelId(0);
                audit.setIffinalItem("F");
                audit.setSubJect(projectbillsDto.getProjectSubName());
                audit.setProjectNo(projectBS.getProjectSubNo());
                audit.setBranchId(projectbillsDto.getApprovalBranchId());
                audit.setSendUserId(sysUserDto.getUserId().intValue());
                audit.setSendName(sysUserDto.getUsername());
                audit.setSendTime(new Date());
                audit.setAuditUserId(sysUserDto.getUserId().intValue());
                audit.setAuditItem(new Date());
                audit.setAuditMsg("提交");
                audit.setAuditStatus("O");
                audit.setProjectMngId(projectbillsDto.getProjectSubMngId());
                EntityWrapper<Projectbills> projectbillsEntityWrapper = new EntityWrapper<>();
                projectbillsEntityWrapper.setSqlSelect("id", "project_leader").eq("bill_no", projectbillsDto.getBillNo())
                        .eq("act_id", projectbillsDto.getActId());
                Projectbills projectbills = projectbillsService.selectOne(projectbillsEntityWrapper);
                if (projectbills != null) {
                    audit.setProjectLeader(projectbills.getProjectLeader());
                }
                boolean approvalFlow = auditItemsService.createApprovalFlow(audit);
                if (!approvalFlow) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("审批流异常请检查提交信息");
                    return result;
                }
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 提交错误：" + e.toString(), e);
            result.addErrorMessage("提交错误，请重新尝试");
        }
        return result;
    }

    @Override
    public Map<String, Object> queryEngineeringInvoiceTemporary(InvoiceBillsDto invoiceBillsDto, SysUserDto sysUserDto) {
        if (invoiceBillsDto != null && invoiceBillsDto.getId() != null) {
            Map<String, Object> map = new HashMap<>();
            InvoiceBills invoiceBills = invoiceBillsService.selectById(invoiceBillsDto.getId());
            if (invoiceBills != null) {
                EntityWrapper<SubContractBills> subContractBillsEntityWrapper = new EntityWrapper<>();
                subContractBillsEntityWrapper.eq("purchase_plan_no", invoiceBills.getPurchaseNo())
                        .eq("project_sub_no", invoiceBills.getProjectSubNo())
                        .eq("branch_id", invoiceBills.getBranchId());
                if (invoiceBills.getContractNo() != null) {
                    subContractBillsEntityWrapper.eq("contract_no", invoiceBills.getContractNo());
                }
                SubContractBills subContractBills = subContractBillsService.selectOne(subContractBillsEntityWrapper);
                if (subContractBills != null) {
                    double subConStlAmt = 0d;
                    if ("F".equals(subContractBills.getStlType())) {
                        EntityWrapper<ProjectBillsStlPlans> plansEntityWrapper = new EntityWrapper<>();
                        plansEntityWrapper.setSqlSelect("id", "amt", "stl_amt")
                                .eq("bill_no", subContractBills.getBillNo())
                                .eq("act_id", 112)
                                .eq("nature", "预付款");
                        ProjectBillsStlPlans projectBillsStlPlans = projectBillsStlPlansService.selectOne(plansEntityWrapper);
                        double amt = DataUtils.keepDecimals(projectBillsStlPlans.getAmt() - projectBillsStlPlans.getStlAmt());
                        if (amt > 0) {
                            subConStlAmt = amt;
                        }
                    }
                    map.put("subConStlAmt", subConStlAmt);
                    map.put("subContract", subContractBills);
                }
                EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
                projectBillsSubsEntityWrapper.setSqlSelect("id").eq("project_sub_no", invoiceBills.getProjectSubNo());
                ProjectBillsSubs billsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
                if (billsSubs != null) {
                    ProjectBillsSubsDto projectBillsSubsDto = new ProjectBillsSubsDto();
                    projectBillsSubsDto.setId(billsSubs.getId());
                    ProjectBS projectBS = invoiceBillsService.selectInvoice(projectBillsSubsDto);
                    if (projectBS != null) {
                        Bdepts bdepts = bdeptsService.selectById(sysUserDto.getDeptId());
                        map.put("dept", bdepts);
                        EntityWrapper<InvoiceBillsItems> itemsEntityWrapper = new EntityWrapper<>();
                        itemsEntityWrapper.eq("bill_no", invoiceBills.getBillNo())
                                .eq("project_sub_no", invoiceBills.getProjectSubNo());
                        List<InvoiceBillsItems> billsItems = invoiceBillsItemsService.selectList(itemsEntityWrapper);
                        if (billsItems.size() != 0) {
                            map.put("invoiceitem", billsItems);
                        }
                        projectBS.setBillNo(invoiceBills.getBillNo());
                        map.put("payPosted", invoiceBills);
                        EntityWrapper<PurchaseBillsProjs> purchaseBillsProjsEntityWrapper = new EntityWrapper<>();
                        purchaseBillsProjsEntityWrapper.setSqlSelect("id", "project_Sub_No", "purchase_Plan_No", "purchase_NC_No", "purchase_id")
                                .eq("project_Sub_No", projectBS.getProjectSubNo());
                        List<PurchaseBillsProjs> purchaseBillsProjs = purchaseBillsProjsService.selectList(purchaseBillsProjsEntityWrapper);
                        if (purchaseBillsProjs.size() != 0) {
                            map.put("purchPro", purchaseBillsProjs);
                        }
                        EntityWrapper<Bpurchases> bpurchasesEntityWrapper = new EntityWrapper<>();
                        bpurchasesEntityWrapper.setSqlSelect("id", "c_name");
                        List<Bpurchases> bpurchases = new ArrayList<>();
                        if (!Objects.equals(sysUserDto.getLoginContractorId(), 1)) {
                            bpurchasesEntityWrapper.eq("branch_id", sysUserDto.getLoginContractorId());
                        }
                        bpurchases = bpurchasesService.selectList(bpurchasesEntityWrapper);
                        map.put("bpurch", bpurchases);
                        map.put("form", projectBS);
                        if (projectBS.getProjectTypeId() != null && projectBS.getProjectTypeId() != 0) {
                            EntityWrapper<BprojectTypes> bprojectTypesEntityWrapper = new EntityWrapper<>();
                            bprojectTypesEntityWrapper.setSqlSelect("id", "project_type_name").eq("id", projectBS.getProjectTypeId());
                            BprojectTypes bprojectTypes = bprojectTypesService.selectOne(bprojectTypesEntityWrapper);
                            map.put("projectType", bprojectTypes);
                        }
                        if (projectBS.getCorpId() != null && projectBS.getCorpId() != 0) {
                            EntityWrapper<Bcorps> bcorpsEntityWrapper = new EntityWrapper<>();
                            bcorpsEntityWrapper.setSqlSelect("id", "c_name").eq("id", projectBS.getCorpId());
                            Bcorps bcorps = bcorpsService.selectOne(bcorpsEntityWrapper);
                            map.put("corp", bcorps);
                        }
                        Bbranchs bbranchs = bbranchsService.selectById(invoiceBills.getBranchId());
                        map.put("branch", bbranchs);
                        return map;
                    }
                }
            }
            return map;
        }
        return null;
    }

    @Override
    public Map<String, Object> changeFuzzyQueryProject(ProjectBillsSubsDto projectBillsSubsDto) {
        if (projectBillsSubsDto.getId() != null && projectBillsSubsDto.getId() != 0) {
            Map<String, Object> map = new HashMap<>();
            ProjectBS projectBS = invoiceBillsService.selectInvoice(projectBillsSubsDto);
            EntityWrapper<ProjectBillsStlPlans> projectBillsStlPlansEntityWrapper = new EntityWrapper<>();
            projectBillsStlPlansEntityWrapper.eq("bill_no", projectBS.getBillNo());
            List<ProjectBillsStlPlans> projectBillsStlPlans = projectBillsStlPlansService.selectList(projectBillsStlPlansEntityWrapper);
            if (projectBillsStlPlans.size() != 0) {
                map.put("proStlPlans", projectBillsStlPlans);
            }
            ProjectBS bs = new ProjectBS();
            bs.setActStartDate(projectBS.getActStartDate());
            bs.setActEndDate(projectBS.getActEndDate());
            bs.setActDays(projectBS.getActDays());
            bs.setCurrentProgress(projectBS.getCurrentProgress());
            map.put("form", projectBS);
            map.put("project", bs);
            if (projectBS.getProjectTypeId() != null) {
                EntityWrapper<BprojectTypes> bprojectTypesEntityWrapper = new EntityWrapper<>();
                bprojectTypesEntityWrapper.setSqlSelect("id", "project_type_name").eq("id", projectBS.getProjectTypeId());
                BprojectTypes bprojectTypes = bprojectTypesService.selectOne(bprojectTypesEntityWrapper);
                map.put("projectType", bprojectTypes);
            }
            if (projectBS.getCorpId() != null) {
                EntityWrapper<Bcorps> bcorpsEntityWrapper = new EntityWrapper<>();
                bcorpsEntityWrapper.setSqlSelect("id", "c_name").eq("id", projectBS.getCorpId());
                Bcorps bcorps = bcorpsService.selectOne(bcorpsEntityWrapper);
                map.put("corp", bcorps);
            }
            if (projectBS.getConstructorId() != null) {
                EntityWrapper<Bbranchs> bbranchsEntityWrapper = new EntityWrapper<>();
                bbranchsEntityWrapper.setSqlSelect("id", "c_name").eq("id", projectBS.getConstructorId());
                Bbranchs bbranchs = bbranchsService.selectOne(bbranchsEntityWrapper);
                map.put("branch", bbranchs);
            }
            return map;
        }
        return null;
    }

    @Override
    public Map<String, Object> queryInvoiceTemporary(InvoiceBillsDto invoiceBills) {
        if (invoiceBills != null && invoiceBills.getId() != null) {
            EntityWrapper<InvoiceBills> entityWrapper = new EntityWrapper<>();
            entityWrapper.eq("id", invoiceBills.getId());
            InvoiceBills invoiceBillsDto = invoiceBillsService.selectOne(entityWrapper);
            Map<String, Object> map = new HashMap<>();
            EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
            projectBillsSubsEntityWrapper.eq("project_sub_no", invoiceBillsDto.getProjectSubNo());
            ProjectBillsSubs billsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
            if (billsSubs != null) {
                map.put("proSub", billsSubs);
                EntityWrapper<ProjectBillsStlPlans> projectBillsStlPlansEntityWrapper = new EntityWrapper<>();
                projectBillsStlPlansEntityWrapper.eq("bill_no", billsSubs.getBillNo());
                List<ProjectBillsStlPlans> projectBillsStlPlans = projectBillsStlPlansService.selectList(projectBillsStlPlansEntityWrapper);
                if (projectBillsStlPlans.size() != 0) {
                    map.put("proStlPlans", projectBillsStlPlans);
                }
                ProjectBillsSubsDto projectBillsSubsDto = new ProjectBillsSubsDto();
                projectBillsSubsDto.setId(billsSubs.getId());
                ProjectBS projectBS = invoiceBillsService.selectInvoice(projectBillsSubsDto);
                projectBS.setBillNo(invoiceBillsDto.getBillNo());
                if (projectBS.getProjectTypeId() != null && projectBS.getProjectTypeId() != 0) {
                    EntityWrapper<BprojectTypes> bprojectTypesEntityWrapper = new EntityWrapper<>();
                    bprojectTypesEntityWrapper.setSqlSelect("id", "project_type_name").eq("id", projectBS.getProjectTypeId());
                    BprojectTypes bprojectTypes = bprojectTypesService.selectOne(bprojectTypesEntityWrapper);
                    map.put("projectType", bprojectTypes);
                }
                if (projectBS.getCorpId() != null && projectBS.getCorpId() != 0) {
                    EntityWrapper<Bcorps> bcorpsEntityWrapper = new EntityWrapper<>();
                    bcorpsEntityWrapper.setSqlSelect("id", "c_name").eq("id", projectBS.getCorpId());
                    Bcorps bcorps = bcorpsService.selectOne(bcorpsEntityWrapper);
                    map.put("corp", bcorps);
                }
                if (projectBS.getConstructorId() != null && projectBS.getConstructorId() != 0) {
                    EntityWrapper<Bbranchs> bbranchsEntityWrapper = new EntityWrapper<>();
                    bbranchsEntityWrapper.setSqlSelect("id", "c_name").eq("id", projectBS.getConstructorId());
                    Bbranchs bbranchs = bbranchsService.selectOne(bbranchsEntityWrapper);
                    map.put("branch", bbranchs);
                }
                map.put("form", projectBS);
                ProjectBS bs = new ProjectBS();
                bs.setActStartDate(projectBS.getActStartDate());
                bs.setActEndDate(projectBS.getActEndDate());
                bs.setCurrentProgress(projectBS.getCurrentProgress());
                map.put("project", bs);
                InvoiceBills bills = new InvoiceBills();
                bills.setId(invoiceBillsDto.getId());
                bills.setInvAmt(invoiceBillsDto.getInvAmt());
                bills.setInvTotalAmt(invoiceBillsDto.getInvTotalAmt());
                bills.setInvAmtRate(invoiceBillsDto.getInvAmtRate());
                bills.setPayPropertyId(invoiceBillsDto.getPayPropertyId());
                bills.setInvTotalRate(invoiceBillsDto.getInvTotalRate());
                bills.setProgressRate(invoiceBillsDto.getProgressRate());
                bills.setPurchaseNcNo(invoiceBillsDto.getPurchaseNcNo());
                EntityWrapper<BpayPropertys> bpayPropertysEntityWrapper = new EntityWrapper<>();
                bpayPropertysEntityWrapper.setSqlSelect("id", "pay_property_name").eq("id", invoiceBillsDto.getPayPropertyId());
                BpayPropertys bpayPropertys = bpayPropertysService.selectOne(bpayPropertysEntityWrapper);
                map.put("property", bpayPropertys);
                map.put("collectionProgress", bills);
                EntityWrapper<InvoiceBillsItems> invoiceBillsItemsEntityWrapper = new EntityWrapper<>();
                invoiceBillsItemsEntityWrapper.eq("bill_no", invoiceBillsDto.getBillNo());
                List<InvoiceBillsItems> billsItems = invoiceBillsItemsService.selectList(invoiceBillsItemsEntityWrapper);
                if (billsItems.size() != 0) {
                    map.put("invoiceItems", billsItems);
                }
                return map;
            }
        }
        return null;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> invoiceTemporary(String projectForm, String progress, String maintenance, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            ProjectBS projectBS = JSONArray.parseObject(projectForm, ProjectBS.class);
            InvoiceBills invoiceBills = JSONArray.parseObject(progress, InvoiceBills.class);
            JSONArray jsonArray = JSONArray.parseArray(maintenance);
            List<InvoiceBillsItems> invoiceBillsItems = JSONObject.parseArray(jsonArray.toJSONString(), InvoiceBillsItems.class);
            invoiceBills.setBillNo(projectBS.getBillNo());
            invoiceBills.setProjectSubNo(projectBS.getProjectSubNo());
            invoiceBills.setActId(107);
            invoiceBills.setBillStatus(2);
            invoiceBills.setInvAmt(projectBS.getInvAmt());
            invoiceBills.setOpUserId(sysUserDto.getUserId().intValue());
            invoiceBills.setOpUserName(sysUserDto.getUsername());
            invoiceBills.setCreateDate(new Date());
            invoiceBills.setBillDate(new Date());
            invoiceBills.setBranchId(projectBS.getConstructorId());
            boolean update = invoiceBillsService.insertOrUpdate(invoiceBills);
            if (!update) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("暂存失败：更新收款发票失败。");
                return result;
            }
            List<ProjectBillsStlPlans> projectBillsStlPlans = invoiceBillsService.selectProStlPlans(projectBS);
            if (projectBillsStlPlans.size() != 0) {
                for (ProjectBillsStlPlans pb : projectBillsStlPlans) {
                    double amt = pb.getAmt() - pb.getStlAmt();
                    if (amt != 0 && projectBS.getInvAmt() >= amt) {
                        pb.setStlAmt(pb.getAmt());
                        projectBS.setInvAmt(projectBS.getInvAmt() - amt);
                        boolean updateById1 = projectBillsStlPlansService.updateById(pb);
                        if (!updateById1) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("暂存失败：更新累计收款失败。");
                            return result;
                        }
                    }
                }
            }
            if (invoiceBillsItems.size() != 0) {
                EntityWrapper<InvoiceBillsItems> invoiceBillsItemsEntityWrapper = new EntityWrapper<>();
                invoiceBillsItemsEntityWrapper.setSqlSelect("id").eq("bill_no", projectBS.getBillNo())
                        .eq("project_sub_no", projectBS.getProjectSubNo());
                List<InvoiceBillsItems> billsItems = invoiceBillsItemsService.selectList(invoiceBillsItemsEntityWrapper);
                if (billsItems.size() != 0) {
                    for (InvoiceBillsItems ib : billsItems) {
                        invoiceBillsItemsService.deleteById(ib);
                    }
                }
                int line = 0;
                for (InvoiceBillsItems invo : invoiceBillsItems) {
                    line++;
                    invo.setBillNo(projectBS.getBillNo());
                    invo.setActId(107);
                    invo.setLineNo(line);
                    invo.setProjectSubNo(projectBS.getProjectSubNo());
                    invo.setBranchId(projectBS.getBranchId());
                    boolean insert = invoiceBillsItemsService.insert(invo);
                    if (!insert) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("暂存失败：新建发票明细失败。");
                        return result;
                    }
                }
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 暂存错误：" + e.toString(), e);
            result.addErrorMessage("暂存失败，请重新尝试");
        }
        return result;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> invoiceSave(String projectForm, String progress, String maintenance, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            ProjectBS projectBS = JSONArray.parseObject(projectForm, ProjectBS.class);
            InvoiceBills invoiceBills = JSONArray.parseObject(progress, InvoiceBills.class);
            JSONArray jsonArray = JSONArray.parseArray(maintenance);
            List<InvoiceBillsItems> invoiceBillsItems = JSONObject.parseArray(jsonArray.toJSONString(), InvoiceBillsItems.class);
            EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
            projectBillsSubsEntityWrapper.setSqlSelect("id", "sub_inv_amt_dr", "sub_inv_amt_cr").eq("project_sub_no", projectBS.getProjectSubNo());
            ProjectBillsSubs billsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
            invoiceBills.setBillNo(projectBS.getBillNo());
            invoiceBills.setProjectSubNo(projectBS.getProjectSubNo());
            invoiceBills.setActId(107);
            invoiceBills.setBillStatus(6);
            invoiceBills.setInvAmt(projectBS.getInvAmt());
            invoiceBills.setOpUserId(sysUserDto.getUserId().intValue());
            invoiceBills.setOpUserName(sysUserDto.getUsername());
            invoiceBills.setCreateDate(new Date());
            invoiceBills.setBillDate(new Date());
            invoiceBills.setPostDate(new Date());
            invoiceBills.setBranchId(sysUserDto.getLoginContractorId());
            boolean update = invoiceBillsService.insertOrUpdate(invoiceBills);
            if (!update) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("暂存失败：更新收款发票失败。");
                return result;
            }
            billsSubs.setSubInvAmtDr(billsSubs.getSubInvAmtDr() + invoiceBills.getInvAmt());
            boolean updateById = projectBillsSubsService.updateById(billsSubs);
            if (!updateById) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("提交失败：更新累计收款发票失败。");
                return result;
            }
            List<ProjectBillsStlPlans> projectBillsStlPlans = invoiceBillsService.selectProStlPlans(projectBS);
            if (projectBillsStlPlans.size() != 0) {
                Double invAmt = invoiceBills.getInvAmt();
                for (ProjectBillsStlPlans pb : projectBillsStlPlans) {
                    double amt = pb.getAmt() - pb.getStlAmt();
                    if (amt != 0 && invAmt != 0) {
                        boolean updateById1 = false;
                        if (invAmt >= amt) {
                            pb.setStlAmt(pb.getAmt());
                            invAmt = invAmt - amt;
                            updateById1 = projectBillsStlPlansService.updateById(pb);
                            if (!updateById1) {
                                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                result.addErrorMessage("提交失败：更新累计收款失败。");
                                return result;
                            }
                        } else {
                            pb.setStlAmt(invAmt);
                            updateById1 = projectBillsStlPlansService.updateById(pb);
                            if (!updateById1) {
                                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                result.addErrorMessage("提交失败：更新累计收款失败。");
                                return result;
                            }
                            break;
                        }
                    }
                }
            }
            if (invoiceBillsItems.size() != 0) {
                EntityWrapper<InvoiceBillsItems> invoiceBillsItemsEntityWrapper = new EntityWrapper<>();
                invoiceBillsItemsEntityWrapper.setSqlSelect("id").eq("bill_no", projectBS.getBillNo())
                        .eq("project_sub_no", projectBS.getProjectSubNo());
                List<InvoiceBillsItems> billsItems = invoiceBillsItemsService.selectList(invoiceBillsItemsEntityWrapper);
                if (billsItems.size() != 0) {
                    for (InvoiceBillsItems ib : billsItems) {
                        boolean deleteBatchIds = invoiceBillsItemsService.deleteById(ib);
                        if (!deleteBatchIds) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：删除旧数据失败。");
                            return result;
                        }
                    }
                }
                int line = 0;
                for (InvoiceBillsItems invo : invoiceBillsItems) {
                    line++;
                    invo.setBillNo(projectBS.getBillNo());
                    invo.setActId(107);
                    invo.setLineNo(line);
                    invo.setProjectSubNo(projectBS.getProjectSubNo());
                    invo.setBranchId(sysUserDto.getLoginContractorId());
                    boolean insert = invoiceBillsItemsService.insert(invo);
                    if (!insert) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：新建发票明细失败。");
                        return result;
                    }
                }
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 提交错误：" + e.toString(), e);
            result.addErrorMessage("提交错误，请重新尝试");
        }
        return result;
    }


    @Override
    public Map<String, Object> selectItem(ProjectBillsSubsDto dto) {
        Map<String, Object> map = new HashMap<>();
        EntityWrapper<ProjectBillsSubs> wentityWrapper = new EntityWrapper<>();
        wentityWrapper.eq("project_sub_no", dto.getProjectSubNo());
        ProjectBillsSubs projectBillsSubsDto = projectBillsSubsService.selectOne(wentityWrapper);
        List<PurchaseBillsItems> purchaseBillsItemsList = new ArrayList<>();
        EntityWrapper<PurchaseBills> purchaseBillsEntityWrapper = new EntityWrapper<>();
        purchaseBillsEntityWrapper.eq("project_sub_no", projectBillsSubsDto.getProjectSubNo());
        purchaseBillsEntityWrapper.eq("act_id", 4);
        purchaseBillsEntityWrapper.eq("bill_status", 6);
        List<PurchaseBills> purchaseBills = purchaseBillsService.selectList(purchaseBillsEntityWrapper);
        EntityWrapper<Projectbills> projectbillsEntityWrapper = new EntityWrapper<>();
        projectbillsEntityWrapper.eq("bill_no", projectBillsSubsDto.getBillNo());
        List<Bpurchases> bpurchases = new ArrayList<>();
        for (PurchaseBills bills : purchaseBills) {
            EntityWrapper<PurchaseBillsItems> purchaseBillsItemsEntityWrapper = new EntityWrapper<>();
            purchaseBillsItemsEntityWrapper.eq("bill_no", bills.getBillNo());
            purchaseBillsItemsEntityWrapper.eq("act_id", 4);
            List<PurchaseBillsItems> purchaseBillsItems = purchaseBillsItemsService.selectList(purchaseBillsItemsEntityWrapper);
            purchaseBillsItemsList.addAll(purchaseBillsItems);
            for (PurchaseBillsItems billsItems : purchaseBillsItems) {
                EntityWrapper<Bpurchases> bpurchasesEntityWrapper = new EntityWrapper<>();
                bpurchasesEntityWrapper.eq("id", billsItems.getPurchaseId());
                Bpurchases purchases = bpurchasesService.selectOne(bpurchasesEntityWrapper);
                if (bpurchases.size() == 0) {
                    bpurchases.add(purchases);
                } else {
                    for (Bpurchases chase : bpurchases) {
                        if (!Objects.equals(purchases.getId(), chase.getId())) {
                            bpurchases.add(purchases);
                            break;
                        }
                    }
                }
            }
        }
        Projectbills projectbills = projectbillsService.selectOne(projectbillsEntityWrapper);
        EntityWrapper<Bcorps> bcorpsEntityWrapper = new EntityWrapper<>();
        bcorpsEntityWrapper.eq("id", projectbills.getCorpId());
        EntityWrapper<BprojectTypes> bprojectTypesEntityWrapper = new EntityWrapper<>();
        bprojectTypesEntityWrapper.eq("id", projectbills.getProjectTypeId());
        EntityWrapper<Bbranchs> bbranchsEntityWrapper = new EntityWrapper<>();
        bbranchsEntityWrapper.eq("id", projectbills.getBranchId());
        EntityWrapper<ProjectBillsBudgets> budgetsEntityWrapper = new EntityWrapper<>();
        budgetsEntityWrapper.eq("project_sub_no", projectBillsSubsDto.getProjectSubNo());

        EntityWrapper<ProjectBillsSubs> entityWrapper = new EntityWrapper<>();
        entityWrapper.setSqlSelect("id", "project_sub_name").eq("project_sub_no", projectBillsSubsDto.getProjectSubNo());
        ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(entityWrapper);
        if (projectBillsSubs != null) {
            map.put("proSub", projectBillsSubs);
        }
        map.put("zhu", purchaseBills);
        map.put("item", purchaseBillsItemsList);
        map.put("gong", bpurchases);
        map.put("zong", projectbills);
        map.put("project", projectBillsSubsDto);
        map.put("yezhu", bcorpsService.selectOne(bcorpsEntityWrapper));
        map.put("leixing", bprojectTypesService.selectOne(bprojectTypesEntityWrapper));
        map.put("chengbao", bbranchsService.selectOne(bbranchsEntityWrapper));
        map.put("yusuan", projectBillsBudgetsService.selectList(budgetsEntityWrapper));
        map.put("shiji", bbranchsService.selectById(projectbills.getConstructorId()));
        return map;

    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public String directTemporary(String zhu, String fapiao, String fujian, SysUserDto sysUserDto) {
        try {
            InvoiceBills invoiceBills = JSONArray.parseObject(zhu, InvoiceBills.class);
            JSONArray jsonArray = JSONArray.parseArray(fapiao);
            List<InvoiceBillsItems> invoiceBillsItems = JSONObject.parseArray(jsonArray.toJSONString(), InvoiceBillsItems.class);
            JSONArray faArray = JSONArray.parseArray(fujian);
            List<InvoiceBillsAttachs> invoiceBillsPlans = JSONObject.parseArray(faArray.toJSONString(), InvoiceBillsAttachs.class);
            if (invoiceBillsPlans.size() != 0) {
                for (InvoiceBillsAttachs iv : invoiceBillsPlans) {
                    iv.setOpUserId(sysUserDto.getUserId().intValue());
                    iv.setOpUserName(sysUserDto.getUsername());
                    iv.setOpDate(new Date());
                }
            }
            if (!invoiceBillsService.insertOrUpdate(invoiceBills)) {
                return "表单数据有误，请核对";
            } else if (!invoiceBillsItemsService.insertOrUpdateBatch(invoiceBillsItems)) {
                return "发票信息有误，请检查发票信息";
            } else if (!invoiceBillsAttachsService.insertOrUpdateBatch(invoiceBillsPlans)) {
                return "保存附件出错，请检查数据";
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 提交错误：" + e.toString(), e);
            return "1";
        }
        return "1";
    }

    @Override
    public Map<String, Object> selectBillsItem(String subNo, Integer purchaseId) {
        Map<String, Object> map = new HashMap<>();
        EntityWrapper<PurchaseBillsItems> billsItemsEntityWrapper = new EntityWrapper<>();
        billsItemsEntityWrapper.eq("act_id", 4)
                .eq("project_Sub_No", subNo)
                .eq("purchase_id", purchaseId);
        List<PurchaseBillsItems> purchaseBillsItems = purchaseBillsItemsService.selectList(billsItemsEntityWrapper);
        if (purchaseBillsItems.size() != 0) {
            for (int i = 0; i < purchaseBillsItems.size() - 1; i++) {
                for (int j = purchaseBillsItems.size() - 1; j > i; j--) {
                    String contractPrice = String.valueOf(purchaseBillsItems.get(i).getContractPrice());
                    String contractPrice2 = String.valueOf(purchaseBillsItems.get(j).getContractPrice());
                    if (purchaseBillsItems.get(i).getItemNo() != null && purchaseBillsItems.get(j).getItemNo() != null &&
                            purchaseBillsItems.get(i).getItemSpecs() != null && purchaseBillsItems.get(j).getItemSpecs() != null) {
                        boolean billNoStatus = purchaseBillsItems.get(i).getBillNo().equals(purchaseBillsItems.get(j).getBillNo());
                        boolean itemNameStatus = purchaseBillsItems.get(i).getItemName().equals(purchaseBillsItems.get(j).getItemName());
                        boolean itemNoStatus = purchaseBillsItems.get(i).getItemNo().equals(purchaseBillsItems.get(j).getItemNo());
                        boolean itemSpecsStatus = purchaseBillsItems.get(i).getItemSpecs().equals(purchaseBillsItems.get(j).getItemSpecs());
                        if (!Objects.equals(purchaseBillsItems.get(i).getId(), purchaseBillsItems.get(j).getId()) && billNoStatus && itemSpecsStatus &&
                                itemNameStatus && itemNoStatus && contractPrice.equals(contractPrice2)) {
                            purchaseBillsItems.get(i).setContractQty(Double.parseDouble(String.format("%.4f", purchaseBillsItems.get(i).getContractQty() + purchaseBillsItems.get(j).getContractQty())));
                            purchaseBillsItems.get(i).setInvTotalQty(Double.parseDouble(String.format("%.4f", purchaseBillsItems.get(i).getInvTotalQty() + purchaseBillsItems.get(j).getInvTotalQty())));
                            purchaseBillsItems.remove(j);
                        }
                    }
                }
            }
            map.put("item", purchaseBillsItems);
        } else {
            map.put("item", null);
        }
        return map;
    }

    @Override
    public Map<String, Object> queryDirectCostTemporary(InvoiceBillsDto invoiceBillsDto) {
        if (invoiceBillsDto != null && invoiceBillsDto.getId() != null) {
            Map<String, Object> map = new HashMap<>();
            EntityWrapper<InvoiceBills> entityWrapper = new EntityWrapper<>();
            entityWrapper.eq("id", invoiceBillsDto.getId());
            InvoiceBills invoiceBills = invoiceBillsService.selectOne(entityWrapper);
            if (invoiceBills != null) {
                map.put("invoice", invoiceBills);
                map.put("projectSubNo", invoiceBills.getProjectSubNo());
                ProjectBS projectBS = invoiceBillsService.selectDirectCostTemporary(map);
                if (projectBS != null) {
                    map.put("proBS", projectBS);
                    EntityWrapper<BprojectTypes> typesEntityWrapper = new EntityWrapper<>();
                    typesEntityWrapper.eq("id", projectBS.getProjectTypeId());
                    BprojectTypes bprojectTypes = bprojectTypesService.selectOne(typesEntityWrapper);
                    if (bprojectTypes != null) {
                        map.put("proType", bprojectTypes);
                    }
                    EntityWrapper<Bcorps> bcorpsEntityWrapper = new EntityWrapper<>();
                    bcorpsEntityWrapper.eq("id", projectBS.getCorpId());
                    Bcorps bcorps = bcorpsService.selectOne(bcorpsEntityWrapper);
                    if (bcorps != null) {
                        map.put("corp", bcorps);
                    }
                    EntityWrapper<Bbranchs> bbranchsEntityWrapper = new EntityWrapper<>();
                    bbranchsEntityWrapper.eq("id", projectBS.getBranchId());
                    Bbranchs bbranchs = bbranchsService.selectOne(bbranchsEntityWrapper);
                    if (bbranchs != null) {
                        map.put("branch", bbranchs);
                    }
                }
                EntityWrapper<InvoiceBillsItems> invoiceBillsItemsEntityWrapper = new EntityWrapper<>();
                invoiceBillsItemsEntityWrapper.eq("bill_no", invoiceBills.getBillNo()).eq("act_id", invoiceBills.getActId());
                List<InvoiceBillsItems> billsItemsList = invoiceBillsItemsService.selectList(invoiceBillsItemsEntityWrapper);
                if (billsItemsList.size() != 0) {
                    map.put("invoItems", billsItemsList);
                }
                EntityWrapper<InvoiceBillsAttachs> invoiceBillsAttachsEntityWrapper = new EntityWrapper<>();
                invoiceBillsAttachsEntityWrapper.eq("bill_no", invoiceBills.getBillNo()).eq("act_id", invoiceBills.getActId());
                List<InvoiceBillsAttachs> invoiceBillsAttachs = invoiceBillsAttachsService.selectList(invoiceBillsAttachsEntityWrapper);
                if (invoiceBillsAttachs.size() != 0) {
                    map.put("invoAttachs", invoiceBillsAttachs);
                }
            }
            return map;
        }
        return null;
    }

    @Override
    public Map<String, Object> invoiceMaterialPage(Map<String, Object> map, SysUserDto sysUserDto) {
        Map<String, Object> objectMap = new HashMap<>();
        SysRole sysRole = subContractBillsService.selectRole(sysUserDto);
        map.put("user", sysUserDto);
        map.put("role", sysRole);
        try {
            int num = invoiceBillsService.selectInvoiceMaterialTotal(map);
            if (num != 0) {
                int current = (int) map.get("current");
                int size = (int) map.get("size");
                if (current <= 1) {
                    current = 0;
                } else {
                    current = (current - 1) * size;
                }
                map.put("size", size);
                map.put("current", current);
                List<Map<String, Object>> mapList = invoiceBillsService.selectInvoiceMaterialRecords(map);
                Page page = new Page();
                page.setRecords(mapList);
                page.setTotal(num);
                objectMap.put("page", page);
                return objectMap;
            }
        } catch (Exception e) {
            logger.error("操作异常：" + e.toString(), e);
        }
        return null;
    }

    @Override
    public Map<String, Object> queryEngineeringSubContract(SubContractBillsDto subContractBillsDto) {
        if (subContractBillsDto != null && subContractBillsDto.getPurchasePlanNo() != null) {
            Map<String, Object> map = new HashMap<>();
            EntityWrapper<SubContractBills> entityWrapper = new EntityWrapper<>();
            entityWrapper.eq("purchase_plan_no", subContractBillsDto.getPurchasePlanNo());
            SubContractBills subContractBills = subContractBillsService.selectOne(entityWrapper);
            if (subContractBills != null) {
                map.put("subContract", subContractBills);
            }
            return map;
        }
        return null;
    }

    @Override
    public Map<String, Object> queryPayInvoiceMaintenBudget(ProjectBillsBudgetsDto projectBillsBudgetsDto) {
        if (projectBillsBudgetsDto != null) {
            Map<String, Object> map = new HashMap<>();
            EntityWrapper<ProjectBillsBudgets> entityWrapper = new EntityWrapper<>();
            entityWrapper.eq("project_sub_no", projectBillsBudgetsDto.getProjectSubNo())
                    .eq("budget_id", projectBillsBudgetsDto.getBudgetId());
            ProjectBillsBudgets billsBudgets = projectBillsBudgetsService.selectOne(entityWrapper);
            if (billsBudgets != null) {
                map.put("proBudget", billsBudgets);
            }
            return map;
        }
        return null;
    }

    @Override
    public Map<String, Object> selectPrint(InvoiceBillsDto invoiceBillsDto, SysUserDto sysUserDto) {
        if (invoiceBillsDto != null && invoiceBillsDto.getId() != null) {
            Map<String, Object> map = new HashMap<>();
            map = invoiceBillsService.selectReimbursementPrint(invoiceBillsDto);
            EntityWrapper<Bbranchs> bbranchsEntityWrapper = new EntityWrapper<>();
            bbranchsEntityWrapper.setSqlSelect("id", "c_name").eq("id", sysUserDto.getLoginContractorId());
            Bbranchs bbranchs = bbranchsService.selectOne(bbranchsEntityWrapper);
            map.put("branName", bbranchs.getCname());
            return map;
        }
        return null;
    }

    @Override
    public Map<String, Object> queryInvoiceIndirect(InvoiceBillsDto invoiceBillsDto) {
        if (invoiceBillsDto != null && invoiceBillsDto.getId() != null) {
            Map<String, Object> map = new HashMap<>();
            EntityWrapper<InvoiceBills> entityWrapper = new EntityWrapper<>();
            entityWrapper.eq("id", invoiceBillsDto.getId());
            InvoiceBills invoiceBills = invoiceBillsService.selectOne(entityWrapper);
            if (invoiceBills != null) {
                EntityWrapper<OtherProject> otherProjectEntityWrapper = new EntityWrapper<>();
                otherProjectEntityWrapper.eq("purchase_nc_no", invoiceBills.getPurchaseNcNo())
                        .eq("budget_id", invoiceBills.getBudgetId()).eq("purchases_id", invoiceBills.getPurchaseId());
                OtherProject otherProject = otherProjectService.selectOne(otherProjectEntityWrapper);
                if (otherProject != null) {
                    map.put("other", otherProject);
                }
                List<Map<String, Object>> mapList = invoiceBillsService.selectInvoiceIndirectPro(invoiceBillsDto);
                map.put("mapList", mapList);
            }
            return map;
        }
        return null;
    }

    @Override
    public Boolean updatePrintTime(Integer id) {
        InvoiceBills invoiceBills = invoiceBillsService.selectById(id);
        invoiceBills.setPrintTime(new Date());
        invoiceBills.setIsPrint(1);
        return invoiceBillsService.updateById(invoiceBills);
    }

    @Override
    public Map<String, Object> selectOtherIndirect(Map<String, Object> map, SysUserDto sysUserDto) {
        Map<String, Object> objectMap = new HashMap<>();
        SysRole sysRole = subContractBillsService.selectRole(sysUserDto);
        map.put("user", sysUserDto);
        map.put("role", sysRole);
        try {
            int num = invoiceBillsService.selectOtherIndirectCount(map);
            if (num != 0) {
                int current = (int) map.get("current");
                int size = (int) map.get("size");
                if (current <= 1) {
                    current = 0;
                } else {
                    current = (current - 1) * size;
                }
                map.put("size", size);
                map.put("current", current);
                List<Map<String, Object>> mapList = invoiceBillsService.selectOtherIndirect(map);
                Page page = new Page();
                page.setRecords(mapList);
                page.setTotal(num);
                objectMap.put("page", page);
                return objectMap;
            }
        } catch (Exception e) {
            logger.error("操作异常：" + e.toString(), e);
        }
        return null;
    }

    @Override
    public ExecuteResult<String> updateContractNo(SubContractBillsDto subContractBillsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        if (subContractBillsDto == null) {
            result.addErrorMessage("未找到分包合同");
            return result;
        }
        int id = Integer.parseInt(subContractBillsDto.getRemark());
        InvoiceBills invoiceBills = invoiceBillsService.selectById(id);
        invoiceBills.setContractNo(subContractBillsDto.getContractNo());
        boolean update = invoiceBillsService.updateById(invoiceBills);
        if (!update) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            result.addErrorMessage("提交失败：更新合同编号失败");
            return result;
        }
        return result;
    }

    @Override
    public ExecuteResult<String> updatePayCrContractNo(SubContractBillsDto subContractBillsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        if (subContractBillsDto == null) {
            result.addErrorMessage("未找到分包合同");
            return result;
        }
        int id = Integer.parseInt(subContractBillsDto.getRemark());
        PayCrBills payCrBills = payCrBillsService.selectById(id);
        payCrBills.setContractNo(subContractBillsDto.getContractNo());
        boolean update = payCrBillsService.updateById(payCrBills);
        if (!update) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            result.addErrorMessage("提交失败：更新合同编号失败");
            return result;
        }
        return result;
    }

    /**
     * 撤销功能
     * 1.根据id查出 invoice_bills 信息
     * 2.根据invoice_bills.project_sub_no、branch_id 查出 project_bills_subs表
     * 3.根据project_bills_subs.sub_inv_amt_cr - invoice_bills.inv_amt
     * 4.根据invoice_bills的project_sub_no、branch_id、purchase_id、contract_no（可能存在空） 查出 sub_contract_bills
     * 5.修改 sub_contract_bills的sub_inv_amt_cr - invoice_bills.inv_amt
     * 6.查 project_bills_budgets   project_bills_subs.project_sub_no + project_bills_subs.branch_id + project_bills_subs.budget_id(1)
     * 7.改project_bills_budgets  sub_inv_amt_cr - invoice_bills.inv_amt
     * 8.状态invoice_bills.bill_status为2，更新修改时间、修改人信息
     *
     * @param invoiceBillsDto
     * @return
     * @Author shanxin
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> revoke(InvoiceBillsDto invoiceBillsDto, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<>();
        try {
            InvoiceBills invoiceBills = this.invoiceBillsService.selectById(invoiceBillsDto.getId());
            if (null == invoiceBillsDto) {
                result.setErrorMessages(Arrays.asList("查询InvoiceBills出错！"));
                return result;
            }

            // 根据invoice_bills的project_sub_no、branch_id、purchase_id、contract_no（可能存在空） 查出 sub_contract_bills
            if (invoiceBills.getProjectSubNo() == null ||
                    invoiceBills.getBranchId() == null ||
                    invoiceBills.getPurchaseId() == null ||
                    invoiceBills.getContractNo() == null) {
                result.setErrorMessages(Arrays.asList("invoiceBills参数缺失sub_contract_bills，无法获取，请联系管理员"));
                return result;
            }


            // project_bills_subs.sub_inv_amt_cr - invoice_bills.inv_amt
            EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
            projectBillsSubsEntityWrapper.eq("project_sub_no", invoiceBills.getProjectSubNo())
                    .eq("branch_id", invoiceBills.getBranchId());
            ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
            projectBillsSubs.setSubInvAmtCr(interceptDoubleTwo(projectBillsSubs.getSubInvAmtCr() - invoiceBills.getInvAmt()));
            projectBillsSubsService.updateById(projectBillsSubs);

            // 修改 sub_contract_bills的sub_inv_amt_cr - invoice_bills.inv_amt
            EntityWrapper<SubContractBills> subContractBillsEntityWrapper = new EntityWrapper<>();
            subContractBillsEntityWrapper.eq("project_sub_no", invoiceBills.getProjectSubNo())
                    .eq("branch_id", invoiceBills.getBranchId())
                    .eq("purchase_id", invoiceBills.getPurchaseId())
                    .eq("contract_no", invoiceBills.getContractNo());
            SubContractBills subContractBills = subContractBillsService.selectOne(subContractBillsEntityWrapper);
            subContractBills.setSubInvAmtCr(interceptDoubleTwo(subContractBills.getSubInvAmtCr() - invoiceBills.getInvAmt()));
            subContractBillsService.updateById(subContractBills);

            // 修改 project_bills_budgets.sub_inv_amt_cr - invoice_bills.inv_amt
            EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
            projectBillsBudgetsEntityWrapper.eq("budget_id", 1)
                    .eq("branch_id", invoiceBills.getBranchId())
                    .eq("project_sub_no", invoiceBills.getProjectSubNo());
            ProjectBillsBudgets projectBillsBudgets = projectBillsBudgetsService.selectOne(projectBillsBudgetsEntityWrapper);
            projectBillsBudgets.setSubInvAmtCr(interceptDoubleTwo(projectBillsBudgets.getSubInvAmtCr() - invoiceBills.getInvAmt()));
            projectBillsBudgets.setSubInvAmtBlc(interceptDoubleTwo(projectBillsBudgets.getBudgetAmt() - projectBillsBudgets.getSubInvAmtCr()));
            projectBillsBudgetsService.updateById(projectBillsBudgets);


            // 状态invoice_bills.bill_status为2，更新修改时间、修改人信息
            invoiceBills.setBillStatus(2);
            invoiceBills.setModifyTime(new Date());
            invoiceBills.setModifyUserId(sysUserDto.getUserId());
            boolean b = invoiceBillsService.updateById(invoiceBills);
            if (b) {
                result.setSuccessMessage("操作成功!");
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            e.printStackTrace();
        }
        return result;
    }


    /**
     * 撤销--材料款
     *
     * @param invoiceBillsDto
     * @param sysUserDto
     * @return
     * @Author shanxin
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> revokeProjectPirce(InvoiceBillsDto invoiceBillsDto, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<>();
        InvoiceBills invoiceBills = this.invoiceBillsService.selectById(invoiceBillsDto.getId());
        try {
            EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
            projectBillsBudgetsEntityWrapper.eq("project_sub_no", invoiceBills.getProjectSubNo())
                    .eq("branch_id", invoiceBills.getBranchId())
                    .eq("budget_id", invoiceBills.getBudgetId());
            ProjectBillsBudgets billsBudgets = projectBillsBudgetsService.selectOne(projectBillsBudgetsEntityWrapper);
            billsBudgets.setSubInvAmtCr(interceptDoubleTwo(billsBudgets.getSubInvAmtCr() - invoiceBills.getInvAmt()));
            billsBudgets.setSubInvAmtBlc(interceptDoubleTwo(billsBudgets.getBudgetAmt() - billsBudgets.getSubInvAmtCr()));
            boolean updateByBudget = projectBillsBudgetsService.updateById(billsBudgets);
            if (!updateByBudget) {
                result.addErrorMessage("提交错误，更新预算失败");
                return result;
            }
            EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
            projectBillsSubsEntityWrapper.eq("project_sub_no", invoiceBills.getProjectSubNo())
                    .eq("branch_id", invoiceBills.getBranchId());
            ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);

            projectBillsSubs.setSubInvAmtCr(interceptDoubleTwo(projectBillsSubs.getSubInvAmtCr() - invoiceBills.getInvAmt()));
            boolean updateBySubs = projectBillsSubsService.updateById(projectBillsSubs);
            if (!updateBySubs) {
                result.addErrorMessage("提交错误，更新二级项目失败");
                return result;
            }
            EntityWrapper<OtherProject> otherProjectEntityWrapper = new EntityWrapper<>();
            otherProjectEntityWrapper.eq("purchase_nc_no", invoiceBills.getPurchaseNcNo())
                    .eq("project_sub_no", invoiceBills.getProjectSubNo())
                    .eq("branch_id", invoiceBills.getBranchId());
            OtherProject otherProject = otherProjectService.selectOne(otherProjectEntityWrapper);
            otherProject.setContractTotalAmt(interceptDoubleTwo(otherProject.getContractTotalAmt() - invoiceBills.getInvAmt()));
            boolean otherProjectType = otherProjectService.updateById(otherProject);
            if (!otherProjectType) {
                result.addErrorMessage("撤回失败: 更新其他合同失败");
                return result;
            }
            if ("F".equals(invoiceBills.getIsSur())) {
                EntityWrapper<PurchaseBillsItems> itemsEntityWrapper = new EntityWrapper<>();
                String beginTime = new String("2020-11-19 00:00:00");
                SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                Date sd1 = df.parse(beginTime);
                long long1 = invoiceBills.getCreateDate().getTime();
                long long2 = sd1.getTime();
                // 2020-11-19 之前创建的
                if (long1 < long2) {
                    itemsEntityWrapper.eq("bill_no", invoiceBills.getBillNo())
                            .eq("act_id", 9);
                } else {
                    itemsEntityWrapper.eq("act_id", 4);
                }
                itemsEntityWrapper.eq("project_sub_no", invoiceBills.getProjectSubNo())
                        .eq("purchase_id", invoiceBills.getPurchaseId());
                List<PurchaseBillsItems> purchaseBillsItemsList = purchaseBillsItemsService.selectList(itemsEntityWrapper);
                for (PurchaseBillsItems billsItems : purchaseBillsItemsList) {
                    EntityWrapper<InvoicePurchase> purchaseEntityWrapper = new EntityWrapper<>();
                    purchaseEntityWrapper.eq("inv_id", invoiceBills.getId())
                            .eq("purchase_item_id", billsItems.getId());
                    InvoicePurchase invoicePurchase = invoicePurchaseService.selectOne(purchaseEntityWrapper);
                    if (invoicePurchase != null) {
                        billsItems.setTimeQty(invoicePurchase.getTimeQty());
                        billsItems.setTimeAmt(invoicePurchase.getTimeAmt());
                    }
                    billsItems.setInvTotalQty(billsItems.getInvTotalQty() - billsItems.getTimeQty());
                    billsItems.setInvTotalAmt(interceptDoubleTwo(billsItems.getInvTotalAmt() - billsItems.getTimeAmt()));
                    boolean billType = purchaseBillsItemsService.updateById(billsItems);
                    if (!billType) {
                        result.addErrorMessage("提交失败：更新累计开票失败");
                    }
                }
            }
            // 更新invoiceBills
            invoiceBills.setBillStatus(2);
            invoiceBills.setModifyTime(new Date());
            invoiceBills.setModifyUserId(sysUserDto.getUserId());
            boolean b = invoiceBillsService.updateById(invoiceBills);
            if (b) {
                result.setSuccessMessage("操作成功!");
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            e.printStackTrace();
        }
        return result;
    }

    /**
     * 撤销-其他款项-直接
     *
     * @param invoiceBillsDto
     * @param sysUserDto
     * @return
     * @Author shanxin
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public ExecuteResult<String> revokeDirectInvoiceCost(InvoiceBillsDto invoiceBillsDto, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<>();
        InvoiceBills invoiceBills = this.invoiceBillsService.selectById(invoiceBillsDto.getId());
        try {
            EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
            projectBillsBudgetsEntityWrapper.eq("project_sub_no", invoiceBills.getProjectSubNo())
                    .eq("branch_id", invoiceBills.getBranchId())
                    .eq("budget_id", invoiceBills.getBudgetId());
            ProjectBillsBudgets billsBudgets = projectBillsBudgetsService.selectOne(projectBillsBudgetsEntityWrapper);
            billsBudgets.setSubInvAmtCr(Double.parseDouble(String.format("%.2f", billsBudgets.getSubInvAmtCr() - invoiceBills.getInvAmt())));
            billsBudgets.setSubInvAmtBlc(Double.parseDouble(String.format("%.2f", billsBudgets.getBudgetAmt() - billsBudgets.getSubInvAmtCr())));
            boolean updateByBudget = projectBillsBudgetsService.updateById(billsBudgets);
            if (!updateByBudget) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("提交错误，更新预算失败");
                return result;
            }
            EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
            projectBillsSubsEntityWrapper.eq("project_sub_no", invoiceBills.getProjectSubNo())
                    .eq("branch_id", invoiceBills.getBranchId());
            ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
            double sum = projectBillsBudgetsService.selectApprovedAmountSum(billsBudgets);
            projectBillsSubs.setActualBudgetAmt(sum);
            projectBillsSubs.setSubInvAmtCr(Double.parseDouble(String.format("%.2f", projectBillsSubs.getSubInvAmtCr() - invoiceBills.getInvAmt())));
            boolean updateBySubs = projectBillsSubsService.updateById(projectBillsSubs);
            if (!updateBySubs) {
                result.addErrorMessage("提交错误，更新二级项目失败");
                return result;
            }
            EntityWrapper<OtherProject> otherProjectEntityWrapper = new EntityWrapper<>();
            otherProjectEntityWrapper.eq("purchase_nc_no", invoiceBills.getPurchaseNcNo())
                    .eq("project_sub_no", invoiceBills.getProjectSubNo())
                    .eq("branch_id", invoiceBills.getBranchId());
            OtherProject otherProject = otherProjectService.selectOne(otherProjectEntityWrapper);
            otherProject.setContractTotalAmt(Double.parseDouble(String.format("%.2f", otherProject.getContractTotalAmt() - invoiceBills.getInvAmt())));
            boolean otherProjectType = otherProjectService.updateById(otherProject);
            if (!otherProjectType) {
                result.addErrorMessage("撤回失败: 更新其他合同失败");
                return result;
            }

            // 更新invoiceBills
            invoiceBills.setBillStatus(2);
            invoiceBills.setModifyTime(new Date());
            invoiceBills.setModifyUserId(sysUserDto.getUserId());
            boolean b = invoiceBillsService.updateById(invoiceBills);
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            e.printStackTrace();
        }
        return result;
    }

    /**
     * 撤销-其他款项-间接
     *
     * @param invoiceBillsDto
     * @param sysUserDto
     * @return
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public ExecuteResult<String> revokeIndirect(InvoiceBillsDto invoiceBillsDto, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<>();
        try {
            InvoiceBills invoiceBills = this.invoiceBillsService.selectById(invoiceBillsDto.getId());
            EntityWrapper<OtherProject> otherProjectEntityWrapper = new EntityWrapper<>();
            otherProjectEntityWrapper.eq("purchase_nc_no", invoiceBills.getPurchaseNcNo())
                    .eq("branch_id", invoiceBills.getBranchId());
            OtherProject otherProject = otherProjectService.selectOne(otherProjectEntityWrapper);
            otherProject.setContractTotalAmt(interceptDoubleTwo(otherProject.getContractTotalAmt() - invoiceBills.getInvAmt()));
            boolean updateByOther = otherProjectService.updateById(otherProject);
            if (!updateByOther) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("提交失败：更新其他合同失败。");
                return result;
            }
            /*这里修改了朱的代码*/
            // List<InvoiceBillsShares> invoiceBillsShares = invoiceBillsSharesService.selectWithdrawalInvoShareList(invoiceBills);
            EntityWrapper<InvoiceBillsShares> invoiceBillsSharesEntityWrapper = new EntityWrapper<>();
            invoiceBillsSharesEntityWrapper.eq("act_id", 202)
                    .eq("branch_id", invoiceBills.getBranchId())
                    .eq("bill_no", invoiceBills.getBillNo());
            List<InvoiceBillsShares> invoiceBillsShares = invoiceBillsSharesService.selectList(invoiceBillsSharesEntityWrapper);
            for (InvoiceBillsShares is : invoiceBillsShares) {
                EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
                projectBillsBudgetsEntityWrapper.eq("project_sub_no", is.getProjectSubNo())
                        .eq("budget_id", is.getBudgetId())
                        .eq("branch_id", invoiceBills.getBranchId());
                ProjectBillsBudgets billsBudgets = projectBillsBudgetsService.selectOne(projectBillsBudgetsEntityWrapper);
                billsBudgets.setBudgetUseAmt(interceptDoubleTwo(billsBudgets.getBudgetUseAmt() - is.getShareAmt()));
                billsBudgets.setSubInvAmtCr(interceptDoubleTwo(billsBudgets.getSubInvAmtCr() - is.getShareAmt()));
                boolean updateByBudget = projectBillsBudgetsService.updateById(billsBudgets);
                if (!updateByBudget) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：更新项目预算失败。");
                    return result;
                }
                EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
                projectBillsSubsEntityWrapper.eq("project_sub_no", is.getProjectSubNo())
                        .eq("branch_id", invoiceBills.getBranchId());
                ProjectBillsSubs billsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
                billsSubs.setSubInvAmtCr(interceptDoubleTwo(billsSubs.getSubInvAmtCr() - is.getShareAmt()));
                boolean updateByProSub = projectBillsSubsService.updateById(billsSubs);
                if (!updateByProSub) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：更新累计成本失败。");
                    return result;
                }

                EntityWrapper<InvoiceBillsIndirect> invoiceBillsIndirectEntityWrapper = new EntityWrapper<>();
                invoiceBillsIndirectEntityWrapper.eq("project_sub_no", is.getProjectSubNo())
                        .eq("budget_id", is.getBudgetId())
                        .eq("purchase_id", invoiceBills.getPurchaseId());
                InvoiceBillsIndirect invoiceBillsIndirect = invoiceBillsIndirectService.selectOne(invoiceBillsIndirectEntityWrapper);
                invoiceBillsIndirect.setSubInvAmtCr(interceptDoubleTwo(invoiceBillsIndirect.getSubInvAmtCr() - is.getShareAmt()));
                boolean updateByInvIndirect = invoiceBillsIndirectService.updateById(invoiceBillsIndirect);
                if (!updateByInvIndirect) {
                    return result;
                }
            }
            // 记录撤销人信息
            invoiceBills.setBillStatus(2);
            invoiceBills.setModifyTime(new Date());
            invoiceBills.setModifyUserId(sysUserDto.getUserId());
            invoiceBillsService.updateById(invoiceBills);
        } catch (NoTransactionException e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            e.printStackTrace();
        }
        return result;
    }


    /**
     * Double数值  保存两位
     *
     * @param inDouble
     * @return
     */
    private Double interceptDoubleTwo(Double inDouble) {
        Double resDouble = Double.parseDouble(String.format("%.2f", inDouble));
        return resDouble;
    }


}

