
package io.platform.moneyManagement.service.client.impl;

import com.alibaba.dubbo.config.annotation.Service;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;


import io.platform.moneyManagement.biz.entity.InvoiceBillsShares;
import io.platform.moneyManagement.biz.service.InvoiceBillsSharesService;
import io.platform.moneyManagement.dto.InvoiceBillsSharesDto;
import io.platform.moneyManagement.service.client.api.InvoiceBillsServiceClient;
import io.platform.moneyManagement.service.client.api.InvoiceBillsSharesServiceClient;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

import io.platform.base.common.BaseServiceClient;
import io.platform.base.common.utils.ExecuteResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Created by sevelli on 2017/8/31.
 */
@Component
@Service(version = "1.0.0", interfaceClass = InvoiceBillsSharesServiceClient.class)
public class InvoiceBillsSharesServiceClientImpl extends BaseServiceClient<InvoiceBillsShares, InvoiceBillsSharesDto> implements InvoiceBillsSharesServiceClient {
    private Logger logger = LoggerFactory.getLogger(getClass());
    @Resource
    private InvoiceBillsSharesService invoiceBillsSharesService;

    @Override
    public InvoiceBillsSharesDto queryObject(Long id) {
        InvoiceBillsShares invoiceBillsShares = invoiceBillsSharesService.selectById(id);
        InvoiceBillsSharesDto invoiceBillsSharesDto = new InvoiceBillsSharesDto();
        BeanUtils.copyProperties(invoiceBillsShares, invoiceBillsSharesDto);
        return invoiceBillsSharesDto;
    }

    @Override
    public List<InvoiceBillsSharesDto> queryList(Map<String, Object> map) {
        List<InvoiceBillsShares> invoiceBillsSharesList = invoiceBillsSharesService.selectByMap(map);
        return convertList(invoiceBillsSharesList, InvoiceBillsSharesDto.class);
    }

    @Override
    public int queryTotal(Map<String, Object> map) {
        EntityWrapper<InvoiceBillsShares> ew = new EntityWrapper<>();
        ew.allEq(map);
        return invoiceBillsSharesService.selectCount(ew);
    }

    @Override
    public ExecuteResult<String> save(InvoiceBillsSharesDto invoiceBillsSharesDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            InvoiceBillsShares invoiceBillsShares = new InvoiceBillsShares();
            revert(invoiceBillsSharesDto, invoiceBillsShares);
            boolean flag = invoiceBillsSharesService.insert(invoiceBillsShares);
            if (!flag) {
                result.addErrorMessage("保存失败。");
            }
        } catch (Exception e) {
            logger.error(" 保存错误：" + e.toString(), e);
            result.addErrorMessage("保存错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> update(InvoiceBillsSharesDto invoiceBillsSharesDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            InvoiceBillsShares invoiceBillsShares = new InvoiceBillsShares();
            revert(invoiceBillsSharesDto, invoiceBillsShares);

            boolean flag = invoiceBillsSharesService.updateById(invoiceBillsShares);
            if (!flag) {
                result.addErrorMessage("更新失败。");
            }
        } catch (Exception e) {
            logger.error(" 更新错误：" + e.toString(), e);
            result.addErrorMessage("更新错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> delete(Long id) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = invoiceBillsSharesService.deleteById(id);
            if (!flag) {
                result.addErrorMessage("删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = invoiceBillsSharesService.deleteBatchIds(ids);
            if (!flag) {
                result.addErrorMessage("批量删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public Page<InvoiceBillsSharesDto> getPage(Page<InvoiceBillsSharesDto> pageDto, InvoiceBillsSharesDto invoiceBillsSharesDto) {
        Page<InvoiceBillsShares> page = new Page<>(pageDto.getCurrent(), pageDto.getSize());
        page.setAsc(pageDto.isAsc());
        page.setOrderByField(pageDto.getOrderByField());
        page.setCondition(pageDto.getCondition());
        InvoiceBillsShares invoiceBillsShares = new InvoiceBillsShares();
        revert(invoiceBillsSharesDto, invoiceBillsShares);
        EntityWrapper<InvoiceBillsShares> wrapper = new EntityWrapper<>();
        wrapper.setEntity(invoiceBillsShares);
        page = invoiceBillsSharesService.selectPage(page, wrapper);
        List<InvoiceBillsSharesDto> invoiceBillsSharesDtoList = convertList(page.getRecords(), InvoiceBillsSharesDto.class);
        pageDto.setTotal(invoiceBillsSharesService.selectCount(wrapper));
        pageDto.setRecords(invoiceBillsSharesDtoList);
        return pageDto;
    }
}
