
package io.platform.moneyManagement.service.client.impl;

import com.alibaba.dubbo.config.annotation.Service;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;


import io.platform.moneyManagement.biz.entity.InvoicePurchase;
import io.platform.moneyManagement.biz.service.InvoicePurchaseService;
import io.platform.moneyManagement.dto.InvoicePurchaseDto;
import io.platform.moneyManagement.service.client.api.InvoicePurchaseServiceClient;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;
import io.platform.base.common.BaseServiceClient;
import io.platform.base.common.utils.ExecuteResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
 * Created by sevelli on 2017/8/31.
 */
@Component
@Service()
public class InvoicePurchaseServiceClientImpl extends BaseServiceClient<InvoicePurchase, InvoicePurchaseDto> implements InvoicePurchaseServiceClient {
    private Logger logger = LoggerFactory.getLogger(getClass());
    @Resource
    private InvoicePurchaseService invoicePurchaseService;

    @Override
    public InvoicePurchaseDto queryObject(Long id) {
        InvoicePurchase invoicePurchase = invoicePurchaseService.selectById(id);
        InvoicePurchaseDto invoicePurchaseDto = new InvoicePurchaseDto();
        BeanUtils.copyProperties(invoicePurchase,invoicePurchaseDto);
        return invoicePurchaseDto;
    }

    @Override
    public List<InvoicePurchaseDto> queryList(Map<String, Object> map) {
        List<InvoicePurchase> invoicePurchaseList = invoicePurchaseService.selectByMap(map);
        return convertList(invoicePurchaseList,InvoicePurchaseDto.class);
    }

    @Override
    public int queryTotal(Map<String, Object> map) {
        EntityWrapper<InvoicePurchase> ew = new EntityWrapper<>();
        ew.allEq(map);
        return invoicePurchaseService.selectCount(ew);
    }

    @Override
    public ExecuteResult<String> save(InvoicePurchaseDto invoicePurchaseDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try{
            InvoicePurchase invoicePurchase = new InvoicePurchase();
            revert(invoicePurchaseDto,invoicePurchase);
            boolean flag = invoicePurchaseService.insert(invoicePurchase);
            if(!flag){
                result.addErrorMessage("保存失败。");
            }
        }
        catch (Exception e) {
            logger.error(" 保存错误：" + e.toString(), e);
            result.addErrorMessage("保存错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> update(InvoicePurchaseDto invoicePurchaseDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try{
            InvoicePurchase invoicePurchase = new InvoicePurchase();
            revert(invoicePurchaseDto,invoicePurchase);

            boolean flag = invoicePurchaseService.updateById(invoicePurchase);
            if(!flag){
                result.addErrorMessage("更新失败。");
            }
        }
        catch (Exception e) {
            logger.error(" 更新错误：" + e.toString(), e);
            result.addErrorMessage("更新错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> delete(Long id) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try{
            boolean flag = invoicePurchaseService.deleteById(id);
            if(!flag){
                result.addErrorMessage("删除失败。");
            }
        }
        catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try{
            boolean flag = invoicePurchaseService.deleteBatchIds(ids);
            if(!flag){
                result.addErrorMessage("批量删除失败。");
            }
        }
        catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public Page<InvoicePurchaseDto> getPage(Page<InvoicePurchaseDto> pageDto,InvoicePurchaseDto invoicePurchaseDto) {
        Page<InvoicePurchase> page = new Page<>(pageDto.getCurrent(),pageDto.getSize());
        page.setAsc(pageDto.isAsc());
        page.setOrderByField(pageDto.getOrderByField());
        page.setCondition(pageDto.getCondition());
        InvoicePurchase invoicePurchase = new InvoicePurchase();
        revert(invoicePurchaseDto,invoicePurchase);
        EntityWrapper<InvoicePurchase> wrapper = new EntityWrapper<>();
        wrapper.setEntity(invoicePurchase);
        page = invoicePurchaseService.selectPage(page,wrapper);
        List<InvoicePurchaseDto> invoicePurchaseDtoList = convertList(page.getRecords(),InvoicePurchaseDto.class);
        pageDto.setTotal(invoicePurchaseService.selectCount(wrapper));
        pageDto.setRecords(invoicePurchaseDtoList);
        return pageDto;
    }
}
