
package io.platform.moneyManagement.service.client.impl;

import com.alibaba.dubbo.config.annotation.Service;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;


import io.platform.approvalConfiguration.biz.entity.Audit;
import io.platform.approvalConfiguration.biz.service.AuditItemsService;
import io.platform.budget.biz.entity.ProjectBillsBudgets;
import io.platform.budget.biz.service.ProjectBillsBudgetsService;
import io.platform.contract.biz.entity.OtherProject;
import io.platform.contract.biz.service.OtherProjectService;
import io.platform.engineering.biz.entity.*;
import io.platform.engineering.biz.service.BbranchsService;
import io.platform.engineering.biz.service.BbudgetsService;
import io.platform.engineering.biz.service.BdeptsService;
import io.platform.engineering.biz.service.BpurchasesService;
import io.platform.moneyManagement.biz.entity.InvoiceBills;
import io.platform.moneyManagement.biz.entity.InvoiceBillsIndirect;
import io.platform.moneyManagement.biz.entity.PayCrBills;
import io.platform.moneyManagement.biz.entity.PayCrBillsShares;
import io.platform.moneyManagement.biz.service.InvoiceBillsIndirectService;
import io.platform.moneyManagement.biz.service.InvoiceBillsService;
import io.platform.moneyManagement.biz.service.PayCrBillsService;
import io.platform.moneyManagement.biz.service.PayCrBillsSharesService;
import io.platform.moneyManagement.dto.PayCrBillsDto;
import io.platform.moneyManagement.service.client.api.PayCrBillsServiceClient;
import io.platform.project.biz.entity.ProjectBillsSubs;
import io.platform.project.biz.entity.Projectbills;
import io.platform.project.biz.entity.SubContractBills;
import io.platform.project.biz.service.ProjectBillsSubsService;
import io.platform.project.biz.service.ProjectbillsService;
import io.platform.project.biz.service.SubContractBillsService;
import io.platform.project.dto.ProjectBillsSubsDto;
import io.platform.sys.biz.entity.SysRole;
import io.platform.sys.dto.SysUserDto;
import io.platform.utils.DataUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.text.SimpleDateFormat;
import java.time.Instant;
import java.time.LocalDateTime;
import java.time.LocalTime;
import java.time.ZoneId;
import java.util.*;

import io.platform.base.common.BaseServiceClient;
import io.platform.base.common.utils.ExecuteResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;

/**
 * Created by sevelli on 2017/8/31.
 */
@Component
@Service(version = "1.0.0", interfaceClass = PayCrBillsServiceClient.class)
public class PayCrBillsServiceClientImpl extends BaseServiceClient<PayCrBills, PayCrBillsDto> implements PayCrBillsServiceClient {
    private Logger logger = LoggerFactory.getLogger(getClass());
    @Resource
    private BdeptsService bdeptsService;
    @Resource
    private BbranchsService bbranchsService;
    @Resource
    private BbudgetsService bbudgetsService;
    @Resource
    private PayCrBillsService payCrBillsService;
    @Resource
    private AuditItemsService auditItemsService;
    @Resource
    private BpurchasesService bpurchasesService;
    @Resource
    private ProjectbillsService projectbillsService;
    @Resource
    private OtherProjectService otherProjectService;
    @Resource
    private InvoiceBillsService invoiceBillsService;
    @Resource
    private SubContractBillsService subContractBillsService;
    @Resource
    private ProjectBillsSubsService projectBillsSubsService;
    @Resource
    private PayCrBillsSharesService payCrBillsSharesService;
    @Resource
    private ProjectBillsBudgetsService projectBillsBudgetsService;
    @Resource
    private InvoiceBillsIndirectService invoiceBillsIndirectService;


    @Override
    public PayCrBillsDto queryObject(Long id) {
        PayCrBills payCrBills = payCrBillsService.selectById(id);
        PayCrBillsDto payCrBillsDto = new PayCrBillsDto();
        BeanUtils.copyProperties(payCrBills, payCrBillsDto);
        return payCrBillsDto;
    }

    @Override
    public List<PayCrBillsDto> queryList(Map<String, Object> map) {
        List<PayCrBills> payCrBillsList = payCrBillsService.selectByMap(map);
        return convertList(payCrBillsList, PayCrBillsDto.class);
    }

    @Override
    public int queryTotal(Map<String, Object> map) {
        EntityWrapper<PayCrBills> ew = new EntityWrapper<>();
        ew.allEq(map);
        return payCrBillsService.selectCount(ew);
    }

    @Override
    public ExecuteResult<String> save(PayCrBillsDto payCrBillsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            PayCrBills payCrBills = new PayCrBills();
            revert(payCrBillsDto, payCrBills);
            boolean flag = payCrBillsService.insert(payCrBills);
            if (!flag) {
                result.addErrorMessage("保存失败。");
            }
        } catch (Exception e) {
            logger.error(" 保存错误：" + e.toString(), e);
            result.addErrorMessage("保存错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> update(PayCrBillsDto payCrBillsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            PayCrBills payCrBills = new PayCrBills();
            revert(payCrBillsDto, payCrBills);

            boolean flag = payCrBillsService.updateById(payCrBills);
            if (!flag) {
                result.addErrorMessage("更新失败。");
            }
        } catch (Exception e) {
            logger.error(" 更新错误：" + e.toString(), e);
            result.addErrorMessage("更新错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> delete(Long id) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = payCrBillsService.deleteById(id);
            if (!flag) {
                result.addErrorMessage("删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> deleteDirectPayment(PayCrBillsDto payCrBillsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            if (payCrBillsDto != null && payCrBillsDto.getId() != null) {
                boolean flag = payCrBillsService.deleteById(payCrBillsDto.getId());
                if (!flag) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("删除付款记录直接成本失败");
                    return result;
                }
            } else {
                result.addErrorMessage("删除失败：请确认信息 重新提交");
                return result;
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除失败：请确认信息 重新提交");
        }
        return result;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> deletePayCrBill(PayCrBillsDto payCrBillsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            if (payCrBillsDto != null && payCrBillsDto.getId() != null) {
                PayCrBills payCrBills = payCrBillsService.selectById(payCrBillsDto.getId());
                EntityWrapper<PayCrBillsShares> payCrBillsSharesEntityWrapper = new EntityWrapper<>();
                payCrBillsSharesEntityWrapper.eq("bill_no", payCrBills.getBillNo())
                        .eq("act_id", 204);
                boolean deleteById = payCrBillsSharesService.delete(payCrBillsSharesEntityWrapper);
                if (!deleteById) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("删除付款记录间接成本失败");
                    return result;
                }
                boolean flag = payCrBillsService.deleteById(payCrBills);
                if (!flag) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("删除付款记录间接成本失败");
                    return result;
                }
            } else {
                result.addErrorMessage("删除失败：未找到信息");
                return result;
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除失败：请确认信息 重新提交");
            return result;
        }
        return result;
    }

    @Override
    public Map<String, Object> getPage(Map<String, Object> map, SysUserDto sysUserDto) {
        Map<String, Object> objectMap = new HashMap<>();
        SysRole sysRole = subContractBillsService.selectRole(sysUserDto);
        map.put("user", sysUserDto);
        map.put("role", sysRole);
        try {
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            if (map.get("startDate") != null && map.get("startDate") != "") {
                long startimes = (long) map.get("startDate");
                String startTime = sdf.format(new Date(startimes));
                map.put("startDateTime", startTime);
            }
            if (map.get("endDate") != null && map.get("endDate") != "") {
                long endtimes = (long) map.get("endDate");
                LocalDateTime localDateTime = LocalDateTime.ofInstant(Instant.ofEpochMilli(endtimes), ZoneId.systemDefault());
                LocalDateTime endOfDay = localDateTime.with(LocalTime.MAX);
                Date from = Date.from(endOfDay.atZone(ZoneId.systemDefault()).toInstant());
                String endTime = sdf.format(from);
                map.put("endDateTime", endTime);
            }
            int num = payCrBillsService.selectPayCrTotal(map);
            if (num != 0) {
                int current = (int) map.get("current");
                int size = (int) map.get("size");
                if (current <= 1) {
                    current = 0;
                } else {
                    current = (current - 1) * size;
                }
                map.put("size", size);
                map.put("current", current);
                List<Map<String, Object>> mapList = payCrBillsService.selectPayCrRecords(map);
                Page page = new Page();
                page.setRecords(mapList);
                page.setTotal(num);
                objectMap.put("page", page);
                return objectMap;
            }
        } catch (Exception e) {
            logger.error("操作异常：" + e.toString(), e);
        }
        return null;
    }

    @Override
    public Map<String, Object> payCrIndirectPage(Map<String, Object> map, SysUserDto sysUserDto) {
        Map<String, Object> objectMap = new HashMap<>();
        SysRole sysRole = subContractBillsService.selectRole(sysUserDto);
        map.put("user", sysUserDto);
        map.put("role", sysRole);
        int num = payCrBillsService.selectPayIndirectCrTotal(map);
        if (num != 0) {
            int current = (int) map.get("current");
            int size = (int) map.get("size");
            if (current <= 1) {
                current = 0;
            } else {
                current = (current - 1) * size;
            }
            map.put("size", size);
            map.put("current", current);
            List<Map<String, Object>> mapList = payCrBillsService.selectPayCrIndirectRecords(map);
            Page page = new Page();
            page.setRecords(mapList);
            page.setTotal(num);
            objectMap.put("page", page);
            return objectMap;
        }
        return null;
    }

    @Override
    public Map<String, Object> selectPayCrIndirectPrint(PayCrBillsDto payCrBillsDto, SysUserDto sysUserDto) {
        if (payCrBillsDto != null && payCrBillsDto.getId() != null) {
            Map<String, Object> map = new HashMap<>();
            map = invoiceBillsService.selectPayCrIndirectPrint(payCrBillsDto);
            if (map.get("isPrinted").equals("F")) {
                map.put("printTime", new Date());
            }
            List<ProjectBillsSubs> projectBillsSubsList = invoiceBillsService.selectPayCrIndirectPrintProSub(payCrBillsDto);
            String contractName = "";
            if (projectBillsSubsList.size() != 0) {
                for (ProjectBillsSubs pb : projectBillsSubsList) {
                    contractName = contractName + "/" + pb.getProjectSubName();
                }
            }
            EntityWrapper<Bbranchs> bbranchsEntityWrapper = new EntityWrapper<>();
            bbranchsEntityWrapper.setSqlSelect("id", "c_name").eq("id", sysUserDto.getLoginContractorId());
            Bbranchs bbranchs = bbranchsService.selectOne(bbranchsEntityWrapper);
            map.put("branName", bbranchs.getCname());
            map.put("contractName", contractName);
            map.put("deptName", bdeptsService.selectById(sysUserDto.getDeptId()));
            return map;
        }
        return null;
    }

    @Override
    public Map<String, Object> queryPayCrTemporary(PayCrBillsDto payCrBillsDto) {
        if (payCrBillsDto != null && payCrBillsDto.getId() != null) {
            Map<String, Object> map = new HashMap<>();
/*            EntityWrapper<PayCrBills> entityWrapper = new EntityWrapper<>();
            entityWrapper.eq("id", payCrBillsDto.getId());*/
            PayCrBills payCrBills = payCrBillsService.selectById(payCrBillsDto.getId());
            if (payCrBills != null) {
                Bpurchases bpurchases = bpurchasesService.selectById(payCrBills.getPurcaserId());
                map.put("purchase", bpurchases);
                map.put("payCr", payCrBills);
                List<Map<String, Object>> mapList = payCrBillsService.selectTemporaryProject(payCrBills);
                if (mapList.size() != 0) {
                    map.put("mapLists", mapList);
                }
                /*EntityWrapper<PayCrBillsShares> payCrBillsSharesEntityWrapper = new EntityWrapper<>();
                payCrBillsSharesEntityWrapper.eq("bill_no", payCrBills.getBillNo());
                List<PayCrBillsShares> payCrBillsShares = payCrBillsSharesService.selectList(payCrBillsSharesEntityWrapper);
                if (payCrBillsShares.size() != 0) {
                    List<ProjectBillsSubs> payCrBillsSharesList = new ArrayList<>();
                    for (PayCrBillsShares pb : payCrBillsShares) {
                        if (pb.getProjectSubNo() != null && !pb.getProjectSubNo().equals("")) {
                            EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
                            projectBillsSubsEntityWrapper.setSqlSelect("id", "project_sub_name", "nc_project_no",
                                    "project_sub_no", "sub_inv_amt_dr", "sub_inv_amt_cr", "sub_amt_dr", "sub_amt_cr")
                                    .eq("project_sub_no", pb.getProjectSubNo());
                            ProjectBillsSubs billsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
                            if (billsSubs != null) {
                                payCrBillsSharesList.add(billsSubs);
                            }
                        }
                    }
                    map.put("payCrShares", payCrBillsShares);
                    map.put("proSubs", payCrBillsSharesList);
                }*/
                return map;
            }
        }
        return null;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> payCrTemporary(String projectForm, String payment, String supplier,
                                                String paymentSharing, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            PayCrBills payCrBills = JSONArray.parseObject(projectForm, PayCrBills.class);
            PayCrBills parseObject = JSONArray.parseObject(payment, PayCrBills.class);
            PayCrBills payC1 = JSONArray.parseObject(supplier, PayCrBills.class);
            JSONArray jsonArray = JSONArray.parseArray(paymentSharing);
            List<PayCrBillsShares> payCrBillsSharesList = JSONObject.parseArray(jsonArray.toJSONString(), PayCrBillsShares.class);
            EntityWrapper<PayCrBills> payCrBillsEntityWrapper = new EntityWrapper<>();
            payCrBillsEntityWrapper.setSqlSelect("id").eq("bill_no", payCrBills.getBillNo());
            PayCrBills pb = payCrBillsService.selectOne(payCrBillsEntityWrapper);
            if (pb != null) {
                pb.setPurcaserNcNo(parseObject.getPurcaserNcNo());
                pb.setBillNo(payCrBills.getBillNo());
                pb.setOpUserId(sysUserDto.getUserId().intValue());
                pb.setOpUserName(sysUserDto.getUsername());
                pb.setCreateDate(new Date());
                pb.setBillDate(new Date());
                pb.setInvBillNo(payCrBills.getInvBillNo());
                pb.setPrintCount(payCrBills.getPrintCount());
                boolean update = payCrBillsService.updateById(pb);
                if (!update) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("暂存失败：更新收款记录失败。");
                    return result;
                }
            } else {
                parseObject.setBillNo(payCrBills.getBillNo());
                parseObject.setActId(204);
                parseObject.setBillStatus(2);
                parseObject.setOpUserId(sysUserDto.getUserId().intValue());
                parseObject.setOpUserName(sysUserDto.getUsername());
                parseObject.setCreateDate(new Date());
                parseObject.setBillDate(new Date());
                parseObject.setPrintCount(payCrBills.getPrintCount());
                parseObject.setInvBillNo(payCrBills.getInvBillNo());
                boolean insert = payCrBillsService.insert(parseObject);
                if (!insert) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("暂存失败：新建收款记录失败。");
                    return result;
                }
            }
            if (payCrBillsSharesList.size() != 0) {
                EntityWrapper<PayCrBillsShares> payCrBillsSharesEntityWrapper = new EntityWrapper<>();
                payCrBillsSharesEntityWrapper.setSqlSelect("id").eq("bill_no", payCrBills.getBillNo());
                List<PayCrBillsShares> payCrBillsShares = payCrBillsSharesService.selectList(payCrBillsSharesEntityWrapper);
                if (payCrBillsShares.size() != 0) {
                    for (PayCrBillsShares pc : payCrBillsShares) {
                        boolean deleteById = payCrBillsSharesService.deleteById(pc);
                        if (!deleteById) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("暂存失败：删除分摊明细失败");
                            return result;
                        }
                    }
                }
                int line = 0;
                for (PayCrBillsShares pbc : payCrBillsSharesList) {
                    line++;
                    EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
                    projectBillsSubsEntityWrapper.setSqlSelect("id", "project_sub_no", "sub_inv_amt_cr")
                            .eq("project_sub_no", pbc.getProjectSubNo());
                    ProjectBillsSubs billsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
                    if (billsSubs != null) {
                        billsSubs.setSubInvAmtCr(billsSubs.getSubInvAmtCr() + pbc.getShareAmt());
                        boolean updateById = projectBillsSubsService.updateById(billsSubs);
                        if (!updateById) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("暂存失败：更新子项目失败");
                            return result;
                        }
                    }
                    pbc.setBillNo(payCrBills.getBillNo());
                    pbc.setLineNo(line);
                    pbc.setActId(204);
                    boolean insert = payCrBillsSharesService.insert(pbc);
                    if (!insert) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("暂存失败：新建费用分摊明细失败。");
                        return result;
                    }
                }
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 暂存失败：" + e.toString(), e);
            result.addErrorMessage("暂存失败：请确认信息 重新提交");
            return result;
        }
        return result;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> payCrSave(String projectForm, String payment, String supplier, String paymentSharing, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flagSpecial = false;
            PayCrBills payCrBills = JSONArray.parseObject(projectForm, PayCrBills.class);
            PayCrBills parseObject = JSONArray.parseObject(payment, PayCrBills.class);
            PayCrBills payC1 = JSONArray.parseObject(supplier, PayCrBills.class);
            JSONArray jsonArray = JSONArray.parseArray(paymentSharing);
            List<PayCrBillsShares> payCrBillsSharesList = JSONObject.parseArray(jsonArray.toJSONString(), PayCrBillsShares.class);
            EntityWrapper<PayCrBills> payCrBillsEntityWrapper = new EntityWrapper<>();
            payCrBillsEntityWrapper.eq("bill_no", payCrBills.getBillNo())
                    .eq("branch_id", sysUserDto.getLoginContractorId());
            PayCrBills pb = payCrBillsService.selectOne(payCrBillsEntityWrapper);
            if (pb != null) {
                if (Objects.equals(pb.getFlagSpecial(), 0)) {
                    flagSpecial = true;
                }
                pb.setBillNo(payCrBills.getBillNo());
                pb.setOpUserId(sysUserDto.getUserId().intValue());
                pb.setOpUserName(sysUserDto.getUsername());
                pb.setBranchId(sysUserDto.getLoginContractorId());
                pb.setOtherAmt(parseObject.getOtherAmt());
                pb.setWarrantyAmt(parseObject.getWarrantyAmt());
                pb.setCreateDate(new Date());
                pb.setBillDate(new Date());
                pb.setPostDate(new Date());
                if (payCrBills.getFlagSpecial() != 0) {
                    pb.setBillStatus(4);
                } else {
                    pb.setBillStatus(6);
                }
                pb.setFlagSpecial(payCrBills.getFlagSpecial());
                pb.setSpecialItem(payCrBills.getSpecialItem());
                pb.setInvBillNo(payCrBills.getInvBillNo());
                pb.setPrintCount(payCrBills.getPrintCount());
                boolean update = payCrBillsService.updateById(pb);
                if (!update) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：更新收款记录失败。");
                    return result;
                }
            } else {
                if (Objects.equals(payCrBills.getFlagSpecial(), 0)) {
                    flagSpecial = true;
                }
                parseObject.setBillNo(payCrBills.getBillNo());
                parseObject.setActId(204);
                if (payCrBills.getFlagSpecial() != 0) {
                    parseObject.setBillStatus(4);
                } else {
                    parseObject.setBillStatus(6);
                }
                parseObject.setBranchId(sysUserDto.getLoginContractorId());
                parseObject.setOpUserId(sysUserDto.getUserId().intValue());
                parseObject.setOpUserName(sysUserDto.getUsername());
                parseObject.setCreateDate(new Date());
                parseObject.setBillDate(new Date());
                parseObject.setPostDate(new Date());
                parseObject.setInvBillNo(payCrBills.getInvBillNo());
                parseObject.setFlagSpecial(payCrBills.getFlagSpecial());
                parseObject.setSpecialItem(payCrBills.getSpecialItem());
                parseObject.setPrintCount(payCrBills.getPrintCount());
                boolean insert = payCrBillsService.insert(parseObject);
                if (!insert) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：新建收款记录失败。");
                    return result;
                }
            }
            EntityWrapper<PayCrBillsShares> payCrBillsSharesEntityWrapper = new EntityWrapper<>();
            payCrBillsSharesEntityWrapper.eq("bill_no", payCrBills.getBillNo());
            boolean deleteById = payCrBillsSharesService.delete(payCrBillsSharesEntityWrapper);
            if (!deleteById) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("提交失败：删除分摊明细失败。");
                return result;
            }
            int approvalBranchId = 0;
            if (payCrBillsSharesList.size() != 0) {
                int line = 0;
                for (PayCrBillsShares pbc : payCrBillsSharesList) {
                    line++;
                    if (Objects.equals(line, 1)) {
                        EntityWrapper<ProjectBillsSubs> entityWrapper = new EntityWrapper<>();
                        entityWrapper.setSqlSelect("id", "approval_branch_id")
                                .eq("project_sub_no", pbc.getProjectSubNo())
                                .eq("branch_id", sysUserDto.getLoginContractorId());
                        ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(entityWrapper);
                        approvalBranchId = projectBillsSubs.getApprovalBranchId();
                    }
                    EntityWrapper<ProjectBillsBudgets> budgetsEntityWrapper = new EntityWrapper<>();
                    budgetsEntityWrapper.eq("project_sub_no", pbc.getProjectSubNo())
                            .eq("budget_id", pbc.getBudgetId())
                            .eq("branch_id", sysUserDto.getLoginContractorId());
                    ProjectBillsBudgets billsBudgets = projectBillsBudgetsService.selectOne(budgetsEntityWrapper);
                    double subAmtCr = billsBudgets.getSubAmtCr() + pbc.getShareAmt();
                    if (subAmtCr > billsBudgets.getSubInvAmtCr() && flagSpecial) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("该预算已付款金额超出已开票金额");
                        return result;
                    }
                    pbc.setBillNo(payCrBills.getBillNo());
                    pbc.setLineNo(line);
                    pbc.setActId(204);
                    boolean insert = payCrBillsSharesService.insert(pbc);
                    if (!insert) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：新建费用分摊明细失败。");
                        return result;
                    }
                }
            }
            if (payCrBills.getFlagSpecial() != 0) {
                Audit audit = new Audit();
                audit.setActId(570);
                audit.setLevelId(0);
                audit.setIffinalItem("F");
                if (pb != null) {
                    audit.setBillNo(pb.getBillNo());
//                    audit.setBranchId(pb.getBranchId());
                } else {
                    audit.setBillNo(parseObject.getBillNo());
//                    audit.setBranchId(parseObject.getBranchId());
                }
                audit.setBranchId(approvalBranchId);
                audit.setSendUserId(sysUserDto.getUserId().intValue());
                audit.setSendName(sysUserDto.getActualname());
                audit.setSendTime(new Date());
                audit.setAuditUserId(sysUserDto.getUserId().intValue());
                audit.setAuditItem(new Date());
                audit.setAuditMsg("提交");
                audit.setAuditStatus("O");
                boolean approvalFlow = auditItemsService.createApprovalFlow(audit);
                if (!approvalFlow) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("审批流异常请检查提交信息");
                    return result;
                }
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 提交失败：" + e.toString(), e);
            result.addErrorMessage("提交失败");
        }
        return result;
    }

    /*审批版本*/
   /* public ExecuteResult<String> payCrSave(String projectForm, String payment, String supplier, String paymentSharing, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            PayCrBills payCrBills = JSONArray.parseObject(projectForm, PayCrBills.class);
            PayCrBills parseObject = JSONArray.parseObject(payment, PayCrBills.class);
            PayCrBills payC1 = JSONArray.parseObject(supplier, PayCrBills.class);
            JSONArray jsonArray = JSONArray.parseArray(paymentSharing);
            List<PayCrBillsShares> payCrBillsSharesList = JSONObject.parseArray(jsonArray.toJSONString(), PayCrBillsShares.class);
            EntityWrapper<PayCrBills> payCrBillsEntityWrapper = new EntityWrapper<>();
            payCrBillsEntityWrapper.eq("bill_no", payCrBills.getBillNo())
                    .eq("branch_id", sysUserDto.getLoginContractorId());
            PayCrBills pb = payCrBillsService.selectOne(payCrBillsEntityWrapper);
            if (pb != null) {
                pb.setBillNo(payCrBills.getBillNo());
                pb.setOpUserId(sysUserDto.getUserId().intValue());
                pb.setOpUserName(sysUserDto.getUsername());
                pb.setBranchId(sysUserDto.getLoginContractorId());
                pb.setCreateDate(new Date());
                pb.setBillDate(new Date());
                pb.setPostDate(new Date());
                if (payCrBills.getFlagSpecial() != 0) {
                    pb.setBillStatus(4);
                } else {
                    pb.setBillStatus(6);
                }
                pb.setFlagSpecial(payCrBills.getFlagSpecial());
                pb.setSpecialItem(payCrBills.getSpecialItem());
                pb.setInvBillNo(payCrBills.getInvBillNo());
                pb.setPrintCount(payCrBills.getPrintCount());
                boolean update = payCrBillsService.updateById(pb);
                if (!update) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：更新收款记录失败。");
                    return result;
                }
            } else {
                parseObject.setBillNo(payCrBills.getBillNo());
                parseObject.setActId(204);
                if (payCrBills.getFlagSpecial() != 0) {
                    parseObject.setBillStatus(4);
                } else {
                    parseObject.setBillStatus(6);
                }
                parseObject.setBranchId(sysUserDto.getLoginContractorId());
                parseObject.setOpUserId(sysUserDto.getUserId().intValue());
                parseObject.setOpUserName(sysUserDto.getUsername());
                parseObject.setCreateDate(new Date());
                parseObject.setBillDate(new Date());
                parseObject.setPostDate(new Date());
                parseObject.setInvBillNo(payCrBills.getInvBillNo());
                parseObject.setFlagSpecial(payCrBills.getFlagSpecial());
                parseObject.setSpecialItem(payCrBills.getSpecialItem());
                parseObject.setPrintCount(payCrBills.getPrintCount());
                boolean insert = payCrBillsService.insert(parseObject);
                if (!insert) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：新建收款记录失败。");
                    return result;
                }
            }
            if (payCrBillsSharesList.size() != 0) {
                EntityWrapper<PayCrBillsShares> payCrBillsSharesEntityWrapper = new EntityWrapper<>();
                payCrBillsSharesEntityWrapper.eq("bill_no", payCrBills.getBillNo());
                if (pb != null) {
                    payCrBillsSharesEntityWrapper.eq("budget_id", pb.getBudgetId());
                } else {
                    payCrBillsSharesEntityWrapper.eq("budget_id", parseObject.getBudgetId());
                }
                boolean deleteById = payCrBillsSharesService.delete(payCrBillsSharesEntityWrapper);
                if (!deleteById) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：删除分摊明细失败。");
                    return result;
                }
                int line = 0;
                for (PayCrBillsShares pbc : payCrBillsSharesList) {
                    line++;
                    pbc.setBillNo(payCrBills.getBillNo());
                    pbc.setLineNo(line);
                    pbc.setActId(204);
                    boolean insert = payCrBillsSharesService.insert(pbc);
                    if (!insert) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：新建费用分摊明细失败。");
                        return result;
                    }
                }
            }
            if (payCrBills.getFlagSpecial() != 0) {
                Audit audit = new Audit();
                audit.setActId(570);
                audit.setLevelId(0);
                audit.setIffinalItem("F");
                if (pb != null) {
                    audit.setBillNo(pb.getBillNo());
                    audit.setBranchId(pb.getBranchId());
                } else {
                    audit.setBillNo(parseObject.getBillNo());
                    audit.setBranchId(parseObject.getBranchId());
                }
                audit.setSendUserId(sysUserDto.getUserId().intValue());
                audit.setSendName(sysUserDto.getUsername());
                audit.setSendTime(new Date());
                audit.setAuditUserId(sysUserDto.getUserId().intValue());
                audit.setAuditItem(new Date());
                audit.setAuditMsg("提交");
                audit.setAuditStatus("O");
//                audit.setSubJect(projectbillsDto.getProjectSubName());
//                audit.setProjectNo(projectBS.getProjectSubNo());
//                audit.setProjectMngId(projectbillsDto.getProjectSubMngId());
//                EntityWrapper<Projectbills> projectbillsEntityWrapper = new EntityWrapper<>();
//                projectbillsEntityWrapper.setSqlSelect("id", "project_leader").eq("bill_no", projectbillsDto.getBillNo())
//                        .eq("act_id", projectbillsDto.getActId());
//                Projectbills projectbills = projectbillsService.selectOne(projectbillsEntityWrapper);
//                if (projectbills != null) {
//                    audit.setProjectLeader(projectbills.getProjectLeader());
//                }
                boolean approvalFlow = auditItemsService.createApprovalFlow(audit);
                if (!approvalFlow) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("审批流异常请检查提交信息");
                    return result;
                }
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 提交失败：" + e.toString(), e);
            result.addErrorMessage("提交失败");
        }
        return result;
    }*/

    @Override
    public Map<String, Object> payCrSelect(ProjectBillsSubsDto projectBillsSubsDto) {
        try {
            if (projectBillsSubsDto != null) {
                Map<String, Object> map = new HashMap<>();
                EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
                projectBillsBudgetsEntityWrapper.setSqlSelect("id", "budget_id")
                        .eq("project_sub_no", projectBillsSubsDto.getProjectSubNo())
                        .eq("branch_id", projectBillsSubsDto.getBranchId());
                List<ProjectBillsBudgets> projectBillsBudgetsList = projectBillsBudgetsService.selectList(projectBillsBudgetsEntityWrapper);
                List<Bbudgets> bbudgetsList = new ArrayList<>();
                if (projectBillsBudgetsList.size() != 0) {
                    for (ProjectBillsBudgets pb : projectBillsBudgetsList) {
                        EntityWrapper<Bbudgets> bbudgetsEntityWrapper = new EntityWrapper<>();
                        bbudgetsEntityWrapper.setSqlSelect("id", "budget_name").eq("id", pb.getBudgetId());
                        Bbudgets bbudgets = bbudgetsService.selectOne(bbudgetsEntityWrapper);
                        if (bbudgets != null) {
                            bbudgetsList.add(bbudgets);
                        }
                    }
                    if (bbudgetsList.size() != 0) {
                        map.put("budgets", bbudgetsList);
                    }
                }
                return map;
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 操作异常：" + e.toString(), e);
        }
        return null;
    }

    @Override
    public Map<String, Object> fuzzyQueryInvoice(Page page, PayCrBillsDto payCrBillsDto) {
        Map<String, Object> map = new HashMap<>();
        Page pageDto = DataUtils.processingPage(page);
        EntityWrapper<PayCrBills> entityWrapper = new EntityWrapper<>();
        if (payCrBillsDto.getActId() != null && payCrBillsDto.getActId() != 0) {
            entityWrapper.eq("act_id", payCrBillsDto.getActId());
        }
        if (payCrBillsDto.getBillStatus() != null && payCrBillsDto.getBillStatus() != 0) {
            entityWrapper.eq("bill_status", payCrBillsDto.getBillStatus());
        }
        if (payCrBillsDto.getBillNo() != null && !payCrBillsDto.getBillNo().equals("")) {
            entityWrapper.like("bill_no", "%" + payCrBillsDto.getBillNo() + "%");
        }
        if (payCrBillsDto.getInvBillNo() != null && !payCrBillsDto.getInvBillNo().equals("")) {
            entityWrapper.like("inv_bill_no", "%" + payCrBillsDto.getInvBillNo() + "%");
        }
        if (payCrBillsDto.getProjectSubNo() != null && !payCrBillsDto.getProjectSubNo().equals("")) {
            entityWrapper.like("project_sub_no", "%" + payCrBillsDto.getProjectSubNo() + "%");
        }
        int sum = payCrBillsService.selectCount(entityWrapper);
        if (sum != 0) {
            entityWrapper.last("LIMIT " + pageDto.getCurrent() + "," + pageDto.getSize());
            List<PayCrBills> payCrBills = payCrBillsService.selectList(entityWrapper);
            pageDto.setTotal(sum);
            pageDto.setRecords(payCrBills);
            map.put("page", pageDto);
            return map;
        }
        return null;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> directPaymentTemporary(String projectForm) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            PayCrBills payForm = JSONArray.parseObject(projectForm, PayCrBills.class);
            boolean payCrBillsType = payCrBillsService.insertOrUpdate(payForm);
            if (!payCrBillsType) {
                result.addErrorMessage("暂存失败");
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 暂存失败：" + e.toString(), e);
            result.addErrorMessage("暂存失败");
        }
        return result;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> directPaymentSave(String projectForm, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            PayCrBills payForm = JSONArray.parseObject(projectForm, PayCrBills.class);
            payForm.setConfirmStatus("F");
            payForm.setBranchId(sysUserDto.getLoginContractorId());
            EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
            projectBillsBudgetsEntityWrapper.eq("project_sub_no", payForm.getProjectSubNo())
                    .eq("budget_id", payForm.getBudgetId())
                    .eq("branch_id", sysUserDto.getLoginContractorId());
            ProjectBillsBudgets projectBillsBudgets = projectBillsBudgetsService.selectOne(projectBillsBudgetsEntityWrapper);
            projectBillsBudgets.setSubAmtCr((projectBillsBudgets.getSubAmtCr() + payForm.getStlAmt()) - 0.1);
            if (projectBillsBudgets.getSubAmtCr() > projectBillsBudgets.getSubInvAmtCr() && payForm.getFlagSpecial() == 0) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("该预算已付款金额超出已开票金额");
                return result;
            }
            if (payForm.getFlagSpecial() != 0) {
                payForm.setBillStatus(4);
                EntityWrapper<ProjectBillsSubs> entityWrapper = new EntityWrapper<>();
                entityWrapper.eq("project_sub_no", payForm.getProjectSubNo())
                        .eq("branch_id", payForm.getBranchId());
                ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(entityWrapper);
                Audit audit = new Audit();
                audit.setActId(560);
                audit.setLevelId(0);
                audit.setIffinalItem("F");
                audit.setBillNo(payForm.getBillNo());
                audit.setBranchId(projectBillsSubs.getApprovalBranchId());
                audit.setSendUserId(sysUserDto.getUserId().intValue());
                audit.setSendName(sysUserDto.getActualname());
                audit.setSendTime(new Date());
                audit.setAuditUserId(sysUserDto.getUserId().intValue());
                audit.setAuditItem(new Date());
                audit.setAuditMsg("提交");
                audit.setAuditStatus("O");
                audit.setSubJect(projectBillsSubs.getProjectSubName());
                audit.setProjectNo(payForm.getProjectSubNo());
                audit.setProjectMngId(projectBillsSubs.getProjectSubMngId());
                EntityWrapper<Projectbills> projectbillsEntityWrapper = new EntityWrapper<>();
                projectbillsEntityWrapper.setSqlSelect("id", "project_leader").eq("bill_no", projectBillsSubs.getBillNo())
                        .eq("act_id", projectBillsSubs.getActId());
                Projectbills projectbills = projectbillsService.selectOne(projectbillsEntityWrapper);
                if (projectbills != null) {
                    audit.setProjectLeader(projectbills.getProjectLeader());
                }
                boolean approvalFlow = auditItemsService.createApprovalFlow(audit);
                if (!approvalFlow) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("审批流异常请检查提交信息");
                    return result;
                }
            }
            boolean payCrBillsType = payCrBillsService.insertOrUpdate(payForm);
            if (!payCrBillsType) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("提交失败");
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 提交失败：" + e.toString(), e);
            result.addErrorMessage("提交失败");
        }
        return result;
    }

    @Override
    public Map<String, Object> queryBudgets(PayCrBillsDto payCrBillsDto) {
        if (payCrBillsDto != null && payCrBillsDto.getId() != null) {
            Map<String, Object> map = new HashMap<>();
            EntityWrapper<PayCrBills> entityWrapper = new EntityWrapper<>();
            entityWrapper.eq("id", payCrBillsDto.getId());
            PayCrBills payCrBills = payCrBillsService.selectOne(entityWrapper);
            if (payCrBills != null) {
                map.put("payCr", payCrBills);
                EntityWrapper<InvoiceBills> invoiceBillsEntityWrapper = new EntityWrapper<>();
                invoiceBillsEntityWrapper.eq("purchase_nc_no", payCrBills.getProjectSubNo())
                        .eq("budget_id", payCrBills.getBudgetId()).eq("purchase_nc_no", payCrBills.getPurcaserNcNo());
                InvoiceBills invoiceBills = invoiceBillsService.selectOne(invoiceBillsEntityWrapper);
                if (invoiceBills != null) {
                    map.put("invoice", invoiceBills);
                }
                EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
                projectBillsSubsEntityWrapper.setSqlSelect("id", "sub_inv_amt_dr", "sub_inv_amt_cr", "sub_amt_dr", "sub_amt_cr")
                        .eq("project_sub_no", payCrBills.getProjectSubNo());
                ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
                if (projectBillsSubs != null) {
                    map.put("proSub", projectBillsSubs);
                }
                EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
                projectBillsBudgetsEntityWrapper.setSqlSelect("id", "budget_id").eq("project_sub_no", payCrBills.getProjectSubNo());
                List<ProjectBillsBudgets> projectBillsBudgetsList = projectBillsBudgetsService.selectList(projectBillsBudgetsEntityWrapper);
                if (projectBillsBudgetsList.size() != 0) {
                    List<Bbudgets> bbudgets = new ArrayList<>();
                    for (ProjectBillsBudgets pb : projectBillsBudgetsList) {
                        EntityWrapper<Bbudgets> bbudgetsEntityWrapper = new EntityWrapper<>();
                        bbudgetsEntityWrapper.eq("id", pb.getBudgetId());
                        Bbudgets budget = bbudgetsService.selectOne(bbudgetsEntityWrapper);
                        if (budget != null) {
                            bbudgets.add(budget);
                        }
                    }
                    if (bbudgets.size() != 0) {
                        map.put("budgets", bbudgets);
                    }
                }
                EntityWrapper<Bpurchases> bpurchasesEntityWrapper = new EntityWrapper<>();
                bpurchasesEntityWrapper.eq("id", payCrBills.getPurcaserId());
                Bpurchases bpurchases = bpurchasesService.selectOne(bpurchasesEntityWrapper);
                if (bpurchases != null) {
                    map.put("purchase", bpurchases);
                }
            }
            return map;
        }
        return null;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> turnDownStatus(PayCrBillsDto payCrBillsDto, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            if (payCrBillsDto != null && payCrBillsDto.getId() != null) {
                EntityWrapper<PayCrBills> entityWrapper = new EntityWrapper<>();
                entityWrapper.eq("id", payCrBillsDto.getId());
                PayCrBills payCrBills = payCrBillsService.selectOne(entityWrapper);
                if (payCrBills != null) {
                    payCrBills.setBillStatus(2);
                    payCrBills.setUserId(sysUserDto.getUserId().intValue());
                    payCrBills.setUserName(sysUserDto.getUsername());
                    payCrBills.setAffirmantDate(new Date());
                    payCrBills.setAffirmantRemarks(payCrBillsDto.getAffirmantRemarks());
                    payCrBills.setConfirmStatus("S");
                    boolean updateById = payCrBillsService.updateById(payCrBills);
                    if (!updateById) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("驳回失败：更新付款记录失败");
                        return result;
                    }
                } else {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("驳回失败：未找到信息");
                    return result;
                }
            } else {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("驳回失败：未找到信息");
                return result;
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 提交错误：" + e.toString(), e);
            result.addErrorMessage("提交失败");
            return result;
        }
        return result;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> editCrAffirmStatus(PayCrBillsDto payCrBillsDto, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            if (payCrBillsDto != null && payCrBillsDto.getId() != null) {
                PayCrBills payCrBills = payCrBillsService.selectById(payCrBillsDto.getId());
                payCrBills.setAffirmantRemarks(payCrBillsDto.getAffirmantRemarks());
                payCrBills.setUserId(sysUserDto.getUserId().intValue());
                payCrBills.setUserName(sysUserDto.getUsername());
                payCrBills.setAffirmantDate(new Date());
                payCrBills.setConfirmStatus("T");
                boolean updateBy = payCrBillsService.updateById(payCrBills);
                if (!updateBy) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("确认失败请重新编辑提交");
                    return result;
                }
                EntityWrapper<PayCrBillsShares> payCrBillsSharesEntityWrapper = new EntityWrapper<>();
                payCrBillsSharesEntityWrapper.eq("bill_no", payCrBills.getBillNo());
                List<PayCrBillsShares> payCrBillsSharesList = payCrBillsSharesService.selectList(payCrBillsSharesEntityWrapper);
                if (payCrBillsSharesList.size() != 0) {
                    for (PayCrBillsShares pay : payCrBillsSharesList) {
                        /*更新 二级项目 表*/
                        EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
                        projectBillsSubsEntityWrapper.eq("project_sub_no", pay.getProjectSubNo())
                                .eq("branch_id", payCrBills.getBranchId());
                        ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
                        projectBillsSubs.setSubAmtCr(projectBillsSubs.getSubAmtCr() + pay.getShareAmt());
                        boolean updateById = projectBillsSubsService.updateById(projectBillsSubs);
                        if (!updateById) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("确认失败请重新编辑提交");
                            return result;
                        }
                        /*更新*/
                        EntityWrapper<InvoiceBillsIndirect> invoiceBillsIndirectEntityWrapper = new EntityWrapper<>();
                        invoiceBillsIndirectEntityWrapper.eq("project_sub_no", pay.getProjectSubNo())
                                .eq("budget_id", pay.getBudgetId())
                                .eq("purchase_id", pay.getPurcaserId());
                        InvoiceBillsIndirect invoiceBillsIndirect = invoiceBillsIndirectService.selectOne(invoiceBillsIndirectEntityWrapper);
                        if (invoiceBillsIndirect != null) {
                            invoiceBillsIndirect.setSubAmtCr(invoiceBillsIndirect.getSubAmtCr() + pay.getShareAmt());
                            double subAmtCr = invoiceBillsIndirect.getSubAmtCr() - 0.1;
                            if (subAmtCr > invoiceBillsIndirect.getSubInvAmtCr()) {
                                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                result.addErrorMessage("确认失败: 项目累计付款金额超出累计开票金额");
                                return result;
                            }
                            boolean update = invoiceBillsIndirectService.updateById(invoiceBillsIndirect);
                            if (!update) {
                                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                result.addErrorMessage("确认失败: 更新合同失败");
                                return result;
                            }
                        }
                        /*更新项目预算*/
                        EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
                        projectBillsBudgetsEntityWrapper.eq("project_sub_no", pay.getProjectSubNo())
                                .eq("budget_id", payCrBills.getBudgetId());
                        ProjectBillsBudgets billsBudgets = projectBillsBudgetsService.selectOne(projectBillsBudgetsEntityWrapper);
                        billsBudgets.setSubAmtCr(billsBudgets.getSubAmtCr() + pay.getShareAmt());
                        billsBudgets.setSubAmtBlc(billsBudgets.getBudgetAmt() - billsBudgets.getSubAmtCr());
                        boolean update = projectBillsBudgetsService.updateById(billsBudgets);
                        if (!update) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：更新预算失败。");
                            return result;
                        }
                    }
                }
                /*更新其他合同*/
                EntityWrapper<OtherProject> otherProjectEntityWrapper = new EntityWrapper<>();
                otherProjectEntityWrapper.eq("purchase_nc_no", payCrBills.getPurcaserNcNo())
                        .eq("budget_id", payCrBills.getBudgetId()).eq("purchases_id", payCrBills.getPurcaserId());
                OtherProject otherProject = otherProjectService.selectOne(otherProjectEntityWrapper);
                if (otherProject != null) {
                    otherProject.setContractInvAmt(otherProject.getContractInvAmt() + payCrBills.getStlAmt());
                    double contractInvAmt = otherProject.getContractInvAmt() - 0.1;
                    if (otherProject.getContractTotalAmt() < contractInvAmt) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("确认失败: 累计付款金额超出累计开票金额");
                        return result;
                    }
                    boolean updateById = otherProjectService.updateById(otherProject);
                    if (!updateById) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("确认失败: 更新其他合同失败");
                        return result;
                    }
                }
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 提交错误：" + e.toString(), e);
            result.addErrorMessage("提交失败");
            return result;
        }
        return result;
    }


    /**
     * 驳回请求
     * 确认状态为s
     * 单据状态改为处理中
     *
     * @param payCrBillsDto
     * @return
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public ExecuteResult<String> refute(PayCrBillsDto payCrBillsDto, SysUserDto sysUserDto) {
        if (payCrBillsDto != null && payCrBillsDto.getId() != null) {
            ExecuteResult<String> result = new ExecuteResult<String>();
            try {
                EntityWrapper<PayCrBills> entityWrapper = new EntityWrapper<>();
                entityWrapper.eq("id", payCrBillsDto.getId());
                PayCrBills payCrBills = payCrBillsService.selectOne(entityWrapper);
                payCrBills.setUserId(sysUserDto.getUserId().intValue());
                payCrBills.setUserName(sysUserDto.getUsername());
                payCrBills.setAffirmantDate(new Date());
                //确认状态为s
                payCrBills.setConfirmStatus("S");
                //单据状态改为处理中
                payCrBills.setBillStatus(2);
                boolean updateById = payCrBillsService.updateById(payCrBills);
                if (!updateById) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("确认失败请重新编辑提交");
                    return result;
                }
                return result;
            } catch (Exception e) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                logger.error(" 提交错误：" + e.toString(), e);
                result.addErrorMessage("提交失败");
                return result;
            }
        }
        return null;
    }

    @Override
    public Map<String, Object> updatePayCr(Integer id) {
        Map<String, Object> map = new HashMap<>();
        PayCrBills payCrBills = payCrBillsService.selectById(id);
        EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
        projectBillsSubsEntityWrapper.eq("project_sub_no", payCrBills.getProjectSubNo())
                .eq("branch_id", payCrBills.getBranchId());
        EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
        projectBillsBudgetsEntityWrapper.setSqlSelect("id", "budget_id")
                .eq("project_sub_no", payCrBills.getProjectSubNo())
                .eq("branch_id", payCrBills.getBranchId());
        List<ProjectBillsBudgets> bbudgetsList = projectBillsBudgetsService.selectList(projectBillsBudgetsEntityWrapper);
        List<Bbudgets> bbudgets = new ArrayList<>();
        for (ProjectBillsBudgets billsBudgets : bbudgetsList) {
            if (Objects.equals(payCrBills.getBudgetId(), billsBudgets.getBudgetId())) {
                map.put("proBudget", billsBudgets);
            }
            bbudgets.add(bbudgetsService.selectById(billsBudgets.getBudgetId()));
        }
        map.put("pay", payCrBills);
        map.put("sub", projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper));
        map.put("budget", bbudgets);
        map.put("purchase", bpurchasesService.selectById(payCrBills.getPurcaserId()));
        return map;
    }

    @Override
    public String financialDismissal(Integer id, String affirmantRemarks, SysUserDto sysUserDto) {
        PayCrBills payCrBills = payCrBillsService.selectById(id);
        if (affirmantRemarks != null) {
            payCrBills.setAffirmantRemarks(affirmantRemarks);
        }
        payCrBills.setUserId(sysUserDto.getUserId().intValue());
        payCrBills.setUserName(sysUserDto.getUsername());
        payCrBills.setAffirmantDate(new Date());
        payCrBills.setBillStatus(2);
        payCrBills.setConfirmStatus("S");
        boolean payCrBillsType = payCrBillsService.updateById(payCrBills);
        if (!payCrBillsType) {
            return "驳回失败";
        }
        return "驳回成功";
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public String financialSuccess(Integer id, String affirmantRemarks, SysUserDto sysUserDto) {
        PayCrBills payCrBills = payCrBillsService.selectById(id);
        if (affirmantRemarks != null) {
            payCrBills.setAffirmantRemarks(affirmantRemarks);
        }
        payCrBills.setUserId(sysUserDto.getUserId().intValue());
        payCrBills.setUserName(sysUserDto.getUsername());
        payCrBills.setAffirmantDate(new Date());
        payCrBills.setConfirmStatus("T");
        if (payCrBills.getBudgetId() != 1) {
            EntityWrapper<OtherProject> otherProjectEntityWrapper = new EntityWrapper<>();
            otherProjectEntityWrapper.eq("purchases_id", payCrBills.getPurcaserId())
                    .eq("budget_id", payCrBills.getBudgetId())
                    .eq("purchase_nc_no", payCrBills.getPurcaserNcNo())
                    .eq("project_sub_no", payCrBills.getProjectSubNo())
                    .eq("branch_id", payCrBills.getBranchId());
            OtherProject otherProject = otherProjectService.selectOne(otherProjectEntityWrapper);
            if (otherProject.getContractInvAmt() <= 0.0) {
                otherProject.setContractInvAmt(payCrBills.getStlAmt());
            } else {
                otherProject.setContractInvAmt(payCrBills.getStlAmt() + otherProject.getContractInvAmt());
                double contractInvAmt = DataUtils.keepDecimals(otherProject.getContractInvAmt() - 0.1);
                if (otherProject.getContractTotalAmt() < contractInvAmt && payCrBills.getFlagSpecial() == 0) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "累计付款金额不能大于累计开票金额";
                }
            }
            boolean otherProjectType = otherProjectService.updateById(otherProject);
            if (!otherProjectType) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "更新其他合同失败";
            }
        } else {
            EntityWrapper<SubContractBills> subContractBillsEntityWrapper = new EntityWrapper<>();
            subContractBillsEntityWrapper.eq("purchase_nc_no", payCrBills.getPurcaserNcNo())
                    .eq("contract_no", payCrBills.getContractNo())
                    .eq("branch_id", payCrBills.getBranchId());
            SubContractBills subContractBills = subContractBillsService.selectOne(subContractBillsEntityWrapper);
            if (subContractBills != null) {
                payCrBills.setContractNo(subContractBills.getContractNo());
                subContractBills.setSubAmtCr(payCrBills.getStlAmt() + subContractBills.getSubAmtCr());
                double subAmtCr = subContractBills.getSubAmtCr() - 0.1;
                if (subAmtCr > subContractBills.getSubInvAmtCr() && payCrBills.getFlagSpecial() == 0) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "分包合同的已付款金额不能大于已开票金额";
                }
                /*if (subContractBills.getSubAmtCr() <= 0.0) {
                    subContractBills.setSubAmtCr(payCrBills.getStlAmt());
                } else {
                    subContractBills.setSubAmtCr(payCrBills.getStlAmt() + subContractBills.getSubAmtCr());
                    if (subContractBills.getSubAmtCr() > subContractBills.getSubInvAmtCr() && payCrBills.getFlagSpecial() == 0) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        return "分包合同的已付款金额不能大于已开票金额";
                    }
                }*/
                boolean subContractBillsType = subContractBillsService.updateById(subContractBills);
                if (!subContractBillsType) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "更新分包合同失败";
                }
            } else {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "未找到分包信息";
            }
        }
        boolean payCrBillsType = payCrBillsService.updateById(payCrBills);
        if (!payCrBillsType) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "付款确认失败";
        }
        EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
        projectBillsBudgetsEntityWrapper.eq("project_sub_no", payCrBills.getProjectSubNo())
                .eq("budget_id", payCrBills.getBudgetId())
                .eq("branch_id", payCrBills.getBranchId());
        ProjectBillsBudgets projectBillsBudgets = projectBillsBudgetsService.selectOne(projectBillsBudgetsEntityWrapper);
        projectBillsBudgets.setSubAmtCr(projectBillsBudgets.getSubAmtCr() + payCrBills.getStlAmt());
        double subAmtCr = projectBillsBudgets.getSubAmtCr() - 0.1;
        if (subAmtCr > projectBillsBudgets.getSubInvAmtCr() && payCrBills.getFlagSpecial() == 0) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "该预算已付款金额超出已开票金额";
        }
        boolean projectBillsBudgetsType = projectBillsBudgetsService.updateById(projectBillsBudgets);
        if (!projectBillsBudgetsType) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "更新项目预算失败";
        }
        EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
        projectBillsSubsEntityWrapper.eq("project_sub_no", payCrBills.getProjectSubNo()).eq("branch_id", payCrBills.getBranchId());
        ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
        if (projectBillsSubs.getSubAmtCr() == 0.0) {
            projectBillsSubs.setSubAmtCr(payCrBills.getStlAmt());
        } else {
            projectBillsSubs.setSubAmtCr(payCrBills.getStlAmt() + projectBillsSubs.getSubAmtCr());
            double subAmtr = projectBillsSubs.getSubAmtCr() - 0.1;
            if (subAmtr > projectBillsSubs.getSubInvAmtCr() && payCrBills.getFlagSpecial() == 0) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "项目已付款金额大于已开票金额";
            }
        }
        boolean projectBillsSubsType = projectBillsSubsService.updateById(projectBillsSubs);
        if (!projectBillsSubsType) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "更新二级项目金额失败";
        }
        return "付款确认成功";
    }

    @Override
    public boolean updatePayCrIndirectPrint(PayCrBillsDto payCrBillsDto) {
        if (payCrBillsDto != null && payCrBillsDto.getId() != null) {
            PayCrBills payCrBills = new PayCrBills();
            payCrBills.setId(payCrBillsDto.getId());
            payCrBills.setIsPrinted("T");
            payCrBills.setPrintTime(new Date());
            boolean updateById = payCrBillsService.updateById(payCrBills);
            if (!updateById) {
                return false;
            }
            return true;
        }
        return false;
    }

    @Override
    public Map<String, Object> selectFundpay(PayCrBillsDto payCrBillsDto, SysUserDto sysUserDto) {
        if (payCrBillsDto != null && payCrBillsDto.getId() != null && payCrBillsDto.getActId() != null) {
            PayCrBills payCrBills = payCrBillsService.selectById(payCrBillsDto.getId());
            Map<String, Object> objectMap = payCrBillsService.selectFundpay(payCrBills);
            Date d = new Date();
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
            objectMap.put("payCr", payCrBills);
            objectMap.put("date", sdf.format(d));
            objectMap.put("printQrCode", payCrBills.getPrintQrCode());
            objectMap.put("printCount", payCrBills.getPrintCount());
            objectMap.put("id", payCrBillsDto.getId());
            Bdepts bdepts = bdeptsService.selectById(sysUserDto.getDeptId());
            if (bdepts != null) {
                objectMap.put("deptName", bdepts.getDeptName());
            }
            if (Objects.equals(payCrBills.getActId(), 204)) {
                List<ProjectBillsSubs> projectBillsSubsList = invoiceBillsService.selectPayCrIndirectPrintProSub(payCrBillsDto);
                if (projectBillsSubsList.size() != 0) {
                    String contractName = null;
                    for (ProjectBillsSubs pb : projectBillsSubsList) {
                        if (contractName != null) {
                            contractName = contractName + "/" + pb.getProjectSubName();
                        } else {
                            contractName = pb.getProjectSubName();
                        }
                    }
                    objectMap.put("projectSubName", contractName);
                }
            }
            return objectMap;
        }
        return null;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public String cxFinancialSuccess(Integer id, String affirmantRemarks, SysUserDto sysUserDto) {
        PayCrBills payCrBills = payCrBillsService.selectById(id);
        if (affirmantRemarks != null) {
            payCrBills.setAffirmantRemarks(affirmantRemarks);
        }
        payCrBills.setUserId(sysUserDto.getUserId().intValue());
        payCrBills.setUserName(sysUserDto.getUsername());
        payCrBills.setAffirmantDate(new Date());
        payCrBills.setConfirmStatus("T");
        if (payCrBills.getBudgetId() == 1) {
            EntityWrapper<SubContractBills> billsEntityWrapper = new EntityWrapper<>();
            billsEntityWrapper.eq("project_sub_no", payCrBills.getProjectSubNo())
                    .eq("purchase_id", payCrBills.getPurcaserId())
                    .eq("branch_id", payCrBills.getBranchId());
            SubContractBills subContractBills = subContractBillsService.selectOne(billsEntityWrapper); // 查出对应分包合同
            if (subContractBills != null) {
                payCrBills.setContractNo(subContractBills.getContractNo());
                subContractBills.setSubAmtCr(payCrBills.getStlAmt() + subContractBills.getSubAmtCr());
                double subAmtCr = subContractBills.getSubAmtCr() - 0.1;
                if (subAmtCr > subContractBills.getSubInvAmtCr() && payCrBills.getFlagSpecial() == 0) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "分包合同的已付款金额不能大于已开票金额";
                }
                /*if (subContractBills.getSubAmtCr() <= 0.0) {
                    subContractBills.setSubAmtCr(payCrBills.getStlAmt());
                } else {
                    subContractBills.setSubAmtCr(payCrBills.getStlAmt() + subContractBills.getSubAmtCr());
                    if (subContractBills.getSubAmtCr() > subContractBills.getSubInvAmtCr() && payCrBills.getFlagSpecial() == 0) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        return "分包合同的已付款金额不能大于已开票金额";
                    }
                }*/
                boolean subContractBillsType = subContractBillsService.updateById(subContractBills);
                if (!subContractBillsType) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "更新分包合同失败";
                }
            } else {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "未找到分包信息";
            }
        }
        boolean payCrBillsType = payCrBillsService.updateById(payCrBills);
        if (!payCrBillsType) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "付款确认失败";
        }
        EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
        projectBillsBudgetsEntityWrapper.eq("project_sub_no", payCrBills.getProjectSubNo())
                .eq("budget_id", payCrBills.getBudgetId())
                .eq("branch_id", payCrBills.getBranchId());
        ProjectBillsBudgets projectBillsBudgets = projectBillsBudgetsService.selectOne(projectBillsBudgetsEntityWrapper); // 查询项目预算
        projectBillsBudgets.setSubAmtCr(projectBillsBudgets.getSubAmtCr() + payCrBills.getStlAmt());
        double subAmtC = projectBillsBudgets.getSubAmtCr() - 0.1;
        if (subAmtC > projectBillsBudgets.getSubInvAmtCr() && payCrBills.getFlagSpecial() == 0) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "该预算已付款金额超出已开票金额";
        }
        boolean projectBillsBudgetsType = projectBillsBudgetsService.updateById(projectBillsBudgets);
        if (!projectBillsBudgetsType) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "更新项目预算失败";
        }
        EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
        projectBillsSubsEntityWrapper.eq("project_sub_no", payCrBills.getProjectSubNo()).eq("branch_id", payCrBills.getBranchId());
        ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper); // 查询二级项目
        if (projectBillsSubs.getSubAmtCr() == 0.0) {
            projectBillsSubs.setSubAmtCr(payCrBills.getStlAmt());
        } else {
            projectBillsSubs.setSubAmtCr(payCrBills.getStlAmt() + projectBillsSubs.getSubAmtCr());
        }
        double amtCr = projectBillsSubs.getSubAmtCr() - 0.1;
        if (amtCr > projectBillsSubs.getSubInvAmtCr() && payCrBills.getFlagSpecial() == 0) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "项目已付款金额大于已开票金额";
        }
        boolean projectBillsSubsType = projectBillsSubsService.updateById(projectBillsSubs);
        if (!projectBillsSubsType) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "更新二级项目金额失败";
        }
        return "付款确认成功";
    }

    /**
     * 撤销
     *
     * @param payCrBillsDto
     * @param sysUserDto
     * @return
     */
    @Override
    public ExecuteResult<String> revokePayment(PayCrBillsDto payCrBillsDto, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<>();
        PayCrBills payCrBills = payCrBillsService.selectById(payCrBillsDto.getId());
        payCrBills.setBillStatus(2);
        try {
            payCrBillsService.updateById(payCrBills);
            result.setSuccessMessage("操作成功!");
        } catch (Exception e) {
            e.printStackTrace();
            result.setErrorMessages(Arrays.asList("操作异常，请联系管理员!"));
        }
        return result;
    }


}


