
package io.platform.moneyManagement.service.client.impl;

import com.alibaba.dubbo.config.annotation.Service;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;


import io.platform.approvalConfiguration.biz.entity.Audit;
import io.platform.approvalConfiguration.biz.service.AuditItemsService;
import io.platform.budget.biz.entity.ProjectBillsBudgets;
import io.platform.budget.biz.service.ProjectBillsBudgetsService;
import io.platform.contract.biz.entity.OtherProject;
import io.platform.contract.biz.service.OtherProjectService;
import io.platform.engineering.biz.entity.Bbranchs;
import io.platform.engineering.biz.entity.Bbudgets;
import io.platform.engineering.biz.entity.Bdepts;
import io.platform.engineering.biz.entity.Bpurchases;
import io.platform.engineering.biz.service.BbranchsService;
import io.platform.engineering.biz.service.BbudgetsService;
import io.platform.engineering.biz.service.BdeptsService;
import io.platform.engineering.biz.service.BpurchasesService;
import io.platform.moneyManagement.biz.entity.*;
import io.platform.moneyManagement.biz.service.*;
import io.platform.moneyManagement.dto.PayCrBillsSharesDto;
import io.platform.moneyManagement.service.client.api.PayCrBillsSharesServiceClient;
import io.platform.project.biz.entity.ProjectBillsSubs;
import io.platform.project.biz.entity.Projectbills;
import io.platform.project.biz.service.ProjectBillsSubsService;
import io.platform.project.biz.service.ProjectbillsService;
import io.platform.purchase.biz.entity.PurchaseBillsItems;
import io.platform.purchase.biz.service.PurchaseBillsItemsService;
import io.platform.sys.biz.entity.SysUser;
import io.platform.sys.biz.service.SysUserService;
import io.platform.sys.dto.SysUserDto;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.*;

import io.platform.base.common.BaseServiceClient;
import io.platform.base.common.utils.ExecuteResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;

/**
 * Created by sevelli on 2017/8/31.
 */
@Component
@Service(version = "1.0.0", interfaceClass = PayCrBillsSharesServiceClient.class)
public class PayCrBillsSharesServiceClientImpl extends BaseServiceClient<PayCrBillsShares, PayCrBillsSharesDto> implements PayCrBillsSharesServiceClient {
    private Logger logger = LoggerFactory.getLogger(getClass());
    @Resource
    private PayCrBillsSharesService payCrBillsSharesService;
    @Resource
    private ProjectBillsSubsService projectBillsSubsService;
    @Resource
    private BbranchsService bbranchsService;
    @Resource
    private BbudgetsService bbudgetsService;
    @Resource
    private AuditItemsService auditItemsService;
    @Resource
    private BpurchasesService bpurchasesService;
    @Resource
    private PayCrBillsService payCrBillsService;
    @Resource
    private ProjectbillsService projectbillsService;
    @Resource
    private OtherProjectService otherProjectService;
    @Resource
    private InvoicePurchaseService invoicePurchaseService;
    @Resource
    private PurchaseBillsItemsService purchaseBillsItemsService;
    @Resource
    private InvoiceBillsService invoiceBillsService;
    @Resource
    private InvoiceBillsItemsService invoiceBillsItemsService;
    @Resource
    private ProjectBillsBudgetsService projectBillsBudgetsService;
    @Resource
    private BdeptsService bdeptsService;
    @Resource
    private SysUserService sysUserService;

    @Override
    public PayCrBillsSharesDto queryObject(Long id) {
        PayCrBillsShares payCrBillsShares = payCrBillsSharesService.selectById(id);
        PayCrBillsSharesDto payCrBillsSharesDto = new PayCrBillsSharesDto();
        BeanUtils.copyProperties(payCrBillsShares, payCrBillsSharesDto);
        return payCrBillsSharesDto;
    }

    @Override
    public List<PayCrBillsSharesDto> queryList(Map<String, Object> map) {
        List<PayCrBillsShares> payCrBillsSharesList = payCrBillsSharesService.selectByMap(map);
        return convertList(payCrBillsSharesList, PayCrBillsSharesDto.class);
    }

    @Override
    public int queryTotal(Map<String, Object> map) {
        EntityWrapper<PayCrBillsShares> ew = new EntityWrapper<>();
        ew.allEq(map);
        return payCrBillsSharesService.selectCount(ew);
    }

    @Override
    public ExecuteResult<String> save(PayCrBillsSharesDto payCrBillsSharesDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            PayCrBillsShares payCrBillsShares = new PayCrBillsShares();
            revert(payCrBillsSharesDto, payCrBillsShares);
            boolean flag = payCrBillsSharesService.insert(payCrBillsShares);
            if (!flag) {
                result.addErrorMessage("保存失败。");
            }
        } catch (Exception e) {
            logger.error(" 保存错误：" + e.toString(), e);
            result.addErrorMessage("保存错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> update(PayCrBillsSharesDto payCrBillsSharesDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            PayCrBillsShares payCrBillsShares = new PayCrBillsShares();
            revert(payCrBillsSharesDto, payCrBillsShares);

            boolean flag = payCrBillsSharesService.updateById(payCrBillsShares);
            if (!flag) {
                result.addErrorMessage("更新失败。");
            }
        } catch (Exception e) {
            logger.error(" 更新错误：" + e.toString(), e);
            result.addErrorMessage("更新错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> delete(Long id) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = payCrBillsSharesService.deleteById(id);
            if (!flag) {
                result.addErrorMessage("删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = payCrBillsSharesService.deleteBatchIds(ids);
            if (!flag) {
                result.addErrorMessage("批量删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public Page<PayCrBillsSharesDto> getPage(Page<PayCrBillsSharesDto> pageDto, PayCrBillsSharesDto payCrBillsSharesDto) {
        Page<PayCrBillsShares> page = new Page<>(pageDto.getCurrent(), pageDto.getSize());
        page.setAsc(pageDto.isAsc());
        page.setOrderByField(pageDto.getOrderByField());
        page.setCondition(pageDto.getCondition());
        PayCrBillsShares payCrBillsShares = new PayCrBillsShares();
        revert(payCrBillsSharesDto, payCrBillsShares);
        EntityWrapper<PayCrBillsShares> wrapper = new EntityWrapper<>();
        wrapper.setEntity(payCrBillsShares);
        page = payCrBillsSharesService.selectPage(page, wrapper);
        List<PayCrBillsSharesDto> payCrBillsSharesDtoList = convertList(page.getRecords(), PayCrBillsSharesDto.class);
        pageDto.setTotal(payCrBillsSharesService.selectCount(wrapper));
        pageDto.setRecords(payCrBillsSharesDtoList);
        return pageDto;
    }

    @Override
    public Map<String, Object> selectPirce(String dto) {
        Map<String, Object> map = new HashMap<>();
        PayCrBills payCrBills = JSONArray.parseObject(dto, PayCrBills.class);
        PayCrBills bills = payCrBillsService.selectById(payCrBills.getId());
        EntityWrapper<ProjectBillsSubs> subsEntityWrapper = new EntityWrapper<>();
        subsEntityWrapper.eq("project_sub_no", bills.getProjectSubNo());  // 二级项目
        EntityWrapper<Bpurchases> bpurchasesEntityWrapper = new EntityWrapper<>();
        bpurchasesEntityWrapper.eq("id", bills.getPurcaserId()); // 供应商
        EntityWrapper<Bbranchs> bbranchsEntityWrapper = new EntityWrapper<>();
        bbranchsEntityWrapper.eq("id", bills.getBranchId()); // 承包单位
        map.put("sub", projectBillsSubsService.selectOne(subsEntityWrapper));
        map.put("branchs", bbranchsService.selectOne(bbranchsEntityWrapper));
        map.put("purchase", bpurchasesService.selectOne(bpurchasesEntityWrapper));
        map.put("row", bills);
        return map;
    }

    @Override
    public Map<String, Object> selectProjectNc(String ncNo, String subNo, SysUserDto sysUserDto) {
        Map<String, Object> map = new HashMap<>();
        EntityWrapper<OtherProject> projectEntityWrapper = new EntityWrapper<>();
        projectEntityWrapper.eq("purchase_nc_no", ncNo)
                .eq("budget_id", 2)
                .eq("project_sub_no", subNo)
                .eq("branch_id", sysUserDto.getLoginContractorId());
        OtherProject otherProject = otherProjectService.selectOne(projectEntityWrapper);
        if (otherProject == null) {
            return null;
        }
        EntityWrapper<PurchaseBillsItems> purchaseBillsItemsEntityWrapper = new EntityWrapper<>();
        purchaseBillsItemsEntityWrapper.eq("project_Sub_No", subNo)
                .eq("purchase_id", otherProject.getPurchasesId())
                .eq("act_id", 4);
        map.put("item", purchaseBillsItemsService.selectList(purchaseBillsItemsEntityWrapper));
        map.put("other", otherProject);
        return map;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public String saveMaterial(String zhu, String fapiao, String mingxi, SysUserDto sysUserDto) {
        try {
            // —————— 转换——————
            InvoiceBills invoiceBills = JSONArray.parseObject(zhu, InvoiceBills.class);
            JSONArray jsonArray = JSONArray.parseArray(fapiao);
            List<InvoiceBillsItems> invoiceBillsItemsList = JSONObject.parseArray(jsonArray.toJSONString(), InvoiceBillsItems.class);
            // ———————— 更新发票主表——————
            if (Objects.equals(invoiceBills.getIsSpecial(), 1)) {
                invoiceBills.setBillStatus(4);
            } else {
                invoiceBills.setBillStatus(6);
            }
            invoiceBills.setBranchId(sysUserDto.getLoginContractorId());
            Boolean billsType = invoiceBillsService.insertOrUpdate(invoiceBills);
            if (!billsType) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "更新材料款失败，请检查工程与供应商信息";
            }
            if (invoiceBills.getIsSur().equals("F")) {
                EntityWrapper<InvoicePurchase> purchaseEntityWrapper = new EntityWrapper<>();
                purchaseEntityWrapper.eq("inv_id", invoiceBills.getId());
                boolean delete = invoicePurchaseService.delete(purchaseEntityWrapper);
                if (!delete) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "删除旧数据失败";
                }
                JSONArray faArray = JSONArray.parseArray(mingxi);
                List<PurchaseBillsItems> purchaseBillsItemsList = JSONObject.parseArray(faArray.toJSONString(), PurchaseBillsItems.class);
                // ———————— 这个循环是更新需求计划的 累计开票数量与金额————————
                for (PurchaseBillsItems billsItems : purchaseBillsItemsList) {
                    if (billsItems.getTimeQty() != null && billsItems.getTimeQty() != 0.0) {
                        billsItems.setInvTotalQty(billsItems.getInvTotalQty() + billsItems.getTimeQty());
                        billsItems.setInvTotalAmt(billsItems.getInvTotalAmt() + billsItems.getTimeAmt());
                        boolean billsItemsType = purchaseBillsItemsService.insertOrUpdate(billsItems);
                        if (!billsItemsType) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            return "更新累计开票失败";
                        }
                    }
                    InvoicePurchase invoicePurchase = new InvoicePurchase();
                    invoicePurchase.setInvId(invoiceBills.getId());
                    invoicePurchase.setPurchaseItemId(billsItems.getId());
                    invoicePurchase.setTimeQty(billsItems.getTimeQty());
                    invoicePurchase.setTimeAmt(billsItems.getTimeAmt());
                    invoicePurchase.setQty(billsItems.getContractQty());
                    invoicePurchase.setPrice(billsItems.getContractPrice());
                    invoicePurchase.setSubTimeQty(billsItems.getInvTotalQty());
                    boolean insert = invoicePurchaseService.insert(invoicePurchase);
                    if (!insert) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        return "新建开票从表失败";
                    }
                }
            }
            // ————————这个循环是判断页面传来的值是否有问题，筛选出没有问题的，新增到发票明细表————————
            int line = 0;
            EntityWrapper<InvoiceBillsItems> billsItemsEntityWrapper = new EntityWrapper<>();
            billsItemsEntityWrapper.eq("bill_no", invoiceBills.getBillNo())
                    .eq("branch_id", invoiceBills.getBranchId());
            boolean delete = invoiceBillsItemsService.delete(billsItemsEntityWrapper);
            if (!delete) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "删除发票旧数据失败";
            }
            for (InvoiceBillsItems invoiceBillsItem : invoiceBillsItemsList) {
                if (invoiceBillsItem.getInvoiceNo() == null || invoiceBillsItem.getInvoiceAmt() == null || Objects.equals(invoiceBillsItem.getInvoiceAmt(), 0)) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "请检查发票信息";
                }
                line++;
                invoiceBillsItem.setLineNo(line);
                invoiceBillsItem.setBranchId(invoiceBills.getBranchId());
                boolean invoiceBillsItemType = invoiceBillsItemsService.insert(invoiceBillsItem);
                if (!invoiceBillsItemType) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "新增发票明细失败";
                }
            }
            EntityWrapper<OtherProject> otherProjectEntityWrapper = new EntityWrapper<>();
            otherProjectEntityWrapper.eq("purchase_nc_no", invoiceBills.getPurchaseNcNo())
                    .eq("project_sub_no", invoiceBills.getProjectSubNo())
                    .eq("branch_id", invoiceBills.getBranchId());
            OtherProject otherProject = otherProjectService.selectOne(otherProjectEntityWrapper);
            if (otherProject == null) {
                OtherProject otherProjectInstall = otherProjectService.installOrUpdateOtherProject(invoiceBills, sysUserDto);
                boolean otherProjectInstallType = otherProjectService.insert(otherProjectInstall);
                if (!otherProjectInstallType) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "新建其他合同失败";
                }
            } else {
                otherProject.setContractTotalAmt(Double.parseDouble(String.format("%.2f", invoiceBills.getInvAmt() + otherProject.getContractTotalAmt())));
                boolean otherProjectType = otherProjectService.updateById(otherProject);
                if (!otherProjectType) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "更新其他合同失败";
                }
            }
            // —————— 下面是更新项目预算——————
            EntityWrapper<ProjectBillsSubs> subsEntityWrapper = new EntityWrapper<>();
            subsEntityWrapper.eq("project_sub_no", invoiceBills.getProjectSubNo())
                    .eq("branch_id", invoiceBills.getBranchId());
            ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(subsEntityWrapper);
            EntityWrapper<ProjectBillsBudgets> budgetsEntityWrapper = new EntityWrapper<>();
            budgetsEntityWrapper.eq("project_sub_no", invoiceBills.getProjectSubNo())
                    .eq("budget_id", invoiceBills.getBudgetId())
                    .eq("branch_id", invoiceBills.getBranchId());
            ProjectBillsBudgets billsBudgets = projectBillsBudgetsService.selectOne(budgetsEntityWrapper);
            double invamtCr = billsBudgets.getSubInvAmtCr() + invoiceBills.getInvAmt() - 0.1;
            billsBudgets.setSubInvAmtCr(Double.parseDouble(String.format("%.2f", billsBudgets.getSubInvAmtCr() + invoiceBills.getInvAmt())));
            if (invoiceBills.getIsSpecial() == 0) {
                if (invamtCr > billsBudgets.getBudgetAmt()) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "成本开票金额超出成本预算金额";
                }
            }
            if ("T".equals(projectBillsSubs.getIsSur())) {
                billsBudgets.setApprovedAmount(billsBudgets.getSubInvAmtCr());
            }
            boolean billsBudgetsType = projectBillsBudgetsService.updateById(billsBudgets);
            if (!billsBudgetsType) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "更新项目预算失败";
            }
            double amt = projectBillsBudgetsService.selectApprovedAmountSum(billsBudgets);
            projectBillsSubs.setActualBudgetAmt(amt);
            if (projectBillsSubs.getSubInvAmtCr() != 0.0) {
                projectBillsSubs.setSubInvAmtCr(Double.parseDouble(String.format("%.2f", projectBillsSubs.getSubInvAmtCr() + invoiceBills.getInvAmt())));
            } else {
                projectBillsSubs.setSubInvAmtCr(invoiceBills.getInvAmt());
            }
            boolean subType = projectBillsSubsService.updateById(projectBillsSubs);
            if (!subType) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "更新项目发票失败";
            }
            if (Objects.equals(invoiceBills.getIsSpecial(), 1)) {
                Audit audit = new Audit();
                audit.setBillNo(invoiceBills.getBillNo());
                audit.setActId(520);
                audit.setLevelId(0);
                audit.setIffinalItem("F");
                audit.setSubJect(projectBillsSubs.getProjectSubName());
                audit.setProjectNo(invoiceBills.getProjectSubNo());
                audit.setBranchId(projectBillsSubs.getApprovalBranchId());
                audit.setSendUserId(sysUserDto.getUserId().intValue());
                audit.setSendName(sysUserDto.getActualname());
                audit.setSendTime(new Date());
                audit.setAuditUserId(sysUserDto.getUserId().intValue());
                audit.setAuditItem(new Date());
                audit.setAuditMsg("提交");
                audit.setAuditStatus("O");
                audit.setProjectMngId(projectBillsSubs.getProjectSubMngId());
                EntityWrapper<Projectbills> projectbillsEntityWrapper = new EntityWrapper<>();
                projectbillsEntityWrapper.setSqlSelect("id", "project_leader").eq("bill_no", projectBillsSubs.getBillNo())
                        .eq("act_id", projectBillsSubs.getActId());
                Projectbills projectbills = projectbillsService.selectOne(projectbillsEntityWrapper);
                if (projectbills != null) {
                    audit.setProjectLeader(projectbills.getProjectLeader());
                }
                boolean approvalFlow = auditItemsService.createApprovalFlow(audit);
                if (!approvalFlow) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "审批流异常请检查提交信息";
                }
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 提交错误：" + e.toString(), e);
            return "提交失败";
        }
        return "1";
    }

    @Override
    public Map<String, Object> selectPricePrint(Integer id) {
        Map<String, Object> map = new HashMap<>();
        InvoiceBills invoiceBills = invoiceBillsService.selectById(id);
        if (invoiceBills.getIsPrint() == 0) {
            invoiceBills.setPrintTime(new Date());
        }
        EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
        projectBillsSubsEntityWrapper.eq("project_sub_no", invoiceBills.getProjectSubNo());
        ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
        if (projectBillsSubs != null) {
            SysUser sysUser = sysUserService.selectById(invoiceBills.getOpUserId());
            Bdepts bdepts = bdeptsService.selectById(sysUser.getDeptId());
            map.put("dept", bdepts);
            map.put("sub", projectBillsSubs);
            map.put("branch", bbranchsService.selectById(invoiceBills.getBranchId()));
        }
        Bbudgets bbudgets = bbudgetsService.selectById(invoiceBills.getBudgetId());
        map.put("budget", bbudgets);
        map.put("bills", invoiceBills);
        return map;
    }

    @Override
    public Map<String, Object> selectPricePrint2(Integer id) {
        Map<String, Object> map = new HashMap<>();
        InvoiceBills invoiceBills = invoiceBillsService.selectById(id);
        if (invoiceBills.getIsPrint() == 0) {
            invoiceBills.setPrintTime(new Date());
        }
        EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
        projectBillsSubsEntityWrapper.eq("project_sub_no", invoiceBills.getProjectSubNo());
        ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
//        SysUser sysUser = sysUserService.selectById(projectBillsSubs.getProjectSubMngId());
        Bbudgets bbudgets = bbudgetsService.selectById(invoiceBills.getBudgetId());
        map.put("budget", bbudgets);
        map.put("bills", invoiceBills);
//        map.put("sub", projectBillsSubs);
//        map.put("branch", bbranchsService.selectById(projectBillsSubs.getBranchId()));
//        map.put("dept", bdeptsService.selectById(sysUser.getDeptId()));
        return map;
    }

    @Override
    public Map<String, Object> selectDirectPaymentPrint(Integer id) {
        Map<String, Object> map = new HashMap<>();
        PayCrBills payCrBills = payCrBillsService.selectById(id);
        if (payCrBills.getIsPrinted().equals("F")) {
            payCrBills.setPrintTime(new Date());
        }
        EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
        projectBillsSubsEntityWrapper.eq("project_sub_no", payCrBills.getProjectSubNo());
        ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
        SysUser sysUser = sysUserService.selectById(projectBillsSubs.getProjectSubMngId());
        map.put("payCr", payCrBills);
        map.put("sub", projectBillsSubs);
        map.put("brand", bbranchsService.selectById(projectBillsSubs.getBranchId()));
        map.put("dept", bdeptsService.selectById(sysUser.getDeptId()));
        return map;
    }

    @Override
    public Boolean updatePayCrPrint(Integer id) {
        PayCrBills payCrBills = payCrBillsService.selectById(id);
        payCrBills.setPrintTime(new Date());
        payCrBills.setIsPrinted("T");
        return payCrBillsService.updateById(payCrBills);
    }
}
