
package io.platform.moneyManagement.service.client.impl;

import com.alibaba.dubbo.config.annotation.Service;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;


import io.platform.approvalConfiguration.biz.entity.Audit;
import io.platform.approvalConfiguration.biz.service.AuditItemsService;
import io.platform.budget.biz.entity.ProjectBillsBudgets;
import io.platform.budget.biz.service.ProjectBillsBudgetsService;
import io.platform.contract.biz.entity.OtherProject;
import io.platform.contract.biz.service.OtherProjectService;
import io.platform.engineering.biz.entity.Bdepts;
import io.platform.engineering.biz.service.*;
import io.platform.moneyManagement.biz.entity.InvoiceBills;
import io.platform.moneyManagement.biz.entity.InvoiceBillsAttachs;
import io.platform.moneyManagement.biz.entity.InvoiceBillsItems;
import io.platform.moneyManagement.biz.entity.PayDrBillsItems;
import io.platform.moneyManagement.biz.service.InvoiceBillsAttachsService;
import io.platform.moneyManagement.biz.service.InvoiceBillsItemsService;
import io.platform.moneyManagement.biz.service.InvoiceBillsService;
import io.platform.moneyManagement.biz.service.PayDrBillsItemsService;
import io.platform.moneyManagement.dto.PayDrBillsItemsDto;
import io.platform.moneyManagement.service.client.api.PayDrBillsItemsServiceClient;
import io.platform.project.biz.entity.ProjectBillsSubs;
import io.platform.project.biz.entity.Projectbills;
import io.platform.project.biz.service.ProjectBillsSubsService;
import io.platform.project.biz.service.ProjectbillsService;
import io.platform.project.dto.ProjectbillsDto;
import io.platform.sys.dto.SysUserDto;
import io.platform.utils.DataUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.*;

import io.platform.base.common.BaseServiceClient;
import io.platform.base.common.utils.ExecuteResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;

/**
 * Created by sevelli on 2017/8/31.
 */
@Component
@Service(version = "1.0.0", interfaceClass = PayDrBillsItemsServiceClient.class)
public class PayDrBillsItemsServiceClientImpl extends BaseServiceClient<PayDrBillsItems, PayDrBillsItemsDto> implements PayDrBillsItemsServiceClient {
    private Logger logger = LoggerFactory.getLogger(getClass());
    @Resource
    private BcorpsService bcorpsService;
    @Resource
    private BdeptsService bdeptsService;
    @Resource
    private BbranchsService bbranchsService;
    @Resource
    private AuditItemsService auditItemsService;
    @Resource
    private BpurchasesService bpurchasesService;
    @Resource
    private OtherProjectService otherProjectService;
    @Resource
    private ProjectbillsService projectbillsService;
    @Resource
    private InvoiceBillsService invoiceBillsService;
    @Resource
    private BprojectTypesService bprojectTypesService;
    @Resource
    private PayDrBillsItemsService payDrBillsItemsService;
    @Resource
    private ProjectBillsSubsService projectBillsSubsService;
    @Resource
    private InvoiceBillsItemsService invoiceBillsItemsService;
    @Resource
    private ProjectBillsBudgetsService projectBillsBudgetsService;
    @Resource
    private InvoiceBillsAttachsService invoiceBillsAttachsService;

    @Override
    public PayDrBillsItemsDto queryObject(Long id) {
        PayDrBillsItems payDrBillsItems = payDrBillsItemsService.selectById(id);
        PayDrBillsItemsDto payDrBillsItemsDto = new PayDrBillsItemsDto();
        BeanUtils.copyProperties(payDrBillsItems, payDrBillsItemsDto);
        return payDrBillsItemsDto;
    }

    @Override
    public List<PayDrBillsItemsDto> queryList(Map<String, Object> map) {
        List<PayDrBillsItems> payDrBillsItemsList = payDrBillsItemsService.selectByMap(map);
        return convertList(payDrBillsItemsList, PayDrBillsItemsDto.class);
    }

    @Override
    public int queryTotal(Map<String, Object> map) {
        EntityWrapper<PayDrBillsItems> ew = new EntityWrapper<>();
        ew.allEq(map);
        return payDrBillsItemsService.selectCount(ew);
    }

    @Override
    public ExecuteResult<String> save(PayDrBillsItemsDto payDrBillsItemsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            PayDrBillsItems payDrBillsItems = new PayDrBillsItems();
            revert(payDrBillsItemsDto, payDrBillsItems);
            boolean flag = payDrBillsItemsService.insert(payDrBillsItems);
            if (!flag) {
                result.addErrorMessage("保存失败。");
            }
        } catch (Exception e) {
            logger.error(" 保存错误：" + e.toString(), e);
            result.addErrorMessage("保存错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> update(PayDrBillsItemsDto payDrBillsItemsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            PayDrBillsItems payDrBillsItems = new PayDrBillsItems();
            revert(payDrBillsItemsDto, payDrBillsItems);

            boolean flag = payDrBillsItemsService.updateById(payDrBillsItems);
            if (!flag) {
                result.addErrorMessage("更新失败。");
            }
        } catch (Exception e) {
            logger.error(" 更新错误：" + e.toString(), e);
            result.addErrorMessage("更新错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> delete(Long id) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = payDrBillsItemsService.deleteById(id);
            if (!flag) {
                result.addErrorMessage("删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = payDrBillsItemsService.deleteBatchIds(ids);
            if (!flag) {
                result.addErrorMessage("批量删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public Page<PayDrBillsItemsDto> getPage(Page<PayDrBillsItemsDto> pageDto, PayDrBillsItemsDto payDrBillsItemsDto) {
        Page<PayDrBillsItems> page = new Page<>(pageDto.getCurrent(), pageDto.getSize());
        page.setAsc(pageDto.isAsc());
        page.setOrderByField(pageDto.getOrderByField());
        page.setCondition(pageDto.getCondition());
        PayDrBillsItems payDrBillsItems = new PayDrBillsItems();
        revert(payDrBillsItemsDto, payDrBillsItems);
        EntityWrapper<PayDrBillsItems> wrapper = new EntityWrapper<>();
        wrapper.setEntity(payDrBillsItems);
        page = payDrBillsItemsService.selectPage(page, wrapper);
        List<PayDrBillsItemsDto> payDrBillsItemsDtoList = convertList(page.getRecords(), PayDrBillsItemsDto.class);
        pageDto.setTotal(payDrBillsItemsService.selectCount(wrapper));
        pageDto.setRecords(payDrBillsItemsDtoList);
        return pageDto;
    }

    @Override
    public Map<String, Object> selectDirectCostPrice(String subNo, String ncNo, SysUserDto sysUserDto) {
        Map<String, Object> map = new HashMap<>();
        EntityWrapper<OtherProject> otherProjectEntityWrapper = new EntityWrapper<>();
        otherProjectEntityWrapper.eq("purchase_nc_no", ncNo)
                .eq("project_sub_no", subNo)
                .eq("branch_id", sysUserDto.getLoginContractorId());
        OtherProject otherProject = otherProjectService.selectOne(otherProjectEntityWrapper);
        if (otherProject == null) {
            return null;
        }
        EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
        projectBillsBudgetsEntityWrapper.eq("project_sub_no", subNo)
                .eq("budget_id", otherProject.getBudgetId())
                .eq("branch_id", sysUserDto.getLoginContractorId());
        map.put("other", otherProject);
        map.put("budget", projectBillsBudgetsService.selectOne(projectBillsBudgetsEntityWrapper));
        return map;
    }

    /*public String saveDirect(String zhu, String fapiao, String fujian, SysUserDto sysUserDto) { // InvoiceBillsAttachs
        InvoiceBills invoiceBills = JSONArray.parseObject(zhu, InvoiceBills.class);
        invoiceBills.setBranchId(sysUserDto.getLoginContractorId());
        InvoiceBillsAttachs invoiceBillsAttachs = new InvoiceBillsAttachs();
        JSONArray Attachs = JSONArray.parseArray(fujian);
        List<InvoiceBillsAttachs> invoiceBillsAttachsList = JSONObject.parseArray(Attachs.toJSONString(), InvoiceBillsAttachs.class);
        if (invoiceBillsAttachsList.size() != 0) {
            invoiceBillsAttachs = invoiceBillsAttachsList.get(0);
            EntityWrapper<InvoiceBillsAttachs> invoiceBillsAttachsEntityWrapper = new EntityWrapper<>();
            invoiceBillsAttachsEntityWrapper.eq("bill_no", invoiceBills.getBillNo())
                    .eq("act_id", invoiceBills.getActId());
            boolean delete = invoiceBillsAttachsService.delete(invoiceBillsAttachsEntityWrapper);
            if (!delete) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "删除旧数据失败";
            }
            int line = 0;
            for (InvoiceBillsAttachs ib : invoiceBillsAttachsList) {
                line++;
                ib.setLineNo(line);
                boolean invoiceBillsAttachsListType = invoiceBillsAttachsService.insert(ib);
                if (!invoiceBillsAttachsListType) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "更新附件列表失败";
                }
            }
        }
        JSONArray jsonArray = JSONArray.parseArray(fapiao);
        List<InvoiceBillsItems> invoiceBillsItems = JSONObject.parseArray(jsonArray.toJSONString(), InvoiceBillsItems.class);
        if (invoiceBillsItems.size() != 0) {
            EntityWrapper<InvoiceBillsItems> invoiceBillsItemsEntityWrapper = new EntityWrapper<>();
            invoiceBillsItemsEntityWrapper.eq("bill_no", invoiceBills.getBillNo())
                    .eq("act_id", invoiceBills.getActId())
                    .eq("project_sub_no", invoiceBills.getProjectSubNo());
            boolean delete = invoiceBillsItemsService.delete(invoiceBillsItemsEntityWrapper);
            if (!delete) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "删除旧数据失败";
            }
            int line = 0;
            for (InvoiceBillsItems ib : invoiceBillsItems) {
                line++;
                ib.setLineNo(line);
                ib.setBranchId(invoiceBills.getBranchId());
                boolean invoiceBillsItemsListType = invoiceBillsItemsService.insert(ib);
                if (!invoiceBillsItemsListType) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "更新发票明细失败";
                }
            }
        }
        EntityWrapper<OtherProject> otherProjectEntityWrapper = new EntityWrapper<>();
        otherProjectEntityWrapper.eq("purchase_nc_no", invoiceBills.getPurchaseNcNo())
                .eq("project_sub_no", invoiceBills.getProjectSubNo())
                .eq("branch_id", invoiceBills.getBranchId());
        OtherProject otherProject = otherProjectService.selectOne(otherProjectEntityWrapper);
        if (otherProject == null) {
            OtherProject otherProjectInstall = otherProjectService.installOrUpdateOtherProject(invoiceBills, sysUserDto);
            if (invoiceBillsAttachs != null) {
                otherProjectInstall.setAttachId(invoiceBillsAttachs.getAttachId());
                otherProjectInstall.setAttachName(invoiceBillsAttachs.getAttachName());
            }
            boolean InstallType = otherProjectService.insert(otherProjectInstall);
            if (!InstallType) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "新建其他合同失败";
            }
        } else {
            otherProject.setContractTotalAmt(invoiceBills.getInvAmt() + otherProject.getContractTotalAmt());
            boolean otherProjectType = otherProjectService.updateById(otherProject);
            if (!otherProjectType) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "更新其他合同失败";
            }
        }
        String subType = invoiceBillsService.updateProjectPrice(invoiceBills);
        if (!"成功".equals(subType)) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return subType;
        }
//        if (invoiceBills.getIsSpecial() != 1) {
//            EntityWrapper<OtherProject> otherProjectEntityWrapper = new EntityWrapper<>();
//            otherProjectEntityWrapper.eq("purchase_nc_no", invoiceBills.getPurchaseNcNo());
//            OtherProject otherProject = otherProjectService.selectOne(otherProjectEntityWrapper);
//            if (otherProject == null) {
//                OtherProject otherProjectInstall = otherProjectService.installOrUpdateOtherProject(invoiceBills, sysUserDto);
//                if (invoiceBillsAttachs != null) {
//                    otherProjectInstall.setAttachId(invoiceBillsAttachs.getAttachId());
//                    otherProjectInstall.setAttachName(invoiceBillsAttachs.getAttachName());
//                }
//                boolean InstallType = otherProjectService.insert(otherProjectInstall);
//                if (!InstallType) {
//                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
//                    return "新建其他合同失败";
//                }
//            } else {
//                otherProject.setProjectSubNo(invoiceBills.getProjectSubNo());
//                otherProject.setContractTotalAmt(invoiceBills.getInvAmt() + otherProject.getContractTotalAmt());
//                boolean otherProjectType = otherProjectService.updateById(otherProject);
//                if (!otherProjectType) {
//                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
//                    return "更新其他合同失败";
//                }
//            }
//            String subType = invoiceBillsService.updateProjectPrice(invoiceBills);
//            if (!subType.equals("成功")) {
//                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
//                return subType;
//            }
//        } else {
//            invoiceBills.setBillStatus(4);
//            EntityWrapper<ProjectBillsSubs> subsEntityWrapper = new EntityWrapper<>();
//            subsEntityWrapper.eq("project_sub_no", invoiceBills.getProjectSubNo())
//                    .eq("branch_id", invoiceBills.getBranchId());
//            ProjectBillsSubs projectbillsDto = projectBillsSubsService.selectOne(subsEntityWrapper);
//            Audit audit = new Audit();
//            audit.setBillNo(invoiceBills.getBillNo());
//            audit.setActId(530);
//            audit.setLevelId(0);
//            audit.setIffinalItem("F");
//            audit.setSubJect(projectbillsDto.getProjectSubName());
//            audit.setProjectNo(invoiceBills.getProjectSubNo());
//            audit.setBranchId(projectbillsDto.getBranchId());
//            audit.setSendUserId(sysUserDto.getUserId().intValue());
//            audit.setSendName(sysUserDto.getUsername());
//            audit.setSendTime(new Date());
//            audit.setAuditUserId(sysUserDto.getUserId().intValue());
//            audit.setAuditItem(new Date());
//            audit.setAuditMsg("提交");
//            audit.setAuditStatus("O");
//            audit.setProjectMngId(projectbillsDto.getProjectSubMngId());
//            EntityWrapper<Projectbills> projectbillsEntityWrapper = new EntityWrapper<>();
//            projectbillsEntityWrapper.setSqlSelect("id", "project_leader").eq("bill_no", projectbillsDto.getBillNo())
//                    .eq("act_id", projectbillsDto.getActId());
//            Projectbills projectbills = projectbillsService.selectOne(projectbillsEntityWrapper);
//            if (projectbills != null) {
//                audit.setProjectLeader(projectbills.getProjectLeader());
//            }
//            boolean approvalFlow = auditItemsService.createApprovalFlow(audit);
//            if (!approvalFlow) {
//                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
//                return "审批流异常请检查提交信息";
//            }
//        }
        boolean invoiceBillsType = invoiceBillsService.insertOrUpdate(invoiceBills);
        if (!invoiceBillsType) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "新增其他款项——直接成本失败";
        }
        EntityWrapper<ProjectBillsBudgets> billsBudgetsEntityWrapper = new EntityWrapper<>();
        billsBudgetsEntityWrapper.eq("project_sub_no", invoiceBills.getProjectSubNo())
                .eq("branch_id", invoiceBills.getBranchId());
        List<ProjectBillsBudgets> projectBillsBudgets = projectBillsBudgetsService.selectList(billsBudgetsEntityWrapper);
        for (ProjectBillsBudgets pb : projectBillsBudgets) {
            if (Objects.equals(pb.getBudgetId(), invoiceBills.getBudgetId())) {
                pb.setApprovedAmount(pb.getApprovedAmount() + invoiceBills.getInvAmt());
                boolean update = projectBillsBudgetsService.updateById(pb);
                if (!update) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "更新预算失败";
                }
            }
        }
        double sum = projectBillsBudgetsService.selectApprovedAmountSum(projectBillsBudgets.get(0));
        EntityWrapper<ProjectBillsSubs> subsEntityWrapper = new EntityWrapper<>();
        subsEntityWrapper.eq("project_sub_no", invoiceBills.getProjectSubNo())
                .eq("branch_id", invoiceBills.getBranchId());
        ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(subsEntityWrapper);
        projectBillsSubs.setActualBudgetAmt(sum);
        boolean updateById = projectBillsSubsService.updateById(projectBillsSubs);
        if (!updateById) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "更新预算失败";
        }
        return "提交成功";
    }*/

    @Override
    @Transactional(rollbackFor = Exception.class)
    public String saveDirect(String zhu, String fapiao, String fujian, SysUserDto sysUserDto) { // InvoiceBillsAttachs
        InvoiceBills invoiceBills = JSONArray.parseObject(zhu, InvoiceBills.class);
        invoiceBills.setBranchId(sysUserDto.getLoginContractorId());
        InvoiceBillsAttachs invoiceBillsAttachs = new InvoiceBillsAttachs();
        JSONArray Attachs = JSONArray.parseArray(fujian);
        List<InvoiceBillsAttachs> invoiceBillsAttachsList = JSONObject.parseArray(Attachs.toJSONString(), InvoiceBillsAttachs.class);
        if (invoiceBillsAttachsList.size() != 0) {
            invoiceBillsAttachs = invoiceBillsAttachsList.get(0);
            EntityWrapper<InvoiceBillsAttachs> invoiceBillsAttachsEntityWrapper = new EntityWrapper<>();
            invoiceBillsAttachsEntityWrapper.eq("bill_no", invoiceBills.getBillNo())
                    .eq("act_id", invoiceBills.getActId());
            boolean delete = invoiceBillsAttachsService.delete(invoiceBillsAttachsEntityWrapper);
            if (!delete) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "删除旧数据失败";
            }
            int line = 0;
            for (InvoiceBillsAttachs ib : invoiceBillsAttachsList) {
                line++;
                ib.setLineNo(line);
                boolean invoiceBillsAttachsListType = invoiceBillsAttachsService.insert(ib);
                if (!invoiceBillsAttachsListType) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "更新附件列表失败";
                }
            }
        }
        JSONArray jsonArray = JSONArray.parseArray(fapiao);
        List<InvoiceBillsItems> invoiceBillsItems = JSONObject.parseArray(jsonArray.toJSONString(), InvoiceBillsItems.class);
        if (invoiceBillsItems.size() != 0) {
            EntityWrapper<InvoiceBillsItems> invoiceBillsItemsEntityWrapper = new EntityWrapper<>();
            invoiceBillsItemsEntityWrapper.eq("bill_no", invoiceBills.getBillNo())
                    .eq("act_id", invoiceBills.getActId())
                    .eq("project_sub_no", invoiceBills.getProjectSubNo())
                    .eq("branch_id", sysUserDto.getLoginContractorId());
            boolean delete = invoiceBillsItemsService.delete(invoiceBillsItemsEntityWrapper);
            if (!delete) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "删除旧数据失败";
            }
            int line = 0;
            for (InvoiceBillsItems ib : invoiceBillsItems) {
                line++;
                ib.setLineNo(line);
                ib.setProjectSubNo(invoiceBills.getProjectSubNo());
                ib.setBranchId(invoiceBills.getBranchId());
                boolean invoiceBillsItemsListType = invoiceBillsItemsService.insert(ib);
                if (!invoiceBillsItemsListType) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "更新发票明细失败";
                }
            }
        }
        EntityWrapper<OtherProject> otherProjectEntityWrapper = new EntityWrapper<>();
        otherProjectEntityWrapper.eq("purchase_nc_no", invoiceBills.getPurchaseNcNo())
                .eq("project_sub_no", invoiceBills.getProjectSubNo())
                .eq("branch_id", invoiceBills.getBranchId());
        OtherProject otherProject = otherProjectService.selectOne(otherProjectEntityWrapper);
        if (otherProject == null) {
            OtherProject otherProjectInstall = otherProjectService.installOrUpdateOtherProject(invoiceBills, sysUserDto);
            if (invoiceBillsAttachs != null) {
                otherProjectInstall.setAttachId(invoiceBillsAttachs.getAttachId());
                otherProjectInstall.setAttachName(invoiceBillsAttachs.getAttachName());
            }
            boolean InstallType = otherProjectService.insert(otherProjectInstall);
            if (!InstallType) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "新建其他合同失败";
            }
        } else {
            otherProject.setContractAmt(invoiceBills.getContractAmt());
            otherProject.setContractTotalAmt(DataUtils.keepDecimals(invoiceBills.getInvAmt() + otherProject.getContractTotalAmt()));
            boolean otherProjectType = otherProjectService.updateById(otherProject);
            if (!otherProjectType) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "更新其他合同失败";
            }
        }
        EntityWrapper<ProjectBillsSubs> subsEntityWrapper = new EntityWrapper<>();
        subsEntityWrapper.eq("project_sub_no", invoiceBills.getProjectSubNo())
                .eq("branch_id", invoiceBills.getBranchId());
        ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(subsEntityWrapper);

        String subType = invoiceBillsService.updateProjectPrice(invoiceBills);
        if (!"成功".equals(subType)) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return subType;
        }
        if (Objects.equals(invoiceBills.getIsSpecial(), 1)) {
            invoiceBills.setBillStatus(4);
            Audit audit = new Audit();
            audit.setBillNo(invoiceBills.getBillNo());
            audit.setActId(530);
            audit.setLevelId(0);
            audit.setIffinalItem("F");
            audit.setSubJect(projectBillsSubs.getProjectSubName());
            audit.setProjectNo(invoiceBills.getProjectSubNo());
            audit.setBranchId(projectBillsSubs.getApprovalBranchId());
            audit.setSendUserId(sysUserDto.getUserId().intValue());
            audit.setSendName(sysUserDto.getActualname());
            audit.setSendTime(new Date());
            audit.setAuditUserId(sysUserDto.getUserId().intValue());
            audit.setAuditItem(new Date());
            audit.setAuditMsg("提交");
            audit.setAuditStatus("O");
            audit.setProjectMngId(projectBillsSubs.getProjectSubMngId());
            EntityWrapper<Projectbills> projectbillsEntityWrapper = new EntityWrapper<>();
            projectbillsEntityWrapper.setSqlSelect("id", "project_leader").eq("bill_no", projectBillsSubs.getBillNo())
                    .eq("act_id", projectBillsSubs.getActId());
            Projectbills projectbills = projectbillsService.selectOne(projectbillsEntityWrapper);
            if (projectbills != null) {
                audit.setProjectLeader(projectbills.getProjectLeader());
            }
            boolean approvalFlow = auditItemsService.createApprovalFlow(audit);
            if (!approvalFlow) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "审批流异常请检查提交信息";
            }
        }
        boolean invoiceBillsType = invoiceBillsService.insertOrUpdate(invoiceBills);
        if (!invoiceBillsType) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "新增其他款项——直接成本失败";
        }
        return "提交成功";
    }
    /*审批版本*/
    /*public String saveDirect(String zhu, String fapiao, String fujian, SysUserDto sysUserDto) { // InvoiceBillsAttachs
        InvoiceBills invoiceBills = JSONArray.parseObject(zhu, InvoiceBills.class);
        invoiceBills.setBranchId(sysUserDto.getLoginContractorId());
        InvoiceBillsAttachs invoiceBillsAttachs = new InvoiceBillsAttachs();
        JSONArray Attachs = JSONArray.parseArray(fujian);
        List<InvoiceBillsAttachs> invoiceBillsAttachsList = JSONObject.parseArray(Attachs.toJSONString(), InvoiceBillsAttachs.class);
        if (invoiceBillsAttachsList.size() != 0) {
            invoiceBillsAttachs = invoiceBillsAttachsList.get(0);
            EntityWrapper<InvoiceBillsAttachs> invoiceBillsAttachsEntityWrapper = new EntityWrapper<>();
            invoiceBillsAttachsEntityWrapper.eq("bill_no", invoiceBills.getBillNo())
                    .eq("act_id", invoiceBills.getActId());
            boolean delete = invoiceBillsAttachsService.delete(invoiceBillsAttachsEntityWrapper);
            if (!delete) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "删除旧数据失败";
            }
            int line = 0;
            for (InvoiceBillsAttachs ib : invoiceBillsAttachsList) {
                line++;
                ib.setLineNo(line);
                boolean invoiceBillsAttachsListType = invoiceBillsAttachsService.insert(ib);
                if (!invoiceBillsAttachsListType) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "更新附件列表失败";
                }
            }
        }
        JSONArray jsonArray = JSONArray.parseArray(fapiao);
        List<InvoiceBillsItems> invoiceBillsItems = JSONObject.parseArray(jsonArray.toJSONString(), InvoiceBillsItems.class);
        if (invoiceBillsItems.size() != 0) {
            EntityWrapper<InvoiceBillsItems> invoiceBillsItemsEntityWrapper = new EntityWrapper<>();
            invoiceBillsItemsEntityWrapper.eq("bill_no", invoiceBills.getBillNo())
                    .eq("act_id", invoiceBills.getActId())
                    .eq("project_sub_no", invoiceBills.getProjectSubNo());
            boolean delete = invoiceBillsItemsService.delete(invoiceBillsItemsEntityWrapper);
            if (!delete) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "删除旧数据失败";
            }
            int line = 0;
            for (InvoiceBillsItems ib : invoiceBillsItems) {
                line ++;
                ib.setLineNo(line);
                ib.setBranchId(invoiceBills.getBranchId());
                boolean invoiceBillsItemsListType = invoiceBillsItemsService.insert(ib);
                if (!invoiceBillsItemsListType) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "更新发票明细失败";
                }
            }
        }

        if (invoiceBills.getIsSpecial() != 1) {
            EntityWrapper<OtherProject> otherProjectEntityWrapper = new EntityWrapper<>();
            otherProjectEntityWrapper.eq("purchase_nc_no", invoiceBills.getPurchaseNcNo());
            OtherProject otherProject = otherProjectService.selectOne(otherProjectEntityWrapper);
            if (otherProject == null) {
                OtherProject otherProjectInstall = otherProjectService.installOrUpdateOtherProject(invoiceBills, sysUserDto);
                if (invoiceBillsAttachs != null) {
                    otherProjectInstall.setAttachId(invoiceBillsAttachs.getAttachId());
                    otherProjectInstall.setAttachName(invoiceBillsAttachs.getAttachName());
                }
                boolean InstallType = otherProjectService.insert(otherProjectInstall);
                if (!InstallType) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "新建其他合同失败";
                }
            } else {
                otherProject.setProjectSubNo(invoiceBills.getProjectSubNo());
                otherProject.setContractTotalAmt(invoiceBills.getInvAmt() + otherProject.getContractTotalAmt());
                boolean otherProjectType = otherProjectService.updateById(otherProject);
                if (!otherProjectType) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "更新其他合同失败";
                }
            }
            String subType = invoiceBillsService.updateProjectPrice(invoiceBills);
            if (!subType.equals("成功")) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return subType;
            }
        } else {
            invoiceBills.setBillStatus(4);
            EntityWrapper<ProjectBillsSubs> subsEntityWrapper = new EntityWrapper<>();
            subsEntityWrapper.eq("project_sub_no", invoiceBills.getProjectSubNo())
                    .eq("branch_id", invoiceBills.getBranchId());
            ProjectBillsSubs projectbillsDto = projectBillsSubsService.selectOne(subsEntityWrapper);
            Audit audit = new Audit();
            audit.setBillNo(invoiceBills.getBillNo());
            audit.setActId(530);
            audit.setLevelId(0);
            audit.setIffinalItem("F");
            audit.setSubJect(projectbillsDto.getProjectSubName());
            audit.setProjectNo(invoiceBills.getProjectSubNo());
            audit.setBranchId(projectbillsDto.getBranchId());
            audit.setSendUserId(sysUserDto.getUserId().intValue());
            audit.setSendName(sysUserDto.getUsername());
            audit.setSendTime(new Date());
            audit.setAuditUserId(sysUserDto.getUserId().intValue());
            audit.setAuditItem(new Date());
            audit.setAuditMsg("提交");
            audit.setAuditStatus("O");
            audit.setProjectMngId(projectbillsDto.getProjectSubMngId());
            EntityWrapper<Projectbills> projectbillsEntityWrapper = new EntityWrapper<>();
            projectbillsEntityWrapper.setSqlSelect("id", "project_leader").eq("bill_no", projectbillsDto.getBillNo())
                    .eq("act_id", projectbillsDto.getActId());
            Projectbills projectbills = projectbillsService.selectOne(projectbillsEntityWrapper);
            if (projectbills != null) {
                audit.setProjectLeader(projectbills.getProjectLeader());
            }
            boolean approvalFlow = auditItemsService.createApprovalFlow(audit);
            if (!approvalFlow) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "审批流异常请检查提交信息";
            }
        }
        boolean invoiceBillsType = invoiceBillsService.insertOrUpdate(invoiceBills);
        if (!invoiceBillsType) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "新增其他款项——直接成本失败";
        }
        return "提交成功";
    }*/

    @Override
    public Map<String, Object> selectDirect(Integer id, SysUserDto sysUserDto) {
        Map<String, Object> map = new HashMap<>();
        InvoiceBills invoiceBills = invoiceBillsService.selectById(id);
        EntityWrapper<InvoiceBillsItems> invoiceBillsItemsEntityWrapper = new EntityWrapper<>();
        invoiceBillsItemsEntityWrapper.eq("bill_no", invoiceBills.getBillNo());
        EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
        projectBillsSubsEntityWrapper.eq("project_sub_no", invoiceBills.getProjectSubNo())
                .eq("branch_id", invoiceBills.getBranchId());
        ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
        EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
        projectBillsBudgetsEntityWrapper.eq("project_sub_no", invoiceBills.getProjectSubNo())
                .eq("branch_id", invoiceBills.getBranchId());
        EntityWrapper<Projectbills> projectbillsEntityWrapper = new EntityWrapper<>();
        projectbillsEntityWrapper.eq("bill_no", projectBillsSubs.getBillNo())
                .eq("branch_id", invoiceBills.getBranchId());
        Projectbills projectbills = projectbillsService.selectOne(projectbillsEntityWrapper);
        EntityWrapper<InvoiceBillsAttachs> invoiceBillsAttachsEntityWrapper = new EntityWrapper<>();
        invoiceBillsAttachsEntityWrapper.eq("bill_no", invoiceBills.getBillNo())
                .eq("act_id", 116);
        Bdepts bdepts = bdeptsService.selectById(sysUserDto.getDeptId());
        if (bdepts != null) {
            map.put("deptName", bdepts.getDeptName());
        }
        map.put("bills", invoiceBills);
        map.put("project", projectbills);
        map.put("projectType", bprojectTypesService.selectById(projectbills.getProjectTypeId()));
        map.put("purchase", bpurchasesService.selectById(invoiceBills.getPurchaseId()));
        map.put("branch", bbranchsService.selectById(invoiceBills.getBranchId()));
        map.put("corp", bcorpsService.selectById(projectBillsSubs.getCorpId()));
        map.put("sub", projectBillsSubs);
        map.put("invoiceItem", invoiceBillsItemsService.selectList(invoiceBillsItemsEntityWrapper));
        map.put("budget", projectBillsBudgetsService.selectList(projectBillsBudgetsEntityWrapper));
        map.put("attachsList", invoiceBillsAttachsService.selectList(invoiceBillsAttachsEntityWrapper));
        return map;
    }

    @Override
    public List<Map<String, Object>> selectPayDrData(SysUserDto sysUserDto) {
        return payDrBillsItemsService.selectPayDrData(sysUserDto);
    }

    @Override
    public List<Map<String, Object>> selectPayDrDataCount(SysUserDto sysUserDto) {
        return payDrBillsItemsService.selectPayDrDataCount(sysUserDto);
    }

    @Override
    public List<Map<String, Object>> selectPayDrTopData(String name, Integer typeId, SysUserDto sysUserDto) {
        List<Map<String, Object>> topDataList;
        if (name == null) {
            topDataList = payDrBillsItemsService.selectPayDrTopData(0, 1, typeId, sysUserDto);
            return topDataList;
        }
        switch (name) {
            case "1-30日":
                topDataList = payDrBillsItemsService.selectPayDrTopData(30, 0, typeId, sysUserDto);
                break;
            case "30-90日":
                topDataList = payDrBillsItemsService.selectPayDrTopData(30, 90, typeId, sysUserDto);
                return topDataList;
            case "90-180日":
                topDataList = payDrBillsItemsService.selectPayDrTopData(90, 180, typeId, sysUserDto);
                break;
            case "180-360日":
                topDataList = payDrBillsItemsService.selectPayDrTopData(180, 360, typeId, sysUserDto);
                break;
            case "360日以上":
                topDataList = payDrBillsItemsService.selectPayDrTopData(0, 360, typeId, sysUserDto);
                break;
            default:
                topDataList = payDrBillsItemsService.selectPayDrTopData(0, 1, typeId, sysUserDto);
                break;
        }
        return topDataList;
    }

    @Override
    public List<Map<String, Object>> selectPayDyAllAmt() {
        return payDrBillsItemsService.selectPayDyAllAmt();
    }

    @Override
    public Map<String, Object> selectSubAmtCrAndDr(SysUserDto sysUserDto) {
        return payDrBillsItemsService.selectSubAmtCrAndDr(sysUserDto);
    }

    @Override
    public List<Map<String, Object>> selectBranchSubProjectAmt(SysUserDto sysUserDto) {
        return payDrBillsItemsService.selectBranchSubProjectAmt(sysUserDto);
    }

    @Override
    public List<Long> selectAllDrInterestRate(SysUserDto sysUserDto) {
        return payDrBillsItemsService.selectAllDrInterestRate(sysUserDto);
    }
}
