
package io.platform.moneyManagement.service.client.impl;

import com.alibaba.dubbo.config.annotation.Service;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;


import io.platform.engineering.biz.entity.Bbranchs;
import io.platform.engineering.biz.entity.Bcorps;
import io.platform.engineering.biz.entity.Bdepts;
import io.platform.engineering.biz.service.BbranchsService;
import io.platform.engineering.biz.service.BcorpsService;
import io.platform.engineering.biz.service.BdeptsService;
import io.platform.moneyManagement.biz.entity.InvoiceBills;
import io.platform.moneyManagement.biz.entity.PayDrBills;
import io.platform.moneyManagement.biz.entity.PayDrBillsItems;
import io.platform.moneyManagement.biz.service.InvoiceBillsService;
import io.platform.moneyManagement.biz.service.PayDrBillsItemsService;
import io.platform.moneyManagement.biz.service.PayDrBillsService;
import io.platform.moneyManagement.dto.PayDrBillsDto;
import io.platform.moneyManagement.service.client.api.PayDrBillsServiceClient;
import io.platform.project.biz.entity.ProjectBillsSubs;
import io.platform.project.biz.service.ProjectBillsSubsService;
import io.platform.project.biz.service.SubContractBillsService;
import io.platform.project.dto.ProjectBillsSubsDto;
import io.platform.sys.biz.entity.SysRole;
import io.platform.sys.dto.SysUserDto;
import io.platform.utils.DataUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.*;

import io.platform.base.common.BaseServiceClient;
import io.platform.base.common.utils.ExecuteResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;

/**
 * Created by sevelli on 2017/8/31.
 */
@Component
@Service(version = "1.0.0", interfaceClass = PayDrBillsServiceClient.class)
public class PayDrBillsServiceClientImpl extends BaseServiceClient<PayDrBills, PayDrBillsDto> implements PayDrBillsServiceClient {
    private Logger logger = LoggerFactory.getLogger(getClass());
    @Resource
    private BdeptsService bdeptsService;
    @Resource
    private BcorpsService bcorpsService;
    @Resource
    private BbranchsService bbranchsService;
    @Resource
    private PayDrBillsItemsService payDrBillsItemsService;
    @Resource
    private PayDrBillsService payDrBillsService;
    @Resource
    private ProjectBillsSubsService projectBillsSubsService;
    @Resource
    private InvoiceBillsService invoiceBillsService;
    @Resource
    private SubContractBillsService subContractBillsService;

    @Override
    public PayDrBillsDto queryObject(Long id) {
        PayDrBills payDrBills = payDrBillsService.selectById(id);
        PayDrBillsDto payDrBillsDto = new PayDrBillsDto();
        BeanUtils.copyProperties(payDrBills, payDrBillsDto);
        return payDrBillsDto;
    }

    @Override
    public List<PayDrBillsDto> queryList(Map<String, Object> map) {
        List<PayDrBills> payDrBillsList = payDrBillsService.selectByMap(map);
        return convertList(payDrBillsList, PayDrBillsDto.class);
    }

    @Override
    public int queryTotal(Map<String, Object> map) {
        EntityWrapper<PayDrBills> ew = new EntityWrapper<>();
        ew.allEq(map);
        return payDrBillsService.selectCount(ew);
    }

    @Override
    public ExecuteResult<String> save(PayDrBillsDto payDrBillsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            PayDrBills payDrBills = new PayDrBills();
            revert(payDrBillsDto, payDrBills);
            boolean flag = payDrBillsService.insert(payDrBills);
            if (!flag) {
                result.addErrorMessage("保存失败。");
            }
        } catch (Exception e) {
            logger.error(" 保存错误：" + e.toString(), e);
            result.addErrorMessage("保存错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> update(PayDrBillsDto payDrBillsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            PayDrBills payDrBills = new PayDrBills();
            revert(payDrBillsDto, payDrBills);

            boolean flag = payDrBillsService.updateById(payDrBills);
            if (!flag) {
                result.addErrorMessage("更新失败。");
            }
        } catch (Exception e) {
            logger.error(" 更新错误：" + e.toString(), e);
            result.addErrorMessage("更新错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> delete(Long id) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = payDrBillsService.deleteById(id);
            if (!flag) {
                result.addErrorMessage("删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> deletePayDr(PayDrBillsDto payDrBillsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            if (payDrBillsDto != null && payDrBillsDto.getId() != null) {
                EntityWrapper<PayDrBills> entityWrapper = new EntityWrapper<>();
                entityWrapper.setSqlSelect("id", "bill_no", "bill_status").eq("id", payDrBillsDto.getId()).eq("act_id", 108);
                PayDrBills drBills = payDrBillsService.selectOne(entityWrapper);
                if (Objects.equals(drBills.getBillStatus(), 6)) {
                    result.addErrorMessage("已提交不允许删除");
                    return result;
                }
                EntityWrapper<PayDrBillsItems> payDrBillsItemsEntityWrapper = new EntityWrapper<>();
                payDrBillsItemsEntityWrapper.setSqlSelect("id").eq("bill_no", drBills.getBillNo()).eq("act_id", 108);
                List<PayDrBillsItems> payDrBillsItems = payDrBillsItemsService.selectList(payDrBillsItemsEntityWrapper);
                if (payDrBillsItems.size() != 0) {
                    for (PayDrBillsItems pd : payDrBillsItems) {
                        boolean deleteById = payDrBillsItemsService.deleteById(pd);
                        if (!deleteById) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("删除明细失败");
                            return result;
                        }
                    }
                }
                boolean deleteById = payDrBillsService.deleteById(drBills);
                if (!deleteById) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("删除收款记录失败");
                    return result;
                }
            } else {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("未获取信息 请确认后提交");
                return result;
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除失败");
        }
        return result;
    }

    @Override
    public Map<String, Object> getPage(Map<String, Object> map, SysUserDto sysUserDto) {
        Map<String, Object> objectMap = new HashMap<>();
        SysRole sysRole = subContractBillsService.selectRole(sysUserDto);
        map.put("user", sysUserDto);
        map.put("role", sysRole);
        try {
            int num = payDrBillsService.selectProStlTotal(map);
            if (num != 0) {
                int current = (int) map.get("current");
                int size = (int) map.get("size");
                if (current <= 1) {
                    current = 0;
                } else {
                    current = (current - 1) * size;
                }
                map.put("size", size);
                map.put("current", current);
                List<Map<String, Object>> mapList = payDrBillsService.selectProStlRecords(map);
                Page pageDto = new Page<>();
                pageDto.setTotal(num);
                pageDto.setRecords(mapList);
                objectMap.put("page", pageDto);
            }
            return objectMap;
        } catch (Exception e) {
            logger.error("操作异常：" + e.toString(), e);
        }
        return null;
    }

    @Override
    public Map<String, Object> changeFuzzyQueryPayDr(ProjectBillsSubsDto projectBillsSubsDto) {
        if (projectBillsSubsDto != null) {
            Map<String, Object> map = new HashMap<>();
            map.put("proSub", projectBillsSubsDto);
            EntityWrapper<Bbranchs> bbranchsEntityWrapper = new EntityWrapper<>();
            bbranchsEntityWrapper.setSqlSelect("id", "c_name");
            List<Bbranchs> bbranchsList = bbranchsService.selectList(bbranchsEntityWrapper);
            if (bbranchsList != null) {
                map.put("branchs", bbranchsList);
            }
            return map;
        }
        return null;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> payDrTemporary(String payDr, String payDrItems, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            PayDrBills payDrBills = JSONArray.parseObject(payDr, PayDrBills.class);
            JSONArray jsonArray = JSONArray.parseArray(payDrItems);
            List<PayDrBillsItems> payDrBillsItems = JSONObject.parseArray(jsonArray.toJSONString(), PayDrBillsItems.class);
            if (payDrBills != null) {
                EntityWrapper<PayDrBills> payDrBillsEntityWrapper = new EntityWrapper<>();
                payDrBillsEntityWrapper.setSqlSelect("id").eq("bill_no", payDrBills.getBillNo());
                PayDrBills drBills = payDrBillsService.selectOne(payDrBillsEntityWrapper);
                if (drBills != null) {
                    drBills.setBillStatus(2);
                    drBills.setOpUserId(sysUserDto.getUserId().intValue());
                    drBills.setOpUserName(sysUserDto.getUsername());
                    drBills.setCreateDate(new Date());
                    drBills.setPostDate(new Date());
                    drBills.setBillDate(payDrBills.getBillDate());
                    drBills.setRemarks(payDrBills.getRemarks());
                    drBills.setBranchId(sysUserDto.getLoginContractorId());
                    drBills.setCorpId(payDrBills.getCorpId());
                    drBills.setStlAmt(payDrBills.getStlAmt());
                    boolean update = payDrBillsService.updateById(drBills);
                    if (!update) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：更新收款记录失败。");
                        return result;
                    }
                } else {
                    payDrBills.setBillStatus(2);
                    payDrBills.setActId(108);
                    payDrBills.setBranchId(sysUserDto.getLoginContractorId());
                    payDrBills.setOpUserId(sysUserDto.getUserId().intValue());
                    payDrBills.setOpUserName(sysUserDto.getUsername());
                    payDrBills.setCreateDate(new Date());
                    payDrBills.setPostDate(new Date());
                    if (payDrBills.getBillDate() == null) {
                        payDrBills.setBillDate(new Date());
                    }
                    boolean insert = payDrBillsService.insert(payDrBills);
                    if (!insert) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：新建收款记录失败。");
                        return result;
                    }
                }
                if (payDrBillsItems.size() != 0) {
                    EntityWrapper<PayDrBillsItems> payDrBillsItemsEntityWrapper = new EntityWrapper<>();
                    payDrBillsItemsEntityWrapper.setSqlSelect("id").eq("bill_no", payDrBills.getBillNo());
                    List<PayDrBillsItems> billsItems = payDrBillsItemsService.selectList(payDrBillsItemsEntityWrapper);
                    if (billsItems.size() != 0) {
                        for (PayDrBillsItems pd : billsItems) {
                            boolean deleteById = payDrBillsItemsService.deleteById(pd);
                            if (!deleteById) {
                                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                result.addErrorMessage("提交失败：删除明细失败。");
                                return result;
                            }
                        }
                    }
                    int line = 0;
                    for (PayDrBillsItems pd : payDrBillsItems) {
                        line++;
                        pd.setBillNo(payDrBills.getBillNo());
                        pd.setLineNo(line);
                        pd.setActId(108);
                        boolean insert = payDrBillsItemsService.insert(pd);
                        if (!insert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：新建记录明细失败。");
                            return result;
                        }
                    }
                }
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 提交失败：" + e.toString(), e);
            result.addErrorMessage("提交失败");
        }
        return result;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> payDrSave(String payDr, String payDrItems, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            PayDrBills payDrBills = JSONArray.parseObject(payDr, PayDrBills.class);
            JSONArray jsonArray = JSONArray.parseArray(payDrItems);
            List<PayDrBillsItems> payDrBillsItems = JSONObject.parseArray(jsonArray.toJSONString(), PayDrBillsItems.class);
            if (payDrBills != null) {
                EntityWrapper<PayDrBills> payDrBillsEntityWrapper = new EntityWrapper<>();
                payDrBillsEntityWrapper.setSqlSelect("id").eq("bill_no", payDrBills.getBillNo());
                PayDrBills drBills = payDrBillsService.selectOne(payDrBillsEntityWrapper);
                payDrBills.setBillStatus(6);
                payDrBills.setActId(108);
                payDrBills.setBranchId(sysUserDto.getLoginContractorId());
                payDrBills.setOpUserId(sysUserDto.getUserId().intValue());
                payDrBills.setOpUserName(sysUserDto.getUsername());
                payDrBills.setCreateDate(new Date());
                payDrBills.setPostDate(new Date());
                if (payDrBills.getBillDate() == null) {
                    payDrBills.setBillDate(new Date());
                }
                boolean insert = payDrBillsService.insertOrUpdate(payDrBills);
                if (!insert) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：新建收款记录失败。");
                    return result;
                }
                if (payDrBillsItems.size() != 0) {
                    EntityWrapper<PayDrBillsItems> payDrBillsItemsEntityWrapper = new EntityWrapper<>();
                    payDrBillsItemsEntityWrapper.eq("bill_no", payDrBills.getBillNo())
                            .eq("branch_id", payDrBills.getBranchId());
                    boolean deleteById = payDrBillsItemsService.delete(payDrBillsItemsEntityWrapper);
                    if (!deleteById) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：删除明细失败。");
                        return result;
                    }
                    int line = 0;
                    for (PayDrBillsItems pd : payDrBillsItems) {
                        line++;
                        pd.setBillNo(payDrBills.getBillNo());
                        pd.setLineNo(line);
                        pd.setActId(108);
                        boolean insertPayDr = payDrBillsItemsService.insert(pd);
                        if (!insertPayDr) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：新建记录明细失败。");
                            return result;
                        }
                    }
                }
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 提交失败：" + e.toString(), e);
            result.addErrorMessage("提交失败");
        }
        return result;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> editAffirmStatus(PayDrBillsDto payDrBillsDto, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            if (payDrBillsDto != null && payDrBillsDto.getId() != null) {
                PayDrBills drBills = payDrBillsService.selectById(payDrBillsDto.getId());
                if ("T".equals(payDrBillsDto.getConfirmStatus())) {
                    EntityWrapper<PayDrBillsItems> payDrBillsItemsEntityWrapper = new EntityWrapper<>();
                    payDrBillsItemsEntityWrapper.eq("bill_no", payDrBillsDto.getBillNo())
                            .eq("branch_id", payDrBillsDto.getBranchId());
                    List<PayDrBillsItems> payDrBillsItems = payDrBillsItemsService.selectList(payDrBillsItemsEntityWrapper);
                    for (PayDrBillsItems pb : payDrBillsItems) {
                        EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
                        projectBillsSubsEntityWrapper.eq("project_sub_no", pb.getProjectSubNo())
                                .eq("branch_id", pb.getBranchId());
                        ProjectBillsSubs billsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
                        if (Objects.equals(drBills.getIsRefund(), 0)) {
                            billsSubs.setSubAmtDr(DataUtils.keepDecimals(billsSubs.getSubAmtDr() + pb.getStlAmt()));
                        } else {
                            billsSubs.setSubAmtDr(DataUtils.keepDecimals(billsSubs.getSubAmtDr() - pb.getStlAmt()));
                        }
                        boolean updateById = projectBillsSubsService.updateById(billsSubs);
                        if (!updateById) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：更新累计收款失败。");
                            return result;
                        }
                        EntityWrapper<InvoiceBills> invoiceBillsEntityWrapper = new EntityWrapper<>();
                        invoiceBillsEntityWrapper.eq("project_sub_no", pb.getProjectSubNo())
                                .eq("act_id", 107)
                                .orderBy("post_date", true);
                        List<InvoiceBills> invoiceBillsList = invoiceBillsService.selectList(invoiceBillsEntityWrapper);
                        double invAmt = pb.getStlAmt();
                        for (InvoiceBills invoiceBills : invoiceBillsList) { // 冲抵收款发票金额
                            double amt = invoiceBills.getInvAmt() - invoiceBills.getSettledDr();
                            if (amt != 0.0) {
                                if (invAmt <= amt) {
                                    invoiceBills.setSettledDr(invoiceBills.getSettledDr() + invAmt);
                                    invoiceBillsService.updateById(invoiceBills);
                                    break;
                                } else {
                                    invoiceBills.setSettledDr(invoiceBills.getSettledDr() + amt);
                                    invAmt = invAmt - amt;
                                    boolean updateInvoiceBillsType = invoiceBillsService.updateById(invoiceBills);
                                    if (!updateInvoiceBillsType) {
                                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                        result.addErrorMessage("提交失败：冲抵发票金额失败。");
                                        return result;
                                    }
                                }
                            }
                        }
                    }
                    payDrBillsDto.setUserId(sysUserDto.getUserId().intValue());
                    payDrBillsDto.setUserName(sysUserDto.getUsername());
                    payDrBillsDto.setAffirmantDate(new Date());
                    int editStatus = payDrBillsService.editAffirmStatus(payDrBillsDto);
                    if (editStatus != 1) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("确认失败请重新编辑提交");
                        return result;
                    }
                } else if ("S".equals(payDrBillsDto.getConfirmStatus())) {
                    drBills.setAffirmantRemarks(payDrBillsDto.getAffirmantRemarks());
                    drBills.setConfirmStatus(payDrBillsDto.getConfirmStatus());
                    int editProSubStatus = payDrBillsService.editProSubStatus(drBills);
                    if (editProSubStatus != 1) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("确认失败请重新编辑提交");
                        return result;
                    }
                }
                return result;
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 提交错误：" + e.toString(), e);
            result.addErrorMessage("提交失败");
            return result;
        }
        return result;
    }

    @Override
    public Map<String, Object> selectAll(Page<PayDrBillsDto> page, PayDrBillsDto payDrBillsDto, SysUserDto sysUserDto) {
        Map<String, Object> map = new HashMap<>();
        SysRole sysRole = subContractBillsService.selectRole(sysUserDto);
        map.put("user", sysUserDto);
        map.put("role", sysRole);
        map.put("dto", payDrBillsDto);
        int total = payDrBillsService.billsDrPageTotal(map);
        if (total != 0) {
            Page pageDto = DataUtils.processingPage(page);
            map.put("page", pageDto);
            List<Map<String, Object>> list = payDrBillsService.billsDrPage(map);
            Map<String, Object> mapRuste = new HashMap<>();
            pageDto.setTotal(total);
            pageDto.setRecords(list);
            mapRuste.put("page", pageDto);
        }
        return map;
    }

    @Override
    public Map<String, Object> selectPrintInformation(PayDrBillsDto payDrBillsDto, SysUserDto sysUserDto) {
        if (payDrBillsDto.getId() != null) {
            Map<String, Object> objectMap = payDrBillsService.selectPayDrFundpay(payDrBillsDto.getId());
            PayDrBills payDrBills = payDrBillsService.selectById(payDrBillsDto.getId());
            if (sysUserDto.getDeptId() != null) {
                Bdepts bdepts = bdeptsService.selectById(sysUserDto.getDeptId());
                objectMap.put("deptName", bdepts.getDeptName());
            }
            objectMap.put("payDr", payDrBills);
            return objectMap;
        } else {
            return null;
        }
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> updatePayCrIndirectPrint(PayDrBillsDto payDrBillsDto, PayDrBillsDto payDrBillsDto1) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        PayDrBills payDrBills = payDrBillsService.selectById(payDrBillsDto.getId());
        if (payDrBills.getPrintedCount() == null) {
            payDrBills.setPrintedCount(1);
        } else {
            payDrBills.setPrintedCount(payDrBills.getPrintedCount() + 1);
        }
        payDrBills.setPrintedUser(payDrBillsDto.getPrintedUser());
        if (payDrBillsDto.getPrintQrCode() != null) {
            payDrBills.setPrintQrCode(payDrBillsDto.getPrintQrCode());
        }
        boolean update = payDrBillsService.updateById(payDrBills);
        if (!update) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            result.addErrorMessage("确认失败请重新编辑提交");
            return result;
        }
        return result;
    }

    @Override
    public Map<String, Object> queryPayTemporary(PayDrBillsDto payDrBillsDto) {
        if (payDrBillsDto != null && payDrBillsDto.getId() != null) {
            EntityWrapper<PayDrBills> entityWrapper = new EntityWrapper<>();
            entityWrapper.eq("id", payDrBillsDto.getId());
            PayDrBills drBills = payDrBillsService.selectOne(entityWrapper);
            Map<String, Object> map = new HashMap<>();
            EntityWrapper<PayDrBillsItems> payDrBillsItemsEntityWrapper = new EntityWrapper<>();
            payDrBillsItemsEntityWrapper.setSqlSelect("id", "bill_no", "remarks", "project_sub_no", "branch_id", "inv_total_amt",
                    "inv_total_rate", "stl_amt", "stl_total_amt", "stl_total_rate").eq("bill_no", drBills.getBillNo());
            List<PayDrBillsItems> payDrBillsItems = payDrBillsItemsService.selectList(payDrBillsItemsEntityWrapper);
            if (payDrBillsItems.size() != 0) {
                List<ProjectBillsSubs> projectBillsSubsList = new ArrayList<>();
                for (PayDrBillsItems pb : payDrBillsItems) {
                    EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
                    projectBillsSubsEntityWrapper.eq("project_sub_no", pb.getProjectSubNo());
                    ProjectBillsSubs billsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
                    if (billsSubs != null) {
                        projectBillsSubsList.add(billsSubs);
                    }
                }
                map.put("proSubs", projectBillsSubsList);
                map.put("payDr", drBills);
                map.put("payItems", payDrBillsItems);
                List<Integer> integers = new ArrayList<>();
                List<Bbranchs> bbranchs = new ArrayList<>();
                integers.add(drBills.getBranchId());
                for (PayDrBillsItems pb : payDrBillsItems) {
                    if (pb.getBranchId() != null && pb.getBranchId() != 0) {
                        integers.add(pb.getBranchId());
                    }
                }
                List<Integer> integerList = DataUtils.integerDeduplication(integers);
                if (integerList.size() != 0) {
                    for (Integer i : integerList) {
                        EntityWrapper<Bbranchs> bbranchsEntityWrapper = new EntityWrapper<>();
                        bbranchsEntityWrapper.setSqlSelect("id", "c_name").eq("id", i);
                        Bbranchs bran = bbranchsService.selectOne(bbranchsEntityWrapper);
                        if (bran != null) {
                            bbranchs.add(bran);
                        }
                    }
                    map.put("branchs", bbranchs);
                }
                EntityWrapper<Bcorps> bcorpsEntityWrapper = new EntityWrapper<>();
                bcorpsEntityWrapper.setSqlSelect("id", "c_name").eq("id", drBills.getCorpId());
                Bcorps bcorps = bcorpsService.selectOne(bcorpsEntityWrapper);
                if (bcorps != null) {
                    map.put("corp", bcorps);
                }
                return map;
            }

        }
        return null;
    }


}
