
package io.platform.progressConfiguration.service.client.impl;

import com.alibaba.dubbo.config.annotation.Service;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;

import io.platform.contract.biz.entity.ProjectBillsStlPlans;
import io.platform.engineering.biz.entity.BprojectNodeSteps;
import io.platform.engineering.biz.entity.BprojectNodes;
import io.platform.engineering.biz.entity.BprojectTypes;
import io.platform.engineering.biz.entity.BprojectTypesItems;
import io.platform.engineering.biz.service.BprojectNodeStepsService;
import io.platform.engineering.biz.service.BprojectNodesService;
import io.platform.engineering.biz.service.BprojectTypesItemsService;
import io.platform.engineering.biz.service.BprojectTypesService;
import io.platform.progressConfiguration.biz.entity.ProjectNodeNexus;
import io.platform.progressConfiguration.biz.entity.ProjectNodeNexusItem;
import io.platform.progressConfiguration.biz.service.ProjectNodeNexusItemService;
import io.platform.progressConfiguration.biz.service.ProjectNodeNexusService;
import io.platform.progressConfiguration.dto.ProjectNodeNexusDto;
import io.platform.progressConfiguration.service.client.api.ProjectNodeNexusServiceClient;
import io.platform.project.biz.entity.Projectbills;
import io.platform.project.service.client.api.ProjectbillsServiceClient;
import io.platform.sys.dto.SysUserDto;
import io.platform.utils.DataUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import io.platform.base.common.BaseServiceClient;
import io.platform.base.common.utils.ExecuteResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;

/**
 * Created by sevelli on 2017/8/31.
 */
@Component
@Service(version = "1.0.0", interfaceClass = ProjectNodeNexusServiceClient.class)
public class ProjectNodeNexusServiceClientImpl extends BaseServiceClient<ProjectNodeNexus, ProjectNodeNexusDto> implements ProjectNodeNexusServiceClient {
    private Logger logger = LoggerFactory.getLogger(getClass());
    @Resource
    private BprojectTypesService bprojectTypesService;
    @Resource
    private BprojectNodesService bprojectNodesService;
    @Resource
    private ProjectNodeNexusService projectNodeNexusService;
    @Resource
    private BprojectNodeStepsService bprojectNodeStepsService;
    @Resource
    private BprojectTypesItemsService bprojectTypesItemsService;
    @Resource
    private ProjectNodeNexusItemService projectNodeNexusItemService;

    @Override
    public ProjectNodeNexusDto queryObject(Long id) {
        ProjectNodeNexus projectNodeNexus = projectNodeNexusService.selectById(id);
        ProjectNodeNexusDto projectNodeNexusDto = new ProjectNodeNexusDto();
        BeanUtils.copyProperties(projectNodeNexus, projectNodeNexusDto);
        return projectNodeNexusDto;
    }

    @Override
    public List<ProjectNodeNexusDto> queryList(Map<String, Object> map) {
        List<ProjectNodeNexus> projectNodeNexusList = projectNodeNexusService.selectByMap(map);
        return convertList(projectNodeNexusList, ProjectNodeNexusDto.class);
    }

    @Override
    public int queryTotal(Map<String, Object> map) {
        EntityWrapper<ProjectNodeNexus> ew = new EntityWrapper<>();
        ew.allEq(map);
        return projectNodeNexusService.selectCount(ew);
    }

    @Override
    public ExecuteResult<String> save(ProjectNodeNexusDto projectNodeNexusDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            ProjectNodeNexus projectNodeNexus = new ProjectNodeNexus();
            revert(projectNodeNexusDto, projectNodeNexus);
            boolean flag = projectNodeNexusService.insert(projectNodeNexus);
            if (!flag) {
                result.addErrorMessage("保存失败。");
            }
        } catch (Exception e) {
            logger.error(" 保存错误：" + e.toString(), e);
            result.addErrorMessage("保存错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> update(ProjectNodeNexusDto projectNodeNexusDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            ProjectNodeNexus projectNodeNexus = new ProjectNodeNexus();
            revert(projectNodeNexusDto, projectNodeNexus);

            boolean flag = projectNodeNexusService.updateById(projectNodeNexus);
            if (!flag) {
                result.addErrorMessage("更新失败。");
            }
        } catch (Exception e) {
            logger.error(" 更新错误：" + e.toString(), e);
            result.addErrorMessage("更新错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> delete(Long id) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = projectNodeNexusService.deleteById(id);
            if (!flag) {
                result.addErrorMessage("删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = projectNodeNexusService.deleteBatchIds(ids);
            if (!flag) {
                result.addErrorMessage("批量删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public Page getPage(Page<ProjectNodeNexusDto> pageDto, ProjectNodeNexusDto projectNodeNexusDto, SysUserDto sysUserDto) {
        Page page = DataUtils.processingPage(pageDto);
        Map<String, Object> map = new HashMap<>();
        map.put("proNodeNexus", projectNodeNexusDto);
/*        if (!"admin".equals(sysUserDto.getUsername())) {
            map.put("branchId", sysUserDto.getContractorId());
        } else {
            map.put("branchId", null);
        }*/
        if (sysUserDto.getLoginContractorId() != 1) { // 1为集团
            map.put("branchId", sysUserDto.getLoginContractorId());
        }
        int count = projectNodeNexusService.selectTotal(map);
        if (count > 0) {
            map.put("current", page.getCurrent());
            map.put("size", page.getSize());
            List<Map<String, Object>> mapList = projectNodeNexusService.selectRecords(map);
            page.setTotal(count);
            page.setRecords(mapList);
            return page;
        }
        return page;
    }

    @Override
    public Map<String, Object> queryProNodeNexus(SysUserDto sysUserDto) {
        Map<String, Object> map = new HashMap<>();
        EntityWrapper<BprojectTypes> bprojectTypesEntityWrapper = new EntityWrapper<>();
        bprojectTypesEntityWrapper.setSqlSelect("id", "project_type_name");
        EntityWrapper<BprojectTypesItems> bprojectTypesItemsEntityWrapper = new EntityWrapper<>();
        bprojectTypesItemsEntityWrapper.setSqlSelect("id", "project_type_item_name");
        EntityWrapper<BprojectNodes> bprojectNodesEntityWrapper = new EntityWrapper<>();
        bprojectNodesEntityWrapper.setSqlSelect("id", "project_node_name");
        EntityWrapper<BprojectNodeSteps> bprojectNodeStepsEntityWrapper = new EntityWrapper<>();
        bprojectNodeStepsEntityWrapper.setSqlSelect("id", "project_step_name");
/*        if (!"admin".equals(sysUserDto.getUsername())) {
            bprojectNodesEntityWrapper.eq("branch_id", sysUserDto.getContractorId()).orderBy("sort_num").last("asc");
            bprojectNodeStepsEntityWrapper.eq("branch_id", sysUserDto.getContractorId()).orderBy("sort_num").last("asc");
        } */
        if (sysUserDto.getLoginContractorId() != 1) {
            bprojectNodesEntityWrapper.eq("branch_id", sysUserDto.getLoginContractorId());
            bprojectNodeStepsEntityWrapper.eq("branch_id", sysUserDto.getLoginContractorId());
        }
        bprojectNodesEntityWrapper.ne("status","S").orderBy("sort_num").last("asc");
        bprojectNodeStepsEntityWrapper.ne("status","S").orderBy("sort_num").last("asc");
        List<BprojectTypes> bprojectTypes = bprojectTypesService.selectList(bprojectTypesEntityWrapper);
        if (bprojectTypes.size() != 0) {
            map.put("proTypes", bprojectTypes);
        }
        List<BprojectTypesItems> bprojectTypesItems = bprojectTypesItemsService.selectList(bprojectTypesItemsEntityWrapper);
        if (bprojectTypesItems.size() != 0) {
            map.put("proTypeItems", bprojectTypesItems);
        }
        List<BprojectNodes> bprojectNodes = bprojectNodesService.selectList(bprojectNodesEntityWrapper);
        if (bprojectNodes.size() != 0) {
            map.put("proNodes", bprojectNodes);
        }
        List<BprojectNodeSteps> bprojectNodeSteps = bprojectNodeStepsService.selectList(bprojectNodeStepsEntityWrapper);
        if (bprojectNodeSteps.size() != 0) {
            map.put("proNodeSteps", bprojectNodeSteps);
        }
        return map;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> saveProNodeNexus(String form, String items, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            ProjectNodeNexus projectNodeNexus = JSONArray.parseObject(form, ProjectNodeNexus.class);
            if (projectNodeNexus != null) {
                if (projectNodeNexus.getId() != null && "A".equals(projectNodeNexus.getStatus())) {
                    EntityWrapper<ProjectNodeNexus> entityWrapper = new EntityWrapper<>();
                    entityWrapper.setSqlSelect("id").ne("id", projectNodeNexus.getId()).eq("project_type_id", projectNodeNexus.getProjectTypeId())
                            .eq("project_type_item_id", projectNodeNexus.getProjectTypeItemId()).eq("status", projectNodeNexus.getStatus());
                    List<ProjectNodeNexus> projectNodeNexuses = projectNodeNexusService.selectList(entityWrapper);
                    if (projectNodeNexuses.size() != 0) {
                        result.addErrorMessage("提交失败工程同类型有效不得大于一");
                        return result;
                    }
                }
                projectNodeNexus.setOpUserId(sysUserDto.getUserId().intValue());
                projectNodeNexus.setOpDate(new Date());
                if (!"admin".equals(sysUserDto.getUsername())) {
                    projectNodeNexus.setBranchId(sysUserDto.getLoginContractorId());
                }
                boolean updateById = projectNodeNexusService.insertOrUpdate(projectNodeNexus);
                if (!updateById) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败");
                    return result;
                }
                JSONArray jsonArray = JSONArray.parseArray(items);
                List<ProjectNodeNexusItem> projectNodeNexusItemList = JSONObject.parseArray(jsonArray.toJSONString(), ProjectNodeNexusItem.class);
                EntityWrapper<ProjectNodeNexusItem> nodeNexusItemEntityWrapper = new EntityWrapper<>();
                nodeNexusItemEntityWrapper.eq("project_node_nexus_id", projectNodeNexus.getId());
                List<ProjectNodeNexusItem> projectNodeNexusItems = projectNodeNexusItemService.selectList(nodeNexusItemEntityWrapper);
                if (projectNodeNexusItems.size() != 0) {
                    for (ProjectNodeNexusItem pn : projectNodeNexusItems) {
                        boolean deleteById = projectNodeNexusItemService.deleteById(pn);
                        if (!deleteById) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("删除旧数据失败");
                            return result;
                        }
                    }
                }
                if (projectNodeNexusItemList.size() != 0) {
                    for (ProjectNodeNexusItem pn : projectNodeNexusItemList) {
                        if (pn.getProjectNodeId() == null || pn.getProjectNodeStepsId() == null) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：请检查提交信息重新提交");
                            return result;
                        }
                        pn.setProjectNodeNexusId(projectNodeNexus.getId());
                        boolean insert = projectNodeNexusItemService.insert(pn);
                        if (!insert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：添加数据失败");
                            return result;
                        }
                    }
                }
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error("提交失败：" + e.toString(), e);
            result.addErrorMessage("提交失败：请检查提交信息重新提交");
        }
        return result;
    }

    @Override
    public Map<String, Object> queryProNodeNexusTemporary(ProjectNodeNexusDto projectNodeNexusDto, SysUserDto sysUserDto) {
        if (projectNodeNexusDto != null && projectNodeNexusDto.getId() != null) {
            Map<String, Object> map = new HashMap<>();
            ProjectNodeNexus projectNodeNexus = projectNodeNexusService.selectById(projectNodeNexusDto.getId());
            EntityWrapper<ProjectNodeNexusItem> entityWrapper = new EntityWrapper<>();
            entityWrapper.eq("project_node_nexus_id", projectNodeNexus.getId());
            List<ProjectNodeNexusItem> projectNodeNexusItemList = projectNodeNexusItemService.selectList(entityWrapper);
            map.put("proNodeNexu", projectNodeNexus);
            map.put("proNodeNexuItems", projectNodeNexusItemList);
            return map;
        }
        return null;
    }
}
