package io.platform.project.biz.entity;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.enums.IdType;

import java.io.Serializable;

import lombok.Data;

@Data
@TableName("process_bills_steps")
public class ProcessBillsSteps extends Model<ProcessBillsSteps> implements Serializable {
    private static final long serialVersionUID = 5454155825314635342L;


    /**
     * id       db_column: id
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

    /**
     * 单据编号（关联ProjectBillsSubs表）       db_column: bill_no
     */
    @TableField("bill_no")
    private String billNo;

    /**
     * 行号       db_column: line_no
     */
    @TableField("line_no")
    private Integer lineNo;

    /**
     * 业务活动号       db_column: act_id
     */
    @TableField("act_id")
    private Integer actId;

    /**
     * 备注       db_column: remarks
     */
    @TableField("remarks")
    private String remarks;

    /**
     * 子工程编号       db_column: project_sub_no
     */
    @TableField("project_sub_no")
    private String projectSubNo;

    /**
     * 工程节点       db_column: project_node_id
     */
    @TableField("project_node_id")
    private Integer projectNodeId;

    /**
     * 工程步骤id       db_column: project_step_id
     */
    @TableField("project_step_id")
    private Integer projectStepId;

    /**
     * 形象进度占比       db_column: project_work_rate
     */
    @TableField("project_work_rate")
    private Double projectWorkRate;

    /**
     * 计划开工日期       db_column: plan_start_date
     */
    @TableField("plan_start_date")
    private java.util.Date planStartDate;

    /**
     * 计划竣工日期       db_column: plan_end_date
     */
    @TableField("plan_end_date")
    private java.util.Date planEndDate;

    /**
     * 计划施工天数       db_column: plan_days
     */
    @TableField("plan_days")
    private Integer planDays;

    /**
     * 实际开工日期       db_column: act_start_date
     */
    @TableField("act_start_date")
    private java.util.Date actStartDate;

    /**
     * 实际竣工日期       db_column: act_end_date
     */
    @TableField("act_end_date")
    private java.util.Date actEndDate;

    /**
     * 实际施工天数       db_column: act_days
     */
    @TableField("act_days")
    private Integer actDays;

    /**
     * 影像资料上传       db_column: attach1_id
     */
    @TableField("attach1")
    private String attach1;

    /**
     * 工程签证上传       db_column: attach2_id
     */
    @TableField("attach2")
    private String attach2;
    /**
     * 设计变更附件       db_column: act_days
     */
    @TableField("design_changes_attach")
    private String designChangesAttach;
    /**
     * 承包单位id       db_column: branch_id
     */
    @TableField("branch_id")
    private Integer branchId;
//columns END

}
