package io.platform.project.biz.entity;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.enums.IdType;

import java.io.Serializable;

import lombok.Data;

@Data
@TableName("project_bills_subs")
public class ProjectBillsSubs extends Model<ProjectBillsSubs> implements Serializable {
    private static final long serialVersionUID = 5454155825314635342L;


    /**
     * id       db_column: id
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

    /**
     * 单据编号       db_column: bill_no
     */
    @TableField("bill_no")
    private String billNo;

    /**
     * 行号       db_column: line_no
     */
    @TableField("line_no")
    private Integer lineNo;

    /**
     * 活动号       db_column: act_id
     */
    @TableField("act_id")
    private Integer actId;

    /**
     * 状态       db_column: bill_status
     */
    @TableField("bill_status")
    private Integer billStatus;

    /**
     * 备注       db_column: remarks
     */
    @TableField("remarks")
    private String remarks;

    /**
     * NC工程编号       db_column: nc_project_no
     */
    @TableField("nc_project_no")
    private String ncProjectNo;

    /**
     * 子工程编号       db_column: project_sub_no
     */
    @TableField("project_sub_no")
    private String projectSubNo;

    /**
     * 子工程名称       db_column: project_sub_name
     */
    @TableField("project_sub_name")
    private String projectSubName;

    /**
     * 是否是子项目(T是F不是）       db_column: if_project_sub
     */
    @TableField("if_project_sub")
    private String ifProjectSub;

    /**
     * 项目预算状态 (1新建 2暂存  6提交）       db_column: project_budget_status
     */
    @TableField("project_budget_status")
    private Integer projectBudgetStatus;

    /**
     * 项目里程碑状态 (1新建 2暂存  6提交）       db_column: project_steps_status
     */
    @TableField("project_steps_status")
    private Integer projectStepsStatus;

    /**
     * 承包单位id       db_column: branch_id
     */
    @TableField("branch_id")
    private Integer branchId;

    /**
     * 审批公司id（关联基础资料）       db_column: approval_branch_id
     */
    @TableField("approval_branch_id")
    private Integer approvalBranchId;

    /**
     * 业主单位id       db_column: corp_id
     */
    @TableField("corp_id")
    private Integer corpId;

    /**
     * 承包单位名称       db_column: branch_name
     */
    @TableField("branch_name")
    private String branchName;

    /**
     * 分摊合同金额       db_column: contract_amt
     */
    @TableField("contract_amt")
    private Double contractAmt;

    /**
     * 合同审定金额       db_column: contract_audit_amt
     */
    @TableField("contract_audit_amt")
    private Double contractAuditAmt;

    /**
     * 工程量占比（%）       db_column: project_work_rate
     */
    @TableField("project_work_rate")
    private Double projectWorkRate;

    /**
     * 当前进度占比（%）       db_column: current_progress
     */
    @TableField("current_progress")
    private Double currentProgress;

    /**
     * 项目预算创建时间       db_column: budget_create_date
     */
    @TableField("budget_create_date")
    private java.util.Date budgetCreateDate;

    /**
     * 里程碑创建时间       db_column: steps_create_date
     */
    @TableField("steps_create_date")
    private java.util.Date stepsCreateDate;

    /**
     * 子工程项目经理id       db_column: project_sub_mng_id
     */
    @TableField("project_sub_mng_id")
    private Integer projectSubMngId;

    /**
     * 子工程项目经理名称       db_column: project_sub_mng_name
     */
    @TableField("project_sub_mng_name")
    private String projectSubMngName;

    /**
     * 经理部门id       db_column: project_sub_mng_dept_id
     */
    @TableField("project_sub_mng_dept_id")
    private Integer projectSubMngDeptId;

    /**
     * 经理部门名称       db_column: project_sub_mng_dept_name
     */
    @TableField("project_sub_mng_dept_name")
    private String projectSubMngDeptName;

    /**
     * 图纸交割日期       db_column: drawing_date
     */
    @TableField("drawing_date")
    private java.util.Date drawingDate;

    /**
     * 预算原始日期       db_column: budget_org_date
     */
    @TableField("budget_org_date")
    private java.util.Date budgetOrgDate;

    /**
     * 预算原始总金额       db_column: budget_org_amt
     */
    @TableField("budget_org_amt")
    private Double budgetOrgAmt;

    /**
     * 预算原始毛利润额       db_column: budget_org_profit
     */
    @TableField("budget_org_profit")
    private Double budgetOrgProfit;

    /**
     * 预算原始毛利润率       db_column: budget_org_profit_rate
     */
    @TableField("budget_org_profit_rate")
    private Double budgetOrgProfitRate;

    /**
     * 预算总金额       db_column: budget_amt
     */
    @TableField("budget_amt")
    private Double budgetAmt;

    /**
     * 预算毛利润额       db_column: budget_profit
     */
    @TableField("budget_profit")
    private Double budgetProfit;

    /**
     * 预算毛利润率       db_column: budget_profit_rate
     */
    @TableField("budget_profit_rate")
    private Double budgetProfitRate;

    /**
     * 预算编制人姓名       db_column: budget_user_name
     */
    @TableField("budget_user_name")
    private String budgetUserName;

    /**
     * 累计收入开票金额       db_column: sub_inv_amt_dr
     */
    @TableField("sub_inv_amt_dr")
    private Double subInvAmtDr;

    /**
     * 累计成本开票金额       db_column: sub_inv_amt_cr
     */
    @TableField("sub_inv_amt_cr")
    private Double subInvAmtCr;

    /**
     * 累计收入金额       db_column: sub_amt_dr
     */
    @TableField("sub_amt_dr")
    private Double subAmtDr;

    /**
     * 累计成本金额       db_column: sub_amt_cr
     */
    @TableField("sub_amt_cr")
    private Double subAmtCr;

    /**
     * 里程碑制单人       db_column: project_steps_user_name
     */
    @TableField("project_steps_user_name")
    private String projectStepsUserName;

    /**
     * 结项状态 T(已结项) F(未结项)       db_column: closing_status
     */
    @TableField("closing_status")
    private String closingStatus;

    /**
     * 结项人       db_column: closing_user_id
     */
    @TableField("closing_user_id")
    private Integer closingUserId;

    /**
     * 结项日期       db_column: closing_date
     */
    @TableField("closing_date")
    private java.util.Date closingDate;

    /**
     * 结项备注       db_column: closing_remarks
     */
    @TableField("closing_remarks")
    private String closingRemarks;

    /**
     * 合同金额（合同金额 / 合同审定金额）       db_column: amt
     */
    @TableField("amt")
    private Double amt;

    /**
     * 是否是存续项目（T是 F不是）       db_column: is_sur
     */
    @TableField("is_sur")
    private String isSur;

    /**
     * 工程状态（未开工 10, 施工中 20, 已竣工 30, 以结算 40，已结项 50）       db_column: project_status
     */
    @TableField("project_status")
    private Integer projectStatus;

    /**
     * 创建时间       db_column: create_data
     */
    @TableField("create_data")
    private java.util.Date createData;

    /**
     * 创建人       db_column: create_user_id
     */
    @TableField("create_user_id")
    private Integer createUserId;

    /**
     * 分包审定金额(总)       db_column: amt
     */
    @TableField("sub_audit_amt")
    private Double subAuditAmt;

    /**
     * 收付款结项状态 T(已结项) F(未结项)      db_column: settler_ch_status
     */
    @TableField("settler_ch_status")
    private String settlerChStatus;

    /**
     * 收付款结项人id      db_column: settler_ch_user_id
     */
    @TableField("settler_ch_user_id")
    private Integer settlerChUserId;

    /**
     * 收付款结项时间      db_column: settler_ch_date
     */
    @TableField("settler_ch_date")
    private java.util.Date settlerChDate;

    /**
     * 收付款结项备注      db_column: settler_ch_remarks
     */
    @TableField("settler_ch_remarks")
    private String settlerChRemarks;
    /**
     * 分摊成本       db_column: settlement_amt
     */
    @TableField("apportion_budget")
    private double apportionBudget;
    /**
     * 净利润       db_column: settlement_amt
     */
    @TableField("net_profit")
    private double netProfit;
    /**
     * 实际成本金额       db_column: actual_budget_amt
     */
    @TableField("actual_budget_amt")
    private double actualBudgetAmt;
    /**
     * 负毛利率备注       db_column: budget_remarks
     */
    @TableField("budget_remarks")
    private String budgetRemarks;

//columns END

}
