package io.platform.project.biz.entity;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.enums.IdType;

import java.io.Serializable;
import java.util.Date;

import lombok.Data;

@Data
@TableName("sub_contract_bills")
public class SubContractBills extends Model<SubContractBills> implements Serializable {
    private static final long serialVersionUID = 5454155825314635342L;


    /**
     * id       db_column: id
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

    /**
     * 单据编号       db_column: bill_No
     */
    @TableField("bill_No")
    private String billNo;

    /**
     * 业务活动号ID       db_column: act_id
     */
    @TableField("act_id")
    private Integer actId;

    /**
     * 来源活动ID       db_column: src_act_id
     */
    @TableField("src_act_id")
    private Integer srcActId;

    /**
     * 来源编号       db_column: src_bill_no
     */
    @TableField("src_bill_no")
    private String srcBillNo;

    /**
     * 来源行号       db_column: src_line_no
     */
    @TableField("src_line_no")
    private Integer srcLineNo;

    /**
     * 原始活动ID       db_column: org_act_id
     */
    @TableField("org_act_id")
    private Integer orgActId;

    /**
     * 原始编号       db_column: org_bill_no
     */
    @TableField("org_bill_no")
    private String orgBillNo;

    /**
     * 原始行号       db_column: org_line_no
     */
    @TableField("org_line_no")
    private Integer orgLineNo;

    /**
     * 单据状态（1-新建2处理中6完成）       db_column: bill_status
     */
    @TableField("bill_status")
    private Integer billStatus;

    /**
     * 制单人ID       db_column: op_user_id
     */
    @TableField("op_user_id")
    private Integer opUserId;

    /**
     * 制单人姓名       db_column: op_user_name
     */
    @TableField("op_user_name")
    private String opUserName;

    /**
     * 制单日期       db_column: create_date
     */
    @TableField("create_date")
    private Date createDate;

    /**
     * 业务日期       db_column: bill_date
     */
    @TableField("bill_date")
    private Date billDate;

    /**
     * 提交日期       db_column: post_date
     */
    @TableField("post_date")
    private Date postDate;

    /**
     * 备注       db_column: remark
     */
    @TableField("remark")
    private String remark;

    /**
     * 工程编号(关联ProjectSubBills表显示)       db_column: project_sub_no
     */
    @TableField("project_sub_no")
    private String projectSubNo;

    /**
     * 承包单位ID（根据ProjectSubBills自动生成）       db_column: branch_id
     */
    @TableField("branch_id")
    private Integer branchId;

    /**
     * 采购招标编号（根据PurchaseBillsProjs生成）       db_column: purchase_bid_no
     */
    @TableField("purchase_bid_no")
    private String purchaseBidNo;

    /**
     * 工程采购计划编号       db_column: purchase_plan_no
     */
    @TableField("purchase_plan_no")
    private String purchasePlanNo;

    /**
     * 合同编号       db_column: contract_no
     */
    @TableField("contract_no")
    private String contractNo;

    /**
     * 合同名称       db_column: contract_name
     */
    @TableField("contract_name")
    private String contractName;

    /**
     * 分包范围（提取自采购计划）       db_column: purchase_extent
     */
    @TableField("purchase_extent")
    private String purchaseExtent;

    /**
     * 分包类型ID（提取自采购计划）       db_column: purchase_sub_type_id
     */
    @TableField("purchase_sub_type_id")
    private Integer purchaseSubTypeId;

    /**
     * 概算金额（提取自采购计划Amt）       db_column: plan_amt
     */
    @TableField("plan_amt")
    private Double planAmt;

    /**
     * 分包单位（提取自采购计划-即中标单位）       db_column: purchase_id
     */
    @TableField("purchase_id")
    private Integer purchaseId;

    /**
     * 签约地点       db_column: sign_addr
     */
    @TableField("sign_addr")
    private String signAddr;

    /**
     * 签约日期       db_column: sign_date
     */
    @TableField("sign_date")
    private Date signDate;

    /**
     * 计划开工日期       db_column: plan_start_date
     */
    @TableField("plan_start_date")
    private Date planStartDate;

    /**
     * 计划竣工日期       db_column: plan_end_date
     */
    @TableField("plan_end_date")
    private Date planEndDate;

    /**
     * 计划工期天数       db_column: plan_days
     */
    @TableField("plan_days")
    private Integer planDays;

    /**
     * 合同金额       db_column: contract_amt
     */
    @TableField("contract_amt")
    private Double contractAmt;

    /**
     * 合同金额(大写)       db_column: contract_amt_capital
     */
    @TableField("contract_amt_capital")
    private String contractAmtCapital;

    /**
     * 合同税率(%)       db_column: contract_tax_rate
     */
    @TableField("contract_tax_rate")
    private Double contractTaxRate;

    /**
     * 合同税额       db_column: contract_tax_amt
     */
    @TableField("contract_tax_amt")
    private Double contractTaxAmt;

    /**
     * 价款确定方式（关联基础资料）       db_column: price_mode_id
     */
    @TableField("price_mode_id")
    private Integer priceModeId;

    /**
     * 价款结算比例       db_column: settlement_ratio
     */
    @TableField("settlement_ratio")
    private Integer settlementRatio;

    /**
     * 结算方式       db_column: stl_type
     */
    @TableField("stl_type")
    private String stlType;

    /**
     * 是否是存续项目       db_column: is_sur
     */
    @TableField("is_sur")
    private String isSur;

    /**
     * 分包审定金额       db_column: contract_audit_amt
     */
    @TableField("contract_audit_amt")
    private Double contractAuditAmt;

    /**
     * 分包预估金额       db_column: estimated_amt
     */
    @TableField("estimated_amt")
    private Double estimatedAmt;

    /**
     * 分包已开发票金额       db_column: sub_inv_amt_cr
     */
    @TableField("sub_inv_amt_cr")
    private Double subInvAmtCr;

    /**
     * 未开发票金额       db_column: sub_inv_amt_blc
     */
    @TableField("sub_inv_amt_blc")
    private Double subInvAmtBlc;

    /**
     * 已付款金额       db_column: sub_amt_cr
     */
    @TableField("sub_amt_cr")
    private Double subAmtCr;

    /**
     * 剩余应付金额       db_column: sub_amt_blc
     */
    @TableField("sub_amt_blc")
    private Double subAmtBlc;

    /**
     * 结算金额       db_column: settlement_amt
     */
    @TableField("settlement_amt")
    private Double settlementAmt;

    /**
     * 结算状态（1-新建2处理中6完成）       db_column: settlement_status
     */
    @TableField("settlement_status")
    private Integer settlementStatus;

    /**
     * 分包合同金额（合同金额 / 合同审定金额）       db_column: amt
     */
    @TableField("amt")
    private Double amt;

    /**
     * 累计收入开票金额       db_column: subs_inv_amt_dr
     */
    @TableField("subs_inv_amt_dr")
    private Double subsInvAmtDr;
    /**
     * NC采购单号       db_column: subs_inv_amt_dr
     */
    @TableField("purchase_nc_no")
    private String purchaseNcNo;
    /**
     * 审定税率       db_column: amt
     */
    @TableField("tax_rate")
    private Double taxRate;

    /**
     * 分包结算日期       db_column: subs_inv_amt_dr
     */
    @TableField("stl_date")
    private Date stlDate;
    /**
     * 分包结算报告附件       db_column: subs_inv_amt_dr
     */
    @TableField("attach")
    private String attach;
//columns END

}
