package io.platform.project.biz.mapper;

import io.platform.base.common.BaseMapper;
import io.platform.budget.biz.entity.ProjectBillsBudgets;
import io.platform.project.biz.entity.ProjectBillsSubs;
import io.platform.project.dto.ProjectBS;
import io.platform.project.dto.ProjectBillsSubsDto;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Update;

import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/9/6.
 */
@Mapper
public interface ProjectBillsSubsMapper extends BaseMapper<ProjectBillsSubs> {

    List<ProjectBillsSubs> querySettlementProjectSubs(@Param("map") Map<String, Object> mapVal);

    int querySettlementProjectSubsCount(@Param("map") Map<String, Object> mapVal);

    int conditionalQueryProjectSubsNum(@Param("hashMap") Map<String, Object> projectBillsSubsDto);

    List<Map<String, Object>> conditionalQueryProjectSubs(@Param("hashMap") Map<String, Object> map);

    int selectProSubsTotal(@Param("hashMap") Map<String, Object> map);

    List<Map<String, Object>> selectProSubsRecords(@Param("hashMap") Map<String, Object> map);

    Map<String, Object> selectProjectSummaryData(@Param("hashMap") Map<String, Object> map);

    List<Map<String, Object>> selectSubContractData(@Param("hashMap") Map<String, Object> map);

    List<Map<String, Object>> selectSubBudgetsData(@Param("hashMap") Map<String, Object> map);

    List<Map<String, Object>> selectProSummaryRecords(@Param("hashMap") Map<String, Object> map);

    int selectProSummaryTotal(@Param("hashMap") Map<String, Object> map);

    List<Map<String, Object>> selectBalanceRecords(@Param("hashMap") Map<String, Object> map);

    int selectBalanceTotal(@Param("hashMap") Map<String, Object> map);

    ProjectBS selectProBalanceVal(@Param("proSub") ProjectBillsSubsDto projectBillsSubsDto);

    List<ProjectBillsSubs> queryPayInvoiceRecords(@Param("hashMap") Map<String, Object> map);

    int queryPayInvoiceTotal(@Param("hashMap") Map<String, Object> map);

    List<Map<String, Object>> selectPurchaseResult(@Param("map")Map<String,Object> map);

    List<Map<String, Object>> selectEngineeringRecords(@Param("hashMap") Map<String, Object> map);

    int selectEngineeringTotal(@Param("hashMap") Map<String, Object> map);

    List<Map<String, Object>> selectEngineeringExportExcel(@Param("proSub") ProjectBillsSubsDto projectBillsSubsDto);

    List<Map<String, Object>> selectSubsistingExportExcel(@Param("hashMap") Map<String, Object> map);

    Map<String, Object> selectProSubBudget(@Param("proSub") ProjectBillsSubsDto projectBillsSubsDto);

    List<Map<String, Object>> selectSubInvSharesData(@Param("hashMap") Map<String, Object> map);

    List<Map<String, Object>> selectPurchaseResultGoodsItem(@Param("map") Map<String, Object> map);

    int selectPurchaseResultCount(@Param("map") Map<String,Object> map);

    int selectPurchaseResultGoodsItemCount(@Param("map") Map<String, Object> map);

    int selectMoneySettlementTotal(@Param("hashMap") Map<String, Object> params);

    List<Map<String, Object>> selectMoneySettlementRecords(@Param("hashMap") Map<String, Object> params);

    Map<String, Object> selectClsingVal(@Param("id") Integer integer);

    List<ProjectBillsBudgets> selectClsingBudgets(@Param("id") Integer integer);

    List<Map<String, Object>> selectPayCrShares(@Param("hashMap") Map<String, Object> map);

    List<ProjectBillsSubs> queryPayInvoiceRecordsNew(@Param("current") int current,
                                                     @Param("size") int size,
                                                     @Param("projectSubName") String projectSubName,
                                                     @Param("ncProjectNo") String ncProjectNo,
                                                     @Param("projectSubNo") String projectSubNo,
                                                     @Param("loginContractorId") Integer loginContractorId,
                                                     @Param("budgetId") Integer budgetId);

    Integer getQTY(@Param("projectSubNo") Object projectSubNo,
                   @Param("branchId") Object branchId);

    Integer getBicQTY(@Param("projectSubNo") Object projectSubNo,
                      @Param("settlementStatus") Integer settlementStatus);
}
