
package io.platform.project.biz.service;

import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.service.impl.ServiceImpl;

import io.platform.project.biz.mapper.SubContractBillsMapper;
import io.platform.project.biz.entity.SubContractBills;

import io.platform.project.dto.ProjectBillsSubsDto;
import io.platform.project.dto.SubContractBillsDto;
import io.platform.sys.biz.entity.SysRole;
import io.platform.sys.biz.entity.SysUserRole;
import io.platform.sys.biz.service.SysRoleService;
import io.platform.sys.biz.service.SysUserRoleService;
import io.platform.sys.dto.SysUserDto;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;


@Service("subContractBillsService")
public class SubContractBillsService extends ServiceImpl<SubContractBillsMapper, SubContractBills> {
    @Resource
    private SysUserRoleService sysUserRoleService;
    @Resource
    private SysRoleService sysRoleService;

    public List<Map<String, Object>> subContractPage(Map<String, Object> map) {
        return baseMapper.subContractPage(map);
    }

    public int subContractPageTotal(Map<String, Object> map) {
        return baseMapper.subContractPageTotal(map);
    }

    public int selectEnineeringCount(Map<String, Object> map) {
        return baseMapper.selectEnineeringCount(map);
    }

    public List<SubContractBills> selectEnineeringRecords(Map<String, Object> map) {
        return baseMapper.selectEnineeringRecords(map);
    }

    public Map<String, Object> selectSubContractTempProject(SubContractBills subContractBills) {
        return baseMapper.selectSubContractTempProject(subContractBills);
    }
    public SysRole selectRole (SysUserDto sysUserDto) {
        EntityWrapper<SysUserRole> sysUserRoleEntityWrapper = new EntityWrapper<>();
        sysUserRoleEntityWrapper.eq("user_id",sysUserDto.getUserId());
        SysUserRole sysUserRole = sysUserRoleService.selectOne(sysUserRoleEntityWrapper);
        return sysRoleService.selectById(sysUserRole.getRoleId());
    }

    public List<Map<String, Object>> selectRenewRecordNew(ProjectBillsSubsDto projectBillsSubsDto) {
        return baseMapper.selectRenewRecordNew(projectBillsSubsDto);
    }
}
