
package io.platform.project.service.client.impl;

import com.alibaba.dubbo.config.annotation.Service;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;


import io.platform.project.biz.entity.ProcessBillsSteps;
import io.platform.project.biz.service.ProcessBillsStepsService;
import io.platform.project.dto.ProcessBillsStepsDto;
import io.platform.project.service.client.api.ProcessBillsStepsServiceClient;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

import io.platform.base.common.BaseServiceClient;
import io.platform.base.common.utils.ExecuteResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Created by sevelli on 2017/8/31.
 */
@Component
@Service()
public class ProcessBillsStepsServiceClientImpl extends BaseServiceClient<ProcessBillsSteps, ProcessBillsStepsDto> implements ProcessBillsStepsServiceClient {
    private Logger logger = LoggerFactory.getLogger(getClass());
    @Resource
    private ProcessBillsStepsService processBillsStepsService;

    @Override
    public ProcessBillsStepsDto queryObject(Long id) {
        ProcessBillsSteps processBillsSteps = processBillsStepsService.selectById(id);
        ProcessBillsStepsDto processBillsStepsDto = new ProcessBillsStepsDto();
        BeanUtils.copyProperties(processBillsSteps, processBillsStepsDto);
        return processBillsStepsDto;
    }

    @Override
    public List<ProcessBillsStepsDto> queryList(Map<String, Object> map) {
        List<ProcessBillsSteps> processBillsStepsList = processBillsStepsService.selectByMap(map);
        return convertList(processBillsStepsList, ProcessBillsStepsDto.class);
    }

    @Override
    public int queryTotal(Map<String, Object> map) {
        EntityWrapper<ProcessBillsSteps> ew = new EntityWrapper<>();
        ew.allEq(map);
        return processBillsStepsService.selectCount(ew);
    }

    @Override
    public ExecuteResult<String> save(ProcessBillsStepsDto processBillsStepsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            ProcessBillsSteps processBillsSteps = new ProcessBillsSteps();
            revert(processBillsStepsDto, processBillsSteps);
            boolean flag = processBillsStepsService.insert(processBillsSteps);
            if (!flag) {
                result.addErrorMessage("保存失败。");
            }
        } catch (Exception e) {
            logger.error(" 保存错误：" + e.toString(), e);
            result.addErrorMessage("保存错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> update(ProcessBillsStepsDto processBillsStepsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            ProcessBillsSteps processBillsSteps = new ProcessBillsSteps();
            revert(processBillsStepsDto, processBillsSteps);

            boolean flag = processBillsStepsService.updateById(processBillsSteps);
            if (!flag) {
                result.addErrorMessage("更新失败。");
            }
        } catch (Exception e) {
            logger.error(" 更新错误：" + e.toString(), e);
            result.addErrorMessage("更新错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> delete(Long id) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = processBillsStepsService.deleteById(id);
            if (!flag) {
                result.addErrorMessage("删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = processBillsStepsService.deleteBatchIds(ids);
            if (!flag) {
                result.addErrorMessage("批量删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public Page<ProcessBillsStepsDto> getPage(Page<ProcessBillsStepsDto> pageDto, ProcessBillsStepsDto processBillsStepsDto) {
        Page<ProcessBillsSteps> page = new Page<>(pageDto.getCurrent(), pageDto.getSize());
        page.setAsc(pageDto.isAsc());
        page.setOrderByField(pageDto.getOrderByField());
        page.setCondition(pageDto.getCondition());
        ProcessBillsSteps processBillsSteps = new ProcessBillsSteps();
        revert(processBillsStepsDto, processBillsSteps);
        EntityWrapper<ProcessBillsSteps> wrapper = new EntityWrapper<>();
        wrapper.setEntity(processBillsSteps);
        page = processBillsStepsService.selectPage(page, wrapper);
        List<ProcessBillsStepsDto> processBillsStepsDtoList = convertList(page.getRecords(), ProcessBillsStepsDto.class);
        pageDto.setTotal(processBillsStepsService.selectCount(wrapper));
        pageDto.setRecords(processBillsStepsDtoList);
        return pageDto;
    }
}
