
package io.platform.project.service.client.impl;

import com.alibaba.dubbo.config.annotation.Service;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;
import io.platform.project.biz.entity.ProjectBillsStepsAdjust;
import io.platform.project.biz.entity.ProjectBillsSubs;
import io.platform.project.biz.service.ProjectBillsStepsAdjustService;
import io.platform.project.dto.ProjectBillsStepsAdjustDto;
import io.platform.project.service.client.api.ProjectBillsStepsAdjustServiceClient;
import io.platform.project.service.client.api.ProjectBillsStepsServiceClient;
import io.platform.utils.DataUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import io.platform.base.common.BaseServiceClient;
import io.platform.base.common.utils.ExecuteResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Created by sevelli on 2017/8/31.
 */
@Component
@Service(version = "1.0.0", interfaceClass = ProjectBillsStepsAdjustServiceClient.class)
public class ProjectBillsStepsAdjustServiceClientImpl extends BaseServiceClient<ProjectBillsStepsAdjust, ProjectBillsStepsAdjustDto> implements ProjectBillsStepsAdjustServiceClient {
    private Logger logger = LoggerFactory.getLogger(getClass());
    @Resource
    private ProjectBillsStepsAdjustService projectBillsStepsAdjustService;

    @Override
    public ProjectBillsStepsAdjustDto queryObject(Long id) {
        ProjectBillsStepsAdjust projectBillsStepsAdjust = projectBillsStepsAdjustService.selectById(id);
        ProjectBillsStepsAdjustDto projectBillsStepsAdjustDto = new ProjectBillsStepsAdjustDto();
        BeanUtils.copyProperties(projectBillsStepsAdjust, projectBillsStepsAdjustDto);
        return projectBillsStepsAdjustDto;
    }

    @Override
    public List<ProjectBillsStepsAdjustDto> queryList(Map<String, Object> map) {
        List<ProjectBillsStepsAdjust> projectBillsStepsAdjustList = projectBillsStepsAdjustService.selectByMap(map);
        return convertList(projectBillsStepsAdjustList, ProjectBillsStepsAdjustDto.class);
    }

    @Override
    public int queryTotal(Map<String, Object> map) {
        EntityWrapper<ProjectBillsStepsAdjust> ew = new EntityWrapper<>();
        ew.allEq(map);
        return projectBillsStepsAdjustService.selectCount(ew);
    }

    @Override
    public ExecuteResult<String> save(ProjectBillsStepsAdjustDto projectBillsStepsAdjustDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            ProjectBillsStepsAdjust projectBillsStepsAdjust = new ProjectBillsStepsAdjust();
            revert(projectBillsStepsAdjustDto, projectBillsStepsAdjust);
            boolean flag = projectBillsStepsAdjustService.insert(projectBillsStepsAdjust);
            if (!flag) {
                result.addErrorMessage("保存失败。");
            }
        } catch (Exception e) {
            logger.error(" 保存错误：" + e.toString(), e);
            result.addErrorMessage("保存错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> update(ProjectBillsStepsAdjustDto projectBillsStepsAdjustDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            ProjectBillsStepsAdjust projectBillsStepsAdjust = new ProjectBillsStepsAdjust();
            revert(projectBillsStepsAdjustDto, projectBillsStepsAdjust);

            boolean flag = projectBillsStepsAdjustService.updateById(projectBillsStepsAdjust);
            if (!flag) {
                result.addErrorMessage("更新失败。");
            }
        } catch (Exception e) {
            logger.error(" 更新错误：" + e.toString(), e);
            result.addErrorMessage("更新错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> delete(Long id) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = projectBillsStepsAdjustService.deleteById(id);
            if (!flag) {
                result.addErrorMessage("删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = projectBillsStepsAdjustService.deleteBatchIds(ids);
            if (!flag) {
                result.addErrorMessage("批量删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public Page<ProjectBillsStepsAdjustDto> getPage(Page<ProjectBillsStepsAdjustDto> pageDto, ProjectBillsStepsAdjustDto projectBillsStepsAdjustDto) {
        Page<ProjectBillsStepsAdjust> page = new Page<>(pageDto.getCurrent(), pageDto.getSize());
        page.setAsc(pageDto.isAsc());
        page.setOrderByField(pageDto.getOrderByField());
        page.setCondition(pageDto.getCondition());
        ProjectBillsStepsAdjust projectBillsStepsAdjust = new ProjectBillsStepsAdjust();
        revert(projectBillsStepsAdjustDto, projectBillsStepsAdjust);
        EntityWrapper<ProjectBillsStepsAdjust> wrapper = new EntityWrapper<>();
        wrapper.setEntity(projectBillsStepsAdjust);
        page = projectBillsStepsAdjustService.selectPage(page, wrapper);
        List<ProjectBillsStepsAdjustDto> projectBillsStepsAdjustDtoList = convertList(page.getRecords(), ProjectBillsStepsAdjustDto.class);
        pageDto.setTotal(projectBillsStepsAdjustService.selectCount(wrapper));
        pageDto.setRecords(projectBillsStepsAdjustDtoList);
        return pageDto;
    }

    @Override
    public Map<String, Object> fuzzyQueryProjectAdjust(Page page, ProjectBillsStepsAdjustDto projectBillsStepsAdjustDto) {
        Map<String, Object> map = new HashMap<>();
        if (projectBillsStepsAdjustDto != null) {
            Page pageDto = DataUtils.processingPage(page);
            EntityWrapper<ProjectBillsStepsAdjust> entityWrapper = new EntityWrapper<>();
            if (projectBillsStepsAdjustDto.getProjectNodeId() != null && projectBillsStepsAdjustDto.getProjectNodeId() != 0) {
                entityWrapper.eq("project_node_id", projectBillsStepsAdjustDto.getProjectNodeId());
            }
            if (projectBillsStepsAdjustDto.getProjectStepId() != null && projectBillsStepsAdjustDto.getProjectStepId() != 0) {
                entityWrapper.eq("project_step_id", projectBillsStepsAdjustDto.getProjectStepId());
            }
            if (projectBillsStepsAdjustDto.getRemarks() != null && !projectBillsStepsAdjustDto.getRemarks().equals("")) {
                entityWrapper.like("remarks", "%" + projectBillsStepsAdjustDto.getRemarks() + "%");
            }
            if (projectBillsStepsAdjustDto.getProjectSubNo() != null && !projectBillsStepsAdjustDto.getProjectSubNo().equals("")) {
                entityWrapper.like("project_sub_no", "%" + projectBillsStepsAdjustDto.getProjectSubNo() + "%");
            }
            int number = projectBillsStepsAdjustService.selectCount(entityWrapper);
            if (number > 0) {
                entityWrapper.last("LIMIT " + pageDto.getCurrent() + "," + pageDto.getSize());
                List<ProjectBillsStepsAdjust> projectBillsStepsAdjusts = projectBillsStepsAdjustService.selectList(entityWrapper);
                map.put("stepsAdjusts", projectBillsStepsAdjusts);
                return map;
            }
        }
        return null;
    }

    @Override
    public Map<String, Object> selectSubCount() {
        return projectBillsStepsAdjustService.selectSubCount();
    }
}
