
package io.platform.project.service.client.impl;

import com.alibaba.dubbo.config.annotation.Service;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;


import io.platform.project.biz.entity.SubConBillsAttachs;
import io.platform.project.biz.service.SubConBillsAttachsService;
import io.platform.project.dto.SubConBillsAttachsDto;
import io.platform.project.service.client.api.SubConBillsAttachsServiceClient;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;
import io.platform.base.common.BaseServiceClient;
import io.platform.base.common.utils.ExecuteResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
 * Created by sevelli on 2017/8/31.
 */
@Component
@Service()
public class SubConBillsAttachsServiceClientImpl extends BaseServiceClient<SubConBillsAttachs,SubConBillsAttachsDto> implements SubConBillsAttachsServiceClient {
    private Logger logger = LoggerFactory.getLogger(getClass());
    @Resource
    private SubConBillsAttachsService subConBillsAttachsService;

    @Override
    public SubConBillsAttachsDto queryObject(Long id) {
        SubConBillsAttachs subConBillsAttachs = subConBillsAttachsService.selectById(id);
        SubConBillsAttachsDto subConBillsAttachsDto = new SubConBillsAttachsDto();
        BeanUtils.copyProperties(subConBillsAttachs,subConBillsAttachsDto);
        return subConBillsAttachsDto;
    }

    @Override
    public List<SubConBillsAttachsDto> queryList(Map<String, Object> map) {
        List<SubConBillsAttachs> subConBillsAttachsList = subConBillsAttachsService.selectByMap(map);
        return convertList(subConBillsAttachsList,SubConBillsAttachsDto.class);
    }

    @Override
    public int queryTotal(Map<String, Object> map) {
        EntityWrapper<SubConBillsAttachs> ew = new EntityWrapper<>();
        ew.allEq(map);
        return subConBillsAttachsService.selectCount(ew);
    }

    @Override
    public ExecuteResult<String> save(SubConBillsAttachsDto subConBillsAttachsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try{
            SubConBillsAttachs subConBillsAttachs = new SubConBillsAttachs();
            revert(subConBillsAttachsDto,subConBillsAttachs);
            boolean flag = subConBillsAttachsService.insert(subConBillsAttachs);
            if(!flag){
                result.addErrorMessage("保存失败。");
            }
        }
        catch (Exception e) {
            logger.error(" 保存错误：" + e.toString(), e);
            result.addErrorMessage("保存错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> update(SubConBillsAttachsDto subConBillsAttachsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try{
            SubConBillsAttachs subConBillsAttachs = new SubConBillsAttachs();
            revert(subConBillsAttachsDto,subConBillsAttachs);

            boolean flag = subConBillsAttachsService.updateById(subConBillsAttachs);
            if(!flag){
                result.addErrorMessage("更新失败。");
            }
        }
        catch (Exception e) {
            logger.error(" 更新错误：" + e.toString(), e);
            result.addErrorMessage("更新错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> delete(Long id) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try{
            boolean flag = subConBillsAttachsService.deleteById(id);
            if(!flag){
                result.addErrorMessage("删除失败。");
            }
        }
        catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try{
            boolean flag = subConBillsAttachsService.deleteBatchIds(ids);
            if(!flag){
                result.addErrorMessage("批量删除失败。");
            }
        }
        catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public Page<SubConBillsAttachsDto> getPage(Page<SubConBillsAttachsDto> pageDto,SubConBillsAttachsDto subConBillsAttachsDto) {
        Page<SubConBillsAttachs> page = new Page<>(pageDto.getCurrent(),pageDto.getSize());
        page.setAsc(pageDto.isAsc());
        page.setOrderByField(pageDto.getOrderByField());
        page.setCondition(pageDto.getCondition());
        SubConBillsAttachs subConBillsAttachs = new SubConBillsAttachs();
        revert(subConBillsAttachsDto,subConBillsAttachs);
        EntityWrapper<SubConBillsAttachs> wrapper = new EntityWrapper<>();
        wrapper.setEntity(subConBillsAttachs);
        page = subConBillsAttachsService.selectPage(page,wrapper);
        List<SubConBillsAttachsDto> subConBillsAttachsDtoList = convertList(page.getRecords(),SubConBillsAttachsDto.class);
        pageDto.setTotal(subConBillsAttachsService.selectCount(wrapper));
        pageDto.setRecords(subConBillsAttachsDtoList);
        return pageDto;
    }
}
