
package io.platform.project.service.client.impl;

import com.alibaba.dubbo.config.annotation.Service;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;


import io.platform.approvalConfiguration.biz.entity.Audit;
import io.platform.approvalConfiguration.biz.service.AuditItemsService;
import io.platform.budget.biz.entity.ProjectBillsBudgets;
import io.platform.budget.biz.service.ProjectBillsBudgetsService;
import io.platform.contract.biz.entity.ProjectBillsStlPlans;
import io.platform.contract.biz.service.ProjectBillsStlPlansService;
import io.platform.engineering.biz.entity.Bbranchs;
import io.platform.engineering.biz.entity.BpurchaseModes;
import io.platform.engineering.biz.entity.Bpurchases;
import io.platform.engineering.biz.service.BbranchsService;
import io.platform.engineering.biz.service.BpurchaseModesService;
import io.platform.engineering.biz.service.BpurchasesService;
import io.platform.moneyManagement.biz.entity.InvoiceBills;
import io.platform.moneyManagement.biz.entity.PayCrBills;
import io.platform.moneyManagement.biz.service.InvoiceBillsService;
import io.platform.moneyManagement.biz.service.PayCrBillsService;
import io.platform.project.biz.entity.ProjectBillsSubs;
import io.platform.project.biz.entity.Projectbills;
import io.platform.project.biz.entity.SubConBillsAttachs;
import io.platform.project.biz.entity.SubContractBills;
import io.platform.project.biz.service.ProjectBillsSubsService;
import io.platform.project.biz.service.ProjectbillsService;
import io.platform.project.biz.service.SubConBillsAttachsService;
import io.platform.project.biz.service.SubContractBillsService;
import io.platform.project.dto.ProjectBillsSubsDto;
import io.platform.project.dto.SubContractBillsDto;
import io.platform.project.service.client.api.SubContractBillsServiceClient;
import io.platform.projectSettlement.biz.entity.ProjectAnnex;
import io.platform.projectSettlement.biz.service.ProjectAnnexService;
import io.platform.purchase.biz.entity.PurchaseBills;
import io.platform.purchase.biz.entity.PurchaseBillsProjs;
import io.platform.purchase.biz.service.PurchaseBillsProjsService;
import io.platform.purchase.biz.service.PurchaseBillsService;
import io.platform.sys.biz.entity.SysRole;
import io.platform.sys.dto.SysUserDto;
import io.platform.utils.DataUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.*;

import io.platform.base.common.BaseServiceClient;
import io.platform.base.common.utils.ExecuteResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;

/**
 * Created by sevelli on 2017/8/31.
 */
@Component
@Service(version = "1.0.0", interfaceClass = SubContractBillsServiceClient.class)
public class SubContractBillsServiceClientImpl extends BaseServiceClient<SubContractBills, SubContractBillsDto> implements SubContractBillsServiceClient {
    private Logger logger = LoggerFactory.getLogger(getClass());
    @Resource
    private BbranchsService bbranchsService;
    @Resource
    private PayCrBillsService payCrBillsService;
    @Resource
    private BpurchasesService bpurchasesService;
    @Resource
    private ProjectAnnexService projectAnnexService;
    @Resource
    private ProjectbillsService projectbillsService;
    @Resource
    private InvoiceBillsService invoiceBillsService;
    @Resource
    private PurchaseBillsService purchaseBillsService;
    @Resource
    private BpurchaseModesService bpurchaseModesService;
    @Resource
    private SubContractBillsService subContractBillsService;
    @Resource
    private ProjectBillsSubsService projectBillsSubsService;
    @Resource
    private PurchaseBillsProjsService purchaseBillsProjsService;
    @Resource
    private SubConBillsAttachsService subConBillsAttachsService;
    @Resource
    private ProjectBillsBudgetsService projectBillsBudgetsService;
    @Resource
    private ProjectBillsStlPlansService projectBillsStlPlansService;

    @Override
    public SubContractBillsDto queryObject(Long id) {
        SubContractBills subContractBills = subContractBillsService.selectById(id);
        SubContractBillsDto subContractBillsDto = new SubContractBillsDto();
        BeanUtils.copyProperties(subContractBills, subContractBillsDto);
        return subContractBillsDto;
    }

    @Override
    public List<SubContractBillsDto> queryList(Map<String, Object> map) {
        List<SubContractBills> subContractBillsList = subContractBillsService.selectByMap(map);
        return convertList(subContractBillsList, SubContractBillsDto.class);
    }

    @Override
    public int queryTotal(Map<String, Object> map) {
        EntityWrapper<SubContractBills> ew = new EntityWrapper<>();
        ew.allEq(map);
        return subContractBillsService.selectCount(ew);
    }

    @Override
    public ExecuteResult<String> save(SubContractBillsDto subContractBillsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            SubContractBills subContractBills = new SubContractBills();
            revert(subContractBillsDto, subContractBills);
            boolean flag = subContractBillsService.insert(subContractBills);
            if (!flag) {
                result.addErrorMessage("保存失败。");
            }
        } catch (Exception e) {
            logger.error(" 保存错误：" + e.toString(), e);
            result.addErrorMessage("保存错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> update(SubContractBillsDto subContractBillsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            SubContractBills subContractBills = new SubContractBills();
            revert(subContractBillsDto, subContractBills);

            boolean flag = subContractBillsService.updateById(subContractBills);
            if (!flag) {
                result.addErrorMessage("更新失败。");
            }
        } catch (Exception e) {
            logger.error(" 更新错误：" + e.toString(), e);
            result.addErrorMessage("更新错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> delete(Long id) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = subContractBillsService.deleteById(id);
            if (!flag) {
                result.addErrorMessage("删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = subContractBillsService.deleteBatchIds(ids);
            if (!flag) {
                result.addErrorMessage("批量删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public Page<SubContractBillsDto> getPage(Page<SubContractBillsDto> pageDto, SubContractBillsDto subContractBillsDto, SysUserDto sysUserDto) {
        Page page = DataUtils.processingPage(pageDto);
        Map<String, Object> map = new HashMap<>();
        SysRole sysRole = subContractBillsService.selectRole(sysUserDto);
        map.put("dto", subContractBillsDto);
        map.put("user", sysUserDto);
        map.put("role", sysRole);
        int total = subContractBillsService.subContractPageTotal(map);
        if (total != 0) {
            map.put("curr", page.getCurrent());
            map.put("size", page.getSize());
            List<Map<String, Object>> list = subContractBillsService.subContractPage(map);
            page.setTotal(total);
            page.setRecords(list);
            return page;
        }
        return null;
    }

    @Override
    public Map<String, Object> enineeringPage(Page pageDto, SubContractBillsDto subContractBillsDto) {
        if (subContractBillsDto != null) {
            Map<String, Object> map = new HashMap<>();
            map.put("subContract", subContractBillsDto);
            int num = subContractBillsService.selectEnineeringCount(map);
            if (num != 0) {
                Page page = DataUtils.processingPage(pageDto);
                map.put("current", page.getCurrent());
                map.put("size", page.getSize());
                List<SubContractBills> subContractBillsList = subContractBillsService.selectEnineeringRecords(map);
                page.setTotal(num);
                page.setRecords(subContractBillsList);
                map.put("page", page);
            }
            return map;
        }
        return null;
    }

    /**
     * 分包结算 查询方法
     */
    @Override
    public Map<String, Object> selectFormData(Integer id, String subNo, SysUserDto sysUserDto) {
        Map<String, Object> map = new HashMap<>();
        Map<String, Object> mapList = subConBillsAttachsService.selectFormData(id);
        EntityWrapper<SubContractBills> subContractBillsEntityWrapper = new EntityWrapper<>();
        subContractBillsEntityWrapper.eq("project_sub_no", subNo);
        if (sysUserDto.getLoginContractorId() != 1) {
            subContractBillsEntityWrapper.eq("branch_id", sysUserDto.getLoginContractorId());
        }
        Bpurchases bpurchases = new Bpurchases();
        if (sysUserDto.getLoginContractorId() != 1) {
            bpurchases.setBranchId(sysUserDto.getLoginContractorId());
        }
        map.put("bill", mapList);
        map.put("sub", subContractBillsService.selectList(subContractBillsEntityWrapper));
        map.put("purchase", bpurchasesService.selectList(new EntityWrapper<>(bpurchases)));
        return map;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public String saveSubContract(String list, String subNo, SysUserDto sysUserDto) {
        JSONArray jsonArray = JSONArray.parseArray(list);
        List<SubContractBills> subContractBillsList = JSONObject.parseArray(jsonArray.toJSONString(), SubContractBills.class);
        double subInvAmt = 0.0;
        if (subContractBillsList.size() != 0) {
            EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
            projectBillsSubsEntityWrapper.eq("project_sub_no", subContractBillsList.get(0).getProjectSubNo())
                    .eq("branch_id", subContractBillsList.get(0).getBranchId());
            ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
            ProjectBillsBudgets pb = new ProjectBillsBudgets();
            int num = 0;
            int unsettled = 0;
            for (SubContractBills sc : subContractBillsList) {
                if (sc.getSettlementStatus() != 6 && sc.getContractAuditAmt() != null && sc.getContractAuditAmt() != 0.0) {
                    num++;
                    if (sc.getStlDate() == null) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        return "提交失败：请维护" + num + "行结算时间";
                    }
                    sc.setStlDate(new Date());
                    sc.setSettlementStatus(6);
                    sc.setAmt(sc.getContractAuditAmt());
                    subInvAmt = DataUtils.keepDecimals(subInvAmt + sc.getContractAuditAmt());
                    if (sc.getAttach() != null) {
                        ProjectAnnex projectAnnex = new ProjectAnnex();
                        projectAnnex.setSrcActId(206);
                        projectAnnex.setProjectId(sc.getId());
                        projectAnnex.setFileName("分包结算书");
                        projectAnnex.setFileAddress(sc.getAttach());
                        projectAnnex.setBranId(sc.getBranchId());
                        boolean proInsert = projectAnnexService.insert(projectAnnex);
                        if (!proInsert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            return "审批通过失败: 更新分包合同失败";
                        }
                    }
                    boolean subContractBillsType = subContractBillsService.updateById(sc);
                    if (!subContractBillsType) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        return "更新分包合同失败";
                    }
                    EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
                    projectBillsBudgetsEntityWrapper.eq("project_sub_no", sc.getProjectSubNo())
                            .eq("budget_id", 1)
                            .eq("branch_id", sc.getBranchId());
                    ProjectBillsBudgets billsBudgets = projectBillsBudgetsService.selectOne(projectBillsBudgetsEntityWrapper);
                    pb.setBranchId(billsBudgets.getBranchId());
                    pb.setProjectSubNo(billsBudgets.getProjectSubNo());
                    billsBudgets.setApprovedAmount(billsBudgets.getApprovedAmount() + sc.getContractAuditAmt());
                    boolean update = projectBillsBudgetsService.updateById(billsBudgets);
                    if (!update) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        return "更新分包合同失败";
                    }
                } else {
                    unsettled++;
                    continue;
                }
            }
            if (Objects.equals(num, 0)) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "未找到需要结算信息";
            }
            double amt = projectBillsBudgetsService.selectApprovedAmountSum(pb);
            if (unsettled <= 0 && "T".equals(projectBillsSubs.getIsSur())) {
                if (projectBillsSubs.getContractAuditAmt() != null && projectBillsSubs.getContractAuditAmt() > 0) {
                    EntityWrapper<Projectbills> entityWrapper = new EntityWrapper<>();
                    entityWrapper.eq("bill_no", projectBillsSubs.getBillNo())
                            .eq("project_no", projectBillsSubs.getProjectSubNo())
                            .eq("branch_id", projectBillsSubs.getBranchId());
                    Projectbills projectbills = projectbillsService.selectOne(entityWrapper);
                    if (projectbills.getEstimatedAmt() != null && projectbills.getEstimatedAmt() <= 0) {
                        projectBillsSubs.setProjectStatus(40);
                    }
                }
            } else if (unsettled <= 0 && projectBillsSubs.getContractAuditAmt() != null && projectBillsSubs.getContractAuditAmt() > 0) {
                projectBillsSubs.setProjectStatus(40);
            }
            projectBillsSubs.setSubAuditAmt(subInvAmt);
            projectBillsSubs.setActualBudgetAmt(amt);
            EntityWrapper<SubContractBills> subContractBillsEntityWrapper = new EntityWrapper<>();
            subContractBillsEntityWrapper.eq("project_sub_no", projectBillsSubs.getProjectSubNo())
                    .ne("settlement_status", 6)
                    .eq("branch_id", projectBillsSubs.getBranchId());
            int subCount = subContractBillsService.selectCount(subContractBillsEntityWrapper);
            if (Objects.equals(subCount, 0)) {
                projectBillsSubs.setProjectStatus(40);
            }
            boolean projectBillsSubsType = projectBillsSubsService.updateById(projectBillsSubs);
            if (!projectBillsSubsType) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "审批通过失败: 更新二级项目失败";
            }
        } else {
            return "未找到信息";
        }
        return null;
    }

    @Override
    public Map<String, Object> selectProjectSubBills(SubContractBillsDto subContractBillsDto) {
        Map<String, Object> map = new HashMap<>();
        EntityWrapper<SubContractBills> subContractBillsEntityWrapper = new EntityWrapper<>();
        subContractBillsEntityWrapper.eq("project_sub_no", subContractBillsDto.getProjectSubNo());
        subContractBillsEntityWrapper.eq("branch_id", subContractBillsDto.getBranchId());
        subContractBillsEntityWrapper.eq("contract_no", subContractBillsDto.getContractNo());
        subContractBillsEntityWrapper.eq("purchase_id", subContractBillsDto.getPurchaseId());
        map.put("dto", subContractBillsService.selectOne(subContractBillsEntityWrapper));
        map.put("purchase", bpurchasesService.selectById(subContractBillsDto.getPurchaseId()));
        return map;
    }

    @Override
    public List<Map<String, Object>> selectRenewRecordNew(ProjectBillsSubsDto projectBillsSubsDto) {
        return subContractBillsService.selectRenewRecordNew(projectBillsSubsDto);
    }

    @Override
    public double getPrepayments(Integer id) {
        EntityWrapper<SubContractBills> entityWrapper = new EntityWrapper<>();
        entityWrapper.setSqlSelect("id", "bill_no", "stl_type").eq("id", id);
        SubContractBills subContractBills = subContractBillsService.selectOne(entityWrapper);
        if (subContractBills == null) {
            return 0d;
        }
        if ("F".equals(subContractBills.getStlType())) {
            EntityWrapper<ProjectBillsStlPlans> plansEntityWrapper = new EntityWrapper<>();
            plansEntityWrapper.setSqlSelect("id", "amt", "stl_amt")
                    .eq("bill_no", subContractBills.getBillNo())
                    .eq("act_id", 112)
                    .eq("nature", "预付款");
            ProjectBillsStlPlans projectBillsStlPlans = projectBillsStlPlansService.selectOne(plansEntityWrapper);
            double amt = DataUtils.keepDecimals(projectBillsStlPlans.getAmt() - projectBillsStlPlans.getStlAmt());
            if (amt > 0) {
                return amt;
            }
        }
        return 0d;
    }

    @Override
    public ExecuteResult<String> selectPaymentInformation(SubContractBillsDto subContractBillsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        SubContractBills subContractBills = subContractBillsService.selectById(subContractBillsDto.getId());
        EntityWrapper<InvoiceBills> entityWrapper = new EntityWrapper<>();
        entityWrapper.eq("act_id", 109)
                .eq("budget_id", 1)
                .eq("contract_no", subContractBills.getContractNo())
                .eq("project_sub_no", subContractBills.getProjectSubNo())
                .eq("branch_id", subContractBills.getBranchId());
        List<InvoiceBills> invoiceBills = invoiceBillsService.selectList(entityWrapper);
        if (invoiceBills.size() != 0) {
            result.addErrorMessage("该分包工程已进行付款挂账操作不可移除");
            return result;
        }
        EntityWrapper<PayCrBills> payCrBillsEntityWrapper = new EntityWrapper<>();
        payCrBillsEntityWrapper.eq("act_id", 203)
                .eq("contract_no", subContractBills.getContractNo())
                .eq("project_sub_no", subContractBills.getProjectSubNo())
                .eq("budget_id", 1)
                .eq("branch_id", subContractBills.getBranchId());
        List<PayCrBills> payCrBills = payCrBillsService.selectList(payCrBillsEntityWrapper);
        if (payCrBills.size() != 0) {
            result.addErrorMessage("该分包工程已进行付款操作不可移除");
            return result;
        }
        return result;
    }

    @Override
    public Map<String, Object> selectAll(ProjectBillsSubsDto projectBillsSubsDto) {
        Map<String, Object> map = new HashMap<>();
        EntityWrapper<PurchaseBills> billsEntityWrapper = new EntityWrapper<>(); // 采购计划
        EntityWrapper<Bbranchs> bbranchsEntityWrapper = new EntityWrapper<>(); // 承包单位
        EntityWrapper<BpurchaseModes> bpurchaseModesEntityWrapper = new EntityWrapper<>(); // 分包类型
        billsEntityWrapper.eq("project_Sub_No", projectBillsSubsDto.getProjectSubNo());
        PurchaseBills purchaseBills = purchaseBillsService.selectOne(billsEntityWrapper);
        bbranchsEntityWrapper.eq("id", projectBillsSubsDto.getBranchId());
        bpurchaseModesEntityWrapper.eq("id", purchaseBills.getPurchaseModeId());
        map.put("bills", purchaseBills);
        map.put("chengBao", bbranchsService.selectOne(bbranchsEntityWrapper));
        map.put("fenbao", bpurchaseModesService.selectOne(bpurchaseModesEntityWrapper));
        return map;
    }

    @Override
    public Map<String, Object> querySubContractTemporary(SubContractBillsDto subContractBillsDto) {
        if (subContractBillsDto != null && subContractBillsDto.getId() != null) {
            Map<String, Object> map = new HashMap<>();
            EntityWrapper<SubContractBills> entityWrapper = new EntityWrapper<>();
            entityWrapper.eq("id", subContractBillsDto.getId());
            SubContractBills subContractBills = subContractBillsService.selectOne(entityWrapper);
            if (subContractBills != null) {
                map.put("subContract", subContractBills);
                Map<String, Object> hash = subContractBillsService.selectSubContractTempProject(subContractBills);
                map.put("pro", hash);
                if (subContractBills.getBillNo() != null && !subContractBills.getBillNo().equals("")) {
                    EntityWrapper<SubConBillsAttachs> subConBillsAttachsEntityWrapper = new EntityWrapper<>();
                    subConBillsAttachsEntityWrapper.eq("bill_no", subContractBills.getBillNo());
                    List<SubConBillsAttachs> subConBillsAttachs = subConBillsAttachsService.selectList(subConBillsAttachsEntityWrapper);
                    if (subConBillsAttachs.size() != 0) {
                        map.put("subAttachs", subConBillsAttachs);
                    }
                    EntityWrapper<ProjectBillsStlPlans> projectBillsStlPlansEntityWrapper = new EntityWrapper<>();
                    projectBillsStlPlansEntityWrapper.eq("bill_no", subContractBills.getBillNo()).eq("act_id", 112);
                    List<ProjectBillsStlPlans> projectBillsStlPlans = projectBillsStlPlansService.selectList(projectBillsStlPlansEntityWrapper);
                    if (projectBillsStlPlans.size() != 0) {
                        map.put("proPlans", projectBillsStlPlans);
                    }
                }
            }
            return map;
        }
        return null;
    }

    @Override
    public Map<String, Object> fuzzyQuerySubContracts(Page page, SubContractBillsDto subContractBillsDto) {
        Map<String, Object> map = new HashMap<>();
        if (subContractBillsDto != null && subContractBillsDto.getProjectSubNo() != null) {
            EntityWrapper<SubContractBills> entityWrapper = new EntityWrapper<>();
            entityWrapper.eq("project_sub_no", subContractBillsDto.getProjectSubNo()).ne("settlement_status", 6);
            int count = subContractBillsService.selectCount(entityWrapper);
            if (count != 0) {
                Page pageDto = DataUtils.processingPage(page);
                entityWrapper.last("LIMIT " + pageDto.getCurrent() + "," + pageDto.getSize());
                List<SubContractBills> subContractBillsList = subContractBillsService.selectList(entityWrapper);
                pageDto.setTotal(count);
                pageDto.setRecords(subContractBillsList);
                map.put("page", pageDto);
                return map;
            }
        }
        return null;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> subContractTemporary(String from, String item, String list, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            SubContractBills contractBills = JSONArray.parseObject(from, SubContractBills.class);
            JSONArray arrayList = JSONArray.parseArray(item);
            List<SubConBillsAttachs> attachsList = JSONObject.parseArray(arrayList.toJSONString(), SubConBillsAttachs.class);
            JSONArray jsonArray = JSONArray.parseArray(list);
            List<ProjectBillsStlPlans> projectBillsStlPlans = JSONObject.parseArray(jsonArray.toJSONString(), ProjectBillsStlPlans.class);
            if (contractBills != null) {
                EntityWrapper<SubContractBills> subContractBillsEntityWrapper = new EntityWrapper<>();
                subContractBillsEntityWrapper.setSqlSelect("id").eq("bill_No", contractBills.getBillNo())
                        .eq("project_sub_no", contractBills.getProjectSubNo());
                SubContractBills subContractBills = subContractBillsService.selectOne(subContractBillsEntityWrapper);
                if (subContractBills != null) {
                    subContractBills.setOpUserId(sysUserDto.getUserId().intValue());
                    subContractBills.setOpUserName(sysUserDto.getUsername());
                    subContractBills.setCreateDate(new Date());
                    subContractBills.setBillDate(new Date());
                    subContractBills.setRemark(contractBills.getRemark());
                    subContractBills.setProjectSubNo(contractBills.getProjectSubNo());
                    subContractBills.setBranchId(contractBills.getBranchId());
                    subContractBills.setPurchaseBidNo(contractBills.getPurchaseBidNo());
                    subContractBills.setContractNo(contractBills.getContractNo());
                    subContractBills.setContractName(contractBills.getContractName());
                    subContractBills.setPurchaseExtent(contractBills.getPurchaseExtent());
                    subContractBills.setPurchaseSubTypeId(contractBills.getPurchaseSubTypeId());
                    subContractBills.setPlanAmt(contractBills.getPlanAmt());
                    subContractBills.setPurchaseId(contractBills.getPurchaseId());
                    subContractBills.setSignAddr(contractBills.getSignAddr());
                    subContractBills.setSignDate(contractBills.getSignDate());
                    subContractBills.setPlanStartDate(contractBills.getPlanStartDate());
                    subContractBills.setPlanEndDate(contractBills.getPlanEndDate());
                    subContractBills.setPlanDays(contractBills.getPlanDays());
                    subContractBills.setContractAmt(contractBills.getContractAmt());
                    subContractBills.setContractTaxRate(contractBills.getContractTaxRate());
                    subContractBills.setContractTaxAmt(contractBills.getContractTaxAmt());
                    subContractBills.setPriceModeId(contractBills.getPriceModeId());
                    subContractBills.setStlType(contractBills.getStlType());
                    boolean updateById = subContractBillsService.updateById(subContractBills);
                    if (!updateById) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("暂存失败: 更新主表失败");
                        return result;
                    }
                } else {
                    contractBills.setActId(100);
                    contractBills.setBillStatus(2);
                    contractBills.setOpUserId(sysUserDto.getUserId().intValue());
                    contractBills.setOpUserName(sysUserDto.getUsername());
                    contractBills.setCreateDate(new Date());
                    contractBills.setBillDate(new Date());
                    boolean insert = subContractBillsService.insert(contractBills);
                    if (!insert) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("暂存失败: 新建主表失败");
                        return result;
                    }
                }
                if (attachsList.size() != 0) {
                    EntityWrapper<SubConBillsAttachs> subConBillsAttachsEntityWrapper = new EntityWrapper<>();
                    subConBillsAttachsEntityWrapper.setSqlSelect("id").eq("bill_no", contractBills.getBillNo());
                    List<SubConBillsAttachs> subConBillsAttachs = subConBillsAttachsService.selectList(subConBillsAttachsEntityWrapper);
                    if (subConBillsAttachs.size() != 0) {
                        for (SubConBillsAttachs sa : subConBillsAttachs) {
                            subConBillsAttachsService.deleteById(sa);
                        }
                    }
                    int line = 0;
                    for (SubConBillsAttachs sa : attachsList) {
                        line++;
                        sa.setBillNo(contractBills.getBillNo());
                        sa.setLineNo(line);
                        sa.setActId(99);
                        sa.setOpUserId(sysUserDto.getUserId().intValue());
                        sa.setOpUserName(sysUserDto.getUsername());
                        sa.setOpDate(new Date());
                        boolean insert = subConBillsAttachsService.insert(sa);
                        if (!insert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("暂存失败: 新建附件失败");
                            return result;
                        }
                    }
                }
                if (projectBillsStlPlans.size() != 0) {
                    EntityWrapper<ProjectBillsStlPlans> projectBillsStlPlansEntityWrapper = new EntityWrapper<>();
                    projectBillsStlPlansEntityWrapper.setSqlSelect("id").eq("bill_no", contractBills.getBillNo());
                    List<ProjectBillsStlPlans> projectBillsStlPlansList = projectBillsStlPlansService.selectList(projectBillsStlPlansEntityWrapper);
                    if (projectBillsStlPlansList.size() != 0) {
                        for (ProjectBillsStlPlans pb : projectBillsStlPlansList) {
                            projectBillsStlPlansService.deleteById(pb);
                        }
                    }
                    int lin = 0;
                    for (ProjectBillsStlPlans pb : projectBillsStlPlans) {
                        lin++;
                        pb.setBillNo(contractBills.getBillNo());
                        pb.setLineNo(lin);
                        pb.setActId(112);
                        boolean insert = projectBillsStlPlansService.insert(pb);
                        if (!insert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("暂存失败: 新建结算明细失败");
                            return result;
                        }
                    }
                }
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 暂存错误：" + e.toString(), e);
            result.addErrorMessage("暂存失败请确认信息重新提交");
        }

        return result;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> subContractSave(String from, String item, String list, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            SubContractBills contractBills = JSONArray.parseObject(from, SubContractBills.class);
            JSONArray arrayList = JSONArray.parseArray(item);
            List<SubConBillsAttachs> attachsList = JSONObject.parseArray(arrayList.toJSONString(), SubConBillsAttachs.class);
            JSONArray jsonArray = JSONArray.parseArray(list);
            List<ProjectBillsStlPlans> projectBillsStlPlansList = JSONObject.parseArray(jsonArray.toJSONString(), ProjectBillsStlPlans.class);
            if (contractBills != null) {
                EntityWrapper<PurchaseBillsProjs> purchaseBillsProjsEntityWrapper = new EntityWrapper<>();
                purchaseBillsProjsEntityWrapper.eq("project_sub_no", contractBills.getProjectSubNo())
                        .eq("purchase_Plan_No", contractBills.getPurchasePlanNo());
                PurchaseBillsProjs purchaseBillsProjs = purchaseBillsProjsService.selectOne(purchaseBillsProjsEntityWrapper);
                if (purchaseBillsProjs != null) {
                    if (purchaseBillsProjs.getIsUsed().equals("T")) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("暂存失败: 该工程采购计划编号已被使用");
                        return result;
                    } else {
                        purchaseBillsProjs.setIsUsed("T");
                        boolean updateById = purchaseBillsProjsService.updateById(purchaseBillsProjs);
                        if (!updateById) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("暂存失败: 更新工程采购计划编号状态失败");
                            return result;
                        }
                    }
                }
                EntityWrapper<SubContractBills> subContractBillsEntityWrapper = new EntityWrapper<>();
                subContractBillsEntityWrapper.setSqlSelect("id").eq("bill_No", contractBills.getBillNo())
                        .eq("project_sub_no", contractBills.getProjectSubNo());
                SubContractBills subContractBills = subContractBillsService.selectOne(subContractBillsEntityWrapper);
                if (subContractBills != null) {
                    contractBills.setId(subContractBills.getId());
                    subContractBills.setOpUserId(sysUserDto.getUserId().intValue());
                    subContractBills.setOpUserName(sysUserDto.getUsername());
                    subContractBills.setBillStatus(6);
                    subContractBills.setCreateDate(new Date());
                    subContractBills.setBillDate(new Date());
                    subContractBills.setPostDate(new Date());
                    subContractBills.setRemark(contractBills.getRemark());
                    subContractBills.setProjectSubNo(contractBills.getProjectSubNo());
                    subContractBills.setBranchId(contractBills.getBranchId());
                    subContractBills.setPurchaseBidNo(contractBills.getPurchaseBidNo());
                    subContractBills.setContractNo(contractBills.getContractNo());
                    subContractBills.setContractName(contractBills.getContractName());
                    subContractBills.setPurchaseExtent(contractBills.getPurchaseExtent());
                    subContractBills.setPurchaseSubTypeId(contractBills.getPurchaseSubTypeId());
                    subContractBills.setPlanAmt(contractBills.getPlanAmt());
                    subContractBills.setPurchaseId(contractBills.getPurchaseId());
                    subContractBills.setSignAddr(contractBills.getSignAddr());
                    subContractBills.setSignDate(contractBills.getSignDate());
                    subContractBills.setPlanStartDate(contractBills.getPlanStartDate());
                    subContractBills.setPlanEndDate(contractBills.getPlanEndDate());
                    subContractBills.setPlanDays(contractBills.getPlanDays());
                    subContractBills.setContractAmt(contractBills.getContractAmt());
                    subContractBills.setAmt(contractBills.getContractAmt());
                    subContractBills.setContractTaxRate(contractBills.getContractTaxRate());
                    subContractBills.setContractTaxAmt(contractBills.getContractTaxAmt());
                    subContractBills.setPriceModeId(contractBills.getPriceModeId());
                    subContractBills.setStlType(contractBills.getStlType());
                    boolean updateById = subContractBillsService.updateById(subContractBills);
                    if (!updateById) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("暂存失败: 更新主表失败");
                        return result;
                    }
                } else {
                    contractBills.setActId(100);
                    contractBills.setBillStatus(6);
                    contractBills.setPostDate(new Date());
                    contractBills.setAmt(contractBills.getContractAmt());
                    contractBills.setOpUserId(sysUserDto.getUserId().intValue());
                    contractBills.setOpUserName(sysUserDto.getUsername());
                    contractBills.setCreateDate(new Date());
                    contractBills.setBillDate(new Date());
                    boolean insert = subContractBillsService.insert(contractBills);
                    if (!insert) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("暂存失败: 新建主表失败");
                        return result;
                    }
                }
                if (attachsList.size() != 0) {
                    EntityWrapper<SubConBillsAttachs> subConBillsAttachsEntityWrapper = new EntityWrapper<>();
                    subConBillsAttachsEntityWrapper.setSqlSelect("id").eq("bill_no", contractBills.getBillNo());
                    subConBillsAttachsService.delete(subConBillsAttachsEntityWrapper);
                    int line = 0;
                    for (SubConBillsAttachs sa : attachsList) {
                        ProjectAnnex projectAnnex = new ProjectAnnex();
                        projectAnnex.setSrcActId(100);
                        projectAnnex.setProjectId(contractBills.getId());
                        projectAnnex.setFileName("分包合同");
                        projectAnnex.setFileAddress(sa.getAttachId());
                        projectAnnex.setBranId(contractBills.getBranchId());
                        boolean proInsert = projectAnnexService.insert(projectAnnex);
                        if (!proInsert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：更新附件失败");
                            return result;
                        }
                        line++;
                        sa.setBillNo(contractBills.getBillNo());
                        sa.setLineNo(line);
                        sa.setActId(99);
                        boolean insert = subConBillsAttachsService.insert(sa);
                        if (!insert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("暂存失败: 新建附件失败");
                            return result;
                        }
                    }
                }
                if (projectBillsStlPlansList.size() != 0) {
                    EntityWrapper<ProjectBillsStlPlans> projectBillsStlPlansEntityWrapper = new EntityWrapper<>();
                    projectBillsStlPlansEntityWrapper.eq("bill_no", contractBills.getBillNo()).eq("act_id", 112);
                    boolean delete = projectBillsStlPlansService.delete(projectBillsStlPlansEntityWrapper);
                    if (!delete) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("暂存失败: 删除旧数据失败");
                        return result;
                    }
                    int lin = 0;
                    for (ProjectBillsStlPlans pb : projectBillsStlPlansList) {
                        lin++;
                        pb.setBillNo(contractBills.getBillNo());
                        pb.setLineNo(lin);
                        pb.setActId(112);
                        boolean insert = projectBillsStlPlansService.insert(pb);
                        if (!insert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("暂存失败: 新建结算明细失败");
                            return result;
                        }
                    }
                }
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 提交错误：" + e.toString(), e);
            result.addErrorMessage("提交失败请确认信息重新提交");
        }
        return result;
    }
}
