
package io.platform.projectSettlement.service.client.impl;

import com.alibaba.dubbo.config.annotation.Service;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;


import io.platform.projectSettlement.biz.entity.ProjectBillsAttachs;
import io.platform.projectSettlement.biz.service.ProjectBillsAttachsService;
import io.platform.projectSettlement.dto.ProjectBillsAttachsDto;
import io.platform.projectSettlement.service.client.api.ProjectBillsAttachsServiceClient;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

import io.platform.base.common.BaseServiceClient;
import io.platform.base.common.utils.ExecuteResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Created by sevelli on 2017/8/31.
 */
@Component
@Service()
public class ProjectBillsAttachsServiceClientImpl extends BaseServiceClient<ProjectBillsAttachs, ProjectBillsAttachsDto> implements ProjectBillsAttachsServiceClient {
    private Logger logger = LoggerFactory.getLogger(getClass());
    @Resource
    private ProjectBillsAttachsService projectBillsAttachsService;

    @Override
    public ProjectBillsAttachsDto queryObject(Long id) {
        ProjectBillsAttachs projectBillsAttachs = projectBillsAttachsService.selectById(id);
        ProjectBillsAttachsDto projectBillsAttachsDto = new ProjectBillsAttachsDto();
        BeanUtils.copyProperties(projectBillsAttachs, projectBillsAttachsDto);
        return projectBillsAttachsDto;
    }

    @Override
    public List<ProjectBillsAttachsDto> queryList(Map<String, Object> map) {
        List<ProjectBillsAttachs> projectBillsAttachsList = projectBillsAttachsService.selectByMap(map);
        return convertList(projectBillsAttachsList, ProjectBillsAttachsDto.class);
    }

    @Override
    public int queryTotal(Map<String, Object> map) {
        EntityWrapper<ProjectBillsAttachs> ew = new EntityWrapper<>();
        ew.allEq(map);
        return projectBillsAttachsService.selectCount(ew);
    }

    @Override
    public ExecuteResult<String> save(ProjectBillsAttachsDto projectBillsAttachsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            ProjectBillsAttachs projectBillsAttachs = new ProjectBillsAttachs();
            revert(projectBillsAttachsDto, projectBillsAttachs);
            boolean flag = projectBillsAttachsService.insert(projectBillsAttachs);
            if (!flag) {
                result.addErrorMessage("保存失败。");
            }
        } catch (Exception e) {
            logger.error(" 保存错误：" + e.toString(), e);
            result.addErrorMessage("保存错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> update(ProjectBillsAttachsDto projectBillsAttachsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            ProjectBillsAttachs projectBillsAttachs = new ProjectBillsAttachs();
            revert(projectBillsAttachsDto, projectBillsAttachs);

            boolean flag = projectBillsAttachsService.updateById(projectBillsAttachs);
            if (!flag) {
                result.addErrorMessage("更新失败。");
            }
        } catch (Exception e) {
            logger.error(" 更新错误：" + e.toString(), e);
            result.addErrorMessage("更新错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> delete(Long id) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = projectBillsAttachsService.deleteById(id);
            if (!flag) {
                result.addErrorMessage("删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = projectBillsAttachsService.deleteBatchIds(ids);
            if (!flag) {
                result.addErrorMessage("批量删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public Page<ProjectBillsAttachsDto> getPage(Page<ProjectBillsAttachsDto> pageDto, ProjectBillsAttachsDto projectBillsAttachsDto) {
        Page<ProjectBillsAttachs> page = new Page<>(pageDto.getCurrent(), pageDto.getSize());
        page.setAsc(pageDto.isAsc());
        page.setOrderByField(pageDto.getOrderByField());
        page.setCondition(pageDto.getCondition());
        ProjectBillsAttachs projectBillsAttachs = new ProjectBillsAttachs();
        revert(projectBillsAttachsDto, projectBillsAttachs);
        EntityWrapper<ProjectBillsAttachs> wrapper = new EntityWrapper<>();
        wrapper.setEntity(projectBillsAttachs);
        page = projectBillsAttachsService.selectPage(page, wrapper);
        List<ProjectBillsAttachsDto> projectBillsAttachsDtoList = convertList(page.getRecords(), ProjectBillsAttachsDto.class);
        pageDto.setTotal(projectBillsAttachsService.selectCount(wrapper));
        pageDto.setRecords(projectBillsAttachsDtoList);
        return pageDto;
    }
}
