
package io.platform.projectSettlement.service.client.impl;

import com.alibaba.dubbo.config.annotation.Service;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;


import io.platform.projectSettlement.biz.entity.ProjectStlBillsItems;
import io.platform.projectSettlement.biz.service.ProjectStlBillsItemsService;
import io.platform.projectSettlement.dto.ProjectStlBillsItemsDto;
import io.platform.projectSettlement.service.client.api.ProjectStlBillsItemsServiceClient;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

import io.platform.base.common.BaseServiceClient;
import io.platform.base.common.utils.ExecuteResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Created by sevelli on 2017/8/31.
 */
@Component
@Service()
public class ProjectStlBillsItemsServiceClientImpl extends BaseServiceClient<ProjectStlBillsItems, ProjectStlBillsItemsDto> implements ProjectStlBillsItemsServiceClient {
    private Logger logger = LoggerFactory.getLogger(getClass());
    @Resource
    private ProjectStlBillsItemsService projectStlBillsItemsService;

    @Override
    public ProjectStlBillsItemsDto queryObject(Long id) {
        ProjectStlBillsItems projectStlBillsItems = projectStlBillsItemsService.selectById(id);
        ProjectStlBillsItemsDto projectStlBillsItemsDto = new ProjectStlBillsItemsDto();
        BeanUtils.copyProperties(projectStlBillsItems, projectStlBillsItemsDto);
        return projectStlBillsItemsDto;
    }

    @Override
    public List<ProjectStlBillsItemsDto> queryList(Map<String, Object> map) {
        List<ProjectStlBillsItems> projectStlBillsItemsList = projectStlBillsItemsService.selectByMap(map);
        return convertList(projectStlBillsItemsList, ProjectStlBillsItemsDto.class);
    }

    @Override
    public int queryTotal(Map<String, Object> map) {
        EntityWrapper<ProjectStlBillsItems> ew = new EntityWrapper<>();
        ew.allEq(map);
        return projectStlBillsItemsService.selectCount(ew);
    }

    @Override
    public ExecuteResult<String> save(ProjectStlBillsItemsDto projectStlBillsItemsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            ProjectStlBillsItems projectStlBillsItems = new ProjectStlBillsItems();
            revert(projectStlBillsItemsDto, projectStlBillsItems);
            boolean flag = projectStlBillsItemsService.insert(projectStlBillsItems);
            if (!flag) {
                result.addErrorMessage("保存失败。");
            }
        } catch (Exception e) {
            logger.error(" 保存错误：" + e.toString(), e);
            result.addErrorMessage("保存错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> update(ProjectStlBillsItemsDto projectStlBillsItemsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            ProjectStlBillsItems projectStlBillsItems = new ProjectStlBillsItems();
            revert(projectStlBillsItemsDto, projectStlBillsItems);

            boolean flag = projectStlBillsItemsService.updateById(projectStlBillsItems);
            if (!flag) {
                result.addErrorMessage("更新失败。");
            }
        } catch (Exception e) {
            logger.error(" 更新错误：" + e.toString(), e);
            result.addErrorMessage("更新错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> delete(Long id) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = projectStlBillsItemsService.deleteById(id);
            if (!flag) {
                result.addErrorMessage("删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = projectStlBillsItemsService.deleteBatchIds(ids);
            if (!flag) {
                result.addErrorMessage("批量删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public Page<ProjectStlBillsItemsDto> getPage(Page<ProjectStlBillsItemsDto> pageDto, ProjectStlBillsItemsDto projectStlBillsItemsDto) {
        Page<ProjectStlBillsItems> page = new Page<>(pageDto.getCurrent(), pageDto.getSize());
        page.setAsc(pageDto.isAsc());
        page.setOrderByField(pageDto.getOrderByField());
        page.setCondition(pageDto.getCondition());
        ProjectStlBillsItems projectStlBillsItems = new ProjectStlBillsItems();
        revert(projectStlBillsItemsDto, projectStlBillsItems);
        EntityWrapper<ProjectStlBillsItems> wrapper = new EntityWrapper<>();
        wrapper.setEntity(projectStlBillsItems);
        page = projectStlBillsItemsService.selectPage(page, wrapper);
        List<ProjectStlBillsItemsDto> projectStlBillsItemsDtoList = convertList(page.getRecords(), ProjectStlBillsItemsDto.class);
        pageDto.setTotal(projectStlBillsItemsService.selectCount(wrapper));
        pageDto.setRecords(projectStlBillsItemsDtoList);
        return pageDto;
    }
}
