
package io.platform.projectSettlement.service.client.impl;

import com.alibaba.dubbo.config.annotation.Service;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;

import io.platform.project.biz.entity.ProjectBillsSubs;
import io.platform.project.biz.entity.Projectbills;
import io.platform.project.biz.entity.SubContractBills;
import io.platform.project.biz.service.ProjectBillsSubsService;
import io.platform.project.biz.service.ProjectbillsService;
import io.platform.project.biz.service.SubContractBillsService;
import io.platform.project.dto.ProjectBillsSubsDto;
import io.platform.projectSettlement.biz.entity.ProjectBillsAttachs;
import io.platform.projectSettlement.biz.entity.ProjectStlBills;
import io.platform.projectSettlement.biz.entity.ProjectStlBillsItems;
import io.platform.projectSettlement.biz.service.ProjectBillsAttachsService;
import io.platform.projectSettlement.biz.service.ProjectStlBillsItemsService;
import io.platform.projectSettlement.biz.service.ProjectStlBillsService;
import io.platform.projectSettlement.dto.ProjectStlBillsDto;
import io.platform.projectSettlement.service.client.api.ProjectStlBillsServiceClient;
import io.platform.sys.dto.SysUserDto;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.text.SimpleDateFormat;
import java.time.Instant;
import java.time.LocalDateTime;
import java.time.LocalTime;
import java.time.ZoneId;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import io.platform.base.common.BaseServiceClient;
import io.platform.base.common.utils.ExecuteResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;

/**
 * Created by sevelli on 2017/8/31.
 */
@Component
@Service(version = "1.0.0", interfaceClass = ProjectStlBillsServiceClient.class)
public class ProjectStlBillsServiceClientImpl extends BaseServiceClient<ProjectStlBills, ProjectStlBillsDto> implements ProjectStlBillsServiceClient {
    private Logger logger = LoggerFactory.getLogger(getClass());
    @Resource
    private ProjectbillsService projectbillsService;
    @Resource
    private ProjectStlBillsService projectStlBillsService;
    @Resource
    private ProjectBillsSubsService projectBillsSubsService;
    @Resource
    private SubContractBillsService subContractBillsService;
    @Resource
    private ProjectBillsAttachsService projectBillsAttachsService;
    @Resource
    private ProjectStlBillsItemsService projectStlBillsItemsService;

    @Override
    public ProjectStlBillsDto queryObject(Long id) {
        ProjectStlBills projectStlBills = projectStlBillsService.selectById(id);
        ProjectStlBillsDto projectStlBillsDto = new ProjectStlBillsDto();
        BeanUtils.copyProperties(projectStlBills, projectStlBillsDto);
        return projectStlBillsDto;
    }

    @Override
    public List<ProjectStlBillsDto> queryList(Map<String, Object> map) {
        List<ProjectStlBills> projectStlBillsList = projectStlBillsService.selectByMap(map);
        return convertList(projectStlBillsList, ProjectStlBillsDto.class);
    }

    @Override
    public int queryTotal(Map<String, Object> map) {
        EntityWrapper<ProjectStlBills> ew = new EntityWrapper<>();
        ew.allEq(map);
        return projectStlBillsService.selectCount(ew);
    }

    @Override
    public ExecuteResult<String> save(ProjectStlBillsDto projectStlBillsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            ProjectStlBills projectStlBills = new ProjectStlBills();
            revert(projectStlBillsDto, projectStlBills);
            boolean flag = projectStlBillsService.insert(projectStlBills);
            if (!flag) {
                result.addErrorMessage("保存失败。");
            }
        } catch (Exception e) {
            logger.error(" 保存错误：" + e.toString(), e);
            result.addErrorMessage("保存错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> update(ProjectStlBillsDto projectStlBillsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            ProjectStlBills projectStlBills = new ProjectStlBills();
            revert(projectStlBillsDto, projectStlBills);

            boolean flag = projectStlBillsService.updateById(projectStlBills);
            if (!flag) {
                result.addErrorMessage("更新失败。");
            }
        } catch (Exception e) {
            logger.error(" 更新错误：" + e.toString(), e);
            result.addErrorMessage("更新错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> delete(Long id) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = projectStlBillsService.deleteById(id);
            if (!flag) {
                result.addErrorMessage("删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = projectStlBillsService.deleteBatchIds(ids);
            if (!flag) {
                result.addErrorMessage("批量删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public Map<String, Object> proStlBillsPage(Map<String, Object> map) {
        Map<String, Object> objectMap = new HashMap<>();
        try {
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            if (map.get("startDate") != null && map.get("startDate") != "") {
                long startimes = (long) map.get("startDate");
                String startTime = sdf.format(new Date(startimes));
                map.put("startDateTime", startTime);
            }
            if (map.get("endDate") != null && map.get("endDate") != "") {
                long endtimes = (long) map.get("endDate");
                LocalDateTime localDateTime = LocalDateTime.ofInstant(Instant.ofEpochMilli(endtimes), ZoneId.systemDefault());
                LocalDateTime endOfDay = localDateTime.with(LocalTime.MAX);
                Date from = Date.from(endOfDay.atZone(ZoneId.systemDefault()).toInstant());
                String endTime = sdf.format(from);
                map.put("endDateTime", endTime);
            }
            int num = projectStlBillsService.selectProStlBillsPageTotal(map);
            if (num != 0) {
                int current = (int) map.get("current");
                int size = (int) map.get("size");
                if (current <= 1) {
                    current = 0;
                } else {
                    current = (current - 1) * size;
                }
                map.put("size", size);
                map.put("current", current);
                List<Map<String, Object>> mapList = projectStlBillsService.selectProStlBillsPageRecords(map);
                Page pageDto = new Page<>();
                pageDto.setTotal(num);
                pageDto.setRecords(mapList);
                objectMap.put("page", pageDto);
            }
            return objectMap;
        } catch (Exception e) {
            logger.error("操作异常：" + e.toString(), e);
        }
        return null;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> projectStlSave(String projectStlBill, String projectStls, String dataAttachs, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            ProjectStlBills projectStlBills = JSONArray.parseObject(projectStlBill, ProjectStlBills.class);
            JSONArray jsonArray = JSONArray.parseArray(projectStls);
            List<ProjectStlBillsItems> projectStlBillsItemsList = JSONObject.parseArray(jsonArray.toJSONString(), ProjectStlBillsItems.class);
            JSONArray array = JSONArray.parseArray(dataAttachs);
            List<ProjectBillsAttachs> projectBillsAttachsList = JSONObject.parseArray(array.toJSONString(), ProjectBillsAttachs.class);
            if (projectStlBills != null) {
                EntityWrapper<ProjectStlBills> projectStlBillsEntityWrapper = new EntityWrapper<>();
                projectStlBillsEntityWrapper.setSqlSelect("id").eq("bill_no", projectStlBills.getBillNo());
                ProjectStlBills stlBills = projectStlBillsService.selectOne(projectStlBillsEntityWrapper);
                if (stlBills != null) {
                    stlBills.setOpUserId(sysUserDto.getUserId().intValue());
                    stlBills.setOpUserName(sysUserDto.getUsername());
                    stlBills.setBillStatus(6);
                    stlBills.setOpDate(new Date());
                    stlBills.setBillDate(new Date());
                    stlBills.setRemarks(projectStlBills.getRemarks());
                    stlBills.setBranchId(projectStlBills.getBranchId());
                    stlBills.setProjectSubNo(projectStlBills.getProjectSubNo());
                    stlBills.setCorpId(projectStlBills.getCorpId());
                    stlBills.setContractAuditAmt(projectStlBills.getContractAuditAmt());
                    stlBills.setContractAuditDate(projectStlBills.getContractAuditDate());
                    stlBills.setBudgetAmt(projectStlBills.getBudgetAmt());
                    stlBills.setSubContractAuditAmt(projectStlBills.getSubContractAuditAmt());
                    boolean updateById = projectStlBillsService.updateById(stlBills);
                    if (!updateById) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("结算失败：更新主表失败");
                        return result;
                    }
                } else {
                    projectStlBills.setActId(206);
                    projectStlBills.setBillStatus(6);
                    projectStlBills.setOpUserId(sysUserDto.getUserId().intValue());
                    projectStlBills.setOpUserName(sysUserDto.getUsername());
                    projectStlBills.setOpDate(new Date());
                    projectStlBills.setBillDate(new Date());
                    projectStlBills.setPostDate(new Date());
                    boolean insert = projectStlBillsService.insert(projectStlBills);
                    if (!insert) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("结算失败：新建主表失败");
                        return result;
                    }
                }
                if (projectStlBillsItemsList.size() != 0) {
                    EntityWrapper<ProjectStlBillsItems> projectStlBillsItemsEntityWrapper = new EntityWrapper<>();
                    projectStlBillsItemsEntityWrapper.setSqlSelect("id").eq("bill_no", projectStlBills.getBillNo());
                    List<ProjectStlBillsItems> stlBillsItemsList = projectStlBillsItemsService.selectList(projectStlBillsItemsEntityWrapper);
                    if (stlBillsItemsList.size() != 0) {
                        for (ProjectStlBillsItems pb : stlBillsItemsList) {
                            boolean deleteById = projectStlBillsItemsService.deleteById(pb);
                            if (!deleteById) {
                                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                result.addErrorMessage("结算失败：删除旧数据失败");
                                return result;
                            }
                        }
                    }
                    int line = 0;
                    for (ProjectStlBillsItems pb : projectStlBillsItemsList) {
                        line++;
                        pb.setBillNo(projectStlBills.getBillNo());
                        pb.setLineNo(line);
                        pb.setActId(206);
                        pb.setStlDate(new Date());
                        boolean insert = projectStlBillsItemsService.insert(pb);
                        if (!insert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("结算失败：新建明细表失败");
                            return result;
                        }
                        EntityWrapper<SubContractBills> subContractBillsEntityWrapper = new EntityWrapper<>();
                        subContractBillsEntityWrapper.setSqlSelect("id", "settlement_status").eq("purchase_plan_no", pb.getPurchaseNo())
                                .eq("purchase_id", pb.getPurchaseId());
                        SubContractBills subContractBills = subContractBillsService.selectOne(subContractBillsEntityWrapper);
                        if (subContractBills != null) {
                            subContractBills.setSettlementStatus(6);
                            boolean updateById = subContractBillsService.updateById(subContractBills);
                            if (!updateById) {
                                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                result.addErrorMessage("结算失败：更新分包结算失败失败");
                                return result;
                            }
                        }
                    }
                }
                if (projectBillsAttachsList.size() != 0) {
                    EntityWrapper<ProjectBillsAttachs> projectBillsAttachsEntityWrapper = new EntityWrapper<>();
                    projectBillsAttachsEntityWrapper.setSqlSelect("id").eq("bill_no", projectStlBills.getBillNo());
                    List<ProjectBillsAttachs> projectBillsAttachs = projectBillsAttachsService.selectList(projectBillsAttachsEntityWrapper);
                    if (projectBillsAttachs.size() != 0) {
                        for (ProjectBillsAttachs pb : projectBillsAttachs) {
                            boolean deleteById = projectBillsAttachsService.deleteById(pb);
                            if (!deleteById) {
                                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                result.addErrorMessage("结算失败：删除旧数据失败");
                                return result;
                            }
                        }
                    }
                    int line = 0;
                    for (ProjectBillsAttachs pb : projectBillsAttachsList) {
                        line++;
                        pb.setBillNo(projectStlBills.getBillNo());
                        pb.setLineNo(line);
                        pb.setActId(206);
                        pb.setOpUserId(sysUserDto.getUserId().intValue());
                        pb.setOpUserName(sysUserDto.getUsername());
                        pb.setOpDate(new Date());
                        boolean insert = projectBillsAttachsService.insert(pb);
                        if (!insert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("结算失败：新建附件表失败");
                            return result;
                        }
                    }
                }
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 提交错误：" + e.toString(), e);
            result.addErrorMessage("结算失败请确认信息重新提交");
        }
        return result;
    }

    @Override
    public Map<String, Object> querySubContract(ProjectBillsSubsDto projectBillsSubsDto) {
        //  总包结算日期
        if (projectBillsSubsDto != null && projectBillsSubsDto.getId() != null) {
            EntityWrapper<ProjectBillsSubs> entityWrapper = new EntityWrapper<>();
            entityWrapper.eq("id", projectBillsSubsDto.getId());
            ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(entityWrapper);
            if (projectBillsSubs.getBillNo() != null && !projectBillsSubs.getBillNo().equals("")) {
                Map<String, Object> map = new HashMap<>();
                EntityWrapper<Projectbills> projectbillsEntityWrapper = new EntityWrapper<>();
                projectbillsEntityWrapper.eq("bill_no", projectBillsSubs.getBillNo());
                Projectbills projectbills = projectbillsService.selectOne(projectbillsEntityWrapper);
                if (projectbills != null) {
                    map.put("project", projectbills);
                    return map;
                }
            }
        }
        return null;
    }

    @Override
    public Map<String, Object> fuzzyQueryPSTl(ProjectStlBillsDto projectStlBillsDto) {
        if (projectStlBillsDto.getId() != null && projectStlBillsDto.getId() != 0) {
            Map<String, Object> map = new HashMap<>();
            EntityWrapper<ProjectStlBills> projectStlBillsEntityWrapper = new EntityWrapper<>();
            projectStlBillsEntityWrapper.eq("id", projectStlBillsDto.getId());
            ProjectStlBills projectStlBills = projectStlBillsService.selectOne(projectStlBillsEntityWrapper);
            if (projectStlBills != null) {
                EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
                projectBillsSubsEntityWrapper.eq("project_sub_no", projectStlBills.getProjectSubNo());
                ProjectBillsSubs billsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
                if (billsSubs != null) {
                    EntityWrapper<Projectbills> projectbillsEntityWrapper = new EntityWrapper<>();
                    projectbillsEntityWrapper.setSqlSelect("id", "act_start_date", "act_end_date", "act_days", "contract_audit_amt", "contract_tax_rate")
                            .eq("bill_no", billsSubs.getBillNo());
                    Projectbills projectbills = projectbillsService.selectOne(projectbillsEntityWrapper);
                    if (projectbills != null) {
                        map.put("proBills", projectbills);
                    }
                    map.put("proSub", billsSubs);
                }
                map.put("projectStl", projectStlBills);
                EntityWrapper<ProjectStlBillsItems> projectStlBillsItemsEntityWrapper = new EntityWrapper<>();
                projectStlBillsItemsEntityWrapper.eq("bill_no", projectStlBills.getBillNo())
                        .eq("project_sub_no", projectStlBills.getProjectSubNo());
                List<ProjectStlBillsItems> projectStlBillsItemsList = projectStlBillsItemsService.selectList(projectStlBillsItemsEntityWrapper);
                if (projectStlBillsItemsList.size() != 0) {
                    map.put("proStlItems", projectStlBillsItemsList);
                }
                EntityWrapper<ProjectBillsAttachs> projectBillsAttachsEntityWrapper = new EntityWrapper<>();
                projectBillsAttachsEntityWrapper.eq("bill_no", projectStlBills.getBillNo());
                List<ProjectBillsAttachs> projectBillsAttachs = projectBillsAttachsService.selectList(projectBillsAttachsEntityWrapper);
                if (projectBillsAttachs.size() != 0) {
                    map.put("proStlAttachs", projectBillsAttachs);
                }
                return map;
            }
        }
        return null;
    }
}
