package io.platform.purchase.biz.entity;

import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.enums.IdType;

import java.io.Serializable;
import lombok.Data;

@Data
@TableName("purchase_bills")
public class PurchaseBills extends Model<PurchaseBills>  implements Serializable{
private static final long serialVersionUID = 5454155825314635342L;


    /**
     * id       db_column: id
     */
    @TableId(value="id", type= IdType.AUTO)
    private Integer id;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

    /**
     * 单据编号       db_column: bill_no
     */
    @TableField("bill_no")
    private String billNo;

    /**
     * 业务活动号ID       db_column: act_id
     */
    @TableField("act_id")
    private Integer actId;

    /**
     * 来源活动ID       db_column: src_act_id
     */
    @TableField("src_act_id")
    private Integer srcActId;

    /**
     * 来源单据编号       db_column: src_bill_no
     */
    @TableField("src_bill_no")
    private String srcBillNo;

    /**
     * 来源行号       db_column: src_line_no
     */
    @TableField("src_line_no")
    private Integer srcLineNo;

    /**
     * 原始活动ID       db_column: org_act_id
     */
    @TableField("org_act_id")
    private Integer orgActId;

    /**
     * 原始编号       db_column: org_bill_no
     */
    @TableField("org_bill_no")
    private String orgBillNo;

    /**
     * 原始行号       db_column: org_line_no
     */
    @TableField("org_line_no")
    private Integer orgLineNo;

    /**
     * 单据状态（1-新建2处理中6完成）       db_column: bill_status
     */
    @TableField("bill_status")
    private Integer billStatus;

    /**
     * 制单人ID       db_column: op_user_id
     */
    @TableField("op_user_id")
    private Integer opUserId;

    /**
     * 制单人姓名       db_column: op_user_name
     */
    @TableField("op_user_name")
    private String opUserName;

    /**
     * 制单日期       db_column: create_date
     */
    @TableField("create_date")
    private java.util.Date createDate;

    /**
     * 业务日期       db_column: bill_date
     */
    @TableField("bill_date")
    private java.util.Date billDate;

    /**
     * 提交日期       db_column: post_date
     */
    @TableField("post_date")
    private java.util.Date postDate;

    /**
     * 备注       db_column: remark
     */
    @TableField("remark")
    private String remark;

    /**
     * 计划编号或采购编号       db_column: purchase_no
     */
    @TableField("purchase_no")
    private String purchaseNo;

    /**
     * 工程编号（下拉选择）       db_column: project_no
     */
    @TableField("project_sub_no")
    private String projectSubNo;

    /**
     * 本次占用预算金额       db_column: amt
     */
    @TableField("amt")
    private Double amt;

    /**
     * 材料预算金额       db_column: budget_amt
     */
    @TableField("budget_amt")
    private Double budgetAmt;

    /**
     * 累计占用预算金额       db_column: budget_use_amt
     */
    @TableField("budget_use_amt")
    private Double budgetUseAmt;

    /**
     * 剩余预算金额       db_column: budget_blc_amt
     */
    @TableField("budget_blc_amt")
    private Double budgetBlcAmt;
    /**
     * 采购方式ID（基础资料B_PurchaseMode）       db_column: purchase_mode_id
     */
    @TableField("purchase_mode_id")
    private Integer purchaseModeId;

    /**
     * 采购方式选择理由       db_column: purchase_mode_desc
     */
    @TableField("purchase_mode_desc")
    private String purchaseModeDesc;

    /**
     * 是否客户指定       db_column: if_corp_assign
     */
    @TableField("if_corp_assign")
    private String ifCorpAssign;

    /**
     * 单一来源采购详细说明       db_column: corp_assign_desc
     */
    @TableField("corp_assign_desc")
    private String corpAssignDesc;

    /**
     * 供应商ID       db_column: purchase_id purchase_src_id
     */
    @TableField("purchase_id")
    private Integer purchaseId;

    /**
     * 计划类型ID       db_column: purchase_src_id
     */
    @TableField("purchase_src_id")
    private Integer purchaseSrcId;
    /***
     * 附件地址
     */
    @TableField("file_Address")
    private String fileAddress;
    /***
     *  申请单位
     */
    @TableField("contractor_id")
    private Integer contractorId;
//columns END

}
