
package io.platform.purchase.service.client.impl;

import com.alibaba.dubbo.config.annotation.Service;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;


//import com.google.gson.Gson;
import io.platform.base.common.utils.CopyUtils;
import io.platform.budget.biz.entity.ProjectBillsBudgets;
import io.platform.budget.biz.service.ProjectBillsBudgetsService;
import io.platform.engineering.biz.entity.Bpurchases;
import io.platform.engineering.dto.BpurchasesDto;
import io.platform.moneyManagement.biz.entity.PayCrBills;
import io.platform.project.biz.entity.ProjectBillsSubs;
import io.platform.project.biz.service.ProjectBillsSubsService;
import io.platform.project.biz.service.SubContractBillsService;
import io.platform.project.dto.ProjectBillsSubsDto;
import io.platform.purchase.biz.entity.PurchaseBills;
import io.platform.purchase.biz.entity.PurchaseBillsItems;
import io.platform.purchase.biz.service.PurchaseBillsItemsService;
import io.platform.purchase.dto.PurchaseBillsDto;
import io.platform.purchase.dto.PurchaseBillsItemsDto;
import io.platform.purchase.service.client.api.PurchaseBillsItemsServiceClient;
import io.platform.sys.biz.entity.SysRole;
import io.platform.sys.dto.SysUserDto;
import io.platform.utils.DataUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.*;

import io.platform.base.common.BaseServiceClient;
import io.platform.base.common.utils.ExecuteResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;

/**
 * Created by sevelli on 2017/8/31.
 */
@Component
@Service(version = "1.0.0", interfaceClass = PurchaseBillsItemsServiceClient.class)
public class PurchaseBillsItemsServiceClientImpl extends BaseServiceClient<PurchaseBillsItems, PurchaseBillsItemsDto> implements PurchaseBillsItemsServiceClient {
    private Logger logger = LoggerFactory.getLogger(getClass());
    @Resource
    private SubContractBillsService subContractBillsService;
    @Resource
    private ProjectBillsSubsService projectBillsSubsService;
    @Resource
    private PurchaseBillsItemsService purchaseBillsItemsService;
    @Resource
    private ProjectBillsBudgetsService projectBillsBudgetsService;

    @Override
    public PurchaseBillsItemsDto queryObject(Long id) {
        PurchaseBillsItems purchaseBillsItems = purchaseBillsItemsService.selectById(id);
        PurchaseBillsItemsDto purchaseBillsItemsDto = new PurchaseBillsItemsDto();
        BeanUtils.copyProperties(purchaseBillsItems, purchaseBillsItemsDto);
        return purchaseBillsItemsDto;
    }

    @Override
    public List<PurchaseBillsItemsDto> queryList(Map<String, Object> map) {
        List<PurchaseBillsItems> purchaseBillsItemsList = purchaseBillsItemsService.selectByMap(map);
        return convertList(purchaseBillsItemsList, PurchaseBillsItemsDto.class);
    }

    @Override
    public int queryTotal(Map<String, Object> map) {
        EntityWrapper<PurchaseBillsItems> ew = new EntityWrapper<>();
        ew.allEq(map);
        return purchaseBillsItemsService.selectCount(ew);
    }

    @Override
    public ExecuteResult<String> save(PurchaseBillsItemsDto purchaseBillsItemsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            PurchaseBillsItems purchaseBillsItems = new PurchaseBillsItems();
            revert(purchaseBillsItemsDto, purchaseBillsItems);
            boolean flag = purchaseBillsItemsService.insert(purchaseBillsItems);
            if (!flag) {
                result.addErrorMessage("保存失败。");
            }
        } catch (Exception e) {
            logger.error(" 保存错误：" + e.toString(), e);
            result.addErrorMessage("保存错误：" + e.toString());
        }
        return result;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> update(PurchaseBillsItemsDto purchaseBillsItemsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            PurchaseBillsItems purchaseBillsItems = new PurchaseBillsItems();
            revert(purchaseBillsItemsDto, purchaseBillsItems);

            boolean flag = purchaseBillsItemsService.updateById(purchaseBillsItems);
            if (!flag) {
                result.addErrorMessage("更新失败。");
            }
        } catch (Exception e) {
            logger.error(" 更新错误：" + e.toString(), e);
            result.addErrorMessage("更新错误：" + e.toString());
        }
        return result;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> delete(Long id) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = purchaseBillsItemsService.deleteById(id);
            if (!flag) {
                result.addErrorMessage("删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = purchaseBillsItemsService.deleteBatchIds(ids);
            if (!flag) {
                result.addErrorMessage("批量删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public Page<PurchaseBillsItemsDto> getPage(Page<PurchaseBillsItemsDto> pageDto, PurchaseBillsItemsDto purchaseBillsItemsDto) {
        Page<PurchaseBillsItems> page = new Page<>(pageDto.getCurrent(), pageDto.getSize());
        page.setAsc(pageDto.isAsc());
        page.setOrderByField(pageDto.getOrderByField());
        page.setCondition(pageDto.getCondition());
        PurchaseBillsItems purchaseBillsItems = new PurchaseBillsItems();
        revert(purchaseBillsItemsDto, purchaseBillsItems);
        EntityWrapper<PurchaseBillsItems> wrapper = new EntityWrapper<>();
        wrapper.setEntity(purchaseBillsItems);
        page = purchaseBillsItemsService.selectPage(page, wrapper);
        List<PurchaseBillsItemsDto> purchaseBillsItemsDtoList = convertList(page.getRecords(), PurchaseBillsItemsDto.class);
        pageDto.setTotal(purchaseBillsItemsService.selectCount(wrapper));
        pageDto.setRecords(purchaseBillsItemsDtoList);
        return pageDto;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> deleteItem(PurchaseBillsItemsDto purchaseBillsItemsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            Boolean itemType = purchaseBillsItemsService.deleteById(purchaseBillsItemsDto.getId());
            if (!itemType) {
                result.addErrorMessage("删除失败！");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public Map<String, Object> maintenancePage(Page<PurchaseBillsItemsDto> page, PurchaseBillsItemsDto purchaseBillsItemsDto, String list) {
        Page pageDto = DataUtils.processingPage(page);
        Map<String, Object> xmap = new HashMap<>();
        Map<String, Object> map = new HashMap<>();
        xmap.put("sub", list);
        xmap.put("dto", purchaseBillsItemsDto);
        xmap.put("curr", pageDto.getCurrent());
        xmap.put("size", pageDto.getSize());
        List<PurchaseBillsItems> purchaseBillsItems = purchaseBillsItemsService.selectItemPage(xmap);
        int sum = purchaseBillsItems.size();
        if (sum != 0) {
            pageDto.setTotal(sum);
            pageDto.setRecords(purchaseBillsItems);
            map.put("page", pageDto);
            return map;
        }
        return null;
    }

    @Override
    public List<PurchaseBillsItemsDto> selectArrivalSum(List<PurchaseBillsItemsDto> list) {
        List<PurchaseBillsItems> purchaseBillsItems = purchaseBillsItemsService.selectArrivalSum(list);
        List<PurchaseBillsItemsDto> purchaseBillsItemsDtos = new ArrayList<>();
        if (purchaseBillsItems == null || purchaseBillsItems.size() <= 0) {
            return null;
        } else {
            for (PurchaseBillsItemsDto dto : list) {
                for (PurchaseBillsItems item : purchaseBillsItems) {
                    if (item.getSrcBillNo().equals(dto.getBillNo()) && item.getSrcLinoNo().equals(dto.getLinoNo())) {
                        dto.setReceiveTotalQty(item.getReceiveTotalQty());
                        purchaseBillsItemsDtos.add(dto);
                        break;
                    }
                }
            }
        }
        return purchaseBillsItemsDtos;
    }

    @Override
    public Map<String, Object> selectProjectResult(String sub) {
        Map<String, Object> map = new HashMap<>();
        EntityWrapper<PurchaseBillsItems> itemsEntityWrapper = new EntityWrapper<>();
        // Integer[] act = new Integer[]{1,7};
        itemsEntityWrapper.in("act_id", new Integer[]{1, 7});
        itemsEntityWrapper.eq("project_Sub_No", sub);
        List<PurchaseBillsItems> purchaseBillsItemsList = purchaseBillsItemsService.selectList(itemsEntityWrapper);
        if (purchaseBillsItemsList == null || purchaseBillsItemsList.size() <= 0) {
            return null;
        } else {
            List<Double> doubles = new ArrayList<>();
            for (PurchaseBillsItems pb : purchaseBillsItemsList) {
                double amt = purchaseBillsItemsService.selectArrivalVal(pb);
                doubles.add(amt);
            }
            map.put("amts", doubles);
            map.put("item", purchaseBillsItemsList);
            return map;
        }
    }

    @Override
    public Page<PurchaseBillsDto> selectList(Page<PurchaseBillsDto> page, PurchaseBillsDto purchaseBillsDto, SysUserDto sysUserDto) {
        Page pageDto = DataUtils.processingPage(page);
        Map<String, Object> xmap = new HashMap<>();
        SysRole sysRole = subContractBillsService.selectRole(sysUserDto);
        xmap.put("user", sysUserDto);
        xmap.put("role", sysRole);
        xmap.put("dto", purchaseBillsDto);
        int sum = purchaseBillsItemsService.selectListPageCount(xmap);
        if (sum != 0) {
            xmap.put("curr", pageDto.getCurrent());
            xmap.put("size", pageDto.getSize());
            List<Map<String, Object>> list = purchaseBillsItemsService.selectListPage(xmap);
            pageDto.setTotal(sum);
            pageDto.setRecords(list);
            return pageDto;
        }
        return null;
    }

    @Override
    public Map<String, Object> selectSrcType(String mingxi) {
        Map<String, Object> map = new HashMap<>();
        PurchaseBillsItems billsItems = JSONArray.parseObject(mingxi, PurchaseBillsItems.class);
        List<PurchaseBillsItems> purchaseBillsItemsList = purchaseBillsItemsService.selectList(new EntityWrapper<>(billsItems));
        if (purchaseBillsItemsList != null && purchaseBillsItemsList.size() > 0) {
            map.put("item", purchaseBillsItemsList);
            return map;
        }
        return null;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> saveResultItem(String mingxi, SysUserDto sysUserDto) {
        JSONArray arrayList = JSONArray.parseArray(mingxi);
        List<PurchaseBillsItems> billsItems = JSONObject.parseArray(arrayList.toJSONString(), PurchaseBillsItems.class);
        ExecuteResult<String> result = new ExecuteResult<String>();
        double validationAmt = 0.0;
        String subNo = null;
        for (PurchaseBillsItems items : billsItems) {
            subNo = items.getProjectSubNo();
            validationAmt = DataUtils.keepDecimals(validationAmt + items.getPurchaseInvAmt());
            if (items.getContractQty() != null && items.getContractQty() != 0) {
                validationAmt = DataUtils.keepDecimals(validationAmt + items.getContractAmt());
                if (items.getActId() == 1) {
                    PurchaseBillsItems purchaseBillsItems = purchaseBillsItemsService.selectById(items.getId());
                    if (purchaseBillsItems.getReceiveTotalQty() == null) {
                        purchaseBillsItems.setReceiveTotalQty(items.getContractQty());
                    } else {
                        purchaseBillsItems.setReceiveTotalQty(purchaseBillsItems.getReceiveTotalQty() + items.getContractQty());
                    }
                    if (purchaseBillsItems.getPurchaseInvAmt() == null) {
                        purchaseBillsItems.setPurchaseInvAmt(items.getContractAmt());
                    } else {
                        purchaseBillsItems.setPurchaseInvAmt(DataUtils.keepDecimals(purchaseBillsItems.getPurchaseInvAmt() + items.getContractAmt()));
                    }
                    purchaseBillsItems.setPurchaseId(items.getPurchaseId());
                    purchaseBillsItems.setPurchaseName(items.getPurchaseName());
                    purchaseBillsItems.setContractPrice(items.getContractPrice());
                    boolean updateType = purchaseBillsItemsService.updateById(purchaseBillsItems);
                    if (!updateType) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("更新失败");
                        break;
                    } else {
                        items.setActId(4);
                        items.setOpName(sysUserDto.getUsername());
                        items.setOpDate(new Date());
                        items.setId(null);
                        boolean installType = purchaseBillsItemsService.insert(items);
                        if (!installType) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("新增到货记录失败");
                            break;
                        }
                        continue;
                    }
                } if (items.getActId() == 7) {
                    if (items.getId() != null) {
                        PurchaseBillsItems purchaseBillsItems = purchaseBillsItemsService.selectById(items.getId());
                        if (purchaseBillsItems.getReceiveTotalQty() == null) {
                            purchaseBillsItems.setReceiveTotalQty(items.getContractQty());
                        } else {
                            purchaseBillsItems.setReceiveTotalQty(purchaseBillsItems.getReceiveTotalQty() + items.getContractQty());
                        }
                        if (purchaseBillsItems.getPurchaseInvAmt() == null) {
                            purchaseBillsItems.setPurchaseInvAmt(items.getContractAmt());
                        } else {
                            purchaseBillsItems.setPurchaseInvAmt(DataUtils.keepDecimals(purchaseBillsItems.getPurchaseInvAmt() + items.getContractAmt()));
                        }
                        purchaseBillsItems.setContractQty(items.getContractQty());
                        purchaseBillsItems.setContractPrice(items.getContractPrice());
                        boolean updateType = purchaseBillsItemsService.updateById(purchaseBillsItems);
                        if (!updateType) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("更新失败");
                            break;
                        }
                    } else {
                        items.setReceiveTotalQty(items.getContractQty());
                        items.setPurchaseInvAmt(items.getContractAmt()); // 本次合同金额
                        items.setPurchaseInvTime(null);
                        items.setArrivalAcceptanceFile(null);
                        boolean installType = purchaseBillsItemsService.insert(items);
                        if (!installType) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("新增台账失败");
                            break;
                        }
                    }
                    items.setId(null);
                    items.setActId(4);
                    items.setOpName(sysUserDto.getUsername());
                    items.setOpDate(new Date());
                    boolean installType = purchaseBillsItemsService.insert(items);
                    if (!installType) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("新增到货记录失败");
                        break;
                    }
                    continue;
                } else {
                    items.setActId(4);
                    items.setOpName(sysUserDto.getUsername());
                    items.setOpDate(new Date());
                    items.setId(null);
/*                    items.setReceiveTotalQty(null);
                    items.setPurchaseInvAmt(null);*/
                    boolean installResultType = purchaseBillsItemsService.insert(items);
                    if (!installResultType) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("新增到货记录失败");
                        break;
                    }
                }
            } else {
                continue;
            }
        }
        EntityWrapper<ProjectBillsBudgets> billsBudgetsEntityWrapper = new EntityWrapper<>();
        billsBudgetsEntityWrapper.eq("project_sub_no", subNo)
                .eq("branch_id", sysUserDto.getLoginContractorId());
        List<ProjectBillsBudgets> projectBillsBudgets = projectBillsBudgetsService.selectList(billsBudgetsEntityWrapper);
        for (ProjectBillsBudgets pb : projectBillsBudgets) {
            if (Objects.equals(pb.getBudgetId(), 2)) {
                pb.setApprovedAmount(validationAmt);
                if (!projectBillsBudgetsService.updateById(pb)) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("更新预算失败");
                }
            }
        }
        double amt = projectBillsBudgetsService.selectApprovedAmountSum(projectBillsBudgets.get(0));
        EntityWrapper<ProjectBillsSubs> subsEntityWrapper = new EntityWrapper<>();
        subsEntityWrapper.eq("project_sub_no", projectBillsBudgets.get(0).getProjectSubNo())
                .eq("branch_id", projectBillsBudgets.get(0).getBranchId());
        ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(subsEntityWrapper);
        projectBillsSubs.setActualBudgetAmt(amt);
        boolean updateById = projectBillsSubsService.updateById(projectBillsSubs);
        if (!updateById) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            result.addErrorMessage("更新预算失败");
        }
        return result;
    }

    @Override
    public Page<BpurchasesDto> selectResultPurchase(Page<BpurchasesDto> page, ProjectBillsSubsDto projectBillsSubsDto, SysUserDto sysUserDto) {
        Map<String, Object> map = new HashMap<>();
        Page page1 = DataUtils.processingPage(page);
        map.put("page", page1);
        map.put("dto", projectBillsSubsDto);
        map.put("sys", sysUserDto);
        int purchaseNumber = purchaseBillsItemsService.selectResultPurchaseNumber(map);
        if (purchaseNumber != 0) {
            List<BpurchasesDto> mapList = purchaseBillsItemsService.selectResultPurchase(map);
            page.setRecords(mapList);
            page.setTotal(purchaseNumber);
        }
        return page;
    }
}
