
package io.platform.purchase.service.client.impl;

import com.alibaba.dubbo.config.annotation.Service;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;


import io.platform.approvalConfiguration.biz.entity.Audit;
import io.platform.approvalConfiguration.biz.service.AuditItemsService;
import io.platform.budget.biz.entity.ProjectBillsBudgets;
import io.platform.budget.biz.service.ProjectBillsBudgetsService;
import io.platform.engineering.biz.entity.*;
import io.platform.engineering.biz.service.BbranchsService;
import io.platform.engineering.biz.service.BpurchaseModesService;
import io.platform.engineering.biz.service.BpurchaseSubTypesService;
import io.platform.engineering.biz.service.BpurchasesService;
import io.platform.project.biz.entity.ProjectBillsSubs;
import io.platform.project.biz.entity.Projectbills;
import io.platform.project.biz.service.ProjectBillsSubsService;
import io.platform.project.biz.service.ProjectbillsService;
import io.platform.project.biz.service.SubContractBillsService;
import io.platform.purchase.biz.entity.PurchaseBills;
import io.platform.purchase.biz.entity.PurchaseBillsItems;
import io.platform.purchase.biz.entity.PurchaseBillsProjs;
import io.platform.purchase.biz.entity.PurchaseBillsPurids;
import io.platform.purchase.biz.service.PurchaseBillsProjsService;
import io.platform.purchase.biz.service.PurchaseBillsPuridsService;
import io.platform.purchase.biz.service.PurchaseBillsService;
import io.platform.purchase.dto.PurchaseBillsDto;
import io.platform.purchase.dto.PurchaseBillsProjsDto;
import io.platform.purchase.dto.PurchaseBillsPuridsDto;
import io.platform.purchase.service.client.api.PurchaseBillsProjsServiceClient;
import io.platform.sys.biz.entity.SysRole;
import io.platform.sys.biz.entity.SysUser;
import io.platform.sys.biz.service.SysUserService;
import io.platform.sys.dto.SysUserDto;
import io.platform.utils.DataUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.*;

import io.platform.base.common.BaseServiceClient;
import io.platform.base.common.utils.ExecuteResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;

/**
 * Created by sevelli on 2017/8/31.
 */
@Component
@Service(version = "1.0.0", interfaceClass = PurchaseBillsProjsServiceClient.class)
public class PurchaseBillsProjsServiceClientImpl extends BaseServiceClient<PurchaseBillsProjs, PurchaseBillsProjsDto> implements PurchaseBillsProjsServiceClient {
    private Logger logger = LoggerFactory.getLogger(getClass());
    @Resource
    private PurchaseBillsProjsService purchaseBillsProjsService;
    @Resource
    private PurchaseBillsService purchaseBillsService;
    @Resource
    private ProjectBillsBudgetsService projectBillsBudgetsService;
    @Resource
    private AuditItemsService auditItemsService;
    @Resource
    private BpurchasesService bpurchasesService;
    @Resource
    private ProjectBillsSubsService projectBillsSubsService;
    @Resource
    private BpurchaseModesService bpurchaseModesService;
    @Resource
    private BpurchaseSubTypesService bpurchaseSubTypesService;
    @Resource
    private ProjectbillsService projectbillsService;
    @Resource
    private PurchaseBillsPuridsService purchaseBillsPuridsService;
    @Resource
    private SysUserService sysUserService;
    @Resource
    private BbranchsService bbranchsService;
    @Resource
    private SubContractBillsService subContractBillsService;

    @Override
    public PurchaseBillsProjsDto queryObject(Long id) {
        PurchaseBillsProjs purchaseBillsProjs = purchaseBillsProjsService.selectById(id);
        PurchaseBillsProjsDto purchaseBillsProjsDto = new PurchaseBillsProjsDto();
        BeanUtils.copyProperties(purchaseBillsProjs, purchaseBillsProjsDto);
        return purchaseBillsProjsDto;
    }

    @Override
    public List<PurchaseBillsProjsDto> queryList(Map<String, Object> map) {
        List<PurchaseBillsProjs> purchaseBillsProjsList = purchaseBillsProjsService.selectByMap(map);
        return convertList(purchaseBillsProjsList, PurchaseBillsProjsDto.class);
    }

    @Override
    public int queryTotal(Map<String, Object> map) {
        EntityWrapper<PurchaseBillsProjs> ew = new EntityWrapper<>();
        ew.allEq(map);
        return purchaseBillsProjsService.selectCount(ew);
    }

    @Override
    public ExecuteResult<String> save(PurchaseBillsProjsDto purchaseBillsProjsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            PurchaseBillsProjs purchaseBillsProjs = new PurchaseBillsProjs();
            revert(purchaseBillsProjsDto, purchaseBillsProjs);
            boolean flag = purchaseBillsProjsService.insert(purchaseBillsProjs);
            if (!flag) {
                result.addErrorMessage("保存失败。");
            }
        } catch (Exception e) {
            logger.error(" 保存错误：" + e.toString(), e);
            result.addErrorMessage("保存错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> update(PurchaseBillsProjsDto purchaseBillsProjsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            PurchaseBillsProjs purchaseBillsProjs = new PurchaseBillsProjs();
            revert(purchaseBillsProjsDto, purchaseBillsProjs);

            boolean flag = purchaseBillsProjsService.updateById(purchaseBillsProjs);
            if (!flag) {
                result.addErrorMessage("更新失败。");
            }
        } catch (Exception e) {
            logger.error(" 更新错误：" + e.toString(), e);
            result.addErrorMessage("更新错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> delete(Long id) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = purchaseBillsProjsService.deleteById(id);
            if (!flag) {
                result.addErrorMessage("删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = purchaseBillsProjsService.deleteBatchIds(ids);
            if (!flag) {
                result.addErrorMessage("批量删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public Map<String, Object> getPage(Page<PurchaseBillsProjsDto> page, PurchaseBillsProjsDto purchaseBillsProjsDto, SysUserDto sysUserDto) {
        Map<String, Object> map = new HashMap<>();
        Page pageDto = DataUtils.processingPage(page);
        SysRole sysRole = subContractBillsService.selectRole(sysUserDto);
        map.put("purch", purchaseBillsProjsDto);
        map.put("user", sysUserDto);
        map.put("role", sysRole);
        int number = purchaseBillsProjsService.selectProCount(map);
        if (number != 0) {
            map.put("size", pageDto.getSize());
            map.put("current", pageDto.getCurrent());
            List<Map<String, Object>> mapList = purchaseBillsProjsService.selectProjectResultPage(map);
            pageDto.setTotal(number);
            pageDto.setRecords(mapList);
            map.put("page", pageDto);
            return map;
        }
        return null;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public String saveWork(String from, String list, String supper, SysUserDto sysUserDto) {
        PurchaseBills purchaseBills = JSONArray.parseObject(from, PurchaseBills.class);
        purchaseBills.setBillStatus(4);
        // 需求计划：1， 工程采购：2，材料采购：3，采购台账：4 工程台账： 5
        purchaseBills.setPostDate(new Date());
        // 招标：111 ，应用：222，单一：333
        Boolean bills = purchaseBillsService.insertOrUpdate(purchaseBills);
        if (!bills) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "提交失败，请仔细检查表单";
        }
        EntityWrapper<ProjectBillsSubs> subsEntityWrapper = new EntityWrapper<>();
//        purchaseBills.setBudgetUseAmt(purchaseBills.getBudgetUseAmt() + purchaseBills.getAmt());
        subsEntityWrapper.eq("project_sub_no", purchaseBills.getProjectSubNo())
                .eq("branch_id", sysUserDto.getLoginContractorId());
        ProjectBillsSubs projectbillsDto = projectBillsSubsService.selectOne(subsEntityWrapper);
        Audit audit = new Audit();
        audit.setBillNo(purchaseBills.getBillNo());
        if (purchaseBills.getAmt() < 100000) {
            audit.setActId(470);
        } else if (purchaseBills.getAmt() >= 100000 && purchaseBills.getAmt() < 500000) {
            audit.setActId(471);
        } else if (purchaseBills.getAmt() >= 500000 && purchaseBills.getAmt() < 4000000) {
            audit.setActId(472);
        } else if (purchaseBills.getAmt() >= 4000000) {
            audit.setActId(473);
        }
        audit.setLevelId(0);
        audit.setIffinalItem("F");
        audit.setSubJect(projectbillsDto.getProjectSubName());
        audit.setProjectNo(purchaseBills.getProjectSubNo());
        audit.setBranchId(projectbillsDto.getApprovalBranchId());
        audit.setSendUserId(sysUserDto.getUserId().intValue());
        audit.setSendName(sysUserDto.getActualname());
        audit.setSendTime(new Date());
        audit.setAuditUserId(sysUserDto.getUserId().intValue());
        audit.setAuditItem(new Date());
        audit.setAuditMsg("提交");
        audit.setAuditStatus("O");
        audit.setProjectMngId(projectbillsDto.getProjectSubMngId());
        EntityWrapper<Projectbills> projectbillsEntityWrapper = new EntityWrapper<>();
        projectbillsEntityWrapper.setSqlSelect("id", "project_leader").eq("bill_no", projectbillsDto.getBillNo())
                .eq("act_id", projectbillsDto.getActId()).eq("branch_id", projectbillsDto.getBranchId());
        Projectbills projectbills = projectbillsService.selectOne(projectbillsEntityWrapper);
        if (projectbills != null) {
            audit.setProjectLeader(projectbills.getProjectLeader());
        }
        boolean approvalFlow = auditItemsService.createApprovalFlow(audit);
        if (!approvalFlow) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "审批流异常请检查提交信息";
        }
        JSONArray arrayList = JSONArray.parseArray(list);
        List<PurchaseBillsProjs> billsItemsDtos = JSONObject.parseArray(arrayList.toJSONString(), PurchaseBillsProjs.class);
        if (billsItemsDtos.size() != 0) {
            EntityWrapper<PurchaseBillsProjs> purchaseBillsProjsEntityWrapper = new EntityWrapper<>();
            purchaseBillsProjsEntityWrapper.eq("bill_no", purchaseBills.getBillNo())
                    .eq("project_sub_no", purchaseBills.getProjectSubNo());
            boolean delete = purchaseBillsProjsService.delete(purchaseBillsProjsEntityWrapper);
            if (!delete) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "提交失败，删除旧数据失败";
            }
            int line = 0;
            for (PurchaseBillsProjs pb : billsItemsDtos) {
                line++;
                pb.setLinoNo(line);
                Boolean itemPro = purchaseBillsProjsService.insert(pb);
                if (!itemPro) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "提交失败，请仔细检查列表";
                }
            }
        }
        JSONArray supperList = JSONArray.parseArray(supper);
        List<PurchaseBillsPurids> purchaseBillsPuridsList = JSONObject.parseArray(supperList.toJSONString(), PurchaseBillsPurids.class);
        if (purchaseBillsPuridsList.size() != 0) {
            EntityWrapper<PurchaseBillsPurids> puridsEntityWrapper = new EntityWrapper<>();
            puridsEntityWrapper.eq("bill_no", billsItemsDtos.get(0).getPurchasePlanNo())
                    .eq("act_id", purchaseBills.getActId());
            boolean delete = purchaseBillsPuridsService.delete(puridsEntityWrapper);
            if (!delete) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "提交失败，删除旧数据失败";
            }
            int line = 0;
            for (PurchaseBillsPurids pb : purchaseBillsPuridsList) {
                line++;
                pb.setLineNo(line);
                boolean insertOrUpdateBatch = purchaseBillsPuridsService.insert(pb);
                if (!insertOrUpdateBatch) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "提交失败，请检查供应商数据";
                }
            }
        }
        EntityWrapper<ProjectBillsBudgets> budgetsEntityWrapper = new EntityWrapper<>();
        budgetsEntityWrapper.eq("project_sub_no", purchaseBills.getProjectSubNo())
                .eq("budget_id", 1)
                .eq("branch_id", projectbillsDto.getBranchId());
        ProjectBillsBudgets billsBudgets = projectBillsBudgetsService.selectOne(budgetsEntityWrapper);
        if (billsBudgets.getBudgetAmt() < (billsBudgets.getBudgetUseAmt() + purchaseBills.getAmt())) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "提交失败！超出预算";
        }
        billsBudgets.setBudgetUseAmt(billsBudgets.getBudgetUseAmt() + purchaseBills.getAmt());
        boolean updateById = projectBillsBudgetsService.updateById(billsBudgets);
        if (!updateById) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "提交失败，更新预算失败";
        }
        double amt = projectBillsBudgetsService.selectApprovedAmountSum(billsBudgets);
        projectbillsDto.setActualBudgetAmt(amt);
        boolean updateByProSub = projectBillsSubsService.updateById(projectbillsDto);
        if (!updateByProSub) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "更新预算失败";
        }
        return "1";
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public String savePurchasePro(String from, String list, SysUserDto sysUserDto) {
        PurchaseBills purchaseBills = JSONArray.parseObject(from, PurchaseBills.class);
        // 需求计划：1， 工程采购：2，材料采购：3，采购台账：4 工程台账： 5
        purchaseBills.setPostDate(new Date());
        // 招标：111 ，应用：222，单一：333
        purchaseBills.setBillStatus(4);
        Boolean bills = purchaseBillsService.insertOrUpdate(purchaseBills);
        if (!bills) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "提交失败！请仔细检查表单";
        }
        EntityWrapper<ProjectBillsSubs> subsEntityWrapper = new EntityWrapper<>();
        subsEntityWrapper.eq("project_sub_no", purchaseBills.getProjectSubNo())
                .eq("branch_id", sysUserDto.getLoginContractorId());
        ProjectBillsSubs projectbillsDto = projectBillsSubsService.selectOne(subsEntityWrapper);
        JSONArray arrayList = JSONArray.parseArray(list);
        List<PurchaseBillsProjs> billsItemsDtos = JSONObject.parseArray(arrayList.toJSONString(), PurchaseBillsProjs.class);
        EntityWrapper<PurchaseBillsProjs> purchaseBillsProjsEntityWrapper = new EntityWrapper<>();
        purchaseBillsProjsEntityWrapper.eq("bill_no", purchaseBills.getBillNo())
                .eq("project_sub_no", purchaseBills.getProjectSubNo())
                .eq("branch_id", sysUserDto.getLoginContractorId());
        boolean delete = purchaseBillsProjsService.delete(purchaseBillsProjsEntityWrapper);
        if (!delete) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "提交失败！删除旧数据失败";
        }
        if (billsItemsDtos.size() != 0) {
            int lin = 0;
            for (PurchaseBillsProjs pb : billsItemsDtos) {
                lin++;
                pb.setLinoNo(lin);
                pb.setBranchId(projectbillsDto.getBranchId());
                pb.setPurchaseModeId(purchaseBills.getPurchaseModeId());
                pb.setPurchaseModeDesc(purchaseBills.getPurchaseModeDesc());
                Boolean itemPro = purchaseBillsProjsService.insert(pb);
                if (!itemPro) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "提交失败！请仔细检查列表";
                }
            }
        }
        Audit audit = new Audit();
        audit.setBillNo(purchaseBills.getBillNo());
        if (Objects.equals(purchaseBills.getPurchaseSrcId(), 333)) {
            if (purchaseBills.getAmt() < 2000000) {
                audit.setActId(464);
            } else if (purchaseBills.getAmt() >= 2000000) {
                audit.setActId(465);
            }
        } else {
            int act = this.selectActId(purchaseBills, billsItemsDtos.get(0));
            if (act != 0) {
                audit.setActId(act);
            } else {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "提交失败！请确认审核金额";
            }
        }
        audit.setLevelId(0);
        audit.setIffinalItem("F");
        audit.setSubJect(projectbillsDto.getProjectSubName());
        audit.setProjectNo(purchaseBills.getProjectSubNo());
        audit.setBranchId(projectbillsDto.getApprovalBranchId());
        audit.setSendUserId(sysUserDto.getUserId().intValue());
        audit.setSendName(sysUserDto.getActualname());
        audit.setSendTime(new Date());
        audit.setAuditUserId(sysUserDto.getUserId().intValue());
        audit.setAuditItem(new Date());
        audit.setAuditMsg("提交");
        audit.setAuditStatus("O");
        audit.setProjectMngId(projectbillsDto.getProjectSubMngId());
        EntityWrapper<Projectbills> projectbillsEntityWrapper = new EntityWrapper<>();
        projectbillsEntityWrapper.setSqlSelect("id", "project_leader")
                .eq("bill_no", projectbillsDto.getBillNo())
                .eq("act_id", projectbillsDto.getActId());
        Projectbills projectbills = projectbillsService.selectOne(projectbillsEntityWrapper);
        if (projectbills != null) {
            audit.setProjectLeader(projectbills.getProjectLeader());
        }
        boolean approvalFlow = auditItemsService.createApprovalFlow(audit);
        if (!approvalFlow) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "审批流异常请检查提交信息";
        }
        EntityWrapper<ProjectBillsBudgets> budgetsEntityWrapper = new EntityWrapper<>();
        budgetsEntityWrapper.eq("project_sub_no", projectbillsDto.getProjectSubNo())
                .eq("budget_id", 1)
                .eq("branch_id", projectbillsDto.getBranchId());
        ProjectBillsBudgets billsBudgets = projectBillsBudgetsService.selectOne(budgetsEntityWrapper);
        if (billsBudgets.getBudgetAmt() < billsBudgets.getBudgetUseAmt()) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "提交失败！超出预算";
        }
        billsBudgets.setBudgetUseAmt(billsBudgets.getBudgetUseAmt() + purchaseBills.getAmt());
        boolean updateProBudget = projectBillsBudgetsService.updateById(billsBudgets);
        if (!updateProBudget) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "提交失败！更新预算失败";
        }
        double amt = projectBillsBudgetsService.selectApprovedAmountSum(billsBudgets);
        projectbillsDto.setActualBudgetAmt(amt);
        boolean updateById = projectBillsSubsService.updateById(projectbillsDto);
        if (!updateById) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "更新预算失败";
        }
        return "1";
    }

    public int selectActId(PurchaseBills purchaseBills, PurchaseBillsProjs billsProjs) {
        int act = 0;
        // 公开招标
        if (Objects.equals(purchaseBills.getPurchaseModeId(), 1)) {
            act = 450;
            // 邀请招标
        } else if (Objects.equals(purchaseBills.getPurchaseModeId(), 2)) {
            // 劳务分包
            if (Objects.equals(billsProjs.getPurchaseSubTypeId(), 1)) {
                // 分包工程-招标采购-邀请招标(劳务分包以及其他服务50W(包括)及以下)
                if (purchaseBills.getAmt() <= 500000) {
                    act = 451;
                    // 分包工程-招标采购-邀请招标(劳务分包以及其他服务50W(不包括)以上-200W(不包括))
                } else if (purchaseBills.getAmt() > 500000 && purchaseBills.getAmt() < 2000000) {
                    act = 452;
                    // 分包工程-招标采购-邀请招标(200W(不包括) – 400W(包括))
                } else if (purchaseBills.getAmt() > 2000000 && purchaseBills.getAmt() <= 4000000) {
                    act = 454;
                    // 分包工程-招标采购-邀请招标(400W以上(不包括)
                } else if (purchaseBills.getAmt() > 4000000) {
                    act = 455;
                }
                // 专业分包
            } else if (Objects.equals(purchaseBills.getPurchaseModeId(), 2)) {
                // 分包工程-招标采购-邀请招标-专业分包(200W及以下)
                if (purchaseBills.getAmt() <= 2000000) {
                    act = 453;
                    // 分包工程-招标采购-邀请招标(200W(不包括) – 400W(包括))
                } else if (purchaseBills.getAmt() > 2000000 && purchaseBills.getAmt() <= 4000000) {
                    act = 454;
                    // 分包工程-招标采购-邀请招标(400W以上(不包括)
                } else if (purchaseBills.getAmt() > 4000000) {
                    act = 455;
                }
            }
            // 竞争性谈判
        } else if (Objects.equals(purchaseBills.getPurchaseModeId(), 3)) {
            // 劳务分包
            if (Objects.equals(billsProjs.getPurchaseSubTypeId(), 1)) {
                // 分包工程-招标采购-竞争性谈判-劳务分包(50W及以下(包括))
                if (purchaseBills.getAmt() <= 500000) {
                    act = 458;
                    // 分包工程-招标采购-劳务分包(50W(不包括)-200W(不包括))
                } else if (purchaseBills.getAmt() > 500000 && purchaseBills.getAmt() < 2000000) {
                    act = 459;
                }
                // 分包工程-招标采购-竞争性谈判(200W(不包括) – 400W(包括))
                if (purchaseBills.getAmt() > 2000000 && purchaseBills.getAmt() <= 4000000) {
                    act = 461;
                }
                // 专业分包
            } else if (Objects.equals(billsProjs.getPurchaseSubTypeId(), 2)) {
                // 分包工程-招标采购-竞争性谈判-专业分包(200W及以下(包括))
                if (purchaseBills.getAmt() <= 2000000) {
                    act = 460;
                }
                // 分包工程-招标采购-竞争性谈判(200W(不包括) – 400W(包括))
                if (purchaseBills.getAmt() > 2000000 && purchaseBills.getAmt() <= 4000000) {
                    act = 461;
                }
            }
            // 询价采购
        } else if (Objects.equals(purchaseBills.getPurchaseModeId(), 4)) {
            // 分包工程-招标采购-询价采购(30W以下(包括))
            if (purchaseBills.getAmt() <= 300000) {
                act = 456;
                // 分包工程-招标采购-询价采购(30W (不包括) – 50W(不包括))
            } else if (purchaseBills.getAmt() > 300000 && purchaseBills.getAmt() < 500000) {
                act = 457;
            }
            // 自主采购
        } else if (Objects.equals(purchaseBills.getPurchaseModeId(), 5)) {
            // 分包工程-招标采购-自主采购(5W及以下(包括))
            if (purchaseBills.getAmt() <= 50000) {
                act = 462;
                // 分包工程-招标采购-自主采购(5W以上(不包括))
            } else if (purchaseBills.getAmt() > 50000) {
                act = 463;
            }
        }
        return act;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public String updateWork(String from, String list, String supper) {
        PurchaseBills purchaseBills = JSONArray.parseObject(from, PurchaseBills.class);
        // 需求计划：1， 工程采购：2，材料采购：3，采购台账：4 工程台账： 5
        purchaseBills.setPostDate(new Date());
        // 招标：111 ，应用：222，单一：333
        Boolean bills = purchaseBillsService.insertOrUpdate(purchaseBills);
        if (!bills) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "暂存失败！请仔细检查表单";
        }
        EntityWrapper<PurchaseBillsProjs> billsProjsEntityWrapper = new EntityWrapper<>();
        billsProjsEntityWrapper.eq("bill_no", purchaseBills.getBillNo())
                .eq("project_sub_no", purchaseBills.getProjectSubNo())
                .eq("branch_id", purchaseBills.getContractorId());
        List<PurchaseBillsProjs> purchaseBillsProjs = purchaseBillsProjsService.selectList(billsProjsEntityWrapper);
        for (PurchaseBillsProjs pb : purchaseBillsProjs) {
            EntityWrapper<PurchaseBillsPurids> billsPuridsEntityWrapper = new EntityWrapper<>();
            billsPuridsEntityWrapper.eq("bill_no", pb.getPurchasePlanNo())
                    .eq("purchase_id", pb.getPurchaseId());
            boolean delete = purchaseBillsPuridsService.delete(billsPuridsEntityWrapper);
            if (!delete) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "暂存失败！删除旧数据失败";
            }
        }
        JSONArray supperList = JSONArray.parseArray(supper);
        List<PurchaseBillsPurids> purchaseBillsPurids = JSONObject.parseArray(supperList.toJSONString(), PurchaseBillsPurids.class);
        if (purchaseBillsPurids.size() != 0) {
            boolean insertOrUpdateBatch = purchaseBillsPuridsService.insertOrUpdateBatch(purchaseBillsPurids);
            if (!insertOrUpdateBatch) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "提交失败，请检查供应商数据";
            }
        }
        boolean delete = purchaseBillsProjsService.delete(billsProjsEntityWrapper);
        if (!delete) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "暂存失败！请仔细检查表单";
        }
        JSONArray arrayList = JSONArray.parseArray(list);
        List<PurchaseBillsProjs> billsItemsDtos = JSONObject.parseArray(arrayList.toJSONString(), PurchaseBillsProjs.class);
        Boolean itemPro = purchaseBillsProjsService.insertOrUpdateBatch(billsItemsDtos);
        if (!itemPro) {
            return "暂存失败！请仔细检查列表";
        }
        return "1";
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public String updatePurchasePro(String from, String list) {
        PurchaseBills purchaseBills = JSONArray.parseObject(from, PurchaseBills.class);
        JSONArray arrayList = JSONArray.parseArray(list);
        List<PurchaseBillsProjs> billsItemsDtos = JSONObject.parseArray(arrayList.toJSONString(), PurchaseBillsProjs.class);
        // 需求计划：1， 工程采购：2，材料采购：3，采购台账：4 工程台账： 5
        purchaseBills.setPostDate(new Date());
        // 招标：111 ，应用：222，单一：333
        Boolean bills = purchaseBillsService.insertOrUpdate(purchaseBills);
        EntityWrapper<PurchaseBillsProjs> billsProjsEntityWrapper = new EntityWrapper<>();
        billsProjsEntityWrapper.eq("bill_no", purchaseBills.getBillNo())
                .eq("project_sub_no", purchaseBills.getProjectSubNo());
        boolean delete = purchaseBillsProjsService.delete(billsProjsEntityWrapper);
        if (!delete) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "暂存失败！删除旧数据失败";
        }
        Boolean itemPro = purchaseBillsProjsService.insertOrUpdateBatch(billsItemsDtos);
        if (!bills) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "暂存失败！请仔细检查工程信息";
        }
        if (!itemPro) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "暂存失败！请仔细检查计划列表";
        }
        return "1";

    }

    @Override
    public Map<String, Object> fuzzyQueryPurProjs(Page page, PurchaseBillsProjsDto purchaseBillsProjsDto) {
        Map<String, Object> map = new HashMap<>();
        if (purchaseBillsProjsDto != null && purchaseBillsProjsDto.getProjectSubNo() != null) {
            Page pageDto = DataUtils.processingPage(page);
            EntityWrapper<PurchaseBillsProjs> entityWrapper = new EntityWrapper<>();
            entityWrapper.eq("project_sub_no", purchaseBillsProjsDto.getProjectSubNo());
            if (purchaseBillsProjsDto.getIsUsed() != null) {
                entityWrapper.eq("is_used", purchaseBillsProjsDto.getIsUsed());
            }
            if (purchaseBillsProjsDto.getStatus() != null) {
                entityWrapper.eq("status", purchaseBillsProjsDto.getStatus());
            }
            if (purchaseBillsProjsDto.getBranchId() != 1) {
                entityWrapper.eq("branch_id", purchaseBillsProjsDto.getBranchId());
            }
            int number = purchaseBillsProjsService.selectCount(entityWrapper);
            if (number > 0) {
                entityWrapper.last("LIMIT " + pageDto.getCurrent() + "," + pageDto.getSize());
                List<PurchaseBillsProjs> purchaseBillsProjs = purchaseBillsProjsService.selectList(entityWrapper);
                pageDto.setTotal(number);
                pageDto.setRecords(purchaseBillsProjs);
                map.put("page", pageDto);
                return map;
            }
        }
        return null;
    }

    @Override
    public Map<String, Object> changeFuzzyQueryPurProjs(PurchaseBillsProjsDto purchaseBillsProjsDto) {
        if (purchaseBillsProjsDto != null && purchaseBillsProjsDto.getId() != null) {
            Map<String, Object> map = new HashMap<>();
            EntityWrapper<PurchaseBillsProjs> entityWrapper = new EntityWrapper<>();
            entityWrapper.setSqlSelect("id", "project_Sub_No", "purchase_id", "").eq("id", purchaseBillsProjsDto.getId());
            PurchaseBillsProjs purchaseBillsProjs = purchaseBillsProjsService.selectOne(entityWrapper);
            if (purchaseBillsProjs != null) {
                map.put("purProj", purchaseBillsProjs);
            }
            return map;
        }
        if (purchaseBillsProjsDto != null) {
            Map<String, Object> map = new HashMap<>();
            EntityWrapper<PurchaseBillsProjs> entityWrapper = new EntityWrapper<>();
            entityWrapper.setSqlSelect("id", "c_name");
            List<PurchaseBillsProjs> purchaseBillsProjs = purchaseBillsProjsService.selectList(entityWrapper);
            if (purchaseBillsProjs != null) {
                map.put("purProjs", purchaseBillsProjs);
            }
            return map;
        }
        return null;
    }

    @Override
    public Map<String, Object> selectItem(String billNo) {
        Map<String, Object> map = new HashMap<>();
        EntityWrapper<ProjectBillsBudgets> budgetsEntityWrapper = new EntityWrapper<>();
        budgetsEntityWrapper.eq("project_sub_no", billNo);
        budgetsEntityWrapper.eq("budget_id", 1);
        ProjectBillsBudgets projectBillsBudgets = projectBillsBudgetsService.selectOne(budgetsEntityWrapper);
        if (projectBillsBudgets == null) {
            map.put("budget", 0);
        } else {
            EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
            projectBillsSubsEntityWrapper.eq("project_sub_no", billNo);
            ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
            EntityWrapper<Projectbills> projectbillsEntityWrapper = new EntityWrapper<>();
            projectbillsEntityWrapper.eq("bill_no", projectBillsSubs.getBillNo());
            map.put("budget", projectBillsBudgets);
            map.put("project", projectbillsService.selectOne(projectbillsEntityWrapper));
        }
        return map;
    }

    @Override
    public Map<String, Object> editItem(String id) {
        // 工程计划修改查询方法
        Map<String, Object> map = new HashMap<>();
        EntityWrapper<PurchaseBills> purchaseBillsEntityWrapper = new EntityWrapper<>();
        purchaseBillsEntityWrapper.eq("id", id);
        PurchaseBills purchaseBills = purchaseBillsService.selectById(id);
        if (purchaseBills != null) {
            // 明细
            EntityWrapper<PurchaseBillsProjs> projsEntityWrapper = new EntityWrapper<>();
            projsEntityWrapper.eq("bill_no", purchaseBills.getBillNo());
            projsEntityWrapper.eq("act_id", purchaseBills.getActId());
            projsEntityWrapper.eq("purchase_Src_id", purchaseBills.getPurchaseSrcId());
            List<PurchaseBillsProjs> purchaseBillsProjsList = purchaseBillsProjsService.selectList(projsEntityWrapper);
            List<Bpurchases> bpurchasesList = new ArrayList<>(); // 供应商
            List<BpurchaseModes> bpurchaseModesList = new ArrayList<>(); // 采购方式
            List<BpurchaseSubTypes> bpurchaseSubTypesList = new ArrayList<>(); // 分包类型
            List<PurchaseBillsPurids> purchaseBillsPuridsList = new ArrayList<>(); // 应用框架的供应商
            for (PurchaseBillsProjs projs : purchaseBillsProjsList) {
                if (projs.getPurchaseModeId() != null) { // 采购方式
                    EntityWrapper<BpurchaseModes> bpurchaseModesEntityWrapper = new EntityWrapper<>();
                    bpurchaseModesEntityWrapper.eq("id", projs.getPurchaseModeId());
                    bpurchaseModesList.add(bpurchaseModesService.selectOne(bpurchaseModesEntityWrapper));
                }
                if (projs.getPurchaseSubTypeId() != null) { // 分包类型
                    EntityWrapper<BpurchaseSubTypes> bpurchaseSubTypesEntityWrapper = new EntityWrapper<>();
                    bpurchaseSubTypesEntityWrapper.eq("id", projs.getPurchaseSubTypeId());
                    bpurchaseSubTypesList.add(bpurchaseSubTypesService.selectOne(bpurchaseSubTypesEntityWrapper));
                }
                if (projs.getPurchaseId() != null) { // 供应商
                    EntityWrapper<Bpurchases> bpurchasesEntityWrapper = new EntityWrapper<>();
                    bpurchasesEntityWrapper.eq("id", projs.getPurchaseId());
                    bpurchasesList.add(bpurchasesService.selectOne(bpurchasesEntityWrapper));
                }
                if (purchaseBills.getPurchaseSrcId() == 222) {
                    EntityWrapper<PurchaseBillsPurids> purchaseBillsPuridsEntityWrapper = new EntityWrapper<>();
                    purchaseBillsPuridsEntityWrapper.eq("bill_no", projs.getPurchasePlanNo());
                    purchaseBillsPuridsEntityWrapper.eq("act_id", projs.getActId());
                    purchaseBillsPuridsList.addAll(purchaseBillsPuridsService.selectList(purchaseBillsPuridsEntityWrapper));
                }
            }
            //  二级项目
            EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
            projectBillsSubsEntityWrapper.eq("project_sub_no", purchaseBills.getProjectSubNo());
            ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
            // 部门
            SysUser sysUser = sysUserService.selectById(purchaseBills.getOpUserId());
            // 预算
            EntityWrapper<ProjectBillsBudgets> budgetsEntityWrapper = new EntityWrapper<>();
            budgetsEntityWrapper.eq("project_sub_no", purchaseBills.getProjectSubNo());
            budgetsEntityWrapper.eq("budget_id", 1);
            // 总包合同
            EntityWrapper<Projectbills> projectbillsEntityWrapper = new EntityWrapper<>();
            projectbillsEntityWrapper.eq("bill_no", projectBillsSubs.getBillNo());
            map.put("bills", purchaseBills);
            map.put("item", purchaseBillsProjsList);
            map.put("erji", projectBillsSubs);
            map.put("gong", bpurchasesList);
            map.put("fen", bpurchaseSubTypesList);
            map.put("cai", bpurchaseModesList);
            map.put("yu", projectBillsBudgetsService.selectOne(budgetsEntityWrapper));
            map.put("project", projectbillsService.selectOne(projectbillsEntityWrapper));
            map.put("purids", purchaseBillsPuridsList);
            map.put("brand", bbranchsService.selectById(purchaseBills.getContractorId()));
        }
        return map;
    }

    @Override
    public String saveProItem(String purchaseBillsDto) {
        PurchaseBillsProjs purchaseBills = JSONArray.parseObject(purchaseBillsDto, PurchaseBillsProjs.class);
        EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
        projectBillsBudgetsEntityWrapper.eq("project_sub_no", purchaseBills.getProjectSubNo());
        projectBillsBudgetsEntityWrapper.eq("budget_id", 1);
        ProjectBillsBudgets projectBillsBudgets = projectBillsBudgetsService.selectOne(projectBillsBudgetsEntityWrapper);
        projectBillsBudgets.setBudgetUseAmt(projectBillsBudgets.getBudgetUseAmt() + purchaseBills.getBidAmt() - purchaseBills.getAmt());
        boolean billsType = purchaseBillsProjsService.updateById(purchaseBills);
        if (!billsType) {
            return "请检查中标数据";
        }
        if (!projectBillsBudgetsService.updateById(projectBillsBudgets)) {
            return "更新预算失败";
        }
        return "1";
    }

    @Override
    public String adminSaveProItem(String purchaseBillsDto) {
        PurchaseBillsProjs purchaseBills = JSONArray.parseObject(purchaseBillsDto, PurchaseBillsProjs.class);
        boolean billsType = purchaseBillsProjsService.updateById(purchaseBills);
        if (!billsType) {
            return "请检查中标数据";
        }
        return "1";
    }

    @Override
    public Map<String, Object> selectProItem(String id) {
        Map<String, Object> map = new HashMap<>();
        EntityWrapper<PurchaseBills> purchaseBillsEntityWrapper = new EntityWrapper<>();
        PurchaseBillsProjs projs = purchaseBillsProjsService.selectById(id);
        purchaseBillsEntityWrapper.eq("bill_no", projs.getBillNo());
        PurchaseBills purchaseBills = purchaseBillsService.selectOne(purchaseBillsEntityWrapper);
        EntityWrapper<ProjectBillsSubs> subsEntityWrapper = new EntityWrapper<>();
        subsEntityWrapper.eq("project_sub_no", purchaseBills.getProjectSubNo());
        ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(subsEntityWrapper);
        EntityWrapper<Projectbills> projectbillsEntityWrapper = new EntityWrapper<>();
        projectbillsEntityWrapper.eq("bill_no", projectBillsSubs.getBillNo());
        map.put("item", projs);
        map.put("bills", purchaseBills);
        map.put("sub", projectBillsSubs);
        map.put("zong", projectbillsService.selectOne(projectbillsEntityWrapper));
        return map;
    }

    @Override
    public void deleteSupplier(Integer id) {
        purchaseBillsPuridsService.deleteById(id);
    }

    @Override
    public Map<String, Object> selectProItemPurids(Integer id) {
        Map<String, Object> map = new HashMap<>();
        PurchaseBillsProjs purchaseBillsProjs = purchaseBillsProjsService.selectById(id);
        EntityWrapper<PurchaseBillsPurids> purchaseBillsPuridsEntityWrapper = new EntityWrapper<>();
        purchaseBillsPuridsEntityWrapper.eq("bill_no", purchaseBillsProjs.getPurchasePlanNo());
        purchaseBillsPuridsEntityWrapper.eq("act_id", purchaseBillsProjs.getActId());
        map.put("purids", purchaseBillsPuridsService.selectList(purchaseBillsPuridsEntityWrapper));
        return map;
    }
}
