
package io.platform.purchase.service.client.impl;

import com.alibaba.dubbo.config.annotation.Service;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;


import io.platform.engineering.biz.entity.Bpurchases;
import io.platform.engineering.biz.service.BpurchasesService;
import io.platform.purchase.biz.entity.PurchaseBillsPurids;
import io.platform.purchase.biz.service.PurchaseBillsPuridsService;
import io.platform.purchase.dto.PurchaseBillsPuridsDto;
import io.platform.purchase.service.client.api.PurchaseBillsPuridsServiceClient;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import io.platform.base.common.BaseServiceClient;
import io.platform.base.common.utils.ExecuteResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
 * Created by sevelli on 2017/8/31.
 */
@Component
@Service()
public class PurchaseBillsPuridsServiceClientImpl extends BaseServiceClient<PurchaseBillsPurids,PurchaseBillsPuridsDto> implements PurchaseBillsPuridsServiceClient {
    private Logger logger = LoggerFactory.getLogger(getClass());
    @Resource
    private PurchaseBillsPuridsService purchaseBillsPuridsService;
    @Resource
    private BpurchasesService bpurchasesService;

    @Override
    public PurchaseBillsPuridsDto queryObject(Long id) {
        PurchaseBillsPurids purchaseBillsPurids = purchaseBillsPuridsService.selectById(id);
        PurchaseBillsPuridsDto purchaseBillsPuridsDto = new PurchaseBillsPuridsDto();
        BeanUtils.copyProperties(purchaseBillsPurids,purchaseBillsPuridsDto);
        return purchaseBillsPuridsDto;
    }

    @Override
    public List<PurchaseBillsPuridsDto> queryList(Map<String, Object> map) {
        List<PurchaseBillsPurids> purchaseBillsPuridsList = purchaseBillsPuridsService.selectByMap(map);
        return convertList(purchaseBillsPuridsList,PurchaseBillsPuridsDto.class);
    }

    @Override
    public int queryTotal(Map<String, Object> map) {
        EntityWrapper<PurchaseBillsPurids> ew = new EntityWrapper<>();
        ew.allEq(map);
        return purchaseBillsPuridsService.selectCount(ew);
    }

    @Override
    public ExecuteResult<String> save(PurchaseBillsPuridsDto purchaseBillsPuridsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try{
            PurchaseBillsPurids purchaseBillsPurids = new PurchaseBillsPurids();
            revert(purchaseBillsPuridsDto,purchaseBillsPurids);
            boolean flag = purchaseBillsPuridsService.insert(purchaseBillsPurids);
            if(!flag){
                result.addErrorMessage("保存失败。");
            }
        }
        catch (Exception e) {
            logger.error(" 保存错误：" + e.toString(), e);
            result.addErrorMessage("保存错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> update(PurchaseBillsPuridsDto purchaseBillsPuridsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try{
            PurchaseBillsPurids purchaseBillsPurids = new PurchaseBillsPurids();
            revert(purchaseBillsPuridsDto,purchaseBillsPurids);

            boolean flag = purchaseBillsPuridsService.updateById(purchaseBillsPurids);
            if(!flag){
                result.addErrorMessage("更新失败。");
            }
        }
        catch (Exception e) {
            logger.error(" 更新错误：" + e.toString(), e);
            result.addErrorMessage("更新错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> delete(Long id) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try{
            boolean flag = purchaseBillsPuridsService.deleteById(id);
            if(!flag){
                result.addErrorMessage("删除失败。");
            }
        }
        catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try{
            boolean flag = purchaseBillsPuridsService.deleteBatchIds(ids);
            if(!flag){
                result.addErrorMessage("批量删除失败。");
            }
        }
        catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public Page<PurchaseBillsPuridsDto> getPage(Page<PurchaseBillsPuridsDto> pageDto,PurchaseBillsPuridsDto purchaseBillsPuridsDto) {
        Page<PurchaseBillsPurids> page = new Page<>(pageDto.getCurrent(),pageDto.getSize());
        page.setAsc(pageDto.isAsc());
        page.setOrderByField(pageDto.getOrderByField());
        page.setCondition(pageDto.getCondition());
        PurchaseBillsPurids purchaseBillsPurids = new PurchaseBillsPurids();
        revert(purchaseBillsPuridsDto,purchaseBillsPurids);
        EntityWrapper<PurchaseBillsPurids> wrapper = new EntityWrapper<>();
        wrapper.setEntity(purchaseBillsPurids);
        page = purchaseBillsPuridsService.selectPage(page,wrapper);
        List<PurchaseBillsPuridsDto> purchaseBillsPuridsDtoList = convertList(page.getRecords(),PurchaseBillsPuridsDto.class);
        pageDto.setTotal(purchaseBillsPuridsService.selectCount(wrapper));
        pageDto.setRecords(purchaseBillsPuridsDtoList);
        return pageDto;
    }

    @Override
    public Map<String, Object> getSupplierPage(Page<PurchaseBillsPuridsDto> pageDto, PurchaseBillsPuridsDto purchaseBillsPuridsDto) {
        Map<String, Object> map = new HashMap<>();
        List<Bpurchases> bpurchases = new ArrayList<>();
        Page<PurchaseBillsPurids> page = new Page<>(pageDto.getCurrent(),pageDto.getSize());
        page.setAsc(pageDto.isAsc());
        page.setOrderByField(pageDto.getOrderByField());
        page.setCondition(pageDto.getCondition());
        PurchaseBillsPurids purchaseBillsPurids = new PurchaseBillsPurids();
        revert(purchaseBillsPuridsDto,purchaseBillsPurids);
        EntityWrapper<PurchaseBillsPurids> wrapper = new EntityWrapper<>();
        wrapper.setEntity(purchaseBillsPurids);
        page = purchaseBillsPuridsService.selectPage(page,wrapper);
        for (PurchaseBillsPurids purids: page.getRecords()) {
            EntityWrapper<Bpurchases> entityWrapper = new EntityWrapper<>();
            entityWrapper.eq("id",purids.getPurchaseId());
            bpurchases.add(bpurchasesService.selectOne(entityWrapper));
        }
        List<PurchaseBillsPuridsDto> purchaseBillsPuridsDtoList = convertList(page.getRecords(),PurchaseBillsPuridsDto.class);
        pageDto.setTotal(purchaseBillsPuridsService.selectCount(wrapper));
        pageDto.setRecords(purchaseBillsPuridsDtoList);
        map.put("page",pageDto);
        map.put("supplier",bpurchases);
        return map;
    }
}
