
package io.platform.purchase.service.client.impl;

import com.alibaba.dubbo.config.annotation.Service;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;


import io.platform.approvalConfiguration.biz.entity.*;
import io.platform.approvalConfiguration.biz.service.AuditPathsActsService;
import io.platform.approvalConfiguration.biz.service.AuditPathsLevelsService;
import io.platform.approvalConfiguration.biz.service.AuditPathsService;
import io.platform.budget.biz.entity.ProjectBillsBudgets;
import io.platform.budget.biz.service.ProjectBillsBudgetsService;
import io.platform.engineering.biz.entity.BpurchaseTypes;
import io.platform.engineering.biz.service.BbranchsService;
import io.platform.engineering.biz.service.BpurchaseTypesService;
import io.platform.engineering.biz.service.BpurchasesService;
import io.platform.project.biz.entity.ProjectBillsSubs;
import io.platform.project.biz.entity.Projectbills;
import io.platform.approvalConfiguration.biz.service.AuditItemsService;
import io.platform.project.biz.service.ProjectBillsSubsService;
import io.platform.project.biz.service.ProjectbillsService;
import io.platform.projectSettlement.biz.entity.ProjectBillsAttachs;
import io.platform.projectSettlement.biz.service.ProjectBillsAttachsService;
import io.platform.purchase.biz.entity.PurchaseBills;
import io.platform.purchase.biz.entity.PurchaseBillsItems;
import io.platform.purchase.biz.entity.PurchaseBillsProjs;
import io.platform.purchase.biz.entity.PurchaseBillsPurids;
import io.platform.purchase.biz.service.PurchaseBillsItemsService;
import io.platform.purchase.biz.service.PurchaseBillsProjsService;
import io.platform.purchase.biz.service.PurchaseBillsPuridsService;
import io.platform.purchase.biz.service.PurchaseBillsService;
import io.platform.purchase.dto.PurchaseBillsDto;
import io.platform.purchase.service.client.api.PurchaseBillsServiceClient;
import io.platform.sys.dto.SysUserDto;
import io.platform.utils.DataUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.text.SimpleDateFormat;
import java.util.*;

import io.platform.base.common.BaseServiceClient;
import io.platform.base.common.utils.ExecuteResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;

/**
 * Created by sevelli on 2017/8/31.
 */
@Component
@Service(version = "1.0.0", interfaceClass = PurchaseBillsServiceClient.class)
public class PurchaseBillsServiceClientImpl extends BaseServiceClient<PurchaseBills, PurchaseBillsDto> implements PurchaseBillsServiceClient {
    private Logger logger = LoggerFactory.getLogger(getClass());
    @Resource
    private BbranchsService bbranchsService;
    @Resource
    private AuditPathsService auditPathsService;
    @Resource
    private AuditItemsService auditItemsService;
    @Resource
    private BpurchasesService bpurchasesService;
    @Resource
    private ProjectbillsService projectbillsService;
    @Resource
    private PurchaseBillsService purchaseBillsService;
    @Resource
    private AuditPathsActsService auditPathsActsService;
    @Resource
    private BpurchaseTypesService bpurchaseTypesService;
    @Resource
    private AuditPathsLevelsService auditPathsLevelsService;
    @Resource
    private ProjectBillsSubsService projectBillsSubsService;
    @Resource
    private PurchaseBillsProjsService purchaseBillsProjsService;
    @Resource
    private PurchaseBillsItemsService purchaseBillsItemsService;
    @Resource
    private ProjectBillsBudgetsService projectBillsBudgetsService;
    @Resource
    private ProjectBillsAttachsService projectBillsAttachsService;
    @Resource
    private PurchaseBillsPuridsService purchaseBillsPuridsService;

    @Override
    public PurchaseBillsDto queryObject(Long id) {
        PurchaseBills purchaseBills = purchaseBillsService.selectById(id);
        PurchaseBillsDto purchaseBillsDto = new PurchaseBillsDto();
        BeanUtils.copyProperties(purchaseBills, purchaseBillsDto);
        return purchaseBillsDto;
    }

    @Override
    public List<PurchaseBillsDto> queryList(Map<String, Object> map) {
        List<PurchaseBills> purchaseBillsList = purchaseBillsService.selectByMap(map);
        return convertList(purchaseBillsList, PurchaseBillsDto.class);
    }

    @Override
    public int queryTotal(Map<String, Object> map) {
        EntityWrapper<PurchaseBills> ew = new EntityWrapper<>();
        ew.allEq(map);
        return purchaseBillsService.selectCount(ew);
    }

    @Override
    public ExecuteResult<String> save(PurchaseBillsDto purchaseBillsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            PurchaseBills purchaseBills = new PurchaseBills();
            revert(purchaseBillsDto, purchaseBills);
            boolean flag = purchaseBillsService.insert(purchaseBills);
            if (!flag) {
                result.addErrorMessage("保存失败。");
            }
        } catch (Exception e) {
            logger.error(" 保存错误：" + e.toString(), e);
            result.addErrorMessage("保存错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> update(PurchaseBillsDto purchaseBillsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            PurchaseBills purchaseBills = new PurchaseBills();
            revert(purchaseBillsDto, purchaseBills);

            boolean flag = purchaseBillsService.updateById(purchaseBills);
            if (!flag) {
                result.addErrorMessage("更新失败。");
            }
        } catch (Exception e) {
            logger.error(" 更新错误：" + e.toString(), e);
            result.addErrorMessage("更新错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> delete(Long id) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = purchaseBillsService.deleteById(id);
            if (!flag) {
                result.addErrorMessage("删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> deleteBatch(PurchaseBillsDto purchaseBillsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        EntityWrapper<PurchaseBills> billsEntityWrapper = new EntityWrapper<>();
        billsEntityWrapper.eq("src_bill_no", purchaseBillsDto.getBillNo());
        billsEntityWrapper.eq("act_id", 3);
        List<PurchaseBills> billsList = purchaseBillsService.selectList(billsEntityWrapper);
        if (billsList == null || billsList.size() == 0) {
            try {
                EntityWrapper<PurchaseBillsItems> purchaseBillsItemsEntityWrapper = new EntityWrapper<>();
                purchaseBillsItemsEntityWrapper.eq("bill_no", purchaseBillsDto.getBillNo());
                purchaseBillsItemsEntityWrapper.eq("act_id", purchaseBillsDto.getActId());
                Boolean itemType = purchaseBillsItemsService.delete(purchaseBillsItemsEntityWrapper);
                boolean flag = purchaseBillsService.deleteById(purchaseBillsDto.getId());
                if (!flag && !itemType) {
                    result.addErrorMessage("删除失败。");
                }
            } catch (Exception e) {
                logger.error(" 删除错误：" + e.toString(), e);
                result.addErrorMessage("删除错误：" + e.toString());
            }
        } else {
            result.addErrorMessage("该需求计划下已有采购计划，不能删除！");
        }
        return result;
    }

    @Override
    public Page<PurchaseBillsDto> getPage(Page<PurchaseBillsDto> pageDto, PurchaseBillsDto purchaseBillsDto) {
        Page<PurchaseBills> page = new Page<>(pageDto.getCurrent(), pageDto.getSize());
        page.setAsc(pageDto.isAsc());
        page.setOrderByField(pageDto.getOrderByField());
        page.setCondition(pageDto.getCondition());
        PurchaseBills purchaseBills = new PurchaseBills();
        revert(purchaseBillsDto, purchaseBills);
        EntityWrapper<PurchaseBills> wrapper = new EntityWrapper<>();
        wrapper.setEntity(purchaseBills);
        page = purchaseBillsService.selectPage(page, wrapper);
        List<PurchaseBillsDto> purchaseBillsDtoList = convertList(page.getRecords(), PurchaseBillsDto.class);
        pageDto.setTotal(purchaseBillsService.selectCount(wrapper));
        pageDto.setRecords(purchaseBillsDtoList);
        return pageDto;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public String materialDemand(String purchaseBillsDto, String list, SysUserDto sysUserDto) {
        PurchaseBills purchaseBills = JSONArray.parseObject(purchaseBillsDto, PurchaseBills.class);
        JSONArray arrayList = JSONArray.parseArray(list);
        List<PurchaseBillsItems> billsItemsDtos = JSONObject.parseArray(arrayList.toJSONString(), PurchaseBillsItems.class);
        // 需求计划：1， 工程采购：2，物资：3，物资台账：4
        Boolean bills = purchaseBillsService.insertOrUpdate(purchaseBills);
        if (!bills) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "表单数据有问题，请检查";
        }
        double amtCr = 0d;
        EntityWrapper<PurchaseBillsItems> purchaseBillsItemsEntityWrapper = new EntityWrapper<>();
        purchaseBillsItemsEntityWrapper.eq("bill_no", purchaseBills.getBillNo())
                .eq("project_Sub_No", purchaseBills.getProjectSubNo());
        List<PurchaseBillsItems> purchaseBillsItems = purchaseBillsItemsService.selectList(purchaseBillsItemsEntityWrapper);
        if (purchaseBillsItems.size() != 0) {
            for (PurchaseBillsItems billsItems : purchaseBillsItems) {
                if (billsItems.getPurchaseTypeId() == 1) {
                    amtCr = DataUtils.keepDecimals(amtCr + billsItems.getAmt());
                }
            }
        }
        boolean delete = purchaseBillsItemsService.delete(purchaseBillsItemsEntityWrapper);
        if (!delete) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "删除旧数据失败";
        }
        double number = 0d;
        for (PurchaseBillsItems billsItems : billsItemsDtos) {
            if (billsItems.getPurchaseTypeId() == 1) {
                number = number + billsItems.getAmt();
            }
            boolean insert = purchaseBillsItemsService.insert(billsItems);
            if (!insert) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "列表数据有问题，请检查";
            }
        }
        EntityWrapper<ProjectBillsBudgets> billsBudgetsEntityWrapper = new EntityWrapper<>();
        billsBudgetsEntityWrapper.eq("project_sub_no", purchaseBills.getProjectSubNo())
                .eq("budget_id", 2)
                .eq("branch_id", sysUserDto.getLoginContractorId());
        ProjectBillsBudgets billsBudgets = projectBillsBudgetsService.selectOne(billsBudgetsEntityWrapper);
        if (amtCr > 0) {
            billsBudgets.setBudgetUseAmt(billsBudgets.getBudgetUseAmt() - amtCr);
        }
        billsBudgets.setBudgetUseAmt(billsBudgets.getBudgetUseAmt() + number);
        if (!projectBillsBudgetsService.updateById(billsBudgets)) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "更新预算失败";
        }
        double amt = projectBillsBudgetsService.selectApprovedAmountSum(billsBudgets);
        EntityWrapper<ProjectBillsSubs> subsEntityWrapper = new EntityWrapper<>();
        subsEntityWrapper.eq("project_sub_no", purchaseBills.getProjectSubNo())
                .eq("branch_id", sysUserDto.getLoginContractorId());
        ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(subsEntityWrapper);
        projectBillsSubs.setActualBudgetAmt(amt);
        boolean updateById = projectBillsSubsService.updateById(projectBillsSubs);
        if (!updateById) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "更新预算失败";
        }
        return "1";
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public String zancun(String purchaseBillsDto, String billsItemsDtos) {
        PurchaseBills purchaseBills = JSONArray.parseObject(purchaseBillsDto, PurchaseBills.class);
        JSONArray arrayList = JSONArray.parseArray(billsItemsDtos);
        List<PurchaseBillsItems> purchaseBillsItemsList = JSONObject.parseArray(arrayList.toJSONString(), PurchaseBillsItems.class);
        Boolean bills = purchaseBillsService.insertOrUpdate(purchaseBills);
        Boolean items = purchaseBillsItemsService.insertOrUpdateBatch(purchaseBillsItemsList);
        if (!bills) {
            return "表单数据有问题，请检查";
        } else if (!items) {
            return "列表数据有问题，请检查";
        }
        return "1";

    }

    @Override
    public String over(String from, String list) {
        PurchaseBills purchaseBills = JSONArray.parseObject(from, PurchaseBills.class);
        JSONArray arrayList = JSONArray.parseArray(list);
        List<PurchaseBillsItems> billsItemsDtos = JSONObject.parseArray(arrayList.toJSONString(), PurchaseBillsItems.class);
        purchaseBills.setBillStatus(6);
        purchaseBills.setActId(3);
        Boolean bills = purchaseBillsService.insert(purchaseBills);
        Boolean items = purchaseBillsItemsService.insertBatch(billsItemsDtos);
        if (bills && items) {
            return "提交成功";
        } else {
            return "提交失败";
        }
    }

    @Override
    public Map<String, Object> getItem(String billNo, SysUserDto sysUserDto) {
        Map<String, Object> map = new HashMap<>();
        EntityWrapper<ProjectBillsBudgets> budgetsEntityWrapper = new EntityWrapper<>();
        budgetsEntityWrapper.eq("project_sub_no", billNo)
                .eq("budget_id", 2)
                .eq("branch_id", sysUserDto.getLoginContractorId());
        ProjectBillsBudgets projectBillsBudgets = projectBillsBudgetsService.selectOne(budgetsEntityWrapper);
        if (projectBillsBudgets == null) {
            map.put("budget", 0);
        }
        map.put("budget", projectBillsBudgets);
        EntityWrapper<PurchaseBills> billsEntityWrapper = new EntityWrapper<>();
        // 1 是需求计划
        billsEntityWrapper.eq("project_sub_no", billNo);
        billsEntityWrapper.eq("act_id", 1);
        PurchaseBills purchaseBills = purchaseBillsService.selectOne(billsEntityWrapper);
        EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
        projectBillsSubsEntityWrapper.eq("project_sub_no", billNo);
        ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
        EntityWrapper<Projectbills> projectbillsEntityWrapper = new EntityWrapper<>();
        projectbillsEntityWrapper.eq("bill_no", projectBillsSubs.getBillNo());
        map.put("project", projectbillsService.selectOne(projectbillsEntityWrapper));
        if (purchaseBills == null) {
            map.put("bills", 0);
        } else {
            map.put("bills", purchaseBills);
        }
        return map;
    }

    // 去除审批流
    @Override
    @Transactional(rollbackFor = Exception.class)
    public String saveOne(String from, String list, SysUserDto sysUserDto, String attach) {
        PurchaseBills purchaseBills = JSONArray.parseObject(from, PurchaseBills.class);
        purchaseBills.setPostDate(new Date());
        purchaseBills.setBillStatus(4);
        Boolean bills = purchaseBillsService.insertOrUpdate(purchaseBills);
        if (!bills) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "提交失败！请仔细检查表单";
        }
        JSONArray arrayList = JSONArray.parseArray(list);
        List<PurchaseBillsItems> billsItemsDtos = JSONObject.parseArray(arrayList.toJSONString(), PurchaseBillsItems.class);
        EntityWrapper<PurchaseBillsItems> billsItemsEntityWrapper = new EntityWrapper<>();
        billsItemsEntityWrapper.eq("bill_no", purchaseBills.getBillNo())
                .eq("project_Sub_No", purchaseBills.getProjectSubNo());
        boolean delete = purchaseBillsItemsService.delete(billsItemsEntityWrapper);
        if (!delete) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "提交失败！删除旧数据失败";
        }
        if (billsItemsDtos.size() != 0) {
            int line = 0;
            for (PurchaseBillsItems pv : billsItemsDtos) {
                EntityWrapper<PurchaseBillsItems> purchaseBillsItemsEntityWrapper = new EntityWrapper<>();
                purchaseBillsItemsEntityWrapper.eq("bill_no", pv.getSrcBillNo())
                        .eq("lino_no", pv.getSrcLinoNo())
                        .eq("project_sub_no", pv.getProjectSubNo());
                PurchaseBillsItems updateItem = purchaseBillsItemsService.selectOne(purchaseBillsItemsEntityWrapper);
                if (updateItem.getPurchaseInvQty() == null || updateItem.getPurchaseInvQty() == 0) {
                    updateItem.setPurchaseInvQty(pv.getRequireQty());
                } else {
                    updateItem.setPurchaseInvQty(pv.getRequireQty() + updateItem.getPurchaseInvQty());
                }
                if (updateItem.getTimeAmt() == null) {
                    updateItem.setTimeAmt(pv.getTimeAmt());
                } else {
                    updateItem.setTimeAmt(pv.getTimeAmt() + updateItem.getTimeAmt());
                }
                boolean updeteType = purchaseBillsItemsService.updateById(updateItem);
                if (!updeteType) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "审批驳回失败: 更新预算失败";
                }
                line++;
                pv.setLinoNo(line);
                pv.setSrcBillNo(updateItem.getBillNo());
                pv.setSrcLinoNo(updateItem.getLinoNo());
                pv.setProjectSubNo(purchaseBills.getProjectSubNo());
                Boolean itemPro = purchaseBillsItemsService.insertOrUpdate(pv);
                if (!itemPro) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "提交失败！请仔细检查表单";
                }
            }
        }
        EntityWrapper<ProjectBillsBudgets> budgetsEntityWrapper = new EntityWrapper<>();
        budgetsEntityWrapper.eq("project_sub_no", purchaseBills.getProjectSubNo())
                .eq("budget_id", 2)
                .eq("branch_id", sysUserDto.getLoginContractorId());
        ProjectBillsBudgets billsBudgets = projectBillsBudgetsService.selectOne(budgetsEntityWrapper);
        if (billsBudgets.getBudgetAmt() < (billsBudgets.getBudgetUseAmt() + purchaseBills.getAmt())) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "提交失败！超出预算";
        }
        billsBudgets.setBudgetUseAmt(billsBudgets.getBudgetUseAmt() + purchaseBills.getAmt());
        billsBudgets.setApprovedAmount(billsBudgets.getBudgetUseAmt());
        boolean updateById = projectBillsBudgetsService.updateById(billsBudgets);
        if (!updateById) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "提交失败！更新预算失败";
        }
        double amt = projectBillsBudgetsService.selectApprovedAmountSum(billsBudgets);
        EntityWrapper<ProjectBillsSubs> subsEntityWrapper = new EntityWrapper<>();
        subsEntityWrapper.eq("project_sub_no", purchaseBills.getProjectSubNo())
                .eq("branch_id", sysUserDto.getLoginContractorId());
        ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(subsEntityWrapper);
        projectBillsSubs.setActualBudgetAmt(amt);
        boolean updateByProSub = projectBillsSubsService.updateById(projectBillsSubs);
        if (!updateByProSub) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "更新预算失败";
        }
        int act = this.selectActId(purchaseBills);
        /*if (Objects.equals(purchaseBills.getPurchaseModeId(), 1)) {
            // 公开招标
            act = 430;
        } else if (Objects.equals(purchaseBills.getPurchaseModeId(), 2)) {
            // 邀请招标
            if (purchaseBills.getAmt() <= 1000000) {
                act = 431;
            } else if (purchaseBills.getAmt() > 1000000 && purchaseBills.getAmt() <= 2000000) {
                act = 432;
            } else if (purchaseBills.getAmt() > 2000000) {
                act = 433;
            }
        } else if (Objects.equals(purchaseBills.getPurchaseModeId(), 3)) {
            // 竞争性谈判
            if (purchaseBills.getAmt() <= 1000000) {
                act = 434;
            } else if (purchaseBills.getAmt() > 1000000 && purchaseBills.getAmt() <= 2000000) {
                act = 435;
            }
        } else if (Objects.equals(purchaseBills.getPurchaseModeId(), 4)) {
            // 询价采购
            if (purchaseBills.getAmt() <= 300000) {
                act = 436;
            }
        } else if (Objects.equals(purchaseBills.getPurchaseModeId(), 5)) {
            // 自主采购
            if (purchaseBills.getAmt() <= 100000) {
                act = 438;
            } else if (purchaseBills.getAmt() > 100000) {
                act = 439;
            }
        }*/
        Audit audit = new Audit();
        audit.setBillNo(purchaseBills.getBillNo());
        audit.setActId(act);
        audit.setLevelId(0);
        audit.setIffinalItem("F");
        audit.setSubJect(projectBillsSubs.getProjectSubName());
        audit.setProjectNo(purchaseBills.getProjectSubNo());
        audit.setBranchId(projectBillsSubs.getApprovalBranchId());
        audit.setSendUserId(sysUserDto.getUserId().intValue());
        audit.setSendName(sysUserDto.getActualname());
        audit.setSendTime(new Date());
        audit.setAuditUserId(sysUserDto.getUserId().intValue());
        audit.setAuditItem(new Date());
        audit.setAuditMsg("提交");
        audit.setAuditStatus("O");
        audit.setProjectMngId(projectBillsSubs.getProjectSubMngId());
        EntityWrapper<Projectbills> projectbillsEntityWrapper = new EntityWrapper<>();
        projectbillsEntityWrapper.setSqlSelect("id", "project_leader").eq("bill_no", projectBillsSubs.getBillNo())
                .eq("act_id", projectBillsSubs.getActId());
        Projectbills projectbills = projectbillsService.selectOne(projectbillsEntityWrapper);
        if (projectbills != null) {
            audit.setProjectLeader(projectbills.getProjectLeader());
        }
        boolean approvalFlow = auditItemsService.createApprovalFlow(audit);
        if (!approvalFlow) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "审批流异常请检查提交信息";
        }
        JSONArray attachList = JSONArray.parseArray(attach);
        List<ProjectBillsAttachs> projectBillsAttachsList = JSONObject.parseArray(attachList.toJSONString(), ProjectBillsAttachs.class);
        EntityWrapper<ProjectBillsAttachs> billsAttachsEntityWrapper = new EntityWrapper<>();
        billsAttachsEntityWrapper.eq("bill_no", purchaseBills.getBillNo())
                .eq("act_id", 977)
                .eq("branch_id", projectBillsSubs.getBranchId());
        boolean deleteAttach = projectBillsAttachsService.delete(billsAttachsEntityWrapper);
        if (!deleteAttach) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "提交失败！删除旧附件失败";
        }
        if (projectBillsAttachsList.size() != 0) {
            int line = 0;
            for (ProjectBillsAttachs attachs : projectBillsAttachsList) {
                line++;
                attachs.setBillNo(purchaseBills.getBillNo());
                attachs.setLineNo(line);
                attachs.setBranchId(projectBillsSubs.getBranchId());
                boolean insert = projectBillsAttachsService.insert(attachs);
                if (!insert) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "提交失败！添加附件失败";
                }
            }
        }
        return "1";
    }

    public int selectActId (PurchaseBills purchaseBills) {
        int act = 0;
        // 公开招标
        if (Objects.equals(purchaseBills.getPurchaseModeId(), 1)) {
            act = 430;
            // 邀请招标
        } else if (Objects.equals(purchaseBills.getPurchaseModeId(), 2)) {
            // 物资采购-招标采购-邀请招标(100W及以下(包括))
            if (purchaseBills.getAmt() <= 1000000) {
                act = 431;
                // 物资采购-招标采购-邀请招标(100W(不包括)-200W(包括)以下)
            } else if (purchaseBills.getAmt() > 1000000 && purchaseBills.getAmt() <= 2000000) {
                act = 432;
                // 物资采购-招标采购-邀请招标(200W(不包括)以上)
            } else if (purchaseBills.getAmt() > 2000000) {
                act = 433;
            }
            // 竞争性谈判
        } else if (Objects.equals(purchaseBills.getPurchaseModeId(), 3)) {
            // 物资采购-招标采购-竞争性谈判(50W(包括)及以下)
            if (purchaseBills.getAmt() <= 500000) {
                act = 434;
                // 物资采购-招标采购-竞争性谈判(50W(不包括)-100W(包括))
            } else if (purchaseBills.getAmt() > 500000 && purchaseBills.getAmt() <= 1000000) {
                act = 435;
                // 物资采购-招标采购-竞争性谈判(100W(不包括)-200W(包括))
            } else if (purchaseBills.getAmt() > 1000000 && purchaseBills.getAmt() <= 2000000) {
                act = 436;
            }
            // 询价采购
        } else if (Objects.equals(purchaseBills.getPurchaseModeId(), 4)) {
            // 物资采购-招标采购-询价采购(30W(包括)以下)
            if (purchaseBills.getAmt() <= 300000) {
                act = 437;
                // 物资采购-招标采购-询价采购(30W(不包括) – 50W(不包括))
            } else if (purchaseBills.getAmt() > 300000 && purchaseBills.getAmt() < 500000) {
                act = 438;
            }
            // 自主采购
        } else if (Objects.equals(purchaseBills.getPurchaseModeId(), 5)) {
            // 物资采购-招标采购-自主采购(5W(包括)及以下)
            if (purchaseBills.getAmt() <= 50000) {
                act = 439;
                // 物资采购-招标采购-自主采购(5W(不包括)以上)
            } else if (purchaseBills.getAmt() > 50000) {
                act = 440;
            }
        }
        return act;
    }

    /*@Override
    @Transactional(rollbackFor = Exception.class)
    public String saveTwo(String from, String list, String supplierList, SysUserDto sysUserDto, String attach) {
        PurchaseBills purchaseBills = JSONArray.parseObject(from, PurchaseBills.class);
        // 需求计划：1， 工程采购：2，材料采购：3，采购台账：4
        purchaseBills.setPostDate(new Date());
        purchaseBills.setBillStatus(6);
        purchaseBills.setBudgetUseAmt(purchaseBills.getBudgetUseAmt() + purchaseBills.getAmt());
        Boolean bills = purchaseBillsService.insertOrUpdate(purchaseBills);
        if (!bills) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "提交失败！请仔细检查表单";
        }
        JSONArray arrayList = JSONArray.parseArray(list);
        List<PurchaseBillsItems> billsItemsDtos = JSONObject.parseArray(arrayList.toJSONString(), PurchaseBillsItems.class);
        EntityWrapper<PurchaseBillsItems> purchaseBillsItemsEntityWrapper = new EntityWrapper<>();
        purchaseBillsItemsEntityWrapper.eq("bill_no", purchaseBills.getBillNo())
                .eq("project_Sub_No", purchaseBills.getProjectSubNo());
        boolean delete = purchaseBillsItemsService.delete(purchaseBillsItemsEntityWrapper);
        if (!delete) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "提交失败！删除旧数据失败";
        }
        if (billsItemsDtos.size() != 0) {
            int line = 0;
            for (PurchaseBillsItems pb : billsItemsDtos) {
                line++;
                pb.setLinoNo(line);
                Boolean itemPro = purchaseBillsItemsService.insertOrUpdate(pb);
                if (!itemPro) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "提交失败！请仔细检查物料列表";
                }
            }
            for (PurchaseBillsItems items : billsItemsDtos) {
                EntityWrapper<PurchaseBillsItems> billsItemsEntityWrapper = new EntityWrapper<>();
                billsItemsEntityWrapper.eq("bill_no", items.getSrcBillNo())
                        .eq("lino_no", items.getSrcLinoNo())
                        .eq("project_sub_no", purchaseBills.getProjectSubNo());
                PurchaseBillsItems updateItem = purchaseBillsItemsService.selectOne(billsItemsEntityWrapper);
                if (updateItem.getPurchaseInvQty() == null || updateItem.getPurchaseInvQty() == 0) {
                    updateItem.setPurchaseInvQty(items.getRequireQty().intValue());
                } else {
                    updateItem.setPurchaseInvQty(items.getRequireQty().intValue() + updateItem.getPurchaseInvQty());
                }
                if (updateItem.getTimeAmt() == null) {
                    updateItem.setTimeAmt(items.getTimeAmt());
                } else {
                    updateItem.setTimeAmt(items.getTimeAmt() + updateItem.getTimeAmt());
                }
                boolean updeteType = purchaseBillsItemsService.updateById(updateItem);
                if (!updeteType) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "审批驳回失败: 更新预算失败";
                }
            }
        }
        JSONArray arraySupplier = JSONArray.parseArray(supplierList);
        List<PurchaseBillsPurids> listSupplier = JSONObject.parseArray(arraySupplier.toJSONString(), PurchaseBillsPurids.class);
        EntityWrapper<PurchaseBillsPurids> billsPuridsEntityWrapper = new EntityWrapper<>();
        billsPuridsEntityWrapper.eq("bill_no", purchaseBills.getBillNo());
        boolean deleteByPurchasePurids = purchaseBillsPuridsService.delete(billsPuridsEntityWrapper);
        if (!deleteByPurchasePurids) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "提交失败！删除旧数据失败";
        }
        if (listSupplier.size() != 0) {
            int line = 0;
            for (PurchaseBillsPurids pb : listSupplier) {
                line++;
                pb.setLineNo(line);
                Boolean supper = purchaseBillsPuridsService.insertOrUpdate(pb);
                if (!supper) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "提交失败！请仔细检查供应商列表";
                }
            }
        }
        EntityWrapper<ProjectBillsBudgets> budgetsEntityWrapper = new EntityWrapper<>();
        budgetsEntityWrapper.eq("project_sub_no", purchaseBills.getProjectSubNo())
                .eq("budget_id", 2)
                .eq("branch_id", sysUserDto.getLoginContractorId());
        ProjectBillsBudgets billsBudgets = projectBillsBudgetsService.selectOne(budgetsEntityWrapper);
        if (billsBudgets.getBudgetAmt() < (billsBudgets.getBudgetUseAmt() + purchaseBills.getAmt())) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "提交失败！超出预算";
        }
        billsBudgets.setBudgetUseAmt(billsBudgets.getBudgetUseAmt() + purchaseBills.getAmt());
        billsBudgets.setApprovedAmount(billsBudgets.getBudgetUseAmt());
        boolean updateById = projectBillsBudgetsService.updateById(billsBudgets);
        if (!updateById) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "提交失败！更新预算失败";
        }
        double amt = projectBillsBudgetsService.selectApprovedAmountSum(billsBudgets);
        EntityWrapper<ProjectBillsSubs> subsEntityWrapper = new EntityWrapper<>();
        subsEntityWrapper.eq("project_sub_no", billsBudgets.getProjectSubNo())
                .eq("branch_id", billsBudgets.getBranchId());
        ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(subsEntityWrapper);
        projectBillsSubs.setActualBudgetAmt(amt);
        boolean updateByProSub = projectBillsSubsService.updateById(projectBillsSubs);
        if (!updateByProSub) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "更新预算失败";
        }
        JSONArray attachList = JSONArray.parseArray(attach);
        List<ProjectBillsAttachs> projectBillsAttachsList = JSONObject.parseArray(attachList.toJSONString(), ProjectBillsAttachs.class);
        EntityWrapper<ProjectBillsAttachs> billsAttachsEntityWrapper = new EntityWrapper<>();
        billsAttachsEntityWrapper.eq("bill_no", purchaseBills.getBillNo())
                .eq("act_id", 988)
                .eq("branch_id", projectBillsSubs.getBranchId());
        boolean deleteAttach = projectBillsAttachsService.delete(billsAttachsEntityWrapper);
        if (!deleteAttach) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "提交失败！删除旧附件失败";
        }
        if (projectBillsAttachsList.size() != 0) {
            int line = 0;
            for (ProjectBillsAttachs attachs : projectBillsAttachsList) {
                line++;
                attachs.setBillNo(purchaseBills.getBillNo());
                attachs.setLineNo(line);
                attachs.setBranchId(projectBillsSubs.getBranchId());
                boolean insert = projectBillsAttachsService.insert(attachs);
                if (!insert) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "提交失败！添加附件失败";
                }
            }
        }
        return "1";
    }*/
    @Override
    @Transactional(rollbackFor = Exception.class)
    public String saveTwo(String from, String list, String supplierList, SysUserDto sysUserDto, String attach) {
        PurchaseBills purchaseBills = JSONArray.parseObject(from, PurchaseBills.class);
        EntityWrapper<ProjectBillsSubs> subsEntityWrapper = new EntityWrapper<>();
        subsEntityWrapper.eq("project_sub_no", purchaseBills.getProjectSubNo())
                .eq("branch_id", sysUserDto.getLoginContractorId());
        ProjectBillsSubs projectbillsDto = projectBillsSubsService.selectOne(subsEntityWrapper);
        Audit audit = new Audit();
        audit.setBillNo(purchaseBills.getBillNo());
        if (purchaseBills.getAmt() < 50000) {
            audit.setActId(420);
        } else if (purchaseBills.getAmt() >= 50000 && purchaseBills.getAmt() < 100000) {
            audit.setActId(421);
        } else if (purchaseBills.getAmt() >= 100000 && purchaseBills.getAmt() < 300000) {
            audit.setActId(422);
        } else if (purchaseBills.getAmt() >= 300000) {
            audit.setActId(423);
        }
        audit.setLevelId(0);
        audit.setIffinalItem("F");
        audit.setSubJect(projectbillsDto.getProjectSubName());
        audit.setProjectNo(purchaseBills.getProjectSubNo());
        audit.setBranchId(projectbillsDto.getApprovalBranchId());
        audit.setSendUserId(sysUserDto.getUserId().intValue());
        audit.setSendName(sysUserDto.getActualname());
        audit.setSendTime(new Date());
        audit.setAuditUserId(sysUserDto.getUserId().intValue());
        audit.setAuditItem(new Date());
        audit.setAuditMsg("提交");
        audit.setAuditStatus("O");
        audit.setProjectMngId(projectbillsDto.getProjectSubMngId());
        EntityWrapper<Projectbills> projectbillsEntityWrapper = new EntityWrapper<>();
        projectbillsEntityWrapper.setSqlSelect("id", "project_leader").eq("bill_no", projectbillsDto.getBillNo())
                .eq("act_id", projectbillsDto.getActId()).eq("branch_id", projectbillsDto.getBranchId());
        Projectbills projectbills = projectbillsService.selectOne(projectbillsEntityWrapper);
        if (projectbills != null) {
            audit.setProjectLeader(projectbills.getProjectLeader());
        }
        boolean approvalFlow = auditItemsService.createApprovalFlow(audit);
        if (!approvalFlow) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "审批流异常请检查提交信息";
        }
        // 需求计划：1， 工程采购：2，材料采购：3，采购台账：4
        purchaseBills.setBillStatus(4);
        purchaseBills.setContractorId(sysUserDto.getLoginContractorId());
        purchaseBills.setPostDate(new Date());
        purchaseBills.setBudgetUseAmt(purchaseBills.getBudgetUseAmt() + purchaseBills.getAmt());
        Boolean bills = purchaseBillsService.insertOrUpdate(purchaseBills);
        if (!bills) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "提交失败！请仔细检查表单";
        }
        JSONArray arrayList = JSONArray.parseArray(list);
        List<PurchaseBillsItems> billsItemsDtos = JSONObject.parseArray(arrayList.toJSONString(), PurchaseBillsItems.class);
        EntityWrapper<PurchaseBillsItems> purchaseBillsItemsEntityWrapper = new EntityWrapper<>();
        purchaseBillsItemsEntityWrapper.eq("bill_no", purchaseBills.getBillNo())
                .eq("project_Sub_No", purchaseBills.getProjectSubNo());
        boolean delete = purchaseBillsItemsService.delete(purchaseBillsItemsEntityWrapper);
        if (!delete) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "提交失败！删除旧数据失败";
        }
        if (billsItemsDtos.size() != 0) {
            int line = 0;
            for (PurchaseBillsItems pb : billsItemsDtos) {
                EntityWrapper<PurchaseBillsItems> billsItemsEntityWrapper = new EntityWrapper<>();
                billsItemsEntityWrapper.eq("bill_no", pb.getSrcBillNo())
                        .eq("lino_no", pb.getSrcLinoNo())
                        .eq("project_sub_no", pb.getProjectSubNo());
                PurchaseBillsItems updateItem = purchaseBillsItemsService.selectOne(billsItemsEntityWrapper);
                if (updateItem.getPurchaseInvQty() == null || updateItem.getPurchaseInvQty() == 0) {
                    updateItem.setPurchaseInvQty(pb.getRequireQty());
                } else {
                    updateItem.setPurchaseInvQty(pb.getRequireQty() + updateItem.getPurchaseInvQty());
                }
                if (updateItem.getTimeAmt() == null) {
                    updateItem.setTimeAmt(pb.getTimeAmt());
                } else {
                    updateItem.setTimeAmt(DataUtils.keepDecimals(pb.getTimeAmt() + updateItem.getTimeAmt()));
                }
                boolean updeteType = purchaseBillsItemsService.updateById(updateItem);
                if (!updeteType) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "审批驳回失败: 更新预算失败";
                }
                line++;
                pb.setLinoNo(line);
                pb.setSrcBillNo(updateItem.getBillNo());
                pb.setSrcLinoNo(updateItem.getLinoNo());
                pb.setProjectSubNo(purchaseBills.getProjectSubNo());
                Boolean itemPro = purchaseBillsItemsService.insertOrUpdate(pb);
                if (!itemPro) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "提交失败！请仔细检查物料列表";
                }
            }
        }
        JSONArray arraySupplier = JSONArray.parseArray(supplierList);
        List<PurchaseBillsPurids> listSupplier = JSONObject.parseArray(arraySupplier.toJSONString(), PurchaseBillsPurids.class);
        EntityWrapper<PurchaseBillsPurids> billsPuridsEntityWrapper = new EntityWrapper<>();
        billsPuridsEntityWrapper.eq("bill_no", purchaseBills.getBillNo())
                .eq("act_id", purchaseBills.getActId());
        boolean deleteByPurchasePurids = purchaseBillsPuridsService.delete(billsPuridsEntityWrapper);
        if (!deleteByPurchasePurids) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "提交失败！删除旧数据失败";
        }
        if (listSupplier.size() != 0) {
            int line = 0;
            for (PurchaseBillsPurids pb : listSupplier) {
                line++;
                pb.setLineNo(line);
                Boolean supper = purchaseBillsPuridsService.insertOrUpdate(pb);
                if (!supper) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "提交失败！请仔细检查供应商列表";
                }
            }
        }
        EntityWrapper<ProjectBillsBudgets> budgetsEntityWrapper = new EntityWrapper<>();
        budgetsEntityWrapper.eq("project_sub_no", purchaseBills.getProjectSubNo())
                .eq("budget_id", 2)
                .eq("branch_id", sysUserDto.getLoginContractorId());
        ProjectBillsBudgets billsBudgets = projectBillsBudgetsService.selectOne(budgetsEntityWrapper);
        if (billsBudgets.getBudgetAmt() < (billsBudgets.getBudgetUseAmt() + purchaseBills.getAmt())) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "提交失败！超出预算";
        }
        billsBudgets.setBudgetUseAmt(billsBudgets.getBudgetUseAmt() + purchaseBills.getAmt());
        billsBudgets.setApprovedAmount(billsBudgets.getBudgetUseAmt());
        boolean updateById = projectBillsBudgetsService.updateById(billsBudgets);
        if (!updateById) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "提交失败！更新预算失败";
        }
        double amt = projectBillsBudgetsService.selectApprovedAmountSum(billsBudgets);
        projectbillsDto.setActualBudgetAmt(amt);
        boolean updateByProSub = projectBillsSubsService.updateById(projectbillsDto);
        if (!updateByProSub) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "更新预算失败";
        }
        JSONArray attachList = JSONArray.parseArray(attach);
        List<ProjectBillsAttachs> projectBillsAttachsList = JSONObject.parseArray(attachList.toJSONString(), ProjectBillsAttachs.class);
        EntityWrapper<ProjectBillsAttachs> billsAttachsEntityWrapper = new EntityWrapper<>();
        billsAttachsEntityWrapper.eq("bill_no", purchaseBills.getBillNo())
                .eq("act_id", 988)
                .eq("branch_id", projectbillsDto.getBranchId());
        boolean deleteAttach = projectBillsAttachsService.delete(billsAttachsEntityWrapper);
        if (!deleteAttach) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "提交失败！删除旧附件失败";
        }
        if (projectBillsAttachsList.size() != 0) {
            int line = 0;
            for (ProjectBillsAttachs attachs : projectBillsAttachsList) {
                line++;
                attachs.setBillNo(purchaseBills.getBillNo());
                attachs.setLineNo(line);
                attachs.setBranchId(projectbillsDto.getBranchId());
                boolean insert = projectBillsAttachsService.insert(attachs);
                if (!insert) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "提交失败！添加附件失败";
                }
            }
        }
        return "1";
    }

    /*审批版本*/
    /*@Override
    @Transactional(rollbackFor = Exception.class)
    public String saveTwo(String from, String list, String supplierList, SysUserDto sysUserDto) {
        PurchaseBills purchaseBills = JSONArray.parseObject(from, PurchaseBills.class);
        JSONArray arrayList = JSONArray.parseArray(list);
        List<PurchaseBillsItems> billsItemsDtos = JSONObject.parseArray(arrayList.toJSONString(), PurchaseBillsItems.class);
        JSONArray arraySupplier = JSONArray.parseArray(supplierList);
        List<PurchaseBillsPurids> listSupplier = JSONObject.parseArray(arraySupplier.toJSONString(), PurchaseBillsPurids.class);
        // 需求计划：1， 工程采购：2，材料采购：3，采购台账：4
        purchaseBills.setPostDate(new Date());
        EntityWrapper<ProjectBillsSubs> subsEntityWrapper = new EntityWrapper<>();
        subsEntityWrapper.eq("project_sub_no", purchaseBills.getProjectSubNo());
        if (Objects.equals(sysUserDto.getContractorId(), 1)) {
            subsEntityWrapper.eq("branch_id", sysUserDto.getLoginContractorId());
        } else {
            subsEntityWrapper.eq("branch_id", sysUserDto.getContractorId());
        }
        ProjectBillsSubs projectbillsDto = projectBillsSubsService.selectOne(subsEntityWrapper);
        Audit audit = new Audit();
        audit.setBillNo(purchaseBills.getBillNo());
        audit.setActId(440);
        audit.setLevelId(0);
        audit.setIffinalItem("F");
        audit.setSubJect(projectbillsDto.getProjectSubName());
        audit.setProjectNo(purchaseBills.getProjectSubNo());
        audit.setBranchId(projectbillsDto.getBranchId());
        audit.setSendUserId(sysUserDto.getUserId().intValue());
        audit.setSendName(sysUserDto.getUsername());
        audit.setSendTime(new Date());
        audit.setAuditUserId(sysUserDto.getUserId().intValue());
        audit.setAuditItem(new Date());
        audit.setAuditMsg("提交");
        audit.setAuditStatus("O");
        audit.setProjectMngId(projectbillsDto.getProjectSubMngId());
        EntityWrapper<Projectbills> projectbillsEntityWrapper = new EntityWrapper<>();
        projectbillsEntityWrapper.setSqlSelect("id", "project_leader").eq("bill_no", projectbillsDto.getBillNo())
                .eq("act_id", projectbillsDto.getActId()).eq("branch_id", projectbillsDto.getBranchId());
        Projectbills projectbills = projectbillsService.selectOne(projectbillsEntityWrapper);
        if (projectbills != null) {
            audit.setProjectLeader(projectbills.getProjectLeader());
        }
        boolean approvalFlow = auditItemsService.createApprovalFlow(audit);
        if (!approvalFlow) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "审批流异常请检查提交信息";
        }
        purchaseBills.setBillStatus(4);
        purchaseBills.setBudgetUseAmt(purchaseBills.getBudgetUseAmt() + purchaseBills.getAmt());
        Boolean bills = purchaseBillsService.insertOrUpdate(purchaseBills);
        if (!bills) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "提交失败！请仔细检查表单";
        }
        if (billsItemsDtos.size() != 0) {
            EntityWrapper<PurchaseBillsItems> itemsEntityWrapper = new EntityWrapper<>();
            itemsEntityWrapper.eq("bill_no", purchaseBills.getBillNo())
                    .eq("act_id", purchaseBills.getActId())
                    .eq("project_sub_no", purchaseBills.getProjectSubNo());
            boolean delete = purchaseBillsItemsService.delete(itemsEntityWrapper);
            if (!delete) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "提交失败！删除旧数据失败";
            }
            int line = 0;
            for (PurchaseBillsItems pb : billsItemsDtos) {
                line++;
                pb.setLinoNo(line);
                Boolean itemPro = purchaseBillsItemsService.insert(pb);
                if (!itemPro) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "提交失败！请仔细检查物料列表";
                }
            }
        }
        if (listSupplier.size() != 0) {
            EntityWrapper<PurchaseBillsPurids> itemsEntityWrapper = new EntityWrapper<>();
            itemsEntityWrapper.eq("bill_no", purchaseBills.getBillNo())
                    .eq("act_id", purchaseBills.getActId());
            boolean delete = purchaseBillsPuridsService.delete(itemsEntityWrapper);
            if (!delete) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "提交失败！删除旧数据失败";
            }
            int line = 0;
            for (PurchaseBillsPurids pb : listSupplier) {
                line++;
                pb.setLineNo(line);
                Boolean supper = purchaseBillsPuridsService.insertOrUpdateBatch(listSupplier);
                if (!supper) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "提交失败！请仔细检查供应商列表";
                }
            }
        }
        EntityWrapper<ProjectBillsBudgets> budgetsEntityWrapper = new EntityWrapper<>();
        budgetsEntityWrapper.eq("project_sub_no", purchaseBills.getProjectSubNo());
        budgetsEntityWrapper.eq("budget_id", 2);
        ProjectBillsBudgets projectBillsBudgets = projectBillsBudgetsService.selectOne(budgetsEntityWrapper);
        if ((Double) projectBillsBudgets.getBudgetUseAmt() != null && projectBillsBudgets.getBudgetUseAmt() != 0.0) {
            if (projectBillsBudgets.getBudgetAmt() < (projectBillsBudgets.getBudgetUseAmt() + purchaseBills.getAmt())) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "提交失败！超出预算";
            }
            projectBillsBudgets.setBudgetUseAmt(projectBillsBudgets.getBudgetUseAmt() + purchaseBills.getAmt());
            boolean updateById = projectBillsBudgetsService.updateById(projectBillsBudgets);
            if (!updateById) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "提交失败！更新预算失败";
            }
        } else {
            if (projectBillsBudgets.getBudgetAmt() < purchaseBills.getAmt()) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "提交失败！超出预算";
            }
            projectBillsBudgets.setBudgetUseAmt(purchaseBills.getAmt());
            boolean updateById = projectBillsBudgetsService.updateById(projectBillsBudgets);
            if (!updateById) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "提交失败！更新预算失败";
            }
        }
        return "1";
    }*/

    @Override
    public Map<String, Object> onceAgain(Integer id) {
        // 需求计划修改查询方法
        Map<String, Object> map = new HashMap<>();
        if (id != null) {
            PurchaseBills purchaseBills = purchaseBillsService.selectById(id);
            EntityWrapper<PurchaseBillsItems> purchaseBillsItemsEntityWrapper = new EntityWrapper<>();
            purchaseBillsItemsEntityWrapper.eq("bill_no", purchaseBills.getBillNo());
            purchaseBillsItemsEntityWrapper.eq("act_id", purchaseBills.getActId());
            // 应用框架供应商
            EntityWrapper<PurchaseBillsPurids> bpurchasesEntityWrapper = new EntityWrapper<>();
            bpurchasesEntityWrapper.eq("bill_no", purchaseBills.getBillNo());
            //  二级项目
            EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
            projectBillsSubsEntityWrapper.eq("project_sub_no", purchaseBills.getProjectSubNo())
                    .eq("branch_id", purchaseBills.getContractorId());
            ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
            EntityWrapper<ProjectBillsBudgets> budgetsEntityWrapper = new EntityWrapper<>();
            budgetsEntityWrapper.eq("project_sub_no", purchaseBills.getProjectSubNo())
                    .eq("budget_id", 2)
                    .eq("branch_id", projectBillsSubs.getBranchId());
            EntityWrapper<Projectbills> projectbillsEntityWrapper = new EntityWrapper<>();
            projectbillsEntityWrapper.eq("bill_no", projectBillsSubs.getBillNo())
                    .eq("branch_id", projectBillsSubs.getBranchId());
            if (purchaseBills.getPurchaseSrcId() != null && purchaseBills.getPurchaseSrcId() == 333) {
                map.put("pur", bpurchasesService.selectById(purchaseBills.getPurchaseId()));
            }
            EntityWrapper<ProjectBillsAttachs> billsAttachsEntityWrapper = new EntityWrapper<>();
            billsAttachsEntityWrapper.eq("bill_no", purchaseBills.getBillNo())
                    .eq("branch_id", projectBillsSubs.getBranchId());
            if (Objects.equals(purchaseBills.getPurchaseSrcId(), 111)) {
                billsAttachsEntityWrapper.eq("act_id", 977);
            } else if (Objects.equals(purchaseBills.getPurchaseSrcId(), 222)) {
                billsAttachsEntityWrapper.eq("act_id", 988);
            }
            List<ProjectBillsAttachs> projectBillsAttachsList = projectBillsAttachsService.selectList(billsAttachsEntityWrapper);
            map.put("attach", projectBillsAttachsList);
            map.put("bills", purchaseBills);
            map.put("item", purchaseBillsItemsService.selectList(purchaseBillsItemsEntityWrapper));
            map.put("erji", projectBillsSubs);
            map.put("gong", purchaseBillsPuridsService.selectList(bpurchasesEntityWrapper));
            map.put("project", projectbillsService.selectOne(projectbillsEntityWrapper));
            map.put("brand", bbranchsService.selectById(purchaseBills.getContractorId()));
            map.put("yu", projectBillsBudgetsService.selectOne(budgetsEntityWrapper));
        }
        return map;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public String temporaryOne(String zhu, String mingxi, SysUserDto sysUserDto, String attach) {
        PurchaseBills purchaseBills = JSONArray.parseObject(zhu, PurchaseBills.class);
        JSONArray arrayList = JSONArray.parseArray(mingxi);
        List<PurchaseBillsItems> billsItemsDtos = JSONObject.parseArray(arrayList.toJSONString(), PurchaseBillsItems.class);
/*         需求计划：1， 工程采购：2，物资采购：3，采购台账：4 工程台账： 5
         招标：111 ，应用：222，单一：333
         计划：0，结账：2,订单：1 */
        purchaseBills.setPostDate(new Date());
        Boolean bills = purchaseBillsService.insertOrUpdate(purchaseBills);
        Boolean itemPro = purchaseBillsItemsService.insertOrUpdateBatch(billsItemsDtos);
        if (!bills) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "暂存失败！请仔细检查表单";
        } else if (!itemPro) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "暂存失败！请仔细检查列表";
        }
        JSONArray attachList = JSONArray.parseArray(attach);
        List<ProjectBillsAttachs> projectBillsAttachsList = JSONObject.parseArray(attachList.toJSONString(), ProjectBillsAttachs.class);
        EntityWrapper<ProjectBillsAttachs> billsAttachsEntityWrapper = new EntityWrapper<>();
        billsAttachsEntityWrapper.eq("bill_no", purchaseBills.getBillNo())
                .eq("branch_id", sysUserDto.getLoginContractorId());
        if (Objects.equals(purchaseBills.getPurchaseSrcId(), 111)) {
            billsAttachsEntityWrapper.eq("act_id", 977);
        } else if (Objects.equals(purchaseBills.getPurchaseSrcId(), 222)) {
            billsAttachsEntityWrapper.eq("act_id", 988);
        } else if (Objects.equals(purchaseBills.getPurchaseSrcId(), 333)) {
            billsAttachsEntityWrapper.eq("act_id", 999);
        }
        boolean deleteAttach = projectBillsAttachsService.delete(billsAttachsEntityWrapper);
        if (!deleteAttach) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "提交失败！删除旧附件失败";
        }
        if (projectBillsAttachsList.size() != 0) {
            int line = 0;
            for (ProjectBillsAttachs attachs : projectBillsAttachsList) {
                line++;
                attachs.setBillNo(purchaseBills.getBillNo());
                attachs.setLineNo(line);
                attachs.setBranchId(sysUserDto.getLoginContractorId());
                boolean insert = projectBillsAttachsService.insert(attachs);
                if (!insert) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "提交失败！添加附件失败";
                }
            }
        }
        return "1";
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public String temporaryTwo(String from, String list, String supplierList, String attach, SysUserDto sysUserDto) {
        PurchaseBills purchaseBills = JSONArray.parseObject(from, PurchaseBills.class);
        purchaseBills.setPostDate(new Date());
        Boolean bills = purchaseBillsService.insertOrUpdate(purchaseBills);
        if (!bills) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "暂存失败！请仔细检查表单";
        }
        JSONArray arrayList = JSONArray.parseArray(list);
        List<PurchaseBillsItems> billsItemsDtos = JSONObject.parseArray(arrayList.toJSONString(), PurchaseBillsItems.class);
        EntityWrapper<PurchaseBillsItems> purchaseBillsItemsEntityWrapper = new EntityWrapper<>();
        purchaseBillsItemsEntityWrapper.eq("bill_no", purchaseBills.getBillNo())
                .eq("project_Sub_No", purchaseBills.getProjectSubNo());
        boolean delete = purchaseBillsItemsService.delete(purchaseBillsItemsEntityWrapper);
        if (!delete) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "提交失败！删除旧数据失败";
        }
        if (billsItemsDtos.size() != 0) {
            int line = 0;
            for (PurchaseBillsItems pb : billsItemsDtos) {
                line++;
                pb.setLinoNo(line);
                Boolean itemPro = purchaseBillsItemsService.insertOrUpdate(pb);
                if (!itemPro) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "提交失败！请仔细检查物料列表";
                }
            }
        }
        JSONArray supplierListArray = JSONArray.parseArray(supplierList);
        List<PurchaseBillsPurids> billsPuridsList = JSONObject.parseArray(supplierListArray.toJSONString(), PurchaseBillsPurids.class);
        EntityWrapper<PurchaseBillsPurids> billsPuridsEntityWrapper = new EntityWrapper<>();
        billsPuridsEntityWrapper.eq("bill_no", purchaseBills.getBillNo());
        boolean deleteByPurchasePurids = purchaseBillsPuridsService.delete(billsPuridsEntityWrapper);
        if (!deleteByPurchasePurids) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "提交失败！删除旧数据失败";
        }
        if (billsPuridsList.size() != 0) {
            int line = 0;
            for (PurchaseBillsPurids pb : billsPuridsList) {
                line++;
                pb.setLineNo(line);
                Boolean supper = purchaseBillsPuridsService.insertOrUpdate(pb);
                if (!supper) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "提交失败！请仔细检查供应商列表";
                }
            }
        }
        JSONArray attachList = JSONArray.parseArray(attach);
        List<ProjectBillsAttachs> projectBillsAttachsList = JSONObject.parseArray(attachList.toJSONString(), ProjectBillsAttachs.class);
        EntityWrapper<ProjectBillsAttachs> billsAttachsEntityWrapper = new EntityWrapper<>();
        billsAttachsEntityWrapper.eq("bill_no", purchaseBills.getBillNo())
                .eq("act_id", 988)
                .eq("branch_id", sysUserDto.getLoginContractorId());
        boolean deleteAttach = projectBillsAttachsService.delete(billsAttachsEntityWrapper);
        if (!deleteAttach) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "提交失败！删除旧附件失败";
        }
        if (projectBillsAttachsList.size() != 0) {
            int line = 0;
            for (ProjectBillsAttachs attachs : projectBillsAttachsList) {
                line++;
                attachs.setBillNo(purchaseBills.getBillNo());
                attachs.setLineNo(line);
                attachs.setBranchId(sysUserDto.getLoginContractorId());
                boolean insert = projectBillsAttachsService.insert(attachs);
                if (!insert) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "提交失败！添加附件失败";
                }
            }
        }
        return "1";
    }

    @Override
    public Map<String, Object> getResultItem(String billNo, String zbNo) {
        Map<String, Object> map = new HashMap<>();
        EntityWrapper<ProjectBillsBudgets> budgetsEntityWrapper = new EntityWrapper<>();
        budgetsEntityWrapper.eq("project_sub_no", billNo);
        budgetsEntityWrapper.eq("budget_id", 2);
        ProjectBillsBudgets billsBudgets = projectBillsBudgetsService.selectOne(budgetsEntityWrapper);
        EntityWrapper<Projectbills> projectbillsEntityWrapper = new EntityWrapper<>();
        projectbillsEntityWrapper.eq("bill_no", zbNo);
        if (billsBudgets == null) {
            map.put("budget", 0);
        } else {
            map.put("budget", billsBudgets);
            map.put("zb", projectbillsService.selectOne(projectbillsEntityWrapper));
        }
        return map;
    }

    @Override
    public Map<String, Object> selectPurchaseTypes() {
        Map<String, Object> map = new HashMap<>();
        EntityWrapper<BpurchaseTypes> bpurchaseTypesEntityWrapper = new EntityWrapper<>();
        map.put("types", bpurchaseTypesService.selectList(bpurchaseTypesEntityWrapper));
        return map;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> deleteTender(PurchaseBillsDto purchaseBillsDto, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        EntityWrapper<PurchaseBills> billsEntityWrapper = new EntityWrapper<>();
        billsEntityWrapper.eq("project_sub_no", purchaseBillsDto.getProjectSubNo());
        billsEntityWrapper.eq("act_id", 4);
        List<PurchaseBills> billsList = purchaseBillsService.selectList(billsEntityWrapper);
        if (billsList == null || billsList.size() == 0) {
            try {
                EntityWrapper<PurchaseBillsItems> purchaseBillsItemsEntityWrapper = new EntityWrapper<>();
                purchaseBillsItemsEntityWrapper.eq("bill_no", purchaseBillsDto.getBillNo())
                        .eq("act_id", purchaseBillsDto.getActId());
                boolean itemType = purchaseBillsItemsService.delete(purchaseBillsItemsEntityWrapper);
                if (!itemType) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("删除失败。");
                }
                EntityWrapper<ProjectBillsAttachs> billsAttachsEntityWrapper = new EntityWrapper<>();
                billsAttachsEntityWrapper.eq("bill_no", purchaseBillsDto.getBillNo())
                        .eq("branch_id", sysUserDto.getLoginContractorId());
                if (purchaseBillsDto.getPurchaseSrcId() != null && Objects.equals(purchaseBillsDto.getPurchaseSrcId(), 333)) {
                    billsAttachsEntityWrapper.eq("act_id", 999);
                } else {
                    billsAttachsEntityWrapper.eq("act_id", 977);
                }
                boolean delete = projectBillsAttachsService.delete(billsAttachsEntityWrapper);
                if (!delete) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("删除附件失败。");
                }
                boolean flag = purchaseBillsService.deleteById(purchaseBillsDto.getId());
                if (!flag) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("删除失败。");
                }
            } catch (Exception e) {
                logger.error(" 删除错误：" + e.toString(), e);
                result.addErrorMessage("删除错误：" + e.toString());
            }
        } else {
            result.addErrorMessage("该采购计划已做台账，不能删除！");
        }
        return result;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> deleteFrame(PurchaseBillsDto purchaseBillsDto, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            EntityWrapper<PurchaseBills> billsEntityWrapper = new EntityWrapper<>();
            billsEntityWrapper.eq("project_sub_no", purchaseBillsDto.getProjectSubNo());
            billsEntityWrapper.eq("act_id", 4);
            List<PurchaseBills> billsList = purchaseBillsService.selectList(billsEntityWrapper);
            if (billsList == null || billsList.size() == 0) {
                EntityWrapper<PurchaseBillsItems> purchaseBillsItemsEntityWrapper = new EntityWrapper<>();
                purchaseBillsItemsEntityWrapper.eq("bill_no", purchaseBillsDto.getBillNo())
                        .eq("act_id", purchaseBillsDto.getActId());
                EntityWrapper<PurchaseBillsPurids> puridsEntityWrapper = new EntityWrapper<>();
                puridsEntityWrapper.eq("bill_no", purchaseBillsDto.getBillNo());
                boolean purds = purchaseBillsPuridsService.delete(puridsEntityWrapper);
                boolean itemType = purchaseBillsItemsService.delete(purchaseBillsItemsEntityWrapper);
                boolean flag = purchaseBillsService.deleteById(purchaseBillsDto.getId());
                if (!flag && !itemType && !purds) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("删除失败。");
                }
                EntityWrapper<ProjectBillsAttachs> billsAttachsEntityWrapper = new EntityWrapper<>();
                billsAttachsEntityWrapper.eq("bill_no", purchaseBillsDto.getBillNo())
                        .eq("act_id", 988)
                        .eq("branch_id", sysUserDto.getLoginContractorId());
                boolean delete = projectBillsAttachsService.delete(billsAttachsEntityWrapper);
                if (!delete) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("删除附件失败。");
                }
            } else {
                result.addErrorMessage("该采购计划已做台账，不能删除！");
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public String upLedger(String zhu, String mingxi) {
        PurchaseBills purchaseBills = JSONArray.parseObject(zhu, PurchaseBills.class);
        JSONArray arrayList = JSONArray.parseArray(mingxi);
        List<PurchaseBillsItems> billsItemsDtos = JSONObject.parseArray(arrayList.toJSONString(), PurchaseBillsItems.class);
        // 需求计划：1， 工程采购：2，物资：3，物资台账：4
        Boolean bills = purchaseBillsService.insertOrUpdate(purchaseBills);
        Boolean items = purchaseBillsItemsService.insertOrUpdateBatch(billsItemsDtos);
        if (!bills) {
            return "表单数据有问题，请检查";
        } else if (!items) {
            return "列表数据有问题，请检查";
        }
        for (PurchaseBillsItems purchaseBillsItems : billsItemsDtos) {
            PurchaseBillsItems billsItems = new PurchaseBillsItems();
            billsItems.setLinoNo(purchaseBillsItems.getSrcLinoNo());
            billsItems.setActId(1);
            billsItems.setBillNo(purchaseBillsItems.getSrcBillNo());
            PurchaseBillsItems updateItem = purchaseBillsItemsService.selectOne(new EntityWrapper<>(billsItems));
            if (updateItem.getReceiveTotalQty() != null && updateItem.getReceiveTotalQty() != 0.0) {
                updateItem.setReceiveTotalQty(updateItem.getReceiveTotalQty() + purchaseBillsItems.getContractQty());
            } else {
                updateItem.setReceiveTotalQty(purchaseBillsItems.getContractQty());
            }
            if (updateItem.getContractAmt() != null && updateItem.getContractAmt() != 0.0) {
                updateItem.setContractAmt(updateItem.getContractAmt() + purchaseBillsItems.getContractAmt());
            } else {
                updateItem.setContractAmt(purchaseBillsItems.getContractAmt());
            }
            purchaseBillsItemsService.updateById(updateItem);
        }
        return "1";
    }

    @Override
    public Map<String, Object> selectContractor(SysUserDto sysUserDto) {
        Map<String, Object> map = new HashMap<>();
        Date date = new Date();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        map.put("contractor", bbranchsService.selectById(sysUserDto.getLoginContractorId()));
        map.put("d", date);
        map.put("user", sysUserDto);
        map.put("time", sdf.format(date));
        return map;
    }

    /*public String saveSingle(String from, String list, SysUserDto sysUserDto, String attach) {
        PurchaseBills purchaseBills = JSONArray.parseObject(from, PurchaseBills.class);
        purchaseBills.setPostDate(new Date());
        purchaseBills.setBillStatus(6);
        Boolean bills = purchaseBillsService.insertOrUpdate(purchaseBills);
        if (!bills) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "提交失败！请仔细检查表单";
        }
        JSONArray arrayList = JSONArray.parseArray(list);
        List<PurchaseBillsItems> billsItemsDtos = JSONObject.parseArray(arrayList.toJSONString(), PurchaseBillsItems.class);
        EntityWrapper<PurchaseBillsItems> billsItemsEntityWrapper = new EntityWrapper<>();
        billsItemsEntityWrapper.eq("bill_no", purchaseBills.getBillNo())
                .eq("project_Sub_No", purchaseBills.getProjectSubNo());
        boolean delete = purchaseBillsItemsService.delete(billsItemsEntityWrapper);
        if (!delete) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "提交失败！删除旧数据失败";
        }
        if (billsItemsDtos.size() != 0) {
            int line = 0;
            for (PurchaseBillsItems pb : billsItemsDtos) {
                line++;
                pb.setLinoNo(line);
                Boolean itemPro = purchaseBillsItemsService.insertOrUpdate(pb);
                if (!itemPro) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "提交失败！请仔细检查物料列表";
                }
                EntityWrapper<PurchaseBillsItems> purchaseBillsItemsEntityWrapper = new EntityWrapper<>();
                purchaseBillsItemsEntityWrapper.eq("bill_no", pb.getSrcBillNo());
                purchaseBillsItemsEntityWrapper.eq("lino_no", pb.getSrcLinoNo());
                PurchaseBillsItems updateItem = purchaseBillsItemsService.selectOne(purchaseBillsItemsEntityWrapper);
                if (updateItem.getPurchaseInvQty() == null || updateItem.getPurchaseInvQty() == 0) {
                    updateItem.setPurchaseInvQty(pb.getRequireQty());
                } else {
                    updateItem.setPurchaseInvQty(pb.getRequireQty() + updateItem.getPurchaseInvQty());
                }
                if (updateItem.getTimeAmt() == null) {
                    updateItem.setTimeAmt(pb.getTimeAmt());
                } else {
                    updateItem.setTimeAmt(pb.getTimeAmt() + updateItem.getTimeAmt());
                }
                boolean updeteType = purchaseBillsItemsService.updateById(updateItem);
                if (!updeteType) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "审批驳回失败: 更新预算失败";
                }
            }
        }
        EntityWrapper<ProjectBillsBudgets> budgetsEntityWrapper = new EntityWrapper<>();
        budgetsEntityWrapper.eq("project_sub_no", purchaseBills.getProjectSubNo())
                .eq("branch_id", sysUserDto.getLoginContractorId());
        List<ProjectBillsBudgets> billsBudgets = projectBillsBudgetsService.selectList(budgetsEntityWrapper);
        for (ProjectBillsBudgets pb : billsBudgets) {
            if (Objects.equals(pb.getBudgetId(), 2)) {
                if (pb.getBudgetAmt() < (pb.getBudgetUseAmt() + purchaseBills.getAmt())) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "提交失败！超出预算";
                }
                pb.setBudgetUseAmt(pb.getBudgetUseAmt() + purchaseBills.getAmt());
                pb.setApprovedAmount(pb.getBudgetUseAmt());
                boolean updateById = projectBillsBudgetsService.updateById(pb);
                if (!updateById) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "提交失败！更新预算失败";
                }
            }
        }
        double amt = projectBillsBudgetsService.selectApprovedAmountSum(billsBudgets.get(0));
        EntityWrapper<ProjectBillsSubs> subsEntityWrapper = new EntityWrapper<>();
        subsEntityWrapper.eq("project_sub_no", purchaseBills.getProjectSubNo())
                .eq("branch_id", sysUserDto.getLoginContractorId());
        ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(subsEntityWrapper);
        projectBillsSubs.setActualBudgetAmt(amt);
        boolean updateById = projectBillsSubsService.updateById(projectBillsSubs);
        if (!updateById) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "更新预算失败";
        }
        JSONArray attachList = JSONArray.parseArray(attach);
        List<ProjectBillsAttachs> projectBillsAttachsList = JSONObject.parseArray(attachList.toJSONString(), ProjectBillsAttachs.class);
        EntityWrapper<ProjectBillsAttachs> billsAttachsEntityWrapper = new EntityWrapper<>();
        billsAttachsEntityWrapper.eq("bill_no", purchaseBills.getBillNo())
                .eq("act_id", 999)
                .eq("branch_id", projectBillsSubs.getBranchId());
        boolean deleteAttach = projectBillsAttachsService.delete(billsAttachsEntityWrapper);
        if (!deleteAttach) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "提交失败！删除旧附件失败";
        }
        if (projectBillsAttachsList.size() != 0) {
            int line = 0;
            for (ProjectBillsAttachs attachs : projectBillsAttachsList) {
                line++;
                attachs.setBillNo(purchaseBills.getBillNo());
                attachs.setLineNo(line);
                attachs.setBranchId(projectBillsSubs.getBranchId());
                boolean insert = projectBillsAttachsService.insert(attachs);
                if (!insert) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "提交失败！添加附件失败";
                }
            }
        }
        return "1";
    }*/

    @Override
    @Transactional(rollbackFor = Exception.class)
    public String saveSingle(String from, String list, SysUserDto sysUserDto, String attach) {
        PurchaseBills purchaseBills = JSONArray.parseObject(from, PurchaseBills.class);
        EntityWrapper<ProjectBillsSubs> subsEntityWrapper = new EntityWrapper<>();
        subsEntityWrapper.eq("project_sub_no", purchaseBills.getProjectSubNo())
                .eq("branch_id", sysUserDto.getLoginContractorId());
        ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(subsEntityWrapper);
        Audit audit = new Audit();
        audit.setBillNo(purchaseBills.getBillNo());
        if (purchaseBills.getAmt() < 2000000) {
            audit.setActId(441);
        } else if (purchaseBills.getAmt() >= 2000000) {
            audit.setActId(442);
        }
        audit.setLevelId(0);
        audit.setIffinalItem("F");
        audit.setSubJect(projectBillsSubs.getProjectSubName());
        audit.setProjectNo(purchaseBills.getProjectSubNo());
        audit.setBranchId(projectBillsSubs.getApprovalBranchId());
        audit.setSendUserId(sysUserDto.getUserId().intValue());
        audit.setSendName(sysUserDto.getActualname());
        audit.setSendTime(new Date());
        audit.setAuditUserId(sysUserDto.getUserId().intValue());
        audit.setAuditItem(new Date());
        audit.setAuditMsg("提交");
        audit.setAuditStatus("O");
        audit.setProjectMngId(projectBillsSubs.getProjectSubMngId());
        EntityWrapper<Projectbills> projectbillsEntityWrapper = new EntityWrapper<>();
        projectbillsEntityWrapper.setSqlSelect("id", "project_leader")
                .eq("bill_no", projectBillsSubs.getBillNo())
                .eq("branch_id", projectBillsSubs.getBranchId());
        Projectbills projectbills = projectbillsService.selectOne(projectbillsEntityWrapper);
        if (projectbills != null) {
            audit.setProjectLeader(projectbills.getProjectLeader());
        }
        boolean approvalFlow = auditItemsService.createApprovalFlow(audit);
        if (!approvalFlow) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "审批流异常请检查提交信息";
        }
        purchaseBills.setBillStatus(4);
        purchaseBills.setPostDate(new Date());
        Boolean bills = purchaseBillsService.insertOrUpdate(purchaseBills);
        if (!bills) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "提交失败！请仔细检查表单";
        }
        JSONArray arrayList = JSONArray.parseArray(list);
        List<PurchaseBillsItems> billsItemsDtos = JSONObject.parseArray(arrayList.toJSONString(), PurchaseBillsItems.class);
        EntityWrapper<PurchaseBillsItems> billsItemsEntityWrapper = new EntityWrapper<>();
        billsItemsEntityWrapper.eq("bill_no", purchaseBills.getBillNo())
                .eq("project_Sub_No", purchaseBills.getProjectSubNo());
        boolean delete = purchaseBillsItemsService.delete(billsItemsEntityWrapper);
        if (!delete) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "提交失败！删除旧数据失败";
        }
        if (billsItemsDtos.size() != 0) {
            int line = 0;
            for (PurchaseBillsItems pb : billsItemsDtos) {
                EntityWrapper<PurchaseBillsItems> purchaseBillsItemsEntityWrapper = new EntityWrapper<>();
                purchaseBillsItemsEntityWrapper.eq("bill_no", pb.getSrcBillNo())
                        .eq("lino_no", pb.getSrcLinoNo())
                        .eq("project_sub_no", pb.getProjectSubNo());
                PurchaseBillsItems updateItem = purchaseBillsItemsService.selectOne(purchaseBillsItemsEntityWrapper);
                if (updateItem.getPurchaseInvQty() == null || updateItem.getPurchaseInvQty() == 0) {
                    updateItem.setPurchaseInvQty(pb.getRequireQty());
                } else {
                    updateItem.setPurchaseInvQty(pb.getRequireQty() + updateItem.getPurchaseInvQty());
                }
                if (updateItem.getTimeAmt() == null) {
                    updateItem.setTimeAmt(pb.getTimeAmt());
                } else {
                    updateItem.setTimeAmt(DataUtils.keepDecimals(pb.getTimeAmt() + updateItem.getTimeAmt()));
                }
                boolean updeteType = purchaseBillsItemsService.updateById(updateItem);
                if (!updeteType) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "审批驳回失败: 更新预算失败";
                }
                line++;
                pb.setLinoNo(line);
                pb.setSrcBillNo(updateItem.getBillNo());
                pb.setSrcLinoNo(updateItem.getLinoNo());
                pb.setProjectSubNo(updateItem.getProjectSubNo());
                Boolean itemPro = purchaseBillsItemsService.insertOrUpdate(pb);
                if (!itemPro) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "提交失败！请仔细检查物料列表";
                }
            }
        }
        EntityWrapper<ProjectBillsBudgets> budgetsEntityWrapper = new EntityWrapper<>();
        budgetsEntityWrapper.eq("project_sub_no", purchaseBills.getProjectSubNo())
                .eq("branch_id", sysUserDto.getLoginContractorId());
        List<ProjectBillsBudgets> billsBudgets = projectBillsBudgetsService.selectList(budgetsEntityWrapper);
        for (ProjectBillsBudgets pb : billsBudgets) {
            if (Objects.equals(pb.getBudgetId(), 2)) {
                if (pb.getBudgetAmt() < (pb.getBudgetUseAmt() + purchaseBills.getAmt() - 0.1)) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "提交失败！超出预算";
                }
                pb.setBudgetUseAmt(pb.getBudgetUseAmt() + purchaseBills.getAmt());
                pb.setApprovedAmount(pb.getBudgetUseAmt());
                boolean updateById = projectBillsBudgetsService.updateById(pb);
                if (!updateById) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "提交失败！更新预算失败";
                }
            }
        }
        double amt = projectBillsBudgetsService.selectApprovedAmountSum(billsBudgets.get(0));
        projectBillsSubs.setActualBudgetAmt(amt);
        boolean updateById = projectBillsSubsService.updateById(projectBillsSubs);
        if (!updateById) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "更新预算失败";
        }
        JSONArray attachList = JSONArray.parseArray(attach);
        List<ProjectBillsAttachs> projectBillsAttachsList = JSONObject.parseArray(attachList.toJSONString(), ProjectBillsAttachs.class);
        EntityWrapper<ProjectBillsAttachs> billsAttachsEntityWrapper = new EntityWrapper<>();
        billsAttachsEntityWrapper.eq("bill_no", purchaseBills.getBillNo())
                .eq("act_id", 999)
                .eq("branch_id", projectBillsSubs.getBranchId());
        boolean deleteAttach = projectBillsAttachsService.delete(billsAttachsEntityWrapper);
        if (!deleteAttach) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "提交失败！删除旧附件失败";
        }
        if (projectBillsAttachsList.size() != 0) {
            int line = 0;
            for (ProjectBillsAttachs attachs : projectBillsAttachsList) {
                line++;
                attachs.setBillNo(purchaseBills.getBillNo());
                attachs.setLineNo(line);
                attachs.setBranchId(projectBillsSubs.getBranchId());
                boolean insert = projectBillsAttachsService.insert(attachs);
                if (!insert) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "提交失败！添加附件失败";
                }
            }
        }
        return "1";
    }

    /*审批版本*/
    /*public String saveSingle(String from, String list, SysUserDto sysUserDto) {
        PurchaseBills purchaseBills = JSONArray.parseObject(from, PurchaseBills.class);
        JSONArray arrayList = JSONArray.parseArray(list);
        List<PurchaseBillsItems> billsItemsDtos = JSONObject.parseArray(arrayList.toJSONString(), PurchaseBillsItems.class);
        purchaseBills.setPostDate(new Date());
        EntityWrapper<ProjectBillsSubs> subsEntityWrapper = new EntityWrapper<>();
        subsEntityWrapper.eq("project_sub_no", purchaseBills.getProjectSubNo());
        if (!Objects.equals(sysUserDto.getLoginContractorId(), 1)) {
            subsEntityWrapper.eq("branch_id", sysUserDto.getLoginContractorId());
        }
        ProjectBillsSubs projectbillsDto = projectBillsSubsService.selectOne(subsEntityWrapper);
        Audit audit = new Audit();
        audit.setBillNo(purchaseBills.getBillNo());
        audit.setActId(450);
        audit.setLevelId(0);
        audit.setIffinalItem("F");
        audit.setSubJect(projectbillsDto.getProjectSubName());
        audit.setProjectNo(purchaseBills.getProjectSubNo());
        audit.setBranchId(projectbillsDto.getBranchId());
        audit.setSendUserId(sysUserDto.getUserId().intValue());
        audit.setSendName(sysUserDto.getActualname());
        audit.setSendTime(new Date());
        audit.setAuditUserId(sysUserDto.getUserId().intValue());
        audit.setAuditItem(new Date());
        audit.setAuditMsg("提交");
        audit.setAuditStatus("O");
        audit.setProjectMngId(projectbillsDto.getProjectSubMngId());
        EntityWrapper<Projectbills> projectbillsEntityWrapper = new EntityWrapper<>();
        projectbillsEntityWrapper.setSqlSelect("id", "project_leader").eq("bill_no", projectbillsDto.getBillNo())
                .eq("act_id", projectbillsDto.getActId()).eq("branch_id", projectbillsDto.getBranchId());
        Projectbills projectbills = projectbillsService.selectOne(projectbillsEntityWrapper);
        if (projectbills != null) {
            audit.setProjectLeader(projectbills.getProjectLeader());
        }
        boolean approvalFlow = auditItemsService.createApprovalFlow(audit);
        if (!approvalFlow) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "审批流异常请检查提交信息";
        }
        purchaseBills.setBillStatus(4);
        purchaseBills.setBudgetUseAmt(purchaseBills.getBudgetUseAmt() + purchaseBills.getAmt());
        Boolean bills = purchaseBillsService.insertOrUpdate(purchaseBills);
        if (!bills) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return "提交失败！请仔细检查表单";
        }
        if (billsItemsDtos.size() != 0) {
            EntityWrapper<PurchaseBillsItems> itemsEntityWrapper = new EntityWrapper<>();
            itemsEntityWrapper.eq("bill_no", purchaseBills.getBillNo())
                    .eq("act_id", purchaseBills.getActId())
                    .eq("project_sub_no", purchaseBills.getProjectSubNo());
            boolean delete = purchaseBillsItemsService.delete(itemsEntityWrapper);
            if (!delete) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "提交失败！删除旧数据失败";
            }
            int line = 0;
            for (PurchaseBillsItems pb : billsItemsDtos) {
                line++;
                pb.setLinoNo(line);
                Boolean itemPro = purchaseBillsItemsService.insert(pb);
                if (!itemPro) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return "提交失败！请仔细检查物料列表";
                }
            }
        }
        EntityWrapper<ProjectBillsBudgets> budgetsEntityWrapper = new EntityWrapper<>();
        budgetsEntityWrapper.eq("project_sub_no", purchaseBills.getProjectSubNo());
        budgetsEntityWrapper.eq("budget_id", 2);
        ProjectBillsBudgets projectBillsBudgets = projectBillsBudgetsService.selectOne(budgetsEntityWrapper);
        if ((Double) projectBillsBudgets.getBudgetUseAmt() != null && projectBillsBudgets.getBudgetUseAmt() != 0.0) {
            if (projectBillsBudgets.getBudgetAmt() < (projectBillsBudgets.getBudgetUseAmt() + purchaseBills.getAmt())) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "提交失败！超出预算";
            }
            projectBillsBudgets.setBudgetUseAmt(projectBillsBudgets.getBudgetUseAmt() + purchaseBills.getAmt());
            boolean updateById = projectBillsBudgetsService.updateById(projectBillsBudgets);
            if (!updateById) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "提交失败！更新预算失败";
            }
        } else {
            if (projectBillsBudgets.getBudgetAmt() < purchaseBills.getAmt()) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "提交失败！超出预算";
            }
            projectBillsBudgets.setBudgetUseAmt(purchaseBills.getAmt());
            boolean updateById = projectBillsBudgetsService.updateById(projectBillsBudgets);
            if (!updateById) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return "提交失败！更新预算失败";
            }
        }
        return "1";
    }*/

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> deletePurchase(PurchaseBillsDto purchaseBillsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            if (purchaseBillsDto.getId() != null) {
                EntityWrapper<PurchaseBillsProjs> billsProjsEntityWrapper = new EntityWrapper<>();
                billsProjsEntityWrapper.eq("bill_no", purchaseBillsDto.getBillNo())
                        .eq("project_sub_no", purchaseBillsDto.getProjectSubNo())
                        .eq("branch_id", purchaseBillsDto.getContractorId());
                if (Objects.equals(purchaseBillsDto.getPurchaseSrcId(), 222)) {
                    List<PurchaseBillsProjs> purchaseBillsProjs = purchaseBillsProjsService.selectList(billsProjsEntityWrapper);
                    for (PurchaseBillsProjs pb : purchaseBillsProjs) {
                        EntityWrapper<PurchaseBillsPurids> billsPuridsEntityWrapper = new EntityWrapper<>();
                        billsPuridsEntityWrapper.eq("bill_no", pb.getPurchasePlanNo())
                                .eq("purchase_id", pb.getPurchaseId());
                        boolean delete = purchaseBillsPuridsService.delete(billsPuridsEntityWrapper);
                        if (!delete) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("删除失败: 删除旧数据失败");
                            return result;
                        }
                    }
                }
                boolean deleteById = purchaseBillsService.deleteById(purchaseBillsDto.getId());
                if (!deleteById) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("删除失败：请刷新后再试");
                }
                boolean delete = purchaseBillsProjsService.delete(billsProjsEntityWrapper);
                if (!delete) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("删除失败: 请刷新后再试");
                }
            } else {
                result.addErrorMessage("未找到该项目");
                return result;
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }
}
