package io.platform.sys.biz.entity;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import lombok.Data;

import java.io.Serializable;

@Data
@TableName("sys_sms_log")
public class SysSmsLog extends Model<SysSmsLog>  implements Serializable{
private static final long serialVersionUID = 5454155825314635342L;


    /**
     * 主键       db_column: id
     */
    @TableId(value="id", type= IdType.AUTO)
    private String id;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

    /**
     * 操作人       db_column: user_id
     */
    @TableField("user_id")
    private Long userId;

    /**
     * 必填参数。发送内容（1-500 个汉字）UTF-8编码       db_column: content
     */
    @TableField("content")
    private String content;

    /**
     * 必填参数。手机号码。多个以英文逗号隔开       db_column: mobile
     */
    @TableField("mobile")
    private String mobile;

    /**
     * 可选参数。发送时间，填写时已填写的时间发送，不填时为当前时间发送       db_column: stime
     */
    @TableField("stime")
    private java.util.Date stime;

    /**
     * 必填参数。用户签名       db_column: sign
     */
    @TableField("sign")
    private String sign;

    /**
     * 必填参数。固定值 pt       db_column: type
     */
    @TableField("type")
    private String type;

    /**
     * templateId       db_column: template_id
     */
    @TableField("template_id")
    private String templateId;

    /**
     * 可选参数。扩展码，用户定义扩展码，只能为数字       db_column: extno
     */
    @TableField("extno")
    private String extno;

    /**
     * 1成功 0失败       db_column: send_status
     */
    @TableField("send_status")
    private Integer sendStatus;

    /**
     * 发送编号       db_column: send_id
     */
    @TableField("send_id")
    private String sendId;

    /**
     * 无效号码数       db_column: invalid_num
     */
    @TableField("invalid_num")
    private Integer invalidNum;

    /**
     * 成功提交数       db_column: success_num
     */
    @TableField("success_num")
    private Integer successNum;

    /**
     * 黑名单数       db_column: black_num
     */
    @TableField("black_num")
    private Integer blackNum;

    /**
     * 返回消息       db_column: return_msg
     */
    @TableField("return_msg")
    private String returnMsg;
//columns END

}
