package io.platform.sys.biz.entity;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import lombok.Data;

import java.io.Serializable;
import java.util.List;

@Data
@TableName("sys_user")
public class SysUser extends Model<SysUser> implements Serializable {
    private static final long serialVersionUID = 5454155825314635348L;


    /**
     * userId       db_column: user_id
     */
    @TableId(value = "user_id", type = IdType.AUTO)
    private Long userId;


    @Override
    protected Serializable pkVal() {
        return this.userId;
    }

    /**
     * 用户名       db_column: username
     */
    @TableField("username")
    private String username;

    /**
     * 真实名       db_column: actualname
     */
    @TableField("actualname")
    private String actualname;

    /**
     * 密码       db_column: password
     */
    @TableField("password")
    private String password;

    /**
     * 盐       db_column: salt
     */
    @TableField("salt")
    private String salt;

    /**
     * 邮箱       db_column: email
     */
    @TableField("email")
    private String email;

    /**
     * 手机号       db_column: mobile
     */
    @TableField("mobile")
    private String mobile;

    /**
     * 部门id       db_column: dept_id
     */
    @TableField("dept_id")
    private Integer deptId;

    /**
     * 状态  0：禁用   1：正常       db_column: status
     */
    @TableField("status")
    private Integer status;

    /**
     * 创建者ID       db_column: create_user_id
     */
    @TableField("create_user_id")
    private Long createUserId;

    /**
     * 创建时间       db_column: create_time
     */
    @TableField("create_time")
    private java.util.Date createTime;


    /**
     * 角色ID列表
     */
    @TableField(exist = false)
    private Integer roleIdList;

    /**
     * 承包单位       db_column: contractor_id
     */
    @TableField("contractor_id")
    private Integer contractorId;


    /**
     * 登陆承包单位       db_column: contractor_id
     */
    @TableField("login_contractor_id")
    private Integer loginContractorId;

    /**
     * 创建用户人员公司Id       db_column: contractor_id
     */
    @TableField("create_contractor_id")
    private Integer createContractorId;

    /**
     * 是否管理员       db_column: is_admin
     */
    @TableField("is_admin")
    private String isAdmin;

//columns END

}
