package io.platform.sys.biz.mapper;

import com.baomidou.mybatisplus.plugins.Page;
import io.platform.base.common.BaseMapper;
import io.platform.sys.biz.entity.SysUser;
import io.platform.sys.dto.SysUserDto;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Update;

import java.util.HashMap;
import java.util.List;
import java.util.Map;


/**
 * Created by sevelli on 2017/9/6.
 */
@Mapper
public interface SysUserMapper extends BaseMapper<SysUser> {

    Long queryId(SysUserDto sysUserDto);

    List<String> queryAllPerms(Long userId);

    List<Long> queryAllMenuId(Long userId);

    SysUser queryByUserName(String username);

    List<SysUser> fuzzyQueryUser(@Param("user") SysUserDto sysUserDto);

    List<SysUser> selectProjectUser(@Param("id") Integer branchId);

    List<SysUser> selectProjectManagers(@Param("hashMap") Map<String, Object> map);

    @Update("update sys_user SET login_contractor_id = ${user.loginContractorId} where user_id = ${user.userId} ")
    int updateLoginContractorId(@Param("user") SysUserDto sysUserDto);

    List<HashMap<String, String>> selectListPage(@Param("user") SysUserDto sysUserDto, @Param("us") SysUserDto userDto);

    int selectListTotal(@Param("user") SysUserDto sysUserDto, @Param("us") SysUserDto userDto);
}
