
package io.platform.sys.biz.service;

import com.baomidou.mybatisplus.service.impl.ServiceImpl;
import io.platform.sys.biz.entity.SysUserRole;
import io.platform.sys.biz.mapper.SysUserRoleMapper;
import io.platform.sys.dto.SysUserRoleDto;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


@Service("sysUserRoleService")
public class SysUserRoleService extends ServiceImpl<SysUserRoleMapper, SysUserRole>{

    public Boolean deleteByUserId(Long userId){
        return baseMapper.deleteByUserId(userId);
    }

    public void saveOrUpdate(Long userId, Integer roleIdList) {
        //先删除用户与角色关系
        Map<String,Object> map = new HashMap<>();
        map.put("user_id", userId);
        this.deleteByMap(map);

        if(roleIdList == null){
            return ;
        }

/*        //保存用户与角色关系
        List<SysUserRole> list = new ArrayList<>(roleIdList.size());
        for(Long roleId : roleIdList){
            SysUserRole sysUserRoleEntity = new SysUserRole();
            sysUserRoleEntity.setUserId(userId);
            sysUserRoleEntity.setRoleId(roleId);

            list.add(sysUserRoleEntity);
        }
        this.insertBatch(list);*/
        SysUserRole sysUserRole = new SysUserRole();
        sysUserRole.setRoleId(roleIdList.longValue());
        sysUserRole.setUserId(userId);
        this.insert(sysUserRole);
    }

    public int deleteBatch(Long[] roleIds) {
        return baseMapper.deleteBatch(roleIds);
    }

    public List<Long> queryRoleIdList(Long userId) {
        return baseMapper.queryRoleIdList(userId);
    }
}
