
package io.platform.tasklistsHistory.service.client.impl;

import com.alibaba.dubbo.config.annotation.Service;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;


import io.platform.tasklistsHistory.biz.entity.TasklistsHistory;
import io.platform.tasklistsHistory.biz.service.TasklistsHistoryService;
import io.platform.tasklistsHistory.dto.TasklistsHistoryDto;
import io.platform.tasklistsHistory.service.client.api.TasklistsHistoryServiceClient;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;
import java.util.Map;
import io.platform.base.common.BaseServiceClient;
import io.platform.base.common.utils.ExecuteResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
 * Created by sevelli on 2017/8/31.
 */
@Component
@Service()
public class TasklistsHistoryServiceClientImpl extends BaseServiceClient<TasklistsHistory, TasklistsHistoryDto> implements TasklistsHistoryServiceClient {
    private Logger logger = LoggerFactory.getLogger(getClass());
    @Resource
    private TasklistsHistoryService tasklistsHistoryService;

    @Override
    public TasklistsHistoryDto queryObject(Long id) {
        TasklistsHistory tasklistsHistory = tasklistsHistoryService.selectById(id);
        TasklistsHistoryDto tasklistsHistoryDto = new TasklistsHistoryDto();
        BeanUtils.copyProperties(tasklistsHistory,tasklistsHistoryDto);
        return tasklistsHistoryDto;
    }

    @Override
    public List<TasklistsHistoryDto> queryList(Map<String, Object> map) {
        List<TasklistsHistory> tasklistsHistoryList = tasklistsHistoryService.selectByMap(map);
        return convertList(tasklistsHistoryList,TasklistsHistoryDto.class);
    }

    @Override
    public int queryTotal(Map<String, Object> map) {
        EntityWrapper<TasklistsHistory> ew = new EntityWrapper<>();
        ew.allEq(map);
        return tasklistsHistoryService.selectCount(ew);
    }

    @Override
    public ExecuteResult<String> save(TasklistsHistoryDto tasklistsHistoryDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try{
            TasklistsHistory tasklistsHistory = new TasklistsHistory();
            revert(tasklistsHistoryDto,tasklistsHistory);
            tasklistsHistory.setOperateDate(new Date());
            boolean flag = tasklistsHistoryService.insert(tasklistsHistory);
            if(!flag){
                result.addErrorMessage("保存失败。");
            }
        }
        catch (Exception e) {
            logger.error(" 保存错误：" + e.toString(), e);
            result.addErrorMessage("保存错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> update(TasklistsHistoryDto tasklistsHistoryDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try{
            TasklistsHistory tasklistsHistory = new TasklistsHistory();
            revert(tasklistsHistoryDto,tasklistsHistory);

            boolean flag = tasklistsHistoryService.updateById(tasklistsHistory);
            if(!flag){
                result.addErrorMessage("更新失败。");
            }
        }
        catch (Exception e) {
            logger.error(" 更新错误：" + e.toString(), e);
            result.addErrorMessage("更新错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> delete(Long id) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try{
            boolean flag = tasklistsHistoryService.deleteById(id);
            if(!flag){
                result.addErrorMessage("删除失败。");
            }
        }
        catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public ExecuteResult<String> deleteBatch(List<Long> ids) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try{
            boolean flag = tasklistsHistoryService.deleteBatchIds(ids);
            if(!flag){
                result.addErrorMessage("批量删除失败。");
            }
        }
        catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    public Page<TasklistsHistoryDto> getPage(Page<TasklistsHistoryDto> pageDto,TasklistsHistoryDto tasklistsHistoryDto) {
        Page<TasklistsHistory> page = new Page<>(pageDto.getCurrent(),pageDto.getSize());
        page.setAsc(pageDto.isAsc());
        page.setOrderByField(pageDto.getOrderByField());
        page.setCondition(pageDto.getCondition());

        pageDto.setTotal(tasklistsHistoryService.queryPagecount(page,tasklistsHistoryDto));
        pageDto.setRecords(tasklistsHistoryService.queryPage(page,tasklistsHistoryDto));
        return pageDto;
    }
}
