
package io.platform.project.service.client.impl;

import com.alibaba.dubbo.config.annotation.Service;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;
import io.platform.approvalConfiguration.biz.entity.Audit;
import io.platform.approvalConfiguration.biz.entity.AuditItems;
import io.platform.approvalConfiguration.biz.entity.AuditItemsUsers;
import io.platform.approvalConfiguration.biz.service.*;
import io.platform.approvalConfiguration.dto.AuditItemsDto;
import io.platform.base.common.BaseServiceClient;
import io.platform.base.common.utils.ExecuteResult;
import io.platform.budget.biz.entity.BudgetAdjustBills;
import io.platform.budget.biz.entity.ProjectBillsAdjusts;
import io.platform.budget.biz.entity.ProjectBillsBudgets;
import io.platform.budget.biz.service.BudgetAdjustBillsService;
import io.platform.budget.biz.service.ProjectBillsAdjustsService;
import io.platform.budget.biz.service.ProjectBillsBudgetsService;
import io.platform.budget.dto.ProjectBillsBudgetsDto;
import io.platform.contract.biz.entity.OtherProject;
import io.platform.contract.biz.entity.ProjectBillsStlPlans;
import io.platform.contract.biz.entity.Tasklists;
import io.platform.contract.biz.service.OtherProjectService;
import io.platform.contract.biz.service.ProjectBillsStlPlansService;
import io.platform.contract.biz.service.TasklistsService;
import io.platform.engineering.biz.entity.*;
import io.platform.engineering.biz.service.*;
import io.platform.moneyManagement.biz.entity.*;
import io.platform.moneyManagement.biz.service.*;
import io.platform.moneyManagement.dto.InvoiceBillsDto;
import io.platform.project.biz.entity.*;
import io.platform.project.biz.service.*;
import io.platform.project.dto.ProjectBS;
import io.platform.project.dto.ProjectBillsSubsDto;
import io.platform.project.dto.ProjectbillsDto;
import io.platform.project.service.client.api.ProjectbillsServiceClient;
import io.platform.projectSettlement.biz.entity.ProjectAnnex;
import io.platform.projectSettlement.biz.entity.ProjectBillsAttachs;
import io.platform.projectSettlement.biz.service.ProjectAnnexService;
import io.platform.projectSettlement.biz.service.ProjectBillsAttachsService;
import io.platform.purchase.biz.entity.PurchaseBills;
import io.platform.purchase.biz.entity.PurchaseBillsItems;
import io.platform.purchase.biz.service.PurchaseBillsItemsService;
import io.platform.purchase.biz.service.PurchaseBillsService;
import io.platform.sys.biz.entity.SysRole;
import io.platform.sys.biz.entity.SysUser;
import io.platform.sys.biz.entity.SysUserRole;
import io.platform.sys.biz.service.SysRoleService;
import io.platform.sys.biz.service.SysUserRoleService;
import io.platform.sys.biz.service.SysUserService;
import io.platform.sys.dto.SysUserDto;
import io.platform.utils.DataUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;

import javax.annotation.Resource;
import java.text.DecimalFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.Instant;
import java.time.LocalDateTime;
import java.time.LocalTime;
import java.time.ZoneId;
import java.util.*;

import static io.platform.project.service.client.impl.ProjectBillsHistoryServiceClientImpl.Getnum;
import static io.platform.project.service.client.impl.ProjectBillsHistoryServiceClientImpl.getStringDate;

/**
 * Created by sevelli on 2017/8/31.
 */
@Component
@Service(version = "1.0.0", interfaceClass = ProjectbillsServiceClient.class)
public class ProjectbillsServiceClientImpl extends BaseServiceClient<Projectbills, ProjectbillsDto> implements ProjectbillsServiceClient {
    private Logger logger = LoggerFactory.getLogger(getClass());
    @Resource
    private BcorpsService bcorpsService;
    @Resource
    private BdeptsService bdeptsService;
    @Resource
    private SysUserService sysUserService;
    @Resource
    private BbranchsService bbranchsService;
    @Resource
    private BbudgetsService bbudgetsService;
    @Resource
    private TasklistsService tasklistsService;
    @Resource
    private BcorpTypesService bcorpTypesService;
    @Resource
    private PayCrBillsService payCrBillsService;
    @Resource
    private AuditItemsService auditItemsService;
    @Resource
    private AttachFilesService attachFilesService;
    @Resource
    private BpriceModesService bpriceModesService;
    @Resource
    private ProjectbillsService projectbillsService;
    @Resource
    private InvoiceBillsService invoiceBillsService;
    @Resource
    private ProjectAnnexService projectAnnexService;
    @Resource
    private DictionariesService dictionariesService;
    @Resource
    private BprojectTypesService bprojectTypesService;
    @Resource
    private OtherProjectService otherProjectService;
    @Resource
    private PurchaseBillsService purchaseBillsService;
    @Resource
    private InvoicePurchaseService invoicePurchaseService;
    @Resource
    private AuditItemsUsersService auditItemsUsersService;
    @Resource
    private PayCrBillsSharesService payCrBillsSharesService;
    @Resource
    private ProjectBillsSubsService projectBillsSubsService;
    @Resource
    private SubContractBillsService subContractBillsService;
    @Resource
    private ProcessBillsStepsService processBillsStepsService;
    @Resource
    private ProjectBillsStepsService projectBillsStepsService;
    @Resource
    private InvoiceBillsSharesService invoiceBillsSharesService;
    @Resource
    private PurchaseBillsItemsService purchaseBillsItemsService;
    @Resource
    private BprojectTypesItemsService bprojectTypesItemsService;
    @Resource
    private ProjectBillsHistoryService projectBillsHistoryService;
    @Resource
    private ProjectBillsBudgetsService projectBillsBudgetsService;
    @Resource
    private ProjectBillsAttachsService projectBillsAttachsService;
    @Resource
    private InvoiceBillsIndirectService invoiceBillsIndirectService;
    @Resource
    private ProjectBillsStlPlansService projectBillsStlPlansService;
    @Resource
    private SysUserRoleService sysUserRoleService;
    @Resource
    private SysRoleService sysRoleService;
    @Resource
    private ProjectBillsAdjustsService projectBillsAdjustsService;
    @Resource
    private BudgetAdjustBillsService budgetAdjustBillsService;

    @Override
    public ProjectbillsDto queryObject(Long id) {
        Projectbills projectbills = projectbillsService.selectById(id);
        ProjectbillsDto projectbillsDto = new ProjectbillsDto();
        BeanUtils.copyProperties(projectbills, projectbillsDto);
        return projectbillsDto;
    }

    @Override
    public int queryTotal(Map<String, Object> map) {
        EntityWrapper<Projectbills> ew = new EntityWrapper<>();
        ew.allEq(map);
        return projectbillsService.selectCount(ew);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> temporary(String projectBillsContract, String projectBillsStls, String attachs, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            Projectbills projectbillsDto = JSONArray.parseObject(projectBillsContract, Projectbills.class);

            EntityWrapper<Projectbills> projectbillsWrapper = new EntityWrapper<>();
            projectbillsWrapper.eq("project_name", projectbillsDto.getProjectName());
            projectbillsWrapper.eq("branch_id", projectbillsDto.getBranchId());
            projectbillsWrapper.eq("is_sur", "F");
            List<Projectbills> projectbillsList = projectbillsService.selectList(projectbillsWrapper);
            if (projectbillsDto.getId() != null) {
                if (projectbillsList.size() == 1 && (projectbillsList.get(0).getId() + "").equals(projectbillsDto.getId() + "")) {

                } else {
                    result.addErrorMessage("暂存失败：工程名称已存在");
                    return result;
                }
            } else {
                if (projectbillsList.size() > 0) {
                    result.addErrorMessage("暂存失败：工程名称已存在");
                    return result;
                }
            }

            JSONArray jsonArray = JSONArray.parseArray(projectBillsStls);
            List<ProjectBillsStlPlans> projectBillsStlPlansList = JSONObject.parseArray(jsonArray.toJSONString(), ProjectBillsStlPlans.class);
            JSONArray array = JSONArray.parseArray(attachs);
            List<AttachFiles> attachFilesList = JSONObject.parseArray(array.toJSONString(), AttachFiles.class);
            if (projectbillsDto != null) {
                if (projectBillsStlPlansList.size() != 0) {
                    EntityWrapper<ProjectBillsStlPlans> projectBillsStlsEntityWrapper = new EntityWrapper<>();
                    projectBillsStlsEntityWrapper.eq("bill_no", projectbillsDto.getBillNo());
                    boolean delete = projectBillsStlPlansService.delete(projectBillsStlsEntityWrapper);
                    if (!delete) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("暂存失败：删除结算明细失败");
                        return result;
                    }
                    int line = 0;
                    for (ProjectBillsStlPlans pro : projectBillsStlPlansList) {
                        line++;
                        pro.setBillNo(projectbillsDto.getBillNo());
                        pro.setLineNo(line);
                        pro.setActId(111);
                        pro.setSrcBillNo(projectbillsDto.getBillNo());
                        pro.setSrcActId(101);
                        boolean insert = projectBillsStlPlansService.insert(pro);
                        if (!insert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("暂存失败：新增结算明细失败");
                            return result;
                        }
                    }
                }
                if (attachFilesList.size() != 0) {
                    EntityWrapper<AttachFiles> attachFilesEntityWrapper = new EntityWrapper<>();
                    attachFilesEntityWrapper.eq("bill_no", projectbillsDto.getBillNo()).eq("act_id", 101);
                    boolean deleteById = attachFilesService.delete(attachFilesEntityWrapper);
                    if (!deleteById) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("暂存失败：更新附件失败");
                        return result;
                    }
                    for (AttachFiles af : attachFilesList) {
                        af.setBillNo(projectbillsDto.getBillNo());
                        af.setActId(101);
                        af.setOpDate(new Date());
                        boolean insert = attachFilesService.insert(af);
                        if (!insert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("暂存失败：更新附件失败");
                            return result;
                        }
                    }
                }
                EntityWrapper<Tasklists> tasklistsEntityWrapper = new EntityWrapper<>();
                tasklistsEntityWrapper.setSqlSelect("id").eq("bill_no", projectbillsDto.getBillNo()).eq("act_id", 10);
                Tasklists task = tasklistsService.selectOne(tasklistsEntityWrapper);
                if (task == null) {
                    Tasklists tasklists = new Tasklists();
                    // 暂定 10 为 总包合同活动号
                    tasklists.setActId(10);
                    tasklists.setStatus(2);
                    tasklists.setBillNo(projectbillsDto.getBillNo());
                    tasklists.setOpUserId(sysUserDto.getUserId().intValue());
                    tasklists.setOpUserName(sysUserDto.getUsername());
                    boolean insertTask = tasklistsService.insert(tasklists);
                    if (!insertTask) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("暂存失败。");
                        return result;
                    }
                }
                EntityWrapper<Projectbills> entityWrapper = new EntityWrapper<>();
                entityWrapper.eq("bill_no", projectbillsDto.getBillNo()).eq("branch_id", projectbillsDto.getBranchId());
                Projectbills projectbills = projectbillsService.selectOne(entityWrapper);
                if (projectbills != null) {
                    projectbillsDto.setAmt(projectbillsDto.getContractAmt());
                    projectbillsDto.setOpUserName(sysUserDto.getUsername());
                    projectbillsDto.setOpUserId(sysUserDto.getUserId().intValue());
                    projectbillsDto.setTaxRate(projectbillsDto.getContractTaxRate());
                    boolean updateById = projectbillsService.updateById(projectbillsDto);
                    if (!updateById) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("暂存失败：更新总包失败");
                        return result;
                    }
                } else {
                    projectbillsDto.setOpUserName(sysUserDto.getUsername());
                    projectbillsDto.setOpUserId(sysUserDto.getUserId().intValue());
                    projectbillsDto.setCreateDate(new Date());
                    projectbillsDto.setAmt(projectbillsDto.getContractAmt());
                    projectbillsDto.setTaxRate(projectbillsDto.getContractTaxRate());
                    boolean insert = projectbillsService.insert(projectbillsDto);
                    if (!insert) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("暂存失败：新增总包失败");
                        return result;
                    }
                }
            } else {
                result.addErrorMessage("暂存失败：未找到信息");
                return result;
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 暂存失败：" + e.toString(), e);
            result.addErrorMessage("暂存失败：" + e.toString());
            return result;
        }
        return result;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> contractSave(String projectBillsContract, String projectBillsStls, String attachs, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            Projectbills projectbillsDto = JSONArray.parseObject(projectBillsContract, Projectbills.class);

            EntityWrapper<Projectbills> projectbillsWrapper = new EntityWrapper<>();
            projectbillsWrapper.eq("project_name", projectbillsDto.getProjectName())
                    .eq("branch_id", projectbillsDto.getBranchId());
            if (projectbillsDto.getId() != null) {
                projectbillsWrapper.ne("id", projectbillsDto.getId());
            }
            List<Projectbills> projectbillsList = projectbillsService.selectList(projectbillsWrapper);
            if (projectbillsList.size() != 0) {
                result.addErrorMessage("该工程名称已被使用");
                return result;
            }
            if (projectbillsDto.getProjectNo() == null) {
                String contractNo = null;
                contractNo = this.updateProjectNo(projectbillsDto);
                if (contractNo != null) {
                    projectbillsDto.setProjectNo(contractNo);
                } else {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败: 生成系统编号失败");
                    return result;
                }
                projectbillsDto.setOpUserId(sysUserDto.getUserId().intValue());
                projectbillsDto.setOpUserName(sysUserDto.getUsername());
                projectbillsDto.setCreateDate(new Date());
                projectbillsDto.setBillDate(new Date());
            }
            projectbillsDto.setPostDate(new Date());
            projectbillsDto.setAmt(projectbillsDto.getContractAmt());
            projectbillsDto.setTaxRate(projectbillsDto.getContractTaxRate());
            boolean insert = projectbillsService.insertOrUpdate(projectbillsDto);
            if (!insert) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("提交失败: 新建合同失败");
                return result;
            }
            EntityWrapper<Tasklists> tasklistsEntityWrapper = new EntityWrapper<>();
            tasklistsEntityWrapper.eq("bill_no", projectbillsDto.getBillNo()).eq("act_id", 10);
            Tasklists task = tasklistsService.selectOne(tasklistsEntityWrapper);
            if (task != null) {
                task.setStatus(6);
                task.setBillNo(projectbillsDto.getBillNo());
                task.setOpUserId(sysUserDto.getUserId().intValue());
                task.setOpUserName(sysUserDto.getUsername());
                boolean updateById = tasklistsService.updateById(task);
                if (!updateById) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：更新任务失败");
                    return result;
                }
            } else {
                Tasklists tasklists = new Tasklists();
                // 暂定 10 为 总包合同活动号
                tasklists.setActId(10);
                tasklists.setStatus(6);
                tasklists.setBillNo(projectbillsDto.getBillNo());
                tasklists.setOpUserId(sysUserDto.getUserId().intValue());
                tasklists.setOpUserName(sysUserDto.getUsername());
                boolean insertTask = tasklistsService.insert(tasklists);
                if (!insertTask) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：新建任务失败");
                    return result;
                }
            }
            EntityWrapper<Tasklists> taskEntityWrapper = new EntityWrapper<>();
            taskEntityWrapper.eq("bill_no", projectbillsDto.getBillNo())
                    .eq("act_id", 11);
            boolean delete = tasklistsService.delete(taskEntityWrapper);
            if (!delete) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("提交失败: 删除旧数据失败");
                return result;
            }
            Tasklists projectTask = new Tasklists();
            // 暂定 10 为 总包合同活动号
            projectTask.setActId(11);
            projectTask.setStatus(2);
            projectTask.setBillNo(projectbillsDto.getBillNo());
            projectTask.setOpUserId(sysUserDto.getUserId().intValue());
            projectTask.setOpUserName(sysUserDto.getUsername());
            boolean insertProjectTask = tasklistsService.insert(projectTask);
            if (!insertProjectTask) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("提交失败: 新建立项任务失败");
                return result;
            }
            JSONArray jsonArray = JSONArray.parseArray(projectBillsStls);
            List<ProjectBillsStlPlans> projectBillsStlPlansList = JSONObject.parseArray(jsonArray.toJSONString(), ProjectBillsStlPlans.class);
            EntityWrapper<ProjectBillsStlPlans> projectBillsStlsEntityWrapper = new EntityWrapper<>();
            projectBillsStlsEntityWrapper.eq("bill_no", projectbillsDto.getBillNo());
            boolean deleteStlPlans = projectBillsStlPlansService.delete(projectBillsStlsEntityWrapper);
            if (!deleteStlPlans) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("提交失败: 删除旧数据失败");
                return result;
            }
            int line = 0;
            for (ProjectBillsStlPlans pro : projectBillsStlPlansList) {
                line++;
                pro.setBillNo(projectbillsDto.getBillNo());
                pro.setLineNo(line);
                pro.setActId(111);
                pro.setSrcBillNo(projectbillsDto.getBillNo());
                pro.setSrcActId(101);
                boolean insertStlPlans = projectBillsStlPlansService.insert(pro);
                if (!insertStlPlans) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败: 新建项目结算失败");
                    return result;
                }
            }

            JSONArray array = JSONArray.parseArray(attachs);
            List<AttachFiles> attachFilesList = JSONObject.parseArray(array.toJSONString(), AttachFiles.class);
            if (attachFilesList.size() != 0) {
                EntityWrapper<AttachFiles> attachFilesEntityWrapper = new EntityWrapper<>();
                attachFilesEntityWrapper.eq("bill_no", projectbillsDto.getBillNo()).eq("act_id", 101);
                boolean deleteAttachFiles = attachFilesService.delete(attachFilesEntityWrapper);
                if (!deleteAttachFiles) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：删除附件失败");
                    return result;
                }
                for (AttachFiles af : attachFilesList) {
                    ProjectAnnex projectAnnex = new ProjectAnnex();
                    projectAnnex.setSrcActId(101);
                    projectAnnex.setProjectId(projectbillsDto.getId());
                    projectAnnex.setFileName("总包合同");
                    projectAnnex.setFileAddress(af.getAttachId());
                    projectAnnex.setBranId(projectbillsDto.getBranchId());
                    boolean proInsert = projectAnnexService.insert(projectAnnex);
                    if (!proInsert) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：更新附件失败");
                        return result;
                    }
                    af.setBillNo(projectbillsDto.getBillNo());
                    af.setActId(101);
                    af.setOpDate(new Date());
                    boolean insertAttach = attachFilesService.insert(af);
                    if (!insertAttach) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：更新附件失败");
                        return result;
                    }
                }
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 提交错误：" + e.toString(), e);
            result.addErrorMessage("提交失败");
            return result;
        }
        return result;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> contractAdminSave(String projectBillsContract, String projectBillsStls, String attachs, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            Projectbills projectbillsDto = JSONArray.parseObject(projectBillsContract, Projectbills.class);
            EntityWrapper<Projectbills> projectbillsWrapper = new EntityWrapper<>();
            projectbillsWrapper.eq("project_name", projectbillsDto.getProjectName())
                    .eq("branch_id", projectbillsDto.getBranchId());
            if (projectbillsDto.getId() != null) {
                projectbillsWrapper.ne("id", projectbillsDto.getId());
            }
            List<Projectbills> projectbillsList = projectbillsService.selectList(projectbillsWrapper);
            if (projectbillsList.size() != 0) {
                result.addErrorMessage("该工程名称已被使用");
                return result;
            }
            projectbillsDto.setBillDate(new Date());
            projectbillsDto.setPostDate(new Date());
            projectbillsDto.setAmt(projectbillsDto.getContractAmt());
            projectbillsDto.setTaxRate(projectbillsDto.getContractTaxRate());
            boolean insert = projectbillsService.updateById(projectbillsDto);
            if (!insert) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("提交失败: 新建合同失败");
                return result;
            }
            if (projectbillsDto.getCreateProjectDate() != null) {
                EntityWrapper<ProjectBillsSubs> entityWrapper = new EntityWrapper<>();
                entityWrapper.eq("bill_no", projectbillsDto.getBillNo())
                        .eq("branch_id", projectbillsDto.getBranchId());
                List<ProjectBillsSubs> projectBillsSubs = projectBillsSubsService.selectList(entityWrapper);
                for (ProjectBillsSubs pb : projectBillsSubs) {
                    pb.setContractAmt((pb.getProjectWorkRate() / 100) * projectbillsDto.getAmt());
                    if (pb.getContractAuditAmt() == null || pb.getContractAuditAmt() <= 0) {
                        pb.setAmt(pb.getContractAmt());
                    }
                    pb.setBudgetProfit(pb.getAmt() - pb.getBudgetAmt());
                    pb.setBudgetProfitRate(pb.getBudgetProfit() / pb.getAmt() * 100);
                    boolean update = projectBillsSubsService.updateById(pb);
                    if (!update) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败: 更新二级项目失败");
                        return result;
                    }
                }
            }
            JSONArray jsonArray = JSONArray.parseArray(projectBillsStls);
            List<ProjectBillsStlPlans> projectBillsStlPlansList = JSONObject.parseArray(jsonArray.toJSONString(), ProjectBillsStlPlans.class);
            EntityWrapper<ProjectBillsStlPlans> projectBillsStlsEntityWrapper = new EntityWrapper<>();
            projectBillsStlsEntityWrapper.eq("bill_no", projectbillsDto.getBillNo());
            boolean deleteStlPlans = projectBillsStlPlansService.delete(projectBillsStlsEntityWrapper);
            if (!deleteStlPlans) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("提交失败: 删除旧数据失败");
                return result;
            }
            int line = 0;
            for (ProjectBillsStlPlans pro : projectBillsStlPlansList) {
                line++;
                pro.setBillNo(projectbillsDto.getBillNo());
                pro.setLineNo(line);
                pro.setActId(111);
                pro.setSrcBillNo(projectbillsDto.getBillNo());
                pro.setSrcActId(101);
                boolean insertStlPlans = projectBillsStlPlansService.insert(pro);
                if (!insertStlPlans) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败: 新建项目结算失败");
                    return result;
                }
            }
            JSONArray array = JSONArray.parseArray(attachs);
            List<AttachFiles> attachFilesList = JSONObject.parseArray(array.toJSONString(), AttachFiles.class);
            if (attachFilesList.size() != 0) {
                EntityWrapper<AttachFiles> attachFilesEntityWrapper = new EntityWrapper<>();
                attachFilesEntityWrapper.eq("bill_no", projectbillsDto.getBillNo()).eq("act_id", 101);
                boolean deleteAttachFiles = attachFilesService.delete(attachFilesEntityWrapper);
                if (!deleteAttachFiles) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：删除附件失败");
                    return result;
                }
                for (AttachFiles af : attachFilesList) {
                    ProjectAnnex projectAnnex = new ProjectAnnex();
                    projectAnnex.setSrcActId(101);
                    projectAnnex.setProjectId(projectbillsDto.getId());
                    projectAnnex.setFileName("总包合同");
                    projectAnnex.setFileAddress(af.getAttachId());
                    projectAnnex.setBranId(projectbillsDto.getBranchId());
                    boolean proInsert = projectAnnexService.insert(projectAnnex);
                    if (!proInsert) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：更新附件失败");
                        return result;
                    }
                    af.setBillNo(projectbillsDto.getBillNo());
                    af.setActId(101);
                    af.setOpDate(new Date());
                    boolean insertAttach = attachFilesService.insert(af);
                    if (!insertAttach) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：更新附件失败");
                        return result;
                    }
                }
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 提交错误：" + e.toString(), e);
            result.addErrorMessage("提交失败");
            return result;
        }
        return result;
    }

    @Override
    public Map<String, Object> queryProjectBills(ProjectbillsDto projectbillsDto) {
        if (projectbillsDto.getId() != null && projectbillsDto.getId() != 0) {
            Map<String, Object> map = new HashMap<>();
            EntityWrapper<Projectbills> projectbillsEntityWrapper = new EntityWrapper<>();
            projectbillsEntityWrapper.eq("id", projectbillsDto.getId());
            Projectbills projectbills = projectbillsService.selectOne(projectbillsEntityWrapper);
            if (projectbills != null) {
                EntityWrapper<ProjectBillsSubs> entityWrapper = new EntityWrapper<>();
                entityWrapper.eq("if_project_sub", "T").eq("bill_no", projectbills.getBillNo());
                List<ProjectBillsSubs> projectBillsSubsList = projectBillsSubsService.selectList(entityWrapper);
                //根据corp_id业主单位id查询业主单位分类  系统内  or 系统外
                Bcorps bcorps = new Bcorps();
                if (projectbills.getCorpId() != null) {
                    EntityWrapper<Bcorps> bcorpsWrapper = new EntityWrapper<>();
                    bcorpsWrapper.eq("id", projectbills.getCorpId());
                    List<Bcorps> bcorpsList = bcorpsService.selectList(bcorpsWrapper);
                    if (bcorpsList != null && !bcorpsList.isEmpty()) {
                        bcorps = bcorpsList.get(0);
                    }
                    if (!"".equals(bcorps.getSystemType()) && bcorps.getSystemType() != null) {
                        if (1 == bcorps.getSystemType()) {
                            projectbills.setSystemType("系统内");
                        } else {
                            projectbills.setSystemType("系统外");
                        }
                    }
                }
                List<SysUser> sysUsers = sysUserService.selectProjectUser(projectbills.getBranchId()); // 现在改为角色的数据权限为1（项目经理）的
                if (sysUsers.size() != 0) {
                    map.put("users", sysUsers);
                }
                map.put("project", projectbills);
                if (projectBillsSubsList.size() != 0) {
                    map.put("proSubs", projectBillsSubsList);
                }
                return map;
            }
        }
        return null;
    }

    @Override
    public List<ProjectBillsBudgetsDto> queryProjectBalance(ProjectbillsDto projectbillsDto) {
        List<ProjectBillsBudgets> projectBillsBudgetsList = projectbillsService.selectProjectBudget(projectbillsDto);
        List<ProjectBillsBudgetsDto> dtoList = new ArrayList<>();
        BeanUtils.copyProperties(dtoList, projectBillsBudgetsList);
        return dtoList;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> projectBalanceSave(ProjectBS projectBS, SysUserDto sysUserDto, String billsBudgets) {
        ExecuteResult<String> result = new ExecuteResult<>();
        try {
            JSONArray jsonArray = JSONArray.parseArray(billsBudgets);
            List<ProjectBillsBudgets> billsBudgetsList = JSONObject.parseArray(jsonArray.toJSONString(), ProjectBillsBudgets.class);
            double amt = 0.0;
            if (billsBudgetsList.size() != 0) {
                projectBillsBudgetsService.deleteLowBudgets(projectBS);
                for (ProjectBillsBudgets pb : billsBudgetsList) {
                    pb.setBranchId(sysUserDto.getLoginContractorId());
                    if (!projectBillsBudgetsService.insert(pb)) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("新增成本失败,请检查成本信息");
                        return result;
                    }
                    if (Objects.equals(pb.getBudgetAmt(), 0)) {
                        amt = DataUtils.keepDecimals(amt + pb.getApprovedAmount());
                    }
                }
            }
            ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectById(projectBS.getId());
            projectBillsSubs.setSubAmtCr(DataUtils.keepDecimals(projectBillsSubs.getSubAmtCr() + amt));
            projectBillsSubs.setNetProfit(projectBS.getNetProfit());
            projectBillsSubs.setClosingRemarks(projectBS.getClosingRemarks());
            projectBillsSubs.setApportionBudget(projectBS.getApportionBudget());
            projectBillsSubs.setClosingUserId(sysUserDto.getUserId().intValue());
            projectBillsSubs.setClosingDate(new Date());
            projectBillsSubs.setClosingStatus("I");
            boolean updateById = projectBillsSubsService.updateById(projectBillsSubs);
            if (!updateById) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("结项失败, 请确认后提交");
                return result;
            }
            Audit audit = new Audit();
            audit.setActId(650);
            audit.setLevelId(0);
            audit.setIffinalItem("F");
            audit.setBillNo(projectBillsSubs.getBillNo());
            audit.setBranchId(projectBillsSubs.getApprovalBranchId());
            audit.setSendUserId(sysUserDto.getUserId().intValue());
            audit.setSendName(sysUserDto.getActualname());
            audit.setSendTime(new Date());
            audit.setAuditUserId(sysUserDto.getUserId().intValue());
            audit.setAuditItem(new Date());
            audit.setAuditMsg("提交");
            audit.setAuditStatus("O");
            audit.setSubJect(projectBillsSubs.getProjectSubName());
            audit.setProjectNo(projectBS.getProjectSubNo());
            audit.setProjectMngId(projectBillsSubs.getProjectSubMngId());
            EntityWrapper<Projectbills> projectbillsEntityWrapper = new EntityWrapper<>();
            projectbillsEntityWrapper.setSqlSelect("id", "project_leader")
                    .eq("bill_no", projectBillsSubs.getBillNo())
                    .eq("branch_id", projectBillsSubs.getBranchId());
            Projectbills projectbills = projectbillsService.selectOne(projectbillsEntityWrapper);
            audit.setProjectLeader(projectbills.getProjectLeader());
            boolean approvalFlow = auditItemsService.createApprovalFlow(audit);
            if (!approvalFlow) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("审批流异常请检查提交信息");
                return result;
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 结项错误：" + e.toString(), e);
            result.addErrorMessage("结项错误：" + e.toString());
            return result;
        }
        return result;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> projectSettlerSave(ProjectBS projectBS, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            projectBS.setUserDate(new Date());
            ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectById(projectBS.getId());
            projectBillsSubs.setSettlerChStatus("T");
            projectBillsSubs.setSettlerChDate(new Date());
            projectBillsSubs.setSettlerChUserId(sysUserDto.getUserId().intValue());
            projectBillsSubs.setSettlerChRemarks(projectBS.getSettlerChRemarks());
            boolean update = projectBillsSubsService.updateById(projectBillsSubs);
            if (!update) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("结项失败");
                return result;
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 结项错误：" + e.toString(), e);
            result.addErrorMessage("结项错误：" + e.toString());
            return result;
        }
        return result;
    }

    /*审批版本*/
    /*public ExecuteResult<String> projectSettlerSave(ProjectBS projectBS, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            projectBS.setUserDate(new Date());
            ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectById(projectBS.getId());
            projectBillsSubs.setSettlerChStatus("I");
            projectBillsSubs.setSettlerChDate(new Date());
            projectBillsSubs.setSettlerChUserId(sysUserDto.getUserId().intValue());
            projectBillsSubs.setSettlerChRemarks(projectBS.getSettlerChRemarks());
            boolean update = projectBillsSubsService.updateById(projectBillsSubs);
            if (!update) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("结项失败");
                return result;
            }
            Audit audit = new Audit();
            audit.setBillNo(projectBS.getBillNo());
            audit.setActId(655);
            audit.setLevelId(0);
            audit.setIffinalItem("F");
            audit.setSubJect(projectBillsSubs.getProjectSubName());
            audit.setProjectNo(projectBillsSubs.getProjectSubNo());
            audit.setBranchId(projectBillsSubs.getBranchId());
            audit.setSendUserId(sysUserDto.getUserId().intValue());
            audit.setSendName(sysUserDto.getUsername());
            audit.setSendTime(new Date());
            audit.setAuditUserId(sysUserDto.getUserId().intValue());
            audit.setAuditItem(new Date());
            audit.setAuditMsg("提交");
            audit.setAuditStatus("O");
            audit.setProjectMngId(projectBillsSubs.getProjectSubMngId());
            EntityWrapper<Projectbills> projectbillsEntityWrapper = new EntityWrapper<>();
            projectbillsEntityWrapper.setSqlSelect("id", "project_leader").eq("bill_no", projectBillsSubs.getBillNo())
                    .eq("act_id", projectBillsSubs.getActId());
            Projectbills projectbills = projectbillsService.selectOne(projectbillsEntityWrapper);
            if (projectbills != null) {
                audit.setProjectLeader(projectbills.getProjectLeader());
            }
            boolean approvalFlow = auditItemsService.createApprovalFlow(audit);
            if (!approvalFlow) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("审批流异常请检查提交信息");
                return result;
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 结项错误：" + e.toString(), e);
            result.addErrorMessage("结项错误：" + e.toString());
            return result;
        }
        return result;
    }*/

    @Override
    public Map<String, Object> queryTurnkeyExistingBillVal(Integer id) {
        if (id != null) {
            Map<String, Object> map = new HashMap<>();
            Map<String, Object> objectMap = projectbillsService.queryTurnkeyExistingVal(id);
            map.put("form", objectMap);
            return map;
        }
        return null;
    }

    @Override
    public Map<String, Object> queryProjectWarning() {
        Map<String, Object> map = new HashMap<>();
        EntityWrapper<Dictionaries> entityWrapper = new EntityWrapper<>();
        entityWrapper.eq("dictionaries_name", "project_warning");
        Dictionaries dictionaries = dictionariesService.selectOne(entityWrapper);
        if (dictionaries != null) {
            List<Projectbills> projectbillsList = projectbillsService.selectProjectWarning(map);
            if (projectbillsList.size() != 0) {
                List<Projectbills> projectbills = new ArrayList<>();
                long timestamp = (System.currentTimeMillis() / 1000 / (60 * 60 * 24)) * dictionaries.getDictionariesNumber();
                for (Projectbills pb : projectbillsList) {
                    long time = pb.getBillDate().getTime() + timestamp;
                    long tim = new Date().getTime();
                    if (tim >= time) {
                        projectbills.add(pb);
                    }
                }
                if (projectbills.size() != 0) {
                    map.put("projects", projectbills);
                }
                return map;
            }
        }
        return null;
    }

    @Override
    public Map<String, Object> queryContractTemporary(ProjectbillsDto projectbillsDto) {
        if (projectbillsDto != null && projectbillsDto.getId() != null) {
            Map<String, Object> map = new HashMap<>();
            Projectbills projectbills = projectbillsService.selectById(projectbillsDto.getId());
            if (projectbills != null) {
                map.put("project", projectbills);
                EntityWrapper<Tasklists> tasklistsEntityWrapper = new EntityWrapper<>();
                tasklistsEntityWrapper.eq("bill_no", projectbills.getBillNo())
                        .eq("act_id", 10);
                Tasklists tasklists = tasklistsService.selectOne(tasklistsEntityWrapper);
                map.put("task", tasklists);
                EntityWrapper<ProjectBillsStlPlans> projectBillsStlPlansEntityWrapper = new EntityWrapper<>();
                projectBillsStlPlansEntityWrapper.eq("bill_no", projectbills.getBillNo());
                List<ProjectBillsStlPlans> projectBillsStlPlans = projectBillsStlPlansService.selectList(projectBillsStlPlansEntityWrapper);
                if (projectBillsStlPlans.size() != 0) {
                    map.put("proStlPlans", projectBillsStlPlans);
                }
                EntityWrapper<AttachFiles> attachFilesEntityWrapper = new EntityWrapper<>();
                attachFilesEntityWrapper.eq("bill_no", projectbills.getBillNo()).eq("act_id", 101);
                List<AttachFiles> attachFiles = attachFilesService.selectList(attachFilesEntityWrapper);
                if (attachFiles.size() != 0) {
                    map.put("attachs", attachFiles);
                }
                EntityWrapper<ProjectBillsSubs> entityWrapper = new EntityWrapper<>();
                entityWrapper.eq("bill_no", projectbills.getBillNo())
                        .eq("branch_id", projectbills.getBranchId())
                        .gt("sub_inv_amt_cr", 0);
                List<ProjectBillsSubs> projectBillsSubs = projectBillsSubsService.selectList(entityWrapper);
                if (projectBillsSubs.size() > 0) {
                    map.put("proSubs", false);
                } else {
                    map.put("proSubs", true);
                }
            }
            return map;
        }
        return null;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> survivingProjectsTemporary(String projectBills, String projects, String costSituation,
                                                            String projectBudgets, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            Projectbills projectbills = JSONArray.parseObject(projectBills, Projectbills.class);
            EntityWrapper<Projectbills> projectbillsWrapper = new EntityWrapper<>();
            projectbillsWrapper.eq("project_name", projectbills.getProjectName())
                    .eq("branch_id", projectbills.getBranchId())
                    .eq("is_sur", "T");
            if (projectbills.getId() != null) {
                projectbillsWrapper.ne("id", projectbills.getId());
            }
            List<Projectbills> projectbillsList = projectbillsService.selectList(projectbillsWrapper);
            if (projectbillsList.size() != 0) {
                result.addErrorMessage("该工程名称已被使用");
                return result;
            }
            Projectbills projectBill = JSONArray.parseObject(projects, Projectbills.class);
            if (projectbills != null) {
                Calendar cal = Calendar.getInstance();
                int year = cal.get(Calendar.YEAR);
                if (projectbills.getProjectNo() == null || "".equals(projectbills.getProjectNo())) {
                    String contractNo = null;
                    contractNo = this.updateProjectNo(projectbills);
                    if (contractNo != null) {
                        projectbills.setBillNo(projectbills.getBillNo().replaceAll("initial", ""));
                        projectbills.setProjectNo(contractNo);
                    } else {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：生成系统工程编号失败");
                        return result;
                    }
                }
                projectbills.setContractAmt(projectBill.getContractAmt());
                if (projectBill.getContractAuditAmt() != null && projectBill.getContractAuditAmt() != 0) {
                    projectbills.setSettlementStatus(6);
                    projectbills.setAmt(projectBill.getContractAuditAmt());
                } else {
                    if (projectBill.getContractAmt() == null || projectBill.getContractAmt() <= 0) {
                        projectbills.setContractAmt(projectBill.getEstimatedAmt());
                        projectbills.setAmt(projectBill.getEstimatedAmt());
                    } else {
                        projectbills.setAmt(projectBill.getContractAmt());
                    }
                }
                projectbills.setContractAuditAmt(projectBill.getContractAuditAmt());
                projectbills.setEstimatedAmt(projectBill.getEstimatedAmt());
                projectbills.setSettlementAmt(projectBill.getSettlementAmt());
                projectbills.setSubInvAmtCr(projectBill.getSubInvAmtCr());
                projectbills.setSubInvAmtBlc(Double.parseDouble(String.format("%.2f", projectBill.getSubInvAmtBlc())));
                projectbills.setSubAmtDr(projectBill.getSubAmtDr());
                projectbills.setSubAmtBlc(Double.parseDouble(String.format("%.2f", projectBill.getSubAmtBlc())));
                projectbills.setRemarks(projectBill.getRemarks());
                projectbills.setStartDateStatus(6);
                projectbills.setStartDateEnd(6);
                projectbills.setRenewProjectStatus(2);
                projectbills.setCreateDate(new Date());
                projectbills.setBillDate(new Date());
                projectbills.setBranchId(sysUserDto.getLoginContractorId());
                projectbills.setOpUserId(sysUserDto.getUserId().intValue());
                projectbills.setOpUserName(sysUserDto.getUsername());
                boolean update = projectbillsService.insertOrUpdate(projectbills);
                if (!update) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：操作总包失败");
                    return result;
                }
                String projectBillBackup = projectbills.getBillNo();
                String projectNoBackup = projectbills.getProjectNo();
                //系统工程编号 2种情况 null 或者  编号+（initial）
                if (projectbills.getProjectNo().indexOf("initial") == -1) {
                    projectbills.setProjectNo(projectbills.getProjectNo() + "initial");
                }
                if (projectbills.getBillNo().indexOf("initial") == -1) {
                    projectbills.setBillNo(projectbills.getBillNo() + "initial");
                }
                EntityWrapper<Projectbills> proEntity = new EntityWrapper<>();
                proEntity.eq("bill_no", projectbills.getBillNo())
                        .eq("project_no", projectbills.getProjectNo())
                        .eq("branch_id", projectbills.getBranchId());
                projectbillsService.delete(proEntity);
                projectbills.setId(null);
                projectbills.setIsSur("I");
                boolean updatePro = projectbillsService.insertOrUpdate(projectbills);
                if (!updatePro) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：操作总包失败");
                    return result;
                }
                Projectbills projectbillsCopy = new Projectbills();
                projectbillsCopy.setBillNo(projectbills.getBillNo());
                projectbillsCopy.setProjectNo(projectbills.getProjectNo());
                projectbillsCopy.setBranchId(projectbills.getBranchId());
                projectbillsCopy.setTaxRate(projectbills.getTaxRate());
                projectbillsCopy.setProjectName(projectbills.getProjectName());
                projectbillsCopy.setActStartDate(projectbills.getActStartDate());
                projectbillsCopy.setActEndDate(projectbills.getActEndDate());
                projectbillsCopy.setNcProjectNo(projectbills.getNcProjectNo());
                projectbillsCopy.setProjectCost(projectbills.getProjectCost());
                projectbillsCopy.setContractAmt(projectbills.getContractAmt());
                projectbillsCopy.setAmt(projectbills.getAmt());
                projectbillsCopy.setIsSur("I");
                projectbills.setBillNo(projectBillBackup);
                projectbills.setProjectNo(projectNoBackup);
                projectbills.setIsSur("T");
                // 添加任务
                EntityWrapper<Tasklists> tasklistsEntityWrapper = new EntityWrapper<>();
                tasklistsEntityWrapper.eq("bill_no", projectbills.getBillNo());
                int count = tasklistsService.selectCount(tasklistsEntityWrapper);
                if (count <= 0) {
                    Tasklists tasklists = new Tasklists();
                    tasklists.setBillNo(projectbills.getBillNo());
                    tasklists.setActId(10);
                    tasklists.setStatus(2);
                    tasklists.setOpUserId(sysUserDto.getUserId().intValue());
                    tasklists.setOpUserName(sysUserDto.getUsername());
                    boolean insert = tasklistsService.insertOrUpdate(tasklists);
                    if (!insert) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：创建任务失败");
                        return result;
                    }
                    tasklists.setActId(11);
                    boolean insertCnt = tasklistsService.insertOrUpdate(tasklists);
                    if (!insertCnt) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：创建任务失败");
                        return result;
                    }
                }
                // 添加分包合同
                double money = 0;
                double subAmtCr = 0.0;
                double subInvAmtCr = 0.0;
                JSONArray jsonArray = JSONArray.parseArray(costSituation);
                List<SubContractBills> subContractBillsList = JSONObject.parseArray(jsonArray.toJSONString(), SubContractBills.class);
                if (subContractBillsList.size() != 0) {
                    EntityWrapper<SubContractBills> subContractBillsEntityWrapper = new EntityWrapper<>();
                    subContractBillsEntityWrapper.eq("bill_no", projectbills.getBillNo())
                            .eq("project_sub_no", projectbills.getProjectNo())
                            .eq("branch_id", projectbills.getBranchId());
                    boolean delete = subContractBillsService.delete(subContractBillsEntityWrapper);
                    if (!delete) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：删除旧数据失败");
                        return result;
                    }
                    int line = 0;
                    for (SubContractBills sub : subContractBillsList) {
                        line++;
                        // 已付款金额
                        subAmtCr = Double.parseDouble(String.format("%.2f", (subAmtCr + sub.getSubAmtCr())));
                        // 已开发票金额
                        subInvAmtCr = Double.parseDouble(String.format("%.2f", (subInvAmtCr + sub.getSubInvAmtCr())));
                        sub.setBillNo(projectbills.getBillNo());
                        sub.setActId(100);
                        sub.setProjectSubNo(projectbills.getProjectNo());
                        sub.setIsSur("T");
                        sub.setBillStatus(2);
                        sub.setOpUserId(sysUserDto.getUserId().intValue());
                        sub.setOpUserName(sysUserDto.getUsername());
                        if (sub.getContractAuditAmt() != null && sub.getContractAuditAmt() != 0) {
                            sub.setSettlementStatus(6);
                            sub.setAmt(sub.getContractAuditAmt());
                        } else {
                            sub.setAmt(sub.getEstimatedAmt());
                        }
                        sub.setCreateDate(new Date());
                        sub.setBillDate(new Date());
                        sub.setPostDate(new Date());
                        sub.setBranchId(projectbills.getBranchId());
                        sub.setContractNo(projectbills.getProjectNo() + "-" + line);
                        sub.setContractName(projectbills.getProjectName());
                        sub.setPlanStartDate(projectbills.getActStartDate());
                        sub.setPlanEndDate(projectbills.getActEndDate());
                        sub.setPlanDays(projectbills.getActDays());
                        sub.setOpUserId(sysUserDto.getUserId().intValue());
                        sub.setOpUserName(sysUserDto.getUsername());
                        sub.setContractTaxRate(projectbills.getTaxRate());
                        // 生成工程采购编号
                        EntityWrapper<Dictionaries> entityWrapper = new EntityWrapper<>();
                        entityWrapper.eq("dictionaries_name", "cx_sub_contract_plan_no");
                        Dictionaries dictionariesNum = dictionariesService.selectOne(entityWrapper);
                        dictionariesNum.setDictionariesNumber(dictionariesNum.getDictionariesNumber() + 1);
                        String purchasePlanNo = "cx" + year + dictionariesNum.getDictionariesNumber();
                        sub.setPurchasePlanNo(purchasePlanNo);
                        boolean updateById = dictionariesService.updateById(dictionariesNum);
                        if (!updateById) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：更新字典集失败");
                            return result;
                        }
                        // 结算金额
                        money = Double.parseDouble(String.format("%.2f", (money + sub.getContractAmt())));
                        boolean insert = subContractBillsService.insert(sub);
                        if (!insert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：新建分包合同失败");
                            return result;
                        }
                    }
                    // 备用数据
                    EntityWrapper<SubContractBills> contractBillsEntityWrapper = new EntityWrapper<>();
                    contractBillsEntityWrapper.eq("bill_no", projectbillsCopy.getBillNo())
                            .eq("project_sub_no", projectbillsCopy.getProjectNo())
                            .eq("branch_id", projectbillsCopy.getBranchId());
                    boolean deleteSubContr = subContractBillsService.delete(contractBillsEntityWrapper);
                    if (!deleteSubContr) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：删除旧数据失败");
                        return result;
                    }
                    int lineBackup = 0;
                    for (SubContractBills sub : subContractBillsList) {
                        lineBackup++;
                        sub.setId(null);
                        sub.setBillNo(projectbillsCopy.getBillNo());
                        sub.setProjectSubNo(projectbillsCopy.getProjectNo());
                        sub.setIsSur("I");
                        sub.setBranchId(projectbillsCopy.getBranchId());
                        sub.setContractNo(projectbillsCopy.getProjectNo() + "-" + lineBackup);
                        sub.setContractName(projectbillsCopy.getProjectName());
                        sub.setPlanStartDate(projectbillsCopy.getActStartDate());
                        sub.setPlanEndDate(projectbillsCopy.getActEndDate());
                        sub.setPlanDays(projectbillsCopy.getActDays());
                        sub.setContractTaxRate(projectbillsCopy.getTaxRate());
                        // 结算金额
                        boolean insert = subContractBillsService.insert(sub);
                        if (!insert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：新建分包合同失败");
                            return result;
                        }
                    }
                    // 插入 项目预算
                    EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
                    projectBillsBudgetsEntityWrapper.eq("bill_no", projectbills.getBillNo())
                            .eq("budget_id", 1)
                            .eq("project_sub_no", projectbills.getProjectNo())
                            .eq("branch_id", projectbills.getBranchId());
                    boolean delete1 = projectBillsBudgetsService.delete(projectBillsBudgetsEntityWrapper);
                    if (!delete1) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：删除工程旧数据失败");
                        return result;
                    }
                    // 备份数据
                    EntityWrapper<ProjectBillsBudgets> billsBudgeEnw = new EntityWrapper<>();
                    billsBudgeEnw.eq("bill_no", projectbillsCopy.getBillNo())
                            .eq("budget_id", 1)
                            .eq("project_sub_no", projectbillsCopy.getProjectNo())
                            .eq("branch_id", projectbillsCopy.getBranchId());
                    boolean deleteSubBudget = projectBillsBudgetsService.delete(billsBudgeEnw);
                    if (!deleteSubBudget) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：删除工程旧数据失败");
                        return result;
                    }
                    // 生成一条工程款预算项目
                    ProjectBillsBudgets billsBudgets = new ProjectBillsBudgets();
                    billsBudgets.setBillNo(projectbills.getBillNo());
                    billsBudgets.setProjectSubNo(projectbills.getProjectNo());
                    billsBudgets.setBudgetId(1);
                    billsBudgets.setBranchId(projectbills.getBranchId());
                    billsBudgets.setBudgetName("工程款");
                    billsBudgets.setBudgetAmt(money);
                    billsBudgets.setSubInvAmtCr(subInvAmtCr);
                    billsBudgets.setSubInvAmtBlc(Double.parseDouble(String.format("%.2f", (billsBudgets.getBudgetAmt() - subInvAmtCr))));
                    billsBudgets.setSubAmtCr(subAmtCr);
                    billsBudgets.setSubAmtBlc(Double.parseDouble(String.format("%.2f", (subInvAmtCr - subAmtCr))));
                    boolean insert = projectBillsBudgetsService.insert(billsBudgets);
                    if (!insert) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：新建工程成本失败");
                        return result;
                    }
                    // 备份
                    billsBudgets.setId(null);
                    billsBudgets.setBillNo(projectbillsCopy.getBillNo());
                    billsBudgets.setProjectSubNo(projectbillsCopy.getProjectNo());
                    billsBudgets.setBranchId(projectbillsCopy.getBranchId());
                    boolean insertSubBudget = projectBillsBudgetsService.insert(billsBudgets);
                    if (!insertSubBudget) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：新建工程成本失败");
                        return result;
                    }
                }
                // 添加预算成本
                JSONArray array = JSONArray.parseArray(projectBudgets);
                List<ProjectBillsBudgets> projectBillsBudgetsList = JSONObject.parseArray(array.toJSONString(), ProjectBillsBudgets.class);
                if (projectBillsBudgetsList.size() != 0) {
                    EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
                    projectBillsBudgetsEntityWrapper.eq("bill_no", projectbills.getBillNo())
                            .ne("budget_id", 1)
                            .eq("project_sub_no", projectbills.getProjectNo())
                            .eq("branch_id", projectbills.getBranchId());
                    boolean delete1 = projectBillsBudgetsService.delete(projectBillsBudgetsEntityWrapper);
                    if (!delete1) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：删除工程旧数据失败");
                        return result;
                    }
                    EntityWrapper<ProjectBillsBudgets> backupEntityWrapper = new EntityWrapper<>();
                    backupEntityWrapper.eq("bill_no", projectbillsCopy.getBillNo())
                            .ne("budget_id", 1)
                            .eq("project_sub_no", projectbillsCopy.getProjectNo())
                            .eq("branch_id", projectbillsCopy.getBranchId());
                    boolean deleteBudgetBackup = projectBillsBudgetsService.delete(backupEntityWrapper);
                    if (!deleteBudgetBackup) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：删除工程旧数据失败");
                        return result;
                    }
                    int line = 0;
                    for (ProjectBillsBudgets sub : projectBillsBudgetsList) {
                        line++;
                        // 已付款金额
                        subAmtCr += sub.getSubAmtCr();
                        // 已开发票金额
                        subInvAmtCr += sub.getSubInvAmtCr();
                        sub.setBudgetAmt(sub.getSettlementAmt());
                        sub.setBillNo(projectbills.getBillNo());
                        sub.setLineNo(line);
                        sub.setBranchId(projectbills.getBranchId());
                        sub.setProjectSubNo(projectbills.getProjectNo());
                        if (Objects.equals(sub.getBudgetId(), 2)) {
                            sub.setApprovedAmount(sub.getSubInvAmtCr());
                        }
                        boolean insert = projectBillsBudgetsService.insert(sub);
                        if (!insert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：新建成本预算失败");
                            return result;
                        }
                    }
                    // 备份
                    int lineBackup = 0;
                    for (ProjectBillsBudgets sub : projectBillsBudgetsList) {
                        lineBackup++;
                        sub.setId(null);
                        sub.setBillNo(projectbillsCopy.getBillNo());
                        sub.setLineNo(lineBackup);
                        sub.setBranchId(projectbillsCopy.getBranchId());
                        sub.setProjectSubNo(projectbillsCopy.getProjectNo());
                        if (Objects.equals(sub.getBudgetId(), 2)) {
                            sub.setApprovedAmount(sub.getSubInvAmtCr());
                        }
                        boolean insert = projectBillsBudgetsService.insert(sub);
                        if (!insert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：新建成本预算失败");
                            return result;
                        }
                    }
                }
                // 添加 二级项目
                ProjectBillsSubs proSub = new ProjectBillsSubs();
                EntityWrapper<ProjectBillsSubs> subsEntityWrapper = new EntityWrapper<>();
                subsEntityWrapper.setSqlSelect("id").eq("bill_no", projectbills.getBillNo())
                        .eq("project_sub_no", projectbills.getProjectNo())
                        .eq("if_project_sub", "F")
                        .eq("is_sur", projectbills.getIsSur())
                        .eq("branch_id", projectbills.getBranchId());
                ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(subsEntityWrapper);
                if (projectBillsSubs != null) {
                    proSub.setId(projectBillsSubs.getId());
                }
                proSub.setBillNo(projectbills.getBillNo());
                proSub.setActId(103);
                proSub.setLineNo(1);
                proSub.setProjectSubNo(projectbills.getProjectNo());
                proSub.setBillStatus(2);
                proSub.setIfProjectSub("F");
                proSub.setIsSur(projectbills.getIsSur());
                proSub.setNcProjectNo(projectbills.getNcProjectNo());
                proSub.setProjectSubNo(projectbills.getProjectNo());
                proSub.setProjectSubName(projectbills.getProjectName());
                proSub.setBranchId(projectbills.getBranchId());
                proSub.setApprovalBranchId(projectbills.getApprovalBranchId());
                proSub.setContractAmt(projectbills.getContractAmt());
                proSub.setAmt(projectbills.getAmt());
                proSub.setProjectBudgetStatus(6);
                proSub.setBudgetCreateDate(new Date());
                proSub.setBudgetOrgDate(new Date());
                proSub.setBudgetAmt(projectbills.getProjectCost());
                proSub.setBudgetProfit(Double.parseDouble(String.format("%.2f", (proSub.getAmt() - proSub.getBudgetAmt()))));
                proSub.setBudgetProfitRate((double) Math.round((proSub.getBudgetProfit() / proSub.getAmt()) * 100));
                proSub.setBudgetUserName(sysUserDto.getUsername());
                proSub.setProjectStepsStatus(6);
                proSub.setCorpId(projectbills.getCorpId());
                proSub.setProjectStatus(30);
                proSub.setCreateData(new Date());
                proSub.setCreateUserId(sysUserDto.getUserId().intValue());
                proSub.setProjectWorkRate(100.0);
                proSub.setCurrentProgress(100.0);
                proSub.setProjectSubMngId(projectbills.getProjectMngId());
                proSub.setProjectSubMngDeptId(projectbills.getProjectMngDeptId());
                proSub.setSubInvAmtDr(projectbills.getSubInvAmtCr());
                proSub.setSubAmtDr(projectbills.getSubAmtDr());
                // 存续项目付款金额可以超过收款
//                if (proSub.getSubAmtDr() < subAmtCr) {
//                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
//                    result.addErrorMessage("提交失败：付款金额不得超过收款金额");
//                    return result;
//                }
                proSub.setSubAmtCr(subAmtCr);
                proSub.setSubInvAmtCr(subInvAmtCr);
                boolean proSubInsert = projectBillsSubsService.insertOrUpdate(proSub);
                if (!proSubInsert) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：新增子项目失败");
                    return result;
                }
                // 备份
                EntityWrapper<ProjectBillsSubs> subsEntityWrapperBackup = new EntityWrapper<>();
                subsEntityWrapperBackup.setSqlSelect("id").eq("bill_no", projectbillsCopy.getBillNo())
                        .eq("project_sub_no", projectbillsCopy.getProjectNo())
                        .eq("if_project_sub", "F")
                        .eq("is_sur", "I")
                        .eq("branch_id", projectbillsCopy.getBranchId());
                ProjectBillsSubs projectBillsSubsBackup = projectBillsSubsService.selectOne(subsEntityWrapperBackup);
                if (projectBillsSubsBackup != null) {
                    proSub.setId(projectBillsSubsBackup.getId());
                } else {
                    proSub.setId(null);
                }
                proSub.setBillNo(projectbillsCopy.getBillNo());
                proSub.setProjectSubNo(projectbillsCopy.getProjectNo());
                proSub.setIsSur(projectbillsCopy.getIsSur());
                proSub.setNcProjectNo(projectbillsCopy.getNcProjectNo());
                proSub.setProjectSubNo(projectbillsCopy.getProjectNo());
                proSub.setProjectSubName(projectbillsCopy.getProjectName());
                proSub.setBranchId(projectbillsCopy.getBranchId());
                proSub.setContractAmt(projectbillsCopy.getContractAmt());
                proSub.setAmt(projectbillsCopy.getAmt());
                proSub.setBudgetAmt(projectbillsCopy.getProjectCost());
                boolean proSubInsertBackup = projectBillsSubsService.insertOrUpdate(proSub);
                if (!proSubInsertBackup) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：新增子项目失败");
                    return result;
                }
            } else {
                result.addErrorMessage("提交失败：未找到项目信息，请检查提交信息重新提交");
                return result;
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error("提交失败：" + e.toString(), e);
            result.addErrorMessage("提交失败：请检查提交信息重新提交");
        }
        return result;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> updateBilling(String from, String list, String edit, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            Projectbills projectbills = JSONArray.parseObject(list, Projectbills.class);
            if (projectbills.getContractAuditAmt() != null && projectbills.getContractAuditAmt() != 0) {
                Projectbills proBills = JSONArray.parseObject(from, Projectbills.class);
                EntityWrapper<ProjectBillsSubs> entityWrapper = new EntityWrapper<>();
                entityWrapper.eq("project_sub_no", proBills.getProjectNo())
                        .eq("branch_id", proBills.getBranchId());
                ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(entityWrapper);
                projectBillsSubs.setContractAuditAmt(projectbills.getContractAuditAmt());
                projectBillsSubs.setAmt(projectbills.getSettlementAmt());
                projectbills.setSettlementStatus(6);
                projectbills.setAmt(projectbills.getSettlementAmt());
                // 添加 总包结算附件
                if (projectbills.getSetAttachId() != null) {
                    EntityWrapper<ProjectBillsAttachs> projectBillsAttachsEntityWrapper = new EntityWrapper<>();
                    projectBillsAttachsEntityWrapper.eq("bill_no", projectbills.getBillNo());
                    boolean delete = projectBillsAttachsService.delete(projectBillsAttachsEntityWrapper);
                    if (!delete) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：删除旧数据失败");
                        return result;
                    }
                    ProjectAnnex projectAnnex = new ProjectAnnex();
                    projectAnnex.setSrcActId(101);
                    projectAnnex.setProjectId(projectbills.getId());
                    projectAnnex.setFileName("总包合同");
                    projectAnnex.setFileAddress(projectbills.getSetAttachId());
                    projectAnnex.setBranId(projectbills.getBranchId());
                    boolean proInsert = projectAnnexService.insert(projectAnnex);
                    if (!proInsert) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：更新附件失败");
                        return result;
                    }
                    ProjectBillsAttachs pba = new ProjectBillsAttachs();
                    pba.setBillNo(projectbills.getBillNo());
                    pba.setLineNo(1);
                    pba.setActId(205);
                    pba.setAttachId(projectbills.getSetAttachId());
                    pba.setOpUserId(sysUserDto.getUserId().intValue());
                    pba.setOpUserName(sysUserDto.getUsername());
                    pba.setOpDate(projectbills.getContractAuditDate());
                    pba.setBranchId(projectbills.getBranchId());
                    boolean insert = projectBillsAttachsService.insert(pba);
                    if (!insert) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：新增附件失败");
                        return result;
                    }
                }
                if (projectbills.getEstimatedAmt() <= 0.00) {
                    projectBillsSubs.setAmt(projectbills.getContractAuditAmt());
                    EntityWrapper<SubContractBills> subContractBillsEntityWrapper = new EntityWrapper<>();
                    subContractBillsEntityWrapper.eq("bill_no", projectBillsSubs.getBillNo())
                            .eq("project_sub_no", projectBillsSubs.getProjectSubNo())
                            .eq("branch_id", projectBillsSubs.getBranchId())
                            .ne("settlement_status", 6);
                    int count = subContractBillsService.selectCount(subContractBillsEntityWrapper);
                    if (count <= 0) {
                        projectBillsSubs.setProjectStatus(40);
                    }
                    projectbills.setAmt(projectbills.getContractAuditAmt());
                    projectbills.setSettlementUserId(sysUserDto.getUserId().intValue());
                    projectbills.setContractAuditDate(new Date());
                }
                boolean updateById = projectBillsSubsService.updateById(projectBillsSubs);
                if (!updateById) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：更新信息有误");
                    return result;
                }
            }
            boolean updateById = projectbillsService.updateById(projectbills);
            if (!updateById) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("提交失败：更新信息有误");
                return result;
            }
            ProjectBillsHistory projectBillsHistory = new ProjectBillsHistory();
            String t = getStringDate();
            int x = (int) (Math.random() * 900) + 100;
            projectBillsHistory.setProjectId(projectbills.getId());
            projectBillsHistory.setSerialNumber(t + x);
            projectBillsHistory.setModifyReason(edit);
            projectBillsHistory.setHistoryUser(sysUserDto.getUserId().intValue());
            projectBillsHistory.setHistoryUserName(sysUserDto.getUsername());
            projectBillsHistory.setHistoryDate(new Date());
            projectBillsHistory.setHistoryBody1(from);
            projectBillsHistory.setHistoryBody2(list);
            projectBillsHistory.setIsSettlement(1);
            boolean flag = projectBillsHistoryService.insert(projectBillsHistory);
            if (!flag) {
                result.addErrorMessage("保存失败。");
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error("提交失败：" + e.toString(), e);
            result.addErrorMessage("提交失败：请检查提交信息重新提交");
        }
        return result;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> withdrawalApproval(ProjectBillsSubsDto projectBillsSubsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            if (projectBillsSubsDto != null) {
                if ((projectBillsSubsDto.getActId() >= 420 && projectBillsSubsDto.getActId() <= 443)
                        || (projectBillsSubsDto.getActId() >= 450 && projectBillsSubsDto.getActId() <= 465)
                        || (projectBillsSubsDto.getActId() >= 470 && projectBillsSubsDto.getActId() <= 473)) {
                    result = this.withdrawalPurchase(projectBillsSubsDto);
                    return result;
                } else if (Objects.equals(projectBillsSubsDto.getActId(), 310) || Objects.equals(projectBillsSubsDto.getActId(), 610)
                        || Objects.equals(projectBillsSubsDto.getActId(), 630) || Objects.equals(projectBillsSubsDto.getActId(), 650)
                        || Objects.equals(projectBillsSubsDto.getActId(), 655) || Objects.equals(projectBillsSubsDto.getActId(), 730)) {
                    result = this.withdrawalProjectSub(projectBillsSubsDto);
                    return result;
                } else if (Objects.equals(projectBillsSubsDto.getActId(), 340)) {
                    result = this.withdrawalCompletion(projectBillsSubsDto);
                    return result;
                } else if (Objects.equals(projectBillsSubsDto.getActId(), 510) || Objects.equals(projectBillsSubsDto.getActId(), 520)
                        || Objects.equals(projectBillsSubsDto.getActId(), 530)) {
                    result = this.withdrawalInvoiceCr(projectBillsSubsDto);
                    return result;
                } else if (Objects.equals(projectBillsSubsDto.getActId(), 540)) {
                    result = this.withdrawalInvoiceSharesCr(projectBillsSubsDto);
                    return result;
                } else if (Objects.equals(projectBillsSubsDto.getActId(), 560) || Objects.equals(projectBillsSubsDto.getActId(), 570)) {
                    result = this.withdrawalPayCr(projectBillsSubsDto);
                    return result;
                } else if (Objects.equals(projectBillsSubsDto.getActId(), 830)) {
                    result = this.withdrawalAdjusts(projectBillsSubsDto);
                    return result;
                }
            } else {
                result.addErrorMessage("提交失败：未找到信息");
                return result;
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error("提交失败：" + e.toString(), e);
            result.addErrorMessage("提交失败：请检查提交信息重新提交");
        }
        return result;
    }

    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> withdrawalPurchase(ProjectBillsSubsDto projectBillsSubsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            PurchaseBills purchaseBills = purchaseBillsService.selectById(projectBillsSubsDto.getId());
            EntityWrapper<ProjectBillsSubs> entityWrapper = new EntityWrapper<>();
            entityWrapper.eq("project_sub_no", purchaseBills.getProjectSubNo())
                    .eq("branch_id", purchaseBills.getContractorId());
            ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(entityWrapper);
            if (Objects.equals(purchaseBills.getBillStatus(), 5) || Objects.equals(purchaseBills.getBillStatus(), 6)) {
                result.addErrorMessage("提交失败：已审批不可撤回");
                return result;
            } else if (Objects.equals(purchaseBills.getBillStatus(), 2)) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("撤回失败: 未提交数据不可撤回");
                return result;
            }
            purchaseBills.setBillStatus(2);
            boolean update = purchaseBillsService.updateById(purchaseBills);
            if (!update) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("撤回失败: 更新采购状态失败");
                return result;
            }
            EntityWrapper<ProjectBillsBudgets> budgetsEntityWrapper = new EntityWrapper<>();
            budgetsEntityWrapper.eq("project_sub_no", purchaseBills.getProjectSubNo())
                    .eq("branch_id", projectBillsSubs.getBranchId());
            if ((projectBillsSubsDto.getActId() >= 420 && projectBillsSubsDto.getActId() <= 443)) {
                budgetsEntityWrapper.eq("budget_id", 2);
                ProjectBillsBudgets projectBillsBudgets = projectBillsBudgetsService.selectOne(budgetsEntityWrapper);
                projectBillsBudgets.setBudgetUseAmt(projectBillsBudgets.getBudgetUseAmt() - purchaseBills.getAmt());
                boolean updateBudget = projectBillsBudgetsService.updateById(projectBillsBudgets);
                if (!updateBudget) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败！更新预算失败");
                    return result;
                }
                double amt = projectBillsBudgetsService.selectApprovedAmountSum(projectBillsBudgets);
                projectBillsSubs.setActualBudgetAmt(amt);
                boolean updateByProSub = projectBillsSubsService.updateById(projectBillsSubs);
                if (!updateByProSub) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("审批驳回失败！更新预算失败");
                    return result;
                }
                EntityWrapper<PurchaseBillsItems> billsItemsEntityWrapper = new EntityWrapper<>();
                billsItemsEntityWrapper.eq("bill_no", purchaseBills.getBillNo())
                        .eq("project_sub_no", purchaseBills.getProjectSubNo());
                List<PurchaseBillsItems> billsItemsDtos = purchaseBillsItemsService.selectList(billsItemsEntityWrapper);
                if (billsItemsDtos.size() != 0) {
                    for (PurchaseBillsItems items : billsItemsDtos) {
                        EntityWrapper<PurchaseBillsItems> purchaseBillsItemsEntityWrapper = new EntityWrapper<>();
                        purchaseBillsItemsEntityWrapper.eq("bill_no", items.getSrcBillNo())
                                .eq("lino_no", items.getSrcLinoNo())
                                .eq("project_sub_no", items.getProjectSubNo());
                        PurchaseBillsItems updateItem = purchaseBillsItemsService.selectOne(purchaseBillsItemsEntityWrapper);
                        updateItem.setPurchaseInvQty(updateItem.getPurchaseInvQty() - items.getRequireQty().intValue());
                        updateItem.setTimeAmt(DataUtils.keepDecimals(updateItem.getTimeAmt() - items.getTimeAmt()));
                        boolean updeteType = purchaseBillsItemsService.updateById(updateItem);
                        if (!updeteType) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("审批驳回失败: 更新预算失败");
                            return result;
                        }
                    }
                }
            } else if ((projectBillsSubsDto.getActId() >= 450 && projectBillsSubsDto.getActId() <= 465)) {
                budgetsEntityWrapper.eq("budget_id", 1);
                ProjectBillsBudgets projectBillsBudgets = projectBillsBudgetsService.selectOne(budgetsEntityWrapper);
                projectBillsBudgets.setBudgetUseAmt(projectBillsBudgets.getBudgetUseAmt() - purchaseBills.getAmt());
                boolean updateProBudget = projectBillsBudgetsService.updateById(projectBillsBudgets);
                if (!updateProBudget) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败！更新预算失败");
                    return result;
                }
                double amt = projectBillsBudgetsService.selectApprovedAmountSum(projectBillsBudgets);
                projectBillsSubs.setActualBudgetAmt(amt);
                boolean updateByProSub = projectBillsSubsService.updateById(projectBillsSubs);
                if (!updateByProSub) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("审批驳回失败！更新预算失败");
                    return result;
                }
            } else if ((projectBillsSubsDto.getActId() >= 470 && projectBillsSubsDto.getActId() <= 473)) {
                budgetsEntityWrapper.eq("budget_id", 1);
                ProjectBillsBudgets projectBillsBudgets = projectBillsBudgetsService.selectOne(budgetsEntityWrapper);
                projectBillsBudgets.setBudgetUseAmt(projectBillsBudgets.getBudgetUseAmt() - purchaseBills.getAmt());
                boolean updateBudget = projectBillsBudgetsService.updateById(projectBillsBudgets);
                if (!updateBudget) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败！更新预算失败");
                    return result;
                }
                double amt = projectBillsBudgetsService.selectApprovedAmountSum(projectBillsBudgets);
                projectBillsSubs.setActualBudgetAmt(amt);
                boolean updateByProSub = projectBillsSubsService.updateById(projectBillsSubs);
                if (!updateByProSub) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("审批驳回失败！更新预算失败");
                    return result;
                }
            }
            int deleteNum = auditItemsService.deletePurchaseApproval(projectBillsSubsDto);
            if (deleteNum == 0) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("撤回失败: 未找到审批信息");
                return result;
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error("提交失败：" + e.toString(), e);
            result.addErrorMessage("提交失败：请检查提交信息重新提交");
        }
        return result;
    }

    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> withdrawalProjectSub(ProjectBillsSubsDto projectBillsSubsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectById(projectBillsSubsDto.getId());
            if (Objects.equals(projectBillsSubsDto.getActId(), 610)) {
                Projectbills projectbills = projectbillsService.selectById(projectBillsSubsDto.getId());
                projectbills.setSettlementStatus(2);
                boolean updateById = projectbillsService.updateById(projectbills);
                if (!updateById) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：更新状态失败");
                }
                int deleteNum = auditItemsService.deleteProjectApproval(projectBillsSubsDto);
                if (deleteNum == 0) {
                    result.addErrorMessage("撤回失败: 未找到审批信息");
                    return result;
                }
                return result;
            } else if (Objects.equals(projectBillsSubsDto.getActId(), 630)) {
                EntityWrapper<SubContractBills> contractBillsEntityWrapper = new EntityWrapper<>();
                contractBillsEntityWrapper.eq("project_sub_no", projectBillsSubs.getProjectSubNo())
                        .eq("branch_id", projectBillsSubs.getBranchId());
                List<SubContractBills> subContractBills = subContractBillsService.selectList(contractBillsEntityWrapper);
                for (SubContractBills sc : subContractBills) {
                    if (Objects.equals(sc.getSettlementStatus(), 5)) {
                        result.addErrorMessage("提交失败：已审批不可撤回");
                        return result;
                    }
                    if (Objects.equals(sc.getSettlementStatus(), 4)) {
                        sc.setSettlementStatus(2);
                        boolean updateById = subContractBillsService.updateById(sc);
                        if (!updateById) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("审批驳回失败: 更新数据失败");
                            return result;
                        }
                    }
                }
            } else if (Objects.equals(projectBillsSubsDto.getActId(), 650) || Objects.equals(projectBillsSubsDto.getActId(), 655)) {
                if (Objects.equals(projectBillsSubsDto.getActId(), 655)) {
                    if ("Z".equals(projectBillsSubs.getSettlerChStatus()) || "T".equals(projectBillsSubs.getSettlerChStatus())) {
                        result.addErrorMessage("提交失败：已审批不可撤回");
                        return result;
                    }
                    if ("S".equals(projectBillsSubs.getSettlerChStatus()) || "F".equals(projectBillsSubs.getSettlerChStatus())) {
                        result.addErrorMessage("提交失败：未提交不可撤回");
                        return result;
                    }
                    projectBillsSubs.setSettlerChStatus("F");
                } else {
                    if ("Z".equals(projectBillsSubs.getClosingStatus()) || "T".equals(projectBillsSubs.getClosingStatus())) {
                        result.addErrorMessage("提交失败：已审批不可撤回");
                        return result;
                    }
                    if ("S".equals(projectBillsSubs.getClosingStatus()) || "F".equals(projectBillsSubs.getClosingStatus())) {
                        result.addErrorMessage("提交失败：未提交不可撤回");
                        return result;
                    }
                    projectBillsSubs.setClosingStatus("F");
                    double amt = 0.0;
                    EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
                    projectBillsBudgetsEntityWrapper.eq("project_sub_no", projectBillsSubs.getProjectSubNo())
                            .eq("branch_id", projectBillsSubs.getBranchId());
                    List<ProjectBillsBudgets> billsBudgets = projectBillsBudgetsService.selectList(projectBillsBudgetsEntityWrapper);
                    if (billsBudgets.size() != 0) {
                        for (ProjectBillsBudgets pb : billsBudgets) {
                            pb.setBranchId(projectBillsSubs.getBranchId());
                            if (!projectBillsBudgetsService.insert(pb)) {
                                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                result.addErrorMessage("新增成本失败,请检查成本信息");
                                return result;
                            }
                            if (Objects.equals(pb.getBudgetAmt(), 0)) {
                                amt = DataUtils.keepDecimals(amt + pb.getApprovedAmount());
                            }
                        }
                    }
                    projectBillsSubs.setSubAmtCr(DataUtils.keepDecimals(projectBillsSubs.getSubAmtCr() - amt));
                }
                boolean updateById = projectBillsSubsService.updateById(projectBillsSubs);
                if (!updateById) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("审批通过失败: 更新状态失败");
                    return result;
                }
            } else if (Objects.equals(projectBillsSubsDto.getActId(), 730)) {
                if (Objects.equals(projectBillsSubs.getProjectBudgetStatus(), 5) || Objects.equals(projectBillsSubs.getProjectBudgetStatus(), 6)) {
                    result.addErrorMessage("提交失败：已审批不可撤回");
                    return result;
                }
                projectBillsSubs.setProjectBudgetStatus(2);
                boolean update = projectBillsSubsService.updateById(projectBillsSubs);
                if (!update) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("审批通过失败: 更新状态失败");
                    return result;
                }
            } else {
                EntityWrapper<ProjectBillsSteps> stepsEntityWrapper = new EntityWrapper<>();
                stepsEntityWrapper.eq("project_sub_no", projectBillsSubs.getProjectSubNo())
                        .eq("branch_id", projectBillsSubs.getBranchId())
                        .in("status", new Integer[]{4, 5});
                List<ProjectBillsSteps> projectBillsSteps = projectBillsStepsService.selectList(stepsEntityWrapper);
                if (Objects.equals(projectBillsSteps.size(), 0)) {
                    result.addErrorMessage("审批撤回失败：未找到审批信息");
                    return result;
                }
                for (ProjectBillsSteps step : projectBillsSteps) {
                    if (Objects.equals(step.getStatus(), 5) || Objects.equals(step.getStatus(), 6)) {
                        result.addErrorMessage("审批撤回失败：已审批不可撤回");
                        return result;
                    }
                    step.setStatus(2);
                    if (!projectBillsStepsService.updateById(step)) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("审批撤回失败: 更新节点状态失败");
                        return result;
                    }
                }
            }
            int deleteNum = auditItemsService.deleteProSubsApproval(projectBillsSubsDto);
            if (deleteNum == 0) {
                result.addErrorMessage("撤回失败: 未找到审批信息");
                return result;
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error("撤回失败：" + e.toString(), e);
            result.addErrorMessage("撤回失败：请检查提交信息重新提交");
        }
        return result;
    }

    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> withdrawalCompletion(ProjectBillsSubsDto projectBillsSubsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            Projectbills projectbills = projectbillsService.selectById(projectBillsSubsDto.getId());
            if (Objects.equals(projectbills.getStartDateEnd(), 5) || Objects.equals(projectbills.getStartDateEnd(), 6)) {
                result.addErrorMessage("撤回失败：已审批不可撤回");
                return result;
            }
            if (Objects.equals(projectbills.getStartDateEnd(), 2) || Objects.equals(projectbills.getStartDateEnd(), 3)) {
                result.addErrorMessage("撤回失败：未提交不可撤回");
                return result;
            }
            projectbills.setStartDateEnd(3);
            boolean update = projectbillsService.updateById(projectbills);
            if (!update) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("撤回失败: 更新竣工状态失败");
                return result;
            }
            int deleteNum = auditItemsService.deleteProjectApproval(projectBillsSubsDto);
            if (deleteNum == 0) {
                result.addErrorMessage("撤回失败: 未找到审批信息");
                return result;
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error("提交失败：" + e.toString(), e);
            result.addErrorMessage("提交失败：请检查提交信息重新提交");
        }
        return result;
    }

    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> withdrawalInvoiceCr(ProjectBillsSubsDto projectBillsSubsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            InvoiceBills invoiceBills = invoiceBillsService.selectById(projectBillsSubsDto.getId());
            if (Objects.equals(invoiceBills.getBillStatus(), 5) || Objects.equals(invoiceBills.getBillStatus(), 6)) {
                result.addErrorMessage("提交失败：已审批不可撤回");
                return result;
            }
            invoiceBills.setBillStatus(2);
            boolean updateById = invoiceBillsService.updateById(invoiceBills);
            if (!updateById) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("撤回失败: 修改状态失败");
                return result;
            }
            if (Objects.equals(projectBillsSubsDto.getActId(), 510) || Objects.equals(projectBillsSubsDto.getActId(), 520) || Objects.equals(projectBillsSubsDto.getActId(), 530)) {
                if (Objects.equals(projectBillsSubsDto.getActId(), 510)) {
                    EntityWrapper<SubContractBills> contractBillsEntityWrapper = new EntityWrapper<>();
                    contractBillsEntityWrapper.eq("contract_no", invoiceBills.getContractNo());
                    contractBillsEntityWrapper.eq("project_sub_no", invoiceBills.getProjectSubNo())
                            .eq("branch_id", invoiceBills.getBranchId());
                    SubContractBills subContractBills = subContractBillsService.selectOne(contractBillsEntityWrapper);
                    subContractBills.setSubInvAmtCr(Double.parseDouble(String.format("%.2f", subContractBills.getSubInvAmtCr() - invoiceBills.getInvAmt())));
                    subContractBills.setPurchaseNcNo(invoiceBills.getPurchaseNcNo());
                    boolean updateBySubCon = subContractBillsService.updateById(subContractBills);
                    if (!updateBySubCon) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：更新分包合同失败");
                        return result;
                    }
                }
                EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
                projectBillsBudgetsEntityWrapper.eq("project_sub_no", invoiceBills.getProjectSubNo())
                        .eq("branch_id", invoiceBills.getBranchId())
                        .eq("budget_id", invoiceBills.getBudgetId());
                ProjectBillsBudgets billsBudgets = projectBillsBudgetsService.selectOne(projectBillsBudgetsEntityWrapper);
                billsBudgets.setSubInvAmtCr(Double.parseDouble(String.format("%.2f", billsBudgets.getSubInvAmtCr() - invoiceBills.getInvAmt())));
                billsBudgets.setSubInvAmtBlc(Double.parseDouble(String.format("%.2f", billsBudgets.getBudgetAmt() - billsBudgets.getSubInvAmtCr())));
                boolean updateByBudget = projectBillsBudgetsService.updateById(billsBudgets);
                if (!updateByBudget) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交错误，更新预算失败");
                    return result;
                }
                EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
                projectBillsSubsEntityWrapper.eq("project_sub_no", invoiceBills.getProjectSubNo())
                        .eq("branch_id", invoiceBills.getBranchId());
                ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
                double sum = projectBillsBudgetsService.selectApprovedAmountSum(billsBudgets);
                projectBillsSubs.setActualBudgetAmt(sum);
                projectBillsSubs.setSubInvAmtCr(Double.parseDouble(String.format("%.2f", projectBillsSubs.getSubInvAmtCr() - invoiceBills.getInvAmt())));
                boolean updateBySubs = projectBillsSubsService.updateById(projectBillsSubs);
                if (!updateBySubs) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交错误，更新二级项目失败");
                    return result;
                }
            }
            if (Objects.equals(projectBillsSubsDto.getActId(), 520) || Objects.equals(projectBillsSubsDto.getActId(), 530)) {
                EntityWrapper<OtherProject> otherProjectEntityWrapper = new EntityWrapper<>();
                otherProjectEntityWrapper.eq("purchase_nc_no", invoiceBills.getPurchaseNcNo())
                        .eq("project_sub_no", invoiceBills.getProjectSubNo())
                        .eq("branch_id", invoiceBills.getBranchId());
                OtherProject otherProject = otherProjectService.selectOne(otherProjectEntityWrapper);
                otherProject.setContractTotalAmt(Double.parseDouble(String.format("%.2f", otherProject.getContractTotalAmt() - invoiceBills.getInvAmt())));
                boolean otherProjectType = otherProjectService.updateById(otherProject);
                if (!otherProjectType) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("撤回失败: 更新其他合同失败");
                    return result;
                }
                if ("F".equals(invoiceBills.getIsSur()) && Objects.equals(projectBillsSubsDto.getActId(), 520)) {
                    EntityWrapper<PurchaseBillsItems> itemsEntityWrapper = new EntityWrapper<>();
                    String beginTime = new String("2020-11-20 00:00:00");
                    SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                    Date sd1 = df.parse(beginTime);
                    long long1 = invoiceBills.getCreateDate().getTime();
                    long long2 = sd1.getTime();
                    // 2020-11-19 之前创建的
                    if (long1 < long2) {
                        itemsEntityWrapper.eq("bill_no", invoiceBills.getBillNo())
                                .eq("act_id", 9);
                    } else {
                        itemsEntityWrapper.eq("act_id", 4);
                    }
                    itemsEntityWrapper.eq("project_sub_no", invoiceBills.getProjectSubNo())
                            .eq("purchase_id", invoiceBills.getPurchaseId());
                    List<PurchaseBillsItems> purchaseBillsItemsList = purchaseBillsItemsService.selectList(itemsEntityWrapper);
                    for (PurchaseBillsItems billsItems : purchaseBillsItemsList) {
                        EntityWrapper<InvoicePurchase> purchaseEntityWrapper = new EntityWrapper<>();
                        purchaseEntityWrapper.eq("inv_id", invoiceBills.getId())
                                .eq("purchase_item_id", billsItems.getId());
                        InvoicePurchase invoicePurchase = invoicePurchaseService.selectOne(purchaseEntityWrapper);
                        if (invoicePurchase != null) {
                            billsItems.setTimeQty(invoicePurchase.getTimeQty());
                            billsItems.setTimeAmt(invoicePurchase.getTimeAmt());
                        }
                        billsItems.setInvTotalQty(billsItems.getInvTotalQty() - billsItems.getTimeQty());
                        billsItems.setInvTotalAmt(Double.parseDouble(String.format("%.2f", billsItems.getInvTotalAmt() - billsItems.getTimeAmt())));
                        boolean billType = purchaseBillsItemsService.updateById(billsItems);
                        if (!billType) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：更新累计开票失败");
                        }
                    }
                }
            }
            int deleteNum = auditItemsService.deleteInvoiceApproval(projectBillsSubsDto);
            if (deleteNum == 0) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("撤回失败: 未找到审批信息");
                return result;
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error("提交失败：" + e.toString(), e);
            result.addErrorMessage("提交失败：请检查提交信息重新提交");
        }
        return result;
    }

    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> withdrawalInvoiceSharesCr(ProjectBillsSubsDto projectBillsSubsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            InvoiceBills invoiceBills = invoiceBillsService.selectById(projectBillsSubsDto.getId());
            if (Objects.equals(invoiceBills.getBillStatus(), 5) || Objects.equals(invoiceBills.getBillStatus(), 6)) {
                result.addErrorMessage("提交失败：已审批不可撤回");
                return result;
            } else if (Objects.equals(invoiceBills.getBillStatus(), 2)) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("撤回失败: 未提交数据不可撤回");
                return result;
            }
            invoiceBills.setBillStatus(2);
            boolean updateById = invoiceBillsService.updateById(invoiceBills);
            if (!updateById) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("撤回失败: 修改状态失败");
                return result;
            }
            EntityWrapper<OtherProject> otherProjectEntityWrapper = new EntityWrapper<>();
            otherProjectEntityWrapper.eq("purchase_nc_no", invoiceBills.getPurchaseNcNo())
                    .eq("branch_id", invoiceBills.getBranchId());
            OtherProject otherProject = otherProjectService.selectOne(otherProjectEntityWrapper);
            otherProject.setContractTotalAmt(DataUtils.keepDecimals(otherProject.getContractTotalAmt() - invoiceBills.getInvAmt()));
            boolean updateByOther = otherProjectService.updateById(otherProject);
            if (!updateByOther) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("提交失败：更新其他合同失败。");
                return result;
            }
            List<InvoiceBillsShares> invoiceBillsShares = invoiceBillsSharesService.selectWithdrawalInvoShareList(invoiceBills);
            for (InvoiceBillsShares is : invoiceBillsShares) {
                EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
                projectBillsBudgetsEntityWrapper.eq("project_sub_no", is.getProjectSubNo())
                        .eq("budget_id", is.getBudgetId())
                        .eq("branch_id", invoiceBills.getBranchId());
                ProjectBillsBudgets billsBudgets = projectBillsBudgetsService.selectOne(projectBillsBudgetsEntityWrapper);
                billsBudgets.setBudgetUseAmt(DataUtils.keepDecimals(billsBudgets.getBudgetUseAmt() - is.getShareAmt()));
                billsBudgets.setSubInvAmtCr(DataUtils.keepDecimals(billsBudgets.getSubInvAmtCr() - is.getShareAmt()));
                if (billsBudgets.getSubInvAmtCr() > billsBudgets.getBudgetAmt()) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：" + billsBudgets.getBudgetName() + "已开发票金额超出预算金额");
                    return result;
                }
                boolean updateByBudget = projectBillsBudgetsService.updateById(billsBudgets);
                if (!updateByBudget) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：更新项目预算失败。");
                    return result;
                }
                EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
                projectBillsSubsEntityWrapper.eq("project_sub_no", is.getProjectSubNo())
                        .eq("branch_id", invoiceBills.getBranchId());
                ProjectBillsSubs billsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
                billsSubs.setSubInvAmtCr(DataUtils.keepDecimals(billsSubs.getSubInvAmtCr() - is.getShareAmt()));
                boolean updateByProSub = projectBillsSubsService.updateById(billsSubs);
                if (!updateByProSub) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：更新累计成本失败。");
                    return result;
                }
                projectBillsSubsDto.setBranchId(billsSubs.getApprovalBranchId());
                EntityWrapper<InvoiceBillsIndirect> invoiceBillsIndirectEntityWrapper = new EntityWrapper<>();
                invoiceBillsIndirectEntityWrapper.eq("project_sub_no", is.getProjectSubNo())
                        .eq("budget_id", is.getBudgetId())
                        .eq("purchase_id", invoiceBills.getPurchaseId());
                InvoiceBillsIndirect invoiceBillsIndirect = invoiceBillsIndirectService.selectOne(invoiceBillsIndirectEntityWrapper);
                invoiceBillsIndirect.setSubInvAmtCr(DataUtils.keepDecimals(invoiceBillsIndirect.getSubInvAmtCr() - is.getShareAmt()));
                boolean updateByInvIndirect = invoiceBillsIndirectService.updateById(invoiceBillsIndirect);
                if (!updateByInvIndirect) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    return result;
                }
            }
            int deleteNum = auditItemsService.deleteInvoiceShareApproval(projectBillsSubsDto);
            if (deleteNum == 0) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("撤回失败: 未找到审批信息");
                return result;
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error("提交失败：" + e.toString(), e);
            result.addErrorMessage("提交失败：请检查提交信息重新提交");
        }
        return result;
    }

    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> withdrawalPayCr(ProjectBillsSubsDto projectBillsSubsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            PayCrBills payCrBills = payCrBillsService.selectById(projectBillsSubsDto.getId());
            if (Objects.equals(payCrBills.getBillStatus(), 5) || Objects.equals(payCrBills.getBillStatus(), 6)) {
                result.addErrorMessage("审批撤回失败：已审批不可撤回");
                return result;
            }
            if (Objects.equals(payCrBills.getBillStatus(), 2)) {
                result.addErrorMessage("审批撤回失败：未提交数据不可撤回");
                return result;
            }
            EntityWrapper<ProjectBillsSubs> entityWrapper = new EntityWrapper<>();
            if (Objects.equals(projectBillsSubsDto.getActId(), 570)) {
                EntityWrapper<PayCrBillsShares> sharesEntityWrapper = new EntityWrapper<>();
                sharesEntityWrapper.eq("bill_no", payCrBills.getBillNo())
                        .eq("purcaser_id", payCrBills.getPurcaserId());
                List<PayCrBillsShares> payCrBillsShares = payCrBillsSharesService.selectList(sharesEntityWrapper);
                entityWrapper.eq("project_sub_no", payCrBillsShares.get(0).getProjectSubNo())
                        .eq("branch_id", payCrBills.getBranchId());
            } else {
                entityWrapper.eq("project_sub_no", payCrBills.getProjectSubNo())
                        .eq("branch_id", payCrBills.getBranchId());
            }
            ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(entityWrapper);
            projectBillsSubsDto.setBranchId(projectBillsSubs.getApprovalBranchId());
            int deleteNum = auditItemsService.deletePayCrApproval(projectBillsSubsDto);
            if (deleteNum == 0) {
                result.addErrorMessage("撤回失败: 未找到审批信息");
                return result;
            }
            payCrBills.setBillStatus(2);
            boolean updateById = payCrBillsService.updateById(payCrBills);
            if (!updateById) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("撤回失败: 修改状态失败");
                return result;
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error("提交失败：" + e.toString(), e);
            result.addErrorMessage("提交失败：请检查提交信息重新提交");
        }
        return result;
    }

    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> withdrawalAdjusts(ProjectBillsSubsDto projectBillsSubsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            ProjectBillsAdjusts payCrBills = projectBillsAdjustsService.selectById(projectBillsSubsDto.getId());
            if (Objects.equals(payCrBills.getBillStatus(), 5) || Objects.equals(payCrBills.getBillStatus(), 6)) {
                result.addErrorMessage("审批撤回失败：已审批不可撤回");
                return result;
            }
            int deleteNum = auditItemsService.deleteAdjusts(projectBillsSubsDto);
            if (deleteNum == 0) {
                result.addErrorMessage("撤回失败: 未找到审批信息");
                return result;
            }
            payCrBills.setBillStatus(3);
            boolean updateById = projectBillsAdjustsService.updateById(payCrBills);
            if (!updateById) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("撤回失败: 修改状态失败");
                return result;
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error("提交失败：" + e.toString(), e);
            result.addErrorMessage("提交失败：请检查提交信息重新提交");
        }
        return result;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> survivingProjectsSave(String projectBills, String projects, String costSituation, String projectBudgets, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            Projectbills projectbills = JSONArray.parseObject(projectBills, Projectbills.class);
            EntityWrapper<Projectbills> projectbillsWrapper = new EntityWrapper<>();
            projectbillsWrapper.eq("project_name", projectbills.getProjectName())
                    .eq("branch_id", projectbills.getBranchId())
                    .eq("is_sur", "T");
            if (projectbills.getId() != null) {
                projectbillsWrapper.ne("id", projectbills.getId());
            }
            List<Projectbills> projectbillsList = projectbillsService.selectList(projectbillsWrapper);
            if (projectbillsList.size() != 0) {
                result.addErrorMessage("该工程名称已被使用");
                return result;
            }
            Projectbills projectBill = JSONArray.parseObject(projects, Projectbills.class);
            if (projectbills != null) {
                Calendar cal = Calendar.getInstance();
                int year = cal.get(Calendar.YEAR);
                if (projectbills.getProjectNo() == null || "".equals(projectbills.getProjectNo())) {
                    String contractNo = null;
                    contractNo = this.updateProjectNo(projectbills);
                    if (contractNo != null) {
                        projectbills.setBillNo(projectbills.getBillNo().replaceAll("initial", ""));
                        projectbills.setProjectNo(contractNo);
                    } else {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：系统工程编号生成失败");
                        return result;
                    }
                }
                projectbills.setContractAmt(projectBill.getContractAmt());
                if (projectBill.getContractAuditAmt() != null && projectBill.getContractAuditAmt() != 0) {
                    projectbills.setSettlementStatus(6);
                    projectbills.setAmt(projectBill.getContractAuditAmt());
                } else {
                    if (projectBill.getContractAmt() == null || projectBill.getContractAmt() <= 0) {
                        projectbills.setContractAmt(projectBill.getEstimatedAmt());
                        projectbills.setAmt(projectBill.getEstimatedAmt());
                    } else {
                        projectbills.setAmt(projectBill.getContractAmt());
                    }
                }
                projectbills.setContractAuditAmt(projectBill.getContractAuditAmt());
                projectbills.setEstimatedAmt(projectBill.getEstimatedAmt());
                projectbills.setSettlementAmt(projectBill.getSettlementAmt());
                projectbills.setSubInvAmtCr(projectBill.getSubInvAmtCr());
                projectbills.setSubInvAmtBlc(Double.parseDouble(String.format("%.2f", projectBill.getSubInvAmtBlc())));
                projectbills.setSubAmtDr(projectBill.getSubAmtDr());
                projectbills.setSubAmtBlc(Double.parseDouble(String.format("%.2f", projectBill.getSubAmtBlc())));
                projectbills.setRemarks(projectBill.getRemarks());
                projectbills.setStartDateStatus(6);
                projectbills.setStartDateEnd(6);
                projectbills.setRenewProjectStatus(6);
                projectbills.setCreateDate(new Date());
                projectbills.setBillDate(new Date());
                projectbills.setBranchId(sysUserDto.getLoginContractorId());
                projectbills.setOpUserId(sysUserDto.getUserId().intValue());
                projectbills.setOpUserName(sysUserDto.getUsername());
                boolean update = projectbillsService.insertOrUpdate(projectbills);
                if (!update) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：操作总包失败");
                    return result;
                }
                String projectBillBackup = projectbills.getBillNo();
                String projectNoBackup = projectbills.getProjectNo();
                //系统工程编号 2种情况 null 或者  编号+（initial）
                if (projectbills.getProjectNo().indexOf("initial") == -1) {
                    projectbills.setProjectNo(projectbills.getProjectNo() + "initial");
                }
                if (projectbills.getBillNo().indexOf("initial") == -1) {
                    projectbills.setBillNo(projectbills.getBillNo() + "initial");
                }
                EntityWrapper<Projectbills> proEntity = new EntityWrapper<>();
                proEntity.eq("bill_no", projectbills.getBillNo())
                        .eq("project_no", projectbills.getProjectNo())
                        .eq("branch_id", projectbills.getBranchId());
                projectbillsService.delete(proEntity);
                projectbills.setId(null);
                projectbills.setIsSur("I");
                boolean updatePro = projectbillsService.insert(projectbills);
                if (!updatePro) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：操作总包失败");
                    return result;
                }
                Projectbills projectbillsCopy = new Projectbills();
                projectbillsCopy.setBillNo(projectbills.getBillNo());
                projectbillsCopy.setProjectNo(projectbills.getProjectNo());
                projectbillsCopy.setBranchId(projectbills.getBranchId());
                projectbillsCopy.setTaxRate(projectbills.getTaxRate());
                projectbillsCopy.setProjectName(projectbills.getProjectName());
                projectbillsCopy.setActStartDate(projectbills.getActStartDate());
                projectbillsCopy.setActEndDate(projectbills.getActEndDate());
                projectbillsCopy.setNcProjectNo(projectbills.getNcProjectNo());
                projectbillsCopy.setProjectCost(projectbills.getProjectCost());
                projectbillsCopy.setContractAmt(projectbills.getContractAmt());
                projectbillsCopy.setAmt(projectbills.getAmt());
                projectbillsCopy.setIsSur("I");
                projectbills.setBillNo(projectBillBackup);
                projectbills.setProjectNo(projectNoBackup);
                projectbills.setIsSur("T");
                // 添加任务
                EntityWrapper<Tasklists> tasklistsEntityWrapper = new EntityWrapper<>();
                tasklistsEntityWrapper.eq("bill_no", projectbills.getBillNo());
                int count = tasklistsService.selectCount(tasklistsEntityWrapper);
                if (count <= 0) {
                    Tasklists tasklists = new Tasklists();
                    tasklists.setBillNo(projectbills.getBillNo());
                    tasklists.setActId(10);
                    tasklists.setStatus(6);
                    tasklists.setOpUserId(sysUserDto.getUserId().intValue());
                    tasklists.setOpUserName(sysUserDto.getUsername());
                    boolean insert = tasklistsService.insertOrUpdate(tasklists);
                    if (!insert) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：创建任务失败");
                        return result;
                    }
                    tasklists.setActId(11);
                    boolean insertCnt = tasklistsService.insertOrUpdate(tasklists);
                    if (!insertCnt) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：创建任务失败");
                        return result;
                    }
                }
                // 添加分包合同
                double money = 0;
                double subAmtCr = 0.0;
                double subInvAmtCr = 0.0;
                JSONArray jsonArray = JSONArray.parseArray(costSituation);
                List<SubContractBills> subContractBillsList = JSONObject.parseArray(jsonArray.toJSONString(), SubContractBills.class);
                if (subContractBillsList.size() != 0) {
                    EntityWrapper<SubContractBills> subContractBillsEntityWrapper = new EntityWrapper<>();
                    subContractBillsEntityWrapper.eq("bill_no", projectbills.getBillNo())
                            .eq("project_sub_no", projectbills.getProjectNo())
                            .eq("branch_id", projectbills.getBranchId());
                    boolean delete = subContractBillsService.delete(subContractBillsEntityWrapper);
                    if (!delete) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：删除旧数据失败");
                        return result;
                    }
                    int line = 0;
                    for (SubContractBills sub : subContractBillsList) {
                        line++;
                        // 已付款金额
                        subAmtCr = Double.parseDouble(String.format("%.2f", (subAmtCr + sub.getSubAmtCr())));
                        // 已开发票金额
                        subInvAmtCr = Double.parseDouble(String.format("%.2f", (subInvAmtCr + sub.getSubInvAmtCr())));
                        sub.setBillNo(projectbills.getBillNo());
                        sub.setActId(100);
                        sub.setProjectSubNo(projectbills.getProjectNo());
                        sub.setIsSur("T");
                        sub.setBillStatus(6);
                        sub.setOpUserId(sysUserDto.getUserId().intValue());
                        sub.setOpUserName(sysUserDto.getUsername());
                        if (sub.getContractAuditAmt() != null && sub.getContractAuditAmt() != 0) {
                            sub.setSettlementStatus(6);
                            sub.setAmt(sub.getContractAuditAmt());
                        } else {
                            sub.setAmt(sub.getEstimatedAmt());
                        }
                        sub.setCreateDate(new Date());
                        sub.setBillDate(new Date());
                        sub.setPostDate(new Date());
                        sub.setBranchId(projectbills.getBranchId());
                        sub.setContractNo(projectbills.getProjectNo() + "-" + line);
                        sub.setContractName(projectbills.getProjectName());
                        sub.setPlanStartDate(projectbills.getActStartDate());
                        sub.setPlanEndDate(projectbills.getActEndDate());
                        sub.setPlanDays(projectbills.getActDays());
                        sub.setOpUserId(sysUserDto.getUserId().intValue());
                        sub.setOpUserName(sysUserDto.getUsername());
                        sub.setContractTaxRate(projectbills.getTaxRate());
                        // 生成工程采购编号
                        EntityWrapper<Dictionaries> entityWrapper = new EntityWrapper<>();
                        entityWrapper.eq("dictionaries_name", "cx_sub_contract_plan_no");
                        Dictionaries dictionariesNum = dictionariesService.selectOne(entityWrapper);
                        dictionariesNum.setDictionariesNumber(dictionariesNum.getDictionariesNumber() + 1);
                        String purchasePlanNo = "cx" + year + dictionariesNum.getDictionariesNumber();
                        sub.setPurchasePlanNo(purchasePlanNo);
                        boolean updateById = dictionariesService.updateById(dictionariesNum);
                        if (!updateById) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：更新字典集失败");
                            return result;
                        }
                        // 结算金额
                        money = Double.parseDouble(String.format("%.2f", (money + sub.getContractAmt())));
                        boolean insert = subContractBillsService.insert(sub);
                        if (!insert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：新建分包合同失败");
                            return result;
                        }
                    }
                    // 备用数据
                    EntityWrapper<SubContractBills> contractBillsEntityWrapper = new EntityWrapper<>();
                    contractBillsEntityWrapper.eq("bill_no", projectbillsCopy.getBillNo())
                            .eq("project_sub_no", projectbillsCopy.getProjectNo())
                            .eq("branch_id", projectbillsCopy.getBranchId());
                    boolean deleteSubContr = subContractBillsService.delete(contractBillsEntityWrapper);
                    if (!deleteSubContr) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：删除旧数据失败");
                        return result;
                    }
                    int lineBackup = 0;
                    for (SubContractBills sub : subContractBillsList) {
                        lineBackup++;
                        sub.setId(null);
                        sub.setBillNo(projectbillsCopy.getBillNo());
                        sub.setProjectSubNo(projectbillsCopy.getProjectNo());
                        sub.setIsSur("I");
                        sub.setBranchId(projectbillsCopy.getBranchId());
                        sub.setContractNo(projectbillsCopy.getProjectNo() + "-" + lineBackup);
                        sub.setContractName(projectbillsCopy.getProjectName());
                        sub.setPlanStartDate(projectbillsCopy.getActStartDate());
                        sub.setPlanEndDate(projectbillsCopy.getActEndDate());
                        sub.setPlanDays(projectbillsCopy.getActDays());
                        sub.setContractTaxRate(projectbillsCopy.getTaxRate());
                        // 结算金额
                        boolean insert = subContractBillsService.insert(sub);
                        if (!insert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：新建分包合同失败");
                            return result;
                        }
                    }
                    // 插入 项目预算
                    EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
                    projectBillsBudgetsEntityWrapper.eq("bill_no", projectbills.getBillNo())
                            .eq("budget_id", 1)
                            .eq("project_sub_no", projectbills.getProjectNo())
                            .eq("branch_id", projectbills.getBranchId());
                    boolean delete1 = projectBillsBudgetsService.delete(projectBillsBudgetsEntityWrapper);
                    if (!delete1) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：删除工程旧数据失败");
                        return result;
                    }
                    // 备份数据
                    EntityWrapper<ProjectBillsBudgets> billsBudgeEnw = new EntityWrapper<>();
                    billsBudgeEnw.eq("bill_no", projectbillsCopy.getBillNo())
                            .eq("budget_id", 1)
                            .eq("project_sub_no", projectbillsCopy.getProjectNo())
                            .eq("branch_id", projectbillsCopy.getBranchId());
                    boolean deleteSubBudget = projectBillsBudgetsService.delete(billsBudgeEnw);
                    if (!deleteSubBudget) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：删除工程旧数据失败");
                        return result;
                    }
                    // 生成一条工程款预算项目
                    ProjectBillsBudgets billsBudgets = new ProjectBillsBudgets();
                    billsBudgets.setBillNo(projectbills.getBillNo());
                    billsBudgets.setProjectSubNo(projectbills.getProjectNo());
                    billsBudgets.setBudgetId(1);
                    billsBudgets.setBranchId(projectbills.getBranchId());
                    billsBudgets.setBudgetName("工程款");
                    billsBudgets.setBudgetAmt(money);
                    billsBudgets.setSubInvAmtCr(subInvAmtCr);
                    billsBudgets.setSubInvAmtBlc(Double.parseDouble(String.format("%.2f", (billsBudgets.getBudgetAmt() - subInvAmtCr))));
                    billsBudgets.setSubAmtCr(subAmtCr);
                    billsBudgets.setSubAmtBlc(Double.parseDouble(String.format("%.2f", (subInvAmtCr - subAmtCr))));
                    boolean insert = projectBillsBudgetsService.insert(billsBudgets);
                    if (!insert) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：新建工程成本失败");
                        return result;
                    }
                    // 备份
                    billsBudgets.setId(null);
                    billsBudgets.setBillNo(projectbillsCopy.getBillNo());
                    billsBudgets.setProjectSubNo(projectbillsCopy.getProjectNo());
                    billsBudgets.setBranchId(projectbillsCopy.getBranchId());
                    boolean insertSubBudget = projectBillsBudgetsService.insert(billsBudgets);
                    if (!insertSubBudget) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：新建工程成本失败");
                        return result;
                    }
                }
                // 添加预算成本
                JSONArray array = JSONArray.parseArray(projectBudgets);
                List<ProjectBillsBudgets> projectBillsBudgetsList = JSONObject.parseArray(array.toJSONString(), ProjectBillsBudgets.class);
                if (projectBillsBudgetsList.size() != 0) {
                    EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
                    projectBillsBudgetsEntityWrapper.eq("bill_no", projectbills.getBillNo())
                            .ne("budget_id", 1)
                            .eq("project_sub_no", projectbills.getProjectNo())
                            .eq("branch_id", projectbills.getBranchId());
                    boolean delete1 = projectBillsBudgetsService.delete(projectBillsBudgetsEntityWrapper);
                    if (!delete1) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：删除工程旧数据失败");
                        return result;
                    }
                    EntityWrapper<ProjectBillsBudgets> backupEntityWrapper = new EntityWrapper<>();
                    backupEntityWrapper.eq("bill_no", projectbillsCopy.getBillNo())
                            .ne("budget_id", 1)
                            .eq("project_sub_no", projectbillsCopy.getProjectNo())
                            .eq("branch_id", projectbillsCopy.getBranchId());
                    boolean deleteBudgetBackup = projectBillsBudgetsService.delete(backupEntityWrapper);
                    if (!deleteBudgetBackup) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：删除工程旧数据失败");
                        return result;
                    }
                    int line = 0;
                    for (ProjectBillsBudgets sub : projectBillsBudgetsList) {
                        line++;
                        // 已付款金额
                        subAmtCr += sub.getSubAmtCr();
                        // 已开发票金额
                        subInvAmtCr += sub.getSubInvAmtCr();
                        sub.setBudgetAmt(sub.getSettlementAmt());
                        sub.setBillNo(projectbills.getBillNo());
                        sub.setLineNo(line);
                        sub.setBranchId(projectbills.getBranchId());
                        sub.setProjectSubNo(projectbills.getProjectNo());
                        if (Objects.equals(sub.getBudgetId(), 2)) {
                            sub.setApprovedAmount(sub.getSubInvAmtCr());
                        }
                        boolean insert = projectBillsBudgetsService.insert(sub);
                        if (!insert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：新建成本预算失败");
                            return result;
                        }
                    }
                    // 备份
                    int lineBackup = 0;
                    for (ProjectBillsBudgets sub : projectBillsBudgetsList) {
                        lineBackup++;
                        sub.setId(null);
                        sub.setBillNo(projectbillsCopy.getBillNo());
                        sub.setLineNo(lineBackup);
                        sub.setBranchId(projectbillsCopy.getBranchId());
                        sub.setProjectSubNo(projectbillsCopy.getProjectNo());
                        if (Objects.equals(sub.getBudgetId(), 2)) {
                            sub.setApprovedAmount(sub.getSubInvAmtCr());
                        }
                        boolean insert = projectBillsBudgetsService.insert(sub);
                        if (!insert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：新建成本预算失败");
                            return result;
                        }
                    }
                }
                // 添加 二级项目
                ProjectBillsSubs proSub = new ProjectBillsSubs();
                EntityWrapper<ProjectBillsSubs> subsEntityWrapper = new EntityWrapper<>();
                subsEntityWrapper.setSqlSelect("id").eq("bill_no", projectbills.getBillNo())
                        .eq("project_sub_no", projectbills.getProjectNo())
                        .eq("if_project_sub", "F")
                        .eq("is_sur", projectbills.getIsSur())
                        .eq("branch_id", projectbills.getBranchId());
                ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(subsEntityWrapper);
                if (projectBillsSubs != null) {
                    proSub.setId(projectBillsSubs.getId());
                }
                proSub.setBillNo(projectbills.getBillNo());
                proSub.setActId(103);
                proSub.setLineNo(1);
                proSub.setProjectSubNo(projectbills.getProjectNo());
                proSub.setBillStatus(6);
                proSub.setIfProjectSub("F");
                proSub.setIsSur(projectbills.getIsSur());
                proSub.setNcProjectNo(projectbills.getNcProjectNo());
                proSub.setProjectSubNo(projectbills.getProjectNo());
                proSub.setProjectSubName(projectbills.getProjectName());
                proSub.setBranchId(projectbills.getBranchId());
                proSub.setApprovalBranchId(projectbills.getApprovalBranchId());
                proSub.setContractAmt(projectbills.getContractAmt());
                proSub.setAmt(projectbills.getAmt());
                proSub.setProjectBudgetStatus(6);
                proSub.setBudgetCreateDate(new Date());
                proSub.setBudgetOrgDate(new Date());
                proSub.setBudgetAmt(projectbills.getProjectCost());
                proSub.setBudgetProfit(Double.parseDouble(String.format("%.2f", (proSub.getAmt() - proSub.getBudgetAmt()))));
                proSub.setBudgetProfitRate((double) Math.round((proSub.getBudgetProfit() / proSub.getAmt()) * 100));
                proSub.setBudgetUserName(sysUserDto.getUsername());
                proSub.setProjectStepsStatus(6);
                proSub.setCorpId(projectbills.getCorpId());
                proSub.setProjectStatus(30);
                proSub.setCreateData(new Date());
                proSub.setCreateUserId(sysUserDto.getUserId().intValue());
                proSub.setProjectWorkRate(100.0);
                proSub.setCurrentProgress(100.0);
                proSub.setProjectSubMngId(projectbills.getProjectMngId());
                proSub.setProjectSubMngDeptId(projectbills.getProjectMngDeptId());
                proSub.setSubInvAmtDr(projectbills.getSubInvAmtCr());
                proSub.setSubAmtDr(projectbills.getSubAmtDr());
                // 存续项目付款金额可以超过收款
//                if (proSub.getSubAmtDr() < subAmtCr) {
//                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
//                    result.addErrorMessage("提交失败：付款金额不得超过收款金额");
//                    return result;
//                }
                proSub.setSubAmtCr(subAmtCr);
                proSub.setSubInvAmtCr(subInvAmtCr);
                boolean proSubInsert = projectBillsSubsService.insertOrUpdate(proSub);
                if (!proSubInsert) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：新增子项目失败");
                    return result;
                }
                // 备份
                EntityWrapper<ProjectBillsSubs> subsEntityWrapperBackup = new EntityWrapper<>();
                subsEntityWrapperBackup.setSqlSelect("id").eq("bill_no", projectbillsCopy.getBillNo())
                        .eq("project_sub_no", projectbillsCopy.getProjectNo())
                        .eq("if_project_sub", "F")
                        .eq("is_sur", "I")
                        .eq("branch_id", projectbillsCopy.getBranchId());
                ProjectBillsSubs projectBillsSubsBackup = projectBillsSubsService.selectOne(subsEntityWrapperBackup);
                if (projectBillsSubsBackup != null) {
                    proSub.setId(projectBillsSubsBackup.getId());
                } else {
                    proSub.setId(null);
                }
                proSub.setBillNo(projectbillsCopy.getBillNo());
                proSub.setProjectSubNo(projectbillsCopy.getProjectNo());
                proSub.setIsSur(projectbillsCopy.getIsSur());
                proSub.setNcProjectNo(projectbillsCopy.getNcProjectNo());
                proSub.setProjectSubNo(projectbillsCopy.getProjectNo());
                proSub.setProjectSubName(projectbillsCopy.getProjectName());
                proSub.setBranchId(projectbillsCopy.getBranchId());
                proSub.setContractAmt(projectbillsCopy.getContractAmt());
                proSub.setAmt(projectbillsCopy.getAmt());
                proSub.setBudgetAmt(projectbillsCopy.getProjectCost());
                boolean proSubInsertBackup = projectBillsSubsService.insertOrUpdate(proSub);
                if (!proSubInsertBackup) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：新增子项目失败");
                    return result;
                }
            } else {
                result.addErrorMessage("提交失败：未找到项目信息，请检查提交信息重新提交");
                return result;
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error("提交失败：" + e.toString(), e);
            result.addErrorMessage("提交失败：请检查提交信息重新提交");
        }
        return result;
    }

    @Transactional(rollbackFor = Exception.class)
    public String updateProjectNo(Projectbills projectbills) {
        Calendar cal = Calendar.getInstance();
        int year = cal.get(Calendar.YEAR);
        String contractNo = null;
        EntityWrapper<BprojectTypes> bprojectTypesEntityWrapper = new EntityWrapper<>();
        bprojectTypesEntityWrapper.setSqlSelect("id", "project_type_no").eq("id", projectbills.getProjectTypeId());
        BprojectTypes bprojectTypes = bprojectTypesService.selectOne(bprojectTypesEntityWrapper);
        if (bprojectTypes == null) {
            bprojectTypes = new BprojectTypes();
            bprojectTypes.setProjectTypeNo("XX");
        }
        EntityWrapper<BprojectTypesItems> bprojectTypesItemsEntityWrapper = new EntityWrapper<>();
        bprojectTypesItemsEntityWrapper.setSqlSelect("id", "project_type_item_no").eq("id", projectbills.getProjectTypeItemId());
        BprojectTypesItems bprojectTypesItems = bprojectTypesItemsService.selectOne(bprojectTypesItemsEntityWrapper);
        if (bprojectTypesItems == null) {
            bprojectTypesItems = new BprojectTypesItems();
            bprojectTypesItems.setProjectTypeItemNo("XX");
        }
        EntityWrapper<Bbranchs> bbranchsEntityWrapper = new EntityWrapper<>();
        bbranchsEntityWrapper.setSqlSelect("id", "branch_no").eq("id", projectbills.getBranchId());
        Bbranchs bbranchs = bbranchsService.selectOne(bbranchsEntityWrapper);
        EntityWrapper<Dictionaries> dictionariesEntityWrapper = new EntityWrapper<>();
        dictionariesEntityWrapper.setSqlSelect("id", "dictionaries_number").eq("dictionaries_name", "RN");
        Dictionaries dictionaries = dictionariesService.selectOne(dictionariesEntityWrapper);
        if (dictionaries == null) {
            dictionaries = new Dictionaries();
            dictionaries.setDictionariesName("RN");
            dictionaries.setDictionariesNumber(0);
            dictionariesService.insert(dictionaries);
        }
        String number = null;
        dictionaries.setDictionariesNumber(dictionaries.getDictionariesNumber() + 1);
        if (dictionaries.getDictionariesNumber() + 1 >= 10) {
            number = "0" + dictionaries.getDictionariesNumber();
        } else if (dictionaries.getDictionariesNumber() <= 9) {
            number = "00" + dictionaries.getDictionariesNumber();
        } else {
            number = "" + dictionaries.getDictionariesNumber();
        }
        contractNo = "CX-" + year + "" + bprojectTypes.getProjectTypeNo() + "" + bprojectTypesItems.getProjectTypeItemNo() + "" + bbranchs.getBranchNo()
                + number;
        for (;;) {
            if (this.selectProjectNo(contractNo, projectbills)) {
                break;
            } else {
                dictionaries.setDictionariesNumber(dictionaries.getDictionariesNumber() + 1);
                if (dictionaries.getDictionariesNumber() + 1 >= 10) {
                    number = "0" + dictionaries.getDictionariesNumber();
                } else if (dictionaries.getDictionariesNumber() <= 9) {
                    number = "00" + dictionaries.getDictionariesNumber();
                } else {
                    number = "" + dictionaries.getDictionariesNumber();
                }
                contractNo = "CX-" + year + "" + bprojectTypes.getProjectTypeNo() + "" + bprojectTypesItems.getProjectTypeItemNo() + "" + bbranchs.getBranchNo()
                        + number;
            }
        }
        boolean update = dictionariesService.updateById(dictionaries);
        if (!update) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return null;
        }
        return contractNo;
    }

    public boolean selectProjectNo (String contractNo, Projectbills projectbills) {
        EntityWrapper<Projectbills> entityWrapper = new EntityWrapper<>();
        entityWrapper.eq("project_no", contractNo);
        int count = projectbillsService.selectCount(entityWrapper);
        if (count > 0) {
            return false;
        }
        return true;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> survivingProjectsModifyCommit(String projectBills, String projects, String costSituation,
                                                               String projectBudgets, String backupData, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            Projectbills projectbills = JSONArray.parseObject(projectBills, Projectbills.class);
            EntityWrapper<Projectbills> projectbillsWrapper = new EntityWrapper<>();
            projectbillsWrapper.eq("project_name", projectbills.getProjectName())
                    .eq("branch_id", projectbills.getBranchId())
                    .eq("is_sur", "T");
            if (projectbills.getId() != null) {
                projectbillsWrapper.ne("id", projectbills.getId());
            }
            List<Projectbills> projectbillsList = projectbillsService.selectList(projectbillsWrapper);
            if (projectbillsList.size() != 0) {
                result.addErrorMessage("该工程名称已被使用");
                return result;
            }
            Projectbills projectBill = JSONArray.parseObject(projects, Projectbills.class);
            if (projectbills != null) {
                projectbills.setContractAmt(projectBill.getContractAmt());
                if (projectBill.getContractAuditAmt() != null && projectBill.getContractAuditAmt() != 0
                        && projectBill.getEstimatedAmt() == 0) {
                    projectbills.setSettlementStatus(6);
                    projectbills.setAmt(projectBill.getContractAuditAmt());
                } else {
                    if (projectBill.getContractAmt() <= 0) {
                        projectbills.setAmt(projectBill.getEstimatedAmt());
                        projectbills.setContractAmt(projectBill.getEstimatedAmt());
                    } else {
                        projectbills.setAmt(projectBill.getContractAmt());
                    }
                }
                projectbills.setEstimatedAmt(projectBill.getEstimatedAmt());
                if (projectBill.getContractAuditAmt() != null) {
                    projectbills.setContractAuditAmt(projectBill.getContractAuditAmt());
                }
                projectbills.setSettlementAmt(projectBill.getSettlementAmt());
                projectbills.setSubInvAmtCr(projectBill.getSubInvAmtCr());
                projectbills.setSubInvAmtBlc(Double.parseDouble(String.format("%.2f", projectBill.getSubInvAmtBlc())));
                projectbills.setSubAmtDr(projectBill.getSubAmtDr());
                projectbills.setSubAmtBlc(Double.parseDouble(String.format("%.2f", projectBill.getSubAmtBlc())));
                projectbills.setRemarks(projectBill.getRemarks());
                projectbills.setStartDateStatus(6);
                projectbills.setStartDateEnd(6);
                projectbills.setRenewProjectStatus(6);
                projectbills.setCreateDate(new Date());
                projectbills.setBillDate(new Date());
                projectbills.setOpUserId(sysUserDto.getUserId().intValue());
                projectbills.setOpUserName(sysUserDto.getUsername());
                // 添加分包合同
                double money = 0;
                double subAmtCr = 0.0;
                double subInvAmtCr = 0.0;
                JSONArray jsonArray = JSONArray.parseArray(costSituation);
                List<SubContractBills> subContractBillsList = JSONObject.parseArray(jsonArray.toJSONString(), SubContractBills.class);
                if (subContractBillsList.size() != 0) {
                    EntityWrapper<SubContractBills> subContractBillsEntityWrapper = new EntityWrapper<>();
                    subContractBillsEntityWrapper.eq("bill_no", projectbills.getBillNo())
                            .eq("project_sub_no", projectbills.getProjectNo())
                            .eq("branch_id", projectbills.getBranchId());
                    List<SubContractBills> subContractBills = subContractBillsService.selectList(subContractBillsEntityWrapper);
                    int line = 0;
                    Calendar cal = Calendar.getInstance();
                    int year = cal.get(Calendar.YEAR);
                    for (SubContractBills sub : subContractBillsList) {
                        line++;
                        // 结算金额
                        money = Double.parseDouble(String.format("%.2f", (money + sub.getSettlementAmt())));
                        // 已付款金额
                        subAmtCr = Double.parseDouble(String.format("%.2f", (subAmtCr + sub.getSubAmtCr())));
                        // 已开发票金额
                        subInvAmtCr = Double.parseDouble(String.format("%.2f", (subInvAmtCr + sub.getSubInvAmtCr())));
                        if (sub.getId() != null) {
                            if (sub.getContractAuditAmt() != null && sub.getContractAuditAmt() > 0) {
                                sub.setAmt(sub.getContractAuditAmt());
                            } else {
                                sub.setAmt(sub.getContractAmt());
                            }
                            boolean insert = subContractBillsService.updateById(sub);
                            if (!insert) {
                                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                result.addErrorMessage("提交失败：更新分包合同失败");
                                return result;
                            }
                            for (int i = 0; i < subContractBills.size(); i++) {
                                if (Objects.equals(subContractBills.get(i).getId(), sub.getId())) {
                                    subContractBills.remove(i);
                                    break;
                                }
                            }
                        } else {
                            sub.setBillNo(projectbills.getBillNo());
                            sub.setProjectSubNo(projectbills.getProjectNo());
                            sub.setBranchId(projectbills.getBranchId());
                            sub.setContractNo(projectbills.getProjectNo() + "-" + line);
                            sub.setContractName(projectbills.getProjectName());
                            sub.setPlanStartDate(projectbills.getActStartDate());
                            sub.setPlanEndDate(projectbills.getActEndDate());
                            sub.setPlanDays(projectbills.getActDays());
                            if (sub.getContractAuditAmt() != null && sub.getContractAuditAmt() != 0 && sub.getEstimatedAmt() == 0) {
                                sub.setSettlementStatus(6);
                                sub.setAmt(sub.getContractAuditAmt());
                            } else {
                                sub.setAmt(projectBill.getContractAmt());
                            }
                            sub.setContractTaxRate(projectbills.getTaxRate());
                            // 结算金额
                            if (sub.getContractAuditAmt() != null) {
                                sub.setContractAuditAmt(sub.getContractAuditAmt());
                            }
                            sub.setActId(100);
                            sub.setIsSur("T");
                            sub.setBillStatus(6);
                            sub.setOpUserId(sysUserDto.getUserId().intValue());
                            sub.setOpUserName(sysUserDto.getUsername());
                            if (sub.getContractAuditAmt() != null && sub.getContractAuditAmt() != 0 && sub.getEstimatedAmt() == 0) {
                                sub.setSettlementStatus(6);
                                sub.setAmt(sub.getContractAuditAmt());
                            } else {
                                sub.setAmt(sub.getContractAmt());
                            }
                            sub.setCreateDate(new Date());
                            sub.setBillDate(new Date());
                            sub.setPostDate(new Date());
                            sub.setBranchId(projectbills.getBranchId());
                            // 生成工程采购编号
                            EntityWrapper<Dictionaries> entityWrapper = new EntityWrapper<>();
                            entityWrapper.eq("dictionaries_name", "cx_sub_contract_plan_no");
                            Dictionaries dictionariesNum = dictionariesService.selectOne(entityWrapper);
                            dictionariesNum.setDictionariesNumber(dictionariesNum.getDictionariesNumber() + 1);
                            String purchasePlanNo = "cx" + year + dictionariesNum.getDictionariesNumber();
                            sub.setPurchasePlanNo(purchasePlanNo);
                            boolean updateById = dictionariesService.updateById(dictionariesNum);
                            if (!updateById) {
                                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                result.addErrorMessage("提交失败：更新字典集失败");
                                return result;
                            }
                            boolean insert = subContractBillsService.insert(sub);
                            if (!insert) {
                                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                result.addErrorMessage("提交失败：新建分包合同失败");
                                return result;
                            }
                        }
                    }
                    for (SubContractBills scb : subContractBills) {
                        boolean insert = subContractBillsService.deleteById(scb.getId());
                        if (!insert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：删除分包合同失败");
                            return result;
                        }
                    }
                    String format = String.format("%.2f", money);
                    money = Double.parseDouble(format);
                }
                // 插入 项目预算
                EntityWrapper<ProjectBillsBudgets> billsBudgetsEntityWrapper = new EntityWrapper<>();
                billsBudgetsEntityWrapper.eq("bill_no", projectbills.getBillNo())
                        .eq("project_sub_no", projectbills.getProjectNo())
                        .eq("budget_id", 1)
                        .eq("branch_id", projectbills.getBranchId());
                ProjectBillsBudgets billsBudgets = projectBillsBudgetsService.selectOne(billsBudgetsEntityWrapper);
                if (billsBudgets != null) {
                    billsBudgets.setBudgetAmt(money);
                    billsBudgets.setSubInvAmtCr(subInvAmtCr);
                    if (money > 0) {
                        billsBudgets.setSubInvAmtBlc(billsBudgets.getBudgetAmt() - subInvAmtCr);
                    } else {
                        billsBudgets.setSubInvAmtBlc(0.00);
                    }
                    billsBudgets.setSubAmtCr(subAmtCr);
                    if (subAmtCr > 0) {
                        billsBudgets.setSubAmtBlc(Double.parseDouble(String.format("%.2f", (money - subAmtCr))));
                    } else {
                        billsBudgets.setSubAmtBlc(0.00);
                    }
                    boolean insert = projectBillsBudgetsService.updateById(billsBudgets);
                    if (!insert) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：新建工程成本失败");
                        return result;
                    }
                } else {
                    ProjectBillsBudgets budgets = new ProjectBillsBudgets();
                    budgets.setBillNo(projectbills.getBillNo());
                    budgets.setLineNo(0);
                    budgets.setBudgetId(1);
                    budgets.setBudgetName("工程款");
                    budgets.setProjectSubNo(projectbills.getProjectNo());
                    budgets.setBudgetAmt(money);
                    budgets.setSubInvAmtCr(subInvAmtCr);
                    if (money > 0) {
                        budgets.setSubInvAmtBlc(Double.parseDouble(String.format("%.2f", (budgets.getBudgetAmt() - subInvAmtCr))));
                    } else {
                        budgets.setSubInvAmtBlc(0.00);
                    }
                    budgets.setSubAmtCr(subAmtCr);
                    if (subAmtCr > 0) {
                        budgets.setSubAmtBlc(Double.parseDouble(String.format("%.2f", (money - subAmtCr))));
                    } else {
                        budgets.setSubAmtBlc(0.00);
                    }
                    budgets.setBranchId(projectbills.getBranchId());
                    boolean insert = projectBillsBudgetsService.insert(budgets);
                    if (!insert) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：新建工程成本失败");
                        return result;
                    }
                }
                // 添加预算成本
                JSONArray array = JSONArray.parseArray(projectBudgets);
                List<ProjectBillsBudgets> projectBillsBudgetsList = JSONObject.parseArray(array.toJSONString(), ProjectBillsBudgets.class);
                EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
                projectBillsBudgetsEntityWrapper.eq("project_sub_no", projectbills.getProjectNo())
                        .ne("budget_id", 1)
                        .eq("branch_id", projectbills.getBranchId());
                boolean delete = projectBillsBudgetsService.delete(projectBillsBudgetsEntityWrapper);
                if (!delete) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：删除旧数据失败");
                    return result;
                }
                if (projectBillsBudgetsList.size() != 0) {
                    int line = 0;
                    for (ProjectBillsBudgets sub : projectBillsBudgetsList) {
                        line++;
                        // 结算金额
                        money = Double.parseDouble(String.format("%.2f", (money + sub.getSettlementAmt())));
                        // 已付款金额
                        subAmtCr = Double.parseDouble(String.format("%.2f", (subAmtCr + sub.getSubAmtCr())));
                        // 已开发票金额
                        subInvAmtCr = Double.parseDouble(String.format("%.2f", (subInvAmtCr + sub.getSubInvAmtCr())));
                        sub.setBillNo(projectbills.getBillNo());
                        sub.setLineNo(line);
                        sub.setProjectSubNo(projectbills.getProjectNo());
                        if (Objects.equals(sub.getBudgetId(), 2)) {
                            sub.setApprovedAmount(sub.getSubInvAmtCr());
                        }
                        sub.setBudgetAmt(sub.getSettlementAmt());
                        sub.setBranchId(projectbills.getBranchId());
                        boolean insert = projectBillsBudgetsService.insert(sub);
                        if (!insert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：新建成本预算失败");
                            return result;
                        }
                    }
                    String format = String.format("%.2f", money);
                    money = Double.parseDouble(format);
                }
                // 添加 二级项目
                EntityWrapper<ProjectBillsSubs> subsEntityWrapper = new EntityWrapper<>();
                subsEntityWrapper.eq("bill_no", projectbills.getBillNo())
                        .eq("project_sub_no", projectbills.getProjectNo())
                        .eq("if_project_sub", "F")
                        .eq("is_sur", projectbills.getIsSur())
                        .eq("branch_id", projectbills.getBranchId());
                ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(subsEntityWrapper);
                projectBillsSubs.setContractAmt(projectbills.getContractAmt());
                projectBillsSubs.setNcProjectNo(projectbills.getNcProjectNo());
                projectBillsSubs.setApprovalBranchId(projectbills.getApprovalBranchId());
                projectBillsSubs.setProjectSubNo(projectbills.getProjectNo());
                projectBillsSubs.setProjectSubName(projectbills.getProjectName());
                projectBillsSubs.setCorpId(projectbills.getCorpId());
                projectBillsSubs.setContractAuditAmt(projectbills.getContractAuditAmt());
                projectBillsSubs.setProjectSubMngId(projectbills.getProjectMngId());
                projectBillsSubs.setProjectSubMngDeptId(projectbills.getProjectMngDeptId());
                projectBillsSubs.setAmt(projectbills.getAmt());
                projectBillsSubs.setBudgetAmt(money);
                projectBillsSubs.setBudgetProfit(Double.parseDouble(String.format("%.2f", (projectBillsSubs.getAmt() - projectBillsSubs.getBudgetAmt()))));
                projectBillsSubs.setBudgetProfitRate((double) Math.round((projectBillsSubs.getBudgetProfit() / projectBillsSubs.getAmt()) * 100));
                projectBillsSubs.setSubInvAmtDr(projectbills.getSubInvAmtCr());
                projectBillsSubs.setSubAmtDr(projectbills.getSubAmtDr());
                // 存续项目付款金额可以超过收款
//                if (projectBillsSubs.getSubAmtDr() < subAmtCr) {
//                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
//                    result.addErrorMessage("提交失败：付款金额不得超过收款金额");
//                    return result;
//                }
                projectBillsSubs.setSubAmtCr(subAmtCr);
                projectBillsSubs.setSubInvAmtCr(subInvAmtCr);
                boolean proSubInsert = projectBillsSubsService.updateById(projectBillsSubs);
                if (!proSubInsert) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：新增子项目失败");
                    return result;
                }
                projectbills.setProjectCost(money);
                boolean update = projectbillsService.updateById(projectbills);
                if (!update) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：操作总包失败");
                    return result;
                }
            } else {
                result.addErrorMessage("提交失败：未找到项目信息，请检查提交信息重新提交");
                return result;
            }
            ProjectBillsHistory history = JSONArray.parseObject(backupData, ProjectBillsHistory.class);
            history.setSerialNumber(Getnum());
            boolean flag = projectBillsHistoryService.insert(history);
            if (!flag) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("提交失败：请检查提交信息重新提交");
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error("提交失败：" + e.toString(), e);
            result.addErrorMessage("提交失败：请检查提交信息重新提交");
        }
        return result;
    }
    /*审批版本*/
    /*@Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> survivingProjectsModifyCommit(String projectBills, String projects, String costSituation,
                                                               String projectBudgets, String backupData, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            Projectbills projectbills = JSONArray.parseObject(projectBills, Projectbills.class);
            Projectbills projectBill = JSONArray.parseObject(projects, Projectbills.class);
            if (projectbills != null) {
                projectbills.setContractAmt(projectBill.getContractAmt());
                if (projectBill.getContractAuditAmt() != null && projectBill.getContractAuditAmt() != 0
                        && projectBill.getEstimatedAmt() == 0) {
                    projectbills.setSettlementStatus(6);
                    projectbills.setAmt(projectBill.getContractAuditAmt());
                } else {
                    if (projectBill.getContractAmt() <= 0) {
                        projectbills.setAmt(projectBill.getEstimatedAmt());
                    } else {
                        projectbills.setAmt(projectBill.getContractAmt());
                    }
                }
                projectbills.setEstimatedAmt(projectBill.getEstimatedAmt());
                if (projectBill.getContractAuditAmt() != null) {
                    projectbills.setContractAuditAmt(projectBill.getContractAuditAmt());
                }
                projectbills.setSettlementAmt(projectBill.getSettlementAmt());
                projectbills.setSubInvAmtCr(projectBill.getSubInvAmtCr());
                projectbills.setSubInvAmtBlc(projectBill.getSubInvAmtBlc());
                projectbills.setSubAmtDr(projectBill.getSubAmtDr());
                projectbills.setSubAmtBlc(projectBill.getSubAmtBlc());
                projectbills.setRemarks(projectBill.getRemarks());
                projectbills.setStartDateStatus(6);
                projectbills.setStartDateEnd(6);
                projectbills.setRenewProjectStatus(5);
                projectbills.setCreateDate(new Date());
                projectbills.setBillDate(new Date());
                projectbills.setOpUserId(sysUserDto.getUserId().intValue());
                projectbills.setOpUserName(sysUserDto.getUsername());
                boolean update = projectbillsService.updateById(projectbills);
                if (!update) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：操作总包失败");
                    return result;
                }
                Audit audit = new Audit();
                audit.setBillNo(projectbills.getBillNo());
                audit.setActId(710);
                audit.setLevelId(0);
                audit.setIffinalItem("F");
                audit.setSubJect(projectbills.getProjectName());
                audit.setProjectNo(projectbills.getProjectNo());
                audit.setBranchId(projectbills.getBranchId());
                audit.setSendUserId(sysUserDto.getUserId().intValue());
                audit.setSendName(sysUserDto.getUsername());
                audit.setSendTime(new Date());
                audit.setAuditUserId(sysUserDto.getUserId().intValue());
                audit.setAuditItem(new Date());
                audit.setAuditMsg("提交");
                audit.setAuditStatus("O");
                audit.setProjectMngId(projectbills.getProjectMngId());
                audit.setProjectLeader(projectbills.getProjectLeader());
                boolean approvalFlow = auditItemsService.createApprovalFlow(audit);
                if (!approvalFlow) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("审批流异常请检查提交信息");
                    return result;
                }
                // 添加分包合同
                double money = 0;
                double subAmtCr = 0.0;
                double subInvAmtCr = 0.0;
                JSONArray jsonArray = JSONArray.parseArray(costSituation);
                List<SubContractBills> subContractBillsList = JSONObject.parseArray(jsonArray.toJSONString(), SubContractBills.class);
                if (subContractBillsList.size() != 0) {
                    int line = 0;
                    for (SubContractBills sub : subContractBillsList) {
                        line++;
                        // 已付款金额
                        subAmtCr += sub.getSubAmtCr();
                        // 已开发票金额
                        subInvAmtCr += sub.getSubInvAmtCr();
                        sub.setBillNo(projectbills.getBillNo());
                        sub.setProjectSubNo(projectbills.getProjectNo());
                        sub.setBranchId(projectbills.getBranchId());
                        sub.setContractNo(projectbills.getProjectNo() + "-" + line);
                        sub.setContractName(projectbills.getProjectName());
                        sub.setPlanStartDate(projectbills.getActStartDate());
                        sub.setPlanEndDate(projectbills.getActEndDate());
                        sub.setPlanDays(projectbills.getActDays());
                        if (sub.getContractAuditAmt() != null && sub.getContractAuditAmt() != 0 &&
                                sub.getEstimatedAmt() == 0) {
                            sub.setSettlementStatus(6);
                            sub.setAmt(sub.getContractAuditAmt());
                        } else {
                            sub.setAmt(projectBill.getContractAmt());
                        }
                        sub.setContractTaxRate(projectbills.getTaxRate());
                        // 结算金额
                        if (sub.getContractAuditAmt() != null) {
                            sub.setContractAuditAmt(sub.getContractAuditAmt());
                        }
                        money += sub.getContractAmt();
                        sub.setAmt(sub.getContractAmt());
                        boolean insert = subContractBillsService.updateById(sub);
                        if (!insert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：新建分包合同失败");
                            return result;
                        }
                    }
                    // 插入 项目预算
                    EntityWrapper<ProjectBillsBudgets> billsBudgetsEntityWrapper = new EntityWrapper<>();
                    billsBudgetsEntityWrapper.eq("bill_no", projectbills.getBillNo()).eq("project_sub_no", projectbills.getProjectNo())
                            .eq("budget_id", 1);
                    ProjectBillsBudgets billsBudgets = projectBillsBudgetsService.selectOne(billsBudgetsEntityWrapper);
                    billsBudgets.setBudgetAmt(money);
                    billsBudgets.setSubInvAmtCr(subInvAmtCr);
                    billsBudgets.setSubInvAmtBlc(billsBudgets.getBudgetAmt() - subInvAmtCr);
                    billsBudgets.setSubAmtCr(subAmtCr);
                    billsBudgets.setSubAmtBlc(subInvAmtCr - subAmtCr);
                    boolean insert = projectBillsBudgetsService.updateById(billsBudgets);
                    if (!insert) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：新建工程成本失败");
                        return result;
                    }
                }
// 添加预算成本
                JSONArray array = JSONArray.parseArray(projectBudgets);
                List<ProjectBillsBudgets> projectBillsBudgetsList = JSONObject.parseArray(array.toJSONString(), ProjectBillsBudgets.class);
                if (projectBillsBudgetsList.size() != 0) {
                    for (ProjectBillsBudgets sub : projectBillsBudgetsList) {
                        // 已付款金额
                        subAmtCr += sub.getSubAmtCr();
                        // 已开发票金额
                        subInvAmtCr += sub.getSubInvAmtCr();
                        sub.setBillNo(projectbills.getBillNo());
                        sub.setProjectSubNo(projectbills.getProjectNo());
                        boolean insert = projectBillsBudgetsService.updateById(sub);
                        if (!insert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：新建成本预算失败");
                            return result;
                        }
                    }
                }
                // 添加 二级项目
                ProjectBillsSubs proSub = new ProjectBillsSubs();
                EntityWrapper<ProjectBillsSubs> subsEntityWrapper = new EntityWrapper<>();
                subsEntityWrapper.setSqlSelect("id").eq("bill_no", projectbills.getBillNo())
                        .eq("project_sub_no", projectbills.getProjectNo())
                        .eq("if_project_sub", "F")
                        .eq("is_sur", projectbills.getIsSur())
                        .eq("branch_id", projectbills.getBranchId());
                ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(subsEntityWrapper);
                projectBillsSubs.setContractAmt(projectbills.getContractAmt());
                projectBillsSubs.setNcProjectNo(projectbills.getNcProjectNo());
                projectBillsSubs.setProjectSubNo(projectbills.getProjectNo());
                projectBillsSubs.setProjectSubName(projectbills.getProjectName());
                projectBillsSubs.setCorpId(projectbills.getCorpId());
                projectBillsSubs.setContractAuditAmt(projectbills.getContractAuditAmt());
                projectBillsSubs.setProjectSubMngId(projectbills.getProjectMngId());
                projectBillsSubs.setProjectSubMngDeptId(projectbills.getProjectMngDeptId());
                projectBillsSubs.setAmt(projectbills.getAmt());
                projectBillsSubs.setBudgetAmt(projectbills.getProjectCost());
                projectBillsSubs.setBudgetProfit(projectBillsSubs.getAmt() - projectBillsSubs.getBudgetAmt());
                projectBillsSubs.setBudgetProfitRate((double) Math.round((projectBillsSubs.getBudgetProfit() / projectBillsSubs.getAmt()) * 100));
                projectBillsSubs.setSubInvAmtDr(projectbills.getSubInvAmtCr());
                projectBillsSubs.setSubAmtDr(projectbills.getSubAmtDr());
                // 存续项目付款金额可以超过收款
//                if (projectBillsSubs.getSubAmtDr() < subAmtCr) {
//                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
//                    result.addErrorMessage("提交失败：付款金额不得超过收款金额");
//                    return result;
//                }
                projectBillsSubs.setSubAmtCr(subAmtCr);
                projectBillsSubs.setSubInvAmtCr(subInvAmtCr);
                boolean proSubInsert = projectBillsSubsService.updateById(projectBillsSubs);
                if (!proSubInsert) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：新增子项目失败");
                    return result;
                }
            } else {
                result.addErrorMessage("提交失败：未找到项目信息，请检查提交信息重新提交");
                return result;
            }
            ProjectBillsHistory history = JSONArray.parseObject(backupData, ProjectBillsHistory.class);
            history.setSerialNumber(Getnum());
            boolean flag = projectBillsHistoryService.insert(history);
            if (!flag) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("提交失败：请检查提交信息重新提交");
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error("提交失败：" + e.toString(), e);
            result.addErrorMessage("提交失败：请检查提交信息重新提交");
        }
        return result;
    }*/

    @Override
    public Map<String, Object> getRenewPage(Map<String, Object> map, SysUserDto sysUserDto) {
        try {
            map.put("user", sysUserDto);
            int num = 0;
            if (map.get("remarks") != null && "projectSummary".equals(map.get("remarks"))) {
                num = projectbillsService.selectProRenewAdjustmentTotal(map);
            } else {
                num = projectbillsService.selectProRenewTotal(map);
            }
            if (num != 0) {
                int current = (int) map.get("current");
                int size = (int) map.get("size");
                if (current <= 1) {
                    current = 0;
                } else {
                    current = (current - 1) * size;
                }
                map.put("size", size);
                map.put("current", current);
                List<Map<String, Object>> mapList = new ArrayList<>();
                if (map.get("remarks") != null && "projectSummary".equals(map.get("remarks"))) {
                    mapList = projectbillsService.selectProRenewAdjustmentRecords(map);
                } else {
                    mapList = projectbillsService.selectProRenewRecords(map);
                }
                Page pageDto = new Page<>();
                pageDto.setTotal(num);
                pageDto.setRecords(mapList);
                map.put("page", pageDto);
            }
            return map;
        } catch (Exception e) {
            logger.error("操作异常：" + e.toString(), e);
        }
        return null;
    }

    @Override
    public Map<String, Object> proBalanceVal(ProjectBillsSubsDto projectBillsSubsDto) {
        if (projectBillsSubsDto != null && projectBillsSubsDto.getId() != null) {
            Map<String, Object> map = new HashMap<>();
            ProjectBS projectBS = projectBillsSubsService.selectProBalanceVal(projectBillsSubsDto);
            if (projectBS != null) {
                map.put("proBs", projectBS);
                EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
                projectBillsBudgetsEntityWrapper.eq("project_sub_no", projectBS.getProjectSubNo());
                List<ProjectBillsBudgets> projectBillsBudgetsList = projectBillsBudgetsService.selectList(projectBillsBudgetsEntityWrapper);
                if (projectBillsBudgetsList.size() != 0) {
                    map.put("proBudgets", projectBillsBudgetsList);
                }
                List<ProjectAnnex> projectAnnexes = projectAnnexService.selectAttachs(projectBS);
                if (projectAnnexes.size() != 0) {
                    map.put("proAnnexs", projectAnnexes);
                }
                EntityWrapper<Bbudgets> bbudgetsEntityWrapper = new EntityWrapper<>();
                map.put("budgets", bbudgetsService.selectList(bbudgetsEntityWrapper));
                return map;
            }
        }
        return null;
    }

    @Override
    public Map<String, Object> queryProjectSumPayCr(ProjectbillsDto projectbillsDto) {
        if (projectbillsDto != null && projectbillsDto.getId() != null) {
            Map<String, Object> map = new HashMap<>();
            map = projectbillsService.queryProjectSumPayCr(projectbillsDto);
            return map;
        }
        return null;
    }

    @Override
    public Map<String, Object> settlementPage(Map<String, Object> map, SysUserDto sysUserDto) {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        SysRole sysRole = subContractBillsService.selectRole(sysUserDto);
        map.put("user", sysUserDto);
        map.put("role", sysRole);
        if (map.get("startDate") != null && map.get("startDate") != "") {
            long startimes = (long) map.get("startDate");
            String startTime = sdf.format(new Date(startimes));
            map.put("startDateTime", startTime);
        }
        if (map.get("endDate") != null && map.get("endDate") != "") {
            long endtimes = (long) map.get("endDate");
            LocalDateTime localDateTime = LocalDateTime.ofInstant(Instant.ofEpochMilli(endtimes), ZoneId.systemDefault());
            LocalDateTime endOfDay = localDateTime.with(LocalTime.MAX);
            Date from = Date.from(endOfDay.atZone(ZoneId.systemDefault()).toInstant());
            String endTime = sdf.format(from);
            map.put("endDateTime", endTime);
        }
        int num = projectbillsService.selectSettlementTotal(map);
        if (num != 0) {
            int current = (int) map.get("current");
            int size = (int) map.get("size");
            if (current <= 1) {
                current = 0;
            } else {
                current = (current - 1) * size;
            }
            map.put("size", size);
            map.put("current", current);
            List<Map<String, Object>> mapList = projectbillsService.selectSettlementRecords(map);
            Page page = new Page();
            page.setTotal(num);
            page.setRecords(mapList);
            map.put("page", page);
            return map;
        }
        return null;
    }

    @Override
    public ExecuteResult<String> completionReminderRead(ProjectbillsDto projectbillsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            if (projectbillsDto != null && projectbillsDto.getId() != null) {
                Projectbills projectbills = new Projectbills();
                projectbills.setId(projectbillsDto.getId());
                projectbills.setCompletionReminder(projectbills.getCompletionReminder() + 1);
                boolean updateById = projectbillsService.updateById(projectbills);
                if (!updateById) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("操作失败：请重新操作");
                    return result;
                }
            } else {
                result.addErrorMessage("操作失败：未找到信息");
                return result;
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error("提交失败：" + e.toString(), e);
            result.addErrorMessage("提交失败：请检查提交信息重新提交");
        }
        return null;
    }

    @Override
    public Map<String, Object> queryPending(Map<String, Object> maps, SysUserDto sysUserDto) {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Map<String, Object> map = new HashMap<>();
        maps.put("userId", sysUserDto.getUserId().intValue());
        maps.put("loginContractorId", sysUserDto.getLoginContractorId());
        if (maps.containsKey("startDate") && maps.get("startDate") != null && maps.get("startDate") != "") {
            long startimes = (long) maps.get("startDate");
            maps.put("startD", sdf.format(new Date(startimes)));
        }
        if (maps.containsKey("endDate") && maps.get("endDate") != null && maps.get("endDate") != "") {
            long endtimes = (long) maps.get("endDate");
            LocalDateTime localDateTime = LocalDateTime.ofInstant(Instant.ofEpochMilli(endtimes), ZoneId.systemDefault());
            LocalDateTime endOfDay = localDateTime.with(LocalTime.MAX);
            Date from = Date.from(endOfDay.atZone(ZoneId.systemDefault()).toInstant());
            maps.put("endD", sdf.format(from));
        }
        int num = auditItemsService.selectAuditItemTotal(maps);
        if (num != 0) {
            int current = (int) maps.get("current");
            int size = (int) maps.get("size");
            if (current <= 1) {
                current = 0;
            } else {
                current = (current - 1) * size;
            }
            maps.put("currents", current);
            List<Map<String, Object>> auditItems = auditItemsService.selectAuditItemRecords(maps);
            Page page = new Page();
            page.setTotal(num);
            page.setRecords(auditItems);
            map.put("page", page);
        }
        return map;
    }

    @Override
    public Map<String, Object> queryPendingProjectId(AuditItemsDto auditItemsDto) {
        if (auditItemsDto != null) {
            AuditItems auditItems = auditItemsService.selectById(auditItemsDto.getId());
            Map<String, Object> map = new HashMap<>();
            if (Objects.equals(auditItemsDto.getActId(), 310) || Objects.equals(auditItemsDto.getActId(), 630)
                    || Objects.equals(auditItemsDto.getActId(), 650) || Objects.equals(auditItemsDto.getActId(), 655)
                    || Objects.equals(auditItemsDto.getActId(), 730)) {
                EntityWrapper<ProjectBillsSubs> entityWrapper = new EntityWrapper<>();
                entityWrapper.eq("bill_no", auditItemsDto.getBillNo())
                        .eq("project_sub_no", auditItemsDto.getProjectNo());
                if (!Objects.equals(auditItemsDto.getBranchId(), 1)) {
                    entityWrapper.eq("approval_branch_id", auditItemsDto.getBranchId());
                }
                ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(entityWrapper);
                if (Objects.equals(auditItemsDto.getActId(), 630)) {
                    map.put("val", projectBillsSubs);
                } else if (projectBillsSubs != null) {
                    map.put("val", projectBillsSubs.getId());
                }
            } else if ((auditItemsDto.getActId() >= 420 && auditItemsDto.getActId() <= 423)
                    || (auditItemsDto.getActId() >= 440 && auditItemsDto.getActId() <= 442)
                    || (auditItemsDto.getActId() >= 450 && auditItemsDto.getActId() <= 465)) {
                EntityWrapper<PurchaseBills> purchaseBillsEntityWrapper = new EntityWrapper<>();
                purchaseBillsEntityWrapper.setSqlSelect("id")
                        .eq("bill_no", auditItemsDto.getBillNo())
                        .eq("project_sub_no", auditItemsDto.getProjectNo());
                if (Objects.equals(auditItemsDto.getActId(), 441) || Objects.equals(auditItemsDto.getActId(), 442)) {
                    purchaseBillsEntityWrapper.eq("purchase_src_id", 333);
                }
                PurchaseBills purchaseBills = purchaseBillsService.selectOne(purchaseBillsEntityWrapper);
                if (purchaseBills != null) {
                    map.put("val", purchaseBills.getId());
                }
            } else if (Objects.equals(auditItemsDto.getActId(), 340) || Objects.equals(auditItemsDto.getActId(), 610)
                    || Objects.equals(auditItemsDto.getActId(), 710)) {
                EntityWrapper<Projectbills> entityWrapper = new EntityWrapper<>();
                entityWrapper.setSqlSelect("id", "is_sur").eq("bill_no", auditItemsDto.getBillNo())
                        .eq("project_no", auditItemsDto.getProjectNo());
                if (!Objects.equals(auditItemsDto.getBranchId(), 1)) {
                    entityWrapper.eq("approval_branch_id", auditItemsDto.getBranchId());
                }
                Projectbills projectbills = projectbillsService.selectOne(entityWrapper);
                if (Objects.equals(auditItemsDto.getActId(), 610)) {
                    map.put("val", projectbills);
                } else if (projectbills != null) {
                    map.put("val", projectbills.getId());
                }
            } else if ((auditItemsDto.getActId() >= 430 && auditItemsDto.getActId() <= 439)
                    || (auditItemsDto.getActId() >= 460 && auditItemsDto.getActId() <= 468)
                    || (auditItemsDto.getActId() >= 470 && auditItemsDto.getActId() <= 473)
                    || Objects.equals(auditItemsDto.getActId(), 480)) {
                EntityWrapper<PurchaseBills> entityWrapper = new EntityWrapper<>();
                entityWrapper.setSqlSelect("id")
                        .eq("bill_no", auditItemsDto.getBillNo())
                        .eq("project_sub_no", auditItemsDto.getProjectNo());
                PurchaseBills projectbills = purchaseBillsService.selectOne(entityWrapper);
                if (projectbills != null) {
                    map.put("val", projectbills.getId());
                }
            } else if (Objects.equals(auditItemsDto.getActId(), 510) || Objects.equals(auditItemsDto.getActId(), 520)
                    || Objects.equals(auditItemsDto.getActId(), 530)) {
                EntityWrapper<InvoiceBills> entityWrapper = new EntityWrapper<>();
                entityWrapper.setSqlSelect("id")
                        .eq("bill_no", auditItemsDto.getBillNo())
                        .eq("project_sub_no", auditItemsDto.getProjectNo());
                InvoiceBills invoiceBills = invoiceBillsService.selectOne(entityWrapper);
                if (invoiceBills != null) {
                    map.put("val", invoiceBills.getId());
                }
            } else if (Objects.equals(auditItemsDto.getActId(), 540)) {
                EntityWrapper<InvoiceBills> entityWrapper = new EntityWrapper<>();
                entityWrapper.setSqlSelect("id").eq("bill_no", auditItemsDto.getBillNo())
                        .eq("act_id", 202);
                InvoiceBills invoiceBills = invoiceBillsService.selectOne(entityWrapper);
                if (invoiceBills != null) {
                    map.put("val", invoiceBills.getId());
                }
            } else if (Objects.equals(auditItemsDto.getActId(), 560)) {
                EntityWrapper<PayCrBills> entityWrapper = new EntityWrapper<>();
                entityWrapper.eq("bill_no", auditItemsDto.getBillNo())
                        .eq("project_sub_no", auditItemsDto.getProjectNo());
                PayCrBills payCrBills = payCrBillsService.selectOne(entityWrapper);
                if (payCrBills != null) {
                    map.put("val", payCrBills);
                }
            } else if (Objects.equals(auditItemsDto.getActId(), 570)) {
                EntityWrapper<PayCrBills> entityWrapper = new EntityWrapper<>();
                entityWrapper.setSqlSelect("id").eq("bill_no", auditItemsDto.getBillNo())
                        .eq("act_id", 204);
                PayCrBills payCrBills = payCrBillsService.selectOne(entityWrapper);
                if (payCrBills != null) {
                    map.put("val", payCrBills.getId());
                }
            } else if (Objects.equals(auditItemsDto.getActId(), 830)) {
                EntityWrapper<ProjectBillsAdjusts> entityWrapper = new EntityWrapper<>();
                entityWrapper.eq("bill_no", auditItemsDto.getBillNo())
                        .eq("project_sub_no", auditItems.getProjectNo());
                ProjectBillsAdjusts payCrBills = projectBillsAdjustsService.selectOne(entityWrapper);
                if (payCrBills != null) {
                    map.put("val", payCrBills);
                }
            }
            return map;
        }
        return null;
    }

    @Override
    public Map<String, Object> projectEndQueryPendingVal(ProjectbillsDto projectbillsDto) {
        if (projectbillsDto != null && projectbillsDto.getId() != null && projectbillsDto.getActId() != null) {
            Map<String, Object> map = new HashMap<>();
            if ((projectbillsDto.getActId() >= 420 && projectbillsDto.getActId() <= 423)
                    || (projectbillsDto.getActId() >= 440 && projectbillsDto.getActId() <= 442)
                    || (projectbillsDto.getActId() >= 450 && projectbillsDto.getActId() <= 465)) {
                PurchaseBills purchaseBills = purchaseBillsService.selectById(projectbillsDto.getId());
                List<Map<String, Object>> pendingVal = projectbillsService.selectPurchaseQueryPendingVal(purchaseBills, projectbillsDto.getActId());
                if (pendingVal.size() != 0) {
                    map.put("audits", pendingVal);
                }
            } else if (Objects.equals(projectbillsDto.getActId(), 310) || Objects.equals(projectbillsDto.getActId(), 630)
                    || Objects.equals(projectbillsDto.getActId(), 650) || Objects.equals(projectbillsDto.getActId(), 655)
                    || Objects.equals(projectbillsDto.getActId(), 730)) {
                List<Map<String, Object>> auditItems = projectbillsService.selectProjectSubEndQueryPendingVal(projectbillsDto);
                if (auditItems.size() != 0) {
                    map.put("audits", auditItems);
                }
            } else if (Objects.equals(projectbillsDto.getActId(), 340) || Objects.equals(projectbillsDto.getActId(), 610)
                    || Objects.equals(projectbillsDto.getActId(), 710)) {
                List<Map<String, Object>> auditItems = projectbillsService.selectProjectEndQueryPendingVal(projectbillsDto);
                if (auditItems.size() != 0) {
                    map.put("audits", auditItems);
                }
            } else if ((projectbillsDto.getActId() >= 430 && projectbillsDto.getActId() <= 439)
                    || (projectbillsDto.getActId() >= 460 && projectbillsDto.getActId() <= 468)
                    || (projectbillsDto.getActId() >= 470 && projectbillsDto.getActId() <= 473)
                    || Objects.equals(projectbillsDto.getActId(), 480)) {
                List<Map<String, Object>> auditItems = projectbillsService.selectPurchQueryPendingVal(projectbillsDto);
                if (auditItems.size() != 0) {
                    map.put("audits", auditItems);
                }
            } else if (Objects.equals(projectbillsDto.getActId(), 510) || Objects.equals(projectbillsDto.getActId(), 520)
                    || Objects.equals(projectbillsDto.getActId(), 530)) {
                List<Map<String, Object>> auditItems = projectbillsService.selectInvoiceQueryPendingVal(projectbillsDto);
                if (auditItems.size() != 0) {
                    map.put("audits", auditItems);
                }
            } else if (Objects.equals(projectbillsDto.getActId(), 540)) {
                List<Map<String, Object>> auditItems = projectbillsService.selectInvoiceSharesVal(projectbillsDto);
                if (auditItems.size() != 0) {
                    map.put("audits", auditItems);
                }
            } else if (Objects.equals(projectbillsDto.getActId(), 560)) {
                List<Map<String, Object>> auditItems = projectbillsService.selectPayCrQueryPendingVal(projectbillsDto);
                if (auditItems.size() != 0) {
                    map.put("audits", auditItems);
                }
            } else if (Objects.equals(projectbillsDto.getActId(), 570)) {
                List<Map<String, Object>> auditItems = projectbillsService.selectPayCrSharesQueryPendingVal(projectbillsDto);
                if (auditItems.size() != 0) {
                    map.put("audits", auditItems);
                }
            } else if (Objects.equals(projectbillsDto.getActId(), 830)) {
                List<Map<String, Object>> auditItems = projectbillsService.selectBudgetsQueryPendingVal(projectbillsDto);
                if (auditItems.size() != 0) {
                    map.put("audits", auditItems);
                }
            }
            return map;
        }
        return null;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> approved(AuditItemsDto auditItemsDto, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            if (auditItemsDto != null && auditItemsDto.getId() != null && auditItemsDto.getActId() != null) {
                if (Objects.equals(auditItemsDto.getActId(), 340) || Objects.equals(auditItemsDto.getActId(), 610)
                        || Objects.equals(auditItemsDto.getActId(), 710)) {
                    result = this.approvedProject(auditItemsDto, sysUserDto);
                    return result;
                } else if (Objects.equals(auditItemsDto.getActId(), 310) || Objects.equals(auditItemsDto.getActId(), 630)
                        || Objects.equals(auditItemsDto.getActId(), 650) || Objects.equals(auditItemsDto.getActId(), 655)
                        || Objects.equals(auditItemsDto.getActId(), 730)) {
                    result = this.approvedProgressBudget(auditItemsDto, sysUserDto);
                    return result;
                } else if ((auditItemsDto.getActId() >= 420 && auditItemsDto.getActId() <= 443)
                        || (auditItemsDto.getActId() >= 450 && auditItemsDto.getActId() <= 465)
                        || (auditItemsDto.getActId() >= 470 && auditItemsDto.getActId() <= 473)) {
                    result = this.approvedPurchase(auditItemsDto, sysUserDto);
                    return result;
                } else if (Objects.equals(auditItemsDto.getActId(), 510) || Objects.equals(auditItemsDto.getActId(), 520)
                        || Objects.equals(auditItemsDto.getActId(), 530)) {
                    result = this.approvedInvoiceCr(auditItemsDto, sysUserDto);
                    return result;
                } else if (Objects.equals(auditItemsDto.getActId(), 540)) {
                    result = this.approvedInvoiceSharesCr(auditItemsDto, sysUserDto);
                    return result;
                } else if (Objects.equals(auditItemsDto.getActId(), 560) || Objects.equals(auditItemsDto.getActId(), 570)) {
                    result = this.approvedPayCr(auditItemsDto, sysUserDto);
                    return result;
                } else if (Objects.equals(auditItemsDto.getActId(), 830)) {
                    result = this.approvedProjectAdjusts(auditItemsDto, sysUserDto);
                    return result;
                } else {
                    result.addErrorMessage("审批失败：未找到信息");
                    return result;
                }
            } else {
                result.addErrorMessage("审批失败：未找到信息");
                return result;
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 审批失败：" + e.toString(), e);
            result.addErrorMessage("审批失败：提交信息有误");
            return result;
        }
    }

    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> approvedPurchase(AuditItemsDto auditItemsDto, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        PurchaseBills projectbills = purchaseBillsService.selectById(auditItemsDto.getId());
        EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
        projectBillsSubsEntityWrapper.eq("project_sub_no", projectbills.getProjectSubNo())
                .eq("branch_id", projectbills.getContractorId());
        ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
        EntityWrapper<AuditItems> auditItemsEntityWrapper = new EntityWrapper<>();
        auditItemsEntityWrapper.eq("bill_no", projectbills.getBillNo())
                .eq("act_id", auditItemsDto.getActId())
                .eq("sub_ject", projectBillsSubs.getProjectSubName())
                .eq("project_no", projectbills.getProjectSubNo());
        List<AuditItems> auditItems = auditItemsService.selectList(auditItemsEntityWrapper);
        int number = 0;
        for (AuditItems at : auditItems) {
            if (!"S".equals(at.getAuditStatus())) {
                continue;
            }
            EntityWrapper<AuditItemsUsers> itemsUsersEntityWrapper = new EntityWrapper<>();
            itemsUsersEntityWrapper.eq("pid", at.getId());
            List<AuditItemsUsers> auditItemsUsers = auditItemsUsersService.selectList(itemsUsersEntityWrapper);
            for (AuditItemsUsers au : auditItemsUsers) {
                if (au.getUserId() == sysUserDto.getUserId().intValue() && au.getAuditStatus().equals("S")) {
                    number++;
                    if (auditItemsDto.getAuditMsg() == null || "".equals(auditItemsDto.getAuditMsg())) {
                        at.setAuditMsg("同意");
                    } else {
                        at.setAuditMsg(auditItemsDto.getAuditMsg());
                    }
                    at.setAuditStatus("A");
                    at.setAuditItem(new Date());
                    at.setAuditUserId(au.getUserId());
                    boolean updateById = auditItemsService.updateById(at);
                    if (!updateById) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("审批通过失败: 更新审批状态失败");
                        return result;
                    }
                    au.setAuditStatus("A");
                    boolean updateByIemUser = auditItemsUsersService.updateById(au);
                    if (!updateByIemUser) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("审批通过失败: 更新审批状态失败");
                        return result;
                    }
                    if ("T".equals(at.getIffinalItem())) {
                        projectbills.setBillStatus(6);
                        boolean update = purchaseBillsService.updateById(projectbills);
                        if (!update) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("审批通过失败: 更新竣工状态失败");
                            return result;
                        }
                        return result;
                    } else if ("F".equals(at.getIffinalItem())) {
                        projectbills.setBillStatus(5);
                        boolean update = purchaseBillsService.updateById(projectbills);
                        if (!update) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("审批通过失败: 更新状态失败");
                            return result;
                        }
                        at.setLevelId(at.getLevelId() + 1);
                        int updateNum = auditItemsService.updateAuditStatus(at);
                        if (updateNum <= 0) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("审批通过失败: 更新审批状态失败");
                            return result;
                        }
                        return result;
                    }
                    break;
                }
            }
        }
        if (number <= 0) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            result.addErrorMessage("该审批已被操作");
            return result;
        }
        return result;
    }

    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> approvedProgressBudget(AuditItemsDto auditItemsDto, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectById(auditItemsDto.getId());
        EntityWrapper<AuditItems> auditItemsEntityWrapper = new EntityWrapper<>();
        auditItemsEntityWrapper.eq("bill_no", projectBillsSubs.getBillNo())
                .eq("act_id", auditItemsDto.getActId())
                .eq("sub_ject", projectBillsSubs.getProjectSubName())
                .eq("project_no", projectBillsSubs.getProjectSubNo());
        List<AuditItems> auditItems = auditItemsService.selectList(auditItemsEntityWrapper);
        int number = 0;
        for (AuditItems at : auditItems) {
            if (!"S".equals(at.getAuditStatus())) {
                continue;
            }
            EntityWrapper<AuditItemsUsers> itemsUsersEntityWrapper = new EntityWrapper<>();
            itemsUsersEntityWrapper.eq("pid", at.getId());
            List<AuditItemsUsers> auditItemsUsers = auditItemsUsersService.selectList(itemsUsersEntityWrapper);
            for (AuditItemsUsers au : auditItemsUsers) {
                if (Objects.equals(au.getUserId(), sysUserDto.getUserId().intValue()) && "S".equals(au.getAuditStatus())) {
                    number++;
                    if (auditItemsDto.getAuditMsg() == null || "".equals(auditItemsDto.getAuditMsg())) {
                        at.setAuditMsg("同意");
                    } else {
                        at.setAuditMsg(auditItemsDto.getAuditMsg());
                    }
                    at.setAuditStatus("A");
                    at.setAuditItem(new Date());
                    at.setAuditUserId(au.getUserId());
                    boolean updateById = auditItemsService.updateById(at);
                    if (!updateById) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("审批通过失败: 更新审批状态失败");
                        return result;
                    }
                    au.setAuditStatus("A");
                    boolean updateByIemUser = auditItemsUsersService.updateById(au);
                    if (!updateByIemUser) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("审批通过失败: 更新审批状态失败");
                        return result;
                    }
                    if (auditItemsDto.getAuditMsg() == null || "".equals(auditItemsDto.getAuditMsg())) {
                        at.setAuditMsg("同意");
                    } else {
                        at.setAuditMsg(auditItemsDto.getAuditMsg());
                    }
                    at.setAuditStatus("A");
                    at.setAuditItem(new Date());
                    boolean updateByAuditItem = auditItemsService.updateById(at);
                    if (!updateByAuditItem) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("审批通过失败: 更新审批状态失败");
                        return result;
                    }
                    EntityWrapper<ProjectBillsSteps> stepsEntityWrapper = new EntityWrapper<>();
                    stepsEntityWrapper.eq("project_sub_no", projectBillsSubs.getProjectSubNo())
                            .eq("branch_id", projectBillsSubs.getBranchId())
                            .in("status", new Integer[]{4, 5});
                    List<ProjectBillsSteps> projectBillsSteps = projectBillsStepsService.selectList(stepsEntityWrapper);
                    if (at.getIffinalItem().equals("T")) {
                        if (Objects.equals(auditItemsDto.getActId(), 310)) {
                            double sum = 0.0;
                            for (ProjectBillsSteps step : projectBillsSteps) {
                                step.setStatus(6);
                                sum += step.getProjectWorkRate();
                                if (!projectBillsStepsService.updateById(step)) {
                                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                    result.addErrorMessage("审批通过失败: 更新节点状态失败");
                                    return result;
                                }
                                ProcessBillsSteps processBillsSteps = new ProcessBillsSteps();
                                processBillsSteps.setBillNo(step.getBillNo());
                                processBillsSteps.setLineNo(step.getLineNo());
                                processBillsSteps.setActId(106);
                                processBillsSteps.setActDays(step.getActDays());
                                processBillsSteps.setActEndDate(step.getActEndDate());
                                processBillsSteps.setActStartDate(step.getActStartDate());
                                processBillsSteps.setAttach1(step.getAttach1());
                                processBillsSteps.setAttach2(step.getAttach2());
                                processBillsSteps.setDesignChangesAttach(step.getDesignChangesAttach());
                                processBillsSteps.setPlanDays(step.getPlanDays());
                                processBillsSteps.setBranchId(step.getBranchId());
                                processBillsSteps.setPlanEndDate(step.getPlanEndDate());
                                processBillsSteps.setPlanStartDate(step.getPlanStartDate());
                                processBillsSteps.setProjectNodeId(step.getProjectNodeId());
                                processBillsSteps.setProjectStepId(step.getProjectStepId());
                                processBillsSteps.setProjectSubNo(step.getProjectSubNo());
                                processBillsSteps.setProjectWorkRate(step.getProjectWorkRate());
                                processBillsSteps.setRemarks(step.getRemarks());
                                if (!processBillsStepsService.insert(processBillsSteps)) {
                                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                    result.addErrorMessage("审批通过失败: 新增形象进度记录失败");
                                    return result;
                                }
                            }
                            projectBillsSubs.setCurrentProgress(sum + projectBillsSubs.getCurrentProgress());
                            if (!projectBillsSubsService.updateById(projectBillsSubs)) {
                                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                result.addErrorMessage("更新二级项目形象进度失败");
                                return result;
                            }
                            EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
                            projectBillsSubsEntityWrapper.setSqlSelect("id", "bill_no")
                                    .eq("bill_no", projectBillsSubs.getBillNo())
                                    .ne("current_progress", 100);
                            List<ProjectBillsSubs> projectBillsSubsList = projectBillsSubsService.selectList(projectBillsSubsEntityWrapper);
                            if (Objects.equals(projectBillsSubsList.size(), 0)) {
                                EntityWrapper<Projectbills> projectbillsEntityWrapper = new EntityWrapper<>();
                                projectbillsEntityWrapper.setSqlSelect("id", "pro_current_status")
                                        .eq("bill_no", projectBillsSubs.getBillNo())
                                        .eq("branch_id", projectBillsSubs.getBranchId());
                                Projectbills projectbills = projectbillsService.selectOne(projectbillsEntityWrapper);
                                projectbills.setProCurrentStatus(6);
                                boolean updateBy = projectbillsService.updateById(projectbills);
                                if (!updateBy) {
                                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                    result.addErrorMessage("更新二级项目形象进度失败");
                                    return result;
                                }
                            }
                            return result;
                        } else if (Objects.equals(auditItemsDto.getActId(), 630)) {
                            EntityWrapper<SubContractBills> contractBillsEntityWrapper = new EntityWrapper<>();
                            contractBillsEntityWrapper.eq("project_sub_no", projectBillsSubs.getProjectSubNo())
                                    .eq("branch_id", projectBillsSubs.getBranchId());
                            List<SubContractBills> subContractBills = subContractBillsService.selectList(contractBillsEntityWrapper);
                            double subInvAmt = 0.0;
                            for (SubContractBills sc : subContractBills) {
                                if (Objects.equals(sc.getSettlementStatus(), 4) || Objects.equals(sc.getSettlementStatus(), 5)) {
                                    sc.setSettlementStatus(6);
                                    subInvAmt = subInvAmt + sc.getContractAuditAmt();
                                    if (sc.getAttach() != null) {
                                        ProjectAnnex projectAnnex = new ProjectAnnex();
                                        projectAnnex.setSrcActId(206);
                                        projectAnnex.setProjectId(sc.getId());
                                        projectAnnex.setFileName("分包结算书");
                                        projectAnnex.setFileAddress(sc.getAttach());
                                        projectAnnex.setBranId(sc.getBranchId());
                                        boolean proInsert = projectAnnexService.insert(projectAnnex);
                                        if (!proInsert) {
                                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                            result.addErrorMessage("审批通过失败: 更新分包合同失败");
                                            return result;
                                        }
                                    }
                                    sc.setAmt(sc.getContractAuditAmt());
                                    boolean updateById1 = subContractBillsService.updateById(sc);
                                    if (!updateById1) {
                                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                        result.addErrorMessage("审批通过失败: 更新数据失败");
                                        return result;
                                    }
                                }
                            }
                            EntityWrapper<ProjectBillsBudgets> billsBudgetsEntityWrapper = new EntityWrapper<>();
                            billsBudgetsEntityWrapper.eq("project_sub_no", projectBillsSubs.getProjectSubNo())
                                    .eq("branch_id", projectBillsSubs.getBranchId());
                            List<ProjectBillsBudgets> projectBillsBudgets = projectBillsBudgetsService.selectList(billsBudgetsEntityWrapper);
                            for (ProjectBillsBudgets pb : projectBillsBudgets) {
                                if (Objects.equals(pb.getBudgetId(), 1)) {
                                    pb.setApprovedAmount(subInvAmt + pb.getApprovedAmount());
                                    if (!projectBillsBudgetsService.updateById(pb)) {
                                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                        result.addErrorMessage("更新预算失败");
                                    }
                                }
                            }
                            double amt = projectBillsBudgetsService.selectApprovedAmountSum(projectBillsBudgets.get(0));
                            projectBillsSubs.setSubAuditAmt(subInvAmt);
                            projectBillsSubs.setActualBudgetAmt(amt);
                            EntityWrapper<SubContractBills> subContractBillsEntityWrapper = new EntityWrapper<>();
                            subContractBillsEntityWrapper.eq("project_sub_no", projectBillsSubs.getProjectSubNo())
                                    .eq("settlement_status", 6);
                            int subCount = subContractBillsService.selectCount(subContractBillsEntityWrapper);
                            if (subCount == 0) {
                                projectBillsSubs.setProjectStatus(40);
                            }
                            boolean projectBillsSubsType = projectBillsSubsService.updateById(projectBillsSubs);
                            if (!projectBillsSubsType) {
                                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                result.addErrorMessage("审批通过失败: 更新二级项目失败");
                                return result;
                            }
                        } else if (Objects.equals(auditItemsDto.getActId(), 650) || Objects.equals(auditItemsDto.getActId(), 655)) {
                            if (Objects.equals(auditItemsDto.getActId(), 655)) {
                                projectBillsSubs.setSettlerChStatus("T");
                                boolean updateByProSub = projectBillsSubsService.updateById(projectBillsSubs);
                                if (!updateByProSub) {
                                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                    result.addErrorMessage("结项失败, 更新状态失败");
                                    return result;
                                }
                            } else {
                                projectBillsSubs.setClosingStatus("T");
                                boolean updateByProSub = projectBillsSubsService.updateById(projectBillsSubs);
                                if (!updateByProSub) {
                                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                    result.addErrorMessage("结项失败, 更新状态失败");
                                    return result;
                                }
                                EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
                                projectBillsSubsEntityWrapper.eq("bill_no", projectBillsSubs.getBillNo())
                                        .eq("corp_id", projectBillsSubs.getCorpId())
                                        .eq("branch_id", projectBillsSubs.getBranchId());
                                List<ProjectBillsSubs> projectBillsSubsList = projectBillsSubsService.selectList(projectBillsSubsEntityWrapper);
                                boolean status = false;
                                for (ProjectBillsSubs pb : projectBillsSubsList) {
                                    if (!"T".equals(pb.getClosingStatus())) {
                                        status = true;
                                    } else if ("T".equals(pb.getClosingStatus())) {
                                        pb.setProjectStatus(50);
                                        boolean updateById1 = projectBillsSubsService.updateById(pb);
                                        if (!updateById1) {
                                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                            result.addErrorMessage("结项失败, 更新状态失败");
                                            return result;
                                        }
                                    }
                                }
                                if (!status) {
                                    EntityWrapper<Projectbills> projectbillsEntityWrapper = new EntityWrapper<>();
                                    projectbillsEntityWrapper.eq("bill_no", projectBillsSubs.getBillNo());
                                    Projectbills projectbills = projectbillsService.selectOne(projectbillsEntityWrapper);
                                    projectbills.setClosingStatus(6);
                                    projectbills.setClosingUserId(sysUserDto.getUserId().intValue());
                                    projectbills.setClosingUserName(sysUserDto.getUsername());
                                    projectbills.setClosingDate(new Date());
                                    boolean updateById1 = projectbillsService.updateById(projectbills);
                                    if (!updateById1) {
                                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                        result.addErrorMessage("结项失败, 更新合同失败");
                                        return result;
                                    }
                                }
                            }
                        } else if (Objects.equals(auditItemsDto.getActId(), 730)) {
                            projectBillsSubs.setProjectBudgetStatus(6);
                            boolean update = projectBillsSubsService.updateById(projectBillsSubs);
                            if (!update) {
                                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                result.addErrorMessage("审批通过失败: 更新状态失败");
                                return result;
                            }
                            return result;
                        }
                    } else if (at.getIffinalItem().equals("F")) {
                        if (Objects.equals(auditItemsDto.getActId(), 310)) {
                            for (ProjectBillsSteps step : projectBillsSteps) {
                                step.setStatus(5);
                                if (!projectBillsStepsService.updateById(step)) {
                                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                    result.addErrorMessage("审批通过失败: 更新节点状态失败");
                                    return result;
                                }
                            }
                        } else if (Objects.equals(auditItemsDto.getActId(), 630)) {
                            EntityWrapper<SubContractBills> contractBillsEntityWrapper = new EntityWrapper<>();
                            contractBillsEntityWrapper.eq("project_sub_no", projectBillsSubs.getProjectSubNo())
                                    .eq("branch_id", projectBillsSubs.getBranchId());
                            List<SubContractBills> subContractBills = subContractBillsService.selectList(contractBillsEntityWrapper);
                            for (SubContractBills sc : subContractBills) {
                                if (Objects.equals(sc.getSettlementStatus(), 4) || Objects.equals(sc.getSettlementStatus(), 5)) {
                                    sc.setSettlementStatus(5);
                                    boolean updateById1 = subContractBillsService.updateById(sc);
                                    if (!updateById1) {
                                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                        result.addErrorMessage("审批通过失败: 更新数据失败");
                                        return result;
                                    }
                                }
                            }
                        } else if (Objects.equals(auditItemsDto.getActId(), 650) || Objects.equals(auditItemsDto.getActId(), 655)) {
                            if (Objects.equals(auditItemsDto.getActId(), 655)) {
                                projectBillsSubs.setSettlerChStatus("Z");
                            } else {
                                projectBillsSubs.setClosingStatus("Z");
                            }
                            boolean updateByProSub = projectBillsSubsService.updateById(projectBillsSubs);
                            if (!updateByProSub) {
                                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                result.addErrorMessage("结项失败, 更新状态失败");
                                return result;
                            }
                        } else if (Objects.equals(auditItemsDto.getActId(), 730)) {
                            projectBillsSubs.setProjectBudgetStatus(5);
                            boolean update = projectBillsSubsService.updateById(projectBillsSubs);
                            if (!update) {
                                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                result.addErrorMessage("审批通过失败: 更新状态失败");
                                return result;
                            }
                        }
                        at.setLevelId(at.getLevelId() + 1);
                        int updateNum = auditItemsService.updateAuditStatus(at);
                        if (updateNum <= 0) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("审批通过失败: 更新审批状态失败");
                            return result;
                        }
                        return result;
                    }
                    break;
                }
            }
        }
        if (number <= 0) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            result.addErrorMessage("该审批已被操作");
            return result;
        }
        return result;
    }

    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> approvedInvoiceCr(AuditItemsDto auditItemsDto, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        InvoiceBills invoiceBills = invoiceBillsService.selectById(auditItemsDto.getId());
        EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
        projectBillsSubsEntityWrapper.eq("project_sub_no", invoiceBills.getProjectSubNo())
                .eq("branch_id", invoiceBills.getBranchId());
        ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
        EntityWrapper<AuditItems> auditItemsEntityWrapper = new EntityWrapper<>();
        auditItemsEntityWrapper.eq("bill_no", invoiceBills.getBillNo())
                .eq("act_id", auditItemsDto.getActId())
                .eq("sub_ject", projectBillsSubs.getProjectSubName())
                .eq("project_no", invoiceBills.getProjectSubNo());
        List<AuditItems> auditItems = auditItemsService.selectList(auditItemsEntityWrapper);
        int number = 0;
        for (AuditItems at : auditItems) {
            if (!"S".equals(at.getAuditStatus())) {
                continue;
            }
            EntityWrapper<AuditItemsUsers> itemsUsersEntityWrapper = new EntityWrapper<>();
            itemsUsersEntityWrapper.eq("pid", at.getId());
            List<AuditItemsUsers> auditItemsUsers = auditItemsUsersService.selectList(itemsUsersEntityWrapper);
            for (AuditItemsUsers au : auditItemsUsers) {
                if (Objects.equals(au.getUserId(), sysUserDto.getUserId().intValue()) && "S".equals(au.getAuditStatus())) {
                    number++;
                    if (auditItemsDto.getAuditMsg() == null || "".equals(auditItemsDto.getAuditMsg())) {
                        at.setAuditMsg("同意");
                    } else {
                        at.setAuditMsg(auditItemsDto.getAuditMsg());
                    }
                    at.setAuditStatus("A");
                    at.setAuditItem(new Date());
                    boolean updateById = auditItemsService.updateById(at);
                    if (!updateById) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("审批通过失败: 更新审批状态失败");
                        return result;
                    }
                    if (at.getIffinalItem().equals("T")) {
                        invoiceBills.setBillStatus(6);
                        boolean update = invoiceBillsService.updateById(invoiceBills);
                        if (!update) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("审批通过失败: 更新状态失败");
                            return result;
                        }
                    } else if (at.getIffinalItem().equals("F")) {
                        invoiceBills.setBillStatus(5);
                        boolean update = invoiceBillsService.updateById(invoiceBills);
                        if (!update) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("审批通过失败: 更新状态失败");
                            return result;
                        }
                        at.setLevelId(at.getLevelId() + 1);
                        int updateNum = auditItemsService.updateAuditStatus(at);
                        if (updateNum <= 0) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("审批通过失败: 更新审批状态失败");
                            return result;
                        }
                    }
                }
            }
        }
        if (number <= 0) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            result.addErrorMessage("该审批已被操作");
            return result;
        }
        return result;
    }

    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> approvedInvoiceSharesCr(AuditItemsDto auditItemsDto, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        InvoiceBills invoiceBills = invoiceBillsService.selectById(auditItemsDto.getId());
        EntityWrapper<AuditItems> auditItemsEntityWrapper = new EntityWrapper<>();
        auditItemsEntityWrapper.eq("bill_no", invoiceBills.getBillNo())
                .eq("act_id", auditItemsDto.getActId());
        List<AuditItems> auditItems = auditItemsService.selectList(auditItemsEntityWrapper);
        int number = 0;
        for (AuditItems at : auditItems) {
            if (!"S".equals(at.getAuditStatus())) {
                continue;
            }
            EntityWrapper<AuditItemsUsers> itemsUsersEntityWrapper = new EntityWrapper<>();
            itemsUsersEntityWrapper.eq("pid", at.getId());
            List<AuditItemsUsers> auditItemsUsers = auditItemsUsersService.selectList(itemsUsersEntityWrapper);
            for (AuditItemsUsers au : auditItemsUsers) {
                if (Objects.equals(au.getUserId(), sysUserDto.getUserId().intValue()) && "S".equals(au.getAuditStatus())) {
                    number++;
                    if (auditItemsDto.getAuditMsg() == null || "".equals(auditItemsDto.getAuditMsg())) {
                        at.setAuditMsg("同意");
                    } else {
                        at.setAuditMsg(auditItemsDto.getAuditMsg());
                    }
                    at.setAuditStatus("A");
                    at.setAuditItem(new Date());
                    boolean updateById = auditItemsService.updateById(at);
                    if (!updateById) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("审批通过失败: 更新审批状态失败");
                        return result;
                    }
                    if ("T".equals(at.getIffinalItem())) {
                        invoiceBills.setBillStatus(6);
                        boolean update = invoiceBillsService.updateById(invoiceBills);
                        if (!update) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("审批通过失败: 更新状态失败");
                            return result;
                        }
                    } else if ("F".equals(at.getIffinalItem())) {
                        invoiceBills.setBillStatus(5);
                        boolean update = invoiceBillsService.updateById(invoiceBills);
                        if (!update) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("审批通过失败: 更新状态失败");
                            return result;
                        }
                        at.setLevelId(at.getLevelId() + 1);
                        int updateNum = auditItemsService.updateInvShareAuditStatus(at);
                        if (updateNum <= 0) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("审批通过失败: 更新审批状态失败");
                            return result;
                        }
                    }
                }
            }
        }
        if (number <= 0) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            result.addErrorMessage("该审批已被操作");
            return result;
        }
        return result;
    }

    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> approvedProjectAdjusts(AuditItemsDto auditItemsDto, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        ProjectBillsAdjusts projectBillsAdjusts = projectBillsAdjustsService.selectById(auditItemsDto.getId());
        EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
        projectBillsSubsEntityWrapper.eq("project_sub_no", projectBillsAdjusts.getProjectSubNo())
                .eq("branch_id", projectBillsAdjusts.getBranchId());
        ProjectBillsSubs billsSubs1 = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
        EntityWrapper<AuditItems> auditItemsEntityWrapper = new EntityWrapper<>();
        auditItemsEntityWrapper.eq("bill_no", projectBillsAdjusts.getBillNo())
                .eq("act_id", auditItemsDto.getActId())
                .eq("branch_id", billsSubs1.getApprovalBranchId());
        List<AuditItems> auditItems = auditItemsService.selectList(auditItemsEntityWrapper);
        int number = 0;
        for (AuditItems at : auditItems) {
            if (!"S".equals(at.getAuditStatus())) {
                continue;
            }
            EntityWrapper<AuditItemsUsers> itemsUsersEntityWrapper = new EntityWrapper<>();
            itemsUsersEntityWrapper.eq("pid", at.getId());
            List<AuditItemsUsers> auditItemsUsers = auditItemsUsersService.selectList(itemsUsersEntityWrapper);
            for (AuditItemsUsers au : auditItemsUsers) {
                if (au.getUserId() == sysUserDto.getUserId().intValue() && "S".equals(au.getAuditStatus())) {
                    number++;
                    if (auditItemsDto.getAuditMsg() == null || "".equals(auditItemsDto.getAuditMsg())) {
                        at.setAuditMsg("同意");
                    } else {
                        at.setAuditMsg(auditItemsDto.getAuditMsg());
                    }
                    at.setAuditStatus("A");
                    at.setAuditItem(new Date());
                    at.setAuditUserId(au.getUserId());
                    boolean updateById = auditItemsService.updateById(at);
                    if (!updateById) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("审批通过失败: 更新审批状态失败");
                        return result;
                    }
                    au.setAuditStatus("A");
                    boolean updateByIemUser = auditItemsUsersService.updateById(au);
                    if (!updateByIemUser) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("审批通过失败: 更新审批状态失败");
                        return result;
                    }
                    if ("T".equals(at.getIffinalItem())) {
                        EntityWrapper<BudgetAdjustBills> billsEntityWrapper = new EntityWrapper<>();
                        billsEntityWrapper.eq("bill_no", projectBillsAdjusts.getBillNo())
                                .eq("project_sub_no", projectBillsAdjusts.getProjectSubNo());
                        List<BudgetAdjustBills> adjustBillsList = budgetAdjustBillsService.selectList(billsEntityWrapper);
                        double amt = 0.00;
                        for (BudgetAdjustBills bj : adjustBillsList) {
                            amt = DataUtils.keepDecimals(amt + bj.getBudgetAmt());
                            EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
                            projectBillsBudgetsEntityWrapper.setSqlSelect("id")
                                    .eq("project_sub_no", bj.getProjectSubNo())
                                    .eq("budget_id", bj.getBudgetId())
                                    .eq("branch_id", projectBillsAdjusts.getBranchId());
                            ProjectBillsBudgets billsBudgets = projectBillsBudgetsService.selectOne(projectBillsBudgetsEntityWrapper);
                            if (billsBudgets != null) {
                                billsBudgets.setBudgetAmt(bj.getBudgetAmt());
                                boolean update = projectBillsBudgetsService.updateById(billsBudgets);
                                if (!update) {
                                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                    result.addErrorMessage("提交失败：更新预算金额失败");
                                    return result;
                                }
                            } else {
                                ProjectBillsBudgets budgets = new ProjectBillsBudgets();
                                budgets.setBillNo(billsSubs1.getBillNo());
                                budgets.setProjectSubNo(bj.getProjectSubNo());
                                budgets.setBudgetId(bj.getBudgetId());
                                budgets.setBudgetAmt(bj.getBudgetAmt());
                                budgets.setBranchId(billsSubs1.getBranchId());
                                Bbudgets bbudgets = bbudgetsService.selectById(bj.getBudgetId());
                                budgets.setBudgetName(bbudgets.getBudgetName());
                                boolean insert = projectBillsBudgetsService.insert(budgets);
                                if (!insert) {
                                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                    result.addErrorMessage("提交失败：新建预算失败");
                                    return result;
                                }
                            }
                        }
                        billsSubs1.setBudgetAmt(amt);
                        billsSubs1.setBudgetProfit(DataUtils.keepDecimals(billsSubs1.getAmt() - billsSubs1.getBudgetAmt()));
                        billsSubs1.setBudgetProfitRate(new Double(new DecimalFormat("#.00").format((billsSubs1.getBudgetProfit() / billsSubs1.getAmt() * 100))));
                        boolean updateById2 = projectBillsSubsService.updateById(billsSubs1);
                        if (!updateById2) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：更新预算金额失败");
                            return result;
                        }
                        projectBillsAdjusts.setBillStatus(6);
                        boolean update = projectBillsAdjustsService.updateById(projectBillsAdjusts);
                        if (!update) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("审批通过失败: 更新状态失败");
                            return result;
                        }
                    } else if ("F".equals(at.getIffinalItem())) {
                        projectBillsAdjusts.setBillStatus(5);
                        boolean update = projectBillsAdjustsService.updateById(projectBillsAdjusts);
                        if (!update) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("审批通过失败: 更新状态失败");
                            return result;
                        }
                        at.setLevelId(at.getLevelId() + 1);
                        int updateNum = auditItemsService.updateAuditStatus(at);
                        if (updateNum <= 0) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("审批通过失败: 更新审批状态失败");
                            return result;
                        }
                        return result;
                    }
                    return result;
                }
            }
        }
        if (number <= 0) {
            result.addErrorMessage("该审批已被操作");
            return result;
        }
        return result;
    }

    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> approvedInvoiceIndirectCr(AuditItemsDto auditItemsDto, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        InvoiceBills invoiceBills = invoiceBillsService.selectById(auditItemsDto.getId());
        EntityWrapper<AuditItems> auditItemsEntityWrapper = new EntityWrapper<>();
        auditItemsEntityWrapper.eq("bill_no", invoiceBills.getBillNo())
                .eq("act_id", auditItemsDto.getActId())
                .eq("branch_id", invoiceBills.getBranchId());
        List<AuditItems> auditItems = auditItemsService.selectList(auditItemsEntityWrapper);
        int number = 0;
        for (AuditItems at : auditItems) {
            if ((at.getAuditUserId() == sysUserDto.getUserId().intValue()) && at.getAuditStatus().equals("S")) {
                number++;
                if (auditItemsDto.getAuditMsg() == null || "".equals(auditItemsDto.getAuditMsg())) {
                    at.setAuditMsg("同意");
                } else {
                    at.setAuditMsg(auditItemsDto.getAuditMsg());
                }
                at.setAuditStatus("A");
                at.setAuditItem(new Date());
                boolean updateById = auditItemsService.updateById(at);
                if (!updateById) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("审批通过失败: 更新审批状态失败");
                    return result;
                }
                if (at.getIffinalItem().equals("T")) {
                    invoiceBills.setBillStatus(6);
                    boolean update = invoiceBillsService.updateById(invoiceBills);
                    if (!update) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("审批通过失败: 更新状态失败");
                        return result;
                    }
                    EntityWrapper<InvoiceBillsShares> sharesEntityWrapper = new EntityWrapper<>();
                    sharesEntityWrapper.eq("bill_no", invoiceBills.getBillNo())
                            .eq("act_id", 202);
                    List<InvoiceBillsShares> invoiceBillsShares = invoiceBillsSharesService.selectList(sharesEntityWrapper);
                    for (InvoiceBillsShares ib : invoiceBillsShares) {
                        EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
                        projectBillsBudgetsEntityWrapper.eq("project_sub_no", ib.getProjectSubNo())
                                .eq("budget_id", ib.getBudgetId());
                        ProjectBillsBudgets billsBudgets = projectBillsBudgetsService.selectOne(projectBillsBudgetsEntityWrapper);
                        billsBudgets.setBudgetUseAmt(billsBudgets.getBudgetUseAmt() + ib.getShareAmt());
                        billsBudgets.setSubInvAmtCr(billsBudgets.getSubInvAmtCr() + ib.getShareAmt());
                        boolean updateBudget = projectBillsBudgetsService.updateById(billsBudgets);
                        if (!updateBudget) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：更新项目预算失败。");
                            return result;
                        }
                        EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
                        projectBillsSubsEntityWrapper.setSqlSelect("id", "sub_inv_amt_cr")
                                .eq("project_sub_no", ib.getProjectSubNo());
                        ProjectBillsSubs billsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
                        billsSubs.setSubInvAmtCr(billsSubs.getSubInvAmtCr() + ib.getShareAmt());
                        boolean updateSubs = projectBillsSubsService.updateById(billsSubs);
                        if (!updateSubs) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：更新累计成本失败。");
                            return result;
                        }
                        EntityWrapper<InvoiceBillsIndirect> invoiceBillsIndirectEntityWrapper = new EntityWrapper<>();
                        invoiceBillsIndirectEntityWrapper.setSqlSelect("id", "sub_inv_amt_cr")
                                .eq("project_sub_no", ib.getProjectSubNo())
                                .eq("budget_id", ib.getBudgetId())
                                .eq("purchase_id", invoiceBills.getPurchaseId());
                        InvoiceBillsIndirect invoiceBillsIndirect = invoiceBillsIndirectService.selectOne(invoiceBillsIndirectEntityWrapper);
                        if (invoiceBillsIndirect != null) {
                            invoiceBillsIndirect.setSubInvAmtCr(invoiceBillsIndirect.getSubInvAmtCr() + ib.getShareAmt());
                            boolean updateInvoice = invoiceBillsIndirectService.updateById(invoiceBillsIndirect);
                            if (!updateInvoice) {
                                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                return result;
                            }
                        } else {
                            InvoiceBillsIndirect invoiceIndirect = new InvoiceBillsIndirect();
                            invoiceIndirect.setBillNo(ib.getBillNo());
                            invoiceIndirect.setProjectSubNo(ib.getProjectSubNo());
                            invoiceIndirect.setBudgetId(ib.getBudgetId());
                            invoiceIndirect.setPurchaseId(invoiceBills.getPurchaseId());
                            invoiceIndirect.setSubInvAmtCr(ib.getShareAmt());
                            boolean insert = invoiceBillsIndirectService.insert(invoiceIndirect);
                            if (!insert) {
                                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                return result;
                            }
                        }
                        ib.setBudgetUseAmt(billsBudgets.getBudgetUseAmt());
                        boolean insert = invoiceBillsSharesService.insert(ib);
                        if (!insert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：新建费用分摊明细失败。");
                            return result;
                        }
                    }
                    EntityWrapper<OtherProject> otherProjectEntityWrapper = new EntityWrapper<>();
                    otherProjectEntityWrapper.setSqlSelect("id", "contract_total_amt", "attach_id")
                            .eq("purchase_nc_no", invoiceBills.getPurchaseNcNo());
                    OtherProject otherProject = otherProjectService.selectOne(otherProjectEntityWrapper);
                    if (otherProject != null) {
                        if (invoiceBills.getFileAddress() != null) {
                            if (otherProject.getAttachId() == null) {
                                otherProject.setAttachId(invoiceBills.getFileAddress());
                                otherProject.setAttachName(invoiceBills.getFileName());
                            }
                        }
                        otherProject.setContractTotalAmt(otherProject.getContractTotalAmt() + invoiceBills.getInvAmt());
                        boolean updateOther = otherProjectService.updateById(otherProject);
                        if (!updateOther) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：更新其他合同失败。");
                            return result;
                        }
                    } else {
                        OtherProject otherPro = new OtherProject();
                        if (invoiceBills.getFileAddress() != null) {
                            otherPro.setAttachId(invoiceBills.getFileAddress());
                            otherPro.setAttachName(invoiceBills.getFileName());
                        }
                        otherPro.setPurchaseNcNo(invoiceBills.getPurchaseNcNo());
                        otherPro.setPurchasesId(invoiceBills.getPurchaseId());
                        otherPro.setBudgetId(invoiceBills.getBudgetId());
                        otherPro.setContractAmt(invoiceBills.getContractAmt());
                        otherPro.setOpUserId(sysUserDto.getUserId().intValue());
                        otherPro.setOpDate(new Date());
                        otherPro.setStatus(6);
                        otherPro.setContractTotalAmt(invoiceBills.getInvAmt());
                        boolean insert = otherProjectService.insert(otherPro);
                        if (!insert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：新建其他合同失败");
                            return result;
                        }
                    }
                } else if (at.getIffinalItem().equals("F")) {
                    invoiceBills.setBillStatus(5);
                    boolean update = invoiceBillsService.updateById(invoiceBills);
                    if (!update) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("审批通过失败: 更新状态失败");
                        return result;
                    }
                    at.setLevelId(at.getLevelId() + 1);
                    int updateNum = auditItemsService.updateAuditStatus(at);
                    if (updateNum <= 0) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("审批通过失败: 更新审批状态失败");
                        return result;
                    }
                    return result;
                }
            }
        }
        if (number <= 0) {
            result.addErrorMessage("该审批已被操作");
            return result;
        }
        return result;
    }

    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> approvedPayCr(AuditItemsDto auditItemsDto, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        PayCrBills payCrBills = payCrBillsService.selectById(auditItemsDto.getId());
        EntityWrapper<ProjectBillsSubs> entityWrapper = new EntityWrapper<>();
        entityWrapper.setSqlSelect("id", "approval_branch_id");
        if (Objects.equals(auditItemsDto.getActId(), 570)) {
            EntityWrapper<PayCrBillsShares> sharesEntityWrapper = new EntityWrapper<>();
            sharesEntityWrapper.eq("bill_no", payCrBills.getBillNo())
                    .eq("purcaser_id", payCrBills.getPurcaserId());
            List<PayCrBillsShares> payCrBillsShares = payCrBillsSharesService.selectList(sharesEntityWrapper);
            entityWrapper.eq("project_sub_no", payCrBillsShares.get(0).getProjectSubNo());
        } else {
            entityWrapper.eq("project_sub_no", payCrBills.getProjectSubNo());
        }
        entityWrapper.eq("branch_id", payCrBills.getBranchId());
        ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(entityWrapper);
        EntityWrapper<AuditItems> auditItemsEntityWrapper = new EntityWrapper<>();
        auditItemsEntityWrapper.eq("bill_no", payCrBills.getBillNo())
                .eq("act_id", auditItemsDto.getActId())
                .eq("branch_id", projectBillsSubs.getApprovalBranchId());
        if (Objects.equals(auditItemsDto.getActId(), 560)) {
            auditItemsEntityWrapper.eq("project_no", payCrBills.getProjectSubNo());
        }
        List<AuditItems> auditItems = auditItemsService.selectList(auditItemsEntityWrapper);
        int number = 0;
        for (AuditItems at : auditItems) {
            if (!"S".equals(at.getAuditStatus())) {
                continue;
            }
            EntityWrapper<AuditItemsUsers> itemsUsersEntityWrapper = new EntityWrapper<>();
            itemsUsersEntityWrapper.eq("pid", at.getId());
            List<AuditItemsUsers> auditItemsUsers = auditItemsUsersService.selectList(itemsUsersEntityWrapper);
            for (AuditItemsUsers au : auditItemsUsers) {
                if (au.getUserId() == sysUserDto.getUserId().intValue() && au.getAuditStatus().equals("S")) {
                    number++;
                    if (auditItemsDto.getAuditMsg() == null || "".equals(auditItemsDto.getAuditMsg())) {
                        at.setAuditMsg("同意");
                    } else {
                        at.setAuditMsg(auditItemsDto.getAuditMsg());
                    }
                    at.setAuditStatus("A");
                    at.setAuditItem(new Date());
                    boolean updateById = auditItemsService.updateById(at);
                    if (!updateById) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("审批通过失败: 更新审批状态失败");
                        return result;
                    }
                    if (at.getIffinalItem().equals("T")) {
                        payCrBills.setBillStatus(6);
                        boolean update = payCrBillsService.updateById(payCrBills);
                        if (!update) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("审批通过失败: 更新状态失败");
                            return result;
                        }
                    } else if (at.getIffinalItem().equals("F")) {
                        payCrBills.setBillStatus(5);
                        boolean update = payCrBillsService.updateById(payCrBills);
                        if (!update) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("审批通过失败: 更新状态失败");
                            return result;
                        }
                        at.setLevelId(at.getLevelId() + 1);
                        int updateNum = 0;
                        if (Objects.equals(auditItemsDto.getActId(), 560)) {
                            auditItemsEntityWrapper.eq("project_no", payCrBills.getProjectSubNo());
                            updateNum = auditItemsService.updateAuditStatus(at);
                        } else {
                            updateNum = auditItemsService.updateInvShareAuditStatus(at);
                        }
                        if (updateNum <= 0) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("审批通过失败: 更新审批状态失败");
                            return result;
                        }
                        return result;
                    }
                }
            }
        }
        if (number <= 0) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            result.addErrorMessage("该审批已被操作");
            return result;
        }
        return result;
    }

    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> approvedAdjusts(AuditItemsDto auditItemsDto, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        PayCrBills payCrBills = payCrBillsService.selectById(auditItemsDto.getId());
        EntityWrapper<AuditItems> auditItemsEntityWrapper = new EntityWrapper<>();
        auditItemsEntityWrapper.eq("bill_no", payCrBills.getBillNo())
                .eq("act_id", auditItemsDto.getActId())
                .eq("branch_id", payCrBills.getBranchId());
        List<AuditItems> auditItems = auditItemsService.selectList(auditItemsEntityWrapper);
        for (AuditItems at : auditItems) {
            if ((at.getAuditUserId() == sysUserDto.getUserId().intValue()) && at.getAuditStatus().equals("S")) {
                if (auditItemsDto.getAuditMsg() == null || "".equals(auditItemsDto.getAuditMsg())) {
                    at.setAuditMsg("同意");
                } else {
                    at.setAuditMsg(auditItemsDto.getAuditMsg());
                }
                at.setAuditStatus("A");
                at.setAuditItem(new Date());
                boolean updateById = auditItemsService.updateById(at);
                if (!updateById) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("审批通过失败: 更新审批状态失败");
                    return result;
                }
                if (at.getIffinalItem().equals("T")) {
                    payCrBills.setBillStatus(6);
                    boolean update = payCrBillsService.updateById(payCrBills);
                    if (!update) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("审批通过失败: 更新状态失败");
                        return result;
                    }
                } else if (at.getIffinalItem().equals("F")) {
                    payCrBills.setBillStatus(5);
                    boolean update = payCrBillsService.updateById(payCrBills);
                    if (!update) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("审批通过失败: 更新状态失败");
                        return result;
                    }
                    at.setLevelId(at.getLevelId() + 1);
                    int updateNum = auditItemsService.updateAuditStatus(at);
                    if (updateNum <= 0) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("审批通过失败: 更新审批状态失败");
                        return result;
                    }
                    return result;
                }
            }
        }
        return result;
    }

    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> approvedProject(AuditItemsDto auditItemsDto, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        Projectbills projectbills = projectbillsService.selectById(auditItemsDto.getId());
        EntityWrapper<AuditItems> auditItemsEntityWrapper = new EntityWrapper<>();
        auditItemsEntityWrapper.eq("bill_no", projectbills.getBillNo())
                .eq("act_id", auditItemsDto.getActId())
                .eq("sub_ject", projectbills.getProjectName())
                .eq("project_no", projectbills.getProjectNo());
        List<AuditItems> auditItems = auditItemsService.selectList(auditItemsEntityWrapper);
        int number = 0;
        for (AuditItems at : auditItems) {
            if (!"S".equals(at.getAuditStatus())) {
                continue;
            }
            EntityWrapper<AuditItemsUsers> itemsUsersEntityWrapper = new EntityWrapper<>();
            itemsUsersEntityWrapper.eq("pid", at.getId());
            List<AuditItemsUsers> auditItemsUsers = auditItemsUsersService.selectList(itemsUsersEntityWrapper);
            for (AuditItemsUsers au : auditItemsUsers) {
                if (au.getUserId() == sysUserDto.getUserId().intValue() && au.getAuditStatus().equals("S")) {
                    number++;
                    if (auditItemsDto.getAuditMsg() == null || "".equals(auditItemsDto.getAuditMsg())) {
                        at.setAuditMsg("同意");
                    } else {
                        at.setAuditMsg(auditItemsDto.getAuditMsg());
                    }
                    at.setAuditStatus("A");
                    at.setAuditItem(new Date());
                    at.setAuditUserId(au.getUserId());
                    boolean updateById = auditItemsService.updateById(at);
                    if (!updateById) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("审批通过失败: 更新审批状态失败");
                        return result;
                    }
                    au.setAuditStatus("A");
                    boolean updateByIemUser = auditItemsUsersService.updateById(au);
                    if (!updateByIemUser) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("审批通过失败: 更新审批状态失败");
                        return result;
                    }
                    if (at.getIffinalItem().equals("T")) {
                        if (Objects.equals(auditItemsDto.getActId(), 340)) {
                            projectbills.setStartDateEnd(6);
                            ProjectAnnex projectAnnex = new ProjectAnnex();
                            projectAnnex.setSrcActId(302);
                            projectAnnex.setProjectId(projectbills.getId());
                            projectAnnex.setFileName("竣工报告");
                            projectAnnex.setFileAddress(projectbills.getSetEndAttachId());
                            projectAnnex.setBranId(projectbills.getBranchId());
                            boolean proInsert = projectAnnexService.insert(projectAnnex);
                            if (!proInsert) {
                                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                result.addErrorMessage("提交失败：更新附件失败");
                                return result;
                            }
                            EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
                            projectBillsSubsEntityWrapper.eq("bill_no", projectbills.getBillNo());
                            ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
                            projectBillsSubs.setProjectStatus(30);
                            boolean updateById1 = projectBillsSubsService.updateById(projectBillsSubs);
                            if (!updateById1) {
                                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                result.addErrorMessage("审批通过失败: 更新工程状态失败");
                                return result;
                            }
                            boolean update = projectbillsService.updateById(projectbills);
                            if (!update) {
                                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                result.addErrorMessage("审批通过失败: 更新竣工状态失败");
                                return result;
                            }
                            return result;
                        } else if (Objects.equals(auditItemsDto.getActId(), 610)) {
                            projectbills.setSettlementStatus(6);
                            projectbills.setAmt(projectbills.getContractAuditAmt());
                            boolean updateByProject = projectbillsService.updateById(projectbills);
                            if (!updateByProject) {
                                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                result.addErrorMessage("审批通过失败: 更新单据状态失败");
                                return result;
                            }
                            EntityWrapper<ProjectBillsSubs> subsEntityWrapper = new EntityWrapper<>();
                            subsEntityWrapper.eq("bill_no", projectbills.getBillNo())
                                    .eq("corp_id", projectbills.getCorpId())
                                    .eq("branch_id", projectbills.getBranchId());
                            List<ProjectBillsSubs> projectBillsSubs = projectBillsSubsService.selectList(subsEntityWrapper);
                            for (ProjectBillsSubs pb : projectBillsSubs) {
                                pb.setAmt(pb.getContractAuditAmt());
                                pb.setBudgetProfit(pb.getAmt() - pb.getBudgetAmt());
                                pb.setBudgetProfitRate((double) Math.round((pb.getBudgetProfit() / pb.getAmt()) * 100));
                                boolean updateByProSub = projectBillsSubsService.updateById(pb);
                                if (!updateByProSub) {
                                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                    result.addErrorMessage("审批通过失败: 更新单据状态失败");
                                    return result;
                                }
                            }
                        } else if (Objects.equals(auditItemsDto.getActId(), 710)) {
                            projectbills.setRenewProjectStatus(6);
                            boolean update = projectbillsService.updateById(projectbills);
                            if (!update) {
                                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                result.addErrorMessage("审批通过失败: 更新审批状态失败");
                                return result;
                            }
                            return result;
                        }
                    } else if (at.getIffinalItem().equals("F")) {
                        if (Objects.equals(auditItemsDto.getActId(), 340)) {
                            projectbills.setStartDateEnd(5);
                            boolean update = projectbillsService.updateById(projectbills);
                            if (!update) {
                                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                result.addErrorMessage("审批通过失败: 更新竣工状态失败");
                                return result;
                            }
                            at.setLevelId(at.getLevelId() + 1);
                            int updateNum = auditItemsService.updateAuditStatus(at);
                            if (updateNum <= 0) {
                                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                result.addErrorMessage("审批通过失败: 更新审批状态失败");
                                return result;
                            }

                            return result;
                        }
                        if (Objects.equals(auditItemsDto.getActId(), 710)) {
                            projectbills.setRenewProjectStatus(7);
                            boolean update = projectbillsService.updateById(projectbills);
                            if (!update) {
                                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                result.addErrorMessage("审批通过失败: 更新状态失败");
                                return result;
                            }
                            at.setLevelId(at.getLevelId() + 1);
                            int updateNum = auditItemsService.updateAuditStatus(at);
                            if (updateNum <= 0) {
                                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                result.addErrorMessage("审批通过失败: 更新审批状态失败");
                                return result;
                            }
                            return result;
                        }
                    }
                    break;
                }
            }
        }
        return result;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> approvalRejected(AuditItemsDto auditItemsDto, SysUserDto sysUserDto) {
        /* 驳回 */
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            if (auditItemsDto != null && auditItemsDto.getId() != null && auditItemsDto.getActId() != null) {
                if (Objects.equals(auditItemsDto.getActId(), 340) || Objects.equals(auditItemsDto.getActId(), 610)
                        || Objects.equals(auditItemsDto.getActId(), 710)) {
                    result = this.approvalRejectedProject(auditItemsDto, sysUserDto);
                    return result;
                } else if (Objects.equals(auditItemsDto.getActId(), 310) || Objects.equals(auditItemsDto.getActId(), 630)
                        || Objects.equals(auditItemsDto.getActId(), 650) || Objects.equals(auditItemsDto.getActId(), 655)
                        || Objects.equals(auditItemsDto.getActId(), 730)) {
                    result = this.approvalRejectedProgressBudget(auditItemsDto, sysUserDto);
                    return result;
                } else if ((auditItemsDto.getActId() >= 420 && auditItemsDto.getActId() <= 443)
                        || (auditItemsDto.getActId() >= 450 && auditItemsDto.getActId() <= 465)
                        || (auditItemsDto.getActId() >= 470 && auditItemsDto.getActId() <= 473)) {
                    result = this.approvalRejectedPurchase(auditItemsDto, sysUserDto);
                    return result;
                } else if (Objects.equals(auditItemsDto.getActId(), 510) || Objects.equals(auditItemsDto.getActId(), 520)
                        || Objects.equals(auditItemsDto.getActId(), 530)) {
                    result = this.approvalRejectedInvoiceCr(auditItemsDto, sysUserDto);
                    return result;
                } else if (Objects.equals(auditItemsDto.getActId(), 540)) {
                    result = this.approvalRejectedInvoiceIndirectCr(auditItemsDto, sysUserDto);
                    return result;
                } else if (Objects.equals(auditItemsDto.getActId(), 560) || Objects.equals(auditItemsDto.getActId(), 570)) {
                    result = this.approvalRejectedPayCr(auditItemsDto, sysUserDto);
                    return result;
                } else if (Objects.equals(auditItemsDto.getActId(), 830)) {
                    result = this.approvalRejectedAdjusts(auditItemsDto, sysUserDto);
                    return result;
                }
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 审批驳回失败：" + e.toString(), e);
            result.addErrorMessage("审批驳回失败：提交信息有误");
            return result;
        }
        return result;
    }

    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> approvalRejectedPurchase(AuditItemsDto auditItemsDto, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        PurchaseBills projectbills = purchaseBillsService.selectById(auditItemsDto.getId());
        projectbills.setBillStatus(3);
        boolean update = purchaseBillsService.updateById(projectbills);
        if (!update) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            result.addErrorMessage("审批驳回失败: 更新采购状态失败");
            return result;
        }
        EntityWrapper<ProjectBillsSubs> subsEntityWrapper = new EntityWrapper<>();
        subsEntityWrapper.eq("project_sub_no", projectbills.getProjectSubNo())
                .eq("branch_id", projectbills.getContractorId());
        ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(subsEntityWrapper);
        EntityWrapper<AuditItems> auditItemsEntityWrapper = new EntityWrapper<>();
        auditItemsEntityWrapper.eq("bill_no", projectbills.getBillNo())
                .eq("act_id", auditItemsDto.getActId())
                .eq("sub_ject", projectBillsSubs.getProjectSubName())
                .eq("project_no", projectbills.getProjectSubNo());
        List<AuditItems> auditItems = auditItemsService.selectList(auditItemsEntityWrapper);
        int number = 0;
        for (AuditItems at : auditItems) {
            if (!"S".equals(at.getAuditStatus())) {
                continue;
            }
            EntityWrapper<AuditItemsUsers> itemsUsersEntityWrapper = new EntityWrapper<>();
            itemsUsersEntityWrapper.eq("pid", at.getId());
            List<AuditItemsUsers> auditItemsUsers = auditItemsUsersService.selectList(itemsUsersEntityWrapper);
            for (AuditItemsUsers au : auditItemsUsers) {
                if (Objects.equals(au.getUserId(), sysUserDto.getUserId().intValue())) {
                    number++;
                    at.setAuditStatus("B");
                    if (auditItemsDto.getAuditMsg() == null || "".equals(auditItemsDto.getAuditMsg())) {
                        at.setAuditMsg("不同意");
                    } else {
                        at.setAuditMsg(auditItemsDto.getAuditMsg());
                    }
                    at.setAuditItem(new Date());
                    at.setAuditUserId(au.getUserId());
                    boolean updateById = auditItemsService.updateById(at);
                    if (!updateById) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("审批驳回失败: 更新审批状态失败");
                        return result;
                    }
                    au.setAuditStatus("B");
                    boolean updateByAuditUser = auditItemsUsersService.updateById(au);
                    if (!updateByAuditUser) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("审批驳回失败: 更新审批状态失败");
                        return result;
                    }
                    if ((auditItemsDto.getActId() >= 420 && auditItemsDto.getActId() <= 443)) {
                        EntityWrapper<ProjectBillsBudgets> budgetsEntityWrapper = new EntityWrapper<>();
                        budgetsEntityWrapper.eq("project_sub_no", projectbills.getProjectSubNo())
                                .eq("budget_id", 2)
                                .eq("branch_id", projectBillsSubs.getBranchId());
                        ProjectBillsBudgets projectBillsBudgets = projectBillsBudgetsService.selectOne(budgetsEntityWrapper);
                        projectBillsBudgets.setBudgetUseAmt(projectBillsBudgets.getBudgetUseAmt() - projectbills.getAmt());
                        boolean updateBudget = projectBillsBudgetsService.updateById(projectBillsBudgets);
                        if (!updateBudget) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("审批驳回失败！更新预算失败");
                            return result;
                        }
                        double amt = projectBillsBudgetsService.selectApprovedAmountSum(projectBillsBudgets);
                        projectBillsSubs.setActualBudgetAmt(amt);
                        boolean updateByProSub = projectBillsSubsService.updateById(projectBillsSubs);
                        if (!updateByProSub) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("审批驳回失败！更新预算失败");
                            return result;
                        }
                        EntityWrapper<PurchaseBillsItems> entityWrapper = new EntityWrapper<>();
                        entityWrapper.eq("bill_no", projectbills.getBillNo())
                                .eq("project_sub_no", projectbills.getProjectSubNo());
                        List<PurchaseBillsItems> billsItemsDtos = purchaseBillsItemsService.selectList(entityWrapper);
                        if (billsItemsDtos.size() != 0) {
                            for (PurchaseBillsItems items : billsItemsDtos) {
                                EntityWrapper<PurchaseBillsItems> purchaseBillsItemsEntityWrapper = new EntityWrapper<>();
                                purchaseBillsItemsEntityWrapper.eq("bill_no", items.getSrcBillNo())
                                        .eq("lino_no", items.getSrcLinoNo())
                                        .eq("project_sub_no", items.getProjectSubNo());
                                PurchaseBillsItems updateItem = purchaseBillsItemsService.selectOne(purchaseBillsItemsEntityWrapper);
                                updateItem.setPurchaseInvQty(updateItem.getPurchaseInvQty() - items.getRequireQty().intValue());
                                updateItem.setTimeAmt(updateItem.getTimeAmt() - items.getTimeAmt());
                                boolean updeteType = purchaseBillsItemsService.updateById(updateItem);
                                if (!updeteType) {
                                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                    result.addErrorMessage("审批驳回失败: 更新预算失败");
                                    return result;
                                }
                            }
                        }
                    } else if ((auditItemsDto.getActId() >= 450 && auditItemsDto.getActId() <= 465)) {
                        EntityWrapper<ProjectBillsBudgets> budgetsEntityWrapper = new EntityWrapper<>();
                        budgetsEntityWrapper.eq("project_sub_no", projectbills.getProjectSubNo())
                                .eq("budget_id", 1)
                                .eq("branch_id", projectBillsSubs.getBranchId());
                        ProjectBillsBudgets projectBillsBudgets = projectBillsBudgetsService.selectOne(budgetsEntityWrapper);
                        projectBillsBudgets.setBudgetUseAmt(projectBillsBudgets.getBudgetUseAmt() - projectbills.getAmt());
                        boolean updateProBudget = projectBillsBudgetsService.updateById(projectBillsBudgets);
                        if (!updateProBudget) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("审批驳回失败！更新预算失败");
                            return result;
                        }
                        double amt = projectBillsBudgetsService.selectApprovedAmountSum(projectBillsBudgets);
                        projectBillsSubs.setActualBudgetAmt(amt);
                        boolean updateByProSub = projectBillsSubsService.updateById(projectBillsSubs);
                        if (!updateByProSub) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("审批驳回失败！更新预算失败");
                            return result;
                        }
                    } else if (auditItemsDto.getActId() >= 470 && auditItemsDto.getActId() <= 473) {
                        EntityWrapper<ProjectBillsBudgets> budgetsEntityWrapper = new EntityWrapper<>();
                        budgetsEntityWrapper.eq("project_sub_no", projectbills.getProjectSubNo())
                                .eq("budget_id", 1)
                                .eq("branch_id", projectbills.getContractorId());
                        ProjectBillsBudgets projectBillsBudgets = projectBillsBudgetsService.selectOne(budgetsEntityWrapper);
                        projectBillsBudgets.setBudgetUseAmt(projectBillsBudgets.getBudgetUseAmt() - projectbills.getAmt());
                        boolean updateBudget = projectBillsBudgetsService.updateById(projectBillsBudgets);
                        if (!updateBudget) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("审批驳回失败！更新预算失败");
                            return result;
                        }
                        double amt = projectBillsBudgetsService.selectApprovedAmountSum(projectBillsBudgets);
                        projectBillsSubs.setActualBudgetAmt(amt);
                        boolean updateByProSub = projectBillsSubsService.updateById(projectBillsSubs);
                        if (!updateByProSub) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("审批驳回失败！更新预算失败");
                            return result;
                        }
                    }
                    int deleteNum = auditItemsService.deleteUpLevelId(at);
                    if (deleteNum <= 0) {
                        logger.error("未删除审批信息");
                    }
                    break;
                }
            }
        }
        if (number <= 0) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            result.addErrorMessage("该审批已被操作");
            return result;
        }
        return result;
    }

    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> approvalRejectedProgressBudget(AuditItemsDto auditItemsDto, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectById(auditItemsDto.getId());
        if (Objects.equals(auditItemsDto.getActId(), 310)) {
            EntityWrapper<ProjectBillsSteps> stepsEntityWrapper = new EntityWrapper<>();
            stepsEntityWrapper.eq("project_sub_no", projectBillsSubs.getProjectSubNo())
                    .eq("branch_id", projectBillsSubs.getBranchId())
                    .in("status", new Integer[]{4, 5});
            List<ProjectBillsSteps> projectBillsSteps = projectBillsStepsService.selectList(stepsEntityWrapper);
            for (ProjectBillsSteps step : projectBillsSteps) {
                step.setStatus(3);
                if (!projectBillsStepsService.updateById(step)) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("审批驳回失败: 更新节点状态失败");
                    return result;
                }
            }
        } else if (Objects.equals(auditItemsDto.getActId(), 630)) {
            EntityWrapper<SubContractBills> contractBillsEntityWrapper = new EntityWrapper<>();
            contractBillsEntityWrapper.eq("project_sub_no", projectBillsSubs.getProjectSubNo())
                    .eq("branch_id", projectBillsSubs.getBranchId());
            List<SubContractBills> subContractBills = subContractBillsService.selectList(contractBillsEntityWrapper);
            for (SubContractBills sc : subContractBills) {
                if (Objects.equals(sc.getSettlementStatus(), 4) || Objects.equals(sc.getSettlementStatus(), 5)) {
                    sc.setSettlementStatus(3);
                    boolean updateById = subContractBillsService.updateById(sc);
                    if (!updateById) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("审批驳回失败: 更新数据失败");
                        return result;
                    }
                }
            }
        } else if (Objects.equals(auditItemsDto.getActId(), 650) || Objects.equals(auditItemsDto.getActId(), 655)) {
            if (Objects.equals(auditItemsDto.getActId(), 655)) {
                projectBillsSubs.setSettlerChStatus("S");
            } else {
                projectBillsSubs.setClosingStatus("S");
                double amt = 0.0;
                EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
                projectBillsBudgetsEntityWrapper.eq("project_sub_no", projectBillsSubs.getProjectSubNo())
                        .eq("branch_id", projectBillsSubs.getBranchId());
                List<ProjectBillsBudgets> billsBudgets = projectBillsBudgetsService.selectList(projectBillsBudgetsEntityWrapper);
                if (billsBudgets.size() != 0) {
                    for (ProjectBillsBudgets pb : billsBudgets) {
                        pb.setBranchId(projectBillsSubs.getBranchId());
                        if (!projectBillsBudgetsService.insert(pb)) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("新增成本失败,请检查成本信息");
                            return result;
                        }
                        if (Objects.equals(pb.getBudgetAmt(), 0)) {
                            amt = DataUtils.keepDecimals(amt + pb.getApprovedAmount());
                        }
                    }
                }
                projectBillsSubs.setSubAmtCr(DataUtils.keepDecimals(projectBillsSubs.getSubAmtCr() - amt));
            }
            boolean update = projectBillsSubsService.updateById(projectBillsSubs);
            if (!update) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("审批驳回失败: 更新状态失败");
                return result;
            }
        } else {
            projectBillsSubs.setProjectBudgetStatus(3);
            boolean update = projectBillsSubsService.updateById(projectBillsSubs);
            if (!update) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("审批驳回失败: 更新状态失败");
                return result;
            }
        }
        EntityWrapper<AuditItems> auditItemsEntityWrapper = new EntityWrapper<>();
        auditItemsEntityWrapper.eq("bill_no", projectBillsSubs.getBillNo())
                .eq("act_id", auditItemsDto.getActId())
                .eq("sub_ject", projectBillsSubs.getProjectSubName())
                .eq("project_no", projectBillsSubs.getProjectSubNo());
        List<AuditItems> auditItems = auditItemsService.selectList(auditItemsEntityWrapper);
        int number = 0;
        for (AuditItems at : auditItems) {
            if (!"S".equals(at.getAuditStatus())) {
                continue;
            }
            EntityWrapper<AuditItemsUsers> itemsUsersEntityWrapper = new EntityWrapper<>();
            itemsUsersEntityWrapper.eq("pid", at.getId());
            List<AuditItemsUsers> auditItemsUsers = auditItemsUsersService.selectList(itemsUsersEntityWrapper);
            for (AuditItemsUsers au : auditItemsUsers) {
                if (Objects.equals(au.getUserId(), sysUserDto.getUserId().intValue())) {
                    number++;
                    at.setAuditStatus("B");
                    if (auditItemsDto.getAuditMsg() == null || "".equals(auditItemsDto.getAuditMsg())) {
                        at.setAuditMsg("不同意");
                    } else {
                        at.setAuditMsg(auditItemsDto.getAuditMsg());
                    }
                    at.setAuditItem(new Date());
                    at.setAuditUserId(au.getUserId());
                    boolean updateById = auditItemsService.updateById(at);
                    if (!updateById) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("审批驳回失败: 更新审批状态失败");
                        return result;
                    }
                    au.setAuditStatus("B");
                    boolean update = auditItemsUsersService.updateById(au);
                    if (!update) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("审批驳回失败: 更新审批状态失败");
                        return result;
                    }
                    if (at.getIffinalItem().equals("F")) {
                        int deleteNum = auditItemsService.deleteUpLevelId(at);
                        if (deleteNum <= 0) {
                            logger.error("未删除审批信息");
                        }
                    }
                }
            }
        }
        if (number <= 0) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            result.addErrorMessage("该审批已被操作");
            return result;
        }
        return result;
    }

    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> approvalRejectedInvoiceCr(AuditItemsDto auditItemsDto, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        InvoiceBills invoiceBills = invoiceBillsService.selectById(auditItemsDto.getId());
        EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
        projectBillsSubsEntityWrapper.eq("project_sub_no", invoiceBills.getProjectSubNo())
                .eq("branch_id", invoiceBills.getBranchId());
        ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
        invoiceBills.setBillStatus(3);
        boolean update = invoiceBillsService.updateById(invoiceBills);
        if (!update) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            result.addErrorMessage("审批驳回失败: 更新状态失败");
            return result;
        }
        if (Objects.equals(auditItemsDto.getActId(), 510) || Objects.equals(auditItemsDto.getActId(), 530)) {
            if (Objects.equals(auditItemsDto.getActId(), 510)) {
                EntityWrapper<SubContractBills> subContractBillsEntityWrapper = new EntityWrapper<>();
                if (invoiceBills.getContractNo() == null || "".equals(invoiceBills.getContractNo())) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("审批驳回失败: 该单据未选择合同编号");
                    return result;
                }
                subContractBillsEntityWrapper.eq("contract_no", invoiceBills.getContractNo())
                        .eq("project_sub_no", invoiceBills.getProjectSubNo())
                        .eq("branch_id", invoiceBills.getBranchId());
                SubContractBills subContractBills = subContractBillsService.selectOne(subContractBillsEntityWrapper);
                subContractBills.setSubInvAmtCr(Double.parseDouble(String.format("%.2f", subContractBills.getSubInvAmtCr() - invoiceBills.getInvAmt())));
                boolean updateBySubCon = subContractBillsService.updateById(subContractBills);
                if (!updateBySubCon) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：更新分包合同失败");
                    return result;
                }
            }
            EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
            projectBillsBudgetsEntityWrapper.eq("project_sub_no", invoiceBills.getProjectSubNo())
                    .eq("budget_id", invoiceBills.getBudgetId())
                    .eq("branch_id", invoiceBills.getBranchId());
            ProjectBillsBudgets billsBudgets = projectBillsBudgetsService.selectOne(projectBillsBudgetsEntityWrapper);
            billsBudgets.setSubInvAmtCr(DataUtils.keepDecimals(billsBudgets.getSubInvAmtCr() - invoiceBills.getInvAmt()));
            billsBudgets.setSubInvAmtBlc(DataUtils.keepDecimals(billsBudgets.getBudgetAmt() - billsBudgets.getSubInvAmtCr()));
            boolean updateByBudget = projectBillsBudgetsService.updateById(billsBudgets);
            if (!updateByBudget) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("提交错误，更新预算失败");
                return result;
            }
            double sum = projectBillsBudgetsService.selectApprovedAmountSum(billsBudgets);
            projectBillsSubs.setActualBudgetAmt(sum);
            projectBillsSubs.setSubInvAmtCr(Double.parseDouble(String.format("%.2f", projectBillsSubs.getSubInvAmtCr() - invoiceBills.getInvAmt())));
            boolean updateById = projectBillsSubsService.updateById(projectBillsSubs);
            if (!updateById) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("提交错误，更新二级项目失败");
                return result;
            }
        } else if (Objects.equals(auditItemsDto.getActId(), 520)) {
            EntityWrapper<ProjectBillsBudgets> billsBudgetsEntityWrapper = new EntityWrapper<>();
            billsBudgetsEntityWrapper.eq("project_sub_no", invoiceBills.getProjectSubNo())
                    .eq("budget_id", 2)
                    .eq("branch_id", invoiceBills.getBranchId());
            ProjectBillsBudgets billsBudgets = projectBillsBudgetsService.selectOne(billsBudgetsEntityWrapper);
            billsBudgets.setSubInvAmtCr(Double.parseDouble(String.format("%.2f", billsBudgets.getSubInvAmtCr() - invoiceBills.getInvAmt())));
            billsBudgets.setSubInvAmtBlc(Double.parseDouble(String.format("%.2f", billsBudgets.getBudgetAmt() - billsBudgets.getSubInvAmtCr())));
            boolean updateByBudget = projectBillsBudgetsService.updateById(billsBudgets);
            if (!updateByBudget) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("提交错误，更新预算失败");
                return result;
            }
            double sum = projectBillsBudgetsService.selectApprovedAmountSum(billsBudgets);
            projectBillsSubs.setActualBudgetAmt(sum);
            projectBillsSubs.setSubInvAmtCr(Double.parseDouble(String.format("%.2f", projectBillsSubs.getSubInvAmtCr() - invoiceBills.getInvAmt())));
            boolean updateBySubs = projectBillsSubsService.updateById(projectBillsSubs);
            if (!updateBySubs) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("提交错误，更新二级项目失败");
                return result;
            }
            EntityWrapper<OtherProject> otherProjectEntityWrapper = new EntityWrapper<>();
            otherProjectEntityWrapper.eq("purchase_nc_no", invoiceBills.getPurchaseNcNo())
                    .eq("project_sub_no", invoiceBills.getProjectSubNo())
                    .eq("branch_id", invoiceBills.getBranchId());
            OtherProject otherProject = otherProjectService.selectOne(otherProjectEntityWrapper);
            otherProject.setContractTotalAmt(Double.parseDouble(String.format("%.2f", otherProject.getContractTotalAmt() - invoiceBills.getInvAmt())));
            boolean otherProjectType = otherProjectService.updateById(otherProject);
            if (!otherProjectType) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("撤回失败: 更新其他合同失败");
                return result;
            }
            if ("F".equals(invoiceBills.getIsSur())) {
                EntityWrapper<PurchaseBillsItems> itemsEntityWrapper = new EntityWrapper<>();
                try {
                    String beginTime = new String("2020-11-19 00:00:00");
                    SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                    Date sd1 = df.parse(beginTime);
                    long long1 = invoiceBills.getCreateDate().getTime();
                    long long2 = sd1.getTime();
                    // 2020-11-19 之前创建的
                    if (long1 < long2) {
                        itemsEntityWrapper.eq("bill_no", invoiceBills.getBillNo())
                                .eq("act_id", 9);
                    } else {
                        itemsEntityWrapper.eq("act_id", 4);
                    }
                    itemsEntityWrapper.eq("project_sub_no", invoiceBills.getProjectSubNo())
                            .eq("purchase_id", invoiceBills.getPurchaseId());
                    List<PurchaseBillsItems> purchaseBillsItemsList = purchaseBillsItemsService.selectList(itemsEntityWrapper);
                    for (PurchaseBillsItems billsItems : purchaseBillsItemsList) {
                        EntityWrapper<InvoicePurchase> purchaseEntityWrapper = new EntityWrapper<>();
                        purchaseEntityWrapper.eq("inv_id", invoiceBills.getId())
                                .eq("purchase_item_id", billsItems.getId());
                        InvoicePurchase invoicePurchase = invoicePurchaseService.selectOne(purchaseEntityWrapper);
                        if (invoicePurchase != null) {
                            billsItems.setTimeQty(invoicePurchase.getTimeQty());
                            billsItems.setTimeAmt(invoicePurchase.getTimeAmt());
                        }
                        billsItems.setInvTotalQty(billsItems.getInvTotalQty() - billsItems.getTimeQty());
                        billsItems.setInvTotalAmt(Double.parseDouble(String.format("%.2f", billsItems.getInvTotalAmt() - billsItems.getTimeAmt())));
                        boolean billType = purchaseBillsItemsService.updateById(billsItems);
                        if (!billType) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：更新累计开票失败");
                        }
                    }
                } catch (ParseException e) {
                    e.printStackTrace();
                }
            }
        }
        EntityWrapper<AuditItems> auditItemsEntityWrapper = new EntityWrapper<>();
        auditItemsEntityWrapper.eq("bill_no", invoiceBills.getBillNo())
                .eq("act_id", auditItemsDto.getActId())
                .eq("sub_ject", projectBillsSubs.getProjectSubName())
                .eq("project_no", invoiceBills.getProjectSubNo())
                .eq("audit_status", "S");
        AuditItems auditItem = auditItemsService.selectOne(auditItemsEntityWrapper);
        if (auditItem == null) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            result.addErrorMessage("该审批已被操作");
            return result;
        }
        auditItem.setAuditStatus("B");
        if (auditItemsDto.getAuditMsg() == null || "".equals(auditItemsDto.getAuditMsg())) {
            auditItem.setAuditMsg("不同意");
        } else {
            auditItem.setAuditMsg(auditItemsDto.getAuditMsg());
        }
        auditItem.setAuditItem(new Date());
        boolean updateById = auditItemsService.updateById(auditItem);
        if (!updateById) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            result.addErrorMessage("审批驳回失败: 更新审批状态失败");
            return result;
        }
        if (auditItem.getIffinalItem().equals("F")) {
            int deleteNum = auditItemsService.deleteUpLevelId(auditItem);
            if (deleteNum <= 0) {
                logger.error("未删除审批信息");
            }
        }
        return result;
    }

    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> approvalRejectedInvoiceIndirectCr(AuditItemsDto auditItemsDto, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        InvoiceBills invoiceBills = invoiceBillsService.selectById(auditItemsDto.getId());
        invoiceBills.setBillStatus(3);
        boolean update = invoiceBillsService.updateById(invoiceBills);
        if (!update) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            result.addErrorMessage("审批驳回失败: 更新状态失败");
            return result;
        }
        EntityWrapper<OtherProject> otherProjectEntityWrapper = new EntityWrapper<>();
        otherProjectEntityWrapper.eq("purchase_nc_no", invoiceBills.getPurchaseNcNo())
                .eq("branch_id", invoiceBills.getBranchId());
        OtherProject otherProject = otherProjectService.selectOne(otherProjectEntityWrapper);
        otherProject.setContractTotalAmt(DataUtils.keepDecimals(otherProject.getContractTotalAmt() - invoiceBills.getInvAmt()));
        boolean updateByOther = otherProjectService.updateById(otherProject);
        if (!updateByOther) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            result.addErrorMessage("提交失败：更新其他合同失败。");
            return result;
        }
        List<InvoiceBillsShares> invoiceBillsShares = invoiceBillsSharesService.selectWithdrawalInvoShareList(invoiceBills);
        for (InvoiceBillsShares is : invoiceBillsShares) {
            EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
            projectBillsBudgetsEntityWrapper.eq("project_sub_no", is.getProjectSubNo())
                    .eq("budget_id", is.getBudgetId())
                    .eq("branch_id", invoiceBills.getBranchId());
            ProjectBillsBudgets billsBudgets = projectBillsBudgetsService.selectOne(projectBillsBudgetsEntityWrapper);
            billsBudgets.setBudgetUseAmt(DataUtils.keepDecimals(billsBudgets.getBudgetUseAmt() - is.getShareAmt()));
            billsBudgets.setSubInvAmtCr(DataUtils.keepDecimals(billsBudgets.getSubInvAmtCr() - is.getShareAmt()));
            if (billsBudgets.getSubInvAmtCr() > billsBudgets.getBudgetAmt()) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("提交失败：" + billsBudgets.getBudgetName() + "已开发票金额超出预算金额");
                return result;
            }
            boolean updateByBudget = projectBillsBudgetsService.updateById(billsBudgets);
            if (!updateByBudget) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("提交失败：更新项目预算失败。");
                return result;
            }
            EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
            projectBillsSubsEntityWrapper.eq("project_sub_no", is.getProjectSubNo())
                    .eq("branch_id", invoiceBills.getBranchId());
            ProjectBillsSubs billsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
            billsSubs.setSubInvAmtCr(DataUtils.keepDecimals(billsSubs.getSubInvAmtCr() - is.getShareAmt()));
            boolean updateByProSub = projectBillsSubsService.updateById(billsSubs);
            if (!updateByProSub) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("提交失败：更新累计成本失败。");
                return result;
            }
            EntityWrapper<InvoiceBillsIndirect> invoiceBillsIndirectEntityWrapper = new EntityWrapper<>();
            invoiceBillsIndirectEntityWrapper.eq("project_sub_no", is.getProjectSubNo())
                    .eq("budget_id", is.getBudgetId())
                    .eq("purchase_id", invoiceBills.getPurchaseId());
            InvoiceBillsIndirect invoiceBillsIndirect = invoiceBillsIndirectService.selectOne(invoiceBillsIndirectEntityWrapper);
            invoiceBillsIndirect.setSubInvAmtCr(DataUtils.keepDecimals(invoiceBillsIndirect.getSubInvAmtCr() - is.getShareAmt()));
            boolean updateByInvIndirect = invoiceBillsIndirectService.updateById(invoiceBillsIndirect);
            if (!updateByInvIndirect) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                return result;
            }
        }
        EntityWrapper<AuditItems> auditItemsEntityWrapper = new EntityWrapper<>();
        auditItemsEntityWrapper.eq("bill_no", invoiceBills.getBillNo())
                .eq("act_id", auditItemsDto.getActId())
                .eq("audit_status", "S");
        AuditItems auditItem = auditItemsService.selectOne(auditItemsEntityWrapper);
        if (auditItem == null) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            result.addErrorMessage("该审批已被操作");
            return result;
        }
        auditItem.setAuditStatus("B");
        if (auditItemsDto.getAuditMsg() == null || "".equals(auditItemsDto.getAuditMsg())) {
            auditItem.setAuditMsg("不同意");
        } else {
            auditItem.setAuditMsg(auditItemsDto.getAuditMsg());
        }
        auditItem.setAuditItem(new Date());
        boolean updateById = auditItemsService.updateById(auditItem);
        if (!updateById) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            result.addErrorMessage("审批驳回失败: 更新审批状态失败");
            return result;
        }
        if ("F".equals(auditItem.getIffinalItem())) {
            int deleteNum = auditItemsService.deleteInvShareUpLevelId(auditItem);
            if (deleteNum <= 0) {
                logger.error("未删除审批信息");
            }
        }
        return result;
    }

    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> approvalRejectedAdjusts(AuditItemsDto auditItemsDto, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        ProjectBillsAdjusts payCrBills = projectBillsAdjustsService.selectById(auditItemsDto.getId());
        payCrBills.setBillStatus(3);
        boolean update = projectBillsAdjustsService.updateById(payCrBills);
        if (!update) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            result.addErrorMessage("审批驳回失败: 更新状态失败");
            return result;
        }
        EntityWrapper<ProjectBillsSubs> entityWrapper = new EntityWrapper<>();
        entityWrapper.setSqlSelect("id", "approval_branch_id")
                .eq("project_sub_no", payCrBills.getProjectSubNo())
                .eq("branch_id", payCrBills.getBranchId());
        ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(entityWrapper);
        EntityWrapper<AuditItems> auditItemsEntityWrapper = new EntityWrapper<>();
        auditItemsEntityWrapper.eq("bill_no", payCrBills.getBillNo())
                .eq("act_id", auditItemsDto.getActId())
                .eq("branch_id", projectBillsSubs.getApprovalBranchId());
        List<AuditItems> auditItems = auditItemsService.selectList(auditItemsEntityWrapper);
        int number = 0;
        for (AuditItems at : auditItems) {
            if (!"S".equals(at.getAuditStatus())) {
                continue;
            }
            EntityWrapper<AuditItemsUsers> itemsUsersEntityWrapper = new EntityWrapper<>();
            itemsUsersEntityWrapper.eq("pid", at.getId());
            List<AuditItemsUsers> auditItemsUsers = auditItemsUsersService.selectList(itemsUsersEntityWrapper);
            for (AuditItemsUsers au : auditItemsUsers) {
                if (Objects.equals(au.getUserId(), sysUserDto.getUserId().intValue())) {
                    number++;
                    at.setAuditStatus("B");
                    if (auditItemsDto.getAuditMsg() == null || "".equals(auditItemsDto.getAuditMsg())) {
                        at.setAuditMsg("不同意");
                    } else {
                        at.setAuditMsg(auditItemsDto.getAuditMsg());
                    }
                    at.setAuditItem(new Date());
                    at.setAuditUserId(au.getUserId());
                    boolean updateById = auditItemsService.updateById(at);
                    if (!updateById) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("审批驳回失败: 更新审批状态失败");
                        return result;
                    }
                    au.setAuditStatus("B");
                    boolean updateByAuditUser = auditItemsUsersService.updateById(au);
                    if (!updateByAuditUser) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("审批驳回失败: 更新审批状态失败");
                        return result;
                    }
                    if ("F".equals(at.getIffinalItem())) {
                        int deleteNum = auditItemsService.deletePayCrUpLevelId(at);
                        if (deleteNum <= 0) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("审批驳回失败: 更新审批状态失败");
                            return result;
                        }
                    }
                    break;
                }
            }
        }
        if (number <= 0) {
            result.addErrorMessage("该审批已被操作");
            return result;
        }
        return result;
    }

    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> approvalRejectedPayCr(AuditItemsDto auditItemsDto, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        PayCrBills payCrBills = payCrBillsService.selectById(auditItemsDto.getId());
        payCrBills.setBillStatus(3);
        boolean update = payCrBillsService.updateById(payCrBills);
        if (!update) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            result.addErrorMessage("审批驳回失败: 更新状态失败");
            return result;
        }
        EntityWrapper<ProjectBillsSubs> entityWrapper = new EntityWrapper<>();
        entityWrapper.setSqlSelect("id", "approval_branch_id");
        if (Objects.equals(auditItemsDto.getActId(), 570)) {
            EntityWrapper<PayCrBillsShares> sharesEntityWrapper = new EntityWrapper<>();
            sharesEntityWrapper.eq("bill_no", payCrBills.getBillNo())
                    .eq("purcaser_id", payCrBills.getPurcaserId());
            List<PayCrBillsShares> payCrBillsShares = payCrBillsSharesService.selectList(sharesEntityWrapper);
            entityWrapper.eq("project_sub_no", payCrBillsShares.get(0).getProjectSubNo())
                    .eq("branch_id", payCrBills.getBranchId());
        } else {
            entityWrapper.eq("project_sub_no", payCrBills.getProjectSubNo())
                    .eq("branch_id", payCrBills.getBranchId());
        }
        ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(entityWrapper);
        EntityWrapper<AuditItems> auditItemsEntityWrapper = new EntityWrapper<>();
        auditItemsEntityWrapper.eq("bill_no", payCrBills.getBillNo())
                .eq("act_id", auditItemsDto.getActId())
                .eq("branch_id", projectBillsSubs.getApprovalBranchId());
        List<AuditItems> auditItems = auditItemsService.selectList(auditItemsEntityWrapper);
        int number = 0;
        for (AuditItems at : auditItems) {
            if (!"S".equals(at.getAuditStatus())) {
                continue;
            }
            EntityWrapper<AuditItemsUsers> itemsUsersEntityWrapper = new EntityWrapper<>();
            itemsUsersEntityWrapper.eq("pid", at.getId());
            List<AuditItemsUsers> auditItemsUsers = auditItemsUsersService.selectList(itemsUsersEntityWrapper);
            for (AuditItemsUsers au : auditItemsUsers) {
                if (Objects.equals(au.getUserId(), sysUserDto.getUserId().intValue())) {
                    number++;
                    at.setAuditStatus("B");
                    if (auditItemsDto.getAuditMsg() == null || "".equals(auditItemsDto.getAuditMsg())) {
                        at.setAuditMsg("不同意");
                    } else {
                        at.setAuditMsg(auditItemsDto.getAuditMsg());
                    }
                    at.setAuditItem(new Date());
                    boolean updateById = auditItemsService.updateById(at);
                    if (!updateById) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("审批驳回失败: 更新审批状态失败");
                        return result;
                    }
                    if (at.getIffinalItem().equals("F")) {
                        int deleteNum = auditItemsService.deletePayCrUpLevelId(at);
                        if (deleteNum <= 0) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("审批驳回失败: 更新审批状态失败");
                            return result;
                        }
                    }
                }
            }
        }
        if (number <= 0) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            result.addErrorMessage("该审批已被操作");
            return result;
        }
        return result;
    }

    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> approvalRejectedProject(AuditItemsDto auditItemsDto, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        Projectbills projectbills = projectbillsService.selectById(auditItemsDto.getId());
        if (Objects.equals(auditItemsDto.getActId(), 340)) {
            projectbills.setStartDateEnd(3);
            boolean update = projectbillsService.updateById(projectbills);
            if (!update) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("审批驳回失败: 更新竣工状态失败");
                return result;
            }
        } else if (Objects.equals(auditItemsDto.getActId(), 610)) {
            projectbills.setSettlementStatus(3);
            projectbills.setAmt(projectbills.getContractAuditAmt());
            boolean updateByProject = projectbillsService.updateById(projectbills);
            if (!updateByProject) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("审批驳回失败: 更新单据状态失败");
                return result;
            }
        } else {
            projectbills.setRenewProjectStatus(3);
            boolean update = projectbillsService.updateById(projectbills);
            if (!update) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("审批驳回失败: 更新审批状态失败");
                return result;
            }
        }
        EntityWrapper<AuditItems> auditItemsEntityWrapper = new EntityWrapper<>();
        auditItemsEntityWrapper.eq("bill_no", projectbills.getBillNo())
                .eq("act_id", auditItemsDto.getActId())
                .eq("sub_ject", projectbills.getProjectName())
                .eq("project_no", projectbills.getProjectNo());
        List<AuditItems> auditItems = auditItemsService.selectList(auditItemsEntityWrapper);
        int number = 0;
        for (AuditItems at : auditItems) {
            if (!"S".equals(at.getAuditStatus())) {
                continue;
            }
            EntityWrapper<AuditItemsUsers> itemsUsersEntityWrapper = new EntityWrapper<>();
            itemsUsersEntityWrapper.eq("pid", at.getId());
            List<AuditItemsUsers> auditItemsUsers = auditItemsUsersService.selectList(itemsUsersEntityWrapper);
            for (AuditItemsUsers au : auditItemsUsers) {
                if (Objects.equals(au.getUserId(), sysUserDto.getUserId().intValue())) {
                    number++;
                    at.setAuditStatus("B");
                    if (auditItemsDto.getAuditMsg() == null || "".equals(auditItemsDto.getAuditMsg())) {
                        at.setAuditMsg("不同意");
                    } else {
                        at.setAuditMsg(auditItemsDto.getAuditMsg());
                    }
                    at.setAuditItem(new Date());
                    at.setAuditUserId(au.getUserId());
                    boolean updateById = auditItemsService.updateById(at);
                    if (!updateById) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("审批驳回失败: 更新审批状态失败");
                        return result;
                    }
                    au.setAuditStatus("B");
                    boolean update = auditItemsUsersService.updateById(au);
                    if (!update) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("审批驳回失败: 更新审批状态失败");
                        return result;
                    }
                    if (at.getIffinalItem().equals("F")) {
                        int deleteNum = auditItemsService.deleteUpLevelId(at);
                        if (deleteNum <= 0) {
                            logger.error("未删除审批信息");
                        }
                    }
                }
            }
        }
        if (number <= 0) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            result.addErrorMessage("该审批已被操作");
            return result;
        }
        return result;
    }

    @Override
    public Map<String, Object> getHomeProList(Map<String, Object> map, SysUserDto sysUserDto) {
        try {
            map.put("registrant", sysUserDto.getUserId().intValue());
            List<Map<String, Object>> mapList = projectbillsService.getHomeProList(map);
            if (mapList.size() != 0) {
                map.put("num", mapList.size());
                map.put("dataList", mapList);
            }
            return map;
        } catch (Exception e) {
            logger.error("操作异常：" + e.toString(), e);
        }
        return map;
    }

    @Override
    public Page selectWarningMatters(Page page, ProjectbillsDto projectbillsDto, SysUserDto sysUserDto) {
        projectbillsDto.setBranchId(sysUserDto.getLoginContractorId());
        // 查询预警信息
        int num = projectbillsService.selectWarningReminderCount(projectbillsDto);
        if (num > 0) {
            Map<String, Object> map = new HashMap<>();
            Page pageDto = DataUtils.processingPage(page);
            map.put("pro", projectbillsDto);
            map.put("page", pageDto);
            List<Map<String, Object>> objectMap = projectbillsService.selectWarningReminderCondition(map);
            pageDto.setTotal(num);
            pageDto.setRecords(objectMap);
            return pageDto;
        }
        return null;
    }

    @Override
    public Double selectSumPurchaseInvCr(InvoiceBillsDto invoiceBillsDto, SysUserDto sysUserDto) {
        double invAmtCr = projectbillsService.selectSumPurchaseInvCr(invoiceBillsDto, sysUserDto);
        double indirectCr = projectbillsService.selectSumPurchaseIndirectInvCr(invoiceBillsDto, sysUserDto);
        return (invAmtCr + indirectCr);
    }

    @Override
    public Page selectAllWarningsCurrent(Page pageDto, ProjectbillsDto projectbillsDto, SysUserDto sysUserDto) {
        Map<String, Object> map = new HashMap<>();
        map.put("pro", projectbillsDto);
        // 查询提醒信息
        projectbillsDto.setBranchId(sysUserDto.getLoginContractorId());
        int num = projectbillsService.selectReminderTotal(projectbillsDto);
        if (num > 0) {
            Page page = DataUtils.processingPage(pageDto);
            map.put("page", page);
            List<Map<String, Object>> list = projectbillsService.selectReminderCurrent(map);
            page.setTotal(num);
            page.setRecords(list);
            return page;
        }
        return null;
    }

    @Override
    public Map<String, Object> getPageSurvivingPro(Map<String, Object> map) {
        try {
            int num = projectbillsService.selectSurvivingProTotal(map);
            if (num != 0) {
                int current = (int) map.get("current");
                int size = (int) map.get("size");
                if (current <= 1) {
                    current = 0;
                } else {
                    current = (current - 1) * size;
                }
                map.put("size", size);
                map.put("current", current);
                List<Map<String, Object>> mapList = projectbillsService.selectSurvivingProRecords(map);
                Page pageDto = new Page<>();
                pageDto.setTotal(num);
                pageDto.setRecords(mapList);
                map.put("page", pageDto);
            }
            return map;
        } catch (Exception e) {
            logger.error("操作异常：" + e.toString(), e);
        }
        return null;
    }

    @Override
    public Map<String, Object> querySurvivingProTemporary(ProjectbillsDto projectbillsDto) {
        if (projectbillsDto != null && projectbillsDto.getId() != null) {
            Map<String, Object> map = new HashMap<>();
            Projectbills projectbills = projectbillsService.selectById(projectbillsDto.getId());
            EntityWrapper<ProjectBillsSubs> subsEntityWrapper = new EntityWrapper<>();
            subsEntityWrapper.eq("bill_no", projectbills.getBillNo())
                    .eq("corp_id", projectbills.getCorpId())
                    .eq("branch_id", projectbills.getBranchId());
            ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(subsEntityWrapper);
            if (projectBillsSubs != null) {
                map.put("proSub", projectBillsSubs);
            }
            if (projectbills != null) {
                map.put("project", projectbills);
                if (projectbills.getBranchId() != null) {
                    map.put("branchId", projectbills.getBranchId());
                    List<SysUser> sysUsers = sysUserService.selectProjectManagers(map);
                    if (sysUsers.size() != 0) {
                        map.put("users", sysUsers);
                    }
                }
                EntityWrapper<SubContractBills> subContractBillsEntityWrapper = new EntityWrapper<>();
                subContractBillsEntityWrapper.eq("bill_no", projectbills.getBillNo())
                        .eq("project_sub_no", projectbills.getProjectNo())
                        .eq("is_sur", "T")
                        .eq("branch_id", projectbills.getBranchId());
                List<SubContractBills> subContractBillsList = subContractBillsService.selectList(subContractBillsEntityWrapper);
                if (subContractBillsList.size() != 0) {
                    map.put("subContracts", subContractBillsList);
                }
                EntityWrapper<ProjectBillsBudgets> projectBillsBudgetsEntityWrapper = new EntityWrapper<>();
                projectBillsBudgetsEntityWrapper.eq("bill_no", projectbills.getBillNo())
                        .eq("project_sub_no", projectbills.getProjectNo())
                        .ne("budget_id", 1)
                        .eq("branch_id", projectbills.getBranchId());
                List<ProjectBillsBudgets> projectBillsBudgetsList = projectBillsBudgetsService.selectList(projectBillsBudgetsEntityWrapper);
                if (projectBillsBudgetsList.size() != 0) {
                    map.put("proBudgets", projectBillsBudgetsList);
                }
            }
            return map;
        }
        return null;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> save(String projectBillsContract, String projectBillsStls, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            ProjectbillsDto projectbillsDto = JSONArray.parseObject(projectBillsContract, ProjectbillsDto.class);
            JSONArray jsonArray = JSONArray.parseArray(projectBillsStls);
            List<ProjectBillsStlPlans> projectBillsStlPlansList = JSONObject.parseArray(jsonArray.toJSONString(), ProjectBillsStlPlans.class);
            if (projectBillsStlPlansList.size() != 0) {
                int line = 0;
                for (ProjectBillsStlPlans pro : projectBillsStlPlansList) {
                    line++;
                    pro.setLineNo(line);
                    pro.setActId(111);
                    pro.setSrcBillNo(projectbillsDto.getBillNo());
                    pro.setSrcActId(101);
                    boolean insert = projectBillsStlPlansService.insert(pro);
                    if (!insert) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败: 结算明细失败");
                        return result;
                    }
                }
            }
            Projectbills projectbills = new Projectbills();
            revert(projectbillsDto, projectbills);
            Tasklists tkTask = new Tasklists();
            // 暂定 10 为 总包合同活动号
            tkTask.setActId(10);
            tkTask.setStatus(6);
            tkTask.setBillNo(projectbills.getBillNo());
            tkTask.setOpUserName(sysUserDto.getUsername());
            tkTask.setOpUserId(sysUserDto.getUserId().intValue());
            boolean insertTkTask = tasklistsService.insert(tkTask);
            if (!insertTkTask) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("提交失败: 新建任务失败");
                return result;
            }
            Tasklists taskLists = new Tasklists();
            // 暂定 11 为 项目合同活动号
            taskLists.setActId(11);
            taskLists.setStatus(2);
            taskLists.setBillNo(projectbills.getBillNo());
            taskLists.setOpUserName(sysUserDto.getUsername());
            taskLists.setOpUserId(sysUserDto.getUserId().intValue());
            boolean insertprojectTask = tasklistsService.insert(taskLists);
            projectbills.setActId(101);
            projectbills.setCreateDate(new Date());
            projectbills.setBillDate(new Date());
            boolean insertTk = projectbillsService.insert(projectbills);
            if (!insertprojectTask || !insertTk) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("提交失败");
                return result;
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 提交失败：" + e.toString(), e);
            result.addErrorMessage("提交失败：" + e.toString());
            return result;
        }
        return result;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> update(String projectBillsContract, String projectBillsStls, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            ProjectbillsDto projectbillsDto = JSONArray.parseObject(projectBillsContract, ProjectbillsDto.class);
            JSONArray jsonArray = JSONArray.parseArray(projectBillsStls);
            List<ProjectBillsStlPlans> projectBillsStlPlansList = JSONObject.parseArray(jsonArray.toJSONString(), ProjectBillsStlPlans.class);
            if (projectBillsStlPlansList.size() != 0) {
                EntityWrapper<ProjectBillsStlPlans> projectBillsStlsEntityWrapper = new EntityWrapper<>();
                projectBillsStlsEntityWrapper.setSqlSelect("id").eq("bill_no", projectBillsStlPlansList.get(0).getBillNo());
                List<ProjectBillsStlPlans> projectBillsStlPlansLS = projectBillsStlPlansService.selectList(projectBillsStlsEntityWrapper);
                if (projectBillsStlPlansLS.size() != 0) {
                    for (ProjectBillsStlPlans pb : projectBillsStlPlansList) {
                        boolean updateById = projectBillsStlPlansService.updateById(pb);
                        if (!updateById) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("操作失败: 删除结算明细失败");
                            return result;
                        }
                    }
                }
            }
            EntityWrapper<Tasklists> tasklistsEntityWrapper = new EntityWrapper<>();
            tasklistsEntityWrapper.eq("bill_no", projectbillsDto.getBillNo()).eq("act_id", 10);
            Tasklists task = tasklistsService.selectOne(tasklistsEntityWrapper);
            if (task != null) {
                task.setStatus(6);
                boolean update = tasklistsService.updateById(task);
                if (!update) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("记账失败");
                    return result;
                }
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 记账失败：" + e.toString(), e);
            result.addErrorMessage("记账失败");
        }
        return result;
    }

    @Override
    public ExecuteResult<String> delete(Long id) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            boolean flag = projectbillsService.deleteById(id);
            if (!flag) {
                result.addErrorMessage("删除失败。");
            }
        } catch (Exception e) {
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("删除错误：" + e.toString());
        }
        return result;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> deleteContract(ProjectbillsDto projectbillsDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            if (projectbillsDto != null && projectbillsDto.getId() != null) {
                EntityWrapper<Projectbills> entityWrapper = new EntityWrapper<>();
                entityWrapper.setSqlSelect("id", "bill_no").eq("id", projectbillsDto.getId());
                Projectbills projectbills = projectbillsService.selectOne(entityWrapper);
                EntityWrapper<Tasklists> tasklistsEntityWrapper = new EntityWrapper<>();
                tasklistsEntityWrapper.eq("act_id", 10).eq("bill_no", projectbills.getBillNo());
                Tasklists tasklists = tasklistsService.selectOne(tasklistsEntityWrapper);
                if (tasklists != null) {
                    if (tasklists.getStatus() == 6) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("已提交合同无法删除");
                        return result;
                    }
                    EntityWrapper<ProjectBillsStlPlans> projectBillsStlsEntityWrapper = new EntityWrapper<>();
                    projectBillsStlsEntityWrapper.setSqlSelect("id").eq("bill_no", projectbills.getBillNo()).eq("act_id", 111);
                    List<ProjectBillsStlPlans> projectBillsStls = projectBillsStlPlansService.selectList(projectBillsStlsEntityWrapper);
                    if (projectBillsStls.size() != 0) {
                        for (ProjectBillsStlPlans pb : projectBillsStls) {
                            boolean deleteById = projectBillsStlPlansService.deleteById(pb);
                            if (!deleteById) {
                                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                result.addErrorMessage("结算明细删除失败");
                                return result;
                            }
                        }
                    }

                    EntityWrapper<AttachFiles> attachFilesEntityWrapper = new EntityWrapper<>();
                    attachFilesEntityWrapper.setSqlSelect("id").eq("bill_no", projectbills.getBillNo()).eq("act_id", 101);
                    List<AttachFiles> attachFiles = attachFilesService.selectList(attachFilesEntityWrapper);
                    if (attachFiles.size() != 0) {
                        for (AttachFiles at : attachFiles) {
                            boolean deleteById = attachFilesService.deleteById(at);
                            if (!deleteById) {
                                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                result.addErrorMessage("结算附件失败");
                                return result;
                            }
                        }
                    }
                    boolean deleteById = tasklistsService.deleteById(tasklists);
                    if (!deleteById) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("任务删除失败");
                        return result;
                    }
                    boolean delete = projectbillsService.deleteById(projectbills);
                    if (!delete) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("合同删除删除失败");
                        return result;
                    }
                } else {
                    result.addErrorMessage("未找到任务，请确认单号");
                    return result;
                }
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("合同删除删除失败");
        }
        return result;
    }

    @Override
    public Map<String, Object> getPage(Map<String, Object> map, SysUserDto sysUserDto) {
        Map<String, Object> objectMap = new HashMap<>();
        SysRole sysRole = subContractBillsService.selectRole(sysUserDto);
        map.put("user", sysUserDto);
        map.put("role", sysRole);
        try {
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            if (map.get("startDate") != null && map.get("startDate") != "") {
                long startimes = (long) map.get("startDate");
                String startTime = sdf.format(new Date(startimes));
                map.put("startDateTime", startTime);
            }
            if (map.get("endDate") != null && map.get("endDate") != "") {
                long endtimes = (long) map.get("endDate");
                LocalDateTime localDateTime = LocalDateTime.ofInstant(Instant.ofEpochMilli(endtimes), ZoneId.systemDefault());
                LocalDateTime endOfDay = localDateTime.with(LocalTime.MAX);
                Date from = Date.from(endOfDay.atZone(ZoneId.systemDefault()).toInstant());
                String endTime = sdf.format(from);
                map.put("endDateTime", endTime);
            }
            int num = projectbillsService.selectProjectTotal(map);
            if (num != 0) {
                int current = (int) map.get("current");
                int size = (int) map.get("size");
                if (current <= 1) {
                    current = 0;
                } else {
                    current = (current - 1) * size;
                }
                map.put("size", size);
                map.put("current", current);
                List<Map<String, Object>> mapList = projectbillsService.selectProjectRecords(map);
                Page page = new Page();
                page.setRecords(mapList);
                page.setTotal(num);
                objectMap.put("page", page);
                return objectMap;
            }
        } catch (Exception e) {
            logger.error("操作异常：" + e.toString(), e);
        }
        return null;
    }

    @Override
    public Map<String, Object> tkPage(Map<String, Object> map, SysUserDto sysUserDto) {
        Map<String, Object> objectMap = new HashMap<>();
        try {
            EntityWrapper<SysUserRole> sysUserRoleEntityWrapper = new EntityWrapper<>();
            sysUserRoleEntityWrapper.eq("user_id", sysUserDto.getUserId());
            SysUserRole sysUserRole = sysUserRoleService.selectOne(sysUserRoleEntityWrapper);
            SysRole sysRole = sysRoleService.selectById(sysUserRole.getRoleId());
            map.put("user", sysUserDto);
            map.put("role", sysRole);
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            if (map.get("startDate") != null && map.get("startDate") != "") {
                long startimes = (long) map.get("startDate");
                String startTime = sdf.format(new Date(startimes));
                map.put("startDateTime", startTime);
            }
            if (map.get("endDate") != null && map.get("endDate") != "") {
                long endtimes = (long) map.get("endDate");
                LocalDateTime localDateTime = LocalDateTime.ofInstant(Instant.ofEpochMilli(endtimes), ZoneId.systemDefault());
                LocalDateTime endOfDay = localDateTime.with(LocalTime.MAX);
                Date from = Date.from(endOfDay.atZone(ZoneId.systemDefault()).toInstant());
                String endTime = sdf.format(from);
                map.put("endDateTime", endTime);
            }
            int num = projectbillsService.selectContractProPageTotal(map);
            if (num != 0) {
                int current = (int) map.get("current");
                int size = (int) map.get("size");
                if (current <= 1) {
                    current = 0;
                } else {
                    current = (current - 1) * size;
                }
                map.put("size", size);
                map.put("current", current);
                List<Map<String, Object>> mapList = projectbillsService.selectContractProPageRecords(map);
                Page pageDto = new Page<>();
                pageDto.setRecords(mapList);
                pageDto.setTotal(num);
                objectMap.put("page", pageDto);
            }
            return objectMap;
        } catch (Exception e) {
            logger.error("操作异常：" + e.toString(), e);
        }
        return null;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> projectBillsTemporary(String project, String proSubs, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            Projectbills projectbills = JSONArray.parseObject(project, Projectbills.class);
            projectbills.setCreateDate(new Date());
            projectbills.setOpUserId(sysUserDto.getUserId().intValue());
            projectbills.setOpUserName(sysUserDto.getUsername());
            projectbills.setCreateDate(new Date());
            projectbills.setBillDate(new Date());
            boolean updateProjectbills = projectbillsService.updateById(projectbills);
            if (!updateProjectbills) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("暂存失败：更新表失败");
                return result;
            }
            EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
            projectBillsSubsEntityWrapper.eq("bill_no", projectbills.getBillNo())
                    .eq("branch_id", projectbills.getBranchId());
            boolean delete = projectBillsSubsService.delete(projectBillsSubsEntityWrapper);
            if (!delete) {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("暂存失败：子项目删除失败");
                return result;
            }
            if ("F".equals(projectbills.getHaveProjectSub())) {
                ProjectBillsSubs pb = new ProjectBillsSubs();
                pb.setBillNo(projectbills.getBillNo());
                pb.setActId(103);
                pb.setLineNo(1);
                pb.setBillStatus(2);
                pb.setIfProjectSub("F");
                pb.setApprovalBranchId(projectbills.getApprovalBranchId());
                pb.setNcProjectNo(projectbills.getNcProjectNo());
                pb.setProjectSubName(projectbills.getProjectName());
                pb.setBranchId(projectbills.getBranchId());
                pb.setAmt(projectbills.getContractAmt());
                pb.setContractAmt(projectbills.getContractAmt());
                pb.setProjectWorkRate(100.0);
                pb.setProjectSubMngId(projectbills.getProjectMngId());
                pb.setProjectSubMngDeptId(projectbills.getProjectMngDeptId());
                boolean insert = projectBillsSubsService.insert(pb);
                if (!insert) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("暂存失败：新增子项目失败");
                    return result;
                }
            } else if ("T".equals(projectbills.getHaveProjectSub())) {
                if (proSubs != null) {
                    JSONArray arrayList = JSONArray.parseArray(proSubs);
                    List<ProjectBillsSubs> projectBillsSubsList = JSONObject.parseArray(arrayList.toJSONString(), ProjectBillsSubs.class);
                    int line = 0;
                    for (ProjectBillsSubs pb : projectBillsSubsList) {
                        line++;
                        pb.setBillNo(projectbills.getBillNo());
                        pb.setActId(103);
                        pb.setLineNo(line);
                        pb.setApprovalBranchId(projectbills.getApprovalBranchId());
                        pb.setProjectSubNo(projectbills.getProjectNo() + "-" + line);
                        pb.setAmt(pb.getContractAmt());
                        pb.setBillStatus(2);
                        pb.setIfProjectSub("T");
                        boolean insert = projectBillsSubsService.insert(pb);
                        if (!insert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("暂存失败：新增子项目失败");
                            return result;
                        }
                    }
                }
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 删除错误：" + e.toString(), e);
            result.addErrorMessage("合同删除删除失败");
        }
        return result;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> projectBillsUpdate(String project, String proSubs, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            Projectbills projectbills = JSONArray.parseObject(project, Projectbills.class);
            if (projectbills != null) {
                projectbills.setCreateProjectDate(new Date());
                projectbills.setCreateDate(new Date());
                projectbills.setBillDate(new Date());
                projectbills.setPostDate(new Date());
                boolean updateProjectbills = projectbillsService.updateById(projectbills);
                if (!updateProjectbills) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：更新表失败");
                    return result;
                }
                EntityWrapper<Tasklists> tasklistsEntityWrapper = new EntityWrapper<>();
                tasklistsEntityWrapper.eq("bill_no", projectbills.getBillNo()).eq("act_id", 11);
                Tasklists tasklists = tasklistsService.selectOne(tasklistsEntityWrapper);
                if (tasklists != null) {
                    tasklists.setStatus(6);
                    boolean updateById = tasklistsService.updateById(tasklists);
                    if (!updateById) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：更新任务表失败");
                        return result;
                    }
                }
                EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
                projectBillsSubsEntityWrapper.eq("bill_no", projectbills.getBillNo())
                        .eq("branch_id", projectbills.getBranchId());
                boolean delete = projectBillsSubsService.delete(projectBillsSubsEntityWrapper);
                if (!delete) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：删除子项目失败");
                    return result;
                }
                if ("F".equals(projectbills.getHaveProjectSub())) {
                    ProjectBillsSubs pb = new ProjectBillsSubs();
                    pb.setBillNo(projectbills.getBillNo());
                    pb.setActId(103);
                    pb.setLineNo(1);
                    pb.setCorpId(projectbills.getCorpId());
                    pb.setProjectSubNo(projectbills.getProjectNo());
                    pb.setBillStatus(6);
                    pb.setIfProjectSub("F");
                    pb.setApprovalBranchId(projectbills.getApprovalBranchId());
                    pb.setNcProjectNo(projectbills.getNcProjectNo());
                    pb.setProjectSubNo(projectbills.getProjectNo());
                    pb.setProjectSubName(projectbills.getProjectName());
                    pb.setBranchId(projectbills.getBranchId());
                    pb.setAmt(projectbills.getContractAmt());
                    pb.setContractAmt(projectbills.getContractAmt());
                    pb.setProjectWorkRate(100.0);
                    pb.setProjectStatus(10);
                    pb.setCreateUserId(sysUserDto.getUserId().intValue());
                    pb.setCreateData(new Date());
                    pb.setProjectSubMngId(projectbills.getProjectMngId());
                    pb.setProjectSubMngDeptId(projectbills.getProjectMngDeptId());
                    boolean insert = projectBillsSubsService.insert(pb);
                    if (!insert) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：新增子项目失败");
                        return result;
                    }
                } else if ("T".equals(projectbills.getHaveProjectSub())) {
                    if (proSubs != null) {
                        JSONArray arrayList = JSONArray.parseArray(proSubs);
                        List<ProjectBillsSubs> projectBillsSubsList = JSONObject.parseArray(arrayList.toJSONString(), ProjectBillsSubs.class);
                        int line = 0;
                        for (ProjectBillsSubs pb : projectBillsSubsList) {
                            line++;
                            pb.setBillNo(projectbills.getBillNo());
                            pb.setActId(103);
                            pb.setLineNo(line);
                            pb.setApprovalBranchId(projectbills.getApprovalBranchId());
                            pb.setCorpId(projectbills.getCorpId());
                            pb.setBranchId(projectbills.getBranchId());
                            pb.setProjectSubNo(projectbills.getProjectNo() + "-" + line);
                            pb.setAmt(pb.getContractAmt());
                            pb.setBillStatus(6);
                            pb.setCreateUserId(sysUserDto.getUserId().intValue());
                            pb.setCreateData(new Date());
                            pb.setProjectStatus(10);
                            pb.setIfProjectSub("T");
                            boolean insert = projectBillsSubsService.insert(pb);
                            if (!insert) {
                                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                result.addErrorMessage("提交失败：新增子项目失败");
                                return result;
                            }
                        }
                    }
                }
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 提交错误：" + e.toString(), e);
            result.addErrorMessage("提交失败：请确认信息重新提交");
            return result;
        }
        return result;
    }

    @Override
    public Map<String, Object> pageStart(Map<String, Object> map, SysUserDto sysUserDto) {
        Map<String, Object> hashMap = new HashMap<>();
        SysRole sysRole = subContractBillsService.selectRole(sysUserDto);
        map.put("user", sysUserDto);
        map.put("role", sysRole);
        try {
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            if (map.get("startDate") != null && map.get("startDate") != "") {
                long startimes = (long) map.get("startDate");
                String startTime = sdf.format(new Date(startimes));
                map.put("startDateTime", startTime);
            }
            if (map.get("proEndStartDate") != null && map.get("proEndStartDate") != "") {
                long startimes = (long) map.get("proEndStartDate");
                String startTime = sdf.format(new Date(startimes));
                map.put("proEndStartDateTime", startTime);
            }
            if (map.get("endDate") != null && map.get("endDate") != "") {
                long endtimes = (long) map.get("endDate");
                LocalDateTime localDateTime = LocalDateTime.ofInstant(Instant.ofEpochMilli(endtimes), ZoneId.systemDefault());
                LocalDateTime endOfDay = localDateTime.with(LocalTime.MAX);
                Date from = Date.from(endOfDay.atZone(ZoneId.systemDefault()).toInstant());
                String endTime = sdf.format(from);
                map.put("endDateTime", endTime);
            }
            if (map.get("proEndEndDate") != null && map.get("proEndEndDate") != "") {
                long endtimes = (long) map.get("proEndEndDate");
                LocalDateTime localDateTime = LocalDateTime.ofInstant(Instant.ofEpochMilli(endtimes), ZoneId.systemDefault());
                LocalDateTime endOfDay = localDateTime.with(LocalTime.MAX);
                Date from = Date.from(endOfDay.atZone(ZoneId.systemDefault()).toInstant());
                String endTime = sdf.format(from);
                map.put("proEndEndDateTime", endTime);
            }
            int num = projectbillsService.selectProjectStartTotal(map);
            if (num != 0) {
                int current = (int) map.get("current");
                int size = (int) map.get("size");
                if (current <= 1) {
                    current = 0;
                } else {
                    current = (current - 1) * size;
                }
                map.put("size", size);
                map.put("current", current);
                List<Map<String, Object>> mapList = projectbillsService.selectProjectStartRecords(map);
                Page pageDto = new Page<>();
                pageDto.setRecords(mapList);
                pageDto.setTotal(num);
                hashMap.put("page", pageDto);
            }
            return hashMap;
        } catch (Exception e) {
            logger.error("操作异常：" + e.toString(), e);
        }
        return null;
    }

    @Override
    public Map<String, Object> queryProStartDateInformation(ProjectbillsDto projectbillsDto) {
        if (projectbillsDto != null && projectbillsDto.getId() != null) {
            Projectbills projectbills = projectbillsService.selectById(projectbillsDto.getId());
            if (projectbills != null) {
                Map<String, Object> map = new HashMap<>();
                map.put("project", projectbills);
                if (projectbills.getCorpId() != null && projectbills.getCorpId() != 0) {
                    EntityWrapper<Bcorps> bcorpsEntityWrapper = new EntityWrapper<>();
                    bcorpsEntityWrapper.setSqlSelect("id", "c_name").eq("id", projectbills.getCorpId());
                    Bcorps bcorps = bcorpsService.selectOne(bcorpsEntityWrapper);
                    map.put("corp", bcorps);
                }
                if (projectbills.getConstructorId() != null && projectbills.getConstructorId() != 0) {
                    EntityWrapper<Bbranchs> bbranchsEntityWrapper = new EntityWrapper<>();
                    bbranchsEntityWrapper.setSqlSelect("id", "c_name").eq("id", projectbills.getConstructorId());
                    Bbranchs bbranchs = bbranchsService.selectOne(bbranchsEntityWrapper);
                    map.put("branch", bbranchs);
                }
                if (projectbills.getProjectMngId() != null && projectbills.getProjectMngId() != 0) {
                    SysUser user = sysUserService.selectById(projectbills.getProjectMngId());
                    map.put("user", user);
                }
                if (projectbills.getProjectMngDeptId() != null && projectbills.getProjectMngDeptId() != 0) {
                    EntityWrapper<Bdepts> bdeptsEntityWrapper = new EntityWrapper<>();
                    bdeptsEntityWrapper.setSqlSelect("id", "dept_name").eq("id", projectbills.getProjectMngDeptId());
                    Bdepts bdepts = bdeptsService.selectOne(bdeptsEntityWrapper);
                    map.put("dept", bdepts);
                }
                return map;
            }
        }
        return null;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> projectStartUpdate(ProjectbillsDto projectbillsDto, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            Projectbills projectbills = projectbillsService.selectById(projectbillsDto.getId());
            if (projectbills != null) {
                if (projectbillsDto.getActEndDate() != null) {
                    if (projectbills.getActStartDate() != null) {
                        long startTime = projectbills.getActStartDate().getTime();
                        long endTime = projectbillsDto.getActEndDate().getTime();
                        if ((endTime - startTime) > 0) {
                            long time = endTime - startTime;
                            int day = (int) (time / (24 * 3600 * 1000));
                            projectbills.setActDays(day);
                        } else {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("竣工失败：日期有误");
                            return result;
                        }
                    }
                    projectbills.setStartDateEnd(6);
                    projectbills.setActEndDate(projectbillsDto.getActEndDate());
                    projectbills.setSetEndAttachId(projectbillsDto.getSetEndAttachId());
                    projectbills.setEndRemarks(projectbillsDto.getEndRemarks());
                    boolean proInsert = true;
                    if (null != projectbills.getSetEndAttachId() &&
                            !"".equals(projectbills.getSetEndAttachId())) {
                        ProjectAnnex projectAnnex = new ProjectAnnex();
                        projectAnnex.setSrcActId(302);
                        projectAnnex.setProjectId(projectbills.getId());
                        projectAnnex.setFileName("竣工报告");
                        projectAnnex.setFileAddress(projectbills.getSetEndAttachId());
                        projectAnnex.setBranId(projectbills.getBranchId());
                        proInsert = projectAnnexService.insert(projectAnnex);
                    }
                    if (!proInsert) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：更新附件失败");
                        return result;
                    }
                    EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
                    projectBillsSubsEntityWrapper.eq("bill_no", projectbills.getBillNo())
                            .eq("branch_id", projectbills.getBranchId());
                    ProjectBillsSubs projectBillsSubs = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
                    projectBillsSubs.setProjectStatus(30);
                    boolean updateById1 = projectBillsSubsService.updateById(projectBillsSubs);
                    if (!updateById1) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("审批通过失败: 更新工程状态失败");
                        return result;
                    }
                    boolean update = projectbillsService.updateById(projectbills);
                    if (!update) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("审批通过失败: 更新竣工状态失败");
                        return result;
                    }
                    return result;
                }
                if (projectbillsDto.getActStartDate() != null) {
                    projectbills.setActStartDate(projectbillsDto.getActStartDate());
                    projectbills.setStartDateStatus(6);
                    if (projectbillsDto.getSetStartAttachId() != null) {
                        projectbills.setSetStartAttachId(projectbillsDto.getSetStartAttachId());
                    }
                    projectbills.setStartUserId(sysUserDto.getUserId().intValue());
                    projectbills.setStartRemarks(projectbillsDto.getStartRemarks());
                    boolean updateById = projectbillsService.updateById(projectbills);
                    if (!updateById) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("开工失败：请检查信息重新提交");
                        return result;
                    }
                    EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
                    projectBillsSubsEntityWrapper.setSqlSelect("id", "project_status").eq("bill_no", projectbills.getBillNo());
                    List<ProjectBillsSubs> projectBillsSubsList = projectBillsSubsService.selectList(projectBillsSubsEntityWrapper);
                    if (projectBillsSubsList.size() != 0) {
                        for (ProjectBillsSubs pro : projectBillsSubsList) {
                            pro.setProjectStatus(20);
                            boolean update = projectBillsSubsService.updateById(pro);
                            if (!update) {
                                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                result.addErrorMessage("开工失败：更新状态失败");
                                return result;
                            }
                        }
                    }
                    /*  */
                    boolean insert = true;
                    if (null != projectbills.getSetEndAttachId() &&
                            !"".equals(projectbills.getSetEndAttachId())) {
                        ProjectAnnex projectAnnex = new ProjectAnnex();
                        projectAnnex.setSrcActId(301);
                        projectAnnex.setProjectId(projectbills.getId());
                        projectAnnex.setFileName("开工报审表");
                        projectAnnex.setFileAddress(projectbills.getSetStartAttachId());
                        projectAnnex.setBranId(projectbills.getBranchId());
                        insert = projectAnnexService.insert(projectAnnex);
                    }

                    if (!insert) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("开工失败：请检查信息重新提交");
                        return result;
                    }
                }
            } else {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("未找到信息，请确认");
                return result;
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 提交错误：" + e.toString(), e);
            result.addErrorMessage("提交失败请确认信息重新提交");
            return result;
        }
        return result;
    }
    /*审批版本*/
    /*@Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> projectStartUpdate(ProjectbillsDto projectbillsDto, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            EntityWrapper<Projectbills> projectbillsEntityWrapper = new EntityWrapper<>();
            projectbillsEntityWrapper.eq("id", projectbillsDto.getId());
            Projectbills projectbills = projectbillsService.selectOne(projectbillsEntityWrapper);
            if (projectbills != null) {
                if (projectbillsDto.getActEndDate() != null) {
                    Audit audit = new Audit();
                    audit.setBillNo(projectbillsDto.getBillNo());
                    audit.setActId(340);
                    audit.setLevelId(0);
                    audit.setIffinalItem("F");
                    audit.setSubJect(projectbillsDto.getProjectName());
                    audit.setProjectNo(projectbillsDto.getProjectNo());
                    audit.setBranchId(projectbillsDto.getBranchId());
                    audit.setSendUserId(sysUserDto.getUserId().intValue());
                    audit.setSendName(sysUserDto.getActualname());
                    audit.setSendTime(new Date());
                    audit.setAuditUserId(sysUserDto.getUserId().intValue());
                    audit.setAuditItem(new Date());
                    audit.setAuditMsg("提交");
                    audit.setAuditStatus("O");
                    audit.setProjectMngId(projectbills.getProjectMngId());
                    audit.setProjectLeader(projectbills.getProjectLeader());
                    boolean approvalFlow = auditItemsService.createApprovalFlow(audit);
                    if (!approvalFlow) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("审批流异常请检查提交信息");
                        return result;
                    }
                    if (projectbills.getActStartDate() != null && !projectbills.getActStartDate().equals("")) {
                        long startTime = projectbills.getActStartDate().getTime();
                        long endTime = projectbillsDto.getActEndDate().getTime();
                        if ((endTime - startTime) > 0) {
                            long time = endTime - startTime;
                            int day = (int) (time / (24 * 3600 * 1000));
                            projectbills.setActDays(day);
                        } else {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("竣工失败：日期有误");
                            return result;
                        }
                    }
                    projectbills.setStartDateEnd(4);
                    projectbills.setActEndDate(projectbillsDto.getActEndDate());
                    projectbills.setSetEndAttachId(projectbillsDto.getSetEndAttachId());
                    projectbills.setEndRemarks(projectbillsDto.getEndRemarks());
                    boolean proStartUpdate = projectbillsService.updateById(projectbills);
                    if (!proStartUpdate) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("竣工失败：修改合同信息失败");
                        return result;
                    }
                    return result;
                }
                if (projectbillsDto.getActStartDate() != null) {
                    projectbills.setActStartDate(projectbillsDto.getActStartDate());
                    projectbills.setStartDateStatus(6);
                    projectbills.setSetStartAttachId(projectbillsDto.getSetStartAttachId());
                    projectbills.setStartUserId(sysUserDto.getUserId().intValue());
                    projectbills.setStartRemarks(projectbillsDto.getStartRemarks());
                    boolean updateById = projectbillsService.updateById(projectbills);
                    if (!updateById) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("开工失败：请检查信息重新提交");
                        return result;
                    }
                    EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
                    projectBillsSubsEntityWrapper.setSqlSelect("id", "project_status").eq("bill_no", projectbills.getBillNo());
                    List<ProjectBillsSubs> projectBillsSubsList = projectBillsSubsService.selectList(projectBillsSubsEntityWrapper);
                    if (projectBillsSubsList.size() != 0) {
                        for (ProjectBillsSubs pro : projectBillsSubsList) {
                            pro.setProjectStatus(20);
                            boolean update = projectBillsSubsService.updateById(pro);
                            if (!update) {
                                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                                result.addErrorMessage("开工失败：更新状态失败");
                                return result;
                            }
                        }
                    }
                    ProjectAnnex projectAnnex = new ProjectAnnex();
                    projectAnnex.setSrcActId(301);
                    projectAnnex.setProjectId(projectbills.getId());
                    projectAnnex.setFileName("开工报审表");
                    projectAnnex.setFileAddress(projectbills.getSetStartAttachId());
                    projectAnnex.setBranId(projectbills.getBranchId());
                    boolean insert = projectAnnexService.insert(projectAnnex);
                    if (!insert) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("开工失败：请检查信息重新提交");
                        return result;
                    }
                }
            } else {
                TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                result.addErrorMessage("未找到信息，请确认");
                return result;
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 提交错误：" + e.toString(), e);
            result.addErrorMessage("提交失败请确认信息重新提交");
            return result;
        }
        return result;
    }*/


    @Override
    public Map<String, Object> queryTurnkeySettlement(ProjectbillsDto projectbillsDto) {
        if (projectbillsDto.getId() != null && projectbillsDto.getId() != 0) {
            Map<String, Object> map = new HashMap<>();
            Projectbills projectbills = projectbillsService.selectById(projectbillsDto.getId());
            if (projectbills != null) {
                map.put("project", projectbills);
                if (projectbills.getProjectTypeId() != null && projectbills.getProjectTypeId() != 0) {
                    EntityWrapper<BprojectTypes> bprojectTypesEntityWrapper = new EntityWrapper<>();
                    bprojectTypesEntityWrapper.setSqlSelect("id", "project_type_name").eq("id", projectbills.getProjectTypeId());
                    BprojectTypes bprojectTypes = bprojectTypesService.selectOne(bprojectTypesEntityWrapper);
                    if (bprojectTypes != null) {
                        map.put("proType", bprojectTypes);
                    }
                }
                if (projectbills.getCorpId() != null && projectbills.getCorpId() != 0) {
                    EntityWrapper<Bcorps> bcorpsEntityWrapper = new EntityWrapper<>();
                    bcorpsEntityWrapper.setSqlSelect("id", "c_name").eq("id", projectbills.getCorpId());
                    Bcorps bcorps = bcorpsService.selectOne(bcorpsEntityWrapper);
                    if (bcorps != null) {
                        map.put("corp", bcorps);
                    }
                }
                if (projectbills.getBranchId() != null && projectbills.getBranchId() != 0) {
                    EntityWrapper<Bbranchs> bbranchsEntityWrapper = new EntityWrapper<>();
                    bbranchsEntityWrapper.setSqlSelect("id", "c_name").eq("id", projectbills.getBranchId());
                    Bbranchs bbranchs = bbranchsService.selectOne(bbranchsEntityWrapper);
                    if (bbranchs != null) {
                        map.put("branch", bbranchs);
                    }
                }
                if (projectbills.getProjectMngId() != null && projectbills.getProjectMngId() != 0) {
                    SysUser sysUser = sysUserService.selectById(projectbills.getProjectMngId());
                    if (sysUser != null) {
                        map.put("user", sysUser);
                    }
                }
                if (projectbills.getProjectMngDeptId() != null && projectbills.getProjectMngDeptId() != 0) {
                    EntityWrapper<Bdepts> bdeptsEntityWrapper = new EntityWrapper<>();
                    bdeptsEntityWrapper.setSqlSelect("id", "dept_name").eq("id", projectbills.getProjectMngDeptId());
                    Bdepts bdepts = bdeptsService.selectOne(bdeptsEntityWrapper);
                    if (bdepts != null) {
                        map.put("dept", bdepts);
                    }
                }
                if (projectbills.getBillNo() != null && !projectbills.getBillNo().equals("")) {
                    EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
                    projectBillsSubsEntityWrapper.setSqlSelect("id", "nc_project_no", "project_sub_no", "project_sub_name",
                            "if_project_sub", "contract_amt", "budget_amt", "contract_audit_amt")
                            .eq("bill_no", projectbills.getBillNo());
                    List<ProjectBillsSubs> billsSubs = projectBillsSubsService.selectList(projectBillsSubsEntityWrapper);
                    if (billsSubs.size() != 0) {
                        map.put("proSubs", billsSubs);
                    }
                    EntityWrapper<ProjectBillsAttachs> projectBillsAttachsEntityWrapper = new EntityWrapper<>();
                    projectBillsAttachsEntityWrapper.eq("bill_no", projectbills.getBillNo());
                    List<ProjectBillsAttachs> projectBillsAttachs = projectBillsAttachsService.selectList(projectBillsAttachsEntityWrapper);
                    if (projectBillsAttachs.size() != 0) {
                        map.put("proAttachs", projectBillsAttachs);
                    }
                }
                return map;
            }
        }
        return null;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ExecuteResult<String> turnkeySettlementSave(String projectbill, String projectSubs, String projectAttachs, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            Projectbills projectbills = JSONArray.parseObject(projectbill, Projectbills.class);
            JSONArray jsonArray = JSONArray.parseArray(projectSubs);
            List<ProjectBillsSubs> projectBillsSubs = JSONObject.parseArray(jsonArray.toJSONString(), ProjectBillsSubs.class);
            JSONArray array = JSONArray.parseArray(projectAttachs);
            List<ProjectBillsAttachs> projectBillsAttachs = JSONObject.parseArray(array.toJSONString(), ProjectBillsAttachs.class);
            if (projectbills != null) {
                if (projectbills.getContractAuditAmt() != null && projectbills.getEstimatedAmt() == 0) {
                    projectbills.setTaxRate(projectbills.getActContractTaxAmt());
                    projectbills.setSettlementStatus(6);
                    projectbills.setAmt(projectbills.getContractAuditAmt());
                    projectbills.setSettlementUserId(sysUserDto.getUserId().intValue());
                    if (projectbills.getContractAuditDate() == null) {
                        projectbills.setContractAuditDate(new Date());
                    }
                    boolean update = projectbillsService.updateById(projectbills);
                    if (!update) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：更新合同失败");
                        return result;
                    }
                }
                if (projectBillsSubs.size() != 0) {
                    for (ProjectBillsSubs pb : projectBillsSubs) {
                        pb.setAmt(pb.getContractAuditAmt());
                        pb.setBudgetProfit(pb.getAmt() - pb.getBudgetAmt());
                        pb.setBudgetProfitRate((double) Math.round((pb.getBudgetProfit() / pb.getAmt()) * 100));
                        boolean proSubUpdate = projectBillsSubsService.updateById(pb);
                        if (!proSubUpdate) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：更新子项目失败");
                            return result;
                        }
                    }
                } else {
                    EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
                    projectBillsSubsEntityWrapper.eq("bill_no", projectbills.getBillNo())
                            .eq("corp_id", projectbills.getCorpId())
                            .eq("branch_id", projectbills.getBranchId());
                    ProjectBillsSubs projectSub = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
                    projectSub.setContractAuditAmt(projectbills.getContractAuditAmt());
                    projectSub.setAmt(projectSub.getContractAuditAmt());
                    projectSub.setBudgetProfit(projectSub.getAmt() - projectSub.getBudgetAmt());
                    double rate = Math.round((projectSub.getBudgetProfit() / projectSub.getAmt()) * 100);
                    projectSub.setBudgetProfitRate(rate);
                    boolean proSubUpdate = projectBillsSubsService.updateById(projectSub);
                    if (!proSubUpdate) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：更新子项目失败");
                        return result;
                    }
                }
                EntityWrapper<ProjectBillsAttachs> projectBillsAttachsEntityWrapper = new EntityWrapper<>();
                projectBillsAttachsEntityWrapper.setSqlSelect("id").eq("bill_no", projectbills.getBillNo());
                boolean deleteById = projectBillsAttachsService.delete(projectBillsAttachsEntityWrapper);
                if (!deleteById) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：删除旧数据失败");
                    return result;
                }
                if (projectBillsAttachs.size() != 0) {
                    int line = 0;
                    for (ProjectBillsAttachs pba : projectBillsAttachs) {
                        ProjectAnnex projectAnnex = new ProjectAnnex();
                        projectAnnex.setSrcActId(205);
                        projectAnnex.setProjectId(projectbills.getId());
                        projectAnnex.setFileName("总包结算书");
                        projectAnnex.setFileAddress(pba.getAttachId());
                        projectAnnex.setBranId(projectbills.getBranchId());
                        boolean proInsert = projectAnnexService.insert(projectAnnex);
                        if (!proInsert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：更新附件失败");
                            return result;
                        }
                        line++;
                        pba.setBillNo(projectbills.getBillNo());
                        pba.setLineNo(line);
                        pba.setActId(205);
                        pba.setOpUserId(sysUserDto.getUserId().intValue());
                        pba.setOpUserName(sysUserDto.getUsername());
                        pba.setOpDate(new Date());
                        boolean insert = projectBillsAttachsService.insert(pba);
                        if (!insert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：新增附件失败");
                            return result;
                        }
                    }
                }
            } else {
                result.addErrorMessage("提交失败：未找到信息");
                return result;
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 提交错误：" + e.toString(), e);
            result.addErrorMessage("提交失败请确认信息重新提交");
            return result;
        }
        return result;
    }

    /*审批版本*/
   /* public ExecuteResult<String> turnkeySettlementSave(String projectbill, String projectSubs, String projectAttachs, SysUserDto sysUserDto) {
        ExecuteResult<String> result = new ExecuteResult<String>();
        try {
            Projectbills projectbills = JSONArray.parseObject(projectbill, Projectbills.class);
            JSONArray jsonArray = JSONArray.parseArray(projectSubs);
            List<ProjectBillsSubs> projectBillsSubs = JSONObject.parseArray(jsonArray.toJSONString(), ProjectBillsSubs.class);
            JSONArray array = JSONArray.parseArray(projectAttachs);
            List<ProjectBillsAttachs> projectBillsAttachs = JSONObject.parseArray(array.toJSONString(), ProjectBillsAttachs.class);
            if (projectbills != null) {
                if (projectbills.getContractAuditAmt() != null && projectbills.getEstimatedAmt() == 0) {
                    projectbills.setTaxRate(projectbills.getActContractTaxAmt());
                    projectbills.setSettlementStatus(4);
                    projectbills.setSettlementUserId(sysUserDto.getUserId().intValue());
                    if (projectbills.getContractAuditDate() == null) {
                        projectbills.setContractAuditDate(new Date());
                    }
                    boolean update = projectbillsService.updateById(projectbills);
                    if (!update) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：更新合同失败");
                        return result;
                    }
                }




                if (projectBillsSubs.size() != 0) {
                    for (ProjectBillsSubs pb : projectBillsSubs) {
                        boolean proSubUpdate = projectBillsSubsService.updateById(pb);
                        if (!proSubUpdate) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：更新子项目失败");
                            return result;
                        }
                    }
                } else {
                    EntityWrapper<ProjectBillsSubs> projectBillsSubsEntityWrapper = new EntityWrapper<>();
                    projectBillsSubsEntityWrapper.eq("bill_no", projectbills.getBillNo())
                            .eq("branch_id", projectbills.getBranchId());
                    ProjectBillsSubs projectSub = projectBillsSubsService.selectOne(projectBillsSubsEntityWrapper);
                    projectSub.setContractAuditAmt(projectbills.getContractAuditAmt());
                    boolean proSubUpdate = projectBillsSubsService.updateById(projectSub);
                    if (!proSubUpdate) {
                        TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                        result.addErrorMessage("提交失败：更新子项目失败");
                        return result;
                    }
                }
                EntityWrapper<ProjectBillsAttachs> projectBillsAttachsEntityWrapper = new EntityWrapper<>();
                projectBillsAttachsEntityWrapper.setSqlSelect("id").eq("bill_no", projectbills.getBillNo());
                boolean deleteById = projectBillsAttachsService.delete(projectBillsAttachsEntityWrapper);
                if (!deleteById) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("提交失败：删除旧数据失败");
                    return result;
                }
                if (projectBillsAttachs.size() != 0) {
                    int line = 0;
                    for (ProjectBillsAttachs pba : projectBillsAttachs) {
                        ProjectAnnex projectAnnex = new ProjectAnnex();
                        projectAnnex.setSrcActId(205);
                        projectAnnex.setProjectId(projectbills.getId());
                        projectAnnex.setFileName("总包结算书");
                        projectAnnex.setFileAddress(pba.getAttachId());
                        projectAnnex.setBranId(projectbills.getBranchId());
                        boolean proInsert = projectAnnexService.insert(projectAnnex);
                        if (!proInsert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：更新附件失败");
                            return result;
                        }
                        line++;
                        pba.setBillNo(projectbills.getBillNo());
                        pba.setLineNo(line);
                        pba.setActId(205);
                        pba.setOpUserId(sysUserDto.getUserId().intValue());
                        pba.setOpUserName(sysUserDto.getUsername());
                        pba.setOpDate(new Date());
                        boolean insert = projectBillsAttachsService.insert(pba);
                        if (!insert) {
                            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                            result.addErrorMessage("提交失败：新增附件失败");
                            return result;
                        }
                    }
                }
                Audit audit = new Audit();
                audit.setBillNo(projectbills.getBillNo());
                audit.setActId(610);
                audit.setLevelId(0);
                audit.setIffinalItem("F");
                audit.setSubJect(projectbills.getProjectName());
                audit.setProjectNo(projectbills.getProjectNo());
                audit.setBranchId(projectbills.getBranchId());
                audit.setSendUserId(sysUserDto.getUserId().intValue());
                audit.setSendName(sysUserDto.getUsername());
                audit.setSendTime(new Date());
                audit.setAuditUserId(sysUserDto.getUserId().intValue());
                audit.setAuditItem(new Date());
                audit.setAuditMsg("提交");
                audit.setAuditStatus("O");
                audit.setProjectMngId(projectbills.getProjectMngId());
                if (projectbills != null) {
                    audit.setProjectLeader(projectbills.getProjectLeader());
                }
                boolean approvalFlow = auditItemsService.createApprovalFlow(audit);
                if (!approvalFlow) {
                    TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
                    result.addErrorMessage("审批流异常请检查提交信息");
                }
            } else {
                result.addErrorMessage("提交失败：未找到信息");
                return result;
            }
        } catch (Exception e) {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            logger.error(" 提交错误：" + e.toString(), e);
            result.addErrorMessage("提交失败请确认信息重新提交");
            return result;
        }
        return result;
    }*/

    public Map<String, Object> getOne(List<ProjectbillsDto> projectbillsDtoList) {
        Map<String, Object> strMap = new HashMap<>();
        List<Integer> bran = new ArrayList<>();
        List<Integer> corp = new ArrayList<>();
        List<Integer> price = new ArrayList<>();
        List<Integer> userId = new ArrayList<>();
        List<Integer> deptId = new ArrayList<>();
        List<Integer> project = new ArrayList<>();
        List<Integer> corpType = new ArrayList<>();
        for (ProjectbillsDto pd : projectbillsDtoList) {
            if (pd.getCorpId() != null && pd.getCorpId() != 0) {
                corp.add(pd.getCorpId());
            }
            if (pd.getCorpTypeId() != null && pd.getCorpTypeId() != 0) {
                corpType.add(pd.getCorpTypeId());
            }
            if (pd.getBranchId() != null && pd.getBranchId() != 0) {
                bran.add(pd.getBranchId());
                if (pd.getConstructorId() != null && pd.getConstructorId() != 0) {
                    bran.add(pd.getConstructorId());
                }
            }
            if (pd.getPriceModeId() != null && pd.getPriceModeId() != 0) {
                price.add(pd.getPriceModeId());
            }
            if (pd.getProjectTypeId() != null && pd.getProjectTypeId() != 0) {
                project.add(pd.getProjectTypeId());
            }
            if (pd.getProjectMngId() != null && pd.getProjectMngId() != 0) {
                userId.add(pd.getProjectMngId());
            }
            if (pd.getProjectMngDeptId() != null && pd.getProjectMngDeptId() != 0) {
                deptId.add(pd.getProjectMngDeptId());
            }
        }
        List<Integer> corpId = DataUtils.integerDeduplication(corp);
        List<Integer> corpTypeId = DataUtils.integerDeduplication(corpType);
        List<Integer> branId = DataUtils.integerDeduplication(bran);
        List<Integer> priceId = DataUtils.integerDeduplication(price);
        List<Integer> projectId = DataUtils.integerDeduplication(project);
        List<Bcorps> bcorps = new ArrayList<>();
        List<Bdepts> bdepts = new ArrayList<>();
        List<SysUser> sUsers = new ArrayList<>();
        List<Bbranchs> bbranchs = new ArrayList<>();
        List<BcorpTypes> bcorpTypes = new ArrayList<>();
        List<BpriceModes> bpriceModes = new ArrayList<>();
        List<BprojectTypes> bprojectTypes = new ArrayList<>();
        for (Integer c : corpId) {
            EntityWrapper<Bcorps> bcorpsEntityWrapper = new EntityWrapper<>();
            bcorpsEntityWrapper.setSqlSelect("id", "c_name").eq("id", c);
            bcorps.add(bcorpsService.selectOne(bcorpsEntityWrapper));
        }
        for (Integer ct : corpTypeId) {
            EntityWrapper<BcorpTypes> bcorpTypesEntityWrapper = new EntityWrapper<>();
            bcorpTypesEntityWrapper.setSqlSelect("id", "corp_type_name").eq("id", ct);
            bcorpTypes.add(bcorpTypesService.selectOne(bcorpTypesEntityWrapper));
        }
        for (Integer b : branId) {
            EntityWrapper<Bbranchs> bbranchsEntityWrapper = new EntityWrapper<>();
            bbranchsEntityWrapper.setSqlSelect("id", "c_name").eq("id", b);
            bbranchs.add(bbranchsService.selectOne(bbranchsEntityWrapper));
        }
        for (Integer pri : priceId) {
            EntityWrapper<BpriceModes> bpriceModesEntityWrapper = new EntityWrapper<>();
            bpriceModesEntityWrapper.setSqlSelect("id", "price_mode_name").eq("id", pri);
            bpriceModes.add(bpriceModesService.selectOne(bpriceModesEntityWrapper));
        }
        for (Integer pro : projectId) {
            EntityWrapper<BprojectTypes> bprojectTypesEntityWrapper = new EntityWrapper<>();
            bprojectTypesEntityWrapper.setSqlSelect("id", "project_type_name").eq("id", pro);
            bprojectTypes.add(bprojectTypesService.selectOne(bprojectTypesEntityWrapper));
        }
        for (Integer us : userId) {
            sUsers.add(sysUserService.selectById(us));
        }
        for (Integer dt : deptId) {
            EntityWrapper<Bdepts> bdeptsEntityWrapper = new EntityWrapper<>();
            bdeptsEntityWrapper.setSqlSelect("id", "dept_name").eq("id", dt);
            bdepts.add(bdeptsService.selectOne(bdeptsEntityWrapper));
        }
        strMap.put("corp", bcorps);
        strMap.put("user", sUsers);
        strMap.put("depts", bdepts);
        strMap.put("corpType", bcorpTypes);
        strMap.put("branch", bbranchs);
        strMap.put("price", bpriceModes);
        strMap.put("proType", bprojectTypes);
        return strMap;
    }

    public String getserialNum(String str) {
        if (str == null || "".equals(str)) {
            str = "contract_no";
        }
        EntityWrapper<Dictionaries> dictionariesEntityWrapper = new EntityWrapper<>();
        dictionariesEntityWrapper.setSqlSelect("id", "dictionaries_number").eq("dictionaries_name", str);
        Dictionaries dictionaries = dictionariesService.selectOne(dictionariesEntityWrapper);
        if (dictionaries == null) {
            dictionaries = new Dictionaries();
            dictionaries.setDictionariesName(str);
            dictionaries.setDictionariesNumber(0);
            dictionariesService.insert(dictionaries);
        }
        String number = null;
        dictionaries.setDictionariesNumber(dictionaries.getDictionariesNumber() + 1);
        if (dictionaries.getDictionariesNumber() + 1 >= 10) {
            number = "0" + dictionaries.getDictionariesNumber();
        } else if (dictionaries.getDictionariesNumber() <= 9) {
            number = "00" + dictionaries.getDictionariesNumber();
        } else {
            number = "" + dictionaries.getDictionariesNumber();
        }
        dictionariesService.updateById(dictionaries);
        return number;
    }

}
